"Main interface for pinpoint type defs"
from __future__ import annotations

from datetime import datetime
from typing import Dict, List
from typing_extensions import TypedDict


__all__ = (
    "ClientCreateAppCreateApplicationRequestTypeDef",
    "ClientCreateAppResponseApplicationResponseTypeDef",
    "ClientCreateAppResponseTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseHookTypeDef",
    "ClientCreateCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientCreateCampaignResponseCampaignResponseStateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTypeDef",
    "ClientCreateCampaignResponseTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestHookTypeDef",
    "ClientCreateCampaignWriteCampaignRequestLimitsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTypeDef",
    "ClientCreateEmailTemplateEmailTemplateRequestTypeDef",
    "ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreateEmailTemplateResponseTypeDef",
    "ClientCreateExportJobExportJobRequestTypeDef",
    "ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef",
    "ClientCreateExportJobResponseExportJobResponseTypeDef",
    "ClientCreateExportJobResponseTypeDef",
    "ClientCreateImportJobImportJobRequestTypeDef",
    "ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef",
    "ClientCreateImportJobResponseImportJobResponseTypeDef",
    "ClientCreateImportJobResponseTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseTypeDef",
    "ClientCreateJourneyResponseTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestLimitsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestScheduleTypeDef",
    "ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef",
    "ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreatePushTemplateResponseTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseTypeDef",
    "ClientCreateSegmentResponseTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestTypeDef",
    "ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreateSmsTemplateResponseTypeDef",
    "ClientCreateSmsTemplateSMSTemplateRequestTypeDef",
    "ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreateVoiceTemplateResponseTypeDef",
    "ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef",
    "ClientDeleteAdmChannelResponseADMChannelResponseTypeDef",
    "ClientDeleteAdmChannelResponseTypeDef",
    "ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef",
    "ClientDeleteApnsChannelResponseTypeDef",
    "ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    "ClientDeleteApnsSandboxChannelResponseTypeDef",
    "ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    "ClientDeleteApnsVoipChannelResponseTypeDef",
    "ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    "ClientDeleteApnsVoipSandboxChannelResponseTypeDef",
    "ClientDeleteAppResponseApplicationResponseTypeDef",
    "ClientDeleteAppResponseTypeDef",
    "ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef",
    "ClientDeleteBaiduChannelResponseTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseHookTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseStateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTypeDef",
    "ClientDeleteCampaignResponseTypeDef",
    "ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef",
    "ClientDeleteEmailChannelResponseTypeDef",
    "ClientDeleteEmailTemplateResponseMessageBodyTypeDef",
    "ClientDeleteEmailTemplateResponseTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseLocationTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseUserTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseTypeDef",
    "ClientDeleteEndpointResponseTypeDef",
    "ClientDeleteEventStreamResponseEventStreamTypeDef",
    "ClientDeleteEventStreamResponseTypeDef",
    "ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef",
    "ClientDeleteGcmChannelResponseTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseTypeDef",
    "ClientDeleteJourneyResponseTypeDef",
    "ClientDeletePushTemplateResponseMessageBodyTypeDef",
    "ClientDeletePushTemplateResponseTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseTypeDef",
    "ClientDeleteSegmentResponseTypeDef",
    "ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef",
    "ClientDeleteSmsChannelResponseTypeDef",
    "ClientDeleteSmsTemplateResponseMessageBodyTypeDef",
    "ClientDeleteSmsTemplateResponseTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef",
    "ClientDeleteUserEndpointsResponseTypeDef",
    "ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef",
    "ClientDeleteVoiceChannelResponseTypeDef",
    "ClientDeleteVoiceTemplateResponseMessageBodyTypeDef",
    "ClientDeleteVoiceTemplateResponseTypeDef",
    "ClientGetAdmChannelResponseADMChannelResponseTypeDef",
    "ClientGetAdmChannelResponseTypeDef",
    "ClientGetApnsChannelResponseAPNSChannelResponseTypeDef",
    "ClientGetApnsChannelResponseTypeDef",
    "ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    "ClientGetApnsSandboxChannelResponseTypeDef",
    "ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    "ClientGetApnsVoipChannelResponseTypeDef",
    "ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    "ClientGetApnsVoipSandboxChannelResponseTypeDef",
    "ClientGetAppResponseApplicationResponseTypeDef",
    "ClientGetAppResponseTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef",
    "ClientGetApplicationDateRangeKpiResponseTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    "ClientGetApplicationSettingsResponseTypeDef",
    "ClientGetAppsResponseApplicationsResponseItemTypeDef",
    "ClientGetAppsResponseApplicationsResponseTypeDef",
    "ClientGetAppsResponseTypeDef",
    "ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef",
    "ClientGetBaiduChannelResponseTypeDef",
    "ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef",
    "ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef",
    "ClientGetCampaignActivitiesResponseTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef",
    "ClientGetCampaignDateRangeKpiResponseTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientGetCampaignResponseCampaignResponseHookTypeDef",
    "ClientGetCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientGetCampaignResponseCampaignResponseStateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseTypeDef",
    "ClientGetCampaignResponseTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseHookTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseStateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTypeDef",
    "ClientGetCampaignVersionResponseTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseTypeDef",
    "ClientGetCampaignVersionsResponseTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseTypeDef",
    "ClientGetCampaignsResponseTypeDef",
    "ClientGetChannelsResponseChannelsResponseChannelsTypeDef",
    "ClientGetChannelsResponseChannelsResponseTypeDef",
    "ClientGetChannelsResponseTypeDef",
    "ClientGetEmailChannelResponseEmailChannelResponseTypeDef",
    "ClientGetEmailChannelResponseTypeDef",
    "ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef",
    "ClientGetEmailTemplateResponseTypeDef",
    "ClientGetEndpointResponseEndpointResponseDemographicTypeDef",
    "ClientGetEndpointResponseEndpointResponseLocationTypeDef",
    "ClientGetEndpointResponseEndpointResponseUserTypeDef",
    "ClientGetEndpointResponseEndpointResponseTypeDef",
    "ClientGetEndpointResponseTypeDef",
    "ClientGetEventStreamResponseEventStreamTypeDef",
    "ClientGetEventStreamResponseTypeDef",
    "ClientGetExportJobResponseExportJobResponseDefinitionTypeDef",
    "ClientGetExportJobResponseExportJobResponseTypeDef",
    "ClientGetExportJobResponseTypeDef",
    "ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    "ClientGetExportJobsResponseExportJobsResponseItemTypeDef",
    "ClientGetExportJobsResponseExportJobsResponseTypeDef",
    "ClientGetExportJobsResponseTypeDef",
    "ClientGetGcmChannelResponseGCMChannelResponseTypeDef",
    "ClientGetGcmChannelResponseTypeDef",
    "ClientGetImportJobResponseImportJobResponseDefinitionTypeDef",
    "ClientGetImportJobResponseImportJobResponseTypeDef",
    "ClientGetImportJobResponseTypeDef",
    "ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    "ClientGetImportJobsResponseImportJobsResponseItemTypeDef",
    "ClientGetImportJobsResponseImportJobsResponseTypeDef",
    "ClientGetImportJobsResponseTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef",
    "ClientGetJourneyDateRangeKpiResponseTypeDef",
    "ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef",
    "ClientGetJourneyExecutionActivityMetricsResponseTypeDef",
    "ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef",
    "ClientGetJourneyExecutionMetricsResponseTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientGetJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseTypeDef",
    "ClientGetJourneyResponseTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef",
    "ClientGetPushTemplateResponseTypeDef",
    "ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    "ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef",
    "ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef",
    "ClientGetSegmentExportJobsResponseTypeDef",
    "ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    "ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef",
    "ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef",
    "ClientGetSegmentImportJobsResponseTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientGetSegmentResponseSegmentResponseTypeDef",
    "ClientGetSegmentResponseTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseTypeDef",
    "ClientGetSegmentVersionResponseTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseTypeDef",
    "ClientGetSegmentVersionsResponseTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseTypeDef",
    "ClientGetSegmentsResponseTypeDef",
    "ClientGetSmsChannelResponseSMSChannelResponseTypeDef",
    "ClientGetSmsChannelResponseTypeDef",
    "ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef",
    "ClientGetSmsTemplateResponseTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseTypeDef",
    "ClientGetUserEndpointsResponseTypeDef",
    "ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef",
    "ClientGetVoiceChannelResponseTypeDef",
    "ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef",
    "ClientGetVoiceTemplateResponseTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemLimitsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemScheduleTypeDef",
    "ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemTypeDef",
    "ClientListJourneysResponseJourneysResponseTypeDef",
    "ClientListJourneysResponseTypeDef",
    "ClientListTagsForResourceResponseTagsModelTypeDef",
    "ClientListTagsForResourceResponseTypeDef",
    "ClientListTemplatesResponseTemplatesResponseItemTypeDef",
    "ClientListTemplatesResponseTemplatesResponseTypeDef",
    "ClientListTemplatesResponseTypeDef",
    "ClientPhoneNumberValidateNumberValidateRequestTypeDef",
    "ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef",
    "ClientPhoneNumberValidateResponseTypeDef",
    "ClientPutEventStreamResponseEventStreamTypeDef",
    "ClientPutEventStreamResponseTypeDef",
    "ClientPutEventStreamWriteEventStreamTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointTypeDef",
    "ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef",
    "ClientPutEventsEventsRequestBatchItemEventsTypeDef",
    "ClientPutEventsEventsRequestBatchItemTypeDef",
    "ClientPutEventsEventsRequestTypeDef",
    "ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef",
    "ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef",
    "ClientPutEventsResponseEventsResponseResultsTypeDef",
    "ClientPutEventsResponseEventsResponseTypeDef",
    "ClientPutEventsResponseTypeDef",
    "ClientRemoveAttributesResponseAttributesResourceTypeDef",
    "ClientRemoveAttributesResponseTypeDef",
    "ClientRemoveAttributesUpdateAttributesRequestTypeDef",
    "ClientSendMessagesMessageRequestAddressesTypeDef",
    "ClientSendMessagesMessageRequestEndpointsTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationTypeDef",
    "ClientSendMessagesMessageRequestTypeDef",
    "ClientSendMessagesResponseMessageResponseEndpointResultTypeDef",
    "ClientSendMessagesResponseMessageResponseResultTypeDef",
    "ClientSendMessagesResponseMessageResponseTypeDef",
    "ClientSendMessagesResponseTypeDef",
    "ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef",
    "ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef",
    "ClientSendUsersMessagesResponseTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTypeDef",
    "ClientTagResourceTagsModelTypeDef",
    "ClientUpdateAdmChannelADMChannelRequestTypeDef",
    "ClientUpdateAdmChannelResponseADMChannelResponseTypeDef",
    "ClientUpdateAdmChannelResponseTypeDef",
    "ClientUpdateApnsChannelAPNSChannelRequestTypeDef",
    "ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef",
    "ClientUpdateApnsChannelResponseTypeDef",
    "ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef",
    "ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    "ClientUpdateApnsSandboxChannelResponseTypeDef",
    "ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef",
    "ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    "ClientUpdateApnsVoipChannelResponseTypeDef",
    "ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef",
    "ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    "ClientUpdateApnsVoipSandboxChannelResponseTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    "ClientUpdateApplicationSettingsResponseTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef",
    "ClientUpdateBaiduChannelBaiduChannelRequestTypeDef",
    "ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef",
    "ClientUpdateBaiduChannelResponseTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseHookTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseStateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTypeDef",
    "ClientUpdateCampaignResponseTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestHookTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTypeDef",
    "ClientUpdateEmailChannelEmailChannelRequestTypeDef",
    "ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef",
    "ClientUpdateEmailChannelResponseTypeDef",
    "ClientUpdateEmailTemplateEmailTemplateRequestTypeDef",
    "ClientUpdateEmailTemplateResponseMessageBodyTypeDef",
    "ClientUpdateEmailTemplateResponseTypeDef",
    "ClientUpdateEndpointEndpointRequestDemographicTypeDef",
    "ClientUpdateEndpointEndpointRequestLocationTypeDef",
    "ClientUpdateEndpointEndpointRequestUserTypeDef",
    "ClientUpdateEndpointEndpointRequestTypeDef",
    "ClientUpdateEndpointResponseMessageBodyTypeDef",
    "ClientUpdateEndpointResponseTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef",
    "ClientUpdateEndpointsBatchResponseMessageBodyTypeDef",
    "ClientUpdateEndpointsBatchResponseTypeDef",
    "ClientUpdateGcmChannelGCMChannelRequestTypeDef",
    "ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef",
    "ClientUpdateGcmChannelResponseTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseTypeDef",
    "ClientUpdateJourneyResponseTypeDef",
    "ClientUpdateJourneyStateJourneyStateRequestTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseTypeDef",
    "ClientUpdateJourneyStateResponseTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef",
    "ClientUpdatePushTemplateResponseMessageBodyTypeDef",
    "ClientUpdatePushTemplateResponseTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseTypeDef",
    "ClientUpdateSegmentResponseTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestTypeDef",
    "ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef",
    "ClientUpdateSmsChannelResponseTypeDef",
    "ClientUpdateSmsChannelSMSChannelRequestTypeDef",
    "ClientUpdateSmsTemplateResponseMessageBodyTypeDef",
    "ClientUpdateSmsTemplateResponseTypeDef",
    "ClientUpdateSmsTemplateSMSTemplateRequestTypeDef",
    "ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef",
    "ClientUpdateVoiceChannelResponseTypeDef",
    "ClientUpdateVoiceChannelVoiceChannelRequestTypeDef",
    "ClientUpdateVoiceTemplateResponseMessageBodyTypeDef",
    "ClientUpdateVoiceTemplateResponseTypeDef",
    "ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef",
)


_RequiredClientCreateAppCreateApplicationRequestTypeDef = TypedDict(
    "_RequiredClientCreateAppCreateApplicationRequestTypeDef", {"Name": str}
)
_OptionalClientCreateAppCreateApplicationRequestTypeDef = TypedDict(
    "_OptionalClientCreateAppCreateApplicationRequestTypeDef", {"tags": Dict[str, str]}, total=False
)


class ClientCreateAppCreateApplicationRequestTypeDef(
    _RequiredClientCreateAppCreateApplicationRequestTypeDef,
    _OptionalClientCreateAppCreateApplicationRequestTypeDef,
):
    """
    Type definition for `ClientCreateApp` `CreateApplicationRequest`

    Specifies the display name of an application and the tags to associate with the application.

    - **Name** *(string) --* **[REQUIRED]**

      The display name of the application. This name is displayed as the **Project name** on the
      Amazon Pinpoint console.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the
      application. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientCreateAppResponseApplicationResponseTypeDef = TypedDict(
    "_ClientCreateAppResponseApplicationResponseTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientCreateAppResponseApplicationResponseTypeDef(
    _ClientCreateAppResponseApplicationResponseTypeDef
):
    """
    Type definition for `ClientCreateAppResponse` `ApplicationResponse`

    Provides information about an application.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the application.

    - **Id** *(string) --*

      The unique identifier for the application. This identifier is displayed as the **Project ID**
      on the Amazon Pinpoint console.

    - **Name** *(string) --*

      The display name of the application. This name is displayed as the **Project name** on the
      Amazon Pinpoint console.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the application. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientCreateAppResponseTypeDef = TypedDict(
    "_ClientCreateAppResponseTypeDef",
    {"ApplicationResponse": ClientCreateAppResponseApplicationResponseTypeDef},
    total=False,
)


class ClientCreateAppResponseTypeDef(_ClientCreateAppResponseTypeDef):
    """
    Type definition for `ClientCreateApp` `Response`

    The request succeeded and the specified resource was created.

    - **ApplicationResponse** *(dict) --*

      Provides information about an application.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the application.

      - **Id** *(string) --*

        The unique identifier for the application. This identifier is displayed as the **Project
        ID** on the Amazon Pinpoint console.

      - **Name** *(string) --*

        The display name of the application. This name is displayed as the **Project name** on the
        Amazon Pinpoint console.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the application. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseAdditionalTreatments`
    `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseAdditionalTreatments` `State`

    The current status of the treatment.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **Id** *(string) --*

      The unique identifier for the treatment.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --*

      The allocated percentage of users (segment members) that the treatment is sent to.

    - **State** *(dict) --*

      The current status of the treatment.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `DefaultState`

    The current status of the campaign's default treatment. This value exists only for campaigns
    that have more than one treatment, to support A/B testing.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientCreateCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseHookTypeDef(
    _ClientCreateCampaignResponseCampaignResponseHookTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientCreateCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseLimitsTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientCreateCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientCreateCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseStateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseStateTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `State`

    The current status of the campaign.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponseTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponseCampaignResponse` `TemplateConfiguration`

    The message template that’s used for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientCreateCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientCreateCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientCreateCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientCreateCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientCreateCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTypeDef
):
    """
    Type definition for `ClientCreateCampaignResponse` `CampaignResponse`

    Provides information about the status, configuration, and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of responses, one for each treatment that you defined for the campaign, in addition
      to the default treatment.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **Id** *(string) --*

          The unique identifier for the treatment.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --*

          The allocated percentage of users (segment members) that the treatment is sent to.

        - **State** *(dict) --*

          The current status of the treatment.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the campaign.

    - **CreationDate** *(string) --*

      The date, ISO 8601 format, when the campaign was created.

    - **DefaultState** *(dict) --*

      The current status of the campaign's default treatment. This value exists only for campaigns
      that have more than one treatment, to support A/B testing.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **Description** *(string) --*

      The custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **Id** *(string) --*

      The unique identifier for the campaign.

    - **IsPaused** *(boolean) --*

      Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
      by changing this value to false.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the campaign was last modified.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment that's associated with the campaign.

    - **SegmentVersion** *(integer) --*

      The version number of the segment that's associated with the campaign.

    - **State** *(dict) --*

      The current status of the campaign.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template that’s used for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of a variation of the campaign that's used for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign that's used for A/B testing.

    - **Version** *(integer) --*

      The version number of the campaign.
    """


_ClientCreateCampaignResponseTypeDef = TypedDict(
    "_ClientCreateCampaignResponseTypeDef",
    {"CampaignResponse": ClientCreateCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientCreateCampaignResponseTypeDef(_ClientCreateCampaignResponseTypeDef):
    """
    Type definition for `ClientCreateCampaign` `Response`

    The request succeeded and the specified resource was created.

    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.

      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.

        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.

          - **Id** *(string) --*

            The unique identifier for the treatment.

          - **MessageConfiguration** *(dict) --*

            The message configuration settings for the treatment.

            - **ADMMessage** *(dict) --*

              The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
              This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **APNSMessage** *(dict) --*

              The message that the campaign sends through the APNs (Apple Push Notification service)
              channel. This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **BaiduMessage** *(dict) --*

              The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
              message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **DefaultMessage** *(dict) --*

              The default message that the campaign sends through all the channels that are
              configured for the campaign.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **EmailMessage** *(dict) --*

              The message that the campaign sends through the email channel.

              - **Body** *(string) --*

                The body of the email for recipients whose email clients don't render HTML content.

              - **FromAddress** *(string) --*

                The verified email address to send the email from. The default address is the
                FromAddress specified for the email channel for the application.

              - **HtmlBody** *(string) --*

                The body of the email, in HTML format, for recipients whose email clients render
                HTML content.

              - **Title** *(string) --*

                The subject line, or title, of the email.

            - **GCMMessage** *(dict) --*

              The message that the campaign sends through the GCM channel, which enables Amazon
              Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
              formerly Google Cloud Messaging (GCM), service. This message overrides the default
              message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **SMSMessage** *(dict) --*

              The message that the campaign sends through the SMS channel.

              - **Body** *(string) --*

                The body of the SMS message.

              - **MessageType** *(string) --*

                The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
                time-sensitive, such as a one-time password that supports a customer transaction;
                and, PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
                message.

              - **SenderId** *(string) --*

                The sender ID to display on recipients' devices when they receive the SMS message.

          - **Schedule** *(dict) --*

            The schedule settings for the treatment.

            - **EndTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign ended or will end.

            - **EventFilter** *(dict) --*

              The type of event that causes the campaign to be sent, if the value of the Frequency
              property is EVENT.

              - **Dimensions** *(dict) --*

                The dimension settings of the event filter for the campaign.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **FilterType** *(string) --*

                The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                when an endpoint event (Events resource) occurs.

            - **Frequency** *(string) --*

              Specifies how often the campaign is sent or whether the campaign is sent in response
              to a specific event.

            - **IsLocalTime** *(boolean) --*

              Specifies whether the start and end times for the campaign schedule use each
              recipient's local time. To base the schedule on each recipient's local time, set this
              value to true.

            - **QuietTime** *(dict) --*

              The default quiet time for the campaign. Quiet time is a specific time range when a
              campaign doesn't send messages to endpoints, if all the following conditions are met:

              * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

              * The current time in the endpoint's time zone is later than or equal to the time
              specified by the QuietTime.Start property for the campaign.

              * The current time in the endpoint's time zone is earlier than or equal to the time
              specified by the QuietTime.End property for the campaign.

              If any of the preceding conditions isn't met, the endpoint will receive messages from
              the campaign, even if quiet time is enabled.

              - **End** *(string) --*

                The specific time when quiet time ends. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

              - **Start** *(string) --*

                The specific time when quiet time begins. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

            - **StartTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
              property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
              UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
              UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
              UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

          - **SizePercent** *(integer) --*

            The allocated percentage of users (segment members) that the treatment is sent to.

          - **State** *(dict) --*

            The current status of the treatment.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **TemplateConfiguration** *(dict) --*

            The message template to use for the treatment.

            - **EmailTemplate** *(dict) --*

              The email template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **PushTemplate** *(dict) --*

              The push notification template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **SMSTemplate** *(dict) --*

              The SMS template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **VoiceTemplate** *(dict) --*

              The voice template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

          - **TreatmentDescription** *(string) --*

            The custom description of the treatment.

          - **TreatmentName** *(string) --*

            The custom name of the treatment. A treatment is a variation of a campaign that's used
            for A/B testing of a campaign.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the campaign applies to.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the campaign.

      - **CreationDate** *(string) --*

        The date, ISO 8601 format, when the campaign was created.

      - **DefaultState** *(dict) --*

        The current status of the campaign's default treatment. This value exists only for campaigns
        that have more than one treatment, to support A/B testing.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **Description** *(string) --*

        The custom description of the campaign.

      - **HoldoutPercent** *(integer) --*

        The allocated percentage of users (segment members) who shouldn't receive messages from the
        campaign.

      - **Hook** *(dict) --*

        The settings for the AWS Lambda function to use as a code hook for the campaign.

        - **LambdaFunctionName** *(string) --*

          The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
          invokes to send messages for a campaign.

        - **Mode** *(string) --*

          Specifies which Lambda mode to use when invoking the AWS Lambda function.

        - **WebUrl** *(string) --*

          The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

      - **Id** *(string) --*

        The unique identifier for the campaign.

      - **IsPaused** *(boolean) --*

        Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
        by changing this value to false.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the campaign was last modified.

      - **Limits** *(dict) --*

        The messaging limits for the campaign.

        - **Daily** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during a
          24-hour period. The maximum value is 100.

        - **MaximumDuration** *(integer) --*

          The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
          after the scheduled start time for the campaign. The minimum value is 60 seconds.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that a campaign can send each second. The minimum value is
          50. The maximum value is 20,000.

        - **Total** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during the
          course of the campaign. The maximum value is 100.

      - **MessageConfiguration** *(dict) --*

        The message configuration settings for the campaign.

        - **ADMMessage** *(dict) --*

          The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
          This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **APNSMessage** *(dict) --*

          The message that the campaign sends through the APNs (Apple Push Notification service)
          channel. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **BaiduMessage** *(dict) --*

          The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
          message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **DefaultMessage** *(dict) --*

          The default message that the campaign sends through all the channels that are configured
          for the campaign.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **EmailMessage** *(dict) --*

          The message that the campaign sends through the email channel.

          - **Body** *(string) --*

            The body of the email for recipients whose email clients don't render HTML content.

          - **FromAddress** *(string) --*

            The verified email address to send the email from. The default address is the
            FromAddress specified for the email channel for the application.

          - **HtmlBody** *(string) --*

            The body of the email, in HTML format, for recipients whose email clients render HTML
            content.

          - **Title** *(string) --*

            The subject line, or title, of the email.

        - **GCMMessage** *(dict) --*

          The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
          to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google
          Cloud Messaging (GCM), service. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **SMSMessage** *(dict) --*

          The message that the campaign sends through the SMS channel.

          - **Body** *(string) --*

            The body of the SMS message.

          - **MessageType** *(string) --*

            The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
            time-sensitive, such as a one-time password that supports a customer transaction; and,
            PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

          - **SenderId** *(string) --*

            The sender ID to display on recipients' devices when they receive the SMS message.

      - **Name** *(string) --*

        The name of the campaign.

      - **Schedule** *(dict) --*

        The schedule settings for the campaign.

        - **EndTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign ended or will end.

        - **EventFilter** *(dict) --*

          The type of event that causes the campaign to be sent, if the value of the Frequency
          property is EVENT.

          - **Dimensions** *(dict) --*

            The dimension settings of the event filter for the campaign.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **FilterType** *(string) --*

            The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
            the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
            endpoint event (Events resource) occurs.

        - **Frequency** *(string) --*

          Specifies how often the campaign is sent or whether the campaign is sent in response to a
          specific event.

        - **IsLocalTime** *(boolean) --*

          Specifies whether the start and end times for the campaign schedule use each recipient's
          local time. To base the schedule on each recipient's local time, set this value to true.

        - **QuietTime** *(dict) --*

          The default quiet time for the campaign. Quiet time is a specific time range when a
          campaign doesn't send messages to endpoints, if all the following conditions are met:

          * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

          * The current time in the endpoint's time zone is later than or equal to the time
          specified by the QuietTime.Start property for the campaign.

          * The current time in the endpoint's time zone is earlier than or equal to the time
          specified by the QuietTime.End property for the campaign.

          If any of the preceding conditions isn't met, the endpoint will receive messages from the
          campaign, even if quiet time is enabled.

          - **End** *(string) --*

            The specific time when quiet time ends. This value has to use 24-hour notation and be in
            HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

          - **Start** *(string) --*

            The specific time when quiet time begins. This value has to use 24-hour notation and be
            in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **StartTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
          UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
          UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

      - **SegmentId** *(string) --*

        The unique identifier for the segment that's associated with the campaign.

      - **SegmentVersion** *(integer) --*

        The version number of the segment that's associated with the campaign.

      - **State** *(dict) --*

        The current status of the campaign.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the campaign. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateConfiguration** *(dict) --*

        The message template that’s used for the campaign.

        - **EmailTemplate** *(dict) --*

          The email template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **PushTemplate** *(dict) --*

          The push notification template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **SMSTemplate** *(dict) --*

          The SMS template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **VoiceTemplate** *(dict) --*

          The voice template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

      - **TreatmentDescription** *(string) --*

        The custom description of a variation of the campaign that's used for A/B testing.

      - **TreatmentName** *(string) --*

        The custom name of a variation of the campaign that's used for A/B testing.

      - **Version** *(integer) --*

        The version number of the campaign.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Title": str},
)
_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --* **[REQUIRED]**

      The subject line, or title, of the email.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --* **[REQUIRED]**

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilter` `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **FilterType** *(string) --* **[REQUIRED]**

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsSchedule`
    `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    {"StartTime": str},
)
_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestAdditionalTreatments` `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **FilterType** *(string) --* **[REQUIRED]**

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --* **[REQUIRED]**

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    {"SizePercent": int},
)
_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    {
        "MessageConfiguration": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
        "TemplateConfiguration": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef,
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequest` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --* **[REQUIRED]**

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --* **[REQUIRED]**

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

        - **FilterType** *(string) --* **[REQUIRED]**

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --* **[REQUIRED]**

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --* **[REQUIRED]**

      The allocated percentage of users (segment members) to send the treatment to.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      A custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientCreateCampaignWriteCampaignRequestHookTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestHookTypeDef(
    _ClientCreateCampaignWriteCampaignRequestHookTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequest` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientCreateCampaignWriteCampaignRequestLimitsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestLimitsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestLimitsTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequest` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestMessageConfiguration` `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestMessageConfiguration` `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_RequiredClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    {"Title": str},
)
_OptionalClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --* **[REQUIRED]**

      The subject line, or title, of the email.
    """


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestMessageConfiguration` `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestMessageConfiguration` `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequest` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --* **[REQUIRED]**

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_RequiredClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str, ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
        ],
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestScheduleEventFilter` `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **FilterType** *(string) --* **[REQUIRED]**

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_RequiredClientCreateCampaignWriteCampaignRequestScheduleTypeDef = TypedDict(
    "_RequiredClientCreateCampaignWriteCampaignRequestScheduleTypeDef", {"StartTime": str}
)
_OptionalClientCreateCampaignWriteCampaignRequestScheduleTypeDef = TypedDict(
    "_OptionalClientCreateCampaignWriteCampaignRequestScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleTypeDef(
    _RequiredClientCreateCampaignWriteCampaignRequestScheduleTypeDef,
    _OptionalClientCreateCampaignWriteCampaignRequestScheduleTypeDef,
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequest` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **FilterType** *(string) --* **[REQUIRED]**

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --* **[REQUIRED]**

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequestTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientCreateCampaignWriteCampaignRequest` `TemplateConfiguration`

    The message template to use for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientCreateCampaignWriteCampaignRequestTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTypeDef",
    {
        "AdditionalTreatments": List[
            ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef
        ],
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientCreateCampaignWriteCampaignRequestHookTypeDef,
        "IsPaused": bool,
        "Limits": ClientCreateCampaignWriteCampaignRequestLimitsTypeDef,
        "MessageConfiguration": ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientCreateCampaignWriteCampaignRequestScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTypeDef
):
    """
    Type definition for `ClientCreateCampaign` `WriteCampaignRequest`

    Specifies the configuration and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of requests that defines additional treatments for the campaign, in addition to the
      default treatment for the campaign.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --* **[REQUIRED]**

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --* **[REQUIRED]**

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

            - **FilterType** *(string) --* **[REQUIRED]**

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --* **[REQUIRED]**

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --* **[REQUIRED]**

          The allocated percentage of users (segment members) to send the treatment to.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          A custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **Description** *(string) --*

      A custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **IsPaused** *(boolean) --*

      Specifies whether to pause the campaign. A paused campaign doesn't run unless you resume it by
      setting this value to false.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --* **[REQUIRED]**

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The custom name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --* **[REQUIRED]**

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

        - **FilterType** *(string) --* **[REQUIRED]**

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --* **[REQUIRED]**

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the campaign.

    - **SegmentVersion** *(integer) --*

      The version of the segment to associate with the campaign.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the
      campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      A custom description of a variation of the campaign to use for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign to use for A/B testing.
    """


_ClientCreateEmailTemplateEmailTemplateRequestTypeDef = TypedDict(
    "_ClientCreateEmailTemplateEmailTemplateRequestTypeDef",
    {
        "DefaultSubstitutions": str,
        "HtmlPart": str,
        "Subject": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TextPart": str,
    },
    total=False,
)


class ClientCreateEmailTemplateEmailTemplateRequestTypeDef(
    _ClientCreateEmailTemplateEmailTemplateRequestTypeDef
):
    """
    Type definition for `ClientCreateEmailTemplate` `EmailTemplateRequest`

    Creates a new message template that you can use in messages that are sent through the email
    channel.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **HtmlPart** *(string) --*

      The message body, in HTML format, to use in email messages that are based on the message
      template. We recommend using HTML format for email clients that render HTML content. You can
      include links, formatted text, and more in an HTML message.

    - **Subject** *(string) --*

      The subject line, or title, to use in email messages that are based on the message template.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.

    - **TextPart** *(string) --*

      The message body, in plain text format, to use in email messages that are based on the message
      template. We recommend using plain text format for email clients that don't render HTML
      content and clients that are connected to high-latency networks, such as mobile devices.
    """


_ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    Type definition for `ClientCreateEmailTemplateResponse` `CreateTemplateMessageBody`

    Provides information about a request to create a message template.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template that was created.

    - **Message** *(string) --*

      The message that's returned from the API for the request to create the message template.

    - **RequestID** *(string) --*

      The unique identifier for the request to create the message template.
    """


_ClientCreateEmailTemplateResponseTypeDef = TypedDict(
    "_ClientCreateEmailTemplateResponseTypeDef",
    {
        "CreateTemplateMessageBody": ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef
    },
    total=False,
)


class ClientCreateEmailTemplateResponseTypeDef(_ClientCreateEmailTemplateResponseTypeDef):
    """
    Type definition for `ClientCreateEmailTemplate` `Response`

    The request succeeded and the specified resource was created.

    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.

      - **Message** *(string) --*

        The message that's returned from the API for the request to create the message template.

      - **RequestID** *(string) --*

        The unique identifier for the request to create the message template.
    """


_RequiredClientCreateExportJobExportJobRequestTypeDef = TypedDict(
    "_RequiredClientCreateExportJobExportJobRequestTypeDef", {"RoleArn": str, "S3UrlPrefix": str}
)
_OptionalClientCreateExportJobExportJobRequestTypeDef = TypedDict(
    "_OptionalClientCreateExportJobExportJobRequestTypeDef",
    {"SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientCreateExportJobExportJobRequestTypeDef(
    _RequiredClientCreateExportJobExportJobRequestTypeDef,
    _OptionalClientCreateExportJobExportJobRequestTypeDef,
):
    """
    Type definition for `ClientCreateExportJob` `ExportJobRequest`

    Specifies the settings for a job that exports endpoint definitions to an Amazon Simple Storage
    Service (Amazon S3) bucket.

    - **RoleArn** *(string) --* **[REQUIRED]**

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorizes Amazon Pinpoint to access the Amazon S3 location where you want to export endpoint
      definitions to.

    - **S3UrlPrefix** *(string) --* **[REQUIRED]**

      The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where you want
      to export endpoint definitions to. This location is typically a folder that contains multiple
      files. The URL should be in the following format: s3://bucket-name/folder-name/.

    - **SegmentId** *(string) --*

      The identifier for the segment to export endpoint definitions from. If you don't specify this
      value, Amazon Pinpoint exports definitions for all the endpoints that are associated with the
      application.

    - **SegmentVersion** *(integer) --*

      The version of the segment to export endpoint definitions from, if specified.
    """


_ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef(
    _ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef
):
    """
    Type definition for `ClientCreateExportJobResponseExportJobResponse` `Definition`

    The resource settings that apply to the export job.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
      were exported to.

    - **S3UrlPrefix** *(string) --*

      The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
      endpoint definitions were exported to. This location is typically a folder that contains
      multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

    - **SegmentId** *(string) --*

      The identifier for the segment that the endpoint definitions were exported from. If this value
      isn't present, Amazon Pinpoint exported definitions for all the endpoints that are associated
      with the application.

    - **SegmentVersion** *(integer) --*

      The version of the segment that the endpoint definitions were exported from.
    """


_ClientCreateExportJobResponseExportJobResponseTypeDef = TypedDict(
    "_ClientCreateExportJobResponseExportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientCreateExportJobResponseExportJobResponseTypeDef(
    _ClientCreateExportJobResponseExportJobResponseTypeDef
):
    """
    Type definition for `ClientCreateExportJobResponse` `ExportJobResponse`

    Provides information about the status and settings of a job that exports endpoint definitions to
    a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3) bucket by
    using the Amazon Pinpoint API or downloaded directly to a computer by using the Amazon Pinpoint
    console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the export job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the export job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the export job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the export job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the export job.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
        were exported to.

      - **S3UrlPrefix** *(string) --*

        The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
        endpoint definitions were exported to. This location is typically a folder that contains
        multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

      - **SegmentId** *(string) --*

        The identifier for the segment that the endpoint definitions were exported from. If this
        value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
        associated with the application.

      - **SegmentVersion** *(integer) --*

        The version of the segment that the endpoint definitions were exported from.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the export job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the export job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the export job.

    - **JobStatus** *(string) --*

      The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      export job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the export job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      export job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the export job.

    - **Type** *(string) --*

      The job type. This value is EXPORT for export jobs.
    """


_ClientCreateExportJobResponseTypeDef = TypedDict(
    "_ClientCreateExportJobResponseTypeDef",
    {"ExportJobResponse": ClientCreateExportJobResponseExportJobResponseTypeDef},
    total=False,
)


class ClientCreateExportJobResponseTypeDef(_ClientCreateExportJobResponseTypeDef):
    """
    Type definition for `ClientCreateExportJob` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **ExportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that exports endpoint definitions
      to a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3)
      bucket by using the Amazon Pinpoint API or downloaded directly to a computer by using the
      Amazon Pinpoint console.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the export job.

      - **CompletedPieces** *(integer) --*

        The number of pieces that were processed successfully (completed) by the export job, as of
        the time of the request.

      - **CompletionDate** *(string) --*

        The date, in ISO 8601 format, when the export job was completed.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the export job was created.

      - **Definition** *(dict) --*

        The resource settings that apply to the export job.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
          were exported to.

        - **S3UrlPrefix** *(string) --*

          The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
          endpoint definitions were exported to. This location is typically a folder that contains
          multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

        - **SegmentId** *(string) --*

          The identifier for the segment that the endpoint definitions were exported from. If this
          value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
          associated with the application.

        - **SegmentVersion** *(integer) --*

          The version of the segment that the endpoint definitions were exported from.

      - **FailedPieces** *(integer) --*

        The number of pieces that weren't processed successfully (failed) by the export job, as of
        the time of the request.

      - **Failures** *(list) --*

        An array of entries, one for each of the first 100 entries that weren't processed
        successfully (failed) by the export job, if any.

        - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the export job.

      - **JobStatus** *(string) --*

        The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
        process one or more pieces in the job.

      - **TotalFailures** *(integer) --*

        The total number of endpoint definitions that weren't processed successfully (failed) by the
        export job, typically because an error, such as a syntax error, occurred.

      - **TotalPieces** *(integer) --*

        The total number of pieces that must be processed to complete the export job. Each piece
        consists of an approximately equal portion of the endpoint definitions that are part of the
        export job.

      - **TotalProcessed** *(integer) --*

        The total number of endpoint definitions that were processed by the export job.

      - **Type** *(string) --*

        The job type. This value is EXPORT for export jobs.
    """


_RequiredClientCreateImportJobImportJobRequestTypeDef = TypedDict(
    "_RequiredClientCreateImportJobImportJobRequestTypeDef",
    {"Format": str, "RoleArn": str, "S3Url": str},
)
_OptionalClientCreateImportJobImportJobRequestTypeDef = TypedDict(
    "_OptionalClientCreateImportJobImportJobRequestTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "RegisterEndpoints": bool,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientCreateImportJobImportJobRequestTypeDef(
    _RequiredClientCreateImportJobImportJobRequestTypeDef,
    _OptionalClientCreateImportJobImportJobRequestTypeDef,
):
    """
    Type definition for `ClientCreateImportJob` `ImportJobRequest`

    Specifies the settings for a job that imports endpoint definitions from an Amazon Simple Storage
    Service (Amazon S3) bucket.

    - **DefineSegment** *(boolean) --*

      Specifies whether to create a segment that contains the endpoints, when the endpoint
      definitions are imported.

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --* **[REQUIRED]**

      The format of the files that contain the endpoint definitions to import. Valid values are:
      CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format. If the
      Amazon S3 location stores multiple files that use different formats, Amazon Pinpoint imports
      data only from the files that use the specified format.

    - **RegisterEndpoints** *(boolean) --*

      Specifies whether to register the endpoints with Amazon Pinpoint, when the endpoint
      definitions are imported.

    - **RoleArn** *(string) --* **[REQUIRED]**

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --* **[REQUIRED]**

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
      definitions to import. This location can be a folder or a single file. If the location is a
      folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
      including any subfolders that the folder contains.

      The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
      location can end with the key for an individual object or a prefix that qualifies multiple
      objects.

    - **SegmentId** *(string) --*

      The identifier for the segment to update or add the imported endpoint definitions to, if the
      import job is meant to update an existing segment.

    - **SegmentName** *(string) --*

      The custom name for the segment that's created by the import job, if the value of the
      DefineSegment property is true.
    """


_ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": str,
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef(
    _ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef
):
    """
    Type definition for `ClientCreateImportJobResponseImportJobResponse` `Definition`

    The resource settings that apply to the import job.

    - **DefineSegment** *(boolean) --*

      Specifies whether the import job creates a segment that contains the endpoints, when the
      endpoint definitions are imported.

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that contain the endpoint definitions to import. Valid values are:
      CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

      If the files are stored in an Amazon S3 location and that location contains multiple files
      that use different formats, Amazon Pinpoint imports data only from the files that use the
      specified format.

    - **RegisterEndpoints** *(boolean) --*

      Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
      endpoint definitions are imported.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
      definitions to import. This location can be a folder or a single file. If the location is a
      folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
      including any subfolders that the folder contains.

      The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
      location can end with the key for an individual object or a prefix that qualifies multiple
      objects.

    - **SegmentId** *(string) --*

      The identifier for the segment that the import job updates or adds endpoint definitions to, if
      the import job updates an existing segment.

    - **SegmentName** *(string) --*

      The custom name for the segment that's created by the import job, if the value of the
      DefineSegment property is true.
    """


_ClientCreateImportJobResponseImportJobResponseTypeDef = TypedDict(
    "_ClientCreateImportJobResponseImportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientCreateImportJobResponseImportJobResponseTypeDef(
    _ClientCreateImportJobResponseImportJobResponseTypeDef
):
    """
    Type definition for `ClientCreateImportJobResponse` `ImportJobResponse`

    Provides information about the status and settings of a job that imports endpoint definitions
    from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon S3)
    bucket or uploaded directly from a computer by using the Amazon Pinpoint console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the import job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the import job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the import job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the import job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the import job.

      - **DefineSegment** *(boolean) --*

        Specifies whether the import job creates a segment that contains the endpoints, when the
        endpoint definitions are imported.

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that contain the endpoint definitions to import. Valid values are:
        CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

        If the files are stored in an Amazon S3 location and that location contains multiple files
        that use different formats, Amazon Pinpoint imports data only from the files that use the
        specified format.

      - **RegisterEndpoints** *(boolean) --*

        Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
        endpoint definitions are imported.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
        definitions to import. This location can be a folder or a single file. If the location is a
        folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
        including any subfolders that the folder contains.

        The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
        location can end with the key for an individual object or a prefix that qualifies multiple
        objects.

      - **SegmentId** *(string) --*

        The identifier for the segment that the import job updates or adds endpoint definitions to,
        if the import job updates an existing segment.

      - **SegmentName** *(string) --*

        The custom name for the segment that's created by the import job, if the value of the
        DefineSegment property is true.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the import job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the import job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the import job.

    - **JobStatus** *(string) --*

      The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      import job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the import job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      import job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the import job.

    - **Type** *(string) --*

      The job type. This value is IMPORT for import jobs.
    """


_ClientCreateImportJobResponseTypeDef = TypedDict(
    "_ClientCreateImportJobResponseTypeDef",
    {"ImportJobResponse": ClientCreateImportJobResponseImportJobResponseTypeDef},
    total=False,
)


class ClientCreateImportJobResponseTypeDef(_ClientCreateImportJobResponseTypeDef):
    """
    Type definition for `ClientCreateImportJob` `Response`

    The request succeeded and the specified resource was created.

    - **ImportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that imports endpoint definitions
      from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon
      S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint console.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the import job.

      - **CompletedPieces** *(integer) --*

        The number of pieces that were processed successfully (completed) by the import job, as of
        the time of the request.

      - **CompletionDate** *(string) --*

        The date, in ISO 8601 format, when the import job was completed.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the import job was created.

      - **Definition** *(dict) --*

        The resource settings that apply to the import job.

        - **DefineSegment** *(boolean) --*

          Specifies whether the import job creates a segment that contains the endpoints, when the
          endpoint definitions are imported.

        - **ExternalId** *(string) --*

          (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
          policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
          endpoint definitions, but we removed this requirement. We don't recommend use of external
          IDs for IAM roles that are assumed by Amazon Pinpoint.

        - **Format** *(string) --*

          The format of the files that contain the endpoint definitions to import. Valid values are:
          CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

          If the files are stored in an Amazon S3 location and that location contains multiple files
          that use different formats, Amazon Pinpoint imports data only from the files that use the
          specified format.

        - **RegisterEndpoints** *(boolean) --*

          Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
          endpoint definitions are imported.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
          from.

        - **S3Url** *(string) --*

          The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
          definitions to import. This location can be a folder or a single file. If the location is
          a folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
          including any subfolders that the folder contains.

          The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
          location can end with the key for an individual object or a prefix that qualifies multiple
          objects.

        - **SegmentId** *(string) --*

          The identifier for the segment that the import job updates or adds endpoint definitions
          to, if the import job updates an existing segment.

        - **SegmentName** *(string) --*

          The custom name for the segment that's created by the import job, if the value of the
          DefineSegment property is true.

      - **FailedPieces** *(integer) --*

        The number of pieces that weren't processed successfully (failed) by the import job, as of
        the time of the request.

      - **Failures** *(list) --*

        An array of entries, one for each of the first 100 entries that weren't processed
        successfully (failed) by the import job, if any.

        - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the import job.

      - **JobStatus** *(string) --*

        The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
        process one or more pieces in the job.

      - **TotalFailures** *(integer) --*

        The total number of endpoint definitions that weren't processed successfully (failed) by the
        import job, typically because an error, such as a syntax error, occurred.

      - **TotalPieces** *(integer) --*

        The total number of pieces that must be processed to complete the import job. Each piece
        consists of an approximately equal portion of the endpoint definitions that are part of the
        import job.

      - **TotalProcessed** *(integer) --*

        The total number of endpoint definitions that were processed by the import job.

      - **Type** *(string) --*

        The job type. This value is IMPORT for import jobs.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitCondition` `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --*

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivities` `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesEMAIL` `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --*

      The percentage of participants who shouldn't continue the journey.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranches`
    `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesMultiCondition`
    `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --*

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplit` `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponse` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --*

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientCreateJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseLimitsTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponse` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponse` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientCreateJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientCreateJourneyResponseJourneyResponseScheduleTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponse` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponseStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponseJourneyResponse` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.
    """


_ClientCreateJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientCreateJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientCreateJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": str,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseTypeDef(
    _ClientCreateJourneyResponseJourneyResponseTypeDef
):
    """
    Type definition for `ClientCreateJourneyResponse` `JourneyResponse`

    Provides information about the status, configuration, and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --*

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the journey applies to.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **Id** *(string) --*

      The unique identifier for the journey.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. If this value is true, the schedule uses each participant's local time.

    - **Name** *(string) --*

      The name of the journey.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The current status of the journey. Possible values are:

      * DRAFT - The journey is being developed and hasn't been published yet.

      * ACTIVE - The journey has been developed and published. Depending on the journey's schedule,
      the journey may currently be running or scheduled to start running at a later time. If a
      journey's status is ACTIVE, you can't add, change, or remove activities from it.

      * COMPLETED - The journey has been published and has finished running. All participants have
      entered the journey and no participants are waiting to complete the journey or any activities
      in the journey.

      * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't add,
      change, or remove activities or segment settings from the journey.

      * CLOSED - The journey has been published and has started running. It may have also passed its
      scheduled end time, or passed its scheduled start time and a refresh frequency hasn't been
      specified for it. If a journey's status is CLOSED, you can't add participants to it, and no
      existing participants can enter the journey for the first time. However, any existing
      participants who are currently waiting to start an activity may resume the journey.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the journey. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientCreateJourneyResponseTypeDef = TypedDict(
    "_ClientCreateJourneyResponseTypeDef",
    {"JourneyResponse": ClientCreateJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientCreateJourneyResponseTypeDef(_ClientCreateJourneyResponseTypeDef):
    """
    Type definition for `ClientCreateJourney` `Response`

    The request succeeded and the specified resource was created.

    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.

      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.

        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.

            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.

              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.

                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.

                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                - **Operator** *(string) --*

                  Specifies how to handle multiple conditions for the activity. For example, if you
                  specify two conditions for an activity, whether both or only one of the conditions
                  must be met for the activity to be performed.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait before determining whether the conditions are met, or the
                date and time when Amazon Pinpoint determines whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

              - **FalseActivity** *(string) --*

                The unique identifier for the activity to perform if the condition isn't met.

              - **TrueActivity** *(string) --*

                The unique identifier for the activity to perform if the condition is met.

            - **Description** *(string) --*

              The custom description of the activity.

            - **EMAIL** *(dict) --*

              The settings for an email activity. This type of activity sends an email message to
              participants.

              - **MessageConfig** *(dict) --*

                The "From" address to use for the message.

                - **FromAddress** *(string) --*

                  The verified email address to send the email message from. The default address is
                  the FromAddress specified for the email channel for the application.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after the message is sent.

              - **TemplateName** *(string) --*

                The name of the email template to use for the message.

            - **Holdout** *(dict) --*

              The settings for a holdout activity. This type of activity stops a journey for a
              specified percentage of participants.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the holdout
                activity.

              - **Percentage** *(integer) --*

                The percentage of participants who shouldn't continue the journey.

            - **MultiCondition** *(dict) --*

              The settings for a multivariate split activity. This type of activity sends
              participants down one of as many as five paths in a journey, based on conditions that
              you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the conditions for entering each path and the
                activity to perform for each path.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity path in a journey.

                  - **Condition** *(dict) --*

                    The condition to evaluate for the activity path.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

              - **DefaultActivity** *(string) --*

                The activity to perform by default for any path in the activity.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait or the date and time when Amazon Pinpoint determines
                whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

            - **RandomSplit** *(dict) --*

              The settings for a random split activity. This type of activity randomly sends
              specified percentages of participants down one of as many as five paths in a journey,
              based on conditions that you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the percentage of participants to enter each
                path and the activity to perform for each path.

                - *(dict) --*

                  Specifies the settings for a path in a random split activity in a journey.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

                  - **Percentage** *(integer) --*

                    The percentage of participants to send down the activity path.

            - **Wait** *(dict) --*

              The settings for a wait activity. This type of activity waits for a certain amount of
              time or until a specific date and time before moving participants to the next activity
              in a journey.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the wait
                activity.

              - **WaitTime** *(dict) --*

                The amount of time to wait or the date and time when the activity moves participants
                to the next activity in the journey.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the journey applies to.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the journey was created.

      - **Id** *(string) --*

        The unique identifier for the journey.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the journey was last modified.

      - **Limits** *(dict) --*

        The messaging and entry limits for the journey.

        - **DailyCap** *(integer) --*

          The maximum number of messages that the journey can send to a single participant during a
          24-hour period. The maximum value is 100.

        - **EndpointReentryCap** *(integer) --*

          The maximum number of times that a participant can enter the journey. The maximum value is
          100. To allow participants to enter the journey an unlimited number of times, set this
          value to 0.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that the journey can send each second.

      - **LocalTime** *(boolean) --*

        Specifies whether the journey's scheduled start and end times use each participant's local
        time. If this value is true, the schedule uses each participant's local time.

      - **Name** *(string) --*

        The name of the journey.

      - **QuietTime** *(dict) --*

        The quiet time settings for the journey. Quiet time is a specific time range when a journey
        doesn't send messages to participants, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
        valid value.

        * The current time in the participant's time zone is later than or equal to the time
        specified by the QuietTime.Start property for the journey.

        * The current time in the participant's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the journey.

        If any of the preceding conditions isn't met, the participant will receive messages from the
        journey, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **RefreshFrequency** *(string) --*

        The frequency with which Amazon Pinpoint evaluates segment and event data for the journey,
        as a duration in ISO 8601 format.

      - **Schedule** *(dict) --*

        The schedule settings for the journey.

        - **EndTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey ended or will end.

        - **StartTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
          UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45,
          UTC-02, UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
          UTC-09:30, UTC-10, and UTC-11.

      - **StartActivity** *(string) --*

        The unique identifier for the first activity in the journey.

      - **StartCondition** *(dict) --*

        The segment that defines which users are participants in the journey.

        - **Description** *(string) --*

          The custom description of the condition.

        - **SegmentStartCondition** *(dict) --*

          The segment that's associated with the first activity in the journey. This segment
          determines which users are participants in the journey.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

      - **State** *(string) --*

        The current status of the journey. Possible values are:

        * DRAFT - The journey is being developed and hasn't been published yet.

        * ACTIVE - The journey has been developed and published. Depending on the journey's
        schedule, the journey may currently be running or scheduled to start running at a later
        time. If a journey's status is ACTIVE, you can't add, change, or remove activities from it.

        * COMPLETED - The journey has been published and has finished running. All participants have
        entered the journey and no participants are waiting to complete the journey or any
        activities in the journey.

        * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't
        add, change, or remove activities or segment settings from the journey.

        * CLOSED - The journey has been published and has started running. It may have also passed
        its scheduled end time, or passed its scheduled start time and a refresh frequency hasn't
        been specified for it. If a journey's status is CLOSED, you can't add participants to it,
        and no existing participants can enter the journey for the first time. However, any existing
        participants who are currently waiting to start an activity may resume the journey.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the journey. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
    },
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {"MessageActivity": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --* **[REQUIRED]**

      The unique identifier for the segment to associate with the activity.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitCondition`
    `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --* **[REQUIRED]**

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --* **[REQUIRED]**

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --* **[REQUIRED]**

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --* **[REQUIRED]**

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --* **[REQUIRED]**

              The latitude coordinate of the location.

            - **Longitude** *(float) --* **[REQUIRED]**

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --* **[REQUIRED]**

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --* **[REQUIRED]**

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --* **[REQUIRED]**

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --* **[REQUIRED]**

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --* **[REQUIRED]**

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --* **[REQUIRED]**

                  The latitude coordinate of the location.

                - **Longitude** *(float) --* **[REQUIRED]**

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivities` `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --* **[REQUIRED]**

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --* **[REQUIRED]**

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --* **[REQUIRED]**

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --* **[REQUIRED]**

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --* **[REQUIRED]**

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --* **[REQUIRED]**

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --* **[REQUIRED]**

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesEMAIL` `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef", {"Percentage": int}
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    {"NextActivity": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --* **[REQUIRED]**

      The percentage of participants who shouldn't continue the journey.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
    },
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {"MessageActivity": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --* **[REQUIRED]**

      The unique identifier for the segment to associate with the activity.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranches`
    `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --* **[REQUIRED]**

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --* **[REQUIRED]**

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --* **[REQUIRED]**

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --* **[REQUIRED]**

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --* **[REQUIRED]**

              The latitude coordinate of the location.

            - **Longitude** *(float) --* **[REQUIRED]**

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesMultiCondition` `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --* **[REQUIRED]**

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --* **[REQUIRED]**

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --* **[REQUIRED]**

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --* **[REQUIRED]**

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --* **[REQUIRED]**

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --* **[REQUIRED]**

                The latitude coordinate of the location.

              - **Longitude** *(float) --* **[REQUIRED]**

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --* **[REQUIRED]**

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --* **[REQUIRED]**

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --* **[REQUIRED]**

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --* **[REQUIRED]**

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --* **[REQUIRED]**

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --* **[REQUIRED]**

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --* **[REQUIRED]**

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplit` `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    {"Branches": List[ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef",
    {
        "ConditionalSplit": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef,
        "Holdout": ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
        "MultiCondition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef,
        "Wait": ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequest` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --* **[REQUIRED]**

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --* **[REQUIRED]**

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --* **[REQUIRED]**

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --* **[REQUIRED]**

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --* **[REQUIRED]**

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --* **[REQUIRED]**

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --* **[REQUIRED]**

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --* **[REQUIRED]**

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --* **[REQUIRED]**

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --* **[REQUIRED]**

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --* **[REQUIRED]**

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --* **[REQUIRED]**

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --* **[REQUIRED]**

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --* **[REQUIRED]**

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --* **[REQUIRED]**

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --* **[REQUIRED]**

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --* **[REQUIRED]**

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --* **[REQUIRED]**

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --* **[REQUIRED]**

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --* **[REQUIRED]**

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --* **[REQUIRED]**

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientCreateJourneyWriteJourneyRequestLimitsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestLimitsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestLimitsTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequest` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequest` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientCreateJourneyWriteJourneyRequestScheduleTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestScheduleTypeDef(
    _ClientCreateJourneyWriteJourneyRequestScheduleTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequest` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
)


class ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequestStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --* **[REQUIRED]**

      The unique identifier for the segment to associate with the activity.
    """


_ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef
):
    """
    Type definition for `ClientCreateJourneyWriteJourneyRequest` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --* **[REQUIRED]**

        The unique identifier for the segment to associate with the activity.
    """


_RequiredClientCreateJourneyWriteJourneyRequestTypeDef = TypedDict(
    "_RequiredClientCreateJourneyWriteJourneyRequestTypeDef", {"Name": str}
)
_OptionalClientCreateJourneyWriteJourneyRequestTypeDef = TypedDict(
    "_OptionalClientCreateJourneyWriteJourneyRequestTypeDef",
    {
        "Activities": Dict[str, ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef],
        "CreationDate": str,
        "LastModifiedDate": str,
        "Limits": ClientCreateJourneyWriteJourneyRequestLimitsTypeDef,
        "LocalTime": bool,
        "QuietTime": ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientCreateJourneyWriteJourneyRequestScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef,
        "State": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestTypeDef(
    _RequiredClientCreateJourneyWriteJourneyRequestTypeDef,
    _OptionalClientCreateJourneyWriteJourneyRequestTypeDef,
):
    """
    Type definition for `ClientCreateJourney` `WriteJourneyRequest`

    Specifies the configuration and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --* **[REQUIRED]**

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --* **[REQUIRED]**

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --* **[REQUIRED]**

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --* **[REQUIRED]**

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --* **[REQUIRED]**

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --* **[REQUIRED]**

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --* **[REQUIRED]**

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --* **[REQUIRED]**

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --* **[REQUIRED]**

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --* **[REQUIRED]**

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --* **[REQUIRED]**

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --* **[REQUIRED]**

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --* **[REQUIRED]**

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --* **[REQUIRED]**

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --* **[REQUIRED]**

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --* **[REQUIRED]**

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --* **[REQUIRED]**

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --* **[REQUIRED]**

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --* **[REQUIRED]**

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --* **[REQUIRED]**

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --* **[REQUIRED]**

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --* **[REQUIRED]**

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --* **[REQUIRED]**

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --* **[REQUIRED]**

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --* **[REQUIRED]**

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. To base the schedule on each participant's local time, set this value to true.

    - **Name** *(string) --* **[REQUIRED]**

      The name of the journey. A journey name can contain a maximum of 150 characters. The
      characters can be alphanumeric characters or symbols, such as underscores (_) or hyphens (-).
      A journey name can't contain any spaces.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --* **[REQUIRED]**

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The status of the journey. Valid values are:

      * DRAFT - Saves the journey and doesn't publish it.

      * ACTIVE - Saves and publishes the journey. Depending on the journey's schedule, the journey
      starts running immediately or at the scheduled start time. If a journey's status is ACTIVE,
      you can't add, change, or remove activities from it.

      The CANCELLED, COMPLETED, and CLOSED values are not supported in requests to create or update
      a journey. To cancel a journey, use the Journey Stateresource.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef
):
    """
    Type definition for `ClientCreatePushTemplatePushNotificationTemplateRequest` `ADM`

    The message template to use for the ADM (Amazon Device Messaging) channel. This message template
    overrides the default template for push notification channels (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    {
        "Action": str,
        "Body": str,
        "MediaUrl": str,
        "RawContent": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef
):
    """
    Type definition for `ClientCreatePushTemplatePushNotificationTemplateRequest` `APNS`

    The message template to use for the APNs (Apple Push Notification service) channel. This message
    template overrides the default template for push notification channels
    (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in push notifications that are based on the message template.

    - **MediaUrl** *(string) --*

      The URL of an image or video to display in push notifications that are based on the message
      template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for push notifications that are based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **Sound** *(string) --*

      The key for the sound to play when the recipient receives a push notification that's based on
      the message template. The value for this key is the name of a sound file in your app's main
      bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
      found or you specify default for the value, the system plays the default alert sound.

    - **Title** *(string) --*

      The title to use in push notifications that are based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef
):
    """
    Type definition for `ClientCreatePushTemplatePushNotificationTemplateRequest` `Baidu`

    The message template to use for the Baidu (Baidu Cloud Push) channel. This message template
    overrides the default template for push notification channels (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    {"Action": str, "Body": str, "Sound": str, "Title": str, "Url": str},
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef
):
    """
    Type definition for `ClientCreatePushTemplatePushNotificationTemplateRequest` `Default`

    The default message template to use for push notification channels.

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS and Android platforms.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in push notifications that are based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      For an iOS platform, this value is the key for the name of a sound file in your app's main
      bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
      found or you specify default for the value, the system plays the default alert sound.

    - **Title** *(string) --*

      The title to use in push notifications that are based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef
):
    """
    Type definition for `ClientCreatePushTemplatePushNotificationTemplateRequest` `GCM`

    The message template to use for the GCM channel, which is used to send notifications through the
    Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service. This message
    template overrides the default template for push notification channels
    (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef",
    {
        "ADM": ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef,
        "APNS": ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef,
        "Baidu": ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef,
        "Default": ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef,
        "DefaultSubstitutions": str,
        "GCM": ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef,
        "tags": Dict[str, str],
        "TemplateDescription": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef
):
    """
    Type definition for `ClientCreatePushTemplate` `PushNotificationTemplateRequest`

    Creates a message template that you can use in messages that are sent through a push
    notification channel.

    - **ADM** *(dict) --*

      The message template to use for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **APNS** *(dict) --*

      The message template to use for the APNs (Apple Push Notification service) channel. This
      message template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in push notifications that are based on the message template.

      - **MediaUrl** *(string) --*

        The URL of an image or video to display in push notifications that are based on the message
        template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for push notifications that are based
        on the message template. If specified, this value overrides all other content for the
        message template.

      - **Sound** *(string) --*

        The key for the sound to play when the recipient receives a push notification that's based
        on the message template. The value for this key is the name of a sound file in your app's
        main bundle or the Library/Sounds folder in your app's data container. If the sound file
        can't be found or you specify default for the value, the system plays the default alert
        sound.

      - **Title** *(string) --*

        The title to use in push notifications that are based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **Baidu** *(dict) --*

      The message template to use for the Baidu (Baidu Cloud Push) channel. This message template
      overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **Default** *(dict) --*

      The default message template to use for push notification channels.

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS and Android platforms.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in push notifications that are based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

        For an iOS platform, this value is the key for the name of a sound file in your app's main
        bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
        found or you specify default for the value, the system plays the default alert sound.

      - **Title** *(string) --*

        The title to use in push notifications that are based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **GCM** *(dict) --*

      The message template to use for the GCM channel, which is used to send notifications through
      the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service. This
      message template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.
    """


_ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    Type definition for `ClientCreatePushTemplateResponse` `CreateTemplateMessageBody`

    Provides information about a request to create a message template.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template that was created.

    - **Message** *(string) --*

      The message that's returned from the API for the request to create the message template.

    - **RequestID** *(string) --*

      The unique identifier for the request to create the message template.
    """


_ClientCreatePushTemplateResponseTypeDef = TypedDict(
    "_ClientCreatePushTemplateResponseTypeDef",
    {"CreateTemplateMessageBody": ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef},
    total=False,
)


class ClientCreatePushTemplateResponseTypeDef(_ClientCreatePushTemplateResponseTypeDef):
    """
    Type definition for `ClientCreatePushTemplate` `Response`

    The request succeeded and the specified resource was created.

    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.

      - **Message** *(string) --*

        The message that's returned from the API for the request to create the message template.

      - **RequestID** *(string) --*

        The unique identifier for the request to create the message template.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponse` `Dimensions`

    The dimension settings for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": str,
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponse` `ImportDefinition`

    The settings for the import job that's associated with the segment.

    - **ChannelCounts** *(dict) --*

      The number of channel types in the endpoint definitions that were imported to create the
      segment.

      - *(string) --*

        - *(integer) --*

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that were imported to create the segment. Valid values are: CSV, for
      comma-separated values format; and, JSON, for newline-delimited JSON format.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint definitions
      were imported from to create the segment.

    - **Size** *(integer) --*

      The number of endpoint definitions that were imported successfully to create the segment.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroups` `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroups`
    `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponseSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponseSegmentResponse` `SegmentGroups`

    A list of one or more segment groups that apply to the segment. Each segment group consists of
    zero or more base segments and the dimensions that are applied to those base segments.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --*

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientCreateSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": str,
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseTypeDef(
    _ClientCreateSegmentResponseSegmentResponseTypeDef
):
    """
    Type definition for `ClientCreateSegmentResponse` `SegmentResponse`

    Provides information about the configuration, dimension, and other settings for a segment.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the segment is associated with.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the segment.

    - **CreationDate** *(string) --*

      The date and time when the segment was created.

    - **Dimensions** *(dict) --*

      The dimension settings for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **ImportDefinition** *(dict) --*

      The settings for the import job that's associated with the segment.

      - **ChannelCounts** *(dict) --*

        The number of channel types in the endpoint definitions that were imported to create the
        segment.

        - *(string) --*

          - *(integer) --*

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that were imported to create the segment. Valid values are: CSV, for
        comma-separated values format; and, JSON, for newline-delimited JSON format.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
        definitions were imported from to create the segment.

      - **Size** *(integer) --*

        The number of endpoint definitions that were imported successfully to create the segment.

    - **LastModifiedDate** *(string) --*

      The date and time when the segment was last modified.

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      A list of one or more segment groups that apply to the segment. Each segment group consists of
      zero or more base segments and the dimensions that are applied to those base segments.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --*

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **SegmentType** *(string) --*

      The segment type. Valid values are:

      * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
      specify and is based on endpoint data that's reported by your app. Dynamic segments can change
      over time.

      * IMPORT - A static segment, which is a segment that uses selection criteria that you specify
      and is based on endpoint definitions that you import from a file. Imported segments are
      static; they don't change over time.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the segment. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientCreateSegmentResponseTypeDef = TypedDict(
    "_ClientCreateSegmentResponseTypeDef",
    {"SegmentResponse": ClientCreateSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientCreateSegmentResponseTypeDef(_ClientCreateSegmentResponseTypeDef):
    """
    Type definition for `ClientCreateSegment` `Response`

    The request succeeded and the specified resource was created.

    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the segment.

      - **CreationDate** *(string) --*

        The date and time when the segment was created.

      - **Dimensions** *(dict) --*

        The dimension settings for the segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the segment.

      - **ImportDefinition** *(dict) --*

        The settings for the import job that's associated with the segment.

        - **ChannelCounts** *(dict) --*

          The number of channel types in the endpoint definitions that were imported to create the
          segment.

          - *(string) --*

            - *(integer) --*

        - **ExternalId** *(string) --*

          (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
          policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
          endpoint definitions, but we removed this requirement. We don't recommend use of external
          IDs for IAM roles that are assumed by Amazon Pinpoint.

        - **Format** *(string) --*

          The format of the files that were imported to create the segment. Valid values are: CSV,
          for comma-separated values format; and, JSON, for newline-delimited JSON format.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
          from.

        - **S3Url** *(string) --*

          The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
          definitions were imported from to create the segment.

        - **Size** *(integer) --*

          The number of endpoint definitions that were imported successfully to create the segment.

      - **LastModifiedDate** *(string) --*

        The date and time when the segment was last modified.

      - **Name** *(string) --*

        The name of the segment.

      - **SegmentGroups** *(dict) --*

        A list of one or more segment groups that apply to the segment. Each segment group consists
        of zero or more base segments and the dimensions that are applied to those base segments.

        - **Groups** *(list) --*

          An array that defines the set of segment criteria to evaluate when handling segment groups
          for the segment.

          - *(dict) --*

            Specifies the base segments and dimensions for a segment, and the relationships between
            these base segments and dimensions.

            - **Dimensions** *(list) --*

              An array that defines the dimensions for the segment.

              - *(dict) --*

                Specifies the dimension settings for a segment.

                - **Attributes** *(dict) --*

                  One or more custom attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **Behavior** *(dict) --*

                  The behavior-based criteria, such as how recently users have used your app, for
                  the segment.

                  - **Recency** *(dict) --*

                    The dimension settings that are based on how recently an endpoint was active.

                    - **Duration** *(string) --*

                      The duration to use when determining whether an endpoint is active or
                      inactive.

                    - **RecencyType** *(string) --*

                      The type of recency dimension to use for the segment. Valid values are:
                      ACTIVE, endpoints that were active within the specified duration are included
                      in the segment; and, INACTIVE, endpoints that weren't active within the
                      specified duration are included in the segment.

                - **Demographic** *(dict) --*

                  The demographic-based criteria, such as device platform, for the segment.

                  - **AppVersion** *(dict) --*

                    The app version criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Channel** *(dict) --*

                    The channel criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **DeviceType** *(dict) --*

                    The device type criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Make** *(dict) --*

                    The device make criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Model** *(dict) --*

                    The device model criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Platform** *(dict) --*

                    The device platform criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                - **Location** *(dict) --*

                  The location-based criteria, such as region or GPS coordinates, for the segment.

                  - **Country** *(dict) --*

                    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **GPSPoint** *(dict) --*

                    The GPS location and range for the segment.

                    - **Coordinates** *(dict) --*

                      The GPS coordinates to measure distance from.

                      - **Latitude** *(float) --*

                        The latitude coordinate of the location.

                      - **Longitude** *(float) --*

                        The longitude coordinate of the location.

                    - **RangeInKilometers** *(float) --*

                      The range, in kilometers, from the GPS coordinates.

                - **Metrics** *(dict) --*

                  One or more custom metrics to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

                - **UserAttributes** *(dict) --*

                  One or more custom user attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

            - **SourceSegments** *(list) --*

              The base segment to build the segment on. A base segment, also referred to as a
              *source segment* , defines the initial population of endpoints for a segment. When you
              add dimensions to a segment, Amazon Pinpoint filters the base segment by using the
              dimensions that you specify.

              You can specify more than one dimensional segment or only one imported segment. If you
              specify an imported segment, the Amazon Pinpoint console displays a segment size
              estimate that indicates the size of the imported segment without any filters applied
              to it.

              - *(dict) --*

                Specifies the segment identifier and version of a segment.

                - **Id** *(string) --*

                  The unique identifier for the segment.

                - **Version** *(integer) --*

                  The version number of the segment.

            - **SourceType** *(string) --*

              Specifies how to handle multiple base segments for the segment. For example, if you
              specify three base segments for the segment, whether the resulting segment is based on
              all, any, or none of the base segments.

            - **Type** *(string) --*

              Specifies how to handle multiple dimensions for the segment. For example, if you
              specify three dimensions for the segment, whether the resulting segment includes
              endpoints that match all, any, or none of the dimensions.

        - **Include** *(string) --*

          Specifies how to handle multiple segment groups for the segment. For example, if the
          segment includes three segment groups, whether the resulting segment includes endpoints
          that match all, any, or none of the segment groups.

      - **SegmentType** *(string) --*

        The segment type. Valid values are:

        * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint data that's reported by your app. Dynamic segments can
        change over time.

        * IMPORT - A static segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint definitions that you import from a file. Imported segments
        are static; they don't change over time.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the segment. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **Version** *(integer) --*

        The version number of the segment.
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    {"Recency": ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsDemographic` `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsDemographic` `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef",
    {
        "Attributes": Dict[str, ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef],
        "Behavior": ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequest` `Dimensions`

    The criteria that define the dimensions for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for
    `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroups` `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str},
)
_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Version": int},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef(
    _RequiredClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef,
    _OptionalClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef,
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroups` `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --* **[REQUIRED]**

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequestSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --* **[REQUIRED]**

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --* **[REQUIRED]**

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --* **[REQUIRED]**

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --* **[REQUIRED]**

                The latitude coordinate of the location.

              - **Longitude** *(float) --* **[REQUIRED]**

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --* **[REQUIRED]**

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    {
        "Groups": List[ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef
):
    """
    Type definition for `ClientCreateSegmentWriteSegmentRequest` `SegmentGroups`

    The segment group to use and the dimensions to apply to the group's base segments in order to
    build the segment. A segment group can consist of zero or more base segments. Your request can
    include only one segment group.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --* **[REQUIRED]**

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --* **[REQUIRED]**

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --* **[REQUIRED]**

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --* **[REQUIRED]**

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --* **[REQUIRED]**

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --* **[REQUIRED]**

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientCreateSegmentWriteSegmentRequestTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestTypeDef",
    {
        "Dimensions": ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef,
        "Name": str,
        "SegmentGroups": ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestTypeDef(_ClientCreateSegmentWriteSegmentRequestTypeDef):
    """
    Type definition for `ClientCreateSegment` `WriteSegmentRequest`

    Specifies the configuration, dimension, and other settings for a segment. A WriteSegmentRequest
    object can include a Dimensions object or a SegmentGroups object, but not both.

    - **Dimensions** *(dict) --*

      The criteria that define the dimensions for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --* **[REQUIRED]**

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --* **[REQUIRED]**

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --* **[REQUIRED]**

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --* **[REQUIRED]**

              The latitude coordinate of the location.

            - **Longitude** *(float) --* **[REQUIRED]**

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      The segment group to use and the dimensions to apply to the group's base segments in order to
      build the segment. A segment group can consist of zero or more base segments. Your request can
      include only one segment group.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --* **[REQUIRED]**

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --* **[REQUIRED]**

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --* **[REQUIRED]**

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --* **[REQUIRED]**

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --* **[REQUIRED]**

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --* **[REQUIRED]**

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the segment.
      Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    Type definition for `ClientCreateSmsTemplateResponse` `CreateTemplateMessageBody`

    Provides information about a request to create a message template.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template that was created.

    - **Message** *(string) --*

      The message that's returned from the API for the request to create the message template.

    - **RequestID** *(string) --*

      The unique identifier for the request to create the message template.
    """


_ClientCreateSmsTemplateResponseTypeDef = TypedDict(
    "_ClientCreateSmsTemplateResponseTypeDef",
    {"CreateTemplateMessageBody": ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef},
    total=False,
)


class ClientCreateSmsTemplateResponseTypeDef(_ClientCreateSmsTemplateResponseTypeDef):
    """
    Type definition for `ClientCreateSmsTemplate` `Response`

    The request succeeded and the specified resource was created.

    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.

      - **Message** *(string) --*

        The message that's returned from the API for the request to create the message template.

      - **RequestID** *(string) --*

        The unique identifier for the request to create the message template.
    """


_ClientCreateSmsTemplateSMSTemplateRequestTypeDef = TypedDict(
    "_ClientCreateSmsTemplateSMSTemplateRequestTypeDef",
    {"Body": str, "DefaultSubstitutions": str, "tags": Dict[str, str], "TemplateDescription": str},
    total=False,
)


class ClientCreateSmsTemplateSMSTemplateRequestTypeDef(
    _ClientCreateSmsTemplateSMSTemplateRequestTypeDef
):
    """
    Type definition for `ClientCreateSmsTemplate` `SMSTemplateRequest`

    Creates a message template that you can use in messages that are sent through the SMS channel.

    - **Body** *(string) --*

      The message body to use in text messages that are based on the message template.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.
    """


_ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    Type definition for `ClientCreateVoiceTemplateResponse` `CreateTemplateMessageBody`

    Provides information about a request to create a message template.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template that was created.

    - **Message** *(string) --*

      The message that's returned from the API for the request to create the message template.

    - **RequestID** *(string) --*

      The unique identifier for the request to create the message template.
    """


_ClientCreateVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientCreateVoiceTemplateResponseTypeDef",
    {
        "CreateTemplateMessageBody": ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef
    },
    total=False,
)


class ClientCreateVoiceTemplateResponseTypeDef(_ClientCreateVoiceTemplateResponseTypeDef):
    """
    Type definition for `ClientCreateVoiceTemplate` `Response`

    The request succeeded and the specified resource was created.

    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.

      - **Message** *(string) --*

        The message that's returned from the API for the request to create the message template.

      - **RequestID** *(string) --*

        The unique identifier for the request to create the message template.
    """


_ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef = TypedDict(
    "_ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef",
    {
        "Body": str,
        "DefaultSubstitutions": str,
        "LanguageCode": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "VoiceId": str,
    },
    total=False,
)


class ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef(
    _ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef
):
    """
    Type definition for `ClientCreateVoiceTemplate` `VoiceTemplateRequest`

    Specifies the content and settings for a message template that can be used in messages that are
    sent through the voice channel.

    - **Body** *(string) --*

      The text of the script to use in messages that are based on the message template, in plain
      text format.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **LanguageCode** *(string) --*

      The code for the language to use when synthesizing the text of the script in messages that are
      based on the message template. For a list of supported languages and the code for each one,
      see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.

    - **VoiceId** *(string) --*

      The name of the voice to use when delivering messages that are based on the message template.
      For a list of supported voices, see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """


_ClientDeleteAdmChannelResponseADMChannelResponseTypeDef = TypedDict(
    "_ClientDeleteAdmChannelResponseADMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteAdmChannelResponseADMChannelResponseTypeDef(
    _ClientDeleteAdmChannelResponseADMChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteAdmChannelResponse` `ADMChannelResponse`

    Provides information about the status and settings of the ADM (Amazon Device Messaging) channel
    for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the ADM channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the ADM channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the ADM channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the ADM channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the ADM channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the ADM channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the ADM channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the ADM channel, this
      value is ADM.

    - **Version** *(integer) --*

      The current version of the ADM channel.
    """


_ClientDeleteAdmChannelResponseTypeDef = TypedDict(
    "_ClientDeleteAdmChannelResponseTypeDef",
    {"ADMChannelResponse": ClientDeleteAdmChannelResponseADMChannelResponseTypeDef},
    total=False,
)


class ClientDeleteAdmChannelResponseTypeDef(_ClientDeleteAdmChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteAdmChannel` `Response`

    The request succeeded.

    - **ADMChannelResponse** *(dict) --*

      Provides information about the status and settings of the ADM (Amazon Device Messaging)
      channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the ADM channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the ADM channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the ADM channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the ADM channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the ADM channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the ADM channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the ADM channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the ADM channel, this
        value is ADM.

      - **Version** *(integer) --*

        The current version of the ADM channel.
    """


_ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef(
    _ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteApnsChannelResponse` `APNSChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with APNs for this
      channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs channel is configured to communicate with APNs by using APNs
      tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
      channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs channel, this
      value is APNS.

    - **Version** *(integer) --*

      The current version of the APNs channel.
    """


_ClientDeleteApnsChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsChannelResponseTypeDef",
    {"APNSChannelResponse": ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef},
    total=False,
)


class ClientDeleteApnsChannelResponseTypeDef(_ClientDeleteApnsChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteApnsChannel` `Response`

    The request succeeded.

    - **APNSChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with APNs for
        this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs channel is configured to communicate with APNs by using APNs
        tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
        channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs channel, this
        value is APNS.

      - **Version** *(integer) --*

        The current version of the APNs channel.
    """


_ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef(
    _ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteApnsSandboxChannelResponse` `APNSSandboxChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    sandbox channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs sandbox channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs sandbox channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
      sandbox environment for this channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs sandbox channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs sandbox channel is configured to communicate with APNs by using
      APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property of
      the channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs sandbox channel. This property is retained only for
      backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs sandbox channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs sandbox channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs sandbox channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs sandbox channel,
      this value is APNS_SANDBOX.

    - **Version** *(integer) --*

      The current version of the APNs sandbox channel.
    """


_ClientDeleteApnsSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsSandboxChannelResponseTypeDef",
    {
        "APNSSandboxChannelResponse": ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientDeleteApnsSandboxChannelResponseTypeDef(_ClientDeleteApnsSandboxChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteApnsSandboxChannel` `Response`

    The request succeeded.

    - **APNSSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) sandbox channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs sandbox channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs sandbox channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
        sandbox environment for this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs sandbox channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs sandbox channel is configured to communicate with APNs by using
        APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property of
        the channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs sandbox channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs sandbox channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs sandbox channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs sandbox channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs sandbox
        channel, this value is APNS_SANDBOX.

      - **Version** *(integer) --*

        The current version of the APNs sandbox channel.
    """


_ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef(
    _ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteApnsVoipChannelResponse` `APNSVoipChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    VoIP channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs VoIP channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs VoIP channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with APNs for this
      channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs VoIP channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs VoIP channel is configured to communicate with APNs by using APNs
      tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
      channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs VoIP channel. This property is retained only for
      backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs VoIP channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs VoIP channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs VoIP channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs VoIP channel,
      this value is APNS_VOIP.

    - **Version** *(integer) --*

      The current version of the APNs VoIP channel.
    """


_ClientDeleteApnsVoipChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipChannelResponseTypeDef",
    {"APNSVoipChannelResponse": ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef},
    total=False,
)


class ClientDeleteApnsVoipChannelResponseTypeDef(_ClientDeleteApnsVoipChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteApnsVoipChannel` `Response`

    The request succeeded.

    - **APNSVoipChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs VoIP channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with APNs for
        this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs VoIP channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs VoIP channel is configured to communicate with APNs by using APNs
        tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
        channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs VoIP channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs VoIP channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs VoIP channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs VoIP channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs VoIP channel,
        this value is APNS_VOIP.

      - **Version** *(integer) --*

        The current version of the APNs VoIP channel.
    """


_ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef(
    _ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteApnsVoipSandboxChannelResponse`
    `APNSVoipSandboxChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    VoIP sandbox channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs VoIP sandbox channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs VoIP sandbox channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
      sandbox environment for this channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is configured to communicate with APNs by
      using APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property
      of the channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs VoIP sandbox channel. This property is retained only
      for backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs VoIP sandbox channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs VoIP sandbox channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs VoIP sandbox
      channel, this value is APNS_VOIP_SANDBOX.

    - **Version** *(integer) --*

      The current version of the APNs VoIP sandbox channel.
    """


_ClientDeleteApnsVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipSandboxChannelResponseTypeDef",
    {
        "APNSVoipSandboxChannelResponse": ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientDeleteApnsVoipSandboxChannelResponseTypeDef(
    _ClientDeleteApnsVoipSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteApnsVoipSandboxChannel` `Response`

    The request succeeded.

    - **APNSVoipSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP sandbox channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP sandbox channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs VoIP sandbox channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
        sandbox environment for this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is configured to communicate with APNs by
        using APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey
        property of the channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs VoIP sandbox channel. This property is retained only
        for backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs VoIP sandbox channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs VoIP sandbox channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs VoIP sandbox
        channel, this value is APNS_VOIP_SANDBOX.

      - **Version** *(integer) --*

        The current version of the APNs VoIP sandbox channel.
    """


_ClientDeleteAppResponseApplicationResponseTypeDef = TypedDict(
    "_ClientDeleteAppResponseApplicationResponseTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientDeleteAppResponseApplicationResponseTypeDef(
    _ClientDeleteAppResponseApplicationResponseTypeDef
):
    """
    Type definition for `ClientDeleteAppResponse` `ApplicationResponse`

    Provides information about an application.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the application.

    - **Id** *(string) --*

      The unique identifier for the application. This identifier is displayed as the **Project ID**
      on the Amazon Pinpoint console.

    - **Name** *(string) --*

      The display name of the application. This name is displayed as the **Project name** on the
      Amazon Pinpoint console.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the application. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientDeleteAppResponseTypeDef = TypedDict(
    "_ClientDeleteAppResponseTypeDef",
    {"ApplicationResponse": ClientDeleteAppResponseApplicationResponseTypeDef},
    total=False,
)


class ClientDeleteAppResponseTypeDef(_ClientDeleteAppResponseTypeDef):
    """
    Type definition for `ClientDeleteApp` `Response`

    The request succeeded.

    - **ApplicationResponse** *(dict) --*

      Provides information about an application.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the application.

      - **Id** *(string) --*

        The unique identifier for the application. This identifier is displayed as the **Project
        ID** on the Amazon Pinpoint console.

      - **Name** *(string) --*

        The display name of the application. This name is displayed as the **Project name** on the
        Amazon Pinpoint console.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the application. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef = TypedDict(
    "_ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef(
    _ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteBaiduChannelResponse` `BaiduChannelResponse`

    Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
    an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the Baidu channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the Baidu channel was enabled.

    - **Credential** *(string) --*

      The API key that you received from the Baidu Cloud Push service to communicate with the
      service.

    - **Enabled** *(boolean) --*

      Specifies whether the Baidu channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the Baidu channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the Baidu channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the Baidu channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the Baidu channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the Baidu channel, this
      value is BAIDU.

    - **Version** *(integer) --*

      The current version of the Baidu channel.
    """


_ClientDeleteBaiduChannelResponseTypeDef = TypedDict(
    "_ClientDeleteBaiduChannelResponseTypeDef",
    {"BaiduChannelResponse": ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef},
    total=False,
)


class ClientDeleteBaiduChannelResponseTypeDef(_ClientDeleteBaiduChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteBaiduChannel` `Response`

    The request succeeded.

    - **BaiduChannelResponse** *(dict) --*

      Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
      an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the Baidu channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the Baidu channel was enabled.

      - **Credential** *(string) --*

        The API key that you received from the Baidu Cloud Push service to communicate with the
        service.

      - **Enabled** *(boolean) --*

        Specifies whether the Baidu channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the Baidu channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the Baidu channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the Baidu channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the Baidu channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the Baidu channel, this
        value is BAIDU.

      - **Version** *(integer) --*

        The current version of the Baidu channel.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatments`
    `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatments` `State`

    The current status of the treatment.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **Id** *(string) --*

      The unique identifier for the treatment.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --*

      The allocated percentage of users (segment members) that the treatment is sent to.

    - **State** *(dict) --*

      The current status of the treatment.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `DefaultState`

    The current status of the campaign's default treatment. This value exists only for campaigns
    that have more than one treatment, to support A/B testing.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientDeleteCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseHookTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseHookTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientDeleteCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseStateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseStateTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `State`

    The current status of the campaign.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponseTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponseCampaignResponse` `TemplateConfiguration`

    The message template that’s used for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientDeleteCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientDeleteCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientDeleteCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTypeDef
):
    """
    Type definition for `ClientDeleteCampaignResponse` `CampaignResponse`

    Provides information about the status, configuration, and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of responses, one for each treatment that you defined for the campaign, in addition
      to the default treatment.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **Id** *(string) --*

          The unique identifier for the treatment.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --*

          The allocated percentage of users (segment members) that the treatment is sent to.

        - **State** *(dict) --*

          The current status of the treatment.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the campaign.

    - **CreationDate** *(string) --*

      The date, ISO 8601 format, when the campaign was created.

    - **DefaultState** *(dict) --*

      The current status of the campaign's default treatment. This value exists only for campaigns
      that have more than one treatment, to support A/B testing.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **Description** *(string) --*

      The custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **Id** *(string) --*

      The unique identifier for the campaign.

    - **IsPaused** *(boolean) --*

      Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
      by changing this value to false.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the campaign was last modified.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment that's associated with the campaign.

    - **SegmentVersion** *(integer) --*

      The version number of the segment that's associated with the campaign.

    - **State** *(dict) --*

      The current status of the campaign.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template that’s used for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of a variation of the campaign that's used for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign that's used for A/B testing.

    - **Version** *(integer) --*

      The version number of the campaign.
    """


_ClientDeleteCampaignResponseTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseTypeDef",
    {"CampaignResponse": ClientDeleteCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientDeleteCampaignResponseTypeDef(_ClientDeleteCampaignResponseTypeDef):
    """
    Type definition for `ClientDeleteCampaign` `Response`

    The request succeeded.

    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.

      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.

        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.

          - **Id** *(string) --*

            The unique identifier for the treatment.

          - **MessageConfiguration** *(dict) --*

            The message configuration settings for the treatment.

            - **ADMMessage** *(dict) --*

              The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
              This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **APNSMessage** *(dict) --*

              The message that the campaign sends through the APNs (Apple Push Notification service)
              channel. This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **BaiduMessage** *(dict) --*

              The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
              message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **DefaultMessage** *(dict) --*

              The default message that the campaign sends through all the channels that are
              configured for the campaign.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **EmailMessage** *(dict) --*

              The message that the campaign sends through the email channel.

              - **Body** *(string) --*

                The body of the email for recipients whose email clients don't render HTML content.

              - **FromAddress** *(string) --*

                The verified email address to send the email from. The default address is the
                FromAddress specified for the email channel for the application.

              - **HtmlBody** *(string) --*

                The body of the email, in HTML format, for recipients whose email clients render
                HTML content.

              - **Title** *(string) --*

                The subject line, or title, of the email.

            - **GCMMessage** *(dict) --*

              The message that the campaign sends through the GCM channel, which enables Amazon
              Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
              formerly Google Cloud Messaging (GCM), service. This message overrides the default
              message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **SMSMessage** *(dict) --*

              The message that the campaign sends through the SMS channel.

              - **Body** *(string) --*

                The body of the SMS message.

              - **MessageType** *(string) --*

                The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
                time-sensitive, such as a one-time password that supports a customer transaction;
                and, PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
                message.

              - **SenderId** *(string) --*

                The sender ID to display on recipients' devices when they receive the SMS message.

          - **Schedule** *(dict) --*

            The schedule settings for the treatment.

            - **EndTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign ended or will end.

            - **EventFilter** *(dict) --*

              The type of event that causes the campaign to be sent, if the value of the Frequency
              property is EVENT.

              - **Dimensions** *(dict) --*

                The dimension settings of the event filter for the campaign.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **FilterType** *(string) --*

                The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                when an endpoint event (Events resource) occurs.

            - **Frequency** *(string) --*

              Specifies how often the campaign is sent or whether the campaign is sent in response
              to a specific event.

            - **IsLocalTime** *(boolean) --*

              Specifies whether the start and end times for the campaign schedule use each
              recipient's local time. To base the schedule on each recipient's local time, set this
              value to true.

            - **QuietTime** *(dict) --*

              The default quiet time for the campaign. Quiet time is a specific time range when a
              campaign doesn't send messages to endpoints, if all the following conditions are met:

              * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

              * The current time in the endpoint's time zone is later than or equal to the time
              specified by the QuietTime.Start property for the campaign.

              * The current time in the endpoint's time zone is earlier than or equal to the time
              specified by the QuietTime.End property for the campaign.

              If any of the preceding conditions isn't met, the endpoint will receive messages from
              the campaign, even if quiet time is enabled.

              - **End** *(string) --*

                The specific time when quiet time ends. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

              - **Start** *(string) --*

                The specific time when quiet time begins. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

            - **StartTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
              property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
              UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
              UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
              UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

          - **SizePercent** *(integer) --*

            The allocated percentage of users (segment members) that the treatment is sent to.

          - **State** *(dict) --*

            The current status of the treatment.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **TemplateConfiguration** *(dict) --*

            The message template to use for the treatment.

            - **EmailTemplate** *(dict) --*

              The email template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **PushTemplate** *(dict) --*

              The push notification template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **SMSTemplate** *(dict) --*

              The SMS template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **VoiceTemplate** *(dict) --*

              The voice template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

          - **TreatmentDescription** *(string) --*

            The custom description of the treatment.

          - **TreatmentName** *(string) --*

            The custom name of the treatment. A treatment is a variation of a campaign that's used
            for A/B testing of a campaign.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the campaign applies to.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the campaign.

      - **CreationDate** *(string) --*

        The date, ISO 8601 format, when the campaign was created.

      - **DefaultState** *(dict) --*

        The current status of the campaign's default treatment. This value exists only for campaigns
        that have more than one treatment, to support A/B testing.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **Description** *(string) --*

        The custom description of the campaign.

      - **HoldoutPercent** *(integer) --*

        The allocated percentage of users (segment members) who shouldn't receive messages from the
        campaign.

      - **Hook** *(dict) --*

        The settings for the AWS Lambda function to use as a code hook for the campaign.

        - **LambdaFunctionName** *(string) --*

          The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
          invokes to send messages for a campaign.

        - **Mode** *(string) --*

          Specifies which Lambda mode to use when invoking the AWS Lambda function.

        - **WebUrl** *(string) --*

          The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

      - **Id** *(string) --*

        The unique identifier for the campaign.

      - **IsPaused** *(boolean) --*

        Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
        by changing this value to false.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the campaign was last modified.

      - **Limits** *(dict) --*

        The messaging limits for the campaign.

        - **Daily** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during a
          24-hour period. The maximum value is 100.

        - **MaximumDuration** *(integer) --*

          The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
          after the scheduled start time for the campaign. The minimum value is 60 seconds.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that a campaign can send each second. The minimum value is
          50. The maximum value is 20,000.

        - **Total** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during the
          course of the campaign. The maximum value is 100.

      - **MessageConfiguration** *(dict) --*

        The message configuration settings for the campaign.

        - **ADMMessage** *(dict) --*

          The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
          This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **APNSMessage** *(dict) --*

          The message that the campaign sends through the APNs (Apple Push Notification service)
          channel. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **BaiduMessage** *(dict) --*

          The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
          message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **DefaultMessage** *(dict) --*

          The default message that the campaign sends through all the channels that are configured
          for the campaign.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **EmailMessage** *(dict) --*

          The message that the campaign sends through the email channel.

          - **Body** *(string) --*

            The body of the email for recipients whose email clients don't render HTML content.

          - **FromAddress** *(string) --*

            The verified email address to send the email from. The default address is the
            FromAddress specified for the email channel for the application.

          - **HtmlBody** *(string) --*

            The body of the email, in HTML format, for recipients whose email clients render HTML
            content.

          - **Title** *(string) --*

            The subject line, or title, of the email.

        - **GCMMessage** *(dict) --*

          The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
          to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google
          Cloud Messaging (GCM), service. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **SMSMessage** *(dict) --*

          The message that the campaign sends through the SMS channel.

          - **Body** *(string) --*

            The body of the SMS message.

          - **MessageType** *(string) --*

            The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
            time-sensitive, such as a one-time password that supports a customer transaction; and,
            PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

          - **SenderId** *(string) --*

            The sender ID to display on recipients' devices when they receive the SMS message.

      - **Name** *(string) --*

        The name of the campaign.

      - **Schedule** *(dict) --*

        The schedule settings for the campaign.

        - **EndTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign ended or will end.

        - **EventFilter** *(dict) --*

          The type of event that causes the campaign to be sent, if the value of the Frequency
          property is EVENT.

          - **Dimensions** *(dict) --*

            The dimension settings of the event filter for the campaign.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **FilterType** *(string) --*

            The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
            the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
            endpoint event (Events resource) occurs.

        - **Frequency** *(string) --*

          Specifies how often the campaign is sent or whether the campaign is sent in response to a
          specific event.

        - **IsLocalTime** *(boolean) --*

          Specifies whether the start and end times for the campaign schedule use each recipient's
          local time. To base the schedule on each recipient's local time, set this value to true.

        - **QuietTime** *(dict) --*

          The default quiet time for the campaign. Quiet time is a specific time range when a
          campaign doesn't send messages to endpoints, if all the following conditions are met:

          * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

          * The current time in the endpoint's time zone is later than or equal to the time
          specified by the QuietTime.Start property for the campaign.

          * The current time in the endpoint's time zone is earlier than or equal to the time
          specified by the QuietTime.End property for the campaign.

          If any of the preceding conditions isn't met, the endpoint will receive messages from the
          campaign, even if quiet time is enabled.

          - **End** *(string) --*

            The specific time when quiet time ends. This value has to use 24-hour notation and be in
            HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

          - **Start** *(string) --*

            The specific time when quiet time begins. This value has to use 24-hour notation and be
            in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **StartTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
          UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
          UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

      - **SegmentId** *(string) --*

        The unique identifier for the segment that's associated with the campaign.

      - **SegmentVersion** *(integer) --*

        The version number of the segment that's associated with the campaign.

      - **State** *(dict) --*

        The current status of the campaign.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the campaign. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateConfiguration** *(dict) --*

        The message template that’s used for the campaign.

        - **EmailTemplate** *(dict) --*

          The email template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **PushTemplate** *(dict) --*

          The push notification template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **SMSTemplate** *(dict) --*

          The SMS template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **VoiceTemplate** *(dict) --*

          The voice template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

      - **TreatmentDescription** *(string) --*

        The custom description of a variation of the campaign that's used for A/B testing.

      - **TreatmentName** *(string) --*

        The custom name of a variation of the campaign that's used for A/B testing.

      - **Version** *(integer) --*

        The version number of the campaign.
    """


_ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef = TypedDict(
    "_ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "ConfigurationSet": str,
        "CreationDate": str,
        "Enabled": bool,
        "FromAddress": str,
        "HasCredential": bool,
        "Id": str,
        "Identity": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "MessagesPerSecond": int,
        "Platform": str,
        "RoleArn": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef(
    _ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteEmailChannelResponse` `EmailChannelResponse`

    Provides information about the status and settings of the email channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the email channel applies to.

    - **ConfigurationSet** *(string) --*

      The configuration set that's applied to email that's sent through the channel by using the
      `Amazon Pinpoint Email API <emailAPIreference.html>`__ .

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the email channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the email channel is enabled for the application.

    - **FromAddress** *(string) --*

      The verified email address that you send email from when you send email through the channel.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the email channel. This property is retained only for backward
      compatibility.

    - **Identity** *(string) --*

      The Amazon Resource Name (ARN) of the identity, verified with Amazon Simple Email Service
      (Amazon SES), that you use when you send email through the channel.

    - **IsArchived** *(boolean) --*

      Specifies whether the email channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the email channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the email channel was last modified.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of emails that you can send through the channel each second.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the email channel, this
      value is EMAIL.

    - **RoleArn** *(string) --*

      The ARN of the AWS Identity and Access Management (IAM) role that Amazon Pinpoint uses to
      submit email-related event data for the channel.

    - **Version** *(integer) --*

      The current version of the email channel.
    """


_ClientDeleteEmailChannelResponseTypeDef = TypedDict(
    "_ClientDeleteEmailChannelResponseTypeDef",
    {"EmailChannelResponse": ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef},
    total=False,
)


class ClientDeleteEmailChannelResponseTypeDef(_ClientDeleteEmailChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteEmailChannel` `Response`

    The request succeeded.

    - **EmailChannelResponse** *(dict) --*

      Provides information about the status and settings of the email channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the email channel applies to.

      - **ConfigurationSet** *(string) --*

        The configuration set that's applied to email that's sent through the channel by using the
        `Amazon Pinpoint Email API <emailAPIreference.html>`__ .

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the email channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the email channel is enabled for the application.

      - **FromAddress** *(string) --*

        The verified email address that you send email from when you send email through the channel.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the email channel. This property is retained only for
        backward compatibility.

      - **Identity** *(string) --*

        The Amazon Resource Name (ARN) of the identity, verified with Amazon Simple Email Service
        (Amazon SES), that you use when you send email through the channel.

      - **IsArchived** *(boolean) --*

        Specifies whether the email channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the email channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the email channel was last modified.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of emails that you can send through the channel each second.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the email channel, this
        value is EMAIL.

      - **RoleArn** *(string) --*

        The ARN of the AWS Identity and Access Management (IAM) role that Amazon Pinpoint uses to
        submit email-related event data for the channel.

      - **Version** *(integer) --*

        The current version of the email channel.
    """


_ClientDeleteEmailTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeleteEmailTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeleteEmailTemplateResponseMessageBodyTypeDef(
    _ClientDeleteEmailTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientDeleteEmailTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientDeleteEmailTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteEmailTemplateResponseTypeDef",
    {"MessageBody": ClientDeleteEmailTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeleteEmailTemplateResponseTypeDef(_ClientDeleteEmailTemplateResponseTypeDef):
    """
    Type definition for `ClientDeleteEmailTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef
):
    """
    Type definition for `ClientDeleteEndpointResponseEndpointResponse` `Demographic`

    The demographic information for the endpoint, such as the time zone and platform.

    - **AppVersion** *(string) --*

      The version of the app that's associated with the endpoint.

    - **Locale** *(string) --*

      The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
      an underscore (_), followed by an ISO 3166-1 alpha-2 value.

    - **Make** *(string) --*

      The manufacturer of the endpoint device, such as Apple or Samsung.

    - **Model** *(string) --*

      The model name or number of the endpoint device, such as iPhone.

    - **ModelVersion** *(string) --*

      The model version of the endpoint device.

    - **Platform** *(string) --*

      The platform of the endpoint device, such as iOS or Android.

    - **PlatformVersion** *(string) --*

      The platform version of the endpoint device.

    - **Timezone** *(string) --*

      The time zone of the endpoint, specified as a tz database name value, such as
      America/Los_Angeles.
    """


_ClientDeleteEndpointResponseEndpointResponseLocationTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseLocationTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseLocationTypeDef
):
    """
    Type definition for `ClientDeleteEndpointResponseEndpointResponse` `Location`

    The geographic information for the endpoint.

    - **City** *(string) --*

      The name of the city where the endpoint is located.

    - **Country** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      endpoint is located. For example, US for the United States.

    - **Latitude** *(float) --*

      The latitude coordinate of the endpoint location, rounded to one decimal place.

    - **Longitude** *(float) --*

      The longitude coordinate of the endpoint location, rounded to one decimal place.

    - **PostalCode** *(string) --*

      The postal or ZIP code for the area where the endpoint is located.

    - **Region** *(string) --*

      The name of the region where the endpoint is located. For locations in the United States, this
      value is the name of a state.
    """


_ClientDeleteEndpointResponseEndpointResponseUserTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseUserTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseUserTypeDef
):
    """
    Type definition for `ClientDeleteEndpointResponseEndpointResponse` `User`

    One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
    associated with the endpoint.

    - **UserAttributes** *(dict) --*

      One or more custom attributes that describe the user by associating a name with an array of
      values. For example, the value of an attribute named Interests might be: ["science", "music",
      "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **UserId** *(string) --*

      The unique identifier for the user.
    """


_ClientDeleteEndpointResponseEndpointResponseTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": str,
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientDeleteEndpointResponseEndpointResponseLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientDeleteEndpointResponseEndpointResponseUserTypeDef,
    },
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseTypeDef
):
    """
    Type definition for `ClientDeleteEndpointResponse` `EndpointResponse`

    Provides information about the channel type and other settings for an endpoint.

    - **Address** *(string) --*

      The destination address for messages or push notifications that you send to the endpoint. The
      address varies by channel. For example, the address for a push-notification channel is
      typically the token provided by a push notification service, such as an Apple Push
      Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
      token. The address for the SMS channel is a phone number in E.164 format, such as
      +12065550100. The address for the email channel is an email address.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the endpoint.

    - **Attributes** *(dict) --*

      One or more custom attributes that describe the endpoint by associating a name with an array
      of values. For example, the value of a custom attribute named Interests might be: ["science",
      "music", "travel"]. You can use these attributes as filter criteria when you create segments.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ChannelType** *(string) --*

      The channel that's used when sending messages or push notifications to the endpoint.

    - **CohortId** *(string) --*

      A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints are
      grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
      endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
      allocations for campaigns.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was created.

    - **Demographic** *(dict) --*

      The demographic information for the endpoint, such as the time zone and platform.

      - **AppVersion** *(string) --*

        The version of the app that's associated with the endpoint.

      - **Locale** *(string) --*

        The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
        an underscore (_), followed by an ISO 3166-1 alpha-2 value.

      - **Make** *(string) --*

        The manufacturer of the endpoint device, such as Apple or Samsung.

      - **Model** *(string) --*

        The model name or number of the endpoint device, such as iPhone.

      - **ModelVersion** *(string) --*

        The model version of the endpoint device.

      - **Platform** *(string) --*

        The platform of the endpoint device, such as iOS or Android.

      - **PlatformVersion** *(string) --*

        The platform version of the endpoint device.

      - **Timezone** *(string) --*

        The time zone of the endpoint, specified as a tz database name value, such as
        America/Los_Angeles.

    - **EffectiveDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was last updated.

    - **EndpointStatus** *(string) --*

      Specifies whether messages or push notifications are sent to the endpoint. Possible values
      are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
      endpoint.

      Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or update
      an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if you update
      another endpoint that has the same address specified by the Address property.

    - **Id** *(string) --*

      The unique identifier that you assigned to the endpoint. The identifier should be a globally
      unique identifier (GUID) to ensure that it doesn't conflict with other endpoint identifiers
      that are associated with the application.

    - **Location** *(dict) --*

      The geographic information for the endpoint.

      - **City** *(string) --*

        The name of the city where the endpoint is located.

      - **Country** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        endpoint is located. For example, US for the United States.

      - **Latitude** *(float) --*

        The latitude coordinate of the endpoint location, rounded to one decimal place.

      - **Longitude** *(float) --*

        The longitude coordinate of the endpoint location, rounded to one decimal place.

      - **PostalCode** *(string) --*

        The postal or ZIP code for the area where the endpoint is located.

      - **Region** *(string) --*

        The name of the region where the endpoint is located. For locations in the United States,
        this value is the name of a state.

    - **Metrics** *(dict) --*

      One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

      - *(string) --*

        - *(float) --*

    - **OptOut** *(string) --*

      Specifies whether the user who's associated with the endpoint has opted out of receiving
      messages and push notifications from you. Possible values are: ALL, the user has opted out and
      doesn't want to receive any messages or push notifications; and, NONE, the user hasn't opted
      out and wants to receive all messages and push notifications.

    - **RequestId** *(string) --*

      The unique identifier for the most recent request to update the endpoint.

    - **User** *(dict) --*

      One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
      associated with the endpoint.

      - **UserAttributes** *(dict) --*

        One or more custom attributes that describe the user by associating a name with an array of
        values. For example, the value of an attribute named Interests might be: ["science",
        "music", "travel"]. You can use these attributes as filter criteria when you create
        segments.

        When you define the name of a custom attribute, avoid using the following characters: number
        sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
        console can't display attribute names that contain these characters. This limitation doesn't
        apply to attribute values.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **UserId** *(string) --*

        The unique identifier for the user.
    """


_ClientDeleteEndpointResponseTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseTypeDef",
    {"EndpointResponse": ClientDeleteEndpointResponseEndpointResponseTypeDef},
    total=False,
)


class ClientDeleteEndpointResponseTypeDef(_ClientDeleteEndpointResponseTypeDef):
    """
    Type definition for `ClientDeleteEndpoint` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **EndpointResponse** *(dict) --*

      Provides information about the channel type and other settings for an endpoint.

      - **Address** *(string) --*

        The destination address for messages or push notifications that you send to the endpoint.
        The address varies by channel. For example, the address for a push-notification channel is
        typically the token provided by a push notification service, such as an Apple Push
        Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
        token. The address for the SMS channel is a phone number in E.164 format, such as
        +12065550100. The address for the email channel is an email address.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the endpoint.

      - **Attributes** *(dict) --*

        One or more custom attributes that describe the endpoint by associating a name with an array
        of values. For example, the value of a custom attribute named Interests might be:
        ["science", "music", "travel"]. You can use these attributes as filter criteria when you
        create segments.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **ChannelType** *(string) --*

        The channel that's used when sending messages or push notifications to the endpoint.

      - **CohortId** *(string) --*

        A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints
        are grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
        endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
        allocations for campaigns.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the endpoint was created.

      - **Demographic** *(dict) --*

        The demographic information for the endpoint, such as the time zone and platform.

        - **AppVersion** *(string) --*

          The version of the app that's associated with the endpoint.

        - **Locale** *(string) --*

          The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed
          by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

        - **Make** *(string) --*

          The manufacturer of the endpoint device, such as Apple or Samsung.

        - **Model** *(string) --*

          The model name or number of the endpoint device, such as iPhone.

        - **ModelVersion** *(string) --*

          The model version of the endpoint device.

        - **Platform** *(string) --*

          The platform of the endpoint device, such as iOS or Android.

        - **PlatformVersion** *(string) --*

          The platform version of the endpoint device.

        - **Timezone** *(string) --*

          The time zone of the endpoint, specified as a tz database name value, such as
          America/Los_Angeles.

      - **EffectiveDate** *(string) --*

        The date and time, in ISO 8601 format, when the endpoint was last updated.

      - **EndpointStatus** *(string) --*

        Specifies whether messages or push notifications are sent to the endpoint. Possible values
        are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
        endpoint.

        Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
        update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if
        you update another endpoint that has the same address specified by the Address property.

      - **Id** *(string) --*

        The unique identifier that you assigned to the endpoint. The identifier should be a globally
        unique identifier (GUID) to ensure that it doesn't conflict with other endpoint identifiers
        that are associated with the application.

      - **Location** *(dict) --*

        The geographic information for the endpoint.

        - **City** *(string) --*

          The name of the city where the endpoint is located.

        - **Country** *(string) --*

          The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
          endpoint is located. For example, US for the United States.

        - **Latitude** *(float) --*

          The latitude coordinate of the endpoint location, rounded to one decimal place.

        - **Longitude** *(float) --*

          The longitude coordinate of the endpoint location, rounded to one decimal place.

        - **PostalCode** *(string) --*

          The postal or ZIP code for the area where the endpoint is located.

        - **Region** *(string) --*

          The name of the region where the endpoint is located. For locations in the United States,
          this value is the name of a state.

      - **Metrics** *(dict) --*

        One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

        - *(string) --*

          - *(float) --*

      - **OptOut** *(string) --*

        Specifies whether the user who's associated with the endpoint has opted out of receiving
        messages and push notifications from you. Possible values are: ALL, the user has opted out
        and doesn't want to receive any messages or push notifications; and, NONE, the user hasn't
        opted out and wants to receive all messages and push notifications.

      - **RequestId** *(string) --*

        The unique identifier for the most recent request to update the endpoint.

      - **User** *(dict) --*

        One or more custom user attributes that your app reports to Amazon Pinpoint for the user
        who's associated with the endpoint.

        - **UserAttributes** *(dict) --*

          One or more custom attributes that describe the user by associating a name with an array
          of values. For example, the value of an attribute named Interests might be: ["science",
          "music", "travel"]. You can use these attributes as filter criteria when you create
          segments.

          When you define the name of a custom attribute, avoid using the following characters:
          number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon
          Pinpoint console can't display attribute names that contain these characters. This
          limitation doesn't apply to attribute values.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **UserId** *(string) --*

          The unique identifier for the user.
    """


_ClientDeleteEventStreamResponseEventStreamTypeDef = TypedDict(
    "_ClientDeleteEventStreamResponseEventStreamTypeDef",
    {
        "ApplicationId": str,
        "DestinationStreamArn": str,
        "ExternalId": str,
        "LastModifiedDate": str,
        "LastUpdatedBy": str,
        "RoleArn": str,
    },
    total=False,
)


class ClientDeleteEventStreamResponseEventStreamTypeDef(
    _ClientDeleteEventStreamResponseEventStreamTypeDef
):
    """
    Type definition for `ClientDeleteEventStreamResponse` `EventStream`

    Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
    Kinesis Data Firehose delivery stream.

    - **ApplicationId** *(string) --*

      The unique identifier for the application to publish event data for.

    - **DestinationStreamArn** *(string) --*

      The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
      Firehose delivery stream to publish event data to.

      For a Kinesis data stream, the ARN format is:
      arn:aws:kinesis:region:account-id:stream/stream_name

      For a Kinesis Data Firehose delivery stream, the ARN format is:
      arn:aws:firehose:region:account-id:deliverystream/stream_name

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when publishing event
      data, but we removed this requirement. We don't recommend use of external IDs for IAM roles
      that are assumed by Amazon Pinpoint.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the event stream was last modified.

    - **LastUpdatedBy** *(string) --*

      The IAM user who last modified the event stream.

    - **RoleArn** *(string) --*

      The AWS Identity and Access Management (IAM) role that authorizes Amazon Pinpoint to publish
      event data to the stream in your AWS account.
    """


_ClientDeleteEventStreamResponseTypeDef = TypedDict(
    "_ClientDeleteEventStreamResponseTypeDef",
    {"EventStream": ClientDeleteEventStreamResponseEventStreamTypeDef},
    total=False,
)


class ClientDeleteEventStreamResponseTypeDef(_ClientDeleteEventStreamResponseTypeDef):
    """
    Type definition for `ClientDeleteEventStream` `Response`

    The request succeeded.

    - **EventStream** *(dict) --*

      Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
      Kinesis Data Firehose delivery stream.

      - **ApplicationId** *(string) --*

        The unique identifier for the application to publish event data for.

      - **DestinationStreamArn** *(string) --*

        The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
        Firehose delivery stream to publish event data to.

        For a Kinesis data stream, the ARN format is:
        arn:aws:kinesis:region:account-id:stream/stream_name

        For a Kinesis Data Firehose delivery stream, the ARN format is:
        arn:aws:firehose:region:account-id:deliverystream/stream_name

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when publishing
        event data, but we removed this requirement. We don't recommend use of external IDs for IAM
        roles that are assumed by Amazon Pinpoint.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the event stream was last modified.

      - **LastUpdatedBy** *(string) --*

        The IAM user who last modified the event stream.

      - **RoleArn** *(string) --*

        The AWS Identity and Access Management (IAM) role that authorizes Amazon Pinpoint to publish
        event data to the stream in your AWS account.
    """


_ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef = TypedDict(
    "_ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef(
    _ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteGcmChannelResponse` `GCMChannelResponse`

    Provides information about the status and settings of the GCM channel for an application. The
    GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
    Messaging (FCM), formerly Google Cloud Messaging (GCM), service.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the GCM channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the GCM channel was enabled.

    - **Credential** *(string) --*

      The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
      Google to communicate with Google services.

    - **Enabled** *(boolean) --*

      Specifies whether the GCM channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the GCM channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the GCM channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the GCM channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the GCM channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the GCM channel, this
      value is GCM.

    - **Version** *(integer) --*

      The current version of the GCM channel.
    """


_ClientDeleteGcmChannelResponseTypeDef = TypedDict(
    "_ClientDeleteGcmChannelResponseTypeDef",
    {"GCMChannelResponse": ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef},
    total=False,
)


class ClientDeleteGcmChannelResponseTypeDef(_ClientDeleteGcmChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteGcmChannel` `Response`

    The request succeeded.

    - **GCMChannelResponse** *(dict) --*

      Provides information about the status and settings of the GCM channel for an application. The
      GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
      Messaging (FCM), formerly Google Cloud Messaging (GCM), service.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the GCM channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the GCM channel was enabled.

      - **Credential** *(string) --*

        The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
        Google to communicate with Google services.

      - **Enabled** *(boolean) --*

        Specifies whether the GCM channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the GCM channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the GCM channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the GCM channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the GCM channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the GCM channel, this
        value is GCM.

      - **Version** *(integer) --*

        The current version of the GCM channel.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitCondition` `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --*

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivities` `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesEMAIL` `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --*

      The percentage of participants who shouldn't continue the journey.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranches`
    `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiCondition`
    `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --*

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplit` `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponse` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --*

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponse` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponse` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponse` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponseStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponseJourneyResponse` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.
    """


_ClientDeleteJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": str,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseTypeDef
):
    """
    Type definition for `ClientDeleteJourneyResponse` `JourneyResponse`

    Provides information about the status, configuration, and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --*

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the journey applies to.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **Id** *(string) --*

      The unique identifier for the journey.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. If this value is true, the schedule uses each participant's local time.

    - **Name** *(string) --*

      The name of the journey.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The current status of the journey. Possible values are:

      * DRAFT - The journey is being developed and hasn't been published yet.

      * ACTIVE - The journey has been developed and published. Depending on the journey's schedule,
      the journey may currently be running or scheduled to start running at a later time. If a
      journey's status is ACTIVE, you can't add, change, or remove activities from it.

      * COMPLETED - The journey has been published and has finished running. All participants have
      entered the journey and no participants are waiting to complete the journey or any activities
      in the journey.

      * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't add,
      change, or remove activities or segment settings from the journey.

      * CLOSED - The journey has been published and has started running. It may have also passed its
      scheduled end time, or passed its scheduled start time and a refresh frequency hasn't been
      specified for it. If a journey's status is CLOSED, you can't add participants to it, and no
      existing participants can enter the journey for the first time. However, any existing
      participants who are currently waiting to start an activity may resume the journey.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the journey. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientDeleteJourneyResponseTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseTypeDef",
    {"JourneyResponse": ClientDeleteJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientDeleteJourneyResponseTypeDef(_ClientDeleteJourneyResponseTypeDef):
    """
    Type definition for `ClientDeleteJourney` `Response`

    The request succeeded.

    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.

      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.

        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.

            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.

              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.

                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.

                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                - **Operator** *(string) --*

                  Specifies how to handle multiple conditions for the activity. For example, if you
                  specify two conditions for an activity, whether both or only one of the conditions
                  must be met for the activity to be performed.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait before determining whether the conditions are met, or the
                date and time when Amazon Pinpoint determines whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

              - **FalseActivity** *(string) --*

                The unique identifier for the activity to perform if the condition isn't met.

              - **TrueActivity** *(string) --*

                The unique identifier for the activity to perform if the condition is met.

            - **Description** *(string) --*

              The custom description of the activity.

            - **EMAIL** *(dict) --*

              The settings for an email activity. This type of activity sends an email message to
              participants.

              - **MessageConfig** *(dict) --*

                The "From" address to use for the message.

                - **FromAddress** *(string) --*

                  The verified email address to send the email message from. The default address is
                  the FromAddress specified for the email channel for the application.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after the message is sent.

              - **TemplateName** *(string) --*

                The name of the email template to use for the message.

            - **Holdout** *(dict) --*

              The settings for a holdout activity. This type of activity stops a journey for a
              specified percentage of participants.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the holdout
                activity.

              - **Percentage** *(integer) --*

                The percentage of participants who shouldn't continue the journey.

            - **MultiCondition** *(dict) --*

              The settings for a multivariate split activity. This type of activity sends
              participants down one of as many as five paths in a journey, based on conditions that
              you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the conditions for entering each path and the
                activity to perform for each path.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity path in a journey.

                  - **Condition** *(dict) --*

                    The condition to evaluate for the activity path.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

              - **DefaultActivity** *(string) --*

                The activity to perform by default for any path in the activity.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait or the date and time when Amazon Pinpoint determines
                whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

            - **RandomSplit** *(dict) --*

              The settings for a random split activity. This type of activity randomly sends
              specified percentages of participants down one of as many as five paths in a journey,
              based on conditions that you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the percentage of participants to enter each
                path and the activity to perform for each path.

                - *(dict) --*

                  Specifies the settings for a path in a random split activity in a journey.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

                  - **Percentage** *(integer) --*

                    The percentage of participants to send down the activity path.

            - **Wait** *(dict) --*

              The settings for a wait activity. This type of activity waits for a certain amount of
              time or until a specific date and time before moving participants to the next activity
              in a journey.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the wait
                activity.

              - **WaitTime** *(dict) --*

                The amount of time to wait or the date and time when the activity moves participants
                to the next activity in the journey.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the journey applies to.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the journey was created.

      - **Id** *(string) --*

        The unique identifier for the journey.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the journey was last modified.

      - **Limits** *(dict) --*

        The messaging and entry limits for the journey.

        - **DailyCap** *(integer) --*

          The maximum number of messages that the journey can send to a single participant during a
          24-hour period. The maximum value is 100.

        - **EndpointReentryCap** *(integer) --*

          The maximum number of times that a participant can enter the journey. The maximum value is
          100. To allow participants to enter the journey an unlimited number of times, set this
          value to 0.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that the journey can send each second.

      - **LocalTime** *(boolean) --*

        Specifies whether the journey's scheduled start and end times use each participant's local
        time. If this value is true, the schedule uses each participant's local time.

      - **Name** *(string) --*

        The name of the journey.

      - **QuietTime** *(dict) --*

        The quiet time settings for the journey. Quiet time is a specific time range when a journey
        doesn't send messages to participants, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
        valid value.

        * The current time in the participant's time zone is later than or equal to the time
        specified by the QuietTime.Start property for the journey.

        * The current time in the participant's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the journey.

        If any of the preceding conditions isn't met, the participant will receive messages from the
        journey, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **RefreshFrequency** *(string) --*

        The frequency with which Amazon Pinpoint evaluates segment and event data for the journey,
        as a duration in ISO 8601 format.

      - **Schedule** *(dict) --*

        The schedule settings for the journey.

        - **EndTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey ended or will end.

        - **StartTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
          UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45,
          UTC-02, UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
          UTC-09:30, UTC-10, and UTC-11.

      - **StartActivity** *(string) --*

        The unique identifier for the first activity in the journey.

      - **StartCondition** *(dict) --*

        The segment that defines which users are participants in the journey.

        - **Description** *(string) --*

          The custom description of the condition.

        - **SegmentStartCondition** *(dict) --*

          The segment that's associated with the first activity in the journey. This segment
          determines which users are participants in the journey.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

      - **State** *(string) --*

        The current status of the journey. Possible values are:

        * DRAFT - The journey is being developed and hasn't been published yet.

        * ACTIVE - The journey has been developed and published. Depending on the journey's
        schedule, the journey may currently be running or scheduled to start running at a later
        time. If a journey's status is ACTIVE, you can't add, change, or remove activities from it.

        * COMPLETED - The journey has been published and has finished running. All participants have
        entered the journey and no participants are waiting to complete the journey or any
        activities in the journey.

        * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't
        add, change, or remove activities or segment settings from the journey.

        * CLOSED - The journey has been published and has started running. It may have also passed
        its scheduled end time, or passed its scheduled start time and a refresh frequency hasn't
        been specified for it. If a journey's status is CLOSED, you can't add participants to it,
        and no existing participants can enter the journey for the first time. However, any existing
        participants who are currently waiting to start an activity may resume the journey.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the journey. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_ClientDeletePushTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeletePushTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeletePushTemplateResponseMessageBodyTypeDef(
    _ClientDeletePushTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientDeletePushTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientDeletePushTemplateResponseTypeDef = TypedDict(
    "_ClientDeletePushTemplateResponseTypeDef",
    {"MessageBody": ClientDeletePushTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeletePushTemplateResponseTypeDef(_ClientDeletePushTemplateResponseTypeDef):
    """
    Type definition for `ClientDeletePushTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponse` `Dimensions`

    The dimension settings for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": str,
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponse` `ImportDefinition`

    The settings for the import job that's associated with the segment.

    - **ChannelCounts** *(dict) --*

      The number of channel types in the endpoint definitions that were imported to create the
      segment.

      - *(string) --*

        - *(integer) --*

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that were imported to create the segment. Valid values are: CSV, for
      comma-separated values format; and, JSON, for newline-delimited JSON format.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint definitions
      were imported from to create the segment.

    - **Size** *(integer) --*

      The number of endpoint definitions that were imported successfully to create the segment.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroups` `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroups`
    `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponseSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponseSegmentResponse` `SegmentGroups`

    A list of one or more segment groups that apply to the segment. Each segment group consists of
    zero or more base segments and the dimensions that are applied to those base segments.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --*

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientDeleteSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": str,
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseTypeDef
):
    """
    Type definition for `ClientDeleteSegmentResponse` `SegmentResponse`

    Provides information about the configuration, dimension, and other settings for a segment.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the segment is associated with.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the segment.

    - **CreationDate** *(string) --*

      The date and time when the segment was created.

    - **Dimensions** *(dict) --*

      The dimension settings for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **ImportDefinition** *(dict) --*

      The settings for the import job that's associated with the segment.

      - **ChannelCounts** *(dict) --*

        The number of channel types in the endpoint definitions that were imported to create the
        segment.

        - *(string) --*

          - *(integer) --*

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that were imported to create the segment. Valid values are: CSV, for
        comma-separated values format; and, JSON, for newline-delimited JSON format.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
        definitions were imported from to create the segment.

      - **Size** *(integer) --*

        The number of endpoint definitions that were imported successfully to create the segment.

    - **LastModifiedDate** *(string) --*

      The date and time when the segment was last modified.

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      A list of one or more segment groups that apply to the segment. Each segment group consists of
      zero or more base segments and the dimensions that are applied to those base segments.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --*

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **SegmentType** *(string) --*

      The segment type. Valid values are:

      * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
      specify and is based on endpoint data that's reported by your app. Dynamic segments can change
      over time.

      * IMPORT - A static segment, which is a segment that uses selection criteria that you specify
      and is based on endpoint definitions that you import from a file. Imported segments are
      static; they don't change over time.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the segment. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientDeleteSegmentResponseTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseTypeDef",
    {"SegmentResponse": ClientDeleteSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientDeleteSegmentResponseTypeDef(_ClientDeleteSegmentResponseTypeDef):
    """
    Type definition for `ClientDeleteSegment` `Response`

    The request succeeded.

    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the segment.

      - **CreationDate** *(string) --*

        The date and time when the segment was created.

      - **Dimensions** *(dict) --*

        The dimension settings for the segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the segment.

      - **ImportDefinition** *(dict) --*

        The settings for the import job that's associated with the segment.

        - **ChannelCounts** *(dict) --*

          The number of channel types in the endpoint definitions that were imported to create the
          segment.

          - *(string) --*

            - *(integer) --*

        - **ExternalId** *(string) --*

          (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
          policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
          endpoint definitions, but we removed this requirement. We don't recommend use of external
          IDs for IAM roles that are assumed by Amazon Pinpoint.

        - **Format** *(string) --*

          The format of the files that were imported to create the segment. Valid values are: CSV,
          for comma-separated values format; and, JSON, for newline-delimited JSON format.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
          from.

        - **S3Url** *(string) --*

          The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
          definitions were imported from to create the segment.

        - **Size** *(integer) --*

          The number of endpoint definitions that were imported successfully to create the segment.

      - **LastModifiedDate** *(string) --*

        The date and time when the segment was last modified.

      - **Name** *(string) --*

        The name of the segment.

      - **SegmentGroups** *(dict) --*

        A list of one or more segment groups that apply to the segment. Each segment group consists
        of zero or more base segments and the dimensions that are applied to those base segments.

        - **Groups** *(list) --*

          An array that defines the set of segment criteria to evaluate when handling segment groups
          for the segment.

          - *(dict) --*

            Specifies the base segments and dimensions for a segment, and the relationships between
            these base segments and dimensions.

            - **Dimensions** *(list) --*

              An array that defines the dimensions for the segment.

              - *(dict) --*

                Specifies the dimension settings for a segment.

                - **Attributes** *(dict) --*

                  One or more custom attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **Behavior** *(dict) --*

                  The behavior-based criteria, such as how recently users have used your app, for
                  the segment.

                  - **Recency** *(dict) --*

                    The dimension settings that are based on how recently an endpoint was active.

                    - **Duration** *(string) --*

                      The duration to use when determining whether an endpoint is active or
                      inactive.

                    - **RecencyType** *(string) --*

                      The type of recency dimension to use for the segment. Valid values are:
                      ACTIVE, endpoints that were active within the specified duration are included
                      in the segment; and, INACTIVE, endpoints that weren't active within the
                      specified duration are included in the segment.

                - **Demographic** *(dict) --*

                  The demographic-based criteria, such as device platform, for the segment.

                  - **AppVersion** *(dict) --*

                    The app version criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Channel** *(dict) --*

                    The channel criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **DeviceType** *(dict) --*

                    The device type criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Make** *(dict) --*

                    The device make criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Model** *(dict) --*

                    The device model criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Platform** *(dict) --*

                    The device platform criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                - **Location** *(dict) --*

                  The location-based criteria, such as region or GPS coordinates, for the segment.

                  - **Country** *(dict) --*

                    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **GPSPoint** *(dict) --*

                    The GPS location and range for the segment.

                    - **Coordinates** *(dict) --*

                      The GPS coordinates to measure distance from.

                      - **Latitude** *(float) --*

                        The latitude coordinate of the location.

                      - **Longitude** *(float) --*

                        The longitude coordinate of the location.

                    - **RangeInKilometers** *(float) --*

                      The range, in kilometers, from the GPS coordinates.

                - **Metrics** *(dict) --*

                  One or more custom metrics to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

                - **UserAttributes** *(dict) --*

                  One or more custom user attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

            - **SourceSegments** *(list) --*

              The base segment to build the segment on. A base segment, also referred to as a
              *source segment* , defines the initial population of endpoints for a segment. When you
              add dimensions to a segment, Amazon Pinpoint filters the base segment by using the
              dimensions that you specify.

              You can specify more than one dimensional segment or only one imported segment. If you
              specify an imported segment, the Amazon Pinpoint console displays a segment size
              estimate that indicates the size of the imported segment without any filters applied
              to it.

              - *(dict) --*

                Specifies the segment identifier and version of a segment.

                - **Id** *(string) --*

                  The unique identifier for the segment.

                - **Version** *(integer) --*

                  The version number of the segment.

            - **SourceType** *(string) --*

              Specifies how to handle multiple base segments for the segment. For example, if you
              specify three base segments for the segment, whether the resulting segment is based on
              all, any, or none of the base segments.

            - **Type** *(string) --*

              Specifies how to handle multiple dimensions for the segment. For example, if you
              specify three dimensions for the segment, whether the resulting segment includes
              endpoints that match all, any, or none of the dimensions.

        - **Include** *(string) --*

          Specifies how to handle multiple segment groups for the segment. For example, if the
          segment includes three segment groups, whether the resulting segment includes endpoints
          that match all, any, or none of the segment groups.

      - **SegmentType** *(string) --*

        The segment type. Valid values are:

        * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint data that's reported by your app. Dynamic segments can
        change over time.

        * IMPORT - A static segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint definitions that you import from a file. Imported segments
        are static; they don't change over time.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the segment. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **Version** *(integer) --*

        The version number of the segment.
    """


_ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef = TypedDict(
    "_ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "PromotionalMessagesPerSecond": int,
        "SenderId": str,
        "ShortCode": str,
        "TransactionalMessagesPerSecond": int,
        "Version": int,
    },
    total=False,
)


class ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef(
    _ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteSmsChannelResponse` `SMSChannelResponse`

    Provides information about the status and settings of the SMS channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the SMS channel applies to.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the SMS channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the SMS channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the SMS channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the SMS channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the SMS channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the SMS channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the SMS channel, this
      value is SMS.

    - **PromotionalMessagesPerSecond** *(integer) --*

      The maximum number of promotional messages that you can send through the SMS channel each
      second.

    - **SenderId** *(string) --*

      The identity that displays on recipients' devices when they receive messages from the SMS
      channel.

    - **ShortCode** *(string) --*

      The registered short code to use when you send messages through the SMS channel.

    - **TransactionalMessagesPerSecond** *(integer) --*

      The maximum number of transactional messages that you can send through the SMS channel each
      second.

    - **Version** *(integer) --*

      The current version of the SMS channel.
    """


_ClientDeleteSmsChannelResponseTypeDef = TypedDict(
    "_ClientDeleteSmsChannelResponseTypeDef",
    {"SMSChannelResponse": ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef},
    total=False,
)


class ClientDeleteSmsChannelResponseTypeDef(_ClientDeleteSmsChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteSmsChannel` `Response`

    The request succeeded.

    - **SMSChannelResponse** *(dict) --*

      Provides information about the status and settings of the SMS channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the SMS channel applies to.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the SMS channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the SMS channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the SMS channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the SMS channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the SMS channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the SMS channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the SMS channel, this
        value is SMS.

      - **PromotionalMessagesPerSecond** *(integer) --*

        The maximum number of promotional messages that you can send through the SMS channel each
        second.

      - **SenderId** *(string) --*

        The identity that displays on recipients' devices when they receive messages from the SMS
        channel.

      - **ShortCode** *(string) --*

        The registered short code to use when you send messages through the SMS channel.

      - **TransactionalMessagesPerSecond** *(integer) --*

        The maximum number of transactional messages that you can send through the SMS channel each
        second.

      - **Version** *(integer) --*

        The current version of the SMS channel.
    """


_ClientDeleteSmsTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeleteSmsTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeleteSmsTemplateResponseMessageBodyTypeDef(
    _ClientDeleteSmsTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientDeleteSmsTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientDeleteSmsTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteSmsTemplateResponseTypeDef",
    {"MessageBody": ClientDeleteSmsTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeleteSmsTemplateResponseTypeDef(_ClientDeleteSmsTemplateResponseTypeDef):
    """
    Type definition for `ClientDeleteSmsTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef
):
    """
    Type definition for `ClientDeleteUserEndpointsResponseEndpointsResponseItem` `Demographic`

    The demographic information for the endpoint, such as the time zone and platform.

    - **AppVersion** *(string) --*

      The version of the app that's associated with the endpoint.

    - **Locale** *(string) --*

      The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
      an underscore (_), followed by an ISO 3166-1 alpha-2 value.

    - **Make** *(string) --*

      The manufacturer of the endpoint device, such as Apple or Samsung.

    - **Model** *(string) --*

      The model name or number of the endpoint device, such as iPhone.

    - **ModelVersion** *(string) --*

      The model version of the endpoint device.

    - **Platform** *(string) --*

      The platform of the endpoint device, such as iOS or Android.

    - **PlatformVersion** *(string) --*

      The platform version of the endpoint device.

    - **Timezone** *(string) --*

      The time zone of the endpoint, specified as a tz database name value, such as
      America/Los_Angeles.
    """


_ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef
):
    """
    Type definition for `ClientDeleteUserEndpointsResponseEndpointsResponseItem` `Location`

    The geographic information for the endpoint.

    - **City** *(string) --*

      The name of the city where the endpoint is located.

    - **Country** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      endpoint is located. For example, US for the United States.

    - **Latitude** *(float) --*

      The latitude coordinate of the endpoint location, rounded to one decimal place.

    - **Longitude** *(float) --*

      The longitude coordinate of the endpoint location, rounded to one decimal place.

    - **PostalCode** *(string) --*

      The postal or ZIP code for the area where the endpoint is located.

    - **Region** *(string) --*

      The name of the region where the endpoint is located. For locations in the United States, this
      value is the name of a state.
    """


_ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef
):
    """
    Type definition for `ClientDeleteUserEndpointsResponseEndpointsResponseItem` `User`

    One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
    associated with the endpoint.

    - **UserAttributes** *(dict) --*

      One or more custom attributes that describe the user by associating a name with an array of
      values. For example, the value of an attribute named Interests might be: ["science", "music",
      "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **UserId** *(string) --*

      The unique identifier for the user.
    """


_ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": str,
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef,
    },
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef
):
    """
    Type definition for `ClientDeleteUserEndpointsResponseEndpointsResponse` `Item`

    Provides information about the channel type and other settings for an endpoint.

    - **Address** *(string) --*

      The destination address for messages or push notifications that you send to the endpoint. The
      address varies by channel. For example, the address for a push-notification channel is
      typically the token provided by a push notification service, such as an Apple Push
      Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
      token. The address for the SMS channel is a phone number in E.164 format, such as
      +12065550100. The address for the email channel is an email address.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the endpoint.

    - **Attributes** *(dict) --*

      One or more custom attributes that describe the endpoint by associating a name with an array
      of values. For example, the value of a custom attribute named Interests might be: ["science",
      "music", "travel"]. You can use these attributes as filter criteria when you create segments.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ChannelType** *(string) --*

      The channel that's used when sending messages or push notifications to the endpoint.

    - **CohortId** *(string) --*

      A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints are
      grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
      endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
      allocations for campaigns.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was created.

    - **Demographic** *(dict) --*

      The demographic information for the endpoint, such as the time zone and platform.

      - **AppVersion** *(string) --*

        The version of the app that's associated with the endpoint.

      - **Locale** *(string) --*

        The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
        an underscore (_), followed by an ISO 3166-1 alpha-2 value.

      - **Make** *(string) --*

        The manufacturer of the endpoint device, such as Apple or Samsung.

      - **Model** *(string) --*

        The model name or number of the endpoint device, such as iPhone.

      - **ModelVersion** *(string) --*

        The model version of the endpoint device.

      - **Platform** *(string) --*

        The platform of the endpoint device, such as iOS or Android.

      - **PlatformVersion** *(string) --*

        The platform version of the endpoint device.

      - **Timezone** *(string) --*

        The time zone of the endpoint, specified as a tz database name value, such as
        America/Los_Angeles.

    - **EffectiveDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was last updated.

    - **EndpointStatus** *(string) --*

      Specifies whether messages or push notifications are sent to the endpoint. Possible values
      are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
      endpoint.

      Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or update
      an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if you update
      another endpoint that has the same address specified by the Address property.

    - **Id** *(string) --*

      The unique identifier that you assigned to the endpoint. The identifier should be a globally
      unique identifier (GUID) to ensure that it doesn't conflict with other endpoint identifiers
      that are associated with the application.

    - **Location** *(dict) --*

      The geographic information for the endpoint.

      - **City** *(string) --*

        The name of the city where the endpoint is located.

      - **Country** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        endpoint is located. For example, US for the United States.

      - **Latitude** *(float) --*

        The latitude coordinate of the endpoint location, rounded to one decimal place.

      - **Longitude** *(float) --*

        The longitude coordinate of the endpoint location, rounded to one decimal place.

      - **PostalCode** *(string) --*

        The postal or ZIP code for the area where the endpoint is located.

      - **Region** *(string) --*

        The name of the region where the endpoint is located. For locations in the United States,
        this value is the name of a state.

    - **Metrics** *(dict) --*

      One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

      - *(string) --*

        - *(float) --*

    - **OptOut** *(string) --*

      Specifies whether the user who's associated with the endpoint has opted out of receiving
      messages and push notifications from you. Possible values are: ALL, the user has opted out and
      doesn't want to receive any messages or push notifications; and, NONE, the user hasn't opted
      out and wants to receive all messages and push notifications.

    - **RequestId** *(string) --*

      The unique identifier for the most recent request to update the endpoint.

    - **User** *(dict) --*

      One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
      associated with the endpoint.

      - **UserAttributes** *(dict) --*

        One or more custom attributes that describe the user by associating a name with an array of
        values. For example, the value of an attribute named Interests might be: ["science",
        "music", "travel"]. You can use these attributes as filter criteria when you create
        segments.

        When you define the name of a custom attribute, avoid using the following characters: number
        sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
        console can't display attribute names that contain these characters. This limitation doesn't
        apply to attribute values.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **UserId** *(string) --*

        The unique identifier for the user.
    """


_ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef",
    {"Item": List[ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef]},
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef
):
    """
    Type definition for `ClientDeleteUserEndpointsResponse` `EndpointsResponse`

    Provides information about all the endpoints that are associated with a user ID.

    - **Item** *(list) --*

      An array of responses, one for each endpoint that's associated with the user ID.

      - *(dict) --*

        Provides information about the channel type and other settings for an endpoint.

        - **Address** *(string) --*

          The destination address for messages or push notifications that you send to the endpoint.
          The address varies by channel. For example, the address for a push-notification channel is
          typically the token provided by a push notification service, such as an Apple Push
          Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
          token. The address for the SMS channel is a phone number in E.164 format, such as
          +12065550100. The address for the email channel is an email address.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the endpoint.

        - **Attributes** *(dict) --*

          One or more custom attributes that describe the endpoint by associating a name with an
          array of values. For example, the value of a custom attribute named Interests might be:
          ["science", "music", "travel"]. You can use these attributes as filter criteria when you
          create segments.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **ChannelType** *(string) --*

          The channel that's used when sending messages or push notifications to the endpoint.

        - **CohortId** *(string) --*

          A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints
          are grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
          endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
          allocations for campaigns.

        - **CreationDate** *(string) --*

          The date and time, in ISO 8601 format, when the endpoint was created.

        - **Demographic** *(dict) --*

          The demographic information for the endpoint, such as the time zone and platform.

          - **AppVersion** *(string) --*

            The version of the app that's associated with the endpoint.

          - **Locale** *(string) --*

            The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code,
            followed by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

          - **Make** *(string) --*

            The manufacturer of the endpoint device, such as Apple or Samsung.

          - **Model** *(string) --*

            The model name or number of the endpoint device, such as iPhone.

          - **ModelVersion** *(string) --*

            The model version of the endpoint device.

          - **Platform** *(string) --*

            The platform of the endpoint device, such as iOS or Android.

          - **PlatformVersion** *(string) --*

            The platform version of the endpoint device.

          - **Timezone** *(string) --*

            The time zone of the endpoint, specified as a tz database name value, such as
            America/Los_Angeles.

        - **EffectiveDate** *(string) --*

          The date and time, in ISO 8601 format, when the endpoint was last updated.

        - **EndpointStatus** *(string) --*

          Specifies whether messages or push notifications are sent to the endpoint. Possible values
          are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
          endpoint.

          Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
          update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if
          you update another endpoint that has the same address specified by the Address property.

        - **Id** *(string) --*

          The unique identifier that you assigned to the endpoint. The identifier should be a
          globally unique identifier (GUID) to ensure that it doesn't conflict with other endpoint
          identifiers that are associated with the application.

        - **Location** *(dict) --*

          The geographic information for the endpoint.

          - **City** *(string) --*

            The name of the city where the endpoint is located.

          - **Country** *(string) --*

            The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where
            the endpoint is located. For example, US for the United States.

          - **Latitude** *(float) --*

            The latitude coordinate of the endpoint location, rounded to one decimal place.

          - **Longitude** *(float) --*

            The longitude coordinate of the endpoint location, rounded to one decimal place.

          - **PostalCode** *(string) --*

            The postal or ZIP code for the area where the endpoint is located.

          - **Region** *(string) --*

            The name of the region where the endpoint is located. For locations in the United
            States, this value is the name of a state.

        - **Metrics** *(dict) --*

          One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

          - *(string) --*

            - *(float) --*

        - **OptOut** *(string) --*

          Specifies whether the user who's associated with the endpoint has opted out of receiving
          messages and push notifications from you. Possible values are: ALL, the user has opted out
          and doesn't want to receive any messages or push notifications; and, NONE, the user hasn't
          opted out and wants to receive all messages and push notifications.

        - **RequestId** *(string) --*

          The unique identifier for the most recent request to update the endpoint.

        - **User** *(dict) --*

          One or more custom user attributes that your app reports to Amazon Pinpoint for the user
          who's associated with the endpoint.

          - **UserAttributes** *(dict) --*

            One or more custom attributes that describe the user by associating a name with an array
            of values. For example, the value of an attribute named Interests might be: ["science",
            "music", "travel"]. You can use these attributes as filter criteria when you create
            segments.

            When you define the name of a custom attribute, avoid using the following characters:
            number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon
            Pinpoint console can't display attribute names that contain these characters. This
            limitation doesn't apply to attribute values.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **UserId** *(string) --*

            The unique identifier for the user.
    """


_ClientDeleteUserEndpointsResponseTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseTypeDef",
    {"EndpointsResponse": ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef},
    total=False,
)


class ClientDeleteUserEndpointsResponseTypeDef(_ClientDeleteUserEndpointsResponseTypeDef):
    """
    Type definition for `ClientDeleteUserEndpoints` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **EndpointsResponse** *(dict) --*

      Provides information about all the endpoints that are associated with a user ID.

      - **Item** *(list) --*

        An array of responses, one for each endpoint that's associated with the user ID.

        - *(dict) --*

          Provides information about the channel type and other settings for an endpoint.

          - **Address** *(string) --*

            The destination address for messages or push notifications that you send to the
            endpoint. The address varies by channel. For example, the address for a
            push-notification channel is typically the token provided by a push notification
            service, such as an Apple Push Notification service (APNs) device token or a Firebase
            Cloud Messaging (FCM) registration token. The address for the SMS channel is a phone
            number in E.164 format, such as +12065550100. The address for the email channel is an
            email address.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the endpoint.

          - **Attributes** *(dict) --*

            One or more custom attributes that describe the endpoint by associating a name with an
            array of values. For example, the value of a custom attribute named Interests might be:
            ["science", "music", "travel"]. You can use these attributes as filter criteria when you
            create segments.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **ChannelType** *(string) --*

            The channel that's used when sending messages or push notifications to the endpoint.

          - **CohortId** *(string) --*

            A number from 0-99 that represents the cohort that the endpoint is assigned to.
            Endpoints are grouped into cohorts randomly, and each cohort contains approximately 1
            percent of the endpoints for an application. Amazon Pinpoint assigns cohorts to the
            holdout or treatment allocations for campaigns.

          - **CreationDate** *(string) --*

            The date and time, in ISO 8601 format, when the endpoint was created.

          - **Demographic** *(dict) --*

            The demographic information for the endpoint, such as the time zone and platform.

            - **AppVersion** *(string) --*

              The version of the app that's associated with the endpoint.

            - **Locale** *(string) --*

              The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code,
              followed by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

            - **Make** *(string) --*

              The manufacturer of the endpoint device, such as Apple or Samsung.

            - **Model** *(string) --*

              The model name or number of the endpoint device, such as iPhone.

            - **ModelVersion** *(string) --*

              The model version of the endpoint device.

            - **Platform** *(string) --*

              The platform of the endpoint device, such as iOS or Android.

            - **PlatformVersion** *(string) --*

              The platform version of the endpoint device.

            - **Timezone** *(string) --*

              The time zone of the endpoint, specified as a tz database name value, such as
              America/Los_Angeles.

          - **EffectiveDate** *(string) --*

            The date and time, in ISO 8601 format, when the endpoint was last updated.

          - **EndpointStatus** *(string) --*

            Specifies whether messages or push notifications are sent to the endpoint. Possible
            values are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t
            sent to the endpoint.

            Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
            update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE
            if you update another endpoint that has the same address specified by the Address
            property.

          - **Id** *(string) --*

            The unique identifier that you assigned to the endpoint. The identifier should be a
            globally unique identifier (GUID) to ensure that it doesn't conflict with other endpoint
            identifiers that are associated with the application.

          - **Location** *(dict) --*

            The geographic information for the endpoint.

            - **City** *(string) --*

              The name of the city where the endpoint is located.

            - **Country** *(string) --*

              The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where
              the endpoint is located. For example, US for the United States.

            - **Latitude** *(float) --*

              The latitude coordinate of the endpoint location, rounded to one decimal place.

            - **Longitude** *(float) --*

              The longitude coordinate of the endpoint location, rounded to one decimal place.

            - **PostalCode** *(string) --*

              The postal or ZIP code for the area where the endpoint is located.

            - **Region** *(string) --*

              The name of the region where the endpoint is located. For locations in the United
              States, this value is the name of a state.

          - **Metrics** *(dict) --*

            One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

            - *(string) --*

              - *(float) --*

          - **OptOut** *(string) --*

            Specifies whether the user who's associated with the endpoint has opted out of receiving
            messages and push notifications from you. Possible values are: ALL, the user has opted
            out and doesn't want to receive any messages or push notifications; and, NONE, the user
            hasn't opted out and wants to receive all messages and push notifications.

          - **RequestId** *(string) --*

            The unique identifier for the most recent request to update the endpoint.

          - **User** *(dict) --*

            One or more custom user attributes that your app reports to Amazon Pinpoint for the user
            who's associated with the endpoint.

            - **UserAttributes** *(dict) --*

              One or more custom attributes that describe the user by associating a name with an
              array of values. For example, the value of an attribute named Interests might be:
              ["science", "music", "travel"]. You can use these attributes as filter criteria when
              you create segments.

              When you define the name of a custom attribute, avoid using the following characters:
              number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The
              Amazon Pinpoint console can't display attribute names that contain these characters.
              This limitation doesn't apply to attribute values.

              - *(string) --*

                - *(list) --*

                  - *(string) --*

            - **UserId** *(string) --*

              The unique identifier for the user.
    """


_ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef = TypedDict(
    "_ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef(
    _ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef
):
    """
    Type definition for `ClientDeleteVoiceChannelResponse` `VoiceChannelResponse`

    Provides information about the status and settings of the voice channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the voice channel applies to.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the voice channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the voice channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the voice channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the voice channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the voice channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the voice channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the voice channel, this
      value is VOICE.

    - **Version** *(integer) --*

      The current version of the voice channel.
    """


_ClientDeleteVoiceChannelResponseTypeDef = TypedDict(
    "_ClientDeleteVoiceChannelResponseTypeDef",
    {"VoiceChannelResponse": ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef},
    total=False,
)


class ClientDeleteVoiceChannelResponseTypeDef(_ClientDeleteVoiceChannelResponseTypeDef):
    """
    Type definition for `ClientDeleteVoiceChannel` `Response`

    The request succeeded.

    - **VoiceChannelResponse** *(dict) --*

      Provides information about the status and settings of the voice channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the voice channel applies to.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the voice channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the voice channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the voice channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the voice channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the voice channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the voice channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the voice channel, this
        value is VOICE.

      - **Version** *(integer) --*

        The current version of the voice channel.
    """


_ClientDeleteVoiceTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeleteVoiceTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeleteVoiceTemplateResponseMessageBodyTypeDef(
    _ClientDeleteVoiceTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientDeleteVoiceTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientDeleteVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteVoiceTemplateResponseTypeDef",
    {"MessageBody": ClientDeleteVoiceTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeleteVoiceTemplateResponseTypeDef(_ClientDeleteVoiceTemplateResponseTypeDef):
    """
    Type definition for `ClientDeleteVoiceTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientGetAdmChannelResponseADMChannelResponseTypeDef = TypedDict(
    "_ClientGetAdmChannelResponseADMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetAdmChannelResponseADMChannelResponseTypeDef(
    _ClientGetAdmChannelResponseADMChannelResponseTypeDef
):
    """
    Type definition for `ClientGetAdmChannelResponse` `ADMChannelResponse`

    Provides information about the status and settings of the ADM (Amazon Device Messaging) channel
    for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the ADM channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the ADM channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the ADM channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the ADM channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the ADM channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the ADM channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the ADM channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the ADM channel, this
      value is ADM.

    - **Version** *(integer) --*

      The current version of the ADM channel.
    """


_ClientGetAdmChannelResponseTypeDef = TypedDict(
    "_ClientGetAdmChannelResponseTypeDef",
    {"ADMChannelResponse": ClientGetAdmChannelResponseADMChannelResponseTypeDef},
    total=False,
)


class ClientGetAdmChannelResponseTypeDef(_ClientGetAdmChannelResponseTypeDef):
    """
    Type definition for `ClientGetAdmChannel` `Response`

    The request succeeded.

    - **ADMChannelResponse** *(dict) --*

      Provides information about the status and settings of the ADM (Amazon Device Messaging)
      channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the ADM channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the ADM channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the ADM channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the ADM channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the ADM channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the ADM channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the ADM channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the ADM channel, this
        value is ADM.

      - **Version** *(integer) --*

        The current version of the ADM channel.
    """


_ClientGetApnsChannelResponseAPNSChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsChannelResponseAPNSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsChannelResponseAPNSChannelResponseTypeDef(
    _ClientGetApnsChannelResponseAPNSChannelResponseTypeDef
):
    """
    Type definition for `ClientGetApnsChannelResponse` `APNSChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with APNs for this
      channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs channel is configured to communicate with APNs by using APNs
      tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
      channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs channel, this
      value is APNS.

    - **Version** *(integer) --*

      The current version of the APNs channel.
    """


_ClientGetApnsChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsChannelResponseTypeDef",
    {"APNSChannelResponse": ClientGetApnsChannelResponseAPNSChannelResponseTypeDef},
    total=False,
)


class ClientGetApnsChannelResponseTypeDef(_ClientGetApnsChannelResponseTypeDef):
    """
    Type definition for `ClientGetApnsChannel` `Response`

    The request succeeded.

    - **APNSChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with APNs for
        this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs channel is configured to communicate with APNs by using APNs
        tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
        channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs channel, this
        value is APNS.

      - **Version** *(integer) --*

        The current version of the APNs channel.
    """


_ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef(
    _ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientGetApnsSandboxChannelResponse` `APNSSandboxChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    sandbox channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs sandbox channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs sandbox channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
      sandbox environment for this channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs sandbox channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs sandbox channel is configured to communicate with APNs by using
      APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property of
      the channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs sandbox channel. This property is retained only for
      backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs sandbox channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs sandbox channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs sandbox channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs sandbox channel,
      this value is APNS_SANDBOX.

    - **Version** *(integer) --*

      The current version of the APNs sandbox channel.
    """


_ClientGetApnsSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsSandboxChannelResponseTypeDef",
    {
        "APNSSandboxChannelResponse": ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientGetApnsSandboxChannelResponseTypeDef(_ClientGetApnsSandboxChannelResponseTypeDef):
    """
    Type definition for `ClientGetApnsSandboxChannel` `Response`

    The request succeeded.

    - **APNSSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) sandbox channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs sandbox channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs sandbox channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
        sandbox environment for this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs sandbox channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs sandbox channel is configured to communicate with APNs by using
        APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property of
        the channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs sandbox channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs sandbox channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs sandbox channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs sandbox channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs sandbox
        channel, this value is APNS_SANDBOX.

      - **Version** *(integer) --*

        The current version of the APNs sandbox channel.
    """


_ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef(
    _ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef
):
    """
    Type definition for `ClientGetApnsVoipChannelResponse` `APNSVoipChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    VoIP channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs VoIP channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs VoIP channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with APNs for this
      channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs VoIP channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs VoIP channel is configured to communicate with APNs by using APNs
      tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
      channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs VoIP channel. This property is retained only for
      backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs VoIP channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs VoIP channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs VoIP channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs VoIP channel,
      this value is APNS_VOIP.

    - **Version** *(integer) --*

      The current version of the APNs VoIP channel.
    """


_ClientGetApnsVoipChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipChannelResponseTypeDef",
    {"APNSVoipChannelResponse": ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef},
    total=False,
)


class ClientGetApnsVoipChannelResponseTypeDef(_ClientGetApnsVoipChannelResponseTypeDef):
    """
    Type definition for `ClientGetApnsVoipChannel` `Response`

    The request succeeded.

    - **APNSVoipChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs VoIP channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with APNs for
        this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs VoIP channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs VoIP channel is configured to communicate with APNs by using APNs
        tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
        channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs VoIP channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs VoIP channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs VoIP channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs VoIP channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs VoIP channel,
        this value is APNS_VOIP.

      - **Version** *(integer) --*

        The current version of the APNs VoIP channel.
    """


_ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef(
    _ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientGetApnsVoipSandboxChannelResponse` `APNSVoipSandboxChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    VoIP sandbox channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs VoIP sandbox channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs VoIP sandbox channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
      sandbox environment for this channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is configured to communicate with APNs by
      using APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property
      of the channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs VoIP sandbox channel. This property is retained only
      for backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs VoIP sandbox channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs VoIP sandbox channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs VoIP sandbox
      channel, this value is APNS_VOIP_SANDBOX.

    - **Version** *(integer) --*

      The current version of the APNs VoIP sandbox channel.
    """


_ClientGetApnsVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipSandboxChannelResponseTypeDef",
    {
        "APNSVoipSandboxChannelResponse": ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientGetApnsVoipSandboxChannelResponseTypeDef(
    _ClientGetApnsVoipSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientGetApnsVoipSandboxChannel` `Response`

    The request succeeded.

    - **APNSVoipSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP sandbox channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP sandbox channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs VoIP sandbox channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
        sandbox environment for this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is configured to communicate with APNs by
        using APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey
        property of the channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs VoIP sandbox channel. This property is retained only
        for backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs VoIP sandbox channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs VoIP sandbox channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs VoIP sandbox
        channel, this value is APNS_VOIP_SANDBOX.

      - **Version** *(integer) --*

        The current version of the APNs VoIP sandbox channel.
    """


_ClientGetAppResponseApplicationResponseTypeDef = TypedDict(
    "_ClientGetAppResponseApplicationResponseTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientGetAppResponseApplicationResponseTypeDef(
    _ClientGetAppResponseApplicationResponseTypeDef
):
    """
    Type definition for `ClientGetAppResponse` `ApplicationResponse`

    Provides information about an application.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the application.

    - **Id** *(string) --*

      The unique identifier for the application. This identifier is displayed as the **Project ID**
      on the Amazon Pinpoint console.

    - **Name** *(string) --*

      The display name of the application. This name is displayed as the **Project name** on the
      Amazon Pinpoint console.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the application. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientGetAppResponseTypeDef = TypedDict(
    "_ClientGetAppResponseTypeDef",
    {"ApplicationResponse": ClientGetAppResponseApplicationResponseTypeDef},
    total=False,
)


class ClientGetAppResponseTypeDef(_ClientGetAppResponseTypeDef):
    """
    Type definition for `ClientGetApp` `Response`

    The request succeeded.

    - **ApplicationResponse** *(dict) --*

      Provides information about an application.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the application.

      - **Id** *(string) --*

        The unique identifier for the application. This identifier is displayed as the **Project
        ID** on the Amazon Pinpoint console.

      - **Name** *(string) --*

        The display name of the application. This name is displayed as the **Project name** on the
        Amazon Pinpoint console.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the application. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
):
    """
    Type definition for
    `ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRows`
    `GroupedBys`

    Provides a single value and metadata about that value as part of an array of query results for a
    standard metric that applies to an application, campaign, or journey.

    - **Key** *(string) --*

      The friendly name of the metric whose value is specified by the Value property.

    - **Type** *(string) --*

      The data type of the value specified by the Value property.

    - **Value** *(string) --*

      In a Values object, the value for the metric that the query retrieved data for. In a
      GroupedBys object, the value for the field that was used to group data in a result set that
      contains multiple results (Values objects).
    """


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef
):
    """
    Type definition for
    `ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRows` `Values`

    Provides a single value and metadata about that value as part of an array of query results for a
    standard metric that applies to an application, campaign, or journey.

    - **Key** *(string) --*

      The friendly name of the metric whose value is specified by the Value property.

    - **Type** *(string) --*

      The data type of the value specified by the Value property.

    - **Value** *(string) --*

      In a Values object, the value for the metric that the query retrieved data for. In a
      GroupedBys object, the value for the field that was used to group data in a result set that
      contains multiple results (Values objects).
    """


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef",
    {
        "GroupedBys": List[
            ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
        ],
        "Values": List[
            ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef
        ],
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef
):
    """
    Type definition for
    `ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResult` `Rows`

    Provides the results of a query that retrieved the data for a standard metric that applies to an
    application, campaign, or journey.

    - **GroupedBys** *(list) --*

      An array of objects that defines the field and field values that were used to group data in a
      result set that contains multiple results. This value is null if the data in a result set
      isn’t grouped.

      - *(dict) --*

        Provides a single value and metadata about that value as part of an array of query results
        for a standard metric that applies to an application, campaign, or journey.

        - **Key** *(string) --*

          The friendly name of the metric whose value is specified by the Value property.

        - **Type** *(string) --*

          The data type of the value specified by the Value property.

        - **Value** *(string) --*

          In a Values object, the value for the metric that the query retrieved data for. In a
          GroupedBys object, the value for the field that was used to group data in a result set
          that contains multiple results (Values objects).

    - **Values** *(list) --*

      An array of objects that provides pre-aggregated values for a standard metric that applies to
      an application, campaign, or journey.

      - *(dict) --*

        Provides a single value and metadata about that value as part of an array of query results
        for a standard metric that applies to an application, campaign, or journey.

        - **Key** *(string) --*

          The friendly name of the metric whose value is specified by the Value property.

        - **Type** *(string) --*

          The data type of the value specified by the Value property.

        - **Value** *(string) --*

          In a Values object, the value for the metric that the query retrieved data for. In a
          GroupedBys object, the value for the field that was used to group data in a result set
          that contains multiple results (Values objects).
    """


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef",
    {
        "Rows": List[
            ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef
        ]
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef
):
    """
    Type definition for `ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponse`
    `KpiResult`

    An array of objects that contains the results of the query. Each object contains the value for
    the metric and metadata about that value.

    - **Rows** *(list) --*

      An array of objects that provides the results of a query that retrieved the data for a
      standard metric that applies to an application, campaign, or journey.

      - *(dict) --*

        Provides the results of a query that retrieved the data for a standard metric that applies
        to an application, campaign, or journey.

        - **GroupedBys** *(list) --*

          An array of objects that defines the field and field values that were used to group data
          in a result set that contains multiple results. This value is null if the data in a result
          set isn’t grouped.

          - *(dict) --*

            Provides a single value and metadata about that value as part of an array of query
            results for a standard metric that applies to an application, campaign, or journey.

            - **Key** *(string) --*

              The friendly name of the metric whose value is specified by the Value property.

            - **Type** *(string) --*

              The data type of the value specified by the Value property.

            - **Value** *(string) --*

              In a Values object, the value for the metric that the query retrieved data for. In a
              GroupedBys object, the value for the field that was used to group data in a result set
              that contains multiple results (Values objects).

        - **Values** *(list) --*

          An array of objects that provides pre-aggregated values for a standard metric that applies
          to an application, campaign, or journey.

          - *(dict) --*

            Provides a single value and metadata about that value as part of an array of query
            results for a standard metric that applies to an application, campaign, or journey.

            - **Key** *(string) --*

              The friendly name of the metric whose value is specified by the Value property.

            - **Type** *(string) --*

              The data type of the value specified by the Value property.

            - **Value** *(string) --*

              In a Values object, the value for the metric that the query retrieved data for. In a
              GroupedBys object, the value for the field that was used to group data in a result set
              that contains multiple results (Values objects).
    """


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef",
    {
        "ApplicationId": str,
        "EndTime": datetime,
        "KpiName": str,
        "KpiResult": ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef,
        "NextToken": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef
):
    """
    Type definition for `ClientGetApplicationDateRangeKpiResponse` `ApplicationDateRangeKpiResponse`

    Provides the results of a query that retrieved the data for a standard metric that applies to an
    application, and provides information about that query.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the metric applies to.

    - **EndTime** *(datetime) --*

      The last date and time of the date range that was used to filter the query results, in
      extended ISO 8601 format. The date range is inclusive.

    - **KpiName** *(string) --*

      The name of the metric, also referred to as a *key performance indicator (KPI)* , that the
      data was retrieved for. This value describes the associated metric and consists of two or more
      terms, which are comprised of lowercase alphanumeric characters, separated by a hyphen. For a
      list of possible values, see the `Amazon Pinpoint Developer Guide
      <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

    - **KpiResult** *(dict) --*

      An array of objects that contains the results of the query. Each object contains the value for
      the metric and metadata about that value.

      - **Rows** *(list) --*

        An array of objects that provides the results of a query that retrieved the data for a
        standard metric that applies to an application, campaign, or journey.

        - *(dict) --*

          Provides the results of a query that retrieved the data for a standard metric that applies
          to an application, campaign, or journey.

          - **GroupedBys** *(list) --*

            An array of objects that defines the field and field values that were used to group data
            in a result set that contains multiple results. This value is null if the data in a
            result set isn’t grouped.

            - *(dict) --*

              Provides a single value and metadata about that value as part of an array of query
              results for a standard metric that applies to an application, campaign, or journey.

              - **Key** *(string) --*

                The friendly name of the metric whose value is specified by the Value property.

              - **Type** *(string) --*

                The data type of the value specified by the Value property.

              - **Value** *(string) --*

                In a Values object, the value for the metric that the query retrieved data for. In a
                GroupedBys object, the value for the field that was used to group data in a result
                set that contains multiple results (Values objects).

          - **Values** *(list) --*

            An array of objects that provides pre-aggregated values for a standard metric that
            applies to an application, campaign, or journey.

            - *(dict) --*

              Provides a single value and metadata about that value as part of an array of query
              results for a standard metric that applies to an application, campaign, or journey.

              - **Key** *(string) --*

                The friendly name of the metric whose value is specified by the Value property.

              - **Type** *(string) --*

                The data type of the value specified by the Value property.

              - **Value** *(string) --*

                In a Values object, the value for the metric that the query retrieved data for. In a
                GroupedBys object, the value for the field that was used to group data in a result
                set that contains multiple results (Values objects).

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null for the Application Metrics resource because the resource returns
      all results in a single page.

    - **StartTime** *(datetime) --*

      The first date and time of the date range that was used to filter the query results, in
      extended ISO 8601 format. The date range is inclusive.
    """


_ClientGetApplicationDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseTypeDef",
    {
        "ApplicationDateRangeKpiResponse": ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseTypeDef(
    _ClientGetApplicationDateRangeKpiResponseTypeDef
):
    """
    Type definition for `ClientGetApplicationDateRangeKpi` `Response`

    The request succeeded.

    - **ApplicationDateRangeKpiResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard metric that applies to
      an application, and provides information about that query.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.

      - **EndTime** *(datetime) --*

        The last date and time of the date range that was used to filter the query results, in
        extended ISO 8601 format. The date range is inclusive.

      - **KpiName** *(string) --*

        The name of the metric, also referred to as a *key performance indicator (KPI)* , that the
        data was retrieved for. This value describes the associated metric and consists of two or
        more terms, which are comprised of lowercase alphanumeric characters, separated by a hyphen.
        For a list of possible values, see the `Amazon Pinpoint Developer Guide
        <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

      - **KpiResult** *(dict) --*

        An array of objects that contains the results of the query. Each object contains the value
        for the metric and metadata about that value.

        - **Rows** *(list) --*

          An array of objects that provides the results of a query that retrieved the data for a
          standard metric that applies to an application, campaign, or journey.

          - *(dict) --*

            Provides the results of a query that retrieved the data for a standard metric that
            applies to an application, campaign, or journey.

            - **GroupedBys** *(list) --*

              An array of objects that defines the field and field values that were used to group
              data in a result set that contains multiple results. This value is null if the data in
              a result set isn’t grouped.

              - *(dict) --*

                Provides a single value and metadata about that value as part of an array of query
                results for a standard metric that applies to an application, campaign, or journey.

                - **Key** *(string) --*

                  The friendly name of the metric whose value is specified by the Value property.

                - **Type** *(string) --*

                  The data type of the value specified by the Value property.

                - **Value** *(string) --*

                  In a Values object, the value for the metric that the query retrieved data for. In
                  a GroupedBys object, the value for the field that was used to group data in a
                  result set that contains multiple results (Values objects).

            - **Values** *(list) --*

              An array of objects that provides pre-aggregated values for a standard metric that
              applies to an application, campaign, or journey.

              - *(dict) --*

                Provides a single value and metadata about that value as part of an array of query
                results for a standard metric that applies to an application, campaign, or journey.

                - **Key** *(string) --*

                  The friendly name of the metric whose value is specified by the Value property.

                - **Type** *(string) --*

                  The data type of the value specified by the Value property.

                - **Value** *(string) --*

                  In a Values object, the value for the metric that the query retrieved data for. In
                  a GroupedBys object, the value for the field that was used to group data in a
                  result set that contains multiple results (Values objects).

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null for the Application Metrics resource because the resource
        returns all results in a single page.

      - **StartTime** *(datetime) --*

        The first date and time of the date range that was used to filter the query results, in
        extended ISO 8601 format. The date range is inclusive.
    """


_ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef
):
    """
    Type definition for `ClientGetApplicationSettingsResponseApplicationSettingsResource`
    `CampaignHook`

    The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
    application.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef
):
    """
    Type definition for `ClientGetApplicationSettingsResponseApplicationSettingsResource` `Limits`

    The default sending limits for campaigns in the application.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef
):
    """
    Type definition for `ClientGetApplicationSettingsResponseApplicationSettingsResource`
    `QuietTime`

    The default quiet time for campaigns and journeys in the application. Quiet time is a specific
    time range when messages aren't sent to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the application (or a campaign or journey that has custom quiet
    time settings).

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the application (or a campaign or journey that has custom quiet
    time settings).

    If any of the preceding conditions isn't met, the endpoint will receive messages from a campaign
    or journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    {
        "ApplicationId": str,
        "CampaignHook": ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef,
        "LastModifiedDate": str,
        "Limits": ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef,
        "QuietTime": ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef,
    },
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef
):
    """
    Type definition for `ClientGetApplicationSettingsResponse` `ApplicationSettingsResource`

    Provides information about an application, including the default settings for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application. This identifier is displayed as the **Project ID**
      on the Amazon Pinpoint console.

    - **CampaignHook** *(dict) --*

      The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
      application.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the application's settings were last modified.

    - **Limits** *(dict) --*

      The default sending limits for campaigns in the application.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **QuietTime** *(dict) --*

      The default quiet time for campaigns and journeys in the application. Quiet time is a specific
      time range when messages aren't sent to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the application (or a campaign or journey that has custom
      quiet time settings).

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the application (or a campaign or journey that has custom
      quiet time settings).

      If any of the preceding conditions isn't met, the endpoint will receive messages from a
      campaign or journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetApplicationSettingsResponseTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseTypeDef",
    {
        "ApplicationSettingsResource": ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef
    },
    total=False,
)


class ClientGetApplicationSettingsResponseTypeDef(_ClientGetApplicationSettingsResponseTypeDef):
    """
    Type definition for `ClientGetApplicationSettings` `Response`

    The request succeeded.

    - **ApplicationSettingsResource** *(dict) --*

      Provides information about an application, including the default settings for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application. This identifier is displayed as the **Project
        ID** on the Amazon Pinpoint console.

      - **CampaignHook** *(dict) --*

        The settings for the AWS Lambda function to use by default as a code hook for campaigns in
        the application.

        - **LambdaFunctionName** *(string) --*

          The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
          invokes to send messages for a campaign.

        - **Mode** *(string) --*

          Specifies which Lambda mode to use when invoking the AWS Lambda function.

        - **WebUrl** *(string) --*

          The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the application's settings were last modified.

      - **Limits** *(dict) --*

        The default sending limits for campaigns in the application.

        - **Daily** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during a
          24-hour period. The maximum value is 100.

        - **MaximumDuration** *(integer) --*

          The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
          after the scheduled start time for the campaign. The minimum value is 60 seconds.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that a campaign can send each second. The minimum value is
          50. The maximum value is 20,000.

        - **Total** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during the
          course of the campaign. The maximum value is 100.

      - **QuietTime** *(dict) --*

        The default quiet time for campaigns and journeys in the application. Quiet time is a
        specific time range when messages aren't sent to endpoints, if all the following conditions
        are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the application (or a campaign or journey that has
        custom quiet time settings).

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the application (or a campaign or journey that
        has custom quiet time settings).

        If any of the preceding conditions isn't met, the endpoint will receive messages from a
        campaign or journey, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetAppsResponseApplicationsResponseItemTypeDef = TypedDict(
    "_ClientGetAppsResponseApplicationsResponseItemTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientGetAppsResponseApplicationsResponseItemTypeDef(
    _ClientGetAppsResponseApplicationsResponseItemTypeDef
):
    """
    Type definition for `ClientGetAppsResponseApplicationsResponse` `Item`

    Provides information about an application.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the application.

    - **Id** *(string) --*

      The unique identifier for the application. This identifier is displayed as the **Project ID**
      on the Amazon Pinpoint console.

    - **Name** *(string) --*

      The display name of the application. This name is displayed as the **Project name** on the
      Amazon Pinpoint console.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the application. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientGetAppsResponseApplicationsResponseTypeDef = TypedDict(
    "_ClientGetAppsResponseApplicationsResponseTypeDef",
    {"Item": List[ClientGetAppsResponseApplicationsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetAppsResponseApplicationsResponseTypeDef(
    _ClientGetAppsResponseApplicationsResponseTypeDef
):
    """
    Type definition for `ClientGetAppsResponse` `ApplicationsResponse`

    Provides information about all of your applications.

    - **Item** *(list) --*

      An array of responses, one for each application that was returned.

      - *(dict) --*

        Provides information about an application.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the application.

        - **Id** *(string) --*

          The unique identifier for the application. This identifier is displayed as the **Project
          ID** on the Amazon Pinpoint console.

        - **Name** *(string) --*

          The display name of the application. This name is displayed as the **Project name** on the
          Amazon Pinpoint console.

        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that identifies the tags that are associated
          with the application. Each tag consists of a required tag key and an associated tag value.

          - *(string) --*

            - *(string) --*

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetAppsResponseTypeDef = TypedDict(
    "_ClientGetAppsResponseTypeDef",
    {"ApplicationsResponse": ClientGetAppsResponseApplicationsResponseTypeDef},
    total=False,
)


class ClientGetAppsResponseTypeDef(_ClientGetAppsResponseTypeDef):
    """
    Type definition for `ClientGetApps` `Response`

    The request succeeded.

    - **ApplicationsResponse** *(dict) --*

      Provides information about all of your applications.

      - **Item** *(list) --*

        An array of responses, one for each application that was returned.

        - *(dict) --*

          Provides information about an application.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the application.

          - **Id** *(string) --*

            The unique identifier for the application. This identifier is displayed as the **Project
            ID** on the Amazon Pinpoint console.

          - **Name** *(string) --*

            The display name of the application. This name is displayed as the **Project name** on
            the Amazon Pinpoint console.

          - **tags** *(dict) --*

            A string-to-string map of key-value pairs that identifies the tags that are associated
            with the application. Each tag consists of a required tag key and an associated tag
            value.

            - *(string) --*

              - *(string) --*

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef = TypedDict(
    "_ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef(
    _ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef
):
    """
    Type definition for `ClientGetBaiduChannelResponse` `BaiduChannelResponse`

    Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
    an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the Baidu channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the Baidu channel was enabled.

    - **Credential** *(string) --*

      The API key that you received from the Baidu Cloud Push service to communicate with the
      service.

    - **Enabled** *(boolean) --*

      Specifies whether the Baidu channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the Baidu channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the Baidu channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the Baidu channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the Baidu channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the Baidu channel, this
      value is BAIDU.

    - **Version** *(integer) --*

      The current version of the Baidu channel.
    """


_ClientGetBaiduChannelResponseTypeDef = TypedDict(
    "_ClientGetBaiduChannelResponseTypeDef",
    {"BaiduChannelResponse": ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef},
    total=False,
)


class ClientGetBaiduChannelResponseTypeDef(_ClientGetBaiduChannelResponseTypeDef):
    """
    Type definition for `ClientGetBaiduChannel` `Response`

    The request succeeded.

    - **BaiduChannelResponse** *(dict) --*

      Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
      an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the Baidu channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the Baidu channel was enabled.

      - **Credential** *(string) --*

        The API key that you received from the Baidu Cloud Push service to communicate with the
        service.

      - **Enabled** *(boolean) --*

        Specifies whether the Baidu channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the Baidu channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the Baidu channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the Baidu channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the Baidu channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the Baidu channel, this
        value is BAIDU.

      - **Version** *(integer) --*

        The current version of the Baidu channel.
    """


_ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef = TypedDict(
    "_ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CampaignId": str,
        "End": str,
        "Id": str,
        "Result": str,
        "ScheduledStart": str,
        "Start": str,
        "State": str,
        "SuccessfulEndpointCount": int,
        "TimezonesCompletedCount": int,
        "TimezonesTotalCount": int,
        "TotalEndpointCount": int,
        "TreatmentId": str,
    },
    total=False,
)


class ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef(
    _ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef
):
    """
    Type definition for `ClientGetCampaignActivitiesResponseActivitiesResponse` `Item`

    Provides information about an activity that was performed by a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **CampaignId** *(string) --*

      The unique identifier for the campaign that the activity applies to.

    - **End** *(string) --*

      The actual time, in ISO 8601 format, when the activity was marked CANCELLED or COMPLETED.

    - **Id** *(string) --*

      The unique identifier for the activity.

    - **Result** *(string) --*

      Specifies whether the activity succeeded. Possible values are SUCCESS and FAIL.

    - **ScheduledStart** *(string) --*

      The scheduled start time, in ISO 8601 format, for the activity.

    - **Start** *(string) --*

      The actual start time, in ISO 8601 format, of the activity.

    - **State** *(string) --*

      The current status of the activity. Possible values are: PENDING, INITIALIZING, RUNNING,
      PAUSED, CANCELLED, and COMPLETED.

    - **SuccessfulEndpointCount** *(integer) --*

      The total number of endpoints that the campaign successfully delivered messages to.

    - **TimezonesCompletedCount** *(integer) --*

      The total number of time zones that were completed.

    - **TimezonesTotalCount** *(integer) --*

      The total number of unique time zones that are in the segment for the campaign.

    - **TotalEndpointCount** *(integer) --*

      The total number of endpoints that the campaign attempted to deliver messages to.

    - **TreatmentId** *(string) --*

      The unique identifier for the campaign treatment that the activity applies to. A treatment is
      a variation of a campaign that's used for A/B testing of a campaign.
    """


_ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef = TypedDict(
    "_ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef",
    {
        "Item": List[ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef(
    _ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef
):
    """
    Type definition for `ClientGetCampaignActivitiesResponse` `ActivitiesResponse`

    Provides information about the activities that were performed by a campaign.

    - **Item** *(list) --*

      An array of responses, one for each activity that was performed by the campaign.

      - *(dict) --*

        Provides information about an activity that was performed by a campaign.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that the campaign applies to.

        - **CampaignId** *(string) --*

          The unique identifier for the campaign that the activity applies to.

        - **End** *(string) --*

          The actual time, in ISO 8601 format, when the activity was marked CANCELLED or COMPLETED.

        - **Id** *(string) --*

          The unique identifier for the activity.

        - **Result** *(string) --*

          Specifies whether the activity succeeded. Possible values are SUCCESS and FAIL.

        - **ScheduledStart** *(string) --*

          The scheduled start time, in ISO 8601 format, for the activity.

        - **Start** *(string) --*

          The actual start time, in ISO 8601 format, of the activity.

        - **State** *(string) --*

          The current status of the activity. Possible values are: PENDING, INITIALIZING, RUNNING,
          PAUSED, CANCELLED, and COMPLETED.

        - **SuccessfulEndpointCount** *(integer) --*

          The total number of endpoints that the campaign successfully delivered messages to.

        - **TimezonesCompletedCount** *(integer) --*

          The total number of time zones that were completed.

        - **TimezonesTotalCount** *(integer) --*

          The total number of unique time zones that are in the segment for the campaign.

        - **TotalEndpointCount** *(integer) --*

          The total number of endpoints that the campaign attempted to deliver messages to.

        - **TreatmentId** *(string) --*

          The unique identifier for the campaign treatment that the activity applies to. A treatment
          is a variation of a campaign that's used for A/B testing of a campaign.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetCampaignActivitiesResponseTypeDef = TypedDict(
    "_ClientGetCampaignActivitiesResponseTypeDef",
    {"ActivitiesResponse": ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef},
    total=False,
)


class ClientGetCampaignActivitiesResponseTypeDef(_ClientGetCampaignActivitiesResponseTypeDef):
    """
    Type definition for `ClientGetCampaignActivities` `Response`

    The request succeeded.

    - **ActivitiesResponse** *(dict) --*

      Provides information about the activities that were performed by a campaign.

      - **Item** *(list) --*

        An array of responses, one for each activity that was performed by the campaign.

        - *(dict) --*

          Provides information about an activity that was performed by a campaign.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that the campaign applies to.

          - **CampaignId** *(string) --*

            The unique identifier for the campaign that the activity applies to.

          - **End** *(string) --*

            The actual time, in ISO 8601 format, when the activity was marked CANCELLED or
            COMPLETED.

          - **Id** *(string) --*

            The unique identifier for the activity.

          - **Result** *(string) --*

            Specifies whether the activity succeeded. Possible values are SUCCESS and FAIL.

          - **ScheduledStart** *(string) --*

            The scheduled start time, in ISO 8601 format, for the activity.

          - **Start** *(string) --*

            The actual start time, in ISO 8601 format, of the activity.

          - **State** *(string) --*

            The current status of the activity. Possible values are: PENDING, INITIALIZING, RUNNING,
            PAUSED, CANCELLED, and COMPLETED.

          - **SuccessfulEndpointCount** *(integer) --*

            The total number of endpoints that the campaign successfully delivered messages to.

          - **TimezonesCompletedCount** *(integer) --*

            The total number of time zones that were completed.

          - **TimezonesTotalCount** *(integer) --*

            The total number of unique time zones that are in the segment for the campaign.

          - **TotalEndpointCount** *(integer) --*

            The total number of endpoints that the campaign attempted to deliver messages to.

          - **TreatmentId** *(string) --*

            The unique identifier for the campaign treatment that the activity applies to. A
            treatment is a variation of a campaign that's used for A/B testing of a campaign.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
):
    """
    Type definition for
    `ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRows` `GroupedBys`

    Provides a single value and metadata about that value as part of an array of query results for a
    standard metric that applies to an application, campaign, or journey.

    - **Key** *(string) --*

      The friendly name of the metric whose value is specified by the Value property.

    - **Type** *(string) --*

      The data type of the value specified by the Value property.

    - **Value** *(string) --*

      In a Values object, the value for the metric that the query retrieved data for. In a
      GroupedBys object, the value for the field that was used to group data in a result set that
      contains multiple results (Values objects).
    """


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRows` `Values`

    Provides a single value and metadata about that value as part of an array of query results for a
    standard metric that applies to an application, campaign, or journey.

    - **Key** *(string) --*

      The friendly name of the metric whose value is specified by the Value property.

    - **Type** *(string) --*

      The data type of the value specified by the Value property.

    - **Value** *(string) --*

      In a Values object, the value for the metric that the query retrieved data for. In a
      GroupedBys object, the value for the field that was used to group data in a result set that
      contains multiple results (Values objects).
    """


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef",
    {
        "GroupedBys": List[
            ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
        ],
        "Values": List[
            ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef
        ],
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef
):
    """
    Type definition for `ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResult`
    `Rows`

    Provides the results of a query that retrieved the data for a standard metric that applies to an
    application, campaign, or journey.

    - **GroupedBys** *(list) --*

      An array of objects that defines the field and field values that were used to group data in a
      result set that contains multiple results. This value is null if the data in a result set
      isn’t grouped.

      - *(dict) --*

        Provides a single value and metadata about that value as part of an array of query results
        for a standard metric that applies to an application, campaign, or journey.

        - **Key** *(string) --*

          The friendly name of the metric whose value is specified by the Value property.

        - **Type** *(string) --*

          The data type of the value specified by the Value property.

        - **Value** *(string) --*

          In a Values object, the value for the metric that the query retrieved data for. In a
          GroupedBys object, the value for the field that was used to group data in a result set
          that contains multiple results (Values objects).

    - **Values** *(list) --*

      An array of objects that provides pre-aggregated values for a standard metric that applies to
      an application, campaign, or journey.

      - *(dict) --*

        Provides a single value and metadata about that value as part of an array of query results
        for a standard metric that applies to an application, campaign, or journey.

        - **Key** *(string) --*

          The friendly name of the metric whose value is specified by the Value property.

        - **Type** *(string) --*

          The data type of the value specified by the Value property.

        - **Value** *(string) --*

          In a Values object, the value for the metric that the query retrieved data for. In a
          GroupedBys object, the value for the field that was used to group data in a result set
          that contains multiple results (Values objects).
    """


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef",
    {
        "Rows": List[
            ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef
        ]
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef
):
    """
    Type definition for `ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponse`
    `KpiResult`

    An array of objects that contains the results of the query. Each object contains the value for
    the metric and metadata about that value.

    - **Rows** *(list) --*

      An array of objects that provides the results of a query that retrieved the data for a
      standard metric that applies to an application, campaign, or journey.

      - *(dict) --*

        Provides the results of a query that retrieved the data for a standard metric that applies
        to an application, campaign, or journey.

        - **GroupedBys** *(list) --*

          An array of objects that defines the field and field values that were used to group data
          in a result set that contains multiple results. This value is null if the data in a result
          set isn’t grouped.

          - *(dict) --*

            Provides a single value and metadata about that value as part of an array of query
            results for a standard metric that applies to an application, campaign, or journey.

            - **Key** *(string) --*

              The friendly name of the metric whose value is specified by the Value property.

            - **Type** *(string) --*

              The data type of the value specified by the Value property.

            - **Value** *(string) --*

              In a Values object, the value for the metric that the query retrieved data for. In a
              GroupedBys object, the value for the field that was used to group data in a result set
              that contains multiple results (Values objects).

        - **Values** *(list) --*

          An array of objects that provides pre-aggregated values for a standard metric that applies
          to an application, campaign, or journey.

          - *(dict) --*

            Provides a single value and metadata about that value as part of an array of query
            results for a standard metric that applies to an application, campaign, or journey.

            - **Key** *(string) --*

              The friendly name of the metric whose value is specified by the Value property.

            - **Type** *(string) --*

              The data type of the value specified by the Value property.

            - **Value** *(string) --*

              In a Values object, the value for the metric that the query retrieved data for. In a
              GroupedBys object, the value for the field that was used to group data in a result set
              that contains multiple results (Values objects).
    """


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef",
    {
        "ApplicationId": str,
        "CampaignId": str,
        "EndTime": datetime,
        "KpiName": str,
        "KpiResult": ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef,
        "NextToken": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef
):
    """
    Type definition for `ClientGetCampaignDateRangeKpiResponse` `CampaignDateRangeKpiResponse`

    Provides the results of a query that retrieved the data for a standard metric that applies to a
    campaign, and provides information about that query.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the metric applies to.

    - **CampaignId** *(string) --*

      The unique identifier for the campaign that the metric applies to.

    - **EndTime** *(datetime) --*

      The last date and time of the date range that was used to filter the query results, in
      extended ISO 8601 format. The date range is inclusive.

    - **KpiName** *(string) --*

      The name of the metric, also referred to as a *key performance indicator (KPI)* , that the
      data was retrieved for. This value describes the associated metric and consists of two or more
      terms, which are comprised of lowercase alphanumeric characters, separated by a hyphen. For a
      list of possible values, see the `Amazon Pinpoint Developer Guide
      <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

    - **KpiResult** *(dict) --*

      An array of objects that contains the results of the query. Each object contains the value for
      the metric and metadata about that value.

      - **Rows** *(list) --*

        An array of objects that provides the results of a query that retrieved the data for a
        standard metric that applies to an application, campaign, or journey.

        - *(dict) --*

          Provides the results of a query that retrieved the data for a standard metric that applies
          to an application, campaign, or journey.

          - **GroupedBys** *(list) --*

            An array of objects that defines the field and field values that were used to group data
            in a result set that contains multiple results. This value is null if the data in a
            result set isn’t grouped.

            - *(dict) --*

              Provides a single value and metadata about that value as part of an array of query
              results for a standard metric that applies to an application, campaign, or journey.

              - **Key** *(string) --*

                The friendly name of the metric whose value is specified by the Value property.

              - **Type** *(string) --*

                The data type of the value specified by the Value property.

              - **Value** *(string) --*

                In a Values object, the value for the metric that the query retrieved data for. In a
                GroupedBys object, the value for the field that was used to group data in a result
                set that contains multiple results (Values objects).

          - **Values** *(list) --*

            An array of objects that provides pre-aggregated values for a standard metric that
            applies to an application, campaign, or journey.

            - *(dict) --*

              Provides a single value and metadata about that value as part of an array of query
              results for a standard metric that applies to an application, campaign, or journey.

              - **Key** *(string) --*

                The friendly name of the metric whose value is specified by the Value property.

              - **Type** *(string) --*

                The data type of the value specified by the Value property.

              - **Value** *(string) --*

                In a Values object, the value for the metric that the query retrieved data for. In a
                GroupedBys object, the value for the field that was used to group data in a result
                set that contains multiple results (Values objects).

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null for the Campaign Metrics resource because the resource returns
      all results in a single page.

    - **StartTime** *(datetime) --*

      The first date and time of the date range that was used to filter the query results, in
      extended ISO 8601 format. The date range is inclusive.
    """


_ClientGetCampaignDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseTypeDef",
    {
        "CampaignDateRangeKpiResponse": ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseTypeDef(_ClientGetCampaignDateRangeKpiResponseTypeDef):
    """
    Type definition for `ClientGetCampaignDateRangeKpi` `Response`

    The request succeeded.

    - **CampaignDateRangeKpiResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard metric that applies to
      a campaign, and provides information about that query.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.

      - **CampaignId** *(string) --*

        The unique identifier for the campaign that the metric applies to.

      - **EndTime** *(datetime) --*

        The last date and time of the date range that was used to filter the query results, in
        extended ISO 8601 format. The date range is inclusive.

      - **KpiName** *(string) --*

        The name of the metric, also referred to as a *key performance indicator (KPI)* , that the
        data was retrieved for. This value describes the associated metric and consists of two or
        more terms, which are comprised of lowercase alphanumeric characters, separated by a hyphen.
        For a list of possible values, see the `Amazon Pinpoint Developer Guide
        <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

      - **KpiResult** *(dict) --*

        An array of objects that contains the results of the query. Each object contains the value
        for the metric and metadata about that value.

        - **Rows** *(list) --*

          An array of objects that provides the results of a query that retrieved the data for a
          standard metric that applies to an application, campaign, or journey.

          - *(dict) --*

            Provides the results of a query that retrieved the data for a standard metric that
            applies to an application, campaign, or journey.

            - **GroupedBys** *(list) --*

              An array of objects that defines the field and field values that were used to group
              data in a result set that contains multiple results. This value is null if the data in
              a result set isn’t grouped.

              - *(dict) --*

                Provides a single value and metadata about that value as part of an array of query
                results for a standard metric that applies to an application, campaign, or journey.

                - **Key** *(string) --*

                  The friendly name of the metric whose value is specified by the Value property.

                - **Type** *(string) --*

                  The data type of the value specified by the Value property.

                - **Value** *(string) --*

                  In a Values object, the value for the metric that the query retrieved data for. In
                  a GroupedBys object, the value for the field that was used to group data in a
                  result set that contains multiple results (Values objects).

            - **Values** *(list) --*

              An array of objects that provides pre-aggregated values for a standard metric that
              applies to an application, campaign, or journey.

              - *(dict) --*

                Provides a single value and metadata about that value as part of an array of query
                results for a standard metric that applies to an application, campaign, or journey.

                - **Key** *(string) --*

                  The friendly name of the metric whose value is specified by the Value property.

                - **Type** *(string) --*

                  The data type of the value specified by the Value property.

                - **Value** *(string) --*

                  In a Values object, the value for the metric that the query retrieved data for. In
                  a GroupedBys object, the value for the field that was used to group data in a
                  result set that contains multiple results (Values objects).

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null for the Campaign Metrics resource because the resource returns
        all results in a single page.

      - **StartTime** *(datetime) --*

        The first date and time of the date range that was used to filter the query results, in
        extended ISO 8601 format. The date range is inclusive.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration` `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration` `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration` `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilter` `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseAdditionalTreatments` `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseAdditionalTreatments` `State`

    The current status of the treatment.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **Id** *(string) --*

      The unique identifier for the treatment.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --*

      The allocated percentage of users (segment members) that the treatment is sent to.

    - **State** *(dict) --*

      The current status of the treatment.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `DefaultState`

    The current status of the campaign's default treatment. This value exists only for campaigns
    that have more than one treatment, to support A/B testing.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseHookTypeDef(
    _ClientGetCampaignResponseCampaignResponseHookTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientGetCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientGetCampaignResponseCampaignResponseLimitsTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseMessageConfiguration` `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseMessageConfiguration` `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseMessageConfiguration` `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseScheduleEventFilter` `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseStateTypeDef", {"CampaignStatus": str}, total=False
)


class ClientGetCampaignResponseCampaignResponseStateTypeDef(
    _ClientGetCampaignResponseCampaignResponseStateTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `State`

    The current status of the campaign.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponseTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignResponseCampaignResponse` `TemplateConfiguration`

    The message template that’s used for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTypeDef(
    _ClientGetCampaignResponseCampaignResponseTypeDef
):
    """
    Type definition for `ClientGetCampaignResponse` `CampaignResponse`

    Provides information about the status, configuration, and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of responses, one for each treatment that you defined for the campaign, in addition
      to the default treatment.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **Id** *(string) --*

          The unique identifier for the treatment.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --*

          The allocated percentage of users (segment members) that the treatment is sent to.

        - **State** *(dict) --*

          The current status of the treatment.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the campaign.

    - **CreationDate** *(string) --*

      The date, ISO 8601 format, when the campaign was created.

    - **DefaultState** *(dict) --*

      The current status of the campaign's default treatment. This value exists only for campaigns
      that have more than one treatment, to support A/B testing.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **Description** *(string) --*

      The custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **Id** *(string) --*

      The unique identifier for the campaign.

    - **IsPaused** *(boolean) --*

      Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
      by changing this value to false.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the campaign was last modified.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment that's associated with the campaign.

    - **SegmentVersion** *(integer) --*

      The version number of the segment that's associated with the campaign.

    - **State** *(dict) --*

      The current status of the campaign.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template that’s used for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of a variation of the campaign that's used for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign that's used for A/B testing.

    - **Version** *(integer) --*

      The version number of the campaign.
    """


_ClientGetCampaignResponseTypeDef = TypedDict(
    "_ClientGetCampaignResponseTypeDef",
    {"CampaignResponse": ClientGetCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientGetCampaignResponseTypeDef(_ClientGetCampaignResponseTypeDef):
    """
    Type definition for `ClientGetCampaign` `Response`

    The request succeeded.

    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.

      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.

        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.

          - **Id** *(string) --*

            The unique identifier for the treatment.

          - **MessageConfiguration** *(dict) --*

            The message configuration settings for the treatment.

            - **ADMMessage** *(dict) --*

              The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
              This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **APNSMessage** *(dict) --*

              The message that the campaign sends through the APNs (Apple Push Notification service)
              channel. This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **BaiduMessage** *(dict) --*

              The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
              message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **DefaultMessage** *(dict) --*

              The default message that the campaign sends through all the channels that are
              configured for the campaign.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **EmailMessage** *(dict) --*

              The message that the campaign sends through the email channel.

              - **Body** *(string) --*

                The body of the email for recipients whose email clients don't render HTML content.

              - **FromAddress** *(string) --*

                The verified email address to send the email from. The default address is the
                FromAddress specified for the email channel for the application.

              - **HtmlBody** *(string) --*

                The body of the email, in HTML format, for recipients whose email clients render
                HTML content.

              - **Title** *(string) --*

                The subject line, or title, of the email.

            - **GCMMessage** *(dict) --*

              The message that the campaign sends through the GCM channel, which enables Amazon
              Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
              formerly Google Cloud Messaging (GCM), service. This message overrides the default
              message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **SMSMessage** *(dict) --*

              The message that the campaign sends through the SMS channel.

              - **Body** *(string) --*

                The body of the SMS message.

              - **MessageType** *(string) --*

                The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
                time-sensitive, such as a one-time password that supports a customer transaction;
                and, PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
                message.

              - **SenderId** *(string) --*

                The sender ID to display on recipients' devices when they receive the SMS message.

          - **Schedule** *(dict) --*

            The schedule settings for the treatment.

            - **EndTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign ended or will end.

            - **EventFilter** *(dict) --*

              The type of event that causes the campaign to be sent, if the value of the Frequency
              property is EVENT.

              - **Dimensions** *(dict) --*

                The dimension settings of the event filter for the campaign.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **FilterType** *(string) --*

                The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                when an endpoint event (Events resource) occurs.

            - **Frequency** *(string) --*

              Specifies how often the campaign is sent or whether the campaign is sent in response
              to a specific event.

            - **IsLocalTime** *(boolean) --*

              Specifies whether the start and end times for the campaign schedule use each
              recipient's local time. To base the schedule on each recipient's local time, set this
              value to true.

            - **QuietTime** *(dict) --*

              The default quiet time for the campaign. Quiet time is a specific time range when a
              campaign doesn't send messages to endpoints, if all the following conditions are met:

              * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

              * The current time in the endpoint's time zone is later than or equal to the time
              specified by the QuietTime.Start property for the campaign.

              * The current time in the endpoint's time zone is earlier than or equal to the time
              specified by the QuietTime.End property for the campaign.

              If any of the preceding conditions isn't met, the endpoint will receive messages from
              the campaign, even if quiet time is enabled.

              - **End** *(string) --*

                The specific time when quiet time ends. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

              - **Start** *(string) --*

                The specific time when quiet time begins. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

            - **StartTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
              property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
              UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
              UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
              UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

          - **SizePercent** *(integer) --*

            The allocated percentage of users (segment members) that the treatment is sent to.

          - **State** *(dict) --*

            The current status of the treatment.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **TemplateConfiguration** *(dict) --*

            The message template to use for the treatment.

            - **EmailTemplate** *(dict) --*

              The email template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **PushTemplate** *(dict) --*

              The push notification template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **SMSTemplate** *(dict) --*

              The SMS template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **VoiceTemplate** *(dict) --*

              The voice template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

          - **TreatmentDescription** *(string) --*

            The custom description of the treatment.

          - **TreatmentName** *(string) --*

            The custom name of the treatment. A treatment is a variation of a campaign that's used
            for A/B testing of a campaign.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the campaign applies to.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the campaign.

      - **CreationDate** *(string) --*

        The date, ISO 8601 format, when the campaign was created.

      - **DefaultState** *(dict) --*

        The current status of the campaign's default treatment. This value exists only for campaigns
        that have more than one treatment, to support A/B testing.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **Description** *(string) --*

        The custom description of the campaign.

      - **HoldoutPercent** *(integer) --*

        The allocated percentage of users (segment members) who shouldn't receive messages from the
        campaign.

      - **Hook** *(dict) --*

        The settings for the AWS Lambda function to use as a code hook for the campaign.

        - **LambdaFunctionName** *(string) --*

          The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
          invokes to send messages for a campaign.

        - **Mode** *(string) --*

          Specifies which Lambda mode to use when invoking the AWS Lambda function.

        - **WebUrl** *(string) --*

          The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

      - **Id** *(string) --*

        The unique identifier for the campaign.

      - **IsPaused** *(boolean) --*

        Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
        by changing this value to false.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the campaign was last modified.

      - **Limits** *(dict) --*

        The messaging limits for the campaign.

        - **Daily** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during a
          24-hour period. The maximum value is 100.

        - **MaximumDuration** *(integer) --*

          The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
          after the scheduled start time for the campaign. The minimum value is 60 seconds.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that a campaign can send each second. The minimum value is
          50. The maximum value is 20,000.

        - **Total** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during the
          course of the campaign. The maximum value is 100.

      - **MessageConfiguration** *(dict) --*

        The message configuration settings for the campaign.

        - **ADMMessage** *(dict) --*

          The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
          This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **APNSMessage** *(dict) --*

          The message that the campaign sends through the APNs (Apple Push Notification service)
          channel. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **BaiduMessage** *(dict) --*

          The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
          message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **DefaultMessage** *(dict) --*

          The default message that the campaign sends through all the channels that are configured
          for the campaign.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **EmailMessage** *(dict) --*

          The message that the campaign sends through the email channel.

          - **Body** *(string) --*

            The body of the email for recipients whose email clients don't render HTML content.

          - **FromAddress** *(string) --*

            The verified email address to send the email from. The default address is the
            FromAddress specified for the email channel for the application.

          - **HtmlBody** *(string) --*

            The body of the email, in HTML format, for recipients whose email clients render HTML
            content.

          - **Title** *(string) --*

            The subject line, or title, of the email.

        - **GCMMessage** *(dict) --*

          The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
          to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google
          Cloud Messaging (GCM), service. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **SMSMessage** *(dict) --*

          The message that the campaign sends through the SMS channel.

          - **Body** *(string) --*

            The body of the SMS message.

          - **MessageType** *(string) --*

            The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
            time-sensitive, such as a one-time password that supports a customer transaction; and,
            PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

          - **SenderId** *(string) --*

            The sender ID to display on recipients' devices when they receive the SMS message.

      - **Name** *(string) --*

        The name of the campaign.

      - **Schedule** *(dict) --*

        The schedule settings for the campaign.

        - **EndTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign ended or will end.

        - **EventFilter** *(dict) --*

          The type of event that causes the campaign to be sent, if the value of the Frequency
          property is EVENT.

          - **Dimensions** *(dict) --*

            The dimension settings of the event filter for the campaign.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **FilterType** *(string) --*

            The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
            the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
            endpoint event (Events resource) occurs.

        - **Frequency** *(string) --*

          Specifies how often the campaign is sent or whether the campaign is sent in response to a
          specific event.

        - **IsLocalTime** *(boolean) --*

          Specifies whether the start and end times for the campaign schedule use each recipient's
          local time. To base the schedule on each recipient's local time, set this value to true.

        - **QuietTime** *(dict) --*

          The default quiet time for the campaign. Quiet time is a specific time range when a
          campaign doesn't send messages to endpoints, if all the following conditions are met:

          * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

          * The current time in the endpoint's time zone is later than or equal to the time
          specified by the QuietTime.Start property for the campaign.

          * The current time in the endpoint's time zone is earlier than or equal to the time
          specified by the QuietTime.End property for the campaign.

          If any of the preceding conditions isn't met, the endpoint will receive messages from the
          campaign, even if quiet time is enabled.

          - **End** *(string) --*

            The specific time when quiet time ends. This value has to use 24-hour notation and be in
            HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

          - **Start** *(string) --*

            The specific time when quiet time begins. This value has to use 24-hour notation and be
            in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **StartTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
          UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
          UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

      - **SegmentId** *(string) --*

        The unique identifier for the segment that's associated with the campaign.

      - **SegmentVersion** *(integer) --*

        The version number of the segment that's associated with the campaign.

      - **State** *(dict) --*

        The current status of the campaign.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the campaign. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateConfiguration** *(dict) --*

        The message template that’s used for the campaign.

        - **EmailTemplate** *(dict) --*

          The email template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **PushTemplate** *(dict) --*

          The push notification template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **SMSTemplate** *(dict) --*

          The SMS template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **VoiceTemplate** *(dict) --*

          The voice template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

      - **TreatmentDescription** *(string) --*

        The custom description of a variation of the campaign that's used for A/B testing.

      - **TreatmentName** *(string) --*

        The custom name of a variation of the campaign that's used for A/B testing.

      - **Version** *(integer) --*

        The version number of the campaign.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatments`
    `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatments`
    `State`

    The current status of the treatment.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **Id** *(string) --*

      The unique identifier for the treatment.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --*

      The allocated percentage of users (segment members) that the treatment is sent to.

    - **State** *(dict) --*

      The current status of the treatment.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `DefaultState`

    The current status of the campaign's default treatment. This value exists only for campaigns
    that have more than one treatment, to support A/B testing.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignVersionResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseHookTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseHookTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensions` `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignVersionResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseStateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseStateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `State`

    The current status of the campaign.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponseTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponseCampaignResponse` `TemplateConfiguration`

    The message template that’s used for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignVersionResponseCampaignResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignVersionResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignVersionResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionResponse` `CampaignResponse`

    Provides information about the status, configuration, and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of responses, one for each treatment that you defined for the campaign, in addition
      to the default treatment.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **Id** *(string) --*

          The unique identifier for the treatment.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --*

          The allocated percentage of users (segment members) that the treatment is sent to.

        - **State** *(dict) --*

          The current status of the treatment.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the campaign.

    - **CreationDate** *(string) --*

      The date, ISO 8601 format, when the campaign was created.

    - **DefaultState** *(dict) --*

      The current status of the campaign's default treatment. This value exists only for campaigns
      that have more than one treatment, to support A/B testing.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **Description** *(string) --*

      The custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **Id** *(string) --*

      The unique identifier for the campaign.

    - **IsPaused** *(boolean) --*

      Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
      by changing this value to false.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the campaign was last modified.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment that's associated with the campaign.

    - **SegmentVersion** *(integer) --*

      The version number of the segment that's associated with the campaign.

    - **State** *(dict) --*

      The current status of the campaign.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template that’s used for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of a variation of the campaign that's used for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign that's used for A/B testing.

    - **Version** *(integer) --*

      The version number of the campaign.
    """


_ClientGetCampaignVersionResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseTypeDef",
    {"CampaignResponse": ClientGetCampaignVersionResponseCampaignResponseTypeDef},
    total=False,
)


class ClientGetCampaignVersionResponseTypeDef(_ClientGetCampaignVersionResponseTypeDef):
    """
    Type definition for `ClientGetCampaignVersion` `Response`

    The request succeeded.

    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.

      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.

        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.

          - **Id** *(string) --*

            The unique identifier for the treatment.

          - **MessageConfiguration** *(dict) --*

            The message configuration settings for the treatment.

            - **ADMMessage** *(dict) --*

              The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
              This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **APNSMessage** *(dict) --*

              The message that the campaign sends through the APNs (Apple Push Notification service)
              channel. This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **BaiduMessage** *(dict) --*

              The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
              message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **DefaultMessage** *(dict) --*

              The default message that the campaign sends through all the channels that are
              configured for the campaign.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **EmailMessage** *(dict) --*

              The message that the campaign sends through the email channel.

              - **Body** *(string) --*

                The body of the email for recipients whose email clients don't render HTML content.

              - **FromAddress** *(string) --*

                The verified email address to send the email from. The default address is the
                FromAddress specified for the email channel for the application.

              - **HtmlBody** *(string) --*

                The body of the email, in HTML format, for recipients whose email clients render
                HTML content.

              - **Title** *(string) --*

                The subject line, or title, of the email.

            - **GCMMessage** *(dict) --*

              The message that the campaign sends through the GCM channel, which enables Amazon
              Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
              formerly Google Cloud Messaging (GCM), service. This message overrides the default
              message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **SMSMessage** *(dict) --*

              The message that the campaign sends through the SMS channel.

              - **Body** *(string) --*

                The body of the SMS message.

              - **MessageType** *(string) --*

                The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
                time-sensitive, such as a one-time password that supports a customer transaction;
                and, PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
                message.

              - **SenderId** *(string) --*

                The sender ID to display on recipients' devices when they receive the SMS message.

          - **Schedule** *(dict) --*

            The schedule settings for the treatment.

            - **EndTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign ended or will end.

            - **EventFilter** *(dict) --*

              The type of event that causes the campaign to be sent, if the value of the Frequency
              property is EVENT.

              - **Dimensions** *(dict) --*

                The dimension settings of the event filter for the campaign.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **FilterType** *(string) --*

                The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                when an endpoint event (Events resource) occurs.

            - **Frequency** *(string) --*

              Specifies how often the campaign is sent or whether the campaign is sent in response
              to a specific event.

            - **IsLocalTime** *(boolean) --*

              Specifies whether the start and end times for the campaign schedule use each
              recipient's local time. To base the schedule on each recipient's local time, set this
              value to true.

            - **QuietTime** *(dict) --*

              The default quiet time for the campaign. Quiet time is a specific time range when a
              campaign doesn't send messages to endpoints, if all the following conditions are met:

              * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

              * The current time in the endpoint's time zone is later than or equal to the time
              specified by the QuietTime.Start property for the campaign.

              * The current time in the endpoint's time zone is earlier than or equal to the time
              specified by the QuietTime.End property for the campaign.

              If any of the preceding conditions isn't met, the endpoint will receive messages from
              the campaign, even if quiet time is enabled.

              - **End** *(string) --*

                The specific time when quiet time ends. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

              - **Start** *(string) --*

                The specific time when quiet time begins. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

            - **StartTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
              property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
              UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
              UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
              UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

          - **SizePercent** *(integer) --*

            The allocated percentage of users (segment members) that the treatment is sent to.

          - **State** *(dict) --*

            The current status of the treatment.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **TemplateConfiguration** *(dict) --*

            The message template to use for the treatment.

            - **EmailTemplate** *(dict) --*

              The email template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **PushTemplate** *(dict) --*

              The push notification template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **SMSTemplate** *(dict) --*

              The SMS template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **VoiceTemplate** *(dict) --*

              The voice template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

          - **TreatmentDescription** *(string) --*

            The custom description of the treatment.

          - **TreatmentName** *(string) --*

            The custom name of the treatment. A treatment is a variation of a campaign that's used
            for A/B testing of a campaign.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the campaign applies to.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the campaign.

      - **CreationDate** *(string) --*

        The date, ISO 8601 format, when the campaign was created.

      - **DefaultState** *(dict) --*

        The current status of the campaign's default treatment. This value exists only for campaigns
        that have more than one treatment, to support A/B testing.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **Description** *(string) --*

        The custom description of the campaign.

      - **HoldoutPercent** *(integer) --*

        The allocated percentage of users (segment members) who shouldn't receive messages from the
        campaign.

      - **Hook** *(dict) --*

        The settings for the AWS Lambda function to use as a code hook for the campaign.

        - **LambdaFunctionName** *(string) --*

          The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
          invokes to send messages for a campaign.

        - **Mode** *(string) --*

          Specifies which Lambda mode to use when invoking the AWS Lambda function.

        - **WebUrl** *(string) --*

          The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

      - **Id** *(string) --*

        The unique identifier for the campaign.

      - **IsPaused** *(boolean) --*

        Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
        by changing this value to false.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the campaign was last modified.

      - **Limits** *(dict) --*

        The messaging limits for the campaign.

        - **Daily** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during a
          24-hour period. The maximum value is 100.

        - **MaximumDuration** *(integer) --*

          The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
          after the scheduled start time for the campaign. The minimum value is 60 seconds.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that a campaign can send each second. The minimum value is
          50. The maximum value is 20,000.

        - **Total** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during the
          course of the campaign. The maximum value is 100.

      - **MessageConfiguration** *(dict) --*

        The message configuration settings for the campaign.

        - **ADMMessage** *(dict) --*

          The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
          This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **APNSMessage** *(dict) --*

          The message that the campaign sends through the APNs (Apple Push Notification service)
          channel. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **BaiduMessage** *(dict) --*

          The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
          message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **DefaultMessage** *(dict) --*

          The default message that the campaign sends through all the channels that are configured
          for the campaign.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **EmailMessage** *(dict) --*

          The message that the campaign sends through the email channel.

          - **Body** *(string) --*

            The body of the email for recipients whose email clients don't render HTML content.

          - **FromAddress** *(string) --*

            The verified email address to send the email from. The default address is the
            FromAddress specified for the email channel for the application.

          - **HtmlBody** *(string) --*

            The body of the email, in HTML format, for recipients whose email clients render HTML
            content.

          - **Title** *(string) --*

            The subject line, or title, of the email.

        - **GCMMessage** *(dict) --*

          The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
          to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google
          Cloud Messaging (GCM), service. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **SMSMessage** *(dict) --*

          The message that the campaign sends through the SMS channel.

          - **Body** *(string) --*

            The body of the SMS message.

          - **MessageType** *(string) --*

            The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
            time-sensitive, such as a one-time password that supports a customer transaction; and,
            PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

          - **SenderId** *(string) --*

            The sender ID to display on recipients' devices when they receive the SMS message.

      - **Name** *(string) --*

        The name of the campaign.

      - **Schedule** *(dict) --*

        The schedule settings for the campaign.

        - **EndTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign ended or will end.

        - **EventFilter** *(dict) --*

          The type of event that causes the campaign to be sent, if the value of the Frequency
          property is EVENT.

          - **Dimensions** *(dict) --*

            The dimension settings of the event filter for the campaign.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **FilterType** *(string) --*

            The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
            the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
            endpoint event (Events resource) occurs.

        - **Frequency** *(string) --*

          Specifies how often the campaign is sent or whether the campaign is sent in response to a
          specific event.

        - **IsLocalTime** *(boolean) --*

          Specifies whether the start and end times for the campaign schedule use each recipient's
          local time. To base the schedule on each recipient's local time, set this value to true.

        - **QuietTime** *(dict) --*

          The default quiet time for the campaign. Quiet time is a specific time range when a
          campaign doesn't send messages to endpoints, if all the following conditions are met:

          * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

          * The current time in the endpoint's time zone is later than or equal to the time
          specified by the QuietTime.Start property for the campaign.

          * The current time in the endpoint's time zone is earlier than or equal to the time
          specified by the QuietTime.End property for the campaign.

          If any of the preceding conditions isn't met, the endpoint will receive messages from the
          campaign, even if quiet time is enabled.

          - **End** *(string) --*

            The specific time when quiet time ends. This value has to use 24-hour notation and be in
            HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

          - **Start** *(string) --*

            The specific time when quiet time begins. This value has to use 24-hour notation and be
            in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **StartTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
          UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
          UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

      - **SegmentId** *(string) --*

        The unique identifier for the segment that's associated with the campaign.

      - **SegmentVersion** *(integer) --*

        The version number of the segment that's associated with the campaign.

      - **State** *(dict) --*

        The current status of the campaign.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the campaign. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateConfiguration** *(dict) --*

        The message template that’s used for the campaign.

        - **EmailTemplate** *(dict) --*

          The email template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **PushTemplate** *(dict) --*

          The push notification template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **SMSTemplate** *(dict) --*

          The SMS template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **VoiceTemplate** *(dict) --*

          The voice template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

      - **TreatmentDescription** *(string) --*

        The custom description of a variation of the campaign that's used for A/B testing.

      - **TreatmentName** *(string) --*

        The custom name of a variation of the campaign that's used for A/B testing.

      - **Version** *(integer) --*

        The version number of the campaign.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatments`
    `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatments`
    `State`

    The current status of the treatment.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem`
    `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **Id** *(string) --*

      The unique identifier for the treatment.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --*

      The allocated percentage of users (segment members) that the treatment is sent to.

    - **State** *(dict) --*

      The current status of the treatment.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem` `DefaultState`

    The current status of the campaign's default treatment. This value exists only for campaigns
    that have more than one treatment, to support A/B testing.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem`
    `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItemSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem` `State`

    The current status of the campaign.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfiguration` `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfiguration` `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfiguration` `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfiguration` `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponseItem`
    `TemplateConfiguration`

    The message template that’s used for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponseCampaignsResponse` `Item`

    Provides information about the status, configuration, and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of responses, one for each treatment that you defined for the campaign, in addition
      to the default treatment.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **Id** *(string) --*

          The unique identifier for the treatment.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --*

          The allocated percentage of users (segment members) that the treatment is sent to.

        - **State** *(dict) --*

          The current status of the treatment.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the campaign.

    - **CreationDate** *(string) --*

      The date, ISO 8601 format, when the campaign was created.

    - **DefaultState** *(dict) --*

      The current status of the campaign's default treatment. This value exists only for campaigns
      that have more than one treatment, to support A/B testing.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **Description** *(string) --*

      The custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **Id** *(string) --*

      The unique identifier for the campaign.

    - **IsPaused** *(boolean) --*

      Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
      by changing this value to false.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the campaign was last modified.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment that's associated with the campaign.

    - **SegmentVersion** *(integer) --*

      The version number of the segment that's associated with the campaign.

    - **State** *(dict) --*

      The current status of the campaign.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template that’s used for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of a variation of the campaign that's used for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign that's used for A/B testing.

    - **Version** *(integer) --*

      The version number of the campaign.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseTypeDef",
    {"Item": List[ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseTypeDef
):
    """
    Type definition for `ClientGetCampaignVersionsResponse` `CampaignsResponse`

    Provides information about the configuration and other settings for all the campaigns that are
    associated with an application.

    - **Item** *(list) --*

      An array of responses, one for each campaign that's associated with the application.

      - *(dict) --*

        Provides information about the status, configuration, and other settings for a campaign.

        - **AdditionalTreatments** *(list) --*

          An array of responses, one for each treatment that you defined for the campaign, in
          addition to the default treatment.

          - *(dict) --*

            Specifies the settings for a campaign treatment. A treatment is a variation of a
            campaign that's used for A/B testing of a campaign.

            - **Id** *(string) --*

              The unique identifier for the treatment.

            - **MessageConfiguration** *(dict) --*

              The message configuration settings for the treatment.

              - **ADMMessage** *(dict) --*

                The message that the campaign sends through the ADM (Amazon Device Messaging)
                channel. This message overrides the default message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **APNSMessage** *(dict) --*

                The message that the campaign sends through the APNs (Apple Push Notification
                service) channel. This message overrides the default message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **BaiduMessage** *(dict) --*

                The message that the campaign sends through the Baidu (Baidu Cloud Push) channel.
                This message overrides the default message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **DefaultMessage** *(dict) --*

                The default message that the campaign sends through all the channels that are
                configured for the campaign.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **EmailMessage** *(dict) --*

                The message that the campaign sends through the email channel.

                - **Body** *(string) --*

                  The body of the email for recipients whose email clients don't render HTML
                  content.

                - **FromAddress** *(string) --*

                  The verified email address to send the email from. The default address is the
                  FromAddress specified for the email channel for the application.

                - **HtmlBody** *(string) --*

                  The body of the email, in HTML format, for recipients whose email clients render
                  HTML content.

                - **Title** *(string) --*

                  The subject line, or title, of the email.

              - **GCMMessage** *(dict) --*

                The message that the campaign sends through the GCM channel, which enables Amazon
                Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
                formerly Google Cloud Messaging (GCM), service. This message overrides the default
                message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **SMSMessage** *(dict) --*

                The message that the campaign sends through the SMS channel.

                - **Body** *(string) --*

                  The body of the SMS message.

                - **MessageType** *(string) --*

                  The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical
                  or time-sensitive, such as a one-time password that supports a customer
                  transaction; and, PROMOTIONAL, the message isn't critical or time-sensitive, such
                  as a marketing message.

                - **SenderId** *(string) --*

                  The sender ID to display on recipients' devices when they receive the SMS message.

            - **Schedule** *(dict) --*

              The schedule settings for the treatment.

              - **EndTime** *(string) --*

                The scheduled time, in ISO 8601 format, when the campaign ended or will end.

              - **EventFilter** *(dict) --*

                The type of event that causes the campaign to be sent, if the value of the Frequency
                property is EVENT.

                - **Dimensions** *(dict) --*

                  The dimension settings of the event filter for the campaign.

                  - **Attributes** *(dict) --*

                    One or more custom attributes that your application reports to Amazon Pinpoint.
                    You can use these attributes as selection criteria when you create an event
                    filter.

                    - *(string) --*

                      - *(dict) --*

                        Specifies attribute-based criteria for including or excluding endpoints from
                        a segment.

                        - **AttributeType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the AttributeType property, endpoints are included or excluded
                          from the segment if their attribute values match the criteria values.

                          - *(string) --*

                  - **EventType** *(dict) --*

                    The name of the event that causes the campaign to be sent or the journey
                    activity to be performed. This can be a standard type of event that Amazon
                    Pinpoint generates, such as _email.delivered, or a custom event that's specific
                    to your application.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Metrics** *(dict) --*

                    One or more custom metrics that your application reports to Amazon Pinpoint. You
                    can use these metrics as selection criteria when you create an event filter.

                    - *(string) --*

                      - *(dict) --*

                        Specifies metric-based criteria for including or excluding endpoints from a
                        segment. These criteria derive from custom metrics that you define for
                        endpoints.

                        - **ComparisonOperator** *(string) --*

                          The operator to use when comparing metric values. Valid values are:
                          GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                          EQUAL.

                        - **Value** *(float) --*

                          The value to compare.

                - **FilterType** *(string) --*

                  The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                  sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                  when an endpoint event (Events resource) occurs.

              - **Frequency** *(string) --*

                Specifies how often the campaign is sent or whether the campaign is sent in response
                to a specific event.

              - **IsLocalTime** *(boolean) --*

                Specifies whether the start and end times for the campaign schedule use each
                recipient's local time. To base the schedule on each recipient's local time, set
                this value to true.

              - **QuietTime** *(dict) --*

                The default quiet time for the campaign. Quiet time is a specific time range when a
                campaign doesn't send messages to endpoints, if all the following conditions are
                met:

                * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

                * The current time in the endpoint's time zone is later than or equal to the time
                specified by the QuietTime.Start property for the campaign.

                * The current time in the endpoint's time zone is earlier than or equal to the time
                specified by the QuietTime.End property for the campaign.

                If any of the preceding conditions isn't met, the endpoint will receive messages
                from the campaign, even if quiet time is enabled.

                - **End** *(string) --*

                  The specific time when quiet time ends. This value has to use 24-hour notation and
                  be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and
                  MM is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to
                  represent 2:30 PM.

                - **Start** *(string) --*

                  The specific time when quiet time begins. This value has to use 24-hour notation
                  and be in HH:MM format, where HH is the hour (with a leading zero, if applicable)
                  and MM is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to
                  represent 2:30 PM.

              - **StartTime** *(string) --*

                The scheduled time, in ISO 8601 format, when the campaign began or will begin.

              - **Timezone** *(string) --*

                The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
                property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
                UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
                UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04,
                UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

            - **SizePercent** *(integer) --*

              The allocated percentage of users (segment members) that the treatment is sent to.

            - **State** *(dict) --*

              The current status of the treatment.

              - **CampaignStatus** *(string) --*

                The current status of the campaign, or the current status of a treatment that
                belongs to an A/B test campaign. If a campaign uses A/B testing, the campaign has a
                status of COMPLETED only if all campaign treatments have a status of COMPLETED.

            - **TemplateConfiguration** *(dict) --*

              The message template to use for the treatment.

              - **EmailTemplate** *(dict) --*

                The email template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

              - **PushTemplate** *(dict) --*

                The push notification template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

              - **SMSTemplate** *(dict) --*

                The SMS template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

              - **VoiceTemplate** *(dict) --*

                The voice template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

            - **TreatmentDescription** *(string) --*

              The custom description of the treatment.

            - **TreatmentName** *(string) --*

              The custom name of the treatment. A treatment is a variation of a campaign that's used
              for A/B testing of a campaign.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that the campaign applies to.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the campaign.

        - **CreationDate** *(string) --*

          The date, ISO 8601 format, when the campaign was created.

        - **DefaultState** *(dict) --*

          The current status of the campaign's default treatment. This value exists only for
          campaigns that have more than one treatment, to support A/B testing.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **Description** *(string) --*

          The custom description of the campaign.

        - **HoldoutPercent** *(integer) --*

          The allocated percentage of users (segment members) who shouldn't receive messages from
          the campaign.

        - **Hook** *(dict) --*

          The settings for the AWS Lambda function to use as a code hook for the campaign.

          - **LambdaFunctionName** *(string) --*

            The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
            invokes to send messages for a campaign.

          - **Mode** *(string) --*

            Specifies which Lambda mode to use when invoking the AWS Lambda function.

          - **WebUrl** *(string) --*

            The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

        - **Id** *(string) --*

          The unique identifier for the campaign.

        - **IsPaused** *(boolean) --*

          Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume
          it by changing this value to false.

        - **LastModifiedDate** *(string) --*

          The date, in ISO 8601 format, when the campaign was last modified.

        - **Limits** *(dict) --*

          The messaging limits for the campaign.

          - **Daily** *(integer) --*

            The maximum number of messages that a campaign can send to a single endpoint during a
            24-hour period. The maximum value is 100.

          - **MaximumDuration** *(integer) --*

            The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
            after the scheduled start time for the campaign. The minimum value is 60 seconds.

          - **MessagesPerSecond** *(integer) --*

            The maximum number of messages that a campaign can send each second. The minimum value
            is 50. The maximum value is 20,000.

          - **Total** *(integer) --*

            The maximum number of messages that a campaign can send to a single endpoint during the
            course of the campaign. The maximum value is 100.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the campaign.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Name** *(string) --*

          The name of the campaign.

        - **Schedule** *(dict) --*

          The schedule settings for the campaign.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SegmentId** *(string) --*

          The unique identifier for the segment that's associated with the campaign.

        - **SegmentVersion** *(integer) --*

          The version number of the segment that's associated with the campaign.

        - **State** *(dict) --*

          The current status of the campaign.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that identifies the tags that are associated
          with the campaign. Each tag consists of a required tag key and an associated tag value.

          - *(string) --*

            - *(string) --*

        - **TemplateConfiguration** *(dict) --*

          The message template that’s used for the campaign.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of a variation of the campaign that's used for A/B testing.

        - **TreatmentName** *(string) --*

          The custom name of a variation of the campaign that's used for A/B testing.

        - **Version** *(integer) --*

          The version number of the campaign.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetCampaignVersionsResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseTypeDef",
    {"CampaignsResponse": ClientGetCampaignVersionsResponseCampaignsResponseTypeDef},
    total=False,
)


class ClientGetCampaignVersionsResponseTypeDef(_ClientGetCampaignVersionsResponseTypeDef):
    """
    Type definition for `ClientGetCampaignVersions` `Response`

    The request succeeded.

    - **CampaignsResponse** *(dict) --*

      Provides information about the configuration and other settings for all the campaigns that are
      associated with an application.

      - **Item** *(list) --*

        An array of responses, one for each campaign that's associated with the application.

        - *(dict) --*

          Provides information about the status, configuration, and other settings for a campaign.

          - **AdditionalTreatments** *(list) --*

            An array of responses, one for each treatment that you defined for the campaign, in
            addition to the default treatment.

            - *(dict) --*

              Specifies the settings for a campaign treatment. A treatment is a variation of a
              campaign that's used for A/B testing of a campaign.

              - **Id** *(string) --*

                The unique identifier for the treatment.

              - **MessageConfiguration** *(dict) --*

                The message configuration settings for the treatment.

                - **ADMMessage** *(dict) --*

                  The message that the campaign sends through the ADM (Amazon Device Messaging)
                  channel. This message overrides the default message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **APNSMessage** *(dict) --*

                  The message that the campaign sends through the APNs (Apple Push Notification
                  service) channel. This message overrides the default message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **BaiduMessage** *(dict) --*

                  The message that the campaign sends through the Baidu (Baidu Cloud Push) channel.
                  This message overrides the default message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **DefaultMessage** *(dict) --*

                  The default message that the campaign sends through all the channels that are
                  configured for the campaign.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **EmailMessage** *(dict) --*

                  The message that the campaign sends through the email channel.

                  - **Body** *(string) --*

                    The body of the email for recipients whose email clients don't render HTML
                    content.

                  - **FromAddress** *(string) --*

                    The verified email address to send the email from. The default address is the
                    FromAddress specified for the email channel for the application.

                  - **HtmlBody** *(string) --*

                    The body of the email, in HTML format, for recipients whose email clients render
                    HTML content.

                  - **Title** *(string) --*

                    The subject line, or title, of the email.

                - **GCMMessage** *(dict) --*

                  The message that the campaign sends through the GCM channel, which enables Amazon
                  Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
                  formerly Google Cloud Messaging (GCM), service. This message overrides the default
                  message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **SMSMessage** *(dict) --*

                  The message that the campaign sends through the SMS channel.

                  - **Body** *(string) --*

                    The body of the SMS message.

                  - **MessageType** *(string) --*

                    The type of SMS message. Valid values are: TRANSACTIONAL, the message is
                    critical or time-sensitive, such as a one-time password that supports a customer
                    transaction; and, PROMOTIONAL, the message isn't critical or time-sensitive,
                    such as a marketing message.

                  - **SenderId** *(string) --*

                    The sender ID to display on recipients' devices when they receive the SMS
                    message.

              - **Schedule** *(dict) --*

                The schedule settings for the treatment.

                - **EndTime** *(string) --*

                  The scheduled time, in ISO 8601 format, when the campaign ended or will end.

                - **EventFilter** *(dict) --*

                  The type of event that causes the campaign to be sent, if the value of the
                  Frequency property is EVENT.

                  - **Dimensions** *(dict) --*

                    The dimension settings of the event filter for the campaign.

                    - **Attributes** *(dict) --*

                      One or more custom attributes that your application reports to Amazon
                      Pinpoint. You can use these attributes as selection criteria when you create
                      an event filter.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **EventType** *(dict) --*

                      The name of the event that causes the campaign to be sent or the journey
                      activity to be performed. This can be a standard type of event that Amazon
                      Pinpoint generates, such as _email.delivered, or a custom event that's
                      specific to your application.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Metrics** *(dict) --*

                      One or more custom metrics that your application reports to Amazon Pinpoint.
                      You can use these metrics as selection criteria when you create an event
                      filter.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                  - **FilterType** *(string) --*

                    The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                    sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                    when an endpoint event (Events resource) occurs.

                - **Frequency** *(string) --*

                  Specifies how often the campaign is sent or whether the campaign is sent in
                  response to a specific event.

                - **IsLocalTime** *(boolean) --*

                  Specifies whether the start and end times for the campaign schedule use each
                  recipient's local time. To base the schedule on each recipient's local time, set
                  this value to true.

                - **QuietTime** *(dict) --*

                  The default quiet time for the campaign. Quiet time is a specific time range when
                  a campaign doesn't send messages to endpoints, if all the following conditions are
                  met:

                  * The EndpointDemographic.Timezone property of the endpoint is set to a valid
                  value.

                  * The current time in the endpoint's time zone is later than or equal to the time
                  specified by the QuietTime.Start property for the campaign.

                  * The current time in the endpoint's time zone is earlier than or equal to the
                  time specified by the QuietTime.End property for the campaign.

                  If any of the preceding conditions isn't met, the endpoint will receive messages
                  from the campaign, even if quiet time is enabled.

                  - **End** *(string) --*

                    The specific time when quiet time ends. This value has to use 24-hour notation
                    and be in HH:MM format, where HH is the hour (with a leading zero, if
                    applicable) and MM is the minutes. For example, use 02:30 to represent 2:30 AM,
                    or 14:30 to represent 2:30 PM.

                  - **Start** *(string) --*

                    The specific time when quiet time begins. This value has to use 24-hour notation
                    and be in HH:MM format, where HH is the hour (with a leading zero, if
                    applicable) and MM is the minutes. For example, use 02:30 to represent 2:30 AM,
                    or 14:30 to represent 2:30 PM.

                - **StartTime** *(string) --*

                  The scheduled time, in ISO 8601 format, when the campaign began or will begin.

                - **Timezone** *(string) --*

                  The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
                  property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30,
                  UTC+04, UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07,
                  UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02,
                  UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

              - **SizePercent** *(integer) --*

                The allocated percentage of users (segment members) that the treatment is sent to.

              - **State** *(dict) --*

                The current status of the treatment.

                - **CampaignStatus** *(string) --*

                  The current status of the campaign, or the current status of a treatment that
                  belongs to an A/B test campaign. If a campaign uses A/B testing, the campaign has
                  a status of COMPLETED only if all campaign treatments have a status of COMPLETED.

              - **TemplateConfiguration** *(dict) --*

                The message template to use for the treatment.

                - **EmailTemplate** *(dict) --*

                  The email template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

                - **PushTemplate** *(dict) --*

                  The push notification template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

                - **SMSTemplate** *(dict) --*

                  The SMS template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

                - **VoiceTemplate** *(dict) --*

                  The voice template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

              - **TreatmentDescription** *(string) --*

                The custom description of the treatment.

              - **TreatmentName** *(string) --*

                The custom name of the treatment. A treatment is a variation of a campaign that's
                used for A/B testing of a campaign.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that the campaign applies to.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the campaign.

          - **CreationDate** *(string) --*

            The date, ISO 8601 format, when the campaign was created.

          - **DefaultState** *(dict) --*

            The current status of the campaign's default treatment. This value exists only for
            campaigns that have more than one treatment, to support A/B testing.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **Description** *(string) --*

            The custom description of the campaign.

          - **HoldoutPercent** *(integer) --*

            The allocated percentage of users (segment members) who shouldn't receive messages from
            the campaign.

          - **Hook** *(dict) --*

            The settings for the AWS Lambda function to use as a code hook for the campaign.

            - **LambdaFunctionName** *(string) --*

              The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
              invokes to send messages for a campaign.

            - **Mode** *(string) --*

              Specifies which Lambda mode to use when invoking the AWS Lambda function.

            - **WebUrl** *(string) --*

              The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

          - **Id** *(string) --*

            The unique identifier for the campaign.

          - **IsPaused** *(boolean) --*

            Specifies whether the campaign is paused. A paused campaign doesn't run unless you
            resume it by changing this value to false.

          - **LastModifiedDate** *(string) --*

            The date, in ISO 8601 format, when the campaign was last modified.

          - **Limits** *(dict) --*

            The messaging limits for the campaign.

            - **Daily** *(integer) --*

              The maximum number of messages that a campaign can send to a single endpoint during a
              24-hour period. The maximum value is 100.

            - **MaximumDuration** *(integer) --*

              The maximum amount of time, in seconds, that a campaign can attempt to deliver a
              message after the scheduled start time for the campaign. The minimum value is 60
              seconds.

            - **MessagesPerSecond** *(integer) --*

              The maximum number of messages that a campaign can send each second. The minimum value
              is 50. The maximum value is 20,000.

            - **Total** *(integer) --*

              The maximum number of messages that a campaign can send to a single endpoint during
              the course of the campaign. The maximum value is 100.

          - **MessageConfiguration** *(dict) --*

            The message configuration settings for the campaign.

            - **ADMMessage** *(dict) --*

              The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
              This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **APNSMessage** *(dict) --*

              The message that the campaign sends through the APNs (Apple Push Notification service)
              channel. This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **BaiduMessage** *(dict) --*

              The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
              message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **DefaultMessage** *(dict) --*

              The default message that the campaign sends through all the channels that are
              configured for the campaign.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **EmailMessage** *(dict) --*

              The message that the campaign sends through the email channel.

              - **Body** *(string) --*

                The body of the email for recipients whose email clients don't render HTML content.

              - **FromAddress** *(string) --*

                The verified email address to send the email from. The default address is the
                FromAddress specified for the email channel for the application.

              - **HtmlBody** *(string) --*

                The body of the email, in HTML format, for recipients whose email clients render
                HTML content.

              - **Title** *(string) --*

                The subject line, or title, of the email.

            - **GCMMessage** *(dict) --*

              The message that the campaign sends through the GCM channel, which enables Amazon
              Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
              formerly Google Cloud Messaging (GCM), service. This message overrides the default
              message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **SMSMessage** *(dict) --*

              The message that the campaign sends through the SMS channel.

              - **Body** *(string) --*

                The body of the SMS message.

              - **MessageType** *(string) --*

                The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
                time-sensitive, such as a one-time password that supports a customer transaction;
                and, PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
                message.

              - **SenderId** *(string) --*

                The sender ID to display on recipients' devices when they receive the SMS message.

          - **Name** *(string) --*

            The name of the campaign.

          - **Schedule** *(dict) --*

            The schedule settings for the campaign.

            - **EndTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign ended or will end.

            - **EventFilter** *(dict) --*

              The type of event that causes the campaign to be sent, if the value of the Frequency
              property is EVENT.

              - **Dimensions** *(dict) --*

                The dimension settings of the event filter for the campaign.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **FilterType** *(string) --*

                The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                when an endpoint event (Events resource) occurs.

            - **Frequency** *(string) --*

              Specifies how often the campaign is sent or whether the campaign is sent in response
              to a specific event.

            - **IsLocalTime** *(boolean) --*

              Specifies whether the start and end times for the campaign schedule use each
              recipient's local time. To base the schedule on each recipient's local time, set this
              value to true.

            - **QuietTime** *(dict) --*

              The default quiet time for the campaign. Quiet time is a specific time range when a
              campaign doesn't send messages to endpoints, if all the following conditions are met:

              * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

              * The current time in the endpoint's time zone is later than or equal to the time
              specified by the QuietTime.Start property for the campaign.

              * The current time in the endpoint's time zone is earlier than or equal to the time
              specified by the QuietTime.End property for the campaign.

              If any of the preceding conditions isn't met, the endpoint will receive messages from
              the campaign, even if quiet time is enabled.

              - **End** *(string) --*

                The specific time when quiet time ends. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

              - **Start** *(string) --*

                The specific time when quiet time begins. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

            - **StartTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
              property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
              UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
              UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
              UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

          - **SegmentId** *(string) --*

            The unique identifier for the segment that's associated with the campaign.

          - **SegmentVersion** *(integer) --*

            The version number of the segment that's associated with the campaign.

          - **State** *(dict) --*

            The current status of the campaign.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **tags** *(dict) --*

            A string-to-string map of key-value pairs that identifies the tags that are associated
            with the campaign. Each tag consists of a required tag key and an associated tag value.

            - *(string) --*

              - *(string) --*

          - **TemplateConfiguration** *(dict) --*

            The message template that’s used for the campaign.

            - **EmailTemplate** *(dict) --*

              The email template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **PushTemplate** *(dict) --*

              The push notification template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **SMSTemplate** *(dict) --*

              The SMS template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **VoiceTemplate** *(dict) --*

              The voice template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

          - **TreatmentDescription** *(string) --*

            The custom description of a variation of the campaign that's used for A/B testing.

          - **TreatmentName** *(string) --*

            The custom name of a variation of the campaign that's used for A/B testing.

          - **Version** *(integer) --*

            The version number of the campaign.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatments`
    `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatments`
    `State`

    The current status of the treatment.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **Id** *(string) --*

      The unique identifier for the treatment.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --*

      The allocated percentage of users (segment members) that the treatment is sent to.

    - **State** *(dict) --*

      The current status of the treatment.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `DefaultState`

    The current status of the campaign's default treatment. This value exists only for campaigns
    that have more than one treatment, to support A/B testing.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensions` `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `State`

    The current status of the campaign.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItemTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponseItem` `TemplateConfiguration`

    The message template that’s used for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientGetCampaignsResponseCampaignsResponseItemTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponseCampaignsResponse` `Item`

    Provides information about the status, configuration, and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of responses, one for each treatment that you defined for the campaign, in addition
      to the default treatment.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **Id** *(string) --*

          The unique identifier for the treatment.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --*

          The allocated percentage of users (segment members) that the treatment is sent to.

        - **State** *(dict) --*

          The current status of the treatment.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the campaign.

    - **CreationDate** *(string) --*

      The date, ISO 8601 format, when the campaign was created.

    - **DefaultState** *(dict) --*

      The current status of the campaign's default treatment. This value exists only for campaigns
      that have more than one treatment, to support A/B testing.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **Description** *(string) --*

      The custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **Id** *(string) --*

      The unique identifier for the campaign.

    - **IsPaused** *(boolean) --*

      Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
      by changing this value to false.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the campaign was last modified.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment that's associated with the campaign.

    - **SegmentVersion** *(integer) --*

      The version number of the segment that's associated with the campaign.

    - **State** *(dict) --*

      The current status of the campaign.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template that’s used for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of a variation of the campaign that's used for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign that's used for A/B testing.

    - **Version** *(integer) --*

      The version number of the campaign.
    """


_ClientGetCampaignsResponseCampaignsResponseTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseTypeDef",
    {"Item": List[ClientGetCampaignsResponseCampaignsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseTypeDef
):
    """
    Type definition for `ClientGetCampaignsResponse` `CampaignsResponse`

    Provides information about the configuration and other settings for all the campaigns that are
    associated with an application.

    - **Item** *(list) --*

      An array of responses, one for each campaign that's associated with the application.

      - *(dict) --*

        Provides information about the status, configuration, and other settings for a campaign.

        - **AdditionalTreatments** *(list) --*

          An array of responses, one for each treatment that you defined for the campaign, in
          addition to the default treatment.

          - *(dict) --*

            Specifies the settings for a campaign treatment. A treatment is a variation of a
            campaign that's used for A/B testing of a campaign.

            - **Id** *(string) --*

              The unique identifier for the treatment.

            - **MessageConfiguration** *(dict) --*

              The message configuration settings for the treatment.

              - **ADMMessage** *(dict) --*

                The message that the campaign sends through the ADM (Amazon Device Messaging)
                channel. This message overrides the default message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **APNSMessage** *(dict) --*

                The message that the campaign sends through the APNs (Apple Push Notification
                service) channel. This message overrides the default message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **BaiduMessage** *(dict) --*

                The message that the campaign sends through the Baidu (Baidu Cloud Push) channel.
                This message overrides the default message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **DefaultMessage** *(dict) --*

                The default message that the campaign sends through all the channels that are
                configured for the campaign.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **EmailMessage** *(dict) --*

                The message that the campaign sends through the email channel.

                - **Body** *(string) --*

                  The body of the email for recipients whose email clients don't render HTML
                  content.

                - **FromAddress** *(string) --*

                  The verified email address to send the email from. The default address is the
                  FromAddress specified for the email channel for the application.

                - **HtmlBody** *(string) --*

                  The body of the email, in HTML format, for recipients whose email clients render
                  HTML content.

                - **Title** *(string) --*

                  The subject line, or title, of the email.

              - **GCMMessage** *(dict) --*

                The message that the campaign sends through the GCM channel, which enables Amazon
                Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
                formerly Google Cloud Messaging (GCM), service. This message overrides the default
                message.

                - **Action** *(string) --*

                  The action to occur if a recipient taps the push notification. Valid values are:

                  * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                  background. This is the default action.

                  * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                  This setting uses the deep-linking features of iOS and Android.

                  * URL - The default mobile browser on the recipient's device opens and loads the
                  web page at a URL that you specify.

                - **Body** *(string) --*

                  The body of the notification message. The maximum number of characters is 200.

                - **ImageIconUrl** *(string) --*

                  The URL of the image to display as the push-notification icon, such as the icon
                  for the app.

                - **ImageSmallIconUrl** *(string) --*

                  The URL of the image to display as the small, push-notification icon, such as a
                  small version of the icon for the app.

                - **ImageUrl** *(string) --*

                  The URL of an image to display in the push notification.

                - **JsonBody** *(string) --*

                  The JSON payload to use for a silent push notification.

                - **MediaUrl** *(string) --*

                  The URL of the image or video to display in the push notification.

                - **RawContent** *(string) --*

                  The raw, JSON-formatted string to use as the payload for the notification message.
                  If specified, this value overrides all other content for the message.

                - **SilentPush** *(boolean) --*

                  Specifies whether the notification is a silent push notification, which is a push
                  notification that doesn't display on a recipient's device. Silent push
                  notifications can be used for cases such as updating an app's configuration,
                  displaying messages in an in-app message center, or supporting phone home
                  functionality.

                - **TimeToLive** *(integer) --*

                  The number of seconds that the push-notification service should keep the message,
                  if the service is unable to deliver the notification the first time. This value is
                  converted to an expiration value when it's sent to a push-notification service. If
                  this value is 0, the service treats the notification as if it expires immediately
                  and the service doesn't store or try to deliver the notification again.

                  This value doesn't apply to messages that are sent through the Amazon Device
                  Messaging (ADM) service.

                - **Title** *(string) --*

                  The title to display above the notification message on a recipient's device.

                - **Url** *(string) --*

                  The URL to open in a recipient's default mobile browser, if a recipient taps the
                  push notification and the value of the Action property is URL.

              - **SMSMessage** *(dict) --*

                The message that the campaign sends through the SMS channel.

                - **Body** *(string) --*

                  The body of the SMS message.

                - **MessageType** *(string) --*

                  The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical
                  or time-sensitive, such as a one-time password that supports a customer
                  transaction; and, PROMOTIONAL, the message isn't critical or time-sensitive, such
                  as a marketing message.

                - **SenderId** *(string) --*

                  The sender ID to display on recipients' devices when they receive the SMS message.

            - **Schedule** *(dict) --*

              The schedule settings for the treatment.

              - **EndTime** *(string) --*

                The scheduled time, in ISO 8601 format, when the campaign ended or will end.

              - **EventFilter** *(dict) --*

                The type of event that causes the campaign to be sent, if the value of the Frequency
                property is EVENT.

                - **Dimensions** *(dict) --*

                  The dimension settings of the event filter for the campaign.

                  - **Attributes** *(dict) --*

                    One or more custom attributes that your application reports to Amazon Pinpoint.
                    You can use these attributes as selection criteria when you create an event
                    filter.

                    - *(string) --*

                      - *(dict) --*

                        Specifies attribute-based criteria for including or excluding endpoints from
                        a segment.

                        - **AttributeType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the AttributeType property, endpoints are included or excluded
                          from the segment if their attribute values match the criteria values.

                          - *(string) --*

                  - **EventType** *(dict) --*

                    The name of the event that causes the campaign to be sent or the journey
                    activity to be performed. This can be a standard type of event that Amazon
                    Pinpoint generates, such as _email.delivered, or a custom event that's specific
                    to your application.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Metrics** *(dict) --*

                    One or more custom metrics that your application reports to Amazon Pinpoint. You
                    can use these metrics as selection criteria when you create an event filter.

                    - *(string) --*

                      - *(dict) --*

                        Specifies metric-based criteria for including or excluding endpoints from a
                        segment. These criteria derive from custom metrics that you define for
                        endpoints.

                        - **ComparisonOperator** *(string) --*

                          The operator to use when comparing metric values. Valid values are:
                          GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                          EQUAL.

                        - **Value** *(float) --*

                          The value to compare.

                - **FilterType** *(string) --*

                  The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                  sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                  when an endpoint event (Events resource) occurs.

              - **Frequency** *(string) --*

                Specifies how often the campaign is sent or whether the campaign is sent in response
                to a specific event.

              - **IsLocalTime** *(boolean) --*

                Specifies whether the start and end times for the campaign schedule use each
                recipient's local time. To base the schedule on each recipient's local time, set
                this value to true.

              - **QuietTime** *(dict) --*

                The default quiet time for the campaign. Quiet time is a specific time range when a
                campaign doesn't send messages to endpoints, if all the following conditions are
                met:

                * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

                * The current time in the endpoint's time zone is later than or equal to the time
                specified by the QuietTime.Start property for the campaign.

                * The current time in the endpoint's time zone is earlier than or equal to the time
                specified by the QuietTime.End property for the campaign.

                If any of the preceding conditions isn't met, the endpoint will receive messages
                from the campaign, even if quiet time is enabled.

                - **End** *(string) --*

                  The specific time when quiet time ends. This value has to use 24-hour notation and
                  be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and
                  MM is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to
                  represent 2:30 PM.

                - **Start** *(string) --*

                  The specific time when quiet time begins. This value has to use 24-hour notation
                  and be in HH:MM format, where HH is the hour (with a leading zero, if applicable)
                  and MM is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to
                  represent 2:30 PM.

              - **StartTime** *(string) --*

                The scheduled time, in ISO 8601 format, when the campaign began or will begin.

              - **Timezone** *(string) --*

                The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
                property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
                UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
                UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04,
                UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

            - **SizePercent** *(integer) --*

              The allocated percentage of users (segment members) that the treatment is sent to.

            - **State** *(dict) --*

              The current status of the treatment.

              - **CampaignStatus** *(string) --*

                The current status of the campaign, or the current status of a treatment that
                belongs to an A/B test campaign. If a campaign uses A/B testing, the campaign has a
                status of COMPLETED only if all campaign treatments have a status of COMPLETED.

            - **TemplateConfiguration** *(dict) --*

              The message template to use for the treatment.

              - **EmailTemplate** *(dict) --*

                The email template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

              - **PushTemplate** *(dict) --*

                The push notification template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

              - **SMSTemplate** *(dict) --*

                The SMS template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

              - **VoiceTemplate** *(dict) --*

                The voice template to use for the message.

                - **Name** *(string) --*

                  The name of the message template to use for the message. If specified, this value
                  must match the name of an existing message template.

            - **TreatmentDescription** *(string) --*

              The custom description of the treatment.

            - **TreatmentName** *(string) --*

              The custom name of the treatment. A treatment is a variation of a campaign that's used
              for A/B testing of a campaign.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that the campaign applies to.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the campaign.

        - **CreationDate** *(string) --*

          The date, ISO 8601 format, when the campaign was created.

        - **DefaultState** *(dict) --*

          The current status of the campaign's default treatment. This value exists only for
          campaigns that have more than one treatment, to support A/B testing.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **Description** *(string) --*

          The custom description of the campaign.

        - **HoldoutPercent** *(integer) --*

          The allocated percentage of users (segment members) who shouldn't receive messages from
          the campaign.

        - **Hook** *(dict) --*

          The settings for the AWS Lambda function to use as a code hook for the campaign.

          - **LambdaFunctionName** *(string) --*

            The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
            invokes to send messages for a campaign.

          - **Mode** *(string) --*

            Specifies which Lambda mode to use when invoking the AWS Lambda function.

          - **WebUrl** *(string) --*

            The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

        - **Id** *(string) --*

          The unique identifier for the campaign.

        - **IsPaused** *(boolean) --*

          Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume
          it by changing this value to false.

        - **LastModifiedDate** *(string) --*

          The date, in ISO 8601 format, when the campaign was last modified.

        - **Limits** *(dict) --*

          The messaging limits for the campaign.

          - **Daily** *(integer) --*

            The maximum number of messages that a campaign can send to a single endpoint during a
            24-hour period. The maximum value is 100.

          - **MaximumDuration** *(integer) --*

            The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
            after the scheduled start time for the campaign. The minimum value is 60 seconds.

          - **MessagesPerSecond** *(integer) --*

            The maximum number of messages that a campaign can send each second. The minimum value
            is 50. The maximum value is 20,000.

          - **Total** *(integer) --*

            The maximum number of messages that a campaign can send to a single endpoint during the
            course of the campaign. The maximum value is 100.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the campaign.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Name** *(string) --*

          The name of the campaign.

        - **Schedule** *(dict) --*

          The schedule settings for the campaign.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SegmentId** *(string) --*

          The unique identifier for the segment that's associated with the campaign.

        - **SegmentVersion** *(integer) --*

          The version number of the segment that's associated with the campaign.

        - **State** *(dict) --*

          The current status of the campaign.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that identifies the tags that are associated
          with the campaign. Each tag consists of a required tag key and an associated tag value.

          - *(string) --*

            - *(string) --*

        - **TemplateConfiguration** *(dict) --*

          The message template that’s used for the campaign.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of a variation of the campaign that's used for A/B testing.

        - **TreatmentName** *(string) --*

          The custom name of a variation of the campaign that's used for A/B testing.

        - **Version** *(integer) --*

          The version number of the campaign.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetCampaignsResponseTypeDef = TypedDict(
    "_ClientGetCampaignsResponseTypeDef",
    {"CampaignsResponse": ClientGetCampaignsResponseCampaignsResponseTypeDef},
    total=False,
)


class ClientGetCampaignsResponseTypeDef(_ClientGetCampaignsResponseTypeDef):
    """
    Type definition for `ClientGetCampaigns` `Response`

    The request succeeded.

    - **CampaignsResponse** *(dict) --*

      Provides information about the configuration and other settings for all the campaigns that are
      associated with an application.

      - **Item** *(list) --*

        An array of responses, one for each campaign that's associated with the application.

        - *(dict) --*

          Provides information about the status, configuration, and other settings for a campaign.

          - **AdditionalTreatments** *(list) --*

            An array of responses, one for each treatment that you defined for the campaign, in
            addition to the default treatment.

            - *(dict) --*

              Specifies the settings for a campaign treatment. A treatment is a variation of a
              campaign that's used for A/B testing of a campaign.

              - **Id** *(string) --*

                The unique identifier for the treatment.

              - **MessageConfiguration** *(dict) --*

                The message configuration settings for the treatment.

                - **ADMMessage** *(dict) --*

                  The message that the campaign sends through the ADM (Amazon Device Messaging)
                  channel. This message overrides the default message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **APNSMessage** *(dict) --*

                  The message that the campaign sends through the APNs (Apple Push Notification
                  service) channel. This message overrides the default message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **BaiduMessage** *(dict) --*

                  The message that the campaign sends through the Baidu (Baidu Cloud Push) channel.
                  This message overrides the default message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **DefaultMessage** *(dict) --*

                  The default message that the campaign sends through all the channels that are
                  configured for the campaign.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **EmailMessage** *(dict) --*

                  The message that the campaign sends through the email channel.

                  - **Body** *(string) --*

                    The body of the email for recipients whose email clients don't render HTML
                    content.

                  - **FromAddress** *(string) --*

                    The verified email address to send the email from. The default address is the
                    FromAddress specified for the email channel for the application.

                  - **HtmlBody** *(string) --*

                    The body of the email, in HTML format, for recipients whose email clients render
                    HTML content.

                  - **Title** *(string) --*

                    The subject line, or title, of the email.

                - **GCMMessage** *(dict) --*

                  The message that the campaign sends through the GCM channel, which enables Amazon
                  Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
                  formerly Google Cloud Messaging (GCM), service. This message overrides the default
                  message.

                  - **Action** *(string) --*

                    The action to occur if a recipient taps the push notification. Valid values are:

                    * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to
                    the background. This is the default action.

                    * DEEP_LINK - Your app opens and displays a designated user interface in the
                    app. This setting uses the deep-linking features of iOS and Android.

                    * URL - The default mobile browser on the recipient's device opens and loads the
                    web page at a URL that you specify.

                  - **Body** *(string) --*

                    The body of the notification message. The maximum number of characters is 200.

                  - **ImageIconUrl** *(string) --*

                    The URL of the image to display as the push-notification icon, such as the icon
                    for the app.

                  - **ImageSmallIconUrl** *(string) --*

                    The URL of the image to display as the small, push-notification icon, such as a
                    small version of the icon for the app.

                  - **ImageUrl** *(string) --*

                    The URL of an image to display in the push notification.

                  - **JsonBody** *(string) --*

                    The JSON payload to use for a silent push notification.

                  - **MediaUrl** *(string) --*

                    The URL of the image or video to display in the push notification.

                  - **RawContent** *(string) --*

                    The raw, JSON-formatted string to use as the payload for the notification
                    message. If specified, this value overrides all other content for the message.

                  - **SilentPush** *(boolean) --*

                    Specifies whether the notification is a silent push notification, which is a
                    push notification that doesn't display on a recipient's device. Silent push
                    notifications can be used for cases such as updating an app's configuration,
                    displaying messages in an in-app message center, or supporting phone home
                    functionality.

                  - **TimeToLive** *(integer) --*

                    The number of seconds that the push-notification service should keep the
                    message, if the service is unable to deliver the notification the first time.
                    This value is converted to an expiration value when it's sent to a
                    push-notification service. If this value is 0, the service treats the
                    notification as if it expires immediately and the service doesn't store or try
                    to deliver the notification again.

                    This value doesn't apply to messages that are sent through the Amazon Device
                    Messaging (ADM) service.

                  - **Title** *(string) --*

                    The title to display above the notification message on a recipient's device.

                  - **Url** *(string) --*

                    The URL to open in a recipient's default mobile browser, if a recipient taps the
                    push notification and the value of the Action property is URL.

                - **SMSMessage** *(dict) --*

                  The message that the campaign sends through the SMS channel.

                  - **Body** *(string) --*

                    The body of the SMS message.

                  - **MessageType** *(string) --*

                    The type of SMS message. Valid values are: TRANSACTIONAL, the message is
                    critical or time-sensitive, such as a one-time password that supports a customer
                    transaction; and, PROMOTIONAL, the message isn't critical or time-sensitive,
                    such as a marketing message.

                  - **SenderId** *(string) --*

                    The sender ID to display on recipients' devices when they receive the SMS
                    message.

              - **Schedule** *(dict) --*

                The schedule settings for the treatment.

                - **EndTime** *(string) --*

                  The scheduled time, in ISO 8601 format, when the campaign ended or will end.

                - **EventFilter** *(dict) --*

                  The type of event that causes the campaign to be sent, if the value of the
                  Frequency property is EVENT.

                  - **Dimensions** *(dict) --*

                    The dimension settings of the event filter for the campaign.

                    - **Attributes** *(dict) --*

                      One or more custom attributes that your application reports to Amazon
                      Pinpoint. You can use these attributes as selection criteria when you create
                      an event filter.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **EventType** *(dict) --*

                      The name of the event that causes the campaign to be sent or the journey
                      activity to be performed. This can be a standard type of event that Amazon
                      Pinpoint generates, such as _email.delivered, or a custom event that's
                      specific to your application.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Metrics** *(dict) --*

                      One or more custom metrics that your application reports to Amazon Pinpoint.
                      You can use these metrics as selection criteria when you create an event
                      filter.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                  - **FilterType** *(string) --*

                    The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                    sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                    when an endpoint event (Events resource) occurs.

                - **Frequency** *(string) --*

                  Specifies how often the campaign is sent or whether the campaign is sent in
                  response to a specific event.

                - **IsLocalTime** *(boolean) --*

                  Specifies whether the start and end times for the campaign schedule use each
                  recipient's local time. To base the schedule on each recipient's local time, set
                  this value to true.

                - **QuietTime** *(dict) --*

                  The default quiet time for the campaign. Quiet time is a specific time range when
                  a campaign doesn't send messages to endpoints, if all the following conditions are
                  met:

                  * The EndpointDemographic.Timezone property of the endpoint is set to a valid
                  value.

                  * The current time in the endpoint's time zone is later than or equal to the time
                  specified by the QuietTime.Start property for the campaign.

                  * The current time in the endpoint's time zone is earlier than or equal to the
                  time specified by the QuietTime.End property for the campaign.

                  If any of the preceding conditions isn't met, the endpoint will receive messages
                  from the campaign, even if quiet time is enabled.

                  - **End** *(string) --*

                    The specific time when quiet time ends. This value has to use 24-hour notation
                    and be in HH:MM format, where HH is the hour (with a leading zero, if
                    applicable) and MM is the minutes. For example, use 02:30 to represent 2:30 AM,
                    or 14:30 to represent 2:30 PM.

                  - **Start** *(string) --*

                    The specific time when quiet time begins. This value has to use 24-hour notation
                    and be in HH:MM format, where HH is the hour (with a leading zero, if
                    applicable) and MM is the minutes. For example, use 02:30 to represent 2:30 AM,
                    or 14:30 to represent 2:30 PM.

                - **StartTime** *(string) --*

                  The scheduled time, in ISO 8601 format, when the campaign began or will begin.

                - **Timezone** *(string) --*

                  The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
                  property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30,
                  UTC+04, UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07,
                  UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02,
                  UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

              - **SizePercent** *(integer) --*

                The allocated percentage of users (segment members) that the treatment is sent to.

              - **State** *(dict) --*

                The current status of the treatment.

                - **CampaignStatus** *(string) --*

                  The current status of the campaign, or the current status of a treatment that
                  belongs to an A/B test campaign. If a campaign uses A/B testing, the campaign has
                  a status of COMPLETED only if all campaign treatments have a status of COMPLETED.

              - **TemplateConfiguration** *(dict) --*

                The message template to use for the treatment.

                - **EmailTemplate** *(dict) --*

                  The email template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

                - **PushTemplate** *(dict) --*

                  The push notification template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

                - **SMSTemplate** *(dict) --*

                  The SMS template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

                - **VoiceTemplate** *(dict) --*

                  The voice template to use for the message.

                  - **Name** *(string) --*

                    The name of the message template to use for the message. If specified, this
                    value must match the name of an existing message template.

              - **TreatmentDescription** *(string) --*

                The custom description of the treatment.

              - **TreatmentName** *(string) --*

                The custom name of the treatment. A treatment is a variation of a campaign that's
                used for A/B testing of a campaign.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that the campaign applies to.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the campaign.

          - **CreationDate** *(string) --*

            The date, ISO 8601 format, when the campaign was created.

          - **DefaultState** *(dict) --*

            The current status of the campaign's default treatment. This value exists only for
            campaigns that have more than one treatment, to support A/B testing.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **Description** *(string) --*

            The custom description of the campaign.

          - **HoldoutPercent** *(integer) --*

            The allocated percentage of users (segment members) who shouldn't receive messages from
            the campaign.

          - **Hook** *(dict) --*

            The settings for the AWS Lambda function to use as a code hook for the campaign.

            - **LambdaFunctionName** *(string) --*

              The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
              invokes to send messages for a campaign.

            - **Mode** *(string) --*

              Specifies which Lambda mode to use when invoking the AWS Lambda function.

            - **WebUrl** *(string) --*

              The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

          - **Id** *(string) --*

            The unique identifier for the campaign.

          - **IsPaused** *(boolean) --*

            Specifies whether the campaign is paused. A paused campaign doesn't run unless you
            resume it by changing this value to false.

          - **LastModifiedDate** *(string) --*

            The date, in ISO 8601 format, when the campaign was last modified.

          - **Limits** *(dict) --*

            The messaging limits for the campaign.

            - **Daily** *(integer) --*

              The maximum number of messages that a campaign can send to a single endpoint during a
              24-hour period. The maximum value is 100.

            - **MaximumDuration** *(integer) --*

              The maximum amount of time, in seconds, that a campaign can attempt to deliver a
              message after the scheduled start time for the campaign. The minimum value is 60
              seconds.

            - **MessagesPerSecond** *(integer) --*

              The maximum number of messages that a campaign can send each second. The minimum value
              is 50. The maximum value is 20,000.

            - **Total** *(integer) --*

              The maximum number of messages that a campaign can send to a single endpoint during
              the course of the campaign. The maximum value is 100.

          - **MessageConfiguration** *(dict) --*

            The message configuration settings for the campaign.

            - **ADMMessage** *(dict) --*

              The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
              This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **APNSMessage** *(dict) --*

              The message that the campaign sends through the APNs (Apple Push Notification service)
              channel. This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **BaiduMessage** *(dict) --*

              The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
              message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **DefaultMessage** *(dict) --*

              The default message that the campaign sends through all the channels that are
              configured for the campaign.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **EmailMessage** *(dict) --*

              The message that the campaign sends through the email channel.

              - **Body** *(string) --*

                The body of the email for recipients whose email clients don't render HTML content.

              - **FromAddress** *(string) --*

                The verified email address to send the email from. The default address is the
                FromAddress specified for the email channel for the application.

              - **HtmlBody** *(string) --*

                The body of the email, in HTML format, for recipients whose email clients render
                HTML content.

              - **Title** *(string) --*

                The subject line, or title, of the email.

            - **GCMMessage** *(dict) --*

              The message that the campaign sends through the GCM channel, which enables Amazon
              Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
              formerly Google Cloud Messaging (GCM), service. This message overrides the default
              message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **SMSMessage** *(dict) --*

              The message that the campaign sends through the SMS channel.

              - **Body** *(string) --*

                The body of the SMS message.

              - **MessageType** *(string) --*

                The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
                time-sensitive, such as a one-time password that supports a customer transaction;
                and, PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
                message.

              - **SenderId** *(string) --*

                The sender ID to display on recipients' devices when they receive the SMS message.

          - **Name** *(string) --*

            The name of the campaign.

          - **Schedule** *(dict) --*

            The schedule settings for the campaign.

            - **EndTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign ended or will end.

            - **EventFilter** *(dict) --*

              The type of event that causes the campaign to be sent, if the value of the Frequency
              property is EVENT.

              - **Dimensions** *(dict) --*

                The dimension settings of the event filter for the campaign.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **FilterType** *(string) --*

                The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                when an endpoint event (Events resource) occurs.

            - **Frequency** *(string) --*

              Specifies how often the campaign is sent or whether the campaign is sent in response
              to a specific event.

            - **IsLocalTime** *(boolean) --*

              Specifies whether the start and end times for the campaign schedule use each
              recipient's local time. To base the schedule on each recipient's local time, set this
              value to true.

            - **QuietTime** *(dict) --*

              The default quiet time for the campaign. Quiet time is a specific time range when a
              campaign doesn't send messages to endpoints, if all the following conditions are met:

              * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

              * The current time in the endpoint's time zone is later than or equal to the time
              specified by the QuietTime.Start property for the campaign.

              * The current time in the endpoint's time zone is earlier than or equal to the time
              specified by the QuietTime.End property for the campaign.

              If any of the preceding conditions isn't met, the endpoint will receive messages from
              the campaign, even if quiet time is enabled.

              - **End** *(string) --*

                The specific time when quiet time ends. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

              - **Start** *(string) --*

                The specific time when quiet time begins. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

            - **StartTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
              property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
              UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
              UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
              UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

          - **SegmentId** *(string) --*

            The unique identifier for the segment that's associated with the campaign.

          - **SegmentVersion** *(integer) --*

            The version number of the segment that's associated with the campaign.

          - **State** *(dict) --*

            The current status of the campaign.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **tags** *(dict) --*

            A string-to-string map of key-value pairs that identifies the tags that are associated
            with the campaign. Each tag consists of a required tag key and an associated tag value.

            - *(string) --*

              - *(string) --*

          - **TemplateConfiguration** *(dict) --*

            The message template that’s used for the campaign.

            - **EmailTemplate** *(dict) --*

              The email template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **PushTemplate** *(dict) --*

              The push notification template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **SMSTemplate** *(dict) --*

              The SMS template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **VoiceTemplate** *(dict) --*

              The voice template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

          - **TreatmentDescription** *(string) --*

            The custom description of a variation of the campaign that's used for A/B testing.

          - **TreatmentName** *(string) --*

            The custom name of a variation of the campaign that's used for A/B testing.

          - **Version** *(integer) --*

            The version number of the campaign.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetChannelsResponseChannelsResponseChannelsTypeDef = TypedDict(
    "_ClientGetChannelsResponseChannelsResponseChannelsTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Version": int,
    },
    total=False,
)


class ClientGetChannelsResponseChannelsResponseChannelsTypeDef(
    _ClientGetChannelsResponseChannelsResponseChannelsTypeDef
):
    """
    Type definition for `ClientGetChannelsResponseChannelsResponse` `Channels`

    Provides information about the general settings and status of a channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the channel was last modified.

    - **Version** *(integer) --*

      The current version of the channel.
    """


_ClientGetChannelsResponseChannelsResponseTypeDef = TypedDict(
    "_ClientGetChannelsResponseChannelsResponseTypeDef",
    {"Channels": Dict[str, ClientGetChannelsResponseChannelsResponseChannelsTypeDef]},
    total=False,
)


class ClientGetChannelsResponseChannelsResponseTypeDef(
    _ClientGetChannelsResponseChannelsResponseTypeDef
):
    """
    Type definition for `ClientGetChannelsResponse` `ChannelsResponse`

    Provides information about the general settings and status of all channels for an application,
    including channels that aren't enabled for the application.

    - **Channels** *(dict) --*

      A map that contains a multipart response for each channel. For each item in this object, the
      ChannelType is the key and the Channel is the value.

      - *(string) --*

        - *(dict) --*

          Provides information about the general settings and status of a channel for an
          application.

          - **ApplicationId** *(string) --*

            The unique identifier for the application.

          - **CreationDate** *(string) --*

            The date and time, in ISO 8601 format, when the channel was enabled.

          - **Enabled** *(boolean) --*

            Specifies whether the channel is enabled for the application.

          - **HasCredential** *(boolean) --*

            (Not used) This property is retained only for backward compatibility.

          - **Id** *(string) --*

            (Deprecated) An identifier for the channel. This property is retained only for backward
            compatibility.

          - **IsArchived** *(boolean) --*

            Specifies whether the channel is archived.

          - **LastModifiedBy** *(string) --*

            The user who last modified the channel.

          - **LastModifiedDate** *(string) --*

            The date and time, in ISO 8601 format, when the channel was last modified.

          - **Version** *(integer) --*

            The current version of the channel.
    """


_ClientGetChannelsResponseTypeDef = TypedDict(
    "_ClientGetChannelsResponseTypeDef",
    {"ChannelsResponse": ClientGetChannelsResponseChannelsResponseTypeDef},
    total=False,
)


class ClientGetChannelsResponseTypeDef(_ClientGetChannelsResponseTypeDef):
    """
    Type definition for `ClientGetChannels` `Response`

    The request succeeded.

    - **ChannelsResponse** *(dict) --*

      Provides information about the general settings and status of all channels for an application,
      including channels that aren't enabled for the application.

      - **Channels** *(dict) --*

        A map that contains a multipart response for each channel. For each item in this object, the
        ChannelType is the key and the Channel is the value.

        - *(string) --*

          - *(dict) --*

            Provides information about the general settings and status of a channel for an
            application.

            - **ApplicationId** *(string) --*

              The unique identifier for the application.

            - **CreationDate** *(string) --*

              The date and time, in ISO 8601 format, when the channel was enabled.

            - **Enabled** *(boolean) --*

              Specifies whether the channel is enabled for the application.

            - **HasCredential** *(boolean) --*

              (Not used) This property is retained only for backward compatibility.

            - **Id** *(string) --*

              (Deprecated) An identifier for the channel. This property is retained only for
              backward compatibility.

            - **IsArchived** *(boolean) --*

              Specifies whether the channel is archived.

            - **LastModifiedBy** *(string) --*

              The user who last modified the channel.

            - **LastModifiedDate** *(string) --*

              The date and time, in ISO 8601 format, when the channel was last modified.

            - **Version** *(integer) --*

              The current version of the channel.
    """


_ClientGetEmailChannelResponseEmailChannelResponseTypeDef = TypedDict(
    "_ClientGetEmailChannelResponseEmailChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "ConfigurationSet": str,
        "CreationDate": str,
        "Enabled": bool,
        "FromAddress": str,
        "HasCredential": bool,
        "Id": str,
        "Identity": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "MessagesPerSecond": int,
        "Platform": str,
        "RoleArn": str,
        "Version": int,
    },
    total=False,
)


class ClientGetEmailChannelResponseEmailChannelResponseTypeDef(
    _ClientGetEmailChannelResponseEmailChannelResponseTypeDef
):
    """
    Type definition for `ClientGetEmailChannelResponse` `EmailChannelResponse`

    Provides information about the status and settings of the email channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the email channel applies to.

    - **ConfigurationSet** *(string) --*

      The configuration set that's applied to email that's sent through the channel by using the
      `Amazon Pinpoint Email API <emailAPIreference.html>`__ .

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the email channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the email channel is enabled for the application.

    - **FromAddress** *(string) --*

      The verified email address that you send email from when you send email through the channel.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the email channel. This property is retained only for backward
      compatibility.

    - **Identity** *(string) --*

      The Amazon Resource Name (ARN) of the identity, verified with Amazon Simple Email Service
      (Amazon SES), that you use when you send email through the channel.

    - **IsArchived** *(boolean) --*

      Specifies whether the email channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the email channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the email channel was last modified.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of emails that you can send through the channel each second.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the email channel, this
      value is EMAIL.

    - **RoleArn** *(string) --*

      The ARN of the AWS Identity and Access Management (IAM) role that Amazon Pinpoint uses to
      submit email-related event data for the channel.

    - **Version** *(integer) --*

      The current version of the email channel.
    """


_ClientGetEmailChannelResponseTypeDef = TypedDict(
    "_ClientGetEmailChannelResponseTypeDef",
    {"EmailChannelResponse": ClientGetEmailChannelResponseEmailChannelResponseTypeDef},
    total=False,
)


class ClientGetEmailChannelResponseTypeDef(_ClientGetEmailChannelResponseTypeDef):
    """
    Type definition for `ClientGetEmailChannel` `Response`

    The request succeeded.

    - **EmailChannelResponse** *(dict) --*

      Provides information about the status and settings of the email channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the email channel applies to.

      - **ConfigurationSet** *(string) --*

        The configuration set that's applied to email that's sent through the channel by using the
        `Amazon Pinpoint Email API <emailAPIreference.html>`__ .

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the email channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the email channel is enabled for the application.

      - **FromAddress** *(string) --*

        The verified email address that you send email from when you send email through the channel.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the email channel. This property is retained only for
        backward compatibility.

      - **Identity** *(string) --*

        The Amazon Resource Name (ARN) of the identity, verified with Amazon Simple Email Service
        (Amazon SES), that you use when you send email through the channel.

      - **IsArchived** *(boolean) --*

        Specifies whether the email channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the email channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the email channel was last modified.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of emails that you can send through the channel each second.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the email channel, this
        value is EMAIL.

      - **RoleArn** *(string) --*

        The ARN of the AWS Identity and Access Management (IAM) role that Amazon Pinpoint uses to
        submit email-related event data for the channel.

      - **Version** *(integer) --*

        The current version of the email channel.
    """


_ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef = TypedDict(
    "_ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef",
    {
        "Arn": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "HtmlPart": str,
        "LastModifiedDate": str,
        "Subject": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": str,
        "TextPart": str,
    },
    total=False,
)


class ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef(
    _ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef
):
    """
    Type definition for `ClientGetEmailTemplateResponse` `EmailTemplateResponse`

    Provides information about the content and settings for a message template that can be used in
    messages that are sent through the email channel.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template.

    - **CreationDate** *(string) --*

      The date when the message template was created.

    - **DefaultSubstitutions** *(string) --*

      The JSON object that specifies the default values that are used for message variables in the
      message template. This object is a set of key-value pairs. Each key defines a message variable
      in the template. The corresponding value defines the default value for that variable.

    - **HtmlPart** *(string) --*

      The message body, in HTML format, that's used in email messages that are based on the message
      template.

    - **LastModifiedDate** *(string) --*

      The date when the message template was last modified.

    - **Subject** *(string) --*

      The subject line, or title, that's used in email messages that are based on the message
      template.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the message template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      The custom description of the message template.

    - **TemplateName** *(string) --*

      The name of the message template.

    - **TemplateType** *(string) --*

      The type of channel that the message template is designed for. For an email template, this
      value is EMAIL.

    - **TextPart** *(string) --*

      The message body, in plain text format, that's used in email messages that are based on the
      message template.
    """


_ClientGetEmailTemplateResponseTypeDef = TypedDict(
    "_ClientGetEmailTemplateResponseTypeDef",
    {"EmailTemplateResponse": ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef},
    total=False,
)


class ClientGetEmailTemplateResponseTypeDef(_ClientGetEmailTemplateResponseTypeDef):
    """
    Type definition for `ClientGetEmailTemplate` `Response`

    The request succeeded.

    - **EmailTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      messages that are sent through the email channel.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.

      - **CreationDate** *(string) --*

        The date when the message template was created.

      - **DefaultSubstitutions** *(string) --*

        The JSON object that specifies the default values that are used for message variables in the
        message template. This object is a set of key-value pairs. Each key defines a message
        variable in the template. The corresponding value defines the default value for that
        variable.

      - **HtmlPart** *(string) --*

        The message body, in HTML format, that's used in email messages that are based on the
        message template.

      - **LastModifiedDate** *(string) --*

        The date when the message template was last modified.

      - **Subject** *(string) --*

        The subject line, or title, that's used in email messages that are based on the message
        template.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the message template. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateDescription** *(string) --*

        The custom description of the message template.

      - **TemplateName** *(string) --*

        The name of the message template.

      - **TemplateType** *(string) --*

        The type of channel that the message template is designed for. For an email template, this
        value is EMAIL.

      - **TextPart** *(string) --*

        The message body, in plain text format, that's used in email messages that are based on the
        message template.
    """


_ClientGetEndpointResponseEndpointResponseDemographicTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetEndpointResponseEndpointResponseDemographicTypeDef(
    _ClientGetEndpointResponseEndpointResponseDemographicTypeDef
):
    """
    Type definition for `ClientGetEndpointResponseEndpointResponse` `Demographic`

    The demographic information for the endpoint, such as the time zone and platform.

    - **AppVersion** *(string) --*

      The version of the app that's associated with the endpoint.

    - **Locale** *(string) --*

      The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
      an underscore (_), followed by an ISO 3166-1 alpha-2 value.

    - **Make** *(string) --*

      The manufacturer of the endpoint device, such as Apple or Samsung.

    - **Model** *(string) --*

      The model name or number of the endpoint device, such as iPhone.

    - **ModelVersion** *(string) --*

      The model version of the endpoint device.

    - **Platform** *(string) --*

      The platform of the endpoint device, such as iOS or Android.

    - **PlatformVersion** *(string) --*

      The platform version of the endpoint device.

    - **Timezone** *(string) --*

      The time zone of the endpoint, specified as a tz database name value, such as
      America/Los_Angeles.
    """


_ClientGetEndpointResponseEndpointResponseLocationTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientGetEndpointResponseEndpointResponseLocationTypeDef(
    _ClientGetEndpointResponseEndpointResponseLocationTypeDef
):
    """
    Type definition for `ClientGetEndpointResponseEndpointResponse` `Location`

    The geographic information for the endpoint.

    - **City** *(string) --*

      The name of the city where the endpoint is located.

    - **Country** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      endpoint is located. For example, US for the United States.

    - **Latitude** *(float) --*

      The latitude coordinate of the endpoint location, rounded to one decimal place.

    - **Longitude** *(float) --*

      The longitude coordinate of the endpoint location, rounded to one decimal place.

    - **PostalCode** *(string) --*

      The postal or ZIP code for the area where the endpoint is located.

    - **Region** *(string) --*

      The name of the region where the endpoint is located. For locations in the United States, this
      value is the name of a state.
    """


_ClientGetEndpointResponseEndpointResponseUserTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientGetEndpointResponseEndpointResponseUserTypeDef(
    _ClientGetEndpointResponseEndpointResponseUserTypeDef
):
    """
    Type definition for `ClientGetEndpointResponseEndpointResponse` `User`

    One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
    associated with the endpoint.

    - **UserAttributes** *(dict) --*

      One or more custom attributes that describe the user by associating a name with an array of
      values. For example, the value of an attribute named Interests might be: ["science", "music",
      "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **UserId** *(string) --*

      The unique identifier for the user.
    """


_ClientGetEndpointResponseEndpointResponseTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": str,
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientGetEndpointResponseEndpointResponseDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientGetEndpointResponseEndpointResponseLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientGetEndpointResponseEndpointResponseUserTypeDef,
    },
    total=False,
)


class ClientGetEndpointResponseEndpointResponseTypeDef(
    _ClientGetEndpointResponseEndpointResponseTypeDef
):
    """
    Type definition for `ClientGetEndpointResponse` `EndpointResponse`

    Provides information about the channel type and other settings for an endpoint.

    - **Address** *(string) --*

      The destination address for messages or push notifications that you send to the endpoint. The
      address varies by channel. For example, the address for a push-notification channel is
      typically the token provided by a push notification service, such as an Apple Push
      Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
      token. The address for the SMS channel is a phone number in E.164 format, such as
      +12065550100. The address for the email channel is an email address.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the endpoint.

    - **Attributes** *(dict) --*

      One or more custom attributes that describe the endpoint by associating a name with an array
      of values. For example, the value of a custom attribute named Interests might be: ["science",
      "music", "travel"]. You can use these attributes as filter criteria when you create segments.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ChannelType** *(string) --*

      The channel that's used when sending messages or push notifications to the endpoint.

    - **CohortId** *(string) --*

      A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints are
      grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
      endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
      allocations for campaigns.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was created.

    - **Demographic** *(dict) --*

      The demographic information for the endpoint, such as the time zone and platform.

      - **AppVersion** *(string) --*

        The version of the app that's associated with the endpoint.

      - **Locale** *(string) --*

        The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
        an underscore (_), followed by an ISO 3166-1 alpha-2 value.

      - **Make** *(string) --*

        The manufacturer of the endpoint device, such as Apple or Samsung.

      - **Model** *(string) --*

        The model name or number of the endpoint device, such as iPhone.

      - **ModelVersion** *(string) --*

        The model version of the endpoint device.

      - **Platform** *(string) --*

        The platform of the endpoint device, such as iOS or Android.

      - **PlatformVersion** *(string) --*

        The platform version of the endpoint device.

      - **Timezone** *(string) --*

        The time zone of the endpoint, specified as a tz database name value, such as
        America/Los_Angeles.

    - **EffectiveDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was last updated.

    - **EndpointStatus** *(string) --*

      Specifies whether messages or push notifications are sent to the endpoint. Possible values
      are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
      endpoint.

      Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or update
      an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if you update
      another endpoint that has the same address specified by the Address property.

    - **Id** *(string) --*

      The unique identifier that you assigned to the endpoint. The identifier should be a globally
      unique identifier (GUID) to ensure that it doesn't conflict with other endpoint identifiers
      that are associated with the application.

    - **Location** *(dict) --*

      The geographic information for the endpoint.

      - **City** *(string) --*

        The name of the city where the endpoint is located.

      - **Country** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        endpoint is located. For example, US for the United States.

      - **Latitude** *(float) --*

        The latitude coordinate of the endpoint location, rounded to one decimal place.

      - **Longitude** *(float) --*

        The longitude coordinate of the endpoint location, rounded to one decimal place.

      - **PostalCode** *(string) --*

        The postal or ZIP code for the area where the endpoint is located.

      - **Region** *(string) --*

        The name of the region where the endpoint is located. For locations in the United States,
        this value is the name of a state.

    - **Metrics** *(dict) --*

      One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

      - *(string) --*

        - *(float) --*

    - **OptOut** *(string) --*

      Specifies whether the user who's associated with the endpoint has opted out of receiving
      messages and push notifications from you. Possible values are: ALL, the user has opted out and
      doesn't want to receive any messages or push notifications; and, NONE, the user hasn't opted
      out and wants to receive all messages and push notifications.

    - **RequestId** *(string) --*

      The unique identifier for the most recent request to update the endpoint.

    - **User** *(dict) --*

      One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
      associated with the endpoint.

      - **UserAttributes** *(dict) --*

        One or more custom attributes that describe the user by associating a name with an array of
        values. For example, the value of an attribute named Interests might be: ["science",
        "music", "travel"]. You can use these attributes as filter criteria when you create
        segments.

        When you define the name of a custom attribute, avoid using the following characters: number
        sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
        console can't display attribute names that contain these characters. This limitation doesn't
        apply to attribute values.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **UserId** *(string) --*

        The unique identifier for the user.
    """


_ClientGetEndpointResponseTypeDef = TypedDict(
    "_ClientGetEndpointResponseTypeDef",
    {"EndpointResponse": ClientGetEndpointResponseEndpointResponseTypeDef},
    total=False,
)


class ClientGetEndpointResponseTypeDef(_ClientGetEndpointResponseTypeDef):
    """
    Type definition for `ClientGetEndpoint` `Response`

    The request succeeded.

    - **EndpointResponse** *(dict) --*

      Provides information about the channel type and other settings for an endpoint.

      - **Address** *(string) --*

        The destination address for messages or push notifications that you send to the endpoint.
        The address varies by channel. For example, the address for a push-notification channel is
        typically the token provided by a push notification service, such as an Apple Push
        Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
        token. The address for the SMS channel is a phone number in E.164 format, such as
        +12065550100. The address for the email channel is an email address.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the endpoint.

      - **Attributes** *(dict) --*

        One or more custom attributes that describe the endpoint by associating a name with an array
        of values. For example, the value of a custom attribute named Interests might be:
        ["science", "music", "travel"]. You can use these attributes as filter criteria when you
        create segments.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **ChannelType** *(string) --*

        The channel that's used when sending messages or push notifications to the endpoint.

      - **CohortId** *(string) --*

        A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints
        are grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
        endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
        allocations for campaigns.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the endpoint was created.

      - **Demographic** *(dict) --*

        The demographic information for the endpoint, such as the time zone and platform.

        - **AppVersion** *(string) --*

          The version of the app that's associated with the endpoint.

        - **Locale** *(string) --*

          The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed
          by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

        - **Make** *(string) --*

          The manufacturer of the endpoint device, such as Apple or Samsung.

        - **Model** *(string) --*

          The model name or number of the endpoint device, such as iPhone.

        - **ModelVersion** *(string) --*

          The model version of the endpoint device.

        - **Platform** *(string) --*

          The platform of the endpoint device, such as iOS or Android.

        - **PlatformVersion** *(string) --*

          The platform version of the endpoint device.

        - **Timezone** *(string) --*

          The time zone of the endpoint, specified as a tz database name value, such as
          America/Los_Angeles.

      - **EffectiveDate** *(string) --*

        The date and time, in ISO 8601 format, when the endpoint was last updated.

      - **EndpointStatus** *(string) --*

        Specifies whether messages or push notifications are sent to the endpoint. Possible values
        are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
        endpoint.

        Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
        update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if
        you update another endpoint that has the same address specified by the Address property.

      - **Id** *(string) --*

        The unique identifier that you assigned to the endpoint. The identifier should be a globally
        unique identifier (GUID) to ensure that it doesn't conflict with other endpoint identifiers
        that are associated with the application.

      - **Location** *(dict) --*

        The geographic information for the endpoint.

        - **City** *(string) --*

          The name of the city where the endpoint is located.

        - **Country** *(string) --*

          The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
          endpoint is located. For example, US for the United States.

        - **Latitude** *(float) --*

          The latitude coordinate of the endpoint location, rounded to one decimal place.

        - **Longitude** *(float) --*

          The longitude coordinate of the endpoint location, rounded to one decimal place.

        - **PostalCode** *(string) --*

          The postal or ZIP code for the area where the endpoint is located.

        - **Region** *(string) --*

          The name of the region where the endpoint is located. For locations in the United States,
          this value is the name of a state.

      - **Metrics** *(dict) --*

        One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

        - *(string) --*

          - *(float) --*

      - **OptOut** *(string) --*

        Specifies whether the user who's associated with the endpoint has opted out of receiving
        messages and push notifications from you. Possible values are: ALL, the user has opted out
        and doesn't want to receive any messages or push notifications; and, NONE, the user hasn't
        opted out and wants to receive all messages and push notifications.

      - **RequestId** *(string) --*

        The unique identifier for the most recent request to update the endpoint.

      - **User** *(dict) --*

        One or more custom user attributes that your app reports to Amazon Pinpoint for the user
        who's associated with the endpoint.

        - **UserAttributes** *(dict) --*

          One or more custom attributes that describe the user by associating a name with an array
          of values. For example, the value of an attribute named Interests might be: ["science",
          "music", "travel"]. You can use these attributes as filter criteria when you create
          segments.

          When you define the name of a custom attribute, avoid using the following characters:
          number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon
          Pinpoint console can't display attribute names that contain these characters. This
          limitation doesn't apply to attribute values.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **UserId** *(string) --*

          The unique identifier for the user.
    """


_ClientGetEventStreamResponseEventStreamTypeDef = TypedDict(
    "_ClientGetEventStreamResponseEventStreamTypeDef",
    {
        "ApplicationId": str,
        "DestinationStreamArn": str,
        "ExternalId": str,
        "LastModifiedDate": str,
        "LastUpdatedBy": str,
        "RoleArn": str,
    },
    total=False,
)


class ClientGetEventStreamResponseEventStreamTypeDef(
    _ClientGetEventStreamResponseEventStreamTypeDef
):
    """
    Type definition for `ClientGetEventStreamResponse` `EventStream`

    Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
    Kinesis Data Firehose delivery stream.

    - **ApplicationId** *(string) --*

      The unique identifier for the application to publish event data for.

    - **DestinationStreamArn** *(string) --*

      The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
      Firehose delivery stream to publish event data to.

      For a Kinesis data stream, the ARN format is:
      arn:aws:kinesis:region:account-id:stream/stream_name

      For a Kinesis Data Firehose delivery stream, the ARN format is:
      arn:aws:firehose:region:account-id:deliverystream/stream_name

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when publishing event
      data, but we removed this requirement. We don't recommend use of external IDs for IAM roles
      that are assumed by Amazon Pinpoint.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the event stream was last modified.

    - **LastUpdatedBy** *(string) --*

      The IAM user who last modified the event stream.

    - **RoleArn** *(string) --*

      The AWS Identity and Access Management (IAM) role that authorizes Amazon Pinpoint to publish
      event data to the stream in your AWS account.
    """


_ClientGetEventStreamResponseTypeDef = TypedDict(
    "_ClientGetEventStreamResponseTypeDef",
    {"EventStream": ClientGetEventStreamResponseEventStreamTypeDef},
    total=False,
)


class ClientGetEventStreamResponseTypeDef(_ClientGetEventStreamResponseTypeDef):
    """
    Type definition for `ClientGetEventStream` `Response`

    The request succeeded.

    - **EventStream** *(dict) --*

      Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
      Kinesis Data Firehose delivery stream.

      - **ApplicationId** *(string) --*

        The unique identifier for the application to publish event data for.

      - **DestinationStreamArn** *(string) --*

        The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
        Firehose delivery stream to publish event data to.

        For a Kinesis data stream, the ARN format is:
        arn:aws:kinesis:region:account-id:stream/stream_name

        For a Kinesis Data Firehose delivery stream, the ARN format is:
        arn:aws:firehose:region:account-id:deliverystream/stream_name

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when publishing
        event data, but we removed this requirement. We don't recommend use of external IDs for IAM
        roles that are assumed by Amazon Pinpoint.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the event stream was last modified.

      - **LastUpdatedBy** *(string) --*

        The IAM user who last modified the event stream.

      - **RoleArn** *(string) --*

        The AWS Identity and Access Management (IAM) role that authorizes Amazon Pinpoint to publish
        event data to the stream in your AWS account.
    """


_ClientGetExportJobResponseExportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientGetExportJobResponseExportJobResponseDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientGetExportJobResponseExportJobResponseDefinitionTypeDef(
    _ClientGetExportJobResponseExportJobResponseDefinitionTypeDef
):
    """
    Type definition for `ClientGetExportJobResponseExportJobResponse` `Definition`

    The resource settings that apply to the export job.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
      were exported to.

    - **S3UrlPrefix** *(string) --*

      The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
      endpoint definitions were exported to. This location is typically a folder that contains
      multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

    - **SegmentId** *(string) --*

      The identifier for the segment that the endpoint definitions were exported from. If this value
      isn't present, Amazon Pinpoint exported definitions for all the endpoints that are associated
      with the application.

    - **SegmentVersion** *(integer) --*

      The version of the segment that the endpoint definitions were exported from.
    """


_ClientGetExportJobResponseExportJobResponseTypeDef = TypedDict(
    "_ClientGetExportJobResponseExportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetExportJobResponseExportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetExportJobResponseExportJobResponseTypeDef(
    _ClientGetExportJobResponseExportJobResponseTypeDef
):
    """
    Type definition for `ClientGetExportJobResponse` `ExportJobResponse`

    Provides information about the status and settings of a job that exports endpoint definitions to
    a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3) bucket by
    using the Amazon Pinpoint API or downloaded directly to a computer by using the Amazon Pinpoint
    console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the export job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the export job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the export job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the export job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the export job.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
        were exported to.

      - **S3UrlPrefix** *(string) --*

        The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
        endpoint definitions were exported to. This location is typically a folder that contains
        multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

      - **SegmentId** *(string) --*

        The identifier for the segment that the endpoint definitions were exported from. If this
        value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
        associated with the application.

      - **SegmentVersion** *(integer) --*

        The version of the segment that the endpoint definitions were exported from.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the export job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the export job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the export job.

    - **JobStatus** *(string) --*

      The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      export job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the export job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      export job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the export job.

    - **Type** *(string) --*

      The job type. This value is EXPORT for export jobs.
    """


_ClientGetExportJobResponseTypeDef = TypedDict(
    "_ClientGetExportJobResponseTypeDef",
    {"ExportJobResponse": ClientGetExportJobResponseExportJobResponseTypeDef},
    total=False,
)


class ClientGetExportJobResponseTypeDef(_ClientGetExportJobResponseTypeDef):
    """
    Type definition for `ClientGetExportJob` `Response`

    The request succeeded.

    - **ExportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that exports endpoint definitions
      to a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3)
      bucket by using the Amazon Pinpoint API or downloaded directly to a computer by using the
      Amazon Pinpoint console.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the export job.

      - **CompletedPieces** *(integer) --*

        The number of pieces that were processed successfully (completed) by the export job, as of
        the time of the request.

      - **CompletionDate** *(string) --*

        The date, in ISO 8601 format, when the export job was completed.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the export job was created.

      - **Definition** *(dict) --*

        The resource settings that apply to the export job.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
          were exported to.

        - **S3UrlPrefix** *(string) --*

          The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
          endpoint definitions were exported to. This location is typically a folder that contains
          multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

        - **SegmentId** *(string) --*

          The identifier for the segment that the endpoint definitions were exported from. If this
          value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
          associated with the application.

        - **SegmentVersion** *(integer) --*

          The version of the segment that the endpoint definitions were exported from.

      - **FailedPieces** *(integer) --*

        The number of pieces that weren't processed successfully (failed) by the export job, as of
        the time of the request.

      - **Failures** *(list) --*

        An array of entries, one for each of the first 100 entries that weren't processed
        successfully (failed) by the export job, if any.

        - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the export job.

      - **JobStatus** *(string) --*

        The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
        process one or more pieces in the job.

      - **TotalFailures** *(integer) --*

        The total number of endpoint definitions that weren't processed successfully (failed) by the
        export job, typically because an error, such as a syntax error, occurred.

      - **TotalPieces** *(integer) --*

        The total number of pieces that must be processed to complete the export job. Each piece
        consists of an approximately equal portion of the endpoint definitions that are part of the
        export job.

      - **TotalProcessed** *(integer) --*

        The total number of endpoint definitions that were processed by the export job.

      - **Type** *(string) --*

        The job type. This value is EXPORT for export jobs.
    """


_ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef(
    _ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef
):
    """
    Type definition for `ClientGetExportJobsResponseExportJobsResponseItem` `Definition`

    The resource settings that apply to the export job.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
      were exported to.

    - **S3UrlPrefix** *(string) --*

      The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
      endpoint definitions were exported to. This location is typically a folder that contains
      multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

    - **SegmentId** *(string) --*

      The identifier for the segment that the endpoint definitions were exported from. If this value
      isn't present, Amazon Pinpoint exported definitions for all the endpoints that are associated
      with the application.

    - **SegmentVersion** *(integer) --*

      The version of the segment that the endpoint definitions were exported from.
    """


_ClientGetExportJobsResponseExportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetExportJobsResponseExportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetExportJobsResponseExportJobsResponseItemTypeDef(
    _ClientGetExportJobsResponseExportJobsResponseItemTypeDef
):
    """
    Type definition for `ClientGetExportJobsResponseExportJobsResponse` `Item`

    Provides information about the status and settings of a job that exports endpoint definitions to
    a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3) bucket by
    using the Amazon Pinpoint API or downloaded directly to a computer by using the Amazon Pinpoint
    console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the export job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the export job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the export job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the export job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the export job.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
        were exported to.

      - **S3UrlPrefix** *(string) --*

        The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
        endpoint definitions were exported to. This location is typically a folder that contains
        multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

      - **SegmentId** *(string) --*

        The identifier for the segment that the endpoint definitions were exported from. If this
        value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
        associated with the application.

      - **SegmentVersion** *(integer) --*

        The version of the segment that the endpoint definitions were exported from.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the export job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the export job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the export job.

    - **JobStatus** *(string) --*

      The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      export job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the export job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      export job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the export job.

    - **Type** *(string) --*

      The job type. This value is EXPORT for export jobs.
    """


_ClientGetExportJobsResponseExportJobsResponseTypeDef = TypedDict(
    "_ClientGetExportJobsResponseExportJobsResponseTypeDef",
    {"Item": List[ClientGetExportJobsResponseExportJobsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetExportJobsResponseExportJobsResponseTypeDef(
    _ClientGetExportJobsResponseExportJobsResponseTypeDef
):
    """
    Type definition for `ClientGetExportJobsResponse` `ExportJobsResponse`

    Provides information about all the export jobs that are associated with an application or
    segment. An export job is a job that exports endpoint definitions to a file.

    - **Item** *(list) --*

      An array of responses, one for each export job that's associated with the application (Export
      Jobs resource) or segment (Segment Export Jobs resource).

      - *(dict) --*

        Provides information about the status and settings of a job that exports endpoint
        definitions to a file. The file can be added directly to an Amazon Simple Storage Service
        (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer by
        using the Amazon Pinpoint console.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the export job.

        - **CompletedPieces** *(integer) --*

          The number of pieces that were processed successfully (completed) by the export job, as of
          the time of the request.

        - **CompletionDate** *(string) --*

          The date, in ISO 8601 format, when the export job was completed.

        - **CreationDate** *(string) --*

          The date, in ISO 8601 format, when the export job was created.

        - **Definition** *(dict) --*

          The resource settings that apply to the export job.

          - **RoleArn** *(string) --*

            The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
            authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint
            definitions were exported to.

          - **S3UrlPrefix** *(string) --*

            The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
            endpoint definitions were exported to. This location is typically a folder that contains
            multiple files. The URL should be in the following format:
            s3://bucket-name/folder-name/.

          - **SegmentId** *(string) --*

            The identifier for the segment that the endpoint definitions were exported from. If this
            value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
            associated with the application.

          - **SegmentVersion** *(integer) --*

            The version of the segment that the endpoint definitions were exported from.

        - **FailedPieces** *(integer) --*

          The number of pieces that weren't processed successfully (failed) by the export job, as of
          the time of the request.

        - **Failures** *(list) --*

          An array of entries, one for each of the first 100 entries that weren't processed
          successfully (failed) by the export job, if any.

          - *(string) --*

        - **Id** *(string) --*

          The unique identifier for the export job.

        - **JobStatus** *(string) --*

          The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
          process one or more pieces in the job.

        - **TotalFailures** *(integer) --*

          The total number of endpoint definitions that weren't processed successfully (failed) by
          the export job, typically because an error, such as a syntax error, occurred.

        - **TotalPieces** *(integer) --*

          The total number of pieces that must be processed to complete the export job. Each piece
          consists of an approximately equal portion of the endpoint definitions that are part of
          the export job.

        - **TotalProcessed** *(integer) --*

          The total number of endpoint definitions that were processed by the export job.

        - **Type** *(string) --*

          The job type. This value is EXPORT for export jobs.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetExportJobsResponseTypeDef = TypedDict(
    "_ClientGetExportJobsResponseTypeDef",
    {"ExportJobsResponse": ClientGetExportJobsResponseExportJobsResponseTypeDef},
    total=False,
)


class ClientGetExportJobsResponseTypeDef(_ClientGetExportJobsResponseTypeDef):
    """
    Type definition for `ClientGetExportJobs` `Response`

    The request succeeded.

    - **ExportJobsResponse** *(dict) --*

      Provides information about all the export jobs that are associated with an application or
      segment. An export job is a job that exports endpoint definitions to a file.

      - **Item** *(list) --*

        An array of responses, one for each export job that's associated with the application
        (Export Jobs resource) or segment (Segment Export Jobs resource).

        - *(dict) --*

          Provides information about the status and settings of a job that exports endpoint
          definitions to a file. The file can be added directly to an Amazon Simple Storage Service
          (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer
          by using the Amazon Pinpoint console.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the export job.

          - **CompletedPieces** *(integer) --*

            The number of pieces that were processed successfully (completed) by the export job, as
            of the time of the request.

          - **CompletionDate** *(string) --*

            The date, in ISO 8601 format, when the export job was completed.

          - **CreationDate** *(string) --*

            The date, in ISO 8601 format, when the export job was created.

          - **Definition** *(dict) --*

            The resource settings that apply to the export job.

            - **RoleArn** *(string) --*

              The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role
              that authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint
              definitions were exported to.

            - **S3UrlPrefix** *(string) --*

              The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where
              the endpoint definitions were exported to. This location is typically a folder that
              contains multiple files. The URL should be in the following format:
              s3://bucket-name/folder-name/.

            - **SegmentId** *(string) --*

              The identifier for the segment that the endpoint definitions were exported from. If
              this value isn't present, Amazon Pinpoint exported definitions for all the endpoints
              that are associated with the application.

            - **SegmentVersion** *(integer) --*

              The version of the segment that the endpoint definitions were exported from.

          - **FailedPieces** *(integer) --*

            The number of pieces that weren't processed successfully (failed) by the export job, as
            of the time of the request.

          - **Failures** *(list) --*

            An array of entries, one for each of the first 100 entries that weren't processed
            successfully (failed) by the export job, if any.

            - *(string) --*

          - **Id** *(string) --*

            The unique identifier for the export job.

          - **JobStatus** *(string) --*

            The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
            process one or more pieces in the job.

          - **TotalFailures** *(integer) --*

            The total number of endpoint definitions that weren't processed successfully (failed) by
            the export job, typically because an error, such as a syntax error, occurred.

          - **TotalPieces** *(integer) --*

            The total number of pieces that must be processed to complete the export job. Each piece
            consists of an approximately equal portion of the endpoint definitions that are part of
            the export job.

          - **TotalProcessed** *(integer) --*

            The total number of endpoint definitions that were processed by the export job.

          - **Type** *(string) --*

            The job type. This value is EXPORT for export jobs.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetGcmChannelResponseGCMChannelResponseTypeDef = TypedDict(
    "_ClientGetGcmChannelResponseGCMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetGcmChannelResponseGCMChannelResponseTypeDef(
    _ClientGetGcmChannelResponseGCMChannelResponseTypeDef
):
    """
    Type definition for `ClientGetGcmChannelResponse` `GCMChannelResponse`

    Provides information about the status and settings of the GCM channel for an application. The
    GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
    Messaging (FCM), formerly Google Cloud Messaging (GCM), service.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the GCM channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the GCM channel was enabled.

    - **Credential** *(string) --*

      The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
      Google to communicate with Google services.

    - **Enabled** *(boolean) --*

      Specifies whether the GCM channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the GCM channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the GCM channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the GCM channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the GCM channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the GCM channel, this
      value is GCM.

    - **Version** *(integer) --*

      The current version of the GCM channel.
    """


_ClientGetGcmChannelResponseTypeDef = TypedDict(
    "_ClientGetGcmChannelResponseTypeDef",
    {"GCMChannelResponse": ClientGetGcmChannelResponseGCMChannelResponseTypeDef},
    total=False,
)


class ClientGetGcmChannelResponseTypeDef(_ClientGetGcmChannelResponseTypeDef):
    """
    Type definition for `ClientGetGcmChannel` `Response`

    The request succeeded.

    - **GCMChannelResponse** *(dict) --*

      Provides information about the status and settings of the GCM channel for an application. The
      GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
      Messaging (FCM), formerly Google Cloud Messaging (GCM), service.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the GCM channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the GCM channel was enabled.

      - **Credential** *(string) --*

        The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
        Google to communicate with Google services.

      - **Enabled** *(boolean) --*

        Specifies whether the GCM channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the GCM channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the GCM channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the GCM channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the GCM channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the GCM channel, this
        value is GCM.

      - **Version** *(integer) --*

        The current version of the GCM channel.
    """


_ClientGetImportJobResponseImportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientGetImportJobResponseImportJobResponseDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": str,
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientGetImportJobResponseImportJobResponseDefinitionTypeDef(
    _ClientGetImportJobResponseImportJobResponseDefinitionTypeDef
):
    """
    Type definition for `ClientGetImportJobResponseImportJobResponse` `Definition`

    The resource settings that apply to the import job.

    - **DefineSegment** *(boolean) --*

      Specifies whether the import job creates a segment that contains the endpoints, when the
      endpoint definitions are imported.

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that contain the endpoint definitions to import. Valid values are:
      CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

      If the files are stored in an Amazon S3 location and that location contains multiple files
      that use different formats, Amazon Pinpoint imports data only from the files that use the
      specified format.

    - **RegisterEndpoints** *(boolean) --*

      Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
      endpoint definitions are imported.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
      definitions to import. This location can be a folder or a single file. If the location is a
      folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
      including any subfolders that the folder contains.

      The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
      location can end with the key for an individual object or a prefix that qualifies multiple
      objects.

    - **SegmentId** *(string) --*

      The identifier for the segment that the import job updates or adds endpoint definitions to, if
      the import job updates an existing segment.

    - **SegmentName** *(string) --*

      The custom name for the segment that's created by the import job, if the value of the
      DefineSegment property is true.
    """


_ClientGetImportJobResponseImportJobResponseTypeDef = TypedDict(
    "_ClientGetImportJobResponseImportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetImportJobResponseImportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetImportJobResponseImportJobResponseTypeDef(
    _ClientGetImportJobResponseImportJobResponseTypeDef
):
    """
    Type definition for `ClientGetImportJobResponse` `ImportJobResponse`

    Provides information about the status and settings of a job that imports endpoint definitions
    from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon S3)
    bucket or uploaded directly from a computer by using the Amazon Pinpoint console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the import job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the import job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the import job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the import job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the import job.

      - **DefineSegment** *(boolean) --*

        Specifies whether the import job creates a segment that contains the endpoints, when the
        endpoint definitions are imported.

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that contain the endpoint definitions to import. Valid values are:
        CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

        If the files are stored in an Amazon S3 location and that location contains multiple files
        that use different formats, Amazon Pinpoint imports data only from the files that use the
        specified format.

      - **RegisterEndpoints** *(boolean) --*

        Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
        endpoint definitions are imported.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
        definitions to import. This location can be a folder or a single file. If the location is a
        folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
        including any subfolders that the folder contains.

        The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
        location can end with the key for an individual object or a prefix that qualifies multiple
        objects.

      - **SegmentId** *(string) --*

        The identifier for the segment that the import job updates or adds endpoint definitions to,
        if the import job updates an existing segment.

      - **SegmentName** *(string) --*

        The custom name for the segment that's created by the import job, if the value of the
        DefineSegment property is true.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the import job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the import job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the import job.

    - **JobStatus** *(string) --*

      The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      import job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the import job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      import job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the import job.

    - **Type** *(string) --*

      The job type. This value is IMPORT for import jobs.
    """


_ClientGetImportJobResponseTypeDef = TypedDict(
    "_ClientGetImportJobResponseTypeDef",
    {"ImportJobResponse": ClientGetImportJobResponseImportJobResponseTypeDef},
    total=False,
)


class ClientGetImportJobResponseTypeDef(_ClientGetImportJobResponseTypeDef):
    """
    Type definition for `ClientGetImportJob` `Response`

    The request succeeded.

    - **ImportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that imports endpoint definitions
      from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon
      S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint console.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the import job.

      - **CompletedPieces** *(integer) --*

        The number of pieces that were processed successfully (completed) by the import job, as of
        the time of the request.

      - **CompletionDate** *(string) --*

        The date, in ISO 8601 format, when the import job was completed.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the import job was created.

      - **Definition** *(dict) --*

        The resource settings that apply to the import job.

        - **DefineSegment** *(boolean) --*

          Specifies whether the import job creates a segment that contains the endpoints, when the
          endpoint definitions are imported.

        - **ExternalId** *(string) --*

          (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
          policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
          endpoint definitions, but we removed this requirement. We don't recommend use of external
          IDs for IAM roles that are assumed by Amazon Pinpoint.

        - **Format** *(string) --*

          The format of the files that contain the endpoint definitions to import. Valid values are:
          CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

          If the files are stored in an Amazon S3 location and that location contains multiple files
          that use different formats, Amazon Pinpoint imports data only from the files that use the
          specified format.

        - **RegisterEndpoints** *(boolean) --*

          Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
          endpoint definitions are imported.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
          from.

        - **S3Url** *(string) --*

          The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
          definitions to import. This location can be a folder or a single file. If the location is
          a folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
          including any subfolders that the folder contains.

          The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
          location can end with the key for an individual object or a prefix that qualifies multiple
          objects.

        - **SegmentId** *(string) --*

          The identifier for the segment that the import job updates or adds endpoint definitions
          to, if the import job updates an existing segment.

        - **SegmentName** *(string) --*

          The custom name for the segment that's created by the import job, if the value of the
          DefineSegment property is true.

      - **FailedPieces** *(integer) --*

        The number of pieces that weren't processed successfully (failed) by the import job, as of
        the time of the request.

      - **Failures** *(list) --*

        An array of entries, one for each of the first 100 entries that weren't processed
        successfully (failed) by the import job, if any.

        - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the import job.

      - **JobStatus** *(string) --*

        The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
        process one or more pieces in the job.

      - **TotalFailures** *(integer) --*

        The total number of endpoint definitions that weren't processed successfully (failed) by the
        import job, typically because an error, such as a syntax error, occurred.

      - **TotalPieces** *(integer) --*

        The total number of pieces that must be processed to complete the import job. Each piece
        consists of an approximately equal portion of the endpoint definitions that are part of the
        import job.

      - **TotalProcessed** *(integer) --*

        The total number of endpoint definitions that were processed by the import job.

      - **Type** *(string) --*

        The job type. This value is IMPORT for import jobs.
    """


_ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": str,
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef(
    _ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef
):
    """
    Type definition for `ClientGetImportJobsResponseImportJobsResponseItem` `Definition`

    The resource settings that apply to the import job.

    - **DefineSegment** *(boolean) --*

      Specifies whether the import job creates a segment that contains the endpoints, when the
      endpoint definitions are imported.

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that contain the endpoint definitions to import. Valid values are:
      CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

      If the files are stored in an Amazon S3 location and that location contains multiple files
      that use different formats, Amazon Pinpoint imports data only from the files that use the
      specified format.

    - **RegisterEndpoints** *(boolean) --*

      Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
      endpoint definitions are imported.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
      definitions to import. This location can be a folder or a single file. If the location is a
      folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
      including any subfolders that the folder contains.

      The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
      location can end with the key for an individual object or a prefix that qualifies multiple
      objects.

    - **SegmentId** *(string) --*

      The identifier for the segment that the import job updates or adds endpoint definitions to, if
      the import job updates an existing segment.

    - **SegmentName** *(string) --*

      The custom name for the segment that's created by the import job, if the value of the
      DefineSegment property is true.
    """


_ClientGetImportJobsResponseImportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetImportJobsResponseImportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetImportJobsResponseImportJobsResponseItemTypeDef(
    _ClientGetImportJobsResponseImportJobsResponseItemTypeDef
):
    """
    Type definition for `ClientGetImportJobsResponseImportJobsResponse` `Item`

    Provides information about the status and settings of a job that imports endpoint definitions
    from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon S3)
    bucket or uploaded directly from a computer by using the Amazon Pinpoint console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the import job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the import job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the import job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the import job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the import job.

      - **DefineSegment** *(boolean) --*

        Specifies whether the import job creates a segment that contains the endpoints, when the
        endpoint definitions are imported.

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that contain the endpoint definitions to import. Valid values are:
        CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

        If the files are stored in an Amazon S3 location and that location contains multiple files
        that use different formats, Amazon Pinpoint imports data only from the files that use the
        specified format.

      - **RegisterEndpoints** *(boolean) --*

        Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
        endpoint definitions are imported.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
        definitions to import. This location can be a folder or a single file. If the location is a
        folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
        including any subfolders that the folder contains.

        The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
        location can end with the key for an individual object or a prefix that qualifies multiple
        objects.

      - **SegmentId** *(string) --*

        The identifier for the segment that the import job updates or adds endpoint definitions to,
        if the import job updates an existing segment.

      - **SegmentName** *(string) --*

        The custom name for the segment that's created by the import job, if the value of the
        DefineSegment property is true.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the import job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the import job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the import job.

    - **JobStatus** *(string) --*

      The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      import job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the import job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      import job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the import job.

    - **Type** *(string) --*

      The job type. This value is IMPORT for import jobs.
    """


_ClientGetImportJobsResponseImportJobsResponseTypeDef = TypedDict(
    "_ClientGetImportJobsResponseImportJobsResponseTypeDef",
    {"Item": List[ClientGetImportJobsResponseImportJobsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetImportJobsResponseImportJobsResponseTypeDef(
    _ClientGetImportJobsResponseImportJobsResponseTypeDef
):
    """
    Type definition for `ClientGetImportJobsResponse` `ImportJobsResponse`

    Provides information about the status and settings of all the import jobs that are associated
    with an application or segment. An import job is a job that imports endpoint definitions from
    one or more files.

    - **Item** *(list) --*

      An array of responses, one for each import job that's associated with the application (Import
      Jobs resource) or segment (Segment Import Jobs resource).

      - *(dict) --*

        Provides information about the status and settings of a job that imports endpoint
        definitions from one or more files. The files can be stored in an Amazon Simple Storage
        Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint
        console.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the import job.

        - **CompletedPieces** *(integer) --*

          The number of pieces that were processed successfully (completed) by the import job, as of
          the time of the request.

        - **CompletionDate** *(string) --*

          The date, in ISO 8601 format, when the import job was completed.

        - **CreationDate** *(string) --*

          The date, in ISO 8601 format, when the import job was created.

        - **Definition** *(dict) --*

          The resource settings that apply to the import job.

          - **DefineSegment** *(boolean) --*

            Specifies whether the import job creates a segment that contains the endpoints, when the
            endpoint definitions are imported.

          - **ExternalId** *(string) --*

            (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
            trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
            importing endpoint definitions, but we removed this requirement. We don't recommend use
            of external IDs for IAM roles that are assumed by Amazon Pinpoint.

          - **Format** *(string) --*

            The format of the files that contain the endpoint definitions to import. Valid values
            are: CSV, for comma-separated values format; and, JSON, for newline-delimited JSON
            format.

            If the files are stored in an Amazon S3 location and that location contains multiple
            files that use different formats, Amazon Pinpoint imports data only from the files that
            use the specified format.

          - **RegisterEndpoints** *(boolean) --*

            Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
            endpoint definitions are imported.

          - **RoleArn** *(string) --*

            The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
            authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint
            definitions from.

          - **S3Url** *(string) --*

            The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the
            endpoint definitions to import. This location can be a folder or a single file. If the
            location is a folder, Amazon Pinpoint imports endpoint definitions from the files in
            this location, including any subfolders that the folder contains.

            The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
            location can end with the key for an individual object or a prefix that qualifies
            multiple objects.

          - **SegmentId** *(string) --*

            The identifier for the segment that the import job updates or adds endpoint definitions
            to, if the import job updates an existing segment.

          - **SegmentName** *(string) --*

            The custom name for the segment that's created by the import job, if the value of the
            DefineSegment property is true.

        - **FailedPieces** *(integer) --*

          The number of pieces that weren't processed successfully (failed) by the import job, as of
          the time of the request.

        - **Failures** *(list) --*

          An array of entries, one for each of the first 100 entries that weren't processed
          successfully (failed) by the import job, if any.

          - *(string) --*

        - **Id** *(string) --*

          The unique identifier for the import job.

        - **JobStatus** *(string) --*

          The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
          process one or more pieces in the job.

        - **TotalFailures** *(integer) --*

          The total number of endpoint definitions that weren't processed successfully (failed) by
          the import job, typically because an error, such as a syntax error, occurred.

        - **TotalPieces** *(integer) --*

          The total number of pieces that must be processed to complete the import job. Each piece
          consists of an approximately equal portion of the endpoint definitions that are part of
          the import job.

        - **TotalProcessed** *(integer) --*

          The total number of endpoint definitions that were processed by the import job.

        - **Type** *(string) --*

          The job type. This value is IMPORT for import jobs.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetImportJobsResponseTypeDef = TypedDict(
    "_ClientGetImportJobsResponseTypeDef",
    {"ImportJobsResponse": ClientGetImportJobsResponseImportJobsResponseTypeDef},
    total=False,
)


class ClientGetImportJobsResponseTypeDef(_ClientGetImportJobsResponseTypeDef):
    """
    Type definition for `ClientGetImportJobs` `Response`

    The request succeeded.

    - **ImportJobsResponse** *(dict) --*

      Provides information about the status and settings of all the import jobs that are associated
      with an application or segment. An import job is a job that imports endpoint definitions from
      one or more files.

      - **Item** *(list) --*

        An array of responses, one for each import job that's associated with the application
        (Import Jobs resource) or segment (Segment Import Jobs resource).

        - *(dict) --*

          Provides information about the status and settings of a job that imports endpoint
          definitions from one or more files. The files can be stored in an Amazon Simple Storage
          Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon
          Pinpoint console.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the import job.

          - **CompletedPieces** *(integer) --*

            The number of pieces that were processed successfully (completed) by the import job, as
            of the time of the request.

          - **CompletionDate** *(string) --*

            The date, in ISO 8601 format, when the import job was completed.

          - **CreationDate** *(string) --*

            The date, in ISO 8601 format, when the import job was created.

          - **Definition** *(dict) --*

            The resource settings that apply to the import job.

            - **DefineSegment** *(boolean) --*

              Specifies whether the import job creates a segment that contains the endpoints, when
              the endpoint definitions are imported.

            - **ExternalId** *(string) --*

              (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
              trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
              importing endpoint definitions, but we removed this requirement. We don't recommend
              use of external IDs for IAM roles that are assumed by Amazon Pinpoint.

            - **Format** *(string) --*

              The format of the files that contain the endpoint definitions to import. Valid values
              are: CSV, for comma-separated values format; and, JSON, for newline-delimited JSON
              format.

              If the files are stored in an Amazon S3 location and that location contains multiple
              files that use different formats, Amazon Pinpoint imports data only from the files
              that use the specified format.

            - **RegisterEndpoints** *(boolean) --*

              Specifies whether the import job registers the endpoints with Amazon Pinpoint, when
              the endpoint definitions are imported.

            - **RoleArn** *(string) --*

              The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role
              that authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint
              definitions from.

            - **S3Url** *(string) --*

              The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the
              endpoint definitions to import. This location can be a folder or a single file. If the
              location is a folder, Amazon Pinpoint imports endpoint definitions from the files in
              this location, including any subfolders that the folder contains.

              The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
              location can end with the key for an individual object or a prefix that qualifies
              multiple objects.

            - **SegmentId** *(string) --*

              The identifier for the segment that the import job updates or adds endpoint
              definitions to, if the import job updates an existing segment.

            - **SegmentName** *(string) --*

              The custom name for the segment that's created by the import job, if the value of the
              DefineSegment property is true.

          - **FailedPieces** *(integer) --*

            The number of pieces that weren't processed successfully (failed) by the import job, as
            of the time of the request.

          - **Failures** *(list) --*

            An array of entries, one for each of the first 100 entries that weren't processed
            successfully (failed) by the import job, if any.

            - *(string) --*

          - **Id** *(string) --*

            The unique identifier for the import job.

          - **JobStatus** *(string) --*

            The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
            process one or more pieces in the job.

          - **TotalFailures** *(integer) --*

            The total number of endpoint definitions that weren't processed successfully (failed) by
            the import job, typically because an error, such as a syntax error, occurred.

          - **TotalPieces** *(integer) --*

            The total number of pieces that must be processed to complete the import job. Each piece
            consists of an approximately equal portion of the endpoint definitions that are part of
            the import job.

          - **TotalProcessed** *(integer) --*

            The total number of endpoint definitions that were processed by the import job.

          - **Type** *(string) --*

            The job type. This value is IMPORT for import jobs.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
):
    """
    Type definition for
    `ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRows` `GroupedBys`

    Provides a single value and metadata about that value as part of an array of query results for a
    standard metric that applies to an application, campaign, or journey.

    - **Key** *(string) --*

      The friendly name of the metric whose value is specified by the Value property.

    - **Type** *(string) --*

      The data type of the value specified by the Value property.

    - **Value** *(string) --*

      In a Values object, the value for the metric that the query retrieved data for. In a
      GroupedBys object, the value for the field that was used to group data in a result set that
      contains multiple results (Values objects).
    """


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRows` `Values`

    Provides a single value and metadata about that value as part of an array of query results for a
    standard metric that applies to an application, campaign, or journey.

    - **Key** *(string) --*

      The friendly name of the metric whose value is specified by the Value property.

    - **Type** *(string) --*

      The data type of the value specified by the Value property.

    - **Value** *(string) --*

      In a Values object, the value for the metric that the query retrieved data for. In a
      GroupedBys object, the value for the field that was used to group data in a result set that
      contains multiple results (Values objects).
    """


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef",
    {
        "GroupedBys": List[
            ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
        ],
        "Values": List[
            ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef
        ],
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef
):
    """
    Type definition for `ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResult`
    `Rows`

    Provides the results of a query that retrieved the data for a standard metric that applies to an
    application, campaign, or journey.

    - **GroupedBys** *(list) --*

      An array of objects that defines the field and field values that were used to group data in a
      result set that contains multiple results. This value is null if the data in a result set
      isn’t grouped.

      - *(dict) --*

        Provides a single value and metadata about that value as part of an array of query results
        for a standard metric that applies to an application, campaign, or journey.

        - **Key** *(string) --*

          The friendly name of the metric whose value is specified by the Value property.

        - **Type** *(string) --*

          The data type of the value specified by the Value property.

        - **Value** *(string) --*

          In a Values object, the value for the metric that the query retrieved data for. In a
          GroupedBys object, the value for the field that was used to group data in a result set
          that contains multiple results (Values objects).

    - **Values** *(list) --*

      An array of objects that provides pre-aggregated values for a standard metric that applies to
      an application, campaign, or journey.

      - *(dict) --*

        Provides a single value and metadata about that value as part of an array of query results
        for a standard metric that applies to an application, campaign, or journey.

        - **Key** *(string) --*

          The friendly name of the metric whose value is specified by the Value property.

        - **Type** *(string) --*

          The data type of the value specified by the Value property.

        - **Value** *(string) --*

          In a Values object, the value for the metric that the query retrieved data for. In a
          GroupedBys object, the value for the field that was used to group data in a result set
          that contains multiple results (Values objects).
    """


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef",
    {
        "Rows": List[
            ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef
        ]
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef
):
    """
    Type definition for `ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponse`
    `KpiResult`

    An array of objects that contains the results of the query. Each object contains the value for
    the metric and metadata about that value.

    - **Rows** *(list) --*

      An array of objects that provides the results of a query that retrieved the data for a
      standard metric that applies to an application, campaign, or journey.

      - *(dict) --*

        Provides the results of a query that retrieved the data for a standard metric that applies
        to an application, campaign, or journey.

        - **GroupedBys** *(list) --*

          An array of objects that defines the field and field values that were used to group data
          in a result set that contains multiple results. This value is null if the data in a result
          set isn’t grouped.

          - *(dict) --*

            Provides a single value and metadata about that value as part of an array of query
            results for a standard metric that applies to an application, campaign, or journey.

            - **Key** *(string) --*

              The friendly name of the metric whose value is specified by the Value property.

            - **Type** *(string) --*

              The data type of the value specified by the Value property.

            - **Value** *(string) --*

              In a Values object, the value for the metric that the query retrieved data for. In a
              GroupedBys object, the value for the field that was used to group data in a result set
              that contains multiple results (Values objects).

        - **Values** *(list) --*

          An array of objects that provides pre-aggregated values for a standard metric that applies
          to an application, campaign, or journey.

          - *(dict) --*

            Provides a single value and metadata about that value as part of an array of query
            results for a standard metric that applies to an application, campaign, or journey.

            - **Key** *(string) --*

              The friendly name of the metric whose value is specified by the Value property.

            - **Type** *(string) --*

              The data type of the value specified by the Value property.

            - **Value** *(string) --*

              In a Values object, the value for the metric that the query retrieved data for. In a
              GroupedBys object, the value for the field that was used to group data in a result set
              that contains multiple results (Values objects).
    """


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef",
    {
        "ApplicationId": str,
        "EndTime": datetime,
        "JourneyId": str,
        "KpiName": str,
        "KpiResult": ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef,
        "NextToken": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef
):
    """
    Type definition for `ClientGetJourneyDateRangeKpiResponse` `JourneyDateRangeKpiResponse`

    Provides the results of a query that retrieved the data for a standard engagement metric that
    applies to a journey, and provides information about that query.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the metric applies to.

    - **EndTime** *(datetime) --*

      The last date and time of the date range that was used to filter the query results, in
      extended ISO 8601 format. The date range is inclusive.

    - **JourneyId** *(string) --*

      The unique identifier for the journey that the metric applies to.

    - **KpiName** *(string) --*

      The name of the metric, also referred to as a *key performance indicator (KPI)* , that the
      data was retrieved for. This value describes the associated metric and consists of two or more
      terms, which are comprised of lowercase alphanumeric characters, separated by a hyphen. For a
      list of possible values, see the `Amazon Pinpoint Developer Guide
      <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

    - **KpiResult** *(dict) --*

      An array of objects that contains the results of the query. Each object contains the value for
      the metric and metadata about that value.

      - **Rows** *(list) --*

        An array of objects that provides the results of a query that retrieved the data for a
        standard metric that applies to an application, campaign, or journey.

        - *(dict) --*

          Provides the results of a query that retrieved the data for a standard metric that applies
          to an application, campaign, or journey.

          - **GroupedBys** *(list) --*

            An array of objects that defines the field and field values that were used to group data
            in a result set that contains multiple results. This value is null if the data in a
            result set isn’t grouped.

            - *(dict) --*

              Provides a single value and metadata about that value as part of an array of query
              results for a standard metric that applies to an application, campaign, or journey.

              - **Key** *(string) --*

                The friendly name of the metric whose value is specified by the Value property.

              - **Type** *(string) --*

                The data type of the value specified by the Value property.

              - **Value** *(string) --*

                In a Values object, the value for the metric that the query retrieved data for. In a
                GroupedBys object, the value for the field that was used to group data in a result
                set that contains multiple results (Values objects).

          - **Values** *(list) --*

            An array of objects that provides pre-aggregated values for a standard metric that
            applies to an application, campaign, or journey.

            - *(dict) --*

              Provides a single value and metadata about that value as part of an array of query
              results for a standard metric that applies to an application, campaign, or journey.

              - **Key** *(string) --*

                The friendly name of the metric whose value is specified by the Value property.

              - **Type** *(string) --*

                The data type of the value specified by the Value property.

              - **Value** *(string) --*

                In a Values object, the value for the metric that the query retrieved data for. In a
                GroupedBys object, the value for the field that was used to group data in a result
                set that contains multiple results (Values objects).

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null for the Journey Engagement Metrics resource because the resource
      returns all results in a single page.

    - **StartTime** *(datetime) --*

      The first date and time of the date range that was used to filter the query results, in
      extended ISO 8601 format. The date range is inclusive.
    """


_ClientGetJourneyDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseTypeDef",
    {
        "JourneyDateRangeKpiResponse": ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseTypeDef(_ClientGetJourneyDateRangeKpiResponseTypeDef):
    """
    Type definition for `ClientGetJourneyDateRangeKpi` `Response`

    The request succeeded.

    - **JourneyDateRangeKpiResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard engagement metric that
      applies to a journey, and provides information about that query.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.

      - **EndTime** *(datetime) --*

        The last date and time of the date range that was used to filter the query results, in
        extended ISO 8601 format. The date range is inclusive.

      - **JourneyId** *(string) --*

        The unique identifier for the journey that the metric applies to.

      - **KpiName** *(string) --*

        The name of the metric, also referred to as a *key performance indicator (KPI)* , that the
        data was retrieved for. This value describes the associated metric and consists of two or
        more terms, which are comprised of lowercase alphanumeric characters, separated by a hyphen.
        For a list of possible values, see the `Amazon Pinpoint Developer Guide
        <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

      - **KpiResult** *(dict) --*

        An array of objects that contains the results of the query. Each object contains the value
        for the metric and metadata about that value.

        - **Rows** *(list) --*

          An array of objects that provides the results of a query that retrieved the data for a
          standard metric that applies to an application, campaign, or journey.

          - *(dict) --*

            Provides the results of a query that retrieved the data for a standard metric that
            applies to an application, campaign, or journey.

            - **GroupedBys** *(list) --*

              An array of objects that defines the field and field values that were used to group
              data in a result set that contains multiple results. This value is null if the data in
              a result set isn’t grouped.

              - *(dict) --*

                Provides a single value and metadata about that value as part of an array of query
                results for a standard metric that applies to an application, campaign, or journey.

                - **Key** *(string) --*

                  The friendly name of the metric whose value is specified by the Value property.

                - **Type** *(string) --*

                  The data type of the value specified by the Value property.

                - **Value** *(string) --*

                  In a Values object, the value for the metric that the query retrieved data for. In
                  a GroupedBys object, the value for the field that was used to group data in a
                  result set that contains multiple results (Values objects).

            - **Values** *(list) --*

              An array of objects that provides pre-aggregated values for a standard metric that
              applies to an application, campaign, or journey.

              - *(dict) --*

                Provides a single value and metadata about that value as part of an array of query
                results for a standard metric that applies to an application, campaign, or journey.

                - **Key** *(string) --*

                  The friendly name of the metric whose value is specified by the Value property.

                - **Type** *(string) --*

                  The data type of the value specified by the Value property.

                - **Value** *(string) --*

                  In a Values object, the value for the metric that the query retrieved data for. In
                  a GroupedBys object, the value for the field that was used to group data in a
                  result set that contains multiple results (Values objects).

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null for the Journey Engagement Metrics resource because the
        resource returns all results in a single page.

      - **StartTime** *(datetime) --*

        The first date and time of the date range that was used to filter the query results, in
        extended ISO 8601 format. The date range is inclusive.
    """


_ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef",
    {
        "ActivityType": str,
        "ApplicationId": str,
        "JourneyActivityId": str,
        "JourneyId": str,
        "LastEvaluatedTime": str,
        "Metrics": Dict[str, str],
    },
    total=False,
)


class ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef(
    _ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef
):
    """
    Type definition for `ClientGetJourneyExecutionActivityMetricsResponse`
    `JourneyExecutionActivityMetricsResponse`

    Provides the results of a query that retrieved the data for a standard execution metric that
    applies to a journey activity, and provides information about that query.

    - **ActivityType** *(string) --*

      The type of activity that the metric applies to. Possible values are:

      * CONDITIONAL_SPLIT - For a yes/no split activity, which is an activity that sends
      participants down one of two paths in a journey.

      * HOLDOUT - For a holdout activity, which is an activity that stops a journey for a specified
      percentage of participants.

      * MESSAGE - For an email activity, which is an activity that sends an email message to
      participants.

      * MULTI_CONDITIONAL_SPLIT - For a multivariate split activity, which is an activity that sends
      participants down one of as many as five paths in a journey.

      * RANDOM_SPLIT - For a random split activity, which is an activity that sends specified
      percentages of participants down one of as many as five paths in a journey.

      * WAIT - For a wait activity, which is an activity that waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the metric applies to.

    - **JourneyActivityId** *(string) --*

      The unique identifier for the activity that the metric applies to.

    - **JourneyId** *(string) --*

      The unique identifier for the journey that the metric applies to.

    - **LastEvaluatedTime** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint last evaluated the execution
      status of the activity and updated the data for the metric.

    - **Metrics** *(dict) --*

      A JSON object that contains the results of the query. The results vary depending on the type
      of activity (ActivityType). For information about the structure and contents of the results,
      see the `Amazon Pinpoint Developer Guide
      <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

      - *(string) --*

        - *(string) --*
    """


_ClientGetJourneyExecutionActivityMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionActivityMetricsResponseTypeDef",
    {
        "JourneyExecutionActivityMetricsResponse": ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef
    },
    total=False,
)


class ClientGetJourneyExecutionActivityMetricsResponseTypeDef(
    _ClientGetJourneyExecutionActivityMetricsResponseTypeDef
):
    """
    Type definition for `ClientGetJourneyExecutionActivityMetrics` `Response`

    The request succeeded.

    - **JourneyExecutionActivityMetricsResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard execution metric that
      applies to a journey activity, and provides information about that query.

      - **ActivityType** *(string) --*

        The type of activity that the metric applies to. Possible values are:

        * CONDITIONAL_SPLIT - For a yes/no split activity, which is an activity that sends
        participants down one of two paths in a journey.

        * HOLDOUT - For a holdout activity, which is an activity that stops a journey for a
        specified percentage of participants.

        * MESSAGE - For an email activity, which is an activity that sends an email message to
        participants.

        * MULTI_CONDITIONAL_SPLIT - For a multivariate split activity, which is an activity that
        sends participants down one of as many as five paths in a journey.

        * RANDOM_SPLIT - For a random split activity, which is an activity that sends specified
        percentages of participants down one of as many as five paths in a journey.

        * WAIT - For a wait activity, which is an activity that waits for a certain amount of time
        or until a specific date and time before moving participants to the next activity in a
        journey.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.

      - **JourneyActivityId** *(string) --*

        The unique identifier for the activity that the metric applies to.

      - **JourneyId** *(string) --*

        The unique identifier for the journey that the metric applies to.

      - **LastEvaluatedTime** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint last evaluated the execution
        status of the activity and updated the data for the metric.

      - **Metrics** *(dict) --*

        A JSON object that contains the results of the query. The results vary depending on the type
        of activity (ActivityType). For information about the structure and contents of the results,
        see the `Amazon Pinpoint Developer Guide
        <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

        - *(string) --*

          - *(string) --*
    """


_ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef",
    {"ApplicationId": str, "JourneyId": str, "LastEvaluatedTime": str, "Metrics": Dict[str, str]},
    total=False,
)


class ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef(
    _ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef
):
    """
    Type definition for `ClientGetJourneyExecutionMetricsResponse` `JourneyExecutionMetricsResponse`

    Provides the results of a query that retrieved the data for a standard execution metric that
    applies to a journey, and provides information about that query.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the metric applies to.

    - **JourneyId** *(string) --*

      The unique identifier for the journey that the metric applies to.

    - **LastEvaluatedTime** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint last evaluated the journey and
      updated the data for the metric.

    - **Metrics** *(dict) --*

      A JSON object that contains the results of the query. For information about the structure and
      contents of the results, see the `Amazon Pinpoint Developer Guide
      <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

      - *(string) --*

        - *(string) --*
    """


_ClientGetJourneyExecutionMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionMetricsResponseTypeDef",
    {
        "JourneyExecutionMetricsResponse": ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef
    },
    total=False,
)


class ClientGetJourneyExecutionMetricsResponseTypeDef(
    _ClientGetJourneyExecutionMetricsResponseTypeDef
):
    """
    Type definition for `ClientGetJourneyExecutionMetrics` `Response`

    The request succeeded.

    - **JourneyExecutionMetricsResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard execution metric that
      applies to a journey, and provides information about that query.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.

      - **JourneyId** *(string) --*

        The unique identifier for the journey that the metric applies to.

      - **LastEvaluatedTime** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint last evaluated the journey and
        updated the data for the metric.

      - **Metrics** *(dict) --*

        A JSON object that contains the results of the query. For information about the structure
        and contents of the results, see the `Amazon Pinpoint Developer Guide
        <https://docs.aws.amazon.com/pinpoint/latest/developerguide/welcome.html>`__ .

        - *(string) --*

          - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitCondition`
    `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --*

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivities` `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesEMAIL` `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --*

      The percentage of participants who shouldn't continue the journey.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranches`
    `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesMultiCondition` `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --*

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesRandomSplit` `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {"Branches": List[ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponse` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --*

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientGetJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientGetJourneyResponseJourneyResponseLimitsTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponse` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponse` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientGetJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientGetJourneyResponseJourneyResponseScheduleTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponse` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponseStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientGetJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseStartConditionTypeDef
):
    """
    Type definition for `ClientGetJourneyResponseJourneyResponse` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.
    """


_ClientGetJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientGetJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientGetJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientGetJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientGetJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": str,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseTypeDef(
    _ClientGetJourneyResponseJourneyResponseTypeDef
):
    """
    Type definition for `ClientGetJourneyResponse` `JourneyResponse`

    Provides information about the status, configuration, and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --*

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the journey applies to.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **Id** *(string) --*

      The unique identifier for the journey.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. If this value is true, the schedule uses each participant's local time.

    - **Name** *(string) --*

      The name of the journey.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The current status of the journey. Possible values are:

      * DRAFT - The journey is being developed and hasn't been published yet.

      * ACTIVE - The journey has been developed and published. Depending on the journey's schedule,
      the journey may currently be running or scheduled to start running at a later time. If a
      journey's status is ACTIVE, you can't add, change, or remove activities from it.

      * COMPLETED - The journey has been published and has finished running. All participants have
      entered the journey and no participants are waiting to complete the journey or any activities
      in the journey.

      * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't add,
      change, or remove activities or segment settings from the journey.

      * CLOSED - The journey has been published and has started running. It may have also passed its
      scheduled end time, or passed its scheduled start time and a refresh frequency hasn't been
      specified for it. If a journey's status is CLOSED, you can't add participants to it, and no
      existing participants can enter the journey for the first time. However, any existing
      participants who are currently waiting to start an activity may resume the journey.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the journey. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientGetJourneyResponseTypeDef = TypedDict(
    "_ClientGetJourneyResponseTypeDef",
    {"JourneyResponse": ClientGetJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientGetJourneyResponseTypeDef(_ClientGetJourneyResponseTypeDef):
    """
    Type definition for `ClientGetJourney` `Response`

    The request succeeded.

    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.

      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.

        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.

            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.

              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.

                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.

                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                - **Operator** *(string) --*

                  Specifies how to handle multiple conditions for the activity. For example, if you
                  specify two conditions for an activity, whether both or only one of the conditions
                  must be met for the activity to be performed.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait before determining whether the conditions are met, or the
                date and time when Amazon Pinpoint determines whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

              - **FalseActivity** *(string) --*

                The unique identifier for the activity to perform if the condition isn't met.

              - **TrueActivity** *(string) --*

                The unique identifier for the activity to perform if the condition is met.

            - **Description** *(string) --*

              The custom description of the activity.

            - **EMAIL** *(dict) --*

              The settings for an email activity. This type of activity sends an email message to
              participants.

              - **MessageConfig** *(dict) --*

                The "From" address to use for the message.

                - **FromAddress** *(string) --*

                  The verified email address to send the email message from. The default address is
                  the FromAddress specified for the email channel for the application.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after the message is sent.

              - **TemplateName** *(string) --*

                The name of the email template to use for the message.

            - **Holdout** *(dict) --*

              The settings for a holdout activity. This type of activity stops a journey for a
              specified percentage of participants.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the holdout
                activity.

              - **Percentage** *(integer) --*

                The percentage of participants who shouldn't continue the journey.

            - **MultiCondition** *(dict) --*

              The settings for a multivariate split activity. This type of activity sends
              participants down one of as many as five paths in a journey, based on conditions that
              you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the conditions for entering each path and the
                activity to perform for each path.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity path in a journey.

                  - **Condition** *(dict) --*

                    The condition to evaluate for the activity path.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

              - **DefaultActivity** *(string) --*

                The activity to perform by default for any path in the activity.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait or the date and time when Amazon Pinpoint determines
                whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

            - **RandomSplit** *(dict) --*

              The settings for a random split activity. This type of activity randomly sends
              specified percentages of participants down one of as many as five paths in a journey,
              based on conditions that you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the percentage of participants to enter each
                path and the activity to perform for each path.

                - *(dict) --*

                  Specifies the settings for a path in a random split activity in a journey.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

                  - **Percentage** *(integer) --*

                    The percentage of participants to send down the activity path.

            - **Wait** *(dict) --*

              The settings for a wait activity. This type of activity waits for a certain amount of
              time or until a specific date and time before moving participants to the next activity
              in a journey.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the wait
                activity.

              - **WaitTime** *(dict) --*

                The amount of time to wait or the date and time when the activity moves participants
                to the next activity in the journey.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the journey applies to.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the journey was created.

      - **Id** *(string) --*

        The unique identifier for the journey.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the journey was last modified.

      - **Limits** *(dict) --*

        The messaging and entry limits for the journey.

        - **DailyCap** *(integer) --*

          The maximum number of messages that the journey can send to a single participant during a
          24-hour period. The maximum value is 100.

        - **EndpointReentryCap** *(integer) --*

          The maximum number of times that a participant can enter the journey. The maximum value is
          100. To allow participants to enter the journey an unlimited number of times, set this
          value to 0.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that the journey can send each second.

      - **LocalTime** *(boolean) --*

        Specifies whether the journey's scheduled start and end times use each participant's local
        time. If this value is true, the schedule uses each participant's local time.

      - **Name** *(string) --*

        The name of the journey.

      - **QuietTime** *(dict) --*

        The quiet time settings for the journey. Quiet time is a specific time range when a journey
        doesn't send messages to participants, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
        valid value.

        * The current time in the participant's time zone is later than or equal to the time
        specified by the QuietTime.Start property for the journey.

        * The current time in the participant's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the journey.

        If any of the preceding conditions isn't met, the participant will receive messages from the
        journey, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **RefreshFrequency** *(string) --*

        The frequency with which Amazon Pinpoint evaluates segment and event data for the journey,
        as a duration in ISO 8601 format.

      - **Schedule** *(dict) --*

        The schedule settings for the journey.

        - **EndTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey ended or will end.

        - **StartTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
          UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45,
          UTC-02, UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
          UTC-09:30, UTC-10, and UTC-11.

      - **StartActivity** *(string) --*

        The unique identifier for the first activity in the journey.

      - **StartCondition** *(dict) --*

        The segment that defines which users are participants in the journey.

        - **Description** *(string) --*

          The custom description of the condition.

        - **SegmentStartCondition** *(dict) --*

          The segment that's associated with the first activity in the journey. This segment
          determines which users are participants in the journey.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

      - **State** *(string) --*

        The current status of the journey. Possible values are:

        * DRAFT - The journey is being developed and hasn't been published yet.

        * ACTIVE - The journey has been developed and published. Depending on the journey's
        schedule, the journey may currently be running or scheduled to start running at a later
        time. If a journey's status is ACTIVE, you can't add, change, or remove activities from it.

        * COMPLETED - The journey has been published and has finished running. All participants have
        entered the journey and no participants are waiting to complete the journey or any
        activities in the journey.

        * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't
        add, change, or remove activities or segment settings from the journey.

        * CLOSED - The journey has been published and has started running. It may have also passed
        its scheduled end time, or passed its scheduled start time and a refresh frequency hasn't
        been specified for it. If a journey's status is CLOSED, you can't add participants to it,
        and no existing participants can enter the journey for the first time. However, any existing
        participants who are currently waiting to start an activity may resume the journey.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the journey. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef
):
    """
    Type definition for `ClientGetPushTemplateResponsePushNotificationTemplateResponse` `ADM`

    The message template that's used for the ADM (Amazon Device Messaging) channel. This message
    template overrides the default template for push notification channels
    (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef",
    {
        "Action": str,
        "Body": str,
        "MediaUrl": str,
        "RawContent": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef
):
    """
    Type definition for `ClientGetPushTemplateResponsePushNotificationTemplateResponse` `APNS`

    The message template that's used for the APNs (Apple Push Notification service) channel. This
    message template overrides the default template for push notification channels
    (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in push notifications that are based on the message template.

    - **MediaUrl** *(string) --*

      The URL of an image or video to display in push notifications that are based on the message
      template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for push notifications that are based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **Sound** *(string) --*

      The key for the sound to play when the recipient receives a push notification that's based on
      the message template. The value for this key is the name of a sound file in your app's main
      bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
      found or you specify default for the value, the system plays the default alert sound.

    - **Title** *(string) --*

      The title to use in push notifications that are based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef
):
    """
    Type definition for `ClientGetPushTemplateResponsePushNotificationTemplateResponse` `Baidu`

    The message template that's used for the Baidu (Baidu Cloud Push) channel. This message template
    overrides the default template for push notification channels (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef",
    {"Action": str, "Body": str, "Sound": str, "Title": str, "Url": str},
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef
):
    """
    Type definition for `ClientGetPushTemplateResponsePushNotificationTemplateResponse` `Default`

    The default message template that's used for push notification channels.

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS and Android platforms.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in push notifications that are based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      For an iOS platform, this value is the key for the name of a sound file in your app's main
      bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
      found or you specify default for the value, the system plays the default alert sound.

    - **Title** *(string) --*

      The title to use in push notifications that are based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef
):
    """
    Type definition for `ClientGetPushTemplateResponsePushNotificationTemplateResponse` `GCM`

    The message template that's used for the GCM channel, which is used to send notifications
    through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service. This
    message template overrides the default template for push notification channels
    (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef",
    {
        "ADM": ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef,
        "APNS": ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef,
        "Arn": str,
        "Baidu": ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef,
        "CreationDate": str,
        "Default": ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef,
        "DefaultSubstitutions": str,
        "GCM": ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef
):
    """
    Type definition for `ClientGetPushTemplateResponse` `PushNotificationTemplateResponse`

    Provides information about the content and settings for a message template that can be used in
    messages that are sent through a push notification channel.

    - **ADM** *(dict) --*

      The message template that's used for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **APNS** *(dict) --*

      The message template that's used for the APNs (Apple Push Notification service) channel. This
      message template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in push notifications that are based on the message template.

      - **MediaUrl** *(string) --*

        The URL of an image or video to display in push notifications that are based on the message
        template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for push notifications that are based
        on the message template. If specified, this value overrides all other content for the
        message template.

      - **Sound** *(string) --*

        The key for the sound to play when the recipient receives a push notification that's based
        on the message template. The value for this key is the name of a sound file in your app's
        main bundle or the Library/Sounds folder in your app's data container. If the sound file
        can't be found or you specify default for the value, the system plays the default alert
        sound.

      - **Title** *(string) --*

        The title to use in push notifications that are based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template.

    - **Baidu** *(dict) --*

      The message template that's used for the Baidu (Baidu Cloud Push) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **CreationDate** *(string) --*

      The date when the message template was created.

    - **Default** *(dict) --*

      The default message template that's used for push notification channels.

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS and Android platforms.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in push notifications that are based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

        For an iOS platform, this value is the key for the name of a sound file in your app's main
        bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
        found or you specify default for the value, the system plays the default alert sound.

      - **Title** *(string) --*

        The title to use in push notifications that are based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **DefaultSubstitutions** *(string) --*

      The JSON object that specifies the default values that are used for message variables in the
      message template. This object is a set of key-value pairs. Each key defines a message variable
      in the template. The corresponding value defines the default value for that variable.

    - **GCM** *(dict) --*

      The message template that's used for the GCM channel, which is used to send notifications
      through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
      This message template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **LastModifiedDate** *(string) --*

      The date when the message template was last modified.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the message template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      The custom description of the message template.

    - **TemplateName** *(string) --*

      The name of the message template.

    - **TemplateType** *(string) --*

      The type of channel that the message template is designed for. For a push notification
      template, this value is PUSH.
    """


_ClientGetPushTemplateResponseTypeDef = TypedDict(
    "_ClientGetPushTemplateResponseTypeDef",
    {
        "PushNotificationTemplateResponse": ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef
    },
    total=False,
)


class ClientGetPushTemplateResponseTypeDef(_ClientGetPushTemplateResponseTypeDef):
    """
    Type definition for `ClientGetPushTemplate` `Response`

    The request succeeded.

    - **PushNotificationTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      messages that are sent through a push notification channel.

      - **ADM** *(dict) --*

        The message template that's used for the ADM (Amazon Device Messaging) channel. This message
        template overrides the default template for push notification channels
        (DefaultPushNotificationTemplate).

        - **Action** *(string) --*

          The action to occur if a recipient taps a push notification that's based on the message
          template. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The message body to use in a push notification that's based on the message template.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of a push notification
          that's based on the message template.

        - **ImageUrl** *(string) --*

          The URL of an image to display in a push notification that's based on the message
          template.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for a push notification that's based
          on the message template. If specified, this value overrides all other content for the
          message template.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of a
          push notification that's based on the message template.

        - **Sound** *(string) --*

          The sound to play when a recipient receives a push notification that's based on the
          message template. You can use the default stream or specify the file name of a sound
          resource that's bundled in your app. On an Android platform, the sound file must reside in
          /res/raw/.

        - **Title** *(string) --*

          The title to use in a push notification that's based on the message template. This title
          appears above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps a a push
          notification that's based on the message template and the value of the Action property is
          URL.

      - **APNS** *(dict) --*

        The message template that's used for the APNs (Apple Push Notification service) channel.
        This message template overrides the default template for push notification channels
        (DefaultPushNotificationTemplate).

        - **Action** *(string) --*

          The action to occur if a recipient taps a push notification that's based on the message
          template. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of the iOS platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The message body to use in push notifications that are based on the message template.

        - **MediaUrl** *(string) --*

          The URL of an image or video to display in push notifications that are based on the
          message template.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for push notifications that are based
          on the message template. If specified, this value overrides all other content for the
          message template.

        - **Sound** *(string) --*

          The key for the sound to play when the recipient receives a push notification that's based
          on the message template. The value for this key is the name of a sound file in your app's
          main bundle or the Library/Sounds folder in your app's data container. If the sound file
          can't be found or you specify default for the value, the system plays the default alert
          sound.

        - **Title** *(string) --*

          The title to use in push notifications that are based on the message template. This title
          appears above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps a push
          notification that's based on the message template and the value of the Action property is
          URL.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.

      - **Baidu** *(dict) --*

        The message template that's used for the Baidu (Baidu Cloud Push) channel. This message
        template overrides the default template for push notification channels
        (DefaultPushNotificationTemplate).

        - **Action** *(string) --*

          The action to occur if a recipient taps a push notification that's based on the message
          template. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The message body to use in a push notification that's based on the message template.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of a push notification
          that's based on the message template.

        - **ImageUrl** *(string) --*

          The URL of an image to display in a push notification that's based on the message
          template.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for a push notification that's based
          on the message template. If specified, this value overrides all other content for the
          message template.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of a
          push notification that's based on the message template.

        - **Sound** *(string) --*

          The sound to play when a recipient receives a push notification that's based on the
          message template. You can use the default stream or specify the file name of a sound
          resource that's bundled in your app. On an Android platform, the sound file must reside in
          /res/raw/.

        - **Title** *(string) --*

          The title to use in a push notification that's based on the message template. This title
          appears above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps a a push
          notification that's based on the message template and the value of the Action property is
          URL.

      - **CreationDate** *(string) --*

        The date when the message template was created.

      - **Default** *(dict) --*

        The default message template that's used for push notification channels.

        - **Action** *(string) --*

          The action to occur if a recipient taps a push notification that's based on the message
          template. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of the iOS and Android platforms.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The message body to use in push notifications that are based on the message template.

        - **Sound** *(string) --*

          The sound to play when a recipient receives a push notification that's based on the
          message template. You can use the default stream or specify the file name of a sound
          resource that's bundled in your app. On an Android platform, the sound file must reside in
          /res/raw/.

          For an iOS platform, this value is the key for the name of a sound file in your app's main
          bundle or the Library/Sounds folder in your app's data container. If the sound file can't
          be found or you specify default for the value, the system plays the default alert sound.

        - **Title** *(string) --*

          The title to use in push notifications that are based on the message template. This title
          appears above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps a push
          notification that's based on the message template and the value of the Action property is
          URL.

      - **DefaultSubstitutions** *(string) --*

        The JSON object that specifies the default values that are used for message variables in the
        message template. This object is a set of key-value pairs. Each key defines a message
        variable in the template. The corresponding value defines the default value for that
        variable.

      - **GCM** *(dict) --*

        The message template that's used for the GCM channel, which is used to send notifications
        through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
        This message template overrides the default template for push notification channels
        (DefaultPushNotificationTemplate).

        - **Action** *(string) --*

          The action to occur if a recipient taps a push notification that's based on the message
          template. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The message body to use in a push notification that's based on the message template.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of a push notification
          that's based on the message template.

        - **ImageUrl** *(string) --*

          The URL of an image to display in a push notification that's based on the message
          template.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for a push notification that's based
          on the message template. If specified, this value overrides all other content for the
          message template.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of a
          push notification that's based on the message template.

        - **Sound** *(string) --*

          The sound to play when a recipient receives a push notification that's based on the
          message template. You can use the default stream or specify the file name of a sound
          resource that's bundled in your app. On an Android platform, the sound file must reside in
          /res/raw/.

        - **Title** *(string) --*

          The title to use in a push notification that's based on the message template. This title
          appears above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps a a push
          notification that's based on the message template and the value of the Action property is
          URL.

      - **LastModifiedDate** *(string) --*

        The date when the message template was last modified.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the message template. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateDescription** *(string) --*

        The custom description of the message template.

      - **TemplateName** *(string) --*

        The name of the message template.

      - **TemplateType** *(string) --*

        The type of channel that the message template is designed for. For a push notification
        template, this value is PUSH.
    """


_ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef(
    _ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef
):
    """
    Type definition for `ClientGetSegmentExportJobsResponseExportJobsResponseItem` `Definition`

    The resource settings that apply to the export job.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
      were exported to.

    - **S3UrlPrefix** *(string) --*

      The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
      endpoint definitions were exported to. This location is typically a folder that contains
      multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

    - **SegmentId** *(string) --*

      The identifier for the segment that the endpoint definitions were exported from. If this value
      isn't present, Amazon Pinpoint exported definitions for all the endpoints that are associated
      with the application.

    - **SegmentVersion** *(integer) --*

      The version of the segment that the endpoint definitions were exported from.
    """


_ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef(
    _ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef
):
    """
    Type definition for `ClientGetSegmentExportJobsResponseExportJobsResponse` `Item`

    Provides information about the status and settings of a job that exports endpoint definitions to
    a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3) bucket by
    using the Amazon Pinpoint API or downloaded directly to a computer by using the Amazon Pinpoint
    console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the export job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the export job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the export job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the export job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the export job.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint definitions
        were exported to.

      - **S3UrlPrefix** *(string) --*

        The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
        endpoint definitions were exported to. This location is typically a folder that contains
        multiple files. The URL should be in the following format: s3://bucket-name/folder-name/.

      - **SegmentId** *(string) --*

        The identifier for the segment that the endpoint definitions were exported from. If this
        value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
        associated with the application.

      - **SegmentVersion** *(integer) --*

        The version of the segment that the endpoint definitions were exported from.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the export job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the export job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the export job.

    - **JobStatus** *(string) --*

      The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      export job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the export job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      export job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the export job.

    - **Type** *(string) --*

      The job type. This value is EXPORT for export jobs.
    """


_ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef",
    {
        "Item": List[ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef(
    _ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef
):
    """
    Type definition for `ClientGetSegmentExportJobsResponse` `ExportJobsResponse`

    Provides information about all the export jobs that are associated with an application or
    segment. An export job is a job that exports endpoint definitions to a file.

    - **Item** *(list) --*

      An array of responses, one for each export job that's associated with the application (Export
      Jobs resource) or segment (Segment Export Jobs resource).

      - *(dict) --*

        Provides information about the status and settings of a job that exports endpoint
        definitions to a file. The file can be added directly to an Amazon Simple Storage Service
        (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer by
        using the Amazon Pinpoint console.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the export job.

        - **CompletedPieces** *(integer) --*

          The number of pieces that were processed successfully (completed) by the export job, as of
          the time of the request.

        - **CompletionDate** *(string) --*

          The date, in ISO 8601 format, when the export job was completed.

        - **CreationDate** *(string) --*

          The date, in ISO 8601 format, when the export job was created.

        - **Definition** *(dict) --*

          The resource settings that apply to the export job.

          - **RoleArn** *(string) --*

            The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
            authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint
            definitions were exported to.

          - **S3UrlPrefix** *(string) --*

            The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where the
            endpoint definitions were exported to. This location is typically a folder that contains
            multiple files. The URL should be in the following format:
            s3://bucket-name/folder-name/.

          - **SegmentId** *(string) --*

            The identifier for the segment that the endpoint definitions were exported from. If this
            value isn't present, Amazon Pinpoint exported definitions for all the endpoints that are
            associated with the application.

          - **SegmentVersion** *(integer) --*

            The version of the segment that the endpoint definitions were exported from.

        - **FailedPieces** *(integer) --*

          The number of pieces that weren't processed successfully (failed) by the export job, as of
          the time of the request.

        - **Failures** *(list) --*

          An array of entries, one for each of the first 100 entries that weren't processed
          successfully (failed) by the export job, if any.

          - *(string) --*

        - **Id** *(string) --*

          The unique identifier for the export job.

        - **JobStatus** *(string) --*

          The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
          process one or more pieces in the job.

        - **TotalFailures** *(integer) --*

          The total number of endpoint definitions that weren't processed successfully (failed) by
          the export job, typically because an error, such as a syntax error, occurred.

        - **TotalPieces** *(integer) --*

          The total number of pieces that must be processed to complete the export job. Each piece
          consists of an approximately equal portion of the endpoint definitions that are part of
          the export job.

        - **TotalProcessed** *(integer) --*

          The total number of endpoint definitions that were processed by the export job.

        - **Type** *(string) --*

          The job type. This value is EXPORT for export jobs.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetSegmentExportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseTypeDef",
    {"ExportJobsResponse": ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef},
    total=False,
)


class ClientGetSegmentExportJobsResponseTypeDef(_ClientGetSegmentExportJobsResponseTypeDef):
    """
    Type definition for `ClientGetSegmentExportJobs` `Response`

    The request succeeded.

    - **ExportJobsResponse** *(dict) --*

      Provides information about all the export jobs that are associated with an application or
      segment. An export job is a job that exports endpoint definitions to a file.

      - **Item** *(list) --*

        An array of responses, one for each export job that's associated with the application
        (Export Jobs resource) or segment (Segment Export Jobs resource).

        - *(dict) --*

          Provides information about the status and settings of a job that exports endpoint
          definitions to a file. The file can be added directly to an Amazon Simple Storage Service
          (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer
          by using the Amazon Pinpoint console.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the export job.

          - **CompletedPieces** *(integer) --*

            The number of pieces that were processed successfully (completed) by the export job, as
            of the time of the request.

          - **CompletionDate** *(string) --*

            The date, in ISO 8601 format, when the export job was completed.

          - **CreationDate** *(string) --*

            The date, in ISO 8601 format, when the export job was created.

          - **Definition** *(dict) --*

            The resource settings that apply to the export job.

            - **RoleArn** *(string) --*

              The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role
              that authorized Amazon Pinpoint to access the Amazon S3 location where the endpoint
              definitions were exported to.

            - **S3UrlPrefix** *(string) --*

              The URL of the location in an Amazon Simple Storage Service (Amazon S3) bucket where
              the endpoint definitions were exported to. This location is typically a folder that
              contains multiple files. The URL should be in the following format:
              s3://bucket-name/folder-name/.

            - **SegmentId** *(string) --*

              The identifier for the segment that the endpoint definitions were exported from. If
              this value isn't present, Amazon Pinpoint exported definitions for all the endpoints
              that are associated with the application.

            - **SegmentVersion** *(integer) --*

              The version of the segment that the endpoint definitions were exported from.

          - **FailedPieces** *(integer) --*

            The number of pieces that weren't processed successfully (failed) by the export job, as
            of the time of the request.

          - **Failures** *(list) --*

            An array of entries, one for each of the first 100 entries that weren't processed
            successfully (failed) by the export job, if any.

            - *(string) --*

          - **Id** *(string) --*

            The unique identifier for the export job.

          - **JobStatus** *(string) --*

            The status of the export job. The job status is FAILED if Amazon Pinpoint wasn't able to
            process one or more pieces in the job.

          - **TotalFailures** *(integer) --*

            The total number of endpoint definitions that weren't processed successfully (failed) by
            the export job, typically because an error, such as a syntax error, occurred.

          - **TotalPieces** *(integer) --*

            The total number of pieces that must be processed to complete the export job. Each piece
            consists of an approximately equal portion of the endpoint definitions that are part of
            the export job.

          - **TotalProcessed** *(integer) --*

            The total number of endpoint definitions that were processed by the export job.

          - **Type** *(string) --*

            The job type. This value is EXPORT for export jobs.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": str,
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef(
    _ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef
):
    """
    Type definition for `ClientGetSegmentImportJobsResponseImportJobsResponseItem` `Definition`

    The resource settings that apply to the import job.

    - **DefineSegment** *(boolean) --*

      Specifies whether the import job creates a segment that contains the endpoints, when the
      endpoint definitions are imported.

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that contain the endpoint definitions to import. Valid values are:
      CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

      If the files are stored in an Amazon S3 location and that location contains multiple files
      that use different formats, Amazon Pinpoint imports data only from the files that use the
      specified format.

    - **RegisterEndpoints** *(boolean) --*

      Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
      endpoint definitions are imported.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
      definitions to import. This location can be a folder or a single file. If the location is a
      folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
      including any subfolders that the folder contains.

      The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
      location can end with the key for an individual object or a prefix that qualifies multiple
      objects.

    - **SegmentId** *(string) --*

      The identifier for the segment that the import job updates or adds endpoint definitions to, if
      the import job updates an existing segment.

    - **SegmentName** *(string) --*

      The custom name for the segment that's created by the import job, if the value of the
      DefineSegment property is true.
    """


_ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": str,
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef(
    _ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef
):
    """
    Type definition for `ClientGetSegmentImportJobsResponseImportJobsResponse` `Item`

    Provides information about the status and settings of a job that imports endpoint definitions
    from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon S3)
    bucket or uploaded directly from a computer by using the Amazon Pinpoint console.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the import job.

    - **CompletedPieces** *(integer) --*

      The number of pieces that were processed successfully (completed) by the import job, as of the
      time of the request.

    - **CompletionDate** *(string) --*

      The date, in ISO 8601 format, when the import job was completed.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the import job was created.

    - **Definition** *(dict) --*

      The resource settings that apply to the import job.

      - **DefineSegment** *(boolean) --*

        Specifies whether the import job creates a segment that contains the endpoints, when the
        endpoint definitions are imported.

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that contain the endpoint definitions to import. Valid values are:
        CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

        If the files are stored in an Amazon S3 location and that location contains multiple files
        that use different formats, Amazon Pinpoint imports data only from the files that use the
        specified format.

      - **RegisterEndpoints** *(boolean) --*

        Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
        endpoint definitions are imported.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the endpoint
        definitions to import. This location can be a folder or a single file. If the location is a
        folder, Amazon Pinpoint imports endpoint definitions from the files in this location,
        including any subfolders that the folder contains.

        The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
        location can end with the key for an individual object or a prefix that qualifies multiple
        objects.

      - **SegmentId** *(string) --*

        The identifier for the segment that the import job updates or adds endpoint definitions to,
        if the import job updates an existing segment.

      - **SegmentName** *(string) --*

        The custom name for the segment that's created by the import job, if the value of the
        DefineSegment property is true.

    - **FailedPieces** *(integer) --*

      The number of pieces that weren't processed successfully (failed) by the import job, as of the
      time of the request.

    - **Failures** *(list) --*

      An array of entries, one for each of the first 100 entries that weren't processed successfully
      (failed) by the import job, if any.

      - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the import job.

    - **JobStatus** *(string) --*

      The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
      process one or more pieces in the job.

    - **TotalFailures** *(integer) --*

      The total number of endpoint definitions that weren't processed successfully (failed) by the
      import job, typically because an error, such as a syntax error, occurred.

    - **TotalPieces** *(integer) --*

      The total number of pieces that must be processed to complete the import job. Each piece
      consists of an approximately equal portion of the endpoint definitions that are part of the
      import job.

    - **TotalProcessed** *(integer) --*

      The total number of endpoint definitions that were processed by the import job.

    - **Type** *(string) --*

      The job type. This value is IMPORT for import jobs.
    """


_ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef",
    {
        "Item": List[ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef(
    _ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef
):
    """
    Type definition for `ClientGetSegmentImportJobsResponse` `ImportJobsResponse`

    Provides information about the status and settings of all the import jobs that are associated
    with an application or segment. An import job is a job that imports endpoint definitions from
    one or more files.

    - **Item** *(list) --*

      An array of responses, one for each import job that's associated with the application (Import
      Jobs resource) or segment (Segment Import Jobs resource).

      - *(dict) --*

        Provides information about the status and settings of a job that imports endpoint
        definitions from one or more files. The files can be stored in an Amazon Simple Storage
        Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint
        console.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the import job.

        - **CompletedPieces** *(integer) --*

          The number of pieces that were processed successfully (completed) by the import job, as of
          the time of the request.

        - **CompletionDate** *(string) --*

          The date, in ISO 8601 format, when the import job was completed.

        - **CreationDate** *(string) --*

          The date, in ISO 8601 format, when the import job was created.

        - **Definition** *(dict) --*

          The resource settings that apply to the import job.

          - **DefineSegment** *(boolean) --*

            Specifies whether the import job creates a segment that contains the endpoints, when the
            endpoint definitions are imported.

          - **ExternalId** *(string) --*

            (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
            trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
            importing endpoint definitions, but we removed this requirement. We don't recommend use
            of external IDs for IAM roles that are assumed by Amazon Pinpoint.

          - **Format** *(string) --*

            The format of the files that contain the endpoint definitions to import. Valid values
            are: CSV, for comma-separated values format; and, JSON, for newline-delimited JSON
            format.

            If the files are stored in an Amazon S3 location and that location contains multiple
            files that use different formats, Amazon Pinpoint imports data only from the files that
            use the specified format.

          - **RegisterEndpoints** *(boolean) --*

            Specifies whether the import job registers the endpoints with Amazon Pinpoint, when the
            endpoint definitions are imported.

          - **RoleArn** *(string) --*

            The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
            authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint
            definitions from.

          - **S3Url** *(string) --*

            The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the
            endpoint definitions to import. This location can be a folder or a single file. If the
            location is a folder, Amazon Pinpoint imports endpoint definitions from the files in
            this location, including any subfolders that the folder contains.

            The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
            location can end with the key for an individual object or a prefix that qualifies
            multiple objects.

          - **SegmentId** *(string) --*

            The identifier for the segment that the import job updates or adds endpoint definitions
            to, if the import job updates an existing segment.

          - **SegmentName** *(string) --*

            The custom name for the segment that's created by the import job, if the value of the
            DefineSegment property is true.

        - **FailedPieces** *(integer) --*

          The number of pieces that weren't processed successfully (failed) by the import job, as of
          the time of the request.

        - **Failures** *(list) --*

          An array of entries, one for each of the first 100 entries that weren't processed
          successfully (failed) by the import job, if any.

          - *(string) --*

        - **Id** *(string) --*

          The unique identifier for the import job.

        - **JobStatus** *(string) --*

          The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
          process one or more pieces in the job.

        - **TotalFailures** *(integer) --*

          The total number of endpoint definitions that weren't processed successfully (failed) by
          the import job, typically because an error, such as a syntax error, occurred.

        - **TotalPieces** *(integer) --*

          The total number of pieces that must be processed to complete the import job. Each piece
          consists of an approximately equal portion of the endpoint definitions that are part of
          the import job.

        - **TotalProcessed** *(integer) --*

          The total number of endpoint definitions that were processed by the import job.

        - **Type** *(string) --*

          The job type. This value is IMPORT for import jobs.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetSegmentImportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseTypeDef",
    {"ImportJobsResponse": ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef},
    total=False,
)


class ClientGetSegmentImportJobsResponseTypeDef(_ClientGetSegmentImportJobsResponseTypeDef):
    """
    Type definition for `ClientGetSegmentImportJobs` `Response`

    The request succeeded.

    - **ImportJobsResponse** *(dict) --*

      Provides information about the status and settings of all the import jobs that are associated
      with an application or segment. An import job is a job that imports endpoint definitions from
      one or more files.

      - **Item** *(list) --*

        An array of responses, one for each import job that's associated with the application
        (Import Jobs resource) or segment (Segment Import Jobs resource).

        - *(dict) --*

          Provides information about the status and settings of a job that imports endpoint
          definitions from one or more files. The files can be stored in an Amazon Simple Storage
          Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon
          Pinpoint console.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the import job.

          - **CompletedPieces** *(integer) --*

            The number of pieces that were processed successfully (completed) by the import job, as
            of the time of the request.

          - **CompletionDate** *(string) --*

            The date, in ISO 8601 format, when the import job was completed.

          - **CreationDate** *(string) --*

            The date, in ISO 8601 format, when the import job was created.

          - **Definition** *(dict) --*

            The resource settings that apply to the import job.

            - **DefineSegment** *(boolean) --*

              Specifies whether the import job creates a segment that contains the endpoints, when
              the endpoint definitions are imported.

            - **ExternalId** *(string) --*

              (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
              trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
              importing endpoint definitions, but we removed this requirement. We don't recommend
              use of external IDs for IAM roles that are assumed by Amazon Pinpoint.

            - **Format** *(string) --*

              The format of the files that contain the endpoint definitions to import. Valid values
              are: CSV, for comma-separated values format; and, JSON, for newline-delimited JSON
              format.

              If the files are stored in an Amazon S3 location and that location contains multiple
              files that use different formats, Amazon Pinpoint imports data only from the files
              that use the specified format.

            - **RegisterEndpoints** *(boolean) --*

              Specifies whether the import job registers the endpoints with Amazon Pinpoint, when
              the endpoint definitions are imported.

            - **RoleArn** *(string) --*

              The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role
              that authorizes Amazon Pinpoint to access the Amazon S3 location to import endpoint
              definitions from.

            - **S3Url** *(string) --*

              The URL of the Amazon Simple Storage Service (Amazon S3) bucket that contains the
              endpoint definitions to import. This location can be a folder or a single file. If the
              location is a folder, Amazon Pinpoint imports endpoint definitions from the files in
              this location, including any subfolders that the folder contains.

              The URL should be in the following format: s3://bucket-name/folder-name/file-name. The
              location can end with the key for an individual object or a prefix that qualifies
              multiple objects.

            - **SegmentId** *(string) --*

              The identifier for the segment that the import job updates or adds endpoint
              definitions to, if the import job updates an existing segment.

            - **SegmentName** *(string) --*

              The custom name for the segment that's created by the import job, if the value of the
              DefineSegment property is true.

          - **FailedPieces** *(integer) --*

            The number of pieces that weren't processed successfully (failed) by the import job, as
            of the time of the request.

          - **Failures** *(list) --*

            An array of entries, one for each of the first 100 entries that weren't processed
            successfully (failed) by the import job, if any.

            - *(string) --*

          - **Id** *(string) --*

            The unique identifier for the import job.

          - **JobStatus** *(string) --*

            The status of the import job. The job status is FAILED if Amazon Pinpoint wasn't able to
            process one or more pieces in the job.

          - **TotalFailures** *(integer) --*

            The total number of endpoint definitions that weren't processed successfully (failed) by
            the import job, typically because an error, such as a syntax error, occurred.

          - **TotalPieces** *(integer) --*

            The total number of pieces that must be processed to complete the import job. Each piece
            consists of an approximately equal portion of the endpoint definitions that are part of
            the import job.

          - **TotalProcessed** *(integer) --*

            The total number of endpoint definitions that were processed by the import job.

          - **Type** *(string) --*

            The job type. This value is IMPORT for import jobs.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsDemographic` `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsDemographic` `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[str, ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef],
        "Behavior": ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponse` `Dimensions`

    The dimension settings for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": str,
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponse` `ImportDefinition`

    The settings for the import job that's associated with the segment.

    - **ChannelCounts** *(dict) --*

      The number of channel types in the endpoint definitions that were imported to create the
      segment.

      - *(string) --*

        - *(integer) --*

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that were imported to create the segment. Valid values are: CSV, for
      comma-separated values format; and, JSON, for newline-delimited JSON format.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint definitions
      were imported from to create the segment.

    - **Size** *(integer) --*

      The number of endpoint definitions that were imported successfully to create the segment.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroups` `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroupsGroups`
    `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponseSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentResponseSegmentResponse` `SegmentGroups`

    A list of one or more segment groups that apply to the segment. Each segment group consists of
    zero or more base segments and the dimensions that are applied to those base segments.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --*

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientGetSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": str,
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseTypeDef(
    _ClientGetSegmentResponseSegmentResponseTypeDef
):
    """
    Type definition for `ClientGetSegmentResponse` `SegmentResponse`

    Provides information about the configuration, dimension, and other settings for a segment.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the segment is associated with.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the segment.

    - **CreationDate** *(string) --*

      The date and time when the segment was created.

    - **Dimensions** *(dict) --*

      The dimension settings for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **ImportDefinition** *(dict) --*

      The settings for the import job that's associated with the segment.

      - **ChannelCounts** *(dict) --*

        The number of channel types in the endpoint definitions that were imported to create the
        segment.

        - *(string) --*

          - *(integer) --*

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that were imported to create the segment. Valid values are: CSV, for
        comma-separated values format; and, JSON, for newline-delimited JSON format.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
        definitions were imported from to create the segment.

      - **Size** *(integer) --*

        The number of endpoint definitions that were imported successfully to create the segment.

    - **LastModifiedDate** *(string) --*

      The date and time when the segment was last modified.

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      A list of one or more segment groups that apply to the segment. Each segment group consists of
      zero or more base segments and the dimensions that are applied to those base segments.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --*

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **SegmentType** *(string) --*

      The segment type. Valid values are:

      * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
      specify and is based on endpoint data that's reported by your app. Dynamic segments can change
      over time.

      * IMPORT - A static segment, which is a segment that uses selection criteria that you specify
      and is based on endpoint definitions that you import from a file. Imported segments are
      static; they don't change over time.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the segment. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentResponseTypeDef = TypedDict(
    "_ClientGetSegmentResponseTypeDef",
    {"SegmentResponse": ClientGetSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientGetSegmentResponseTypeDef(_ClientGetSegmentResponseTypeDef):
    """
    Type definition for `ClientGetSegment` `Response`

    The request succeeded.

    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the segment.

      - **CreationDate** *(string) --*

        The date and time when the segment was created.

      - **Dimensions** *(dict) --*

        The dimension settings for the segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the segment.

      - **ImportDefinition** *(dict) --*

        The settings for the import job that's associated with the segment.

        - **ChannelCounts** *(dict) --*

          The number of channel types in the endpoint definitions that were imported to create the
          segment.

          - *(string) --*

            - *(integer) --*

        - **ExternalId** *(string) --*

          (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
          policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
          endpoint definitions, but we removed this requirement. We don't recommend use of external
          IDs for IAM roles that are assumed by Amazon Pinpoint.

        - **Format** *(string) --*

          The format of the files that were imported to create the segment. Valid values are: CSV,
          for comma-separated values format; and, JSON, for newline-delimited JSON format.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
          from.

        - **S3Url** *(string) --*

          The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
          definitions were imported from to create the segment.

        - **Size** *(integer) --*

          The number of endpoint definitions that were imported successfully to create the segment.

      - **LastModifiedDate** *(string) --*

        The date and time when the segment was last modified.

      - **Name** *(string) --*

        The name of the segment.

      - **SegmentGroups** *(dict) --*

        A list of one or more segment groups that apply to the segment. Each segment group consists
        of zero or more base segments and the dimensions that are applied to those base segments.

        - **Groups** *(list) --*

          An array that defines the set of segment criteria to evaluate when handling segment groups
          for the segment.

          - *(dict) --*

            Specifies the base segments and dimensions for a segment, and the relationships between
            these base segments and dimensions.

            - **Dimensions** *(list) --*

              An array that defines the dimensions for the segment.

              - *(dict) --*

                Specifies the dimension settings for a segment.

                - **Attributes** *(dict) --*

                  One or more custom attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **Behavior** *(dict) --*

                  The behavior-based criteria, such as how recently users have used your app, for
                  the segment.

                  - **Recency** *(dict) --*

                    The dimension settings that are based on how recently an endpoint was active.

                    - **Duration** *(string) --*

                      The duration to use when determining whether an endpoint is active or
                      inactive.

                    - **RecencyType** *(string) --*

                      The type of recency dimension to use for the segment. Valid values are:
                      ACTIVE, endpoints that were active within the specified duration are included
                      in the segment; and, INACTIVE, endpoints that weren't active within the
                      specified duration are included in the segment.

                - **Demographic** *(dict) --*

                  The demographic-based criteria, such as device platform, for the segment.

                  - **AppVersion** *(dict) --*

                    The app version criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Channel** *(dict) --*

                    The channel criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **DeviceType** *(dict) --*

                    The device type criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Make** *(dict) --*

                    The device make criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Model** *(dict) --*

                    The device model criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Platform** *(dict) --*

                    The device platform criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                - **Location** *(dict) --*

                  The location-based criteria, such as region or GPS coordinates, for the segment.

                  - **Country** *(dict) --*

                    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **GPSPoint** *(dict) --*

                    The GPS location and range for the segment.

                    - **Coordinates** *(dict) --*

                      The GPS coordinates to measure distance from.

                      - **Latitude** *(float) --*

                        The latitude coordinate of the location.

                      - **Longitude** *(float) --*

                        The longitude coordinate of the location.

                    - **RangeInKilometers** *(float) --*

                      The range, in kilometers, from the GPS coordinates.

                - **Metrics** *(dict) --*

                  One or more custom metrics to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

                - **UserAttributes** *(dict) --*

                  One or more custom user attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

            - **SourceSegments** *(list) --*

              The base segment to build the segment on. A base segment, also referred to as a
              *source segment* , defines the initial population of endpoints for a segment. When you
              add dimensions to a segment, Amazon Pinpoint filters the base segment by using the
              dimensions that you specify.

              You can specify more than one dimensional segment or only one imported segment. If you
              specify an imported segment, the Amazon Pinpoint console displays a segment size
              estimate that indicates the size of the imported segment without any filters applied
              to it.

              - *(dict) --*

                Specifies the segment identifier and version of a segment.

                - **Id** *(string) --*

                  The unique identifier for the segment.

                - **Version** *(integer) --*

                  The version number of the segment.

            - **SourceType** *(string) --*

              Specifies how to handle multiple base segments for the segment. For example, if you
              specify three base segments for the segment, whether the resulting segment is based on
              all, any, or none of the base segments.

            - **Type** *(string) --*

              Specifies how to handle multiple dimensions for the segment. For example, if you
              specify three dimensions for the segment, whether the resulting segment includes
              endpoints that match all, any, or none of the dimensions.

        - **Include** *(string) --*

          Specifies how to handle multiple segment groups for the segment. For example, if the
          segment includes three segment groups, whether the resulting segment includes endpoints
          that match all, any, or none of the segment groups.

      - **SegmentType** *(string) --*

        The segment type. Valid values are:

        * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint data that's reported by your app. Dynamic segments can
        change over time.

        * IMPORT - A static segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint definitions that you import from a file. Imported segments
        are static; they don't change over time.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the segment. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **Version** *(integer) --*

        The version number of the segment.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str, ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponse` `Dimensions`

    The dimension settings for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": str,
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponse` `ImportDefinition`

    The settings for the import job that's associated with the segment.

    - **ChannelCounts** *(dict) --*

      The number of channel types in the endpoint definitions that were imported to create the
      segment.

      - *(string) --*

        - *(integer) --*

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that were imported to create the segment. Valid values are: CSV, for
      comma-separated values format; and, JSON, for newline-delimited JSON format.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint definitions
      were imported from to create the segment.

    - **Size** *(integer) --*

      The number of endpoint definitions that were imported successfully to create the segment.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroups`
    `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroups`
    `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponseSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponseSegmentResponse` `SegmentGroups`

    A list of one or more segment groups that apply to the segment. Each segment group consists of
    zero or more base segments and the dimensions that are applied to those base segments.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --*

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientGetSegmentVersionResponseSegmentResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": str,
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionResponse` `SegmentResponse`

    Provides information about the configuration, dimension, and other settings for a segment.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the segment is associated with.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the segment.

    - **CreationDate** *(string) --*

      The date and time when the segment was created.

    - **Dimensions** *(dict) --*

      The dimension settings for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **ImportDefinition** *(dict) --*

      The settings for the import job that's associated with the segment.

      - **ChannelCounts** *(dict) --*

        The number of channel types in the endpoint definitions that were imported to create the
        segment.

        - *(string) --*

          - *(integer) --*

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that were imported to create the segment. Valid values are: CSV, for
        comma-separated values format; and, JSON, for newline-delimited JSON format.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
        definitions were imported from to create the segment.

      - **Size** *(integer) --*

        The number of endpoint definitions that were imported successfully to create the segment.

    - **LastModifiedDate** *(string) --*

      The date and time when the segment was last modified.

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      A list of one or more segment groups that apply to the segment. Each segment group consists of
      zero or more base segments and the dimensions that are applied to those base segments.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --*

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **SegmentType** *(string) --*

      The segment type. Valid values are:

      * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
      specify and is based on endpoint data that's reported by your app. Dynamic segments can change
      over time.

      * IMPORT - A static segment, which is a segment that uses selection criteria that you specify
      and is based on endpoint definitions that you import from a file. Imported segments are
      static; they don't change over time.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the segment. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentVersionResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseTypeDef",
    {"SegmentResponse": ClientGetSegmentVersionResponseSegmentResponseTypeDef},
    total=False,
)


class ClientGetSegmentVersionResponseTypeDef(_ClientGetSegmentVersionResponseTypeDef):
    """
    Type definition for `ClientGetSegmentVersion` `Response`

    The request succeeded.

    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the segment.

      - **CreationDate** *(string) --*

        The date and time when the segment was created.

      - **Dimensions** *(dict) --*

        The dimension settings for the segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the segment.

      - **ImportDefinition** *(dict) --*

        The settings for the import job that's associated with the segment.

        - **ChannelCounts** *(dict) --*

          The number of channel types in the endpoint definitions that were imported to create the
          segment.

          - *(string) --*

            - *(integer) --*

        - **ExternalId** *(string) --*

          (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
          policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
          endpoint definitions, but we removed this requirement. We don't recommend use of external
          IDs for IAM roles that are assumed by Amazon Pinpoint.

        - **Format** *(string) --*

          The format of the files that were imported to create the segment. Valid values are: CSV,
          for comma-separated values format; and, JSON, for newline-delimited JSON format.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
          from.

        - **S3Url** *(string) --*

          The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
          definitions were imported from to create the segment.

        - **Size** *(integer) --*

          The number of endpoint definitions that were imported successfully to create the segment.

      - **LastModifiedDate** *(string) --*

        The date and time when the segment was last modified.

      - **Name** *(string) --*

        The name of the segment.

      - **SegmentGroups** *(dict) --*

        A list of one or more segment groups that apply to the segment. Each segment group consists
        of zero or more base segments and the dimensions that are applied to those base segments.

        - **Groups** *(list) --*

          An array that defines the set of segment criteria to evaluate when handling segment groups
          for the segment.

          - *(dict) --*

            Specifies the base segments and dimensions for a segment, and the relationships between
            these base segments and dimensions.

            - **Dimensions** *(list) --*

              An array that defines the dimensions for the segment.

              - *(dict) --*

                Specifies the dimension settings for a segment.

                - **Attributes** *(dict) --*

                  One or more custom attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **Behavior** *(dict) --*

                  The behavior-based criteria, such as how recently users have used your app, for
                  the segment.

                  - **Recency** *(dict) --*

                    The dimension settings that are based on how recently an endpoint was active.

                    - **Duration** *(string) --*

                      The duration to use when determining whether an endpoint is active or
                      inactive.

                    - **RecencyType** *(string) --*

                      The type of recency dimension to use for the segment. Valid values are:
                      ACTIVE, endpoints that were active within the specified duration are included
                      in the segment; and, INACTIVE, endpoints that weren't active within the
                      specified duration are included in the segment.

                - **Demographic** *(dict) --*

                  The demographic-based criteria, such as device platform, for the segment.

                  - **AppVersion** *(dict) --*

                    The app version criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Channel** *(dict) --*

                    The channel criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **DeviceType** *(dict) --*

                    The device type criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Make** *(dict) --*

                    The device make criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Model** *(dict) --*

                    The device model criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Platform** *(dict) --*

                    The device platform criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                - **Location** *(dict) --*

                  The location-based criteria, such as region or GPS coordinates, for the segment.

                  - **Country** *(dict) --*

                    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **GPSPoint** *(dict) --*

                    The GPS location and range for the segment.

                    - **Coordinates** *(dict) --*

                      The GPS coordinates to measure distance from.

                      - **Latitude** *(float) --*

                        The latitude coordinate of the location.

                      - **Longitude** *(float) --*

                        The longitude coordinate of the location.

                    - **RangeInKilometers** *(float) --*

                      The range, in kilometers, from the GPS coordinates.

                - **Metrics** *(dict) --*

                  One or more custom metrics to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

                - **UserAttributes** *(dict) --*

                  One or more custom user attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

            - **SourceSegments** *(list) --*

              The base segment to build the segment on. A base segment, also referred to as a
              *source segment* , defines the initial population of endpoints for a segment. When you
              add dimensions to a segment, Amazon Pinpoint filters the base segment by using the
              dimensions that you specify.

              You can specify more than one dimensional segment or only one imported segment. If you
              specify an imported segment, the Amazon Pinpoint console displays a segment size
              estimate that indicates the size of the imported segment without any filters applied
              to it.

              - *(dict) --*

                Specifies the segment identifier and version of a segment.

                - **Id** *(string) --*

                  The unique identifier for the segment.

                - **Version** *(integer) --*

                  The version number of the segment.

            - **SourceType** *(string) --*

              Specifies how to handle multiple base segments for the segment. For example, if you
              specify three base segments for the segment, whether the resulting segment is based on
              all, any, or none of the base segments.

            - **Type** *(string) --*

              Specifies how to handle multiple dimensions for the segment. For example, if you
              specify three dimensions for the segment, whether the resulting segment includes
              endpoints that match all, any, or none of the dimensions.

        - **Include** *(string) --*

          Specifies how to handle multiple segment groups for the segment. For example, if the
          segment includes three segment groups, whether the resulting segment includes endpoints
          that match all, any, or none of the segment groups.

      - **SegmentType** *(string) --*

        The segment type. Valid values are:

        * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint data that's reported by your app. Dynamic segments can
        change over time.

        * IMPORT - A static segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint definitions that you import from a file. Imported segments
        are static; they don't change over time.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the segment. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **Version** *(integer) --*

        The version number of the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPoint` `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef
        ],
        "Behavior": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str, ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItem` `Dimensions`

    The dimension settings for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": str,
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItem` `ImportDefinition`

    The settings for the import job that's associated with the segment.

    - **ChannelCounts** *(dict) --*

      The number of channel types in the endpoint definitions that were imported to create the
      segment.

      - *(string) --*

        - *(integer) --*

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that were imported to create the segment. Valid values are: CSV, for
      comma-separated values format; and, JSON, for newline-delimited JSON format.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint definitions
      were imported from to create the segment.

    - **Size** *(integer) --*

      The number of endpoint definitions that were imported successfully to create the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroups`
    `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroups`
    `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    {
        "Groups": List[
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef
        ],
        "Include": str,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponseItem` `SegmentGroups`

    A list of one or more segment groups that apply to the segment. Each segment group consists of
    zero or more base segments and the dimensions that are applied to those base segments.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --*

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef,
        "SegmentType": str,
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponseSegmentsResponse` `Item`

    Provides information about the configuration, dimension, and other settings for a segment.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the segment is associated with.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the segment.

    - **CreationDate** *(string) --*

      The date and time when the segment was created.

    - **Dimensions** *(dict) --*

      The dimension settings for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **ImportDefinition** *(dict) --*

      The settings for the import job that's associated with the segment.

      - **ChannelCounts** *(dict) --*

        The number of channel types in the endpoint definitions that were imported to create the
        segment.

        - *(string) --*

          - *(integer) --*

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that were imported to create the segment. Valid values are: CSV, for
        comma-separated values format; and, JSON, for newline-delimited JSON format.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
        definitions were imported from to create the segment.

      - **Size** *(integer) --*

        The number of endpoint definitions that were imported successfully to create the segment.

    - **LastModifiedDate** *(string) --*

      The date and time when the segment was last modified.

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      A list of one or more segment groups that apply to the segment. Each segment group consists of
      zero or more base segments and the dimensions that are applied to those base segments.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --*

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **SegmentType** *(string) --*

      The segment type. Valid values are:

      * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
      specify and is based on endpoint data that's reported by your app. Dynamic segments can change
      over time.

      * IMPORT - A static segment, which is a segment that uses selection criteria that you specify
      and is based on endpoint definitions that you import from a file. Imported segments are
      static; they don't change over time.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the segment. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseTypeDef",
    {"Item": List[ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseTypeDef
):
    """
    Type definition for `ClientGetSegmentVersionsResponse` `SegmentsResponse`

    Provides information about all the segments that are associated with an application.

    - **Item** *(list) --*

      An array of responses, one for each segment that's associated with the application (Segments
      resource) or each version of a segment that's associated with the application (Segment
      Versions resource).

      - *(dict) --*

        Provides information about the configuration, dimension, and other settings for a segment.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that the segment is associated with.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the segment.

        - **CreationDate** *(string) --*

          The date and time when the segment was created.

        - **Dimensions** *(dict) --*

          The dimension settings for the segment.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **ImportDefinition** *(dict) --*

          The settings for the import job that's associated with the segment.

          - **ChannelCounts** *(dict) --*

            The number of channel types in the endpoint definitions that were imported to create the
            segment.

            - *(string) --*

              - *(integer) --*

          - **ExternalId** *(string) --*

            (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
            trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
            importing endpoint definitions, but we removed this requirement. We don't recommend use
            of external IDs for IAM roles that are assumed by Amazon Pinpoint.

          - **Format** *(string) --*

            The format of the files that were imported to create the segment. Valid values are: CSV,
            for comma-separated values format; and, JSON, for newline-delimited JSON format.

          - **RoleArn** *(string) --*

            The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
            authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint
            definitions from.

          - **S3Url** *(string) --*

            The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
            definitions were imported from to create the segment.

          - **Size** *(integer) --*

            The number of endpoint definitions that were imported successfully to create the
            segment.

        - **LastModifiedDate** *(string) --*

          The date and time when the segment was last modified.

        - **Name** *(string) --*

          The name of the segment.

        - **SegmentGroups** *(dict) --*

          A list of one or more segment groups that apply to the segment. Each segment group
          consists of zero or more base segments and the dimensions that are applied to those base
          segments.

          - **Groups** *(list) --*

            An array that defines the set of segment criteria to evaluate when handling segment
            groups for the segment.

            - *(dict) --*

              Specifies the base segments and dimensions for a segment, and the relationships
              between these base segments and dimensions.

              - **Dimensions** *(list) --*

                An array that defines the dimensions for the segment.

                - *(dict) --*

                  Specifies the dimension settings for a segment.

                  - **Attributes** *(dict) --*

                    One or more custom attributes to use as criteria for the segment.

                    - *(string) --*

                      - *(dict) --*

                        Specifies attribute-based criteria for including or excluding endpoints from
                        a segment.

                        - **AttributeType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the AttributeType property, endpoints are included or excluded
                          from the segment if their attribute values match the criteria values.

                          - *(string) --*

                  - **Behavior** *(dict) --*

                    The behavior-based criteria, such as how recently users have used your app, for
                    the segment.

                    - **Recency** *(dict) --*

                      The dimension settings that are based on how recently an endpoint was active.

                      - **Duration** *(string) --*

                        The duration to use when determining whether an endpoint is active or
                        inactive.

                      - **RecencyType** *(string) --*

                        The type of recency dimension to use for the segment. Valid values are:
                        ACTIVE, endpoints that were active within the specified duration are
                        included in the segment; and, INACTIVE, endpoints that weren't active within
                        the specified duration are included in the segment.

                  - **Demographic** *(dict) --*

                    The demographic-based criteria, such as device platform, for the segment.

                    - **AppVersion** *(dict) --*

                      The app version criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Channel** *(dict) --*

                      The channel criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **DeviceType** *(dict) --*

                      The device type criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Make** *(dict) --*

                      The device make criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Model** *(dict) --*

                      The device model criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Platform** *(dict) --*

                      The device platform criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                  - **Location** *(dict) --*

                    The location-based criteria, such as region or GPS coordinates, for the segment.

                    - **Country** *(dict) --*

                      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **GPSPoint** *(dict) --*

                      The GPS location and range for the segment.

                      - **Coordinates** *(dict) --*

                        The GPS coordinates to measure distance from.

                        - **Latitude** *(float) --*

                          The latitude coordinate of the location.

                        - **Longitude** *(float) --*

                          The longitude coordinate of the location.

                      - **RangeInKilometers** *(float) --*

                        The range, in kilometers, from the GPS coordinates.

                  - **Metrics** *(dict) --*

                    One or more custom metrics to use as criteria for the segment.

                    - *(string) --*

                      - *(dict) --*

                        Specifies metric-based criteria for including or excluding endpoints from a
                        segment. These criteria derive from custom metrics that you define for
                        endpoints.

                        - **ComparisonOperator** *(string) --*

                          The operator to use when comparing metric values. Valid values are:
                          GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                          EQUAL.

                        - **Value** *(float) --*

                          The value to compare.

                  - **UserAttributes** *(dict) --*

                    One or more custom user attributes to use as criteria for the segment.

                    - *(string) --*

                      - *(dict) --*

                        Specifies attribute-based criteria for including or excluding endpoints from
                        a segment.

                        - **AttributeType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the AttributeType property, endpoints are included or excluded
                          from the segment if their attribute values match the criteria values.

                          - *(string) --*

              - **SourceSegments** *(list) --*

                The base segment to build the segment on. A base segment, also referred to as a
                *source segment* , defines the initial population of endpoints for a segment. When
                you add dimensions to a segment, Amazon Pinpoint filters the base segment by using
                the dimensions that you specify.

                You can specify more than one dimensional segment or only one imported segment. If
                you specify an imported segment, the Amazon Pinpoint console displays a segment size
                estimate that indicates the size of the imported segment without any filters applied
                to it.

                - *(dict) --*

                  Specifies the segment identifier and version of a segment.

                  - **Id** *(string) --*

                    The unique identifier for the segment.

                  - **Version** *(integer) --*

                    The version number of the segment.

              - **SourceType** *(string) --*

                Specifies how to handle multiple base segments for the segment. For example, if you
                specify three base segments for the segment, whether the resulting segment is based
                on all, any, or none of the base segments.

              - **Type** *(string) --*

                Specifies how to handle multiple dimensions for the segment. For example, if you
                specify three dimensions for the segment, whether the resulting segment includes
                endpoints that match all, any, or none of the dimensions.

          - **Include** *(string) --*

            Specifies how to handle multiple segment groups for the segment. For example, if the
            segment includes three segment groups, whether the resulting segment includes endpoints
            that match all, any, or none of the segment groups.

        - **SegmentType** *(string) --*

          The segment type. Valid values are:

          * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that
          you specify and is based on endpoint data that's reported by your app. Dynamic segments
          can change over time.

          * IMPORT - A static segment, which is a segment that uses selection criteria that you
          specify and is based on endpoint definitions that you import from a file. Imported
          segments are static; they don't change over time.

        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that identifies the tags that are associated
          with the segment. Each tag consists of a required tag key and an associated tag value.

          - *(string) --*

            - *(string) --*

        - **Version** *(integer) --*

          The version number of the segment.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetSegmentVersionsResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseTypeDef",
    {"SegmentsResponse": ClientGetSegmentVersionsResponseSegmentsResponseTypeDef},
    total=False,
)


class ClientGetSegmentVersionsResponseTypeDef(_ClientGetSegmentVersionsResponseTypeDef):
    """
    Type definition for `ClientGetSegmentVersions` `Response`

    The request succeeded.

    - **SegmentsResponse** *(dict) --*

      Provides information about all the segments that are associated with an application.

      - **Item** *(list) --*

        An array of responses, one for each segment that's associated with the application (Segments
        resource) or each version of a segment that's associated with the application (Segment
        Versions resource).

        - *(dict) --*

          Provides information about the configuration, dimension, and other settings for a segment.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that the segment is associated with.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the segment.

          - **CreationDate** *(string) --*

            The date and time when the segment was created.

          - **Dimensions** *(dict) --*

            The dimension settings for the segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

          - **Id** *(string) --*

            The unique identifier for the segment.

          - **ImportDefinition** *(dict) --*

            The settings for the import job that's associated with the segment.

            - **ChannelCounts** *(dict) --*

              The number of channel types in the endpoint definitions that were imported to create
              the segment.

              - *(string) --*

                - *(integer) --*

            - **ExternalId** *(string) --*

              (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
              trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
              importing endpoint definitions, but we removed this requirement. We don't recommend
              use of external IDs for IAM roles that are assumed by Amazon Pinpoint.

            - **Format** *(string) --*

              The format of the files that were imported to create the segment. Valid values are:
              CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

            - **RoleArn** *(string) --*

              The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role
              that authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint
              definitions from.

            - **S3Url** *(string) --*

              The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
              definitions were imported from to create the segment.

            - **Size** *(integer) --*

              The number of endpoint definitions that were imported successfully to create the
              segment.

          - **LastModifiedDate** *(string) --*

            The date and time when the segment was last modified.

          - **Name** *(string) --*

            The name of the segment.

          - **SegmentGroups** *(dict) --*

            A list of one or more segment groups that apply to the segment. Each segment group
            consists of zero or more base segments and the dimensions that are applied to those base
            segments.

            - **Groups** *(list) --*

              An array that defines the set of segment criteria to evaluate when handling segment
              groups for the segment.

              - *(dict) --*

                Specifies the base segments and dimensions for a segment, and the relationships
                between these base segments and dimensions.

                - **Dimensions** *(list) --*

                  An array that defines the dimensions for the segment.

                  - *(dict) --*

                    Specifies the dimension settings for a segment.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **SourceSegments** *(list) --*

                  The base segment to build the segment on. A base segment, also referred to as a
                  *source segment* , defines the initial population of endpoints for a segment. When
                  you add dimensions to a segment, Amazon Pinpoint filters the base segment by using
                  the dimensions that you specify.

                  You can specify more than one dimensional segment or only one imported segment. If
                  you specify an imported segment, the Amazon Pinpoint console displays a segment
                  size estimate that indicates the size of the imported segment without any filters
                  applied to it.

                  - *(dict) --*

                    Specifies the segment identifier and version of a segment.

                    - **Id** *(string) --*

                      The unique identifier for the segment.

                    - **Version** *(integer) --*

                      The version number of the segment.

                - **SourceType** *(string) --*

                  Specifies how to handle multiple base segments for the segment. For example, if
                  you specify three base segments for the segment, whether the resulting segment is
                  based on all, any, or none of the base segments.

                - **Type** *(string) --*

                  Specifies how to handle multiple dimensions for the segment. For example, if you
                  specify three dimensions for the segment, whether the resulting segment includes
                  endpoints that match all, any, or none of the dimensions.

            - **Include** *(string) --*

              Specifies how to handle multiple segment groups for the segment. For example, if the
              segment includes three segment groups, whether the resulting segment includes
              endpoints that match all, any, or none of the segment groups.

          - **SegmentType** *(string) --*

            The segment type. Valid values are:

            * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that
            you specify and is based on endpoint data that's reported by your app. Dynamic segments
            can change over time.

            * IMPORT - A static segment, which is a segment that uses selection criteria that you
            specify and is based on endpoint definitions that you import from a file. Imported
            segments are static; they don't change over time.

          - **tags** *(dict) --*

            A string-to-string map of key-value pairs that identifies the tags that are associated
            with the segment. Each tag consists of a required tag key and an associated tag value.

            - *(string) --*

              - *(string) --*

          - **Version** *(integer) --*

            The version number of the segment.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    {"Recency": ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef
        ],
        "Behavior": ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItem` `Dimensions`

    The dimension settings for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": str,
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItem` `ImportDefinition`

    The settings for the import job that's associated with the segment.

    - **ChannelCounts** *(dict) --*

      The number of channel types in the endpoint definitions that were imported to create the
      segment.

      - *(string) --*

        - *(integer) --*

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that were imported to create the segment. Valid values are: CSV, for
      comma-separated values format; and, JSON, for newline-delimited JSON format.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint definitions
      were imported from to create the segment.

    - **Size** *(integer) --*

      The number of endpoint definitions that were imported successfully to create the segment.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroups`
    `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroups`
    `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItemSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    {
        "Groups": List[ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponseItem` `SegmentGroups`

    A list of one or more segment groups that apply to the segment. Each segment group consists of
    zero or more base segments and the dimensions that are applied to those base segments.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --*

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientGetSegmentsResponseSegmentsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef,
        "SegmentType": str,
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponseSegmentsResponse` `Item`

    Provides information about the configuration, dimension, and other settings for a segment.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the segment is associated with.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the segment.

    - **CreationDate** *(string) --*

      The date and time when the segment was created.

    - **Dimensions** *(dict) --*

      The dimension settings for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **ImportDefinition** *(dict) --*

      The settings for the import job that's associated with the segment.

      - **ChannelCounts** *(dict) --*

        The number of channel types in the endpoint definitions that were imported to create the
        segment.

        - *(string) --*

          - *(integer) --*

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that were imported to create the segment. Valid values are: CSV, for
        comma-separated values format; and, JSON, for newline-delimited JSON format.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
        definitions were imported from to create the segment.

      - **Size** *(integer) --*

        The number of endpoint definitions that were imported successfully to create the segment.

    - **LastModifiedDate** *(string) --*

      The date and time when the segment was last modified.

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      A list of one or more segment groups that apply to the segment. Each segment group consists of
      zero or more base segments and the dimensions that are applied to those base segments.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --*

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **SegmentType** *(string) --*

      The segment type. Valid values are:

      * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
      specify and is based on endpoint data that's reported by your app. Dynamic segments can change
      over time.

      * IMPORT - A static segment, which is a segment that uses selection criteria that you specify
      and is based on endpoint definitions that you import from a file. Imported segments are
      static; they don't change over time.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the segment. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientGetSegmentsResponseSegmentsResponseTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseTypeDef",
    {"Item": List[ClientGetSegmentsResponseSegmentsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseTypeDef
):
    """
    Type definition for `ClientGetSegmentsResponse` `SegmentsResponse`

    Provides information about all the segments that are associated with an application.

    - **Item** *(list) --*

      An array of responses, one for each segment that's associated with the application (Segments
      resource) or each version of a segment that's associated with the application (Segment
      Versions resource).

      - *(dict) --*

        Provides information about the configuration, dimension, and other settings for a segment.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that the segment is associated with.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the segment.

        - **CreationDate** *(string) --*

          The date and time when the segment was created.

        - **Dimensions** *(dict) --*

          The dimension settings for the segment.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **ImportDefinition** *(dict) --*

          The settings for the import job that's associated with the segment.

          - **ChannelCounts** *(dict) --*

            The number of channel types in the endpoint definitions that were imported to create the
            segment.

            - *(string) --*

              - *(integer) --*

          - **ExternalId** *(string) --*

            (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
            trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
            importing endpoint definitions, but we removed this requirement. We don't recommend use
            of external IDs for IAM roles that are assumed by Amazon Pinpoint.

          - **Format** *(string) --*

            The format of the files that were imported to create the segment. Valid values are: CSV,
            for comma-separated values format; and, JSON, for newline-delimited JSON format.

          - **RoleArn** *(string) --*

            The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
            authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint
            definitions from.

          - **S3Url** *(string) --*

            The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
            definitions were imported from to create the segment.

          - **Size** *(integer) --*

            The number of endpoint definitions that were imported successfully to create the
            segment.

        - **LastModifiedDate** *(string) --*

          The date and time when the segment was last modified.

        - **Name** *(string) --*

          The name of the segment.

        - **SegmentGroups** *(dict) --*

          A list of one or more segment groups that apply to the segment. Each segment group
          consists of zero or more base segments and the dimensions that are applied to those base
          segments.

          - **Groups** *(list) --*

            An array that defines the set of segment criteria to evaluate when handling segment
            groups for the segment.

            - *(dict) --*

              Specifies the base segments and dimensions for a segment, and the relationships
              between these base segments and dimensions.

              - **Dimensions** *(list) --*

                An array that defines the dimensions for the segment.

                - *(dict) --*

                  Specifies the dimension settings for a segment.

                  - **Attributes** *(dict) --*

                    One or more custom attributes to use as criteria for the segment.

                    - *(string) --*

                      - *(dict) --*

                        Specifies attribute-based criteria for including or excluding endpoints from
                        a segment.

                        - **AttributeType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the AttributeType property, endpoints are included or excluded
                          from the segment if their attribute values match the criteria values.

                          - *(string) --*

                  - **Behavior** *(dict) --*

                    The behavior-based criteria, such as how recently users have used your app, for
                    the segment.

                    - **Recency** *(dict) --*

                      The dimension settings that are based on how recently an endpoint was active.

                      - **Duration** *(string) --*

                        The duration to use when determining whether an endpoint is active or
                        inactive.

                      - **RecencyType** *(string) --*

                        The type of recency dimension to use for the segment. Valid values are:
                        ACTIVE, endpoints that were active within the specified duration are
                        included in the segment; and, INACTIVE, endpoints that weren't active within
                        the specified duration are included in the segment.

                  - **Demographic** *(dict) --*

                    The demographic-based criteria, such as device platform, for the segment.

                    - **AppVersion** *(dict) --*

                      The app version criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Channel** *(dict) --*

                      The channel criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **DeviceType** *(dict) --*

                      The device type criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Make** *(dict) --*

                      The device make criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Model** *(dict) --*

                      The device model criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **Platform** *(dict) --*

                      The device platform criteria for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                  - **Location** *(dict) --*

                    The location-based criteria, such as region or GPS coordinates, for the segment.

                    - **Country** *(dict) --*

                      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                      - **DimensionType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the DimensionType property, endpoints are included or excluded from the
                        segment if their values match the criteria values.

                        - *(string) --*

                    - **GPSPoint** *(dict) --*

                      The GPS location and range for the segment.

                      - **Coordinates** *(dict) --*

                        The GPS coordinates to measure distance from.

                        - **Latitude** *(float) --*

                          The latitude coordinate of the location.

                        - **Longitude** *(float) --*

                          The longitude coordinate of the location.

                      - **RangeInKilometers** *(float) --*

                        The range, in kilometers, from the GPS coordinates.

                  - **Metrics** *(dict) --*

                    One or more custom metrics to use as criteria for the segment.

                    - *(string) --*

                      - *(dict) --*

                        Specifies metric-based criteria for including or excluding endpoints from a
                        segment. These criteria derive from custom metrics that you define for
                        endpoints.

                        - **ComparisonOperator** *(string) --*

                          The operator to use when comparing metric values. Valid values are:
                          GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                          EQUAL.

                        - **Value** *(float) --*

                          The value to compare.

                  - **UserAttributes** *(dict) --*

                    One or more custom user attributes to use as criteria for the segment.

                    - *(string) --*

                      - *(dict) --*

                        Specifies attribute-based criteria for including or excluding endpoints from
                        a segment.

                        - **AttributeType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the AttributeType property, endpoints are included or excluded
                          from the segment if their attribute values match the criteria values.

                          - *(string) --*

              - **SourceSegments** *(list) --*

                The base segment to build the segment on. A base segment, also referred to as a
                *source segment* , defines the initial population of endpoints for a segment. When
                you add dimensions to a segment, Amazon Pinpoint filters the base segment by using
                the dimensions that you specify.

                You can specify more than one dimensional segment or only one imported segment. If
                you specify an imported segment, the Amazon Pinpoint console displays a segment size
                estimate that indicates the size of the imported segment without any filters applied
                to it.

                - *(dict) --*

                  Specifies the segment identifier and version of a segment.

                  - **Id** *(string) --*

                    The unique identifier for the segment.

                  - **Version** *(integer) --*

                    The version number of the segment.

              - **SourceType** *(string) --*

                Specifies how to handle multiple base segments for the segment. For example, if you
                specify three base segments for the segment, whether the resulting segment is based
                on all, any, or none of the base segments.

              - **Type** *(string) --*

                Specifies how to handle multiple dimensions for the segment. For example, if you
                specify three dimensions for the segment, whether the resulting segment includes
                endpoints that match all, any, or none of the dimensions.

          - **Include** *(string) --*

            Specifies how to handle multiple segment groups for the segment. For example, if the
            segment includes three segment groups, whether the resulting segment includes endpoints
            that match all, any, or none of the segment groups.

        - **SegmentType** *(string) --*

          The segment type. Valid values are:

          * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that
          you specify and is based on endpoint data that's reported by your app. Dynamic segments
          can change over time.

          * IMPORT - A static segment, which is a segment that uses selection criteria that you
          specify and is based on endpoint definitions that you import from a file. Imported
          segments are static; they don't change over time.

        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that identifies the tags that are associated
          with the segment. Each tag consists of a required tag key and an associated tag value.

          - *(string) --*

            - *(string) --*

        - **Version** *(integer) --*

          The version number of the segment.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientGetSegmentsResponseTypeDef = TypedDict(
    "_ClientGetSegmentsResponseTypeDef",
    {"SegmentsResponse": ClientGetSegmentsResponseSegmentsResponseTypeDef},
    total=False,
)


class ClientGetSegmentsResponseTypeDef(_ClientGetSegmentsResponseTypeDef):
    """
    Type definition for `ClientGetSegments` `Response`

    The request succeeded.

    - **SegmentsResponse** *(dict) --*

      Provides information about all the segments that are associated with an application.

      - **Item** *(list) --*

        An array of responses, one for each segment that's associated with the application (Segments
        resource) or each version of a segment that's associated with the application (Segment
        Versions resource).

        - *(dict) --*

          Provides information about the configuration, dimension, and other settings for a segment.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that the segment is associated with.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the segment.

          - **CreationDate** *(string) --*

            The date and time when the segment was created.

          - **Dimensions** *(dict) --*

            The dimension settings for the segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

          - **Id** *(string) --*

            The unique identifier for the segment.

          - **ImportDefinition** *(dict) --*

            The settings for the import job that's associated with the segment.

            - **ChannelCounts** *(dict) --*

              The number of channel types in the endpoint definitions that were imported to create
              the segment.

              - *(string) --*

                - *(integer) --*

            - **ExternalId** *(string) --*

              (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM
              trust policy. Amazon Pinpoint previously used this value to assume an IAM role when
              importing endpoint definitions, but we removed this requirement. We don't recommend
              use of external IDs for IAM roles that are assumed by Amazon Pinpoint.

            - **Format** *(string) --*

              The format of the files that were imported to create the segment. Valid values are:
              CSV, for comma-separated values format; and, JSON, for newline-delimited JSON format.

            - **RoleArn** *(string) --*

              The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role
              that authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint
              definitions from.

            - **S3Url** *(string) --*

              The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
              definitions were imported from to create the segment.

            - **Size** *(integer) --*

              The number of endpoint definitions that were imported successfully to create the
              segment.

          - **LastModifiedDate** *(string) --*

            The date and time when the segment was last modified.

          - **Name** *(string) --*

            The name of the segment.

          - **SegmentGroups** *(dict) --*

            A list of one or more segment groups that apply to the segment. Each segment group
            consists of zero or more base segments and the dimensions that are applied to those base
            segments.

            - **Groups** *(list) --*

              An array that defines the set of segment criteria to evaluate when handling segment
              groups for the segment.

              - *(dict) --*

                Specifies the base segments and dimensions for a segment, and the relationships
                between these base segments and dimensions.

                - **Dimensions** *(list) --*

                  An array that defines the dimensions for the segment.

                  - *(dict) --*

                    Specifies the dimension settings for a segment.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **SourceSegments** *(list) --*

                  The base segment to build the segment on. A base segment, also referred to as a
                  *source segment* , defines the initial population of endpoints for a segment. When
                  you add dimensions to a segment, Amazon Pinpoint filters the base segment by using
                  the dimensions that you specify.

                  You can specify more than one dimensional segment or only one imported segment. If
                  you specify an imported segment, the Amazon Pinpoint console displays a segment
                  size estimate that indicates the size of the imported segment without any filters
                  applied to it.

                  - *(dict) --*

                    Specifies the segment identifier and version of a segment.

                    - **Id** *(string) --*

                      The unique identifier for the segment.

                    - **Version** *(integer) --*

                      The version number of the segment.

                - **SourceType** *(string) --*

                  Specifies how to handle multiple base segments for the segment. For example, if
                  you specify three base segments for the segment, whether the resulting segment is
                  based on all, any, or none of the base segments.

                - **Type** *(string) --*

                  Specifies how to handle multiple dimensions for the segment. For example, if you
                  specify three dimensions for the segment, whether the resulting segment includes
                  endpoints that match all, any, or none of the dimensions.

            - **Include** *(string) --*

              Specifies how to handle multiple segment groups for the segment. For example, if the
              segment includes three segment groups, whether the resulting segment includes
              endpoints that match all, any, or none of the segment groups.

          - **SegmentType** *(string) --*

            The segment type. Valid values are:

            * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that
            you specify and is based on endpoint data that's reported by your app. Dynamic segments
            can change over time.

            * IMPORT - A static segment, which is a segment that uses selection criteria that you
            specify and is based on endpoint definitions that you import from a file. Imported
            segments are static; they don't change over time.

          - **tags** *(dict) --*

            A string-to-string map of key-value pairs that identifies the tags that are associated
            with the segment. Each tag consists of a required tag key and an associated tag value.

            - *(string) --*

              - *(string) --*

          - **Version** *(integer) --*

            The version number of the segment.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientGetSmsChannelResponseSMSChannelResponseTypeDef = TypedDict(
    "_ClientGetSmsChannelResponseSMSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "PromotionalMessagesPerSecond": int,
        "SenderId": str,
        "ShortCode": str,
        "TransactionalMessagesPerSecond": int,
        "Version": int,
    },
    total=False,
)


class ClientGetSmsChannelResponseSMSChannelResponseTypeDef(
    _ClientGetSmsChannelResponseSMSChannelResponseTypeDef
):
    """
    Type definition for `ClientGetSmsChannelResponse` `SMSChannelResponse`

    Provides information about the status and settings of the SMS channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the SMS channel applies to.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the SMS channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the SMS channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the SMS channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the SMS channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the SMS channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the SMS channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the SMS channel, this
      value is SMS.

    - **PromotionalMessagesPerSecond** *(integer) --*

      The maximum number of promotional messages that you can send through the SMS channel each
      second.

    - **SenderId** *(string) --*

      The identity that displays on recipients' devices when they receive messages from the SMS
      channel.

    - **ShortCode** *(string) --*

      The registered short code to use when you send messages through the SMS channel.

    - **TransactionalMessagesPerSecond** *(integer) --*

      The maximum number of transactional messages that you can send through the SMS channel each
      second.

    - **Version** *(integer) --*

      The current version of the SMS channel.
    """


_ClientGetSmsChannelResponseTypeDef = TypedDict(
    "_ClientGetSmsChannelResponseTypeDef",
    {"SMSChannelResponse": ClientGetSmsChannelResponseSMSChannelResponseTypeDef},
    total=False,
)


class ClientGetSmsChannelResponseTypeDef(_ClientGetSmsChannelResponseTypeDef):
    """
    Type definition for `ClientGetSmsChannel` `Response`

    The request succeeded.

    - **SMSChannelResponse** *(dict) --*

      Provides information about the status and settings of the SMS channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the SMS channel applies to.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the SMS channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the SMS channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the SMS channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the SMS channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the SMS channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the SMS channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the SMS channel, this
        value is SMS.

      - **PromotionalMessagesPerSecond** *(integer) --*

        The maximum number of promotional messages that you can send through the SMS channel each
        second.

      - **SenderId** *(string) --*

        The identity that displays on recipients' devices when they receive messages from the SMS
        channel.

      - **ShortCode** *(string) --*

        The registered short code to use when you send messages through the SMS channel.

      - **TransactionalMessagesPerSecond** *(integer) --*

        The maximum number of transactional messages that you can send through the SMS channel each
        second.

      - **Version** *(integer) --*

        The current version of the SMS channel.
    """


_ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef = TypedDict(
    "_ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef",
    {
        "Arn": str,
        "Body": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": str,
    },
    total=False,
)


class ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef(
    _ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef
):
    """
    Type definition for `ClientGetSmsTemplateResponse` `SMSTemplateResponse`

    Provides information about the content and settings for a message template that can be used in
    text messages that are sent through the SMS channel.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template.

    - **Body** *(string) --*

      The message body that's used in text messages that are based on the message template.

    - **CreationDate** *(string) --*

      The date when the message template was created.

    - **DefaultSubstitutions** *(string) --*

      The JSON object that specifies the default values that are used for message variables in the
      message template. This object is a set of key-value pairs. Each key defines a message variable
      in the template. The corresponding value defines the default value for that variable.

    - **LastModifiedDate** *(string) --*

      The date when the message template was last modified.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the message template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      The custom description of the message template.

    - **TemplateName** *(string) --*

      The name of the message template.

    - **TemplateType** *(string) --*

      The type of channel that the message template is designed for. For an SMS template, this value
      is SMS.
    """


_ClientGetSmsTemplateResponseTypeDef = TypedDict(
    "_ClientGetSmsTemplateResponseTypeDef",
    {"SMSTemplateResponse": ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef},
    total=False,
)


class ClientGetSmsTemplateResponseTypeDef(_ClientGetSmsTemplateResponseTypeDef):
    """
    Type definition for `ClientGetSmsTemplate` `Response`

    The request succeeded.

    - **SMSTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      text messages that are sent through the SMS channel.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.

      - **Body** *(string) --*

        The message body that's used in text messages that are based on the message template.

      - **CreationDate** *(string) --*

        The date when the message template was created.

      - **DefaultSubstitutions** *(string) --*

        The JSON object that specifies the default values that are used for message variables in the
        message template. This object is a set of key-value pairs. Each key defines a message
        variable in the template. The corresponding value defines the default value for that
        variable.

      - **LastModifiedDate** *(string) --*

        The date when the message template was last modified.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the message template. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateDescription** *(string) --*

        The custom description of the message template.

      - **TemplateName** *(string) --*

        The name of the message template.

      - **TemplateType** *(string) --*

        The type of channel that the message template is designed for. For an SMS template, this
        value is SMS.
    """


_ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef
):
    """
    Type definition for `ClientGetUserEndpointsResponseEndpointsResponseItem` `Demographic`

    The demographic information for the endpoint, such as the time zone and platform.

    - **AppVersion** *(string) --*

      The version of the app that's associated with the endpoint.

    - **Locale** *(string) --*

      The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
      an underscore (_), followed by an ISO 3166-1 alpha-2 value.

    - **Make** *(string) --*

      The manufacturer of the endpoint device, such as Apple or Samsung.

    - **Model** *(string) --*

      The model name or number of the endpoint device, such as iPhone.

    - **ModelVersion** *(string) --*

      The model version of the endpoint device.

    - **Platform** *(string) --*

      The platform of the endpoint device, such as iOS or Android.

    - **PlatformVersion** *(string) --*

      The platform version of the endpoint device.

    - **Timezone** *(string) --*

      The time zone of the endpoint, specified as a tz database name value, such as
      America/Los_Angeles.
    """


_ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef
):
    """
    Type definition for `ClientGetUserEndpointsResponseEndpointsResponseItem` `Location`

    The geographic information for the endpoint.

    - **City** *(string) --*

      The name of the city where the endpoint is located.

    - **Country** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      endpoint is located. For example, US for the United States.

    - **Latitude** *(float) --*

      The latitude coordinate of the endpoint location, rounded to one decimal place.

    - **Longitude** *(float) --*

      The longitude coordinate of the endpoint location, rounded to one decimal place.

    - **PostalCode** *(string) --*

      The postal or ZIP code for the area where the endpoint is located.

    - **Region** *(string) --*

      The name of the region where the endpoint is located. For locations in the United States, this
      value is the name of a state.
    """


_ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef
):
    """
    Type definition for `ClientGetUserEndpointsResponseEndpointsResponseItem` `User`

    One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
    associated with the endpoint.

    - **UserAttributes** *(dict) --*

      One or more custom attributes that describe the user by associating a name with an array of
      values. For example, the value of an attribute named Interests might be: ["science", "music",
      "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **UserId** *(string) --*

      The unique identifier for the user.
    """


_ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": str,
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef,
    },
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef
):
    """
    Type definition for `ClientGetUserEndpointsResponseEndpointsResponse` `Item`

    Provides information about the channel type and other settings for an endpoint.

    - **Address** *(string) --*

      The destination address for messages or push notifications that you send to the endpoint. The
      address varies by channel. For example, the address for a push-notification channel is
      typically the token provided by a push notification service, such as an Apple Push
      Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
      token. The address for the SMS channel is a phone number in E.164 format, such as
      +12065550100. The address for the email channel is an email address.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that's associated with the endpoint.

    - **Attributes** *(dict) --*

      One or more custom attributes that describe the endpoint by associating a name with an array
      of values. For example, the value of a custom attribute named Interests might be: ["science",
      "music", "travel"]. You can use these attributes as filter criteria when you create segments.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ChannelType** *(string) --*

      The channel that's used when sending messages or push notifications to the endpoint.

    - **CohortId** *(string) --*

      A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints are
      grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
      endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
      allocations for campaigns.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was created.

    - **Demographic** *(dict) --*

      The demographic information for the endpoint, such as the time zone and platform.

      - **AppVersion** *(string) --*

        The version of the app that's associated with the endpoint.

      - **Locale** *(string) --*

        The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
        an underscore (_), followed by an ISO 3166-1 alpha-2 value.

      - **Make** *(string) --*

        The manufacturer of the endpoint device, such as Apple or Samsung.

      - **Model** *(string) --*

        The model name or number of the endpoint device, such as iPhone.

      - **ModelVersion** *(string) --*

        The model version of the endpoint device.

      - **Platform** *(string) --*

        The platform of the endpoint device, such as iOS or Android.

      - **PlatformVersion** *(string) --*

        The platform version of the endpoint device.

      - **Timezone** *(string) --*

        The time zone of the endpoint, specified as a tz database name value, such as
        America/Los_Angeles.

    - **EffectiveDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was last updated.

    - **EndpointStatus** *(string) --*

      Specifies whether messages or push notifications are sent to the endpoint. Possible values
      are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
      endpoint.

      Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or update
      an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if you update
      another endpoint that has the same address specified by the Address property.

    - **Id** *(string) --*

      The unique identifier that you assigned to the endpoint. The identifier should be a globally
      unique identifier (GUID) to ensure that it doesn't conflict with other endpoint identifiers
      that are associated with the application.

    - **Location** *(dict) --*

      The geographic information for the endpoint.

      - **City** *(string) --*

        The name of the city where the endpoint is located.

      - **Country** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        endpoint is located. For example, US for the United States.

      - **Latitude** *(float) --*

        The latitude coordinate of the endpoint location, rounded to one decimal place.

      - **Longitude** *(float) --*

        The longitude coordinate of the endpoint location, rounded to one decimal place.

      - **PostalCode** *(string) --*

        The postal or ZIP code for the area where the endpoint is located.

      - **Region** *(string) --*

        The name of the region where the endpoint is located. For locations in the United States,
        this value is the name of a state.

    - **Metrics** *(dict) --*

      One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

      - *(string) --*

        - *(float) --*

    - **OptOut** *(string) --*

      Specifies whether the user who's associated with the endpoint has opted out of receiving
      messages and push notifications from you. Possible values are: ALL, the user has opted out and
      doesn't want to receive any messages or push notifications; and, NONE, the user hasn't opted
      out and wants to receive all messages and push notifications.

    - **RequestId** *(string) --*

      The unique identifier for the most recent request to update the endpoint.

    - **User** *(dict) --*

      One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
      associated with the endpoint.

      - **UserAttributes** *(dict) --*

        One or more custom attributes that describe the user by associating a name with an array of
        values. For example, the value of an attribute named Interests might be: ["science",
        "music", "travel"]. You can use these attributes as filter criteria when you create
        segments.

        When you define the name of a custom attribute, avoid using the following characters: number
        sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
        console can't display attribute names that contain these characters. This limitation doesn't
        apply to attribute values.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **UserId** *(string) --*

        The unique identifier for the user.
    """


_ClientGetUserEndpointsResponseEndpointsResponseTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseTypeDef",
    {"Item": List[ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef]},
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseTypeDef
):
    """
    Type definition for `ClientGetUserEndpointsResponse` `EndpointsResponse`

    Provides information about all the endpoints that are associated with a user ID.

    - **Item** *(list) --*

      An array of responses, one for each endpoint that's associated with the user ID.

      - *(dict) --*

        Provides information about the channel type and other settings for an endpoint.

        - **Address** *(string) --*

          The destination address for messages or push notifications that you send to the endpoint.
          The address varies by channel. For example, the address for a push-notification channel is
          typically the token provided by a push notification service, such as an Apple Push
          Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
          token. The address for the SMS channel is a phone number in E.164 format, such as
          +12065550100. The address for the email channel is an email address.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the endpoint.

        - **Attributes** *(dict) --*

          One or more custom attributes that describe the endpoint by associating a name with an
          array of values. For example, the value of a custom attribute named Interests might be:
          ["science", "music", "travel"]. You can use these attributes as filter criteria when you
          create segments.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **ChannelType** *(string) --*

          The channel that's used when sending messages or push notifications to the endpoint.

        - **CohortId** *(string) --*

          A number from 0-99 that represents the cohort that the endpoint is assigned to. Endpoints
          are grouped into cohorts randomly, and each cohort contains approximately 1 percent of the
          endpoints for an application. Amazon Pinpoint assigns cohorts to the holdout or treatment
          allocations for campaigns.

        - **CreationDate** *(string) --*

          The date and time, in ISO 8601 format, when the endpoint was created.

        - **Demographic** *(dict) --*

          The demographic information for the endpoint, such as the time zone and platform.

          - **AppVersion** *(string) --*

            The version of the app that's associated with the endpoint.

          - **Locale** *(string) --*

            The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code,
            followed by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

          - **Make** *(string) --*

            The manufacturer of the endpoint device, such as Apple or Samsung.

          - **Model** *(string) --*

            The model name or number of the endpoint device, such as iPhone.

          - **ModelVersion** *(string) --*

            The model version of the endpoint device.

          - **Platform** *(string) --*

            The platform of the endpoint device, such as iOS or Android.

          - **PlatformVersion** *(string) --*

            The platform version of the endpoint device.

          - **Timezone** *(string) --*

            The time zone of the endpoint, specified as a tz database name value, such as
            America/Los_Angeles.

        - **EffectiveDate** *(string) --*

          The date and time, in ISO 8601 format, when the endpoint was last updated.

        - **EndpointStatus** *(string) --*

          Specifies whether messages or push notifications are sent to the endpoint. Possible values
          are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
          endpoint.

          Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
          update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if
          you update another endpoint that has the same address specified by the Address property.

        - **Id** *(string) --*

          The unique identifier that you assigned to the endpoint. The identifier should be a
          globally unique identifier (GUID) to ensure that it doesn't conflict with other endpoint
          identifiers that are associated with the application.

        - **Location** *(dict) --*

          The geographic information for the endpoint.

          - **City** *(string) --*

            The name of the city where the endpoint is located.

          - **Country** *(string) --*

            The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where
            the endpoint is located. For example, US for the United States.

          - **Latitude** *(float) --*

            The latitude coordinate of the endpoint location, rounded to one decimal place.

          - **Longitude** *(float) --*

            The longitude coordinate of the endpoint location, rounded to one decimal place.

          - **PostalCode** *(string) --*

            The postal or ZIP code for the area where the endpoint is located.

          - **Region** *(string) --*

            The name of the region where the endpoint is located. For locations in the United
            States, this value is the name of a state.

        - **Metrics** *(dict) --*

          One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

          - *(string) --*

            - *(float) --*

        - **OptOut** *(string) --*

          Specifies whether the user who's associated with the endpoint has opted out of receiving
          messages and push notifications from you. Possible values are: ALL, the user has opted out
          and doesn't want to receive any messages or push notifications; and, NONE, the user hasn't
          opted out and wants to receive all messages and push notifications.

        - **RequestId** *(string) --*

          The unique identifier for the most recent request to update the endpoint.

        - **User** *(dict) --*

          One or more custom user attributes that your app reports to Amazon Pinpoint for the user
          who's associated with the endpoint.

          - **UserAttributes** *(dict) --*

            One or more custom attributes that describe the user by associating a name with an array
            of values. For example, the value of an attribute named Interests might be: ["science",
            "music", "travel"]. You can use these attributes as filter criteria when you create
            segments.

            When you define the name of a custom attribute, avoid using the following characters:
            number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon
            Pinpoint console can't display attribute names that contain these characters. This
            limitation doesn't apply to attribute values.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **UserId** *(string) --*

            The unique identifier for the user.
    """


_ClientGetUserEndpointsResponseTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseTypeDef",
    {"EndpointsResponse": ClientGetUserEndpointsResponseEndpointsResponseTypeDef},
    total=False,
)


class ClientGetUserEndpointsResponseTypeDef(_ClientGetUserEndpointsResponseTypeDef):
    """
    Type definition for `ClientGetUserEndpoints` `Response`

    The request succeeded.

    - **EndpointsResponse** *(dict) --*

      Provides information about all the endpoints that are associated with a user ID.

      - **Item** *(list) --*

        An array of responses, one for each endpoint that's associated with the user ID.

        - *(dict) --*

          Provides information about the channel type and other settings for an endpoint.

          - **Address** *(string) --*

            The destination address for messages or push notifications that you send to the
            endpoint. The address varies by channel. For example, the address for a
            push-notification channel is typically the token provided by a push notification
            service, such as an Apple Push Notification service (APNs) device token or a Firebase
            Cloud Messaging (FCM) registration token. The address for the SMS channel is a phone
            number in E.164 format, such as +12065550100. The address for the email channel is an
            email address.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the endpoint.

          - **Attributes** *(dict) --*

            One or more custom attributes that describe the endpoint by associating a name with an
            array of values. For example, the value of a custom attribute named Interests might be:
            ["science", "music", "travel"]. You can use these attributes as filter criteria when you
            create segments.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **ChannelType** *(string) --*

            The channel that's used when sending messages or push notifications to the endpoint.

          - **CohortId** *(string) --*

            A number from 0-99 that represents the cohort that the endpoint is assigned to.
            Endpoints are grouped into cohorts randomly, and each cohort contains approximately 1
            percent of the endpoints for an application. Amazon Pinpoint assigns cohorts to the
            holdout or treatment allocations for campaigns.

          - **CreationDate** *(string) --*

            The date and time, in ISO 8601 format, when the endpoint was created.

          - **Demographic** *(dict) --*

            The demographic information for the endpoint, such as the time zone and platform.

            - **AppVersion** *(string) --*

              The version of the app that's associated with the endpoint.

            - **Locale** *(string) --*

              The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code,
              followed by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

            - **Make** *(string) --*

              The manufacturer of the endpoint device, such as Apple or Samsung.

            - **Model** *(string) --*

              The model name or number of the endpoint device, such as iPhone.

            - **ModelVersion** *(string) --*

              The model version of the endpoint device.

            - **Platform** *(string) --*

              The platform of the endpoint device, such as iOS or Android.

            - **PlatformVersion** *(string) --*

              The platform version of the endpoint device.

            - **Timezone** *(string) --*

              The time zone of the endpoint, specified as a tz database name value, such as
              America/Los_Angeles.

          - **EffectiveDate** *(string) --*

            The date and time, in ISO 8601 format, when the endpoint was last updated.

          - **EndpointStatus** *(string) --*

            Specifies whether messages or push notifications are sent to the endpoint. Possible
            values are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t
            sent to the endpoint.

            Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
            update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE
            if you update another endpoint that has the same address specified by the Address
            property.

          - **Id** *(string) --*

            The unique identifier that you assigned to the endpoint. The identifier should be a
            globally unique identifier (GUID) to ensure that it doesn't conflict with other endpoint
            identifiers that are associated with the application.

          - **Location** *(dict) --*

            The geographic information for the endpoint.

            - **City** *(string) --*

              The name of the city where the endpoint is located.

            - **Country** *(string) --*

              The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where
              the endpoint is located. For example, US for the United States.

            - **Latitude** *(float) --*

              The latitude coordinate of the endpoint location, rounded to one decimal place.

            - **Longitude** *(float) --*

              The longitude coordinate of the endpoint location, rounded to one decimal place.

            - **PostalCode** *(string) --*

              The postal or ZIP code for the area where the endpoint is located.

            - **Region** *(string) --*

              The name of the region where the endpoint is located. For locations in the United
              States, this value is the name of a state.

          - **Metrics** *(dict) --*

            One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

            - *(string) --*

              - *(float) --*

          - **OptOut** *(string) --*

            Specifies whether the user who's associated with the endpoint has opted out of receiving
            messages and push notifications from you. Possible values are: ALL, the user has opted
            out and doesn't want to receive any messages or push notifications; and, NONE, the user
            hasn't opted out and wants to receive all messages and push notifications.

          - **RequestId** *(string) --*

            The unique identifier for the most recent request to update the endpoint.

          - **User** *(dict) --*

            One or more custom user attributes that your app reports to Amazon Pinpoint for the user
            who's associated with the endpoint.

            - **UserAttributes** *(dict) --*

              One or more custom attributes that describe the user by associating a name with an
              array of values. For example, the value of an attribute named Interests might be:
              ["science", "music", "travel"]. You can use these attributes as filter criteria when
              you create segments.

              When you define the name of a custom attribute, avoid using the following characters:
              number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The
              Amazon Pinpoint console can't display attribute names that contain these characters.
              This limitation doesn't apply to attribute values.

              - *(string) --*

                - *(list) --*

                  - *(string) --*

            - **UserId** *(string) --*

              The unique identifier for the user.
    """


_ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef = TypedDict(
    "_ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef(
    _ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef
):
    """
    Type definition for `ClientGetVoiceChannelResponse` `VoiceChannelResponse`

    Provides information about the status and settings of the voice channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the voice channel applies to.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the voice channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the voice channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the voice channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the voice channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the voice channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the voice channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the voice channel, this
      value is VOICE.

    - **Version** *(integer) --*

      The current version of the voice channel.
    """


_ClientGetVoiceChannelResponseTypeDef = TypedDict(
    "_ClientGetVoiceChannelResponseTypeDef",
    {"VoiceChannelResponse": ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef},
    total=False,
)


class ClientGetVoiceChannelResponseTypeDef(_ClientGetVoiceChannelResponseTypeDef):
    """
    Type definition for `ClientGetVoiceChannel` `Response`

    The request succeeded.

    - **VoiceChannelResponse** *(dict) --*

      Provides information about the status and settings of the voice channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the voice channel applies to.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the voice channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the voice channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the voice channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the voice channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the voice channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the voice channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the voice channel, this
        value is VOICE.

      - **Version** *(integer) --*

        The current version of the voice channel.
    """


_ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef",
    {
        "Arn": str,
        "Body": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "LanguageCode": str,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": str,
        "VoiceId": str,
    },
    total=False,
)


class ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef(
    _ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef
):
    """
    Type definition for `ClientGetVoiceTemplateResponse` `VoiceTemplateResponse`

    Provides information about the content and settings for a message template that can be used in
    messages that are sent through the voice channel.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template.

    - **Body** *(string) --*

      The text of the script that's used in messages that are based on the message template, in
      plain text format.

    - **CreationDate** *(string) --*

      The date when the message template was created.

    - **DefaultSubstitutions** *(string) --*

      The JSON object that specifies the default values that are used for message variables in the
      message template. This object is a set of key-value pairs. Each key defines a message variable
      in the template. The corresponding value defines the default value for that variable.

    - **LanguageCode** *(string) --*

      The code for the language that's used when synthesizing the text of the script in messages
      that are based on the message template. For a list of supported languages and the code for
      each one, see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

    - **LastModifiedDate** *(string) --*

      The date when the message template was last modified.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the message template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      The custom description of the message template.

    - **TemplateName** *(string) --*

      The name of the message template.

    - **TemplateType** *(string) --*

      The type of channel that the message template is designed for. For a voice template, this
      value is VOICE.

    - **VoiceId** *(string) --*

      The name of the voice that's used when delivering messages that are based on the message
      template. For a list of supported voices, see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """


_ClientGetVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientGetVoiceTemplateResponseTypeDef",
    {"VoiceTemplateResponse": ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef},
    total=False,
)


class ClientGetVoiceTemplateResponseTypeDef(_ClientGetVoiceTemplateResponseTypeDef):
    """
    Type definition for `ClientGetVoiceTemplate` `Response`

    The request succeeded.

    - **VoiceTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      messages that are sent through the voice channel.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.

      - **Body** *(string) --*

        The text of the script that's used in messages that are based on the message template, in
        plain text format.

      - **CreationDate** *(string) --*

        The date when the message template was created.

      - **DefaultSubstitutions** *(string) --*

        The JSON object that specifies the default values that are used for message variables in the
        message template. This object is a set of key-value pairs. Each key defines a message
        variable in the template. The corresponding value defines the default value for that
        variable.

      - **LanguageCode** *(string) --*

        The code for the language that's used when synthesizing the text of the script in messages
        that are based on the message template. For a list of supported languages and the code for
        each one, see the `Amazon Polly Developer Guide
        <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

      - **LastModifiedDate** *(string) --*

        The date when the message template was last modified.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the message template. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateDescription** *(string) --*

        The custom description of the message template.

      - **TemplateName** *(string) --*

        The name of the message template.

      - **TemplateType** *(string) --*

        The type of channel that the message template is designed for. For a voice template, this
        value is VOICE.

      - **VoiceId** *(string) --*

        The name of the voice that's used when delivering messages that are based on the message
        template. For a list of supported voices, see the `Amazon Polly Developer Guide
        <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitCondition` `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --*

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivities`
    `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivitiesEMAIL`
    `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --*

      The percentage of participants who shouldn't continue the journey.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for
    `ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranches` `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivitiesMultiCondition`
    `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --*

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplit`
    `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef",
    {
        "ConditionalSplit": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef,
        "Holdout": ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef,
        "MultiCondition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef,
        "Wait": ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItem` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --*

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientListJourneysResponseJourneysResponseItemLimitsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemLimitsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemLimitsTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItem` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItem` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientListJourneysResponseJourneysResponseItemScheduleTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemScheduleTypeDef(
    _ClientListJourneysResponseJourneysResponseItemScheduleTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItem` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItemStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponseItem` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.
    """


_ClientListJourneysResponseJourneysResponseItemTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemTypeDef",
    {
        "Activities": Dict[str, ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientListJourneysResponseJourneysResponseItemLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientListJourneysResponseJourneysResponseItemScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef,
        "State": str,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemTypeDef(
    _ClientListJourneysResponseJourneysResponseItemTypeDef
):
    """
    Type definition for `ClientListJourneysResponseJourneysResponse` `Item`

    Provides information about the status, configuration, and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --*

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the journey applies to.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **Id** *(string) --*

      The unique identifier for the journey.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. If this value is true, the schedule uses each participant's local time.

    - **Name** *(string) --*

      The name of the journey.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The current status of the journey. Possible values are:

      * DRAFT - The journey is being developed and hasn't been published yet.

      * ACTIVE - The journey has been developed and published. Depending on the journey's schedule,
      the journey may currently be running or scheduled to start running at a later time. If a
      journey's status is ACTIVE, you can't add, change, or remove activities from it.

      * COMPLETED - The journey has been published and has finished running. All participants have
      entered the journey and no participants are waiting to complete the journey or any activities
      in the journey.

      * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't add,
      change, or remove activities or segment settings from the journey.

      * CLOSED - The journey has been published and has started running. It may have also passed its
      scheduled end time, or passed its scheduled start time and a refresh frequency hasn't been
      specified for it. If a journey's status is CLOSED, you can't add participants to it, and no
      existing participants can enter the journey for the first time. However, any existing
      participants who are currently waiting to start an activity may resume the journey.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the journey. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientListJourneysResponseJourneysResponseTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseTypeDef",
    {"Item": List[ClientListJourneysResponseJourneysResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseTypeDef(
    _ClientListJourneysResponseJourneysResponseTypeDef
):
    """
    Type definition for `ClientListJourneysResponse` `JourneysResponse`

    Provides information about the status, configuration, and other settings for all the journeys
    that are associated with an application.

    - **Item** *(list) --*

      An array of responses, one for each journey that's associated with the application.

      - *(dict) --*

        Provides information about the status, configuration, and other settings for a journey.

        - **Activities** *(dict) --*

          The configuration and other settings for the activities that comprise the journey.

          - *(string) --*

            - *(dict) --*

              Specifies the configuration and other settings for an activity in a journey.

              - **ConditionalSplit** *(dict) --*

                The settings for a yes/no split activity. This type of activity sends participants
                down one of two paths in a journey, based on conditions that you specify.

                - **Condition** *(dict) --*

                  The conditions that define the paths for the activity, and the relationship
                  between the conditions.

                  - **Conditions** *(list) --*

                    The conditions to evaluate for the activity.

                    - *(dict) --*

                      Specifies a condition to evaluate for an activity in a journey.

                      - **EventCondition** *(dict) --*

                        The dimension settings for the event that's associated with the activity.

                        - **Dimensions** *(dict) --*

                          The dimensions for the event filter to use for the activity.

                          - **Attributes** *(dict) --*

                            One or more custom attributes that your application reports to Amazon
                            Pinpoint. You can use these attributes as selection criteria when you
                            create an event filter.

                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.

                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.

                                - **Values** *(list) --*

                                  The criteria values to use for the segment dimension. Depending on
                                  the value of the AttributeType property, endpoints are included or
                                  excluded from the segment if their attribute values match the
                                  criteria values.

                                  - *(string) --*

                          - **EventType** *(dict) --*

                            The name of the event that causes the campaign to be sent or the journey
                            activity to be performed. This can be a standard type of event that
                            Amazon Pinpoint generates, such as _email.delivered, or a custom event
                            that's specific to your application.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Metrics** *(dict) --*

                            One or more custom metrics that your application reports to Amazon
                            Pinpoint. You can use these metrics as selection criteria when you
                            create an event filter.

                            - *(string) --*

                              - *(dict) --*

                                Specifies metric-based criteria for including or excluding endpoints
                                from a segment. These criteria derive from custom metrics that you
                                define for endpoints.

                                - **ComparisonOperator** *(string) --*

                                  The operator to use when comparing metric values. Valid values
                                  are: GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL,
                                  LESS_THAN_OR_EQUAL, and EQUAL.

                                - **Value** *(float) --*

                                  The value to compare.

                        - **MessageActivity** *(string) --*

                          The message identifier (message_id) for the message to use when
                          determining whether message events meet the condition.

                      - **SegmentCondition** *(dict) --*

                        The segment that's associated with the activity.

                        - **SegmentId** *(string) --*

                          The unique identifier for the segment to associate with the activity.

                      - **SegmentDimensions** *(dict) --*

                        The dimension settings for the segment that's associated with the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes to use as criteria for the segment.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **Behavior** *(dict) --*

                          The behavior-based criteria, such as how recently users have used your
                          app, for the segment.

                          - **Recency** *(dict) --*

                            The dimension settings that are based on how recently an endpoint was
                            active.

                            - **Duration** *(string) --*

                              The duration to use when determining whether an endpoint is active or
                              inactive.

                            - **RecencyType** *(string) --*

                              The type of recency dimension to use for the segment. Valid values
                              are: ACTIVE, endpoints that were active within the specified duration
                              are included in the segment; and, INACTIVE, endpoints that weren't
                              active within the specified duration are included in the segment.

                        - **Demographic** *(dict) --*

                          The demographic-based criteria, such as device platform, for the segment.

                          - **AppVersion** *(dict) --*

                            The app version criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Channel** *(dict) --*

                            The channel criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **DeviceType** *(dict) --*

                            The device type criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Make** *(dict) --*

                            The device make criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Model** *(dict) --*

                            The device model criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Platform** *(dict) --*

                            The device platform criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                        - **Location** *(dict) --*

                          The location-based criteria, such as region or GPS coordinates, for the
                          segment.

                          - **Country** *(dict) --*

                            The country or region code, in ISO 3166-1 alpha-2 format, for the
                            segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **GPSPoint** *(dict) --*

                            The GPS location and range for the segment.

                            - **Coordinates** *(dict) --*

                              The GPS coordinates to measure distance from.

                              - **Latitude** *(float) --*

                                The latitude coordinate of the location.

                              - **Longitude** *(float) --*

                                The longitude coordinate of the location.

                            - **RangeInKilometers** *(float) --*

                              The range, in kilometers, from the GPS coordinates.

                        - **Metrics** *(dict) --*

                          One or more custom metrics to use as criteria for the segment.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                        - **UserAttributes** *(dict) --*

                          One or more custom user attributes to use as criteria for the segment.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                  - **Operator** *(string) --*

                    Specifies how to handle multiple conditions for the activity. For example, if
                    you specify two conditions for an activity, whether both or only one of the
                    conditions must be met for the activity to be performed.

                - **EvaluationWaitTime** *(dict) --*

                  The amount of time to wait before determining whether the conditions are met, or
                  the date and time when Amazon Pinpoint determines whether the conditions are met.

                  - **WaitFor** *(string) --*

                    The amount of time to wait, as a duration in ISO 8601 format, before determining
                    whether the activity's conditions have been met or moving participants to the
                    next activity in the journey.

                  - **WaitUntil** *(string) --*

                    The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether
                    the activity's conditions have been met or the activity moves participants to
                    the next activity in the journey.

                - **FalseActivity** *(string) --*

                  The unique identifier for the activity to perform if the condition isn't met.

                - **TrueActivity** *(string) --*

                  The unique identifier for the activity to perform if the condition is met.

              - **Description** *(string) --*

                The custom description of the activity.

              - **EMAIL** *(dict) --*

                The settings for an email activity. This type of activity sends an email message to
                participants.

                - **MessageConfig** *(dict) --*

                  The "From" address to use for the message.

                  - **FromAddress** *(string) --*

                    The verified email address to send the email message from. The default address
                    is the FromAddress specified for the email channel for the application.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after the message is sent.

                - **TemplateName** *(string) --*

                  The name of the email template to use for the message.

              - **Holdout** *(dict) --*

                The settings for a holdout activity. This type of activity stops a journey for a
                specified percentage of participants.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after performing the
                  holdout activity.

                - **Percentage** *(integer) --*

                  The percentage of participants who shouldn't continue the journey.

              - **MultiCondition** *(dict) --*

                The settings for a multivariate split activity. This type of activity sends
                participants down one of as many as five paths in a journey, based on conditions
                that you specify.

                - **Branches** *(list) --*

                  The paths for the activity, including the conditions for entering each path and
                  the activity to perform for each path.

                  - *(dict) --*

                    Specifies a condition to evaluate for an activity path in a journey.

                    - **Condition** *(dict) --*

                      The condition to evaluate for the activity path.

                      - **EventCondition** *(dict) --*

                        The dimension settings for the event that's associated with the activity.

                        - **Dimensions** *(dict) --*

                          The dimensions for the event filter to use for the activity.

                          - **Attributes** *(dict) --*

                            One or more custom attributes that your application reports to Amazon
                            Pinpoint. You can use these attributes as selection criteria when you
                            create an event filter.

                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.

                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.

                                - **Values** *(list) --*

                                  The criteria values to use for the segment dimension. Depending on
                                  the value of the AttributeType property, endpoints are included or
                                  excluded from the segment if their attribute values match the
                                  criteria values.

                                  - *(string) --*

                          - **EventType** *(dict) --*

                            The name of the event that causes the campaign to be sent or the journey
                            activity to be performed. This can be a standard type of event that
                            Amazon Pinpoint generates, such as _email.delivered, or a custom event
                            that's specific to your application.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Metrics** *(dict) --*

                            One or more custom metrics that your application reports to Amazon
                            Pinpoint. You can use these metrics as selection criteria when you
                            create an event filter.

                            - *(string) --*

                              - *(dict) --*

                                Specifies metric-based criteria for including or excluding endpoints
                                from a segment. These criteria derive from custom metrics that you
                                define for endpoints.

                                - **ComparisonOperator** *(string) --*

                                  The operator to use when comparing metric values. Valid values
                                  are: GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL,
                                  LESS_THAN_OR_EQUAL, and EQUAL.

                                - **Value** *(float) --*

                                  The value to compare.

                        - **MessageActivity** *(string) --*

                          The message identifier (message_id) for the message to use when
                          determining whether message events meet the condition.

                      - **SegmentCondition** *(dict) --*

                        The segment that's associated with the activity.

                        - **SegmentId** *(string) --*

                          The unique identifier for the segment to associate with the activity.

                      - **SegmentDimensions** *(dict) --*

                        The dimension settings for the segment that's associated with the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes to use as criteria for the segment.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **Behavior** *(dict) --*

                          The behavior-based criteria, such as how recently users have used your
                          app, for the segment.

                          - **Recency** *(dict) --*

                            The dimension settings that are based on how recently an endpoint was
                            active.

                            - **Duration** *(string) --*

                              The duration to use when determining whether an endpoint is active or
                              inactive.

                            - **RecencyType** *(string) --*

                              The type of recency dimension to use for the segment. Valid values
                              are: ACTIVE, endpoints that were active within the specified duration
                              are included in the segment; and, INACTIVE, endpoints that weren't
                              active within the specified duration are included in the segment.

                        - **Demographic** *(dict) --*

                          The demographic-based criteria, such as device platform, for the segment.

                          - **AppVersion** *(dict) --*

                            The app version criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Channel** *(dict) --*

                            The channel criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **DeviceType** *(dict) --*

                            The device type criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Make** *(dict) --*

                            The device make criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Model** *(dict) --*

                            The device model criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **Platform** *(dict) --*

                            The device platform criteria for the segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                        - **Location** *(dict) --*

                          The location-based criteria, such as region or GPS coordinates, for the
                          segment.

                          - **Country** *(dict) --*

                            The country or region code, in ISO 3166-1 alpha-2 format, for the
                            segment.

                            - **DimensionType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the DimensionType property, endpoints are included or
                              excluded from the segment if their values match the criteria values.

                              - *(string) --*

                          - **GPSPoint** *(dict) --*

                            The GPS location and range for the segment.

                            - **Coordinates** *(dict) --*

                              The GPS coordinates to measure distance from.

                              - **Latitude** *(float) --*

                                The latitude coordinate of the location.

                              - **Longitude** *(float) --*

                                The longitude coordinate of the location.

                            - **RangeInKilometers** *(float) --*

                              The range, in kilometers, from the GPS coordinates.

                        - **Metrics** *(dict) --*

                          One or more custom metrics to use as criteria for the segment.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                        - **UserAttributes** *(dict) --*

                          One or more custom user attributes to use as criteria for the segment.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                    - **NextActivity** *(string) --*

                      The unique identifier for the next activity to perform, after completing the
                      activity for the path.

                - **DefaultActivity** *(string) --*

                  The activity to perform by default for any path in the activity.

                - **EvaluationWaitTime** *(dict) --*

                  The amount of time to wait or the date and time when Amazon Pinpoint determines
                  whether the conditions are met.

                  - **WaitFor** *(string) --*

                    The amount of time to wait, as a duration in ISO 8601 format, before determining
                    whether the activity's conditions have been met or moving participants to the
                    next activity in the journey.

                  - **WaitUntil** *(string) --*

                    The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether
                    the activity's conditions have been met or the activity moves participants to
                    the next activity in the journey.

              - **RandomSplit** *(dict) --*

                The settings for a random split activity. This type of activity randomly sends
                specified percentages of participants down one of as many as five paths in a
                journey, based on conditions that you specify.

                - **Branches** *(list) --*

                  The paths for the activity, including the percentage of participants to enter each
                  path and the activity to perform for each path.

                  - *(dict) --*

                    Specifies the settings for a path in a random split activity in a journey.

                    - **NextActivity** *(string) --*

                      The unique identifier for the next activity to perform, after completing the
                      activity for the path.

                    - **Percentage** *(integer) --*

                      The percentage of participants to send down the activity path.

              - **Wait** *(dict) --*

                The settings for a wait activity. This type of activity waits for a certain amount
                of time or until a specific date and time before moving participants to the next
                activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after performing the wait
                  activity.

                - **WaitTime** *(dict) --*

                  The amount of time to wait or the date and time when the activity moves
                  participants to the next activity in the journey.

                  - **WaitFor** *(string) --*

                    The amount of time to wait, as a duration in ISO 8601 format, before determining
                    whether the activity's conditions have been met or moving participants to the
                    next activity in the journey.

                  - **WaitUntil** *(string) --*

                    The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether
                    the activity's conditions have been met or the activity moves participants to
                    the next activity in the journey.

        - **ApplicationId** *(string) --*

          The unique identifier for the application that the journey applies to.

        - **CreationDate** *(string) --*

          The date, in ISO 8601 format, when the journey was created.

        - **Id** *(string) --*

          The unique identifier for the journey.

        - **LastModifiedDate** *(string) --*

          The date, in ISO 8601 format, when the journey was last modified.

        - **Limits** *(dict) --*

          The messaging and entry limits for the journey.

          - **DailyCap** *(integer) --*

            The maximum number of messages that the journey can send to a single participant during
            a 24-hour period. The maximum value is 100.

          - **EndpointReentryCap** *(integer) --*

            The maximum number of times that a participant can enter the journey. The maximum value
            is 100. To allow participants to enter the journey an unlimited number of times, set
            this value to 0.

          - **MessagesPerSecond** *(integer) --*

            The maximum number of messages that the journey can send each second.

        - **LocalTime** *(boolean) --*

          Specifies whether the journey's scheduled start and end times use each participant's local
          time. If this value is true, the schedule uses each participant's local time.

        - **Name** *(string) --*

          The name of the journey.

        - **QuietTime** *(dict) --*

          The quiet time settings for the journey. Quiet time is a specific time range when a
          journey doesn't send messages to participants, if all the following conditions are met:

          * The EndpointDemographic.Timezone property of the endpoint for the participant is set to
          a valid value.

          * The current time in the participant's time zone is later than or equal to the time
          specified by the QuietTime.Start property for the journey.

          * The current time in the participant's time zone is earlier than or equal to the time
          specified by the QuietTime.End property for the journey.

          If any of the preceding conditions isn't met, the participant will receive messages from
          the journey, even if quiet time is enabled.

          - **End** *(string) --*

            The specific time when quiet time ends. This value has to use 24-hour notation and be in
            HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

          - **Start** *(string) --*

            The specific time when quiet time begins. This value has to use 24-hour notation and be
            in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **RefreshFrequency** *(string) --*

          The frequency with which Amazon Pinpoint evaluates segment and event data for the journey,
          as a duration in ISO 8601 format.

        - **Schedule** *(dict) --*

          The schedule settings for the journey.

          - **EndTime** *(datetime) --*

            The scheduled time, in ISO 8601 format, when the journey ended or will end.

          - **StartTime** *(datetime) --*

            The scheduled time, in ISO 8601 format, when the journey began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the journey schedule, if the value of the journey's
            LocalTime property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30,
            UTC+04, UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08,
            UTC+08:45, UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13,
            UTC+13:45, UTC-02, UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
            UTC-09, UTC-09:30, UTC-10, and UTC-11.

        - **StartActivity** *(string) --*

          The unique identifier for the first activity in the journey.

        - **StartCondition** *(dict) --*

          The segment that defines which users are participants in the journey.

          - **Description** *(string) --*

            The custom description of the condition.

          - **SegmentStartCondition** *(dict) --*

            The segment that's associated with the first activity in the journey. This segment
            determines which users are participants in the journey.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

        - **State** *(string) --*

          The current status of the journey. Possible values are:

          * DRAFT - The journey is being developed and hasn't been published yet.

          * ACTIVE - The journey has been developed and published. Depending on the journey's
          schedule, the journey may currently be running or scheduled to start running at a later
          time. If a journey's status is ACTIVE, you can't add, change, or remove activities from
          it.

          * COMPLETED - The journey has been published and has finished running. All participants
          have entered the journey and no participants are waiting to complete the journey or any
          activities in the journey.

          * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't
          add, change, or remove activities or segment settings from the journey.

          * CLOSED - The journey has been published and has started running. It may have also passed
          its scheduled end time, or passed its scheduled start time and a refresh frequency hasn't
          been specified for it. If a journey's status is CLOSED, you can't add participants to it,
          and no existing participants can enter the journey for the first time. However, any
          existing participants who are currently waiting to start an activity may resume the
          journey.

        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that identifies the tags that are associated
          with the journey. Each tag consists of a required tag key and an associated tag value.

          - *(string) --*

            - *(string) --*

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientListJourneysResponseTypeDef = TypedDict(
    "_ClientListJourneysResponseTypeDef",
    {"JourneysResponse": ClientListJourneysResponseJourneysResponseTypeDef},
    total=False,
)


class ClientListJourneysResponseTypeDef(_ClientListJourneysResponseTypeDef):
    """
    Type definition for `ClientListJourneys` `Response`

    The request succeeded.

    - **JourneysResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for all the journeys
      that are associated with an application.

      - **Item** *(list) --*

        An array of responses, one for each journey that's associated with the application.

        - *(dict) --*

          Provides information about the status, configuration, and other settings for a journey.

          - **Activities** *(dict) --*

            The configuration and other settings for the activities that comprise the journey.

            - *(string) --*

              - *(dict) --*

                Specifies the configuration and other settings for an activity in a journey.

                - **ConditionalSplit** *(dict) --*

                  The settings for a yes/no split activity. This type of activity sends participants
                  down one of two paths in a journey, based on conditions that you specify.

                  - **Condition** *(dict) --*

                    The conditions that define the paths for the activity, and the relationship
                    between the conditions.

                    - **Conditions** *(list) --*

                      The conditions to evaluate for the activity.

                      - *(dict) --*

                        Specifies a condition to evaluate for an activity in a journey.

                        - **EventCondition** *(dict) --*

                          The dimension settings for the event that's associated with the activity.

                          - **Dimensions** *(dict) --*

                            The dimensions for the event filter to use for the activity.

                            - **Attributes** *(dict) --*

                              One or more custom attributes that your application reports to Amazon
                              Pinpoint. You can use these attributes as selection criteria when you
                              create an event filter.

                              - *(string) --*

                                - *(dict) --*

                                  Specifies attribute-based criteria for including or excluding
                                  endpoints from a segment.

                                  - **AttributeType** *(string) --*

                                    The type of segment dimension to use. Valid values are:
                                    INCLUSIVE, endpoints that match the criteria are included in the
                                    segment; and, EXCLUSIVE, endpoints that match the criteria are
                                    excluded from the segment.

                                  - **Values** *(list) --*

                                    The criteria values to use for the segment dimension. Depending
                                    on the value of the AttributeType property, endpoints are
                                    included or excluded from the segment if their attribute values
                                    match the criteria values.

                                    - *(string) --*

                            - **EventType** *(dict) --*

                              The name of the event that causes the campaign to be sent or the
                              journey activity to be performed. This can be a standard type of event
                              that Amazon Pinpoint generates, such as _email.delivered, or a custom
                              event that's specific to your application.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Metrics** *(dict) --*

                              One or more custom metrics that your application reports to Amazon
                              Pinpoint. You can use these metrics as selection criteria when you
                              create an event filter.

                              - *(string) --*

                                - *(dict) --*

                                  Specifies metric-based criteria for including or excluding
                                  endpoints from a segment. These criteria derive from custom
                                  metrics that you define for endpoints.

                                  - **ComparisonOperator** *(string) --*

                                    The operator to use when comparing metric values. Valid values
                                    are: GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL,
                                    LESS_THAN_OR_EQUAL, and EQUAL.

                                  - **Value** *(float) --*

                                    The value to compare.

                          - **MessageActivity** *(string) --*

                            The message identifier (message_id) for the message to use when
                            determining whether message events meet the condition.

                        - **SegmentCondition** *(dict) --*

                          The segment that's associated with the activity.

                          - **SegmentId** *(string) --*

                            The unique identifier for the segment to associate with the activity.

                        - **SegmentDimensions** *(dict) --*

                          The dimension settings for the segment that's associated with the
                          activity.

                          - **Attributes** *(dict) --*

                            One or more custom attributes to use as criteria for the segment.

                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.

                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.

                                - **Values** *(list) --*

                                  The criteria values to use for the segment dimension. Depending on
                                  the value of the AttributeType property, endpoints are included or
                                  excluded from the segment if their attribute values match the
                                  criteria values.

                                  - *(string) --*

                          - **Behavior** *(dict) --*

                            The behavior-based criteria, such as how recently users have used your
                            app, for the segment.

                            - **Recency** *(dict) --*

                              The dimension settings that are based on how recently an endpoint was
                              active.

                              - **Duration** *(string) --*

                                The duration to use when determining whether an endpoint is active
                                or inactive.

                              - **RecencyType** *(string) --*

                                The type of recency dimension to use for the segment. Valid values
                                are: ACTIVE, endpoints that were active within the specified
                                duration are included in the segment; and, INACTIVE, endpoints that
                                weren't active within the specified duration are included in the
                                segment.

                          - **Demographic** *(dict) --*

                            The demographic-based criteria, such as device platform, for the
                            segment.

                            - **AppVersion** *(dict) --*

                              The app version criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Channel** *(dict) --*

                              The channel criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **DeviceType** *(dict) --*

                              The device type criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Make** *(dict) --*

                              The device make criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Model** *(dict) --*

                              The device model criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Platform** *(dict) --*

                              The device platform criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                          - **Location** *(dict) --*

                            The location-based criteria, such as region or GPS coordinates, for the
                            segment.

                            - **Country** *(dict) --*

                              The country or region code, in ISO 3166-1 alpha-2 format, for the
                              segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **GPSPoint** *(dict) --*

                              The GPS location and range for the segment.

                              - **Coordinates** *(dict) --*

                                The GPS coordinates to measure distance from.

                                - **Latitude** *(float) --*

                                  The latitude coordinate of the location.

                                - **Longitude** *(float) --*

                                  The longitude coordinate of the location.

                              - **RangeInKilometers** *(float) --*

                                The range, in kilometers, from the GPS coordinates.

                          - **Metrics** *(dict) --*

                            One or more custom metrics to use as criteria for the segment.

                            - *(string) --*

                              - *(dict) --*

                                Specifies metric-based criteria for including or excluding endpoints
                                from a segment. These criteria derive from custom metrics that you
                                define for endpoints.

                                - **ComparisonOperator** *(string) --*

                                  The operator to use when comparing metric values. Valid values
                                  are: GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL,
                                  LESS_THAN_OR_EQUAL, and EQUAL.

                                - **Value** *(float) --*

                                  The value to compare.

                          - **UserAttributes** *(dict) --*

                            One or more custom user attributes to use as criteria for the segment.

                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.

                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.

                                - **Values** *(list) --*

                                  The criteria values to use for the segment dimension. Depending on
                                  the value of the AttributeType property, endpoints are included or
                                  excluded from the segment if their attribute values match the
                                  criteria values.

                                  - *(string) --*

                    - **Operator** *(string) --*

                      Specifies how to handle multiple conditions for the activity. For example, if
                      you specify two conditions for an activity, whether both or only one of the
                      conditions must be met for the activity to be performed.

                  - **EvaluationWaitTime** *(dict) --*

                    The amount of time to wait before determining whether the conditions are met, or
                    the date and time when Amazon Pinpoint determines whether the conditions are
                    met.

                    - **WaitFor** *(string) --*

                      The amount of time to wait, as a duration in ISO 8601 format, before
                      determining whether the activity's conditions have been met or moving
                      participants to the next activity in the journey.

                    - **WaitUntil** *(string) --*

                      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether
                      the activity's conditions have been met or the activity moves participants to
                      the next activity in the journey.

                  - **FalseActivity** *(string) --*

                    The unique identifier for the activity to perform if the condition isn't met.

                  - **TrueActivity** *(string) --*

                    The unique identifier for the activity to perform if the condition is met.

                - **Description** *(string) --*

                  The custom description of the activity.

                - **EMAIL** *(dict) --*

                  The settings for an email activity. This type of activity sends an email message
                  to participants.

                  - **MessageConfig** *(dict) --*

                    The "From" address to use for the message.

                    - **FromAddress** *(string) --*

                      The verified email address to send the email message from. The default address
                      is the FromAddress specified for the email channel for the application.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after the message is
                    sent.

                  - **TemplateName** *(string) --*

                    The name of the email template to use for the message.

                - **Holdout** *(dict) --*

                  The settings for a holdout activity. This type of activity stops a journey for a
                  specified percentage of participants.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after performing the
                    holdout activity.

                  - **Percentage** *(integer) --*

                    The percentage of participants who shouldn't continue the journey.

                - **MultiCondition** *(dict) --*

                  The settings for a multivariate split activity. This type of activity sends
                  participants down one of as many as five paths in a journey, based on conditions
                  that you specify.

                  - **Branches** *(list) --*

                    The paths for the activity, including the conditions for entering each path and
                    the activity to perform for each path.

                    - *(dict) --*

                      Specifies a condition to evaluate for an activity path in a journey.

                      - **Condition** *(dict) --*

                        The condition to evaluate for the activity path.

                        - **EventCondition** *(dict) --*

                          The dimension settings for the event that's associated with the activity.

                          - **Dimensions** *(dict) --*

                            The dimensions for the event filter to use for the activity.

                            - **Attributes** *(dict) --*

                              One or more custom attributes that your application reports to Amazon
                              Pinpoint. You can use these attributes as selection criteria when you
                              create an event filter.

                              - *(string) --*

                                - *(dict) --*

                                  Specifies attribute-based criteria for including or excluding
                                  endpoints from a segment.

                                  - **AttributeType** *(string) --*

                                    The type of segment dimension to use. Valid values are:
                                    INCLUSIVE, endpoints that match the criteria are included in the
                                    segment; and, EXCLUSIVE, endpoints that match the criteria are
                                    excluded from the segment.

                                  - **Values** *(list) --*

                                    The criteria values to use for the segment dimension. Depending
                                    on the value of the AttributeType property, endpoints are
                                    included or excluded from the segment if their attribute values
                                    match the criteria values.

                                    - *(string) --*

                            - **EventType** *(dict) --*

                              The name of the event that causes the campaign to be sent or the
                              journey activity to be performed. This can be a standard type of event
                              that Amazon Pinpoint generates, such as _email.delivered, or a custom
                              event that's specific to your application.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Metrics** *(dict) --*

                              One or more custom metrics that your application reports to Amazon
                              Pinpoint. You can use these metrics as selection criteria when you
                              create an event filter.

                              - *(string) --*

                                - *(dict) --*

                                  Specifies metric-based criteria for including or excluding
                                  endpoints from a segment. These criteria derive from custom
                                  metrics that you define for endpoints.

                                  - **ComparisonOperator** *(string) --*

                                    The operator to use when comparing metric values. Valid values
                                    are: GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL,
                                    LESS_THAN_OR_EQUAL, and EQUAL.

                                  - **Value** *(float) --*

                                    The value to compare.

                          - **MessageActivity** *(string) --*

                            The message identifier (message_id) for the message to use when
                            determining whether message events meet the condition.

                        - **SegmentCondition** *(dict) --*

                          The segment that's associated with the activity.

                          - **SegmentId** *(string) --*

                            The unique identifier for the segment to associate with the activity.

                        - **SegmentDimensions** *(dict) --*

                          The dimension settings for the segment that's associated with the
                          activity.

                          - **Attributes** *(dict) --*

                            One or more custom attributes to use as criteria for the segment.

                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.

                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.

                                - **Values** *(list) --*

                                  The criteria values to use for the segment dimension. Depending on
                                  the value of the AttributeType property, endpoints are included or
                                  excluded from the segment if their attribute values match the
                                  criteria values.

                                  - *(string) --*

                          - **Behavior** *(dict) --*

                            The behavior-based criteria, such as how recently users have used your
                            app, for the segment.

                            - **Recency** *(dict) --*

                              The dimension settings that are based on how recently an endpoint was
                              active.

                              - **Duration** *(string) --*

                                The duration to use when determining whether an endpoint is active
                                or inactive.

                              - **RecencyType** *(string) --*

                                The type of recency dimension to use for the segment. Valid values
                                are: ACTIVE, endpoints that were active within the specified
                                duration are included in the segment; and, INACTIVE, endpoints that
                                weren't active within the specified duration are included in the
                                segment.

                          - **Demographic** *(dict) --*

                            The demographic-based criteria, such as device platform, for the
                            segment.

                            - **AppVersion** *(dict) --*

                              The app version criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Channel** *(dict) --*

                              The channel criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **DeviceType** *(dict) --*

                              The device type criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Make** *(dict) --*

                              The device make criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Model** *(dict) --*

                              The device model criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **Platform** *(dict) --*

                              The device platform criteria for the segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                          - **Location** *(dict) --*

                            The location-based criteria, such as region or GPS coordinates, for the
                            segment.

                            - **Country** *(dict) --*

                              The country or region code, in ISO 3166-1 alpha-2 format, for the
                              segment.

                              - **DimensionType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the DimensionType property, endpoints are included or
                                excluded from the segment if their values match the criteria values.

                                - *(string) --*

                            - **GPSPoint** *(dict) --*

                              The GPS location and range for the segment.

                              - **Coordinates** *(dict) --*

                                The GPS coordinates to measure distance from.

                                - **Latitude** *(float) --*

                                  The latitude coordinate of the location.

                                - **Longitude** *(float) --*

                                  The longitude coordinate of the location.

                              - **RangeInKilometers** *(float) --*

                                The range, in kilometers, from the GPS coordinates.

                          - **Metrics** *(dict) --*

                            One or more custom metrics to use as criteria for the segment.

                            - *(string) --*

                              - *(dict) --*

                                Specifies metric-based criteria for including or excluding endpoints
                                from a segment. These criteria derive from custom metrics that you
                                define for endpoints.

                                - **ComparisonOperator** *(string) --*

                                  The operator to use when comparing metric values. Valid values
                                  are: GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL,
                                  LESS_THAN_OR_EQUAL, and EQUAL.

                                - **Value** *(float) --*

                                  The value to compare.

                          - **UserAttributes** *(dict) --*

                            One or more custom user attributes to use as criteria for the segment.

                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.

                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.

                                - **Values** *(list) --*

                                  The criteria values to use for the segment dimension. Depending on
                                  the value of the AttributeType property, endpoints are included or
                                  excluded from the segment if their attribute values match the
                                  criteria values.

                                  - *(string) --*

                      - **NextActivity** *(string) --*

                        The unique identifier for the next activity to perform, after completing the
                        activity for the path.

                  - **DefaultActivity** *(string) --*

                    The activity to perform by default for any path in the activity.

                  - **EvaluationWaitTime** *(dict) --*

                    The amount of time to wait or the date and time when Amazon Pinpoint determines
                    whether the conditions are met.

                    - **WaitFor** *(string) --*

                      The amount of time to wait, as a duration in ISO 8601 format, before
                      determining whether the activity's conditions have been met or moving
                      participants to the next activity in the journey.

                    - **WaitUntil** *(string) --*

                      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether
                      the activity's conditions have been met or the activity moves participants to
                      the next activity in the journey.

                - **RandomSplit** *(dict) --*

                  The settings for a random split activity. This type of activity randomly sends
                  specified percentages of participants down one of as many as five paths in a
                  journey, based on conditions that you specify.

                  - **Branches** *(list) --*

                    The paths for the activity, including the percentage of participants to enter
                    each path and the activity to perform for each path.

                    - *(dict) --*

                      Specifies the settings for a path in a random split activity in a journey.

                      - **NextActivity** *(string) --*

                        The unique identifier for the next activity to perform, after completing the
                        activity for the path.

                      - **Percentage** *(integer) --*

                        The percentage of participants to send down the activity path.

                - **Wait** *(dict) --*

                  The settings for a wait activity. This type of activity waits for a certain amount
                  of time or until a specific date and time before moving participants to the next
                  activity in a journey.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after performing the
                    wait activity.

                  - **WaitTime** *(dict) --*

                    The amount of time to wait or the date and time when the activity moves
                    participants to the next activity in the journey.

                    - **WaitFor** *(string) --*

                      The amount of time to wait, as a duration in ISO 8601 format, before
                      determining whether the activity's conditions have been met or moving
                      participants to the next activity in the journey.

                    - **WaitUntil** *(string) --*

                      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether
                      the activity's conditions have been met or the activity moves participants to
                      the next activity in the journey.

          - **ApplicationId** *(string) --*

            The unique identifier for the application that the journey applies to.

          - **CreationDate** *(string) --*

            The date, in ISO 8601 format, when the journey was created.

          - **Id** *(string) --*

            The unique identifier for the journey.

          - **LastModifiedDate** *(string) --*

            The date, in ISO 8601 format, when the journey was last modified.

          - **Limits** *(dict) --*

            The messaging and entry limits for the journey.

            - **DailyCap** *(integer) --*

              The maximum number of messages that the journey can send to a single participant
              during a 24-hour period. The maximum value is 100.

            - **EndpointReentryCap** *(integer) --*

              The maximum number of times that a participant can enter the journey. The maximum
              value is 100. To allow participants to enter the journey an unlimited number of times,
              set this value to 0.

            - **MessagesPerSecond** *(integer) --*

              The maximum number of messages that the journey can send each second.

          - **LocalTime** *(boolean) --*

            Specifies whether the journey's scheduled start and end times use each participant's
            local time. If this value is true, the schedule uses each participant's local time.

          - **Name** *(string) --*

            The name of the journey.

          - **QuietTime** *(dict) --*

            The quiet time settings for the journey. Quiet time is a specific time range when a
            journey doesn't send messages to participants, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint for the participant is set
            to a valid value.

            * The current time in the participant's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the journey.

            * The current time in the participant's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the journey.

            If any of the preceding conditions isn't met, the participant will receive messages from
            the journey, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **RefreshFrequency** *(string) --*

            The frequency with which Amazon Pinpoint evaluates segment and event data for the
            journey, as a duration in ISO 8601 format.

          - **Schedule** *(dict) --*

            The schedule settings for the journey.

            - **EndTime** *(datetime) --*

              The scheduled time, in ISO 8601 format, when the journey ended or will end.

            - **StartTime** *(datetime) --*

              The scheduled time, in ISO 8601 format, when the journey began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the journey schedule, if the value of the journey's
              LocalTime property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30,
              UTC+04, UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08,
              UTC+08:45, UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13,
              UTC+13:45, UTC-02, UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07,
              UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.

          - **StartActivity** *(string) --*

            The unique identifier for the first activity in the journey.

          - **StartCondition** *(dict) --*

            The segment that defines which users are participants in the journey.

            - **Description** *(string) --*

              The custom description of the condition.

            - **SegmentStartCondition** *(dict) --*

              The segment that's associated with the first activity in the journey. This segment
              determines which users are participants in the journey.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

          - **State** *(string) --*

            The current status of the journey. Possible values are:

            * DRAFT - The journey is being developed and hasn't been published yet.

            * ACTIVE - The journey has been developed and published. Depending on the journey's
            schedule, the journey may currently be running or scheduled to start running at a later
            time. If a journey's status is ACTIVE, you can't add, change, or remove activities from
            it.

            * COMPLETED - The journey has been published and has finished running. All participants
            have entered the journey and no participants are waiting to complete the journey or any
            activities in the journey.

            * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you
            can't add, change, or remove activities or segment settings from the journey.

            * CLOSED - The journey has been published and has started running. It may have also
            passed its scheduled end time, or passed its scheduled start time and a refresh
            frequency hasn't been specified for it. If a journey's status is CLOSED, you can't add
            participants to it, and no existing participants can enter the journey for the first
            time. However, any existing participants who are currently waiting to start an activity
            may resume the journey.

          - **tags** *(dict) --*

            A string-to-string map of key-value pairs that identifies the tags that are associated
            with the journey. Each tag consists of a required tag key and an associated tag value.

            - *(string) --*

              - *(string) --*

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientListTagsForResourceResponseTagsModelTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTagsModelTypeDef", {"tags": Dict[str, str]}, total=False
)


class ClientListTagsForResourceResponseTagsModelTypeDef(
    _ClientListTagsForResourceResponseTagsModelTypeDef
):
    """
    Type definition for `ClientListTagsForResourceResponse` `TagsModel`

    Specifies the tags (keys and values) for an application, campaign, journey, message template, or
    segment.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags for an application, campaign,
      journey, message template, or segment. Each of these resources can have a maximum of 50 tags.

      Each tag consists of a required tag key and an associated tag value. The maximum length of a
      tag key is 128 characters. The maximum length of a tag value is 256 characters.

      - *(string) --*

        - *(string) --*
    """


_ClientListTagsForResourceResponseTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTypeDef",
    {"TagsModel": ClientListTagsForResourceResponseTagsModelTypeDef},
    total=False,
)


class ClientListTagsForResourceResponseTypeDef(_ClientListTagsForResourceResponseTypeDef):
    """
    Type definition for `ClientListTagsForResource` `Response`

    The request succeeded.

    - **TagsModel** *(dict) --*

      Specifies the tags (keys and values) for an application, campaign, journey, message template,
      or segment.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that defines the tags for an application,
        campaign, journey, message template, or segment. Each of these resources can have a maximum
        of 50 tags.

        Each tag consists of a required tag key and an associated tag value. The maximum length of a
        tag key is 128 characters. The maximum length of a tag value is 256 characters.

        - *(string) --*

          - *(string) --*
    """


_ClientListTemplatesResponseTemplatesResponseItemTypeDef = TypedDict(
    "_ClientListTemplatesResponseTemplatesResponseItemTypeDef",
    {
        "Arn": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": str,
    },
    total=False,
)


class ClientListTemplatesResponseTemplatesResponseItemTypeDef(
    _ClientListTemplatesResponseTemplatesResponseItemTypeDef
):
    """
    Type definition for `ClientListTemplatesResponseTemplatesResponse` `Item`

    Provides information about a message template that's associated with your Amazon Pinpoint
    account.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the message template.

    - **CreationDate** *(string) --*

      The date when the message template was created.

    - **DefaultSubstitutions** *(string) --*

      The JSON object that specifies the default values that are used for message variables in the
      message template. This object is a set of key-value pairs. Each key defines a message variable
      in the template. The corresponding value defines the default value for that variable.

    - **LastModifiedDate** *(string) --*

      The date when the message template was last modified.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the message template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      The custom description of the message template.

    - **TemplateName** *(string) --*

      The name of the message template.

    - **TemplateType** *(string) --*

      The type of channel that the message template is designed for.
    """


_ClientListTemplatesResponseTemplatesResponseTypeDef = TypedDict(
    "_ClientListTemplatesResponseTemplatesResponseTypeDef",
    {"Item": List[ClientListTemplatesResponseTemplatesResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientListTemplatesResponseTemplatesResponseTypeDef(
    _ClientListTemplatesResponseTemplatesResponseTypeDef
):
    """
    Type definition for `ClientListTemplatesResponse` `TemplatesResponse`

    Provides information about all the message templates that are associated with your Amazon
    Pinpoint account.

    - **Item** *(list) --*

      An array of responses, one for each message template that's associated with your Amazon
      Pinpoint account and meets any filter criteria that you specified in the request.

      - *(dict) --*

        Provides information about a message template that's associated with your Amazon Pinpoint
        account.

        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template.

        - **CreationDate** *(string) --*

          The date when the message template was created.

        - **DefaultSubstitutions** *(string) --*

          The JSON object that specifies the default values that are used for message variables in
          the message template. This object is a set of key-value pairs. Each key defines a message
          variable in the template. The corresponding value defines the default value for that
          variable.

        - **LastModifiedDate** *(string) --*

          The date when the message template was last modified.

        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that identifies the tags that are associated
          with the message template. Each tag consists of a required tag key and an associated tag
          value.

          - *(string) --*

            - *(string) --*

        - **TemplateDescription** *(string) --*

          The custom description of the message template.

        - **TemplateName** *(string) --*

          The name of the message template.

        - **TemplateType** *(string) --*

          The type of channel that the message template is designed for.

    - **NextToken** *(string) --*

      The string to use in a subsequent request to get the next page of results in a paginated
      response. This value is null if there are no additional pages.
    """


_ClientListTemplatesResponseTypeDef = TypedDict(
    "_ClientListTemplatesResponseTypeDef",
    {"TemplatesResponse": ClientListTemplatesResponseTemplatesResponseTypeDef},
    total=False,
)


class ClientListTemplatesResponseTypeDef(_ClientListTemplatesResponseTypeDef):
    """
    Type definition for `ClientListTemplates` `Response`

    The request succeeded.

    - **TemplatesResponse** *(dict) --*

      Provides information about all the message templates that are associated with your Amazon
      Pinpoint account.

      - **Item** *(list) --*

        An array of responses, one for each message template that's associated with your Amazon
        Pinpoint account and meets any filter criteria that you specified in the request.

        - *(dict) --*

          Provides information about a message template that's associated with your Amazon Pinpoint
          account.

          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the message template.

          - **CreationDate** *(string) --*

            The date when the message template was created.

          - **DefaultSubstitutions** *(string) --*

            The JSON object that specifies the default values that are used for message variables in
            the message template. This object is a set of key-value pairs. Each key defines a
            message variable in the template. The corresponding value defines the default value for
            that variable.

          - **LastModifiedDate** *(string) --*

            The date when the message template was last modified.

          - **tags** *(dict) --*

            A string-to-string map of key-value pairs that identifies the tags that are associated
            with the message template. Each tag consists of a required tag key and an associated tag
            value.

            - *(string) --*

              - *(string) --*

          - **TemplateDescription** *(string) --*

            The custom description of the message template.

          - **TemplateName** *(string) --*

            The name of the message template.

          - **TemplateType** *(string) --*

            The type of channel that the message template is designed for.

      - **NextToken** *(string) --*

        The string to use in a subsequent request to get the next page of results in a paginated
        response. This value is null if there are no additional pages.
    """


_ClientPhoneNumberValidateNumberValidateRequestTypeDef = TypedDict(
    "_ClientPhoneNumberValidateNumberValidateRequestTypeDef",
    {"IsoCountryCode": str, "PhoneNumber": str},
    total=False,
)


class ClientPhoneNumberValidateNumberValidateRequestTypeDef(
    _ClientPhoneNumberValidateNumberValidateRequestTypeDef
):
    """
    Type definition for `ClientPhoneNumberValidate` `NumberValidateRequest`

    Specifies a phone number to validate and retrieve information about.

    - **IsoCountryCode** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      phone number was originally registered.

    - **PhoneNumber** *(string) --*

      The phone number to retrieve information about. The phone number that you provide should
      include a valid numeric country code. Otherwise, the operation might result in an error.
    """


_ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef = TypedDict(
    "_ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef",
    {
        "Carrier": str,
        "City": str,
        "CleansedPhoneNumberE164": str,
        "CleansedPhoneNumberNational": str,
        "Country": str,
        "CountryCodeIso2": str,
        "CountryCodeNumeric": str,
        "County": str,
        "OriginalCountryCodeIso2": str,
        "OriginalPhoneNumber": str,
        "PhoneType": str,
        "PhoneTypeCode": int,
        "Timezone": str,
        "ZipCode": str,
    },
    total=False,
)


class ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef(
    _ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef
):
    """
    Type definition for `ClientPhoneNumberValidateResponse` `NumberValidateResponse`

    Provides information about a phone number.

    - **Carrier** *(string) --*

      The carrier or service provider that the phone number is currently registered with. In some
      countries and regions, this value may be the carrier or service provider that the phone number
      was originally registered with.

    - **City** *(string) --*

      The name of the city where the phone number was originally registered.

    - **CleansedPhoneNumberE164** *(string) --*

      The cleansed phone number, in E.164 format, for the location where the phone number was
      originally registered.

    - **CleansedPhoneNumberNational** *(string) --*

      The cleansed phone number, in the format for the location where the phone number was
      originally registered.

    - **Country** *(string) --*

      The name of the country or region where the phone number was originally registered.

    - **CountryCodeIso2** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      phone number was originally registered.

    - **CountryCodeNumeric** *(string) --*

      The numeric code for the country or region where the phone number was originally registered.

    - **County** *(string) --*

      The name of the county where the phone number was originally registered.

    - **OriginalCountryCodeIso2** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, that was sent in the request body.

    - **OriginalPhoneNumber** *(string) --*

      The phone number that was sent in the request body.

    - **PhoneType** *(string) --*

      The description of the phone type. Valid values are: MOBILE, LANDLINE, VOIP, INVALID, PREPAID,
      and OTHER.

    - **PhoneTypeCode** *(integer) --*

      The phone type, represented by an integer. Valid values are: 0 (mobile), 1 (landline), 2
      (VoIP), 3 (invalid), 4 (other), and 5 (prepaid).

    - **Timezone** *(string) --*

      The time zone for the location where the phone number was originally registered.

    - **ZipCode** *(string) --*

      The postal or ZIP code for the location where the phone number was originally registered.
    """


_ClientPhoneNumberValidateResponseTypeDef = TypedDict(
    "_ClientPhoneNumberValidateResponseTypeDef",
    {"NumberValidateResponse": ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef},
    total=False,
)


class ClientPhoneNumberValidateResponseTypeDef(_ClientPhoneNumberValidateResponseTypeDef):
    """
    Type definition for `ClientPhoneNumberValidate` `Response`

    The request succeeded.

    - **NumberValidateResponse** *(dict) --*

      Provides information about a phone number.

      - **Carrier** *(string) --*

        The carrier or service provider that the phone number is currently registered with. In some
        countries and regions, this value may be the carrier or service provider that the phone
        number was originally registered with.

      - **City** *(string) --*

        The name of the city where the phone number was originally registered.

      - **CleansedPhoneNumberE164** *(string) --*

        The cleansed phone number, in E.164 format, for the location where the phone number was
        originally registered.

      - **CleansedPhoneNumberNational** *(string) --*

        The cleansed phone number, in the format for the location where the phone number was
        originally registered.

      - **Country** *(string) --*

        The name of the country or region where the phone number was originally registered.

      - **CountryCodeIso2** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        phone number was originally registered.

      - **CountryCodeNumeric** *(string) --*

        The numeric code for the country or region where the phone number was originally registered.

      - **County** *(string) --*

        The name of the county where the phone number was originally registered.

      - **OriginalCountryCodeIso2** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, that was sent in the request body.

      - **OriginalPhoneNumber** *(string) --*

        The phone number that was sent in the request body.

      - **PhoneType** *(string) --*

        The description of the phone type. Valid values are: MOBILE, LANDLINE, VOIP, INVALID,
        PREPAID, and OTHER.

      - **PhoneTypeCode** *(integer) --*

        The phone type, represented by an integer. Valid values are: 0 (mobile), 1 (landline), 2
        (VoIP), 3 (invalid), 4 (other), and 5 (prepaid).

      - **Timezone** *(string) --*

        The time zone for the location where the phone number was originally registered.

      - **ZipCode** *(string) --*

        The postal or ZIP code for the location where the phone number was originally registered.
    """


_ClientPutEventStreamResponseEventStreamTypeDef = TypedDict(
    "_ClientPutEventStreamResponseEventStreamTypeDef",
    {
        "ApplicationId": str,
        "DestinationStreamArn": str,
        "ExternalId": str,
        "LastModifiedDate": str,
        "LastUpdatedBy": str,
        "RoleArn": str,
    },
    total=False,
)


class ClientPutEventStreamResponseEventStreamTypeDef(
    _ClientPutEventStreamResponseEventStreamTypeDef
):
    """
    Type definition for `ClientPutEventStreamResponse` `EventStream`

    Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
    Kinesis Data Firehose delivery stream.

    - **ApplicationId** *(string) --*

      The unique identifier for the application to publish event data for.

    - **DestinationStreamArn** *(string) --*

      The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
      Firehose delivery stream to publish event data to.

      For a Kinesis data stream, the ARN format is:
      arn:aws:kinesis:region:account-id:stream/stream_name

      For a Kinesis Data Firehose delivery stream, the ARN format is:
      arn:aws:firehose:region:account-id:deliverystream/stream_name

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when publishing event
      data, but we removed this requirement. We don't recommend use of external IDs for IAM roles
      that are assumed by Amazon Pinpoint.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the event stream was last modified.

    - **LastUpdatedBy** *(string) --*

      The IAM user who last modified the event stream.

    - **RoleArn** *(string) --*

      The AWS Identity and Access Management (IAM) role that authorizes Amazon Pinpoint to publish
      event data to the stream in your AWS account.
    """


_ClientPutEventStreamResponseTypeDef = TypedDict(
    "_ClientPutEventStreamResponseTypeDef",
    {"EventStream": ClientPutEventStreamResponseEventStreamTypeDef},
    total=False,
)


class ClientPutEventStreamResponseTypeDef(_ClientPutEventStreamResponseTypeDef):
    """
    Type definition for `ClientPutEventStream` `Response`

    The request succeeded.

    - **EventStream** *(dict) --*

      Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
      Kinesis Data Firehose delivery stream.

      - **ApplicationId** *(string) --*

        The unique identifier for the application to publish event data for.

      - **DestinationStreamArn** *(string) --*

        The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
        Firehose delivery stream to publish event data to.

        For a Kinesis data stream, the ARN format is:
        arn:aws:kinesis:region:account-id:stream/stream_name

        For a Kinesis Data Firehose delivery stream, the ARN format is:
        arn:aws:firehose:region:account-id:deliverystream/stream_name

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when publishing
        event data, but we removed this requirement. We don't recommend use of external IDs for IAM
        roles that are assumed by Amazon Pinpoint.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the event stream was last modified.

      - **LastUpdatedBy** *(string) --*

        The IAM user who last modified the event stream.

      - **RoleArn** *(string) --*

        The AWS Identity and Access Management (IAM) role that authorizes Amazon Pinpoint to publish
        event data to the stream in your AWS account.
    """


_ClientPutEventStreamWriteEventStreamTypeDef = TypedDict(
    "_ClientPutEventStreamWriteEventStreamTypeDef", {"DestinationStreamArn": str, "RoleArn": str}
)


class ClientPutEventStreamWriteEventStreamTypeDef(_ClientPutEventStreamWriteEventStreamTypeDef):
    """
    Type definition for `ClientPutEventStream` `WriteEventStream`

    Specifies the Amazon Resource Name (ARN) of an event stream to publish events to and the AWS
    Identity and Access Management (IAM) role to use when publishing those events.

    - **DestinationStreamArn** *(string) --* **[REQUIRED]**

      The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
      Firehose delivery stream that you want to publish event data to.

      For a Kinesis data stream, the ARN format is:
      arn:aws:kinesis:region:account-id:stream/stream_name

      For a Kinesis Data Firehose delivery stream, the ARN format is:
      arn:aws:firehose:region:account-id:deliverystream/stream_name

    - **RoleArn** *(string) --* **[REQUIRED]**

      The AWS Identity and Access Management (IAM) role that authorizes Amazon Pinpoint to publish
      event data to the stream in your AWS account.
    """


_ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef
):
    """
    Type definition for `ClientPutEventsEventsRequestBatchItemEndpoint` `Demographic`

    The demographic information for the endpoint, such as the time zone and platform.

    - **AppVersion** *(string) --*

      The version of the app that's associated with the endpoint.

    - **Locale** *(string) --*

      The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
      an underscore (_), followed by an ISO 3166-1 alpha-2 value.

    - **Make** *(string) --*

      The manufacturer of the endpoint device, such as Apple or Samsung.

    - **Model** *(string) --*

      The model name or number of the endpoint device, such as iPhone.

    - **ModelVersion** *(string) --*

      The model version of the endpoint device.

    - **Platform** *(string) --*

      The platform of the endpoint device, such as iOS or Android.

    - **PlatformVersion** *(string) --*

      The platform version of the endpoint device.

    - **Timezone** *(string) --*

      The time zone of the endpoint, specified as a tz database name value, such as
      America/Los_Angeles.
    """


_ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef
):
    """
    Type definition for `ClientPutEventsEventsRequestBatchItemEndpoint` `Location`

    The geographic information for the endpoint.

    - **City** *(string) --*

      The name of the city where the endpoint is located.

    - **Country** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      endpoint is located. For example, US for the United States.

    - **Latitude** *(float) --*

      The latitude coordinate of the endpoint location, rounded to one decimal place.

    - **Longitude** *(float) --*

      The longitude coordinate of the endpoint location, rounded to one decimal place.

    - **PostalCode** *(string) --*

      The postal or ZIP code for the area where the endpoint is located.

    - **Region** *(string) --*

      The name of the region where the endpoint is located. For locations in the United States, this
      value is the name of a state.
    """


_ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef
):
    """
    Type definition for `ClientPutEventsEventsRequestBatchItemEndpoint` `User`

    One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
    associated with the endpoint.

    - **UserAttributes** *(dict) --*

      One or more custom attributes that describe the user by associating a name with an array of
      values. For example, the value of an attribute named Interests might be: ["science", "music",
      "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **UserId** *(string) --*

      The unique identifier for the user.
    """


_ClientPutEventsEventsRequestBatchItemEndpointTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointTypeDef",
    {
        "Address": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": str,
        "Demographic": ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Location": ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointTypeDef
):
    """
    Type definition for `ClientPutEventsEventsRequestBatchItem` `Endpoint`

    A set of properties and attributes that are associated with the endpoint.

    - **Address** *(string) --*

      The unique identifier for the recipient, such as a device token, email address, or mobile
      phone number.

    - **Attributes** *(dict) --*

      One or more custom attributes that describe the endpoint by associating a name with an array
      of values. You can use these attributes as filter criteria when you create segments.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ChannelType** *(string) --*

      The channel that's used when sending messages or push notifications to the endpoint.

    - **Demographic** *(dict) --*

      The demographic information for the endpoint, such as the time zone and platform.

      - **AppVersion** *(string) --*

        The version of the app that's associated with the endpoint.

      - **Locale** *(string) --*

        The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
        an underscore (_), followed by an ISO 3166-1 alpha-2 value.

      - **Make** *(string) --*

        The manufacturer of the endpoint device, such as Apple or Samsung.

      - **Model** *(string) --*

        The model name or number of the endpoint device, such as iPhone.

      - **ModelVersion** *(string) --*

        The model version of the endpoint device.

      - **Platform** *(string) --*

        The platform of the endpoint device, such as iOS or Android.

      - **PlatformVersion** *(string) --*

        The platform version of the endpoint device.

      - **Timezone** *(string) --*

        The time zone of the endpoint, specified as a tz database name value, such as
        America/Los_Angeles.

    - **EffectiveDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was last updated.

    - **EndpointStatus** *(string) --*

      Specifies whether to send messages or push notifications to the endpoint. Valid values are:
      ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
      endpoint.

      Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or update
      an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if you update
      another endpoint that has the same address specified by the Address property.

    - **Location** *(dict) --*

      The geographic information for the endpoint.

      - **City** *(string) --*

        The name of the city where the endpoint is located.

      - **Country** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        endpoint is located. For example, US for the United States.

      - **Latitude** *(float) --*

        The latitude coordinate of the endpoint location, rounded to one decimal place.

      - **Longitude** *(float) --*

        The longitude coordinate of the endpoint location, rounded to one decimal place.

      - **PostalCode** *(string) --*

        The postal or ZIP code for the area where the endpoint is located.

      - **Region** *(string) --*

        The name of the region where the endpoint is located. For locations in the United States,
        this value is the name of a state.

    - **Metrics** *(dict) --*

      One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

      - *(string) --*

        - *(float) --*

    - **OptOut** *(string) --*

      Specifies whether the user who's associated with the endpoint has opted out of receiving
      messages and push notifications from you. Possible values are: ALL, the user has opted out and
      doesn't want to receive any messages or push notifications; and, NONE, the user hasn't opted
      out and wants to receive all messages and push notifications.

    - **RequestId** *(string) --*

      A unique identifier that's generated each time the endpoint is updated.

    - **User** *(dict) --*

      One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
      associated with the endpoint.

      - **UserAttributes** *(dict) --*

        One or more custom attributes that describe the user by associating a name with an array of
        values. For example, the value of an attribute named Interests might be: ["science",
        "music", "travel"]. You can use these attributes as filter criteria when you create
        segments.

        When you define the name of a custom attribute, avoid using the following characters: number
        sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
        console can't display attribute names that contain these characters. This limitation doesn't
        apply to attribute values.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **UserId** *(string) --*

        The unique identifier for the user.
    """


_RequiredClientPutEventsEventsRequestBatchItemEventsSessionTypeDef = TypedDict(
    "_RequiredClientPutEventsEventsRequestBatchItemEventsSessionTypeDef",
    {"Id": str, "StartTimestamp": str},
)
_OptionalClientPutEventsEventsRequestBatchItemEventsSessionTypeDef = TypedDict(
    "_OptionalClientPutEventsEventsRequestBatchItemEventsSessionTypeDef",
    {"Duration": int, "StopTimestamp": str},
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef(
    _RequiredClientPutEventsEventsRequestBatchItemEventsSessionTypeDef,
    _OptionalClientPutEventsEventsRequestBatchItemEventsSessionTypeDef,
):
    """
    Type definition for `ClientPutEventsEventsRequestBatchItemEvents` `Session`

    Information about the session in which the event occurred.

    - **Duration** *(integer) --*

      The duration of the session, in milliseconds.

    - **Id** *(string) --* **[REQUIRED]**

      The unique identifier for the session.

    - **StartTimestamp** *(string) --* **[REQUIRED]**

      The date and time when the session began.

    - **StopTimestamp** *(string) --*

      The date and time when the session ended.
    """


_RequiredClientPutEventsEventsRequestBatchItemEventsTypeDef = TypedDict(
    "_RequiredClientPutEventsEventsRequestBatchItemEventsTypeDef",
    {"EventType": str, "Timestamp": str},
)
_OptionalClientPutEventsEventsRequestBatchItemEventsTypeDef = TypedDict(
    "_OptionalClientPutEventsEventsRequestBatchItemEventsTypeDef",
    {
        "AppPackageName": str,
        "AppTitle": str,
        "AppVersionCode": str,
        "Attributes": Dict[str, str],
        "ClientSdkVersion": str,
        "Metrics": Dict[str, float],
        "SdkName": str,
        "Session": ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEventsTypeDef(
    _RequiredClientPutEventsEventsRequestBatchItemEventsTypeDef,
    _OptionalClientPutEventsEventsRequestBatchItemEventsTypeDef,
):
    """
    Type definition for `ClientPutEventsEventsRequestBatchItem` `Events`

    Specifies information about an event that reports data to Amazon Pinpoint.

    - **AppPackageName** *(string) --*

      The package name of the app that's recording the event.

    - **AppTitle** *(string) --*

      The title of the app that's recording the event.

    - **AppVersionCode** *(string) --*

      The version number of the app that's recording the event.

    - **Attributes** *(dict) --*

      One or more custom attributes that are associated with the event.

      - *(string) --*

        - *(string) --*

    - **ClientSdkVersion** *(string) --*

      The version of the SDK that's running on the client device.

    - **EventType** *(string) --* **[REQUIRED]**

      The name of the event.

    - **Metrics** *(dict) --*

      One or more custom metrics that are associated with the event.

      - *(string) --*

        - *(float) --*

    - **SdkName** *(string) --*

      The name of the SDK that's being used to record the event.

    - **Session** *(dict) --*

      Information about the session in which the event occurred.

      - **Duration** *(integer) --*

        The duration of the session, in milliseconds.

      - **Id** *(string) --* **[REQUIRED]**

        The unique identifier for the session.

      - **StartTimestamp** *(string) --* **[REQUIRED]**

        The date and time when the session began.

      - **StopTimestamp** *(string) --*

        The date and time when the session ended.

    - **Timestamp** *(string) --* **[REQUIRED]**

      The date and time, in ISO 8601 format, when the event occurred.
    """


_ClientPutEventsEventsRequestBatchItemTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemTypeDef",
    {
        "Endpoint": ClientPutEventsEventsRequestBatchItemEndpointTypeDef,
        "Events": Dict[str, ClientPutEventsEventsRequestBatchItemEventsTypeDef],
    },
)


class ClientPutEventsEventsRequestBatchItemTypeDef(_ClientPutEventsEventsRequestBatchItemTypeDef):
    """
    Type definition for `ClientPutEventsEventsRequest` `BatchItem`

    Specifies a batch of endpoints and events to process.

    - **Endpoint** *(dict) --* **[REQUIRED]**

      A set of properties and attributes that are associated with the endpoint.

      - **Address** *(string) --*

        The unique identifier for the recipient, such as a device token, email address, or mobile
        phone number.

      - **Attributes** *(dict) --*

        One or more custom attributes that describe the endpoint by associating a name with an array
        of values. You can use these attributes as filter criteria when you create segments.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **ChannelType** *(string) --*

        The channel that's used when sending messages or push notifications to the endpoint.

      - **Demographic** *(dict) --*

        The demographic information for the endpoint, such as the time zone and platform.

        - **AppVersion** *(string) --*

          The version of the app that's associated with the endpoint.

        - **Locale** *(string) --*

          The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed
          by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

        - **Make** *(string) --*

          The manufacturer of the endpoint device, such as Apple or Samsung.

        - **Model** *(string) --*

          The model name or number of the endpoint device, such as iPhone.

        - **ModelVersion** *(string) --*

          The model version of the endpoint device.

        - **Platform** *(string) --*

          The platform of the endpoint device, such as iOS or Android.

        - **PlatformVersion** *(string) --*

          The platform version of the endpoint device.

        - **Timezone** *(string) --*

          The time zone of the endpoint, specified as a tz database name value, such as
          America/Los_Angeles.

      - **EffectiveDate** *(string) --*

        The date and time, in ISO 8601 format, when the endpoint was last updated.

      - **EndpointStatus** *(string) --*

        Specifies whether to send messages or push notifications to the endpoint. Valid values are:
        ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
        endpoint.

        Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
        update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if
        you update another endpoint that has the same address specified by the Address property.

      - **Location** *(dict) --*

        The geographic information for the endpoint.

        - **City** *(string) --*

          The name of the city where the endpoint is located.

        - **Country** *(string) --*

          The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
          endpoint is located. For example, US for the United States.

        - **Latitude** *(float) --*

          The latitude coordinate of the endpoint location, rounded to one decimal place.

        - **Longitude** *(float) --*

          The longitude coordinate of the endpoint location, rounded to one decimal place.

        - **PostalCode** *(string) --*

          The postal or ZIP code for the area where the endpoint is located.

        - **Region** *(string) --*

          The name of the region where the endpoint is located. For locations in the United States,
          this value is the name of a state.

      - **Metrics** *(dict) --*

        One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

        - *(string) --*

          - *(float) --*

      - **OptOut** *(string) --*

        Specifies whether the user who's associated with the endpoint has opted out of receiving
        messages and push notifications from you. Possible values are: ALL, the user has opted out
        and doesn't want to receive any messages or push notifications; and, NONE, the user hasn't
        opted out and wants to receive all messages and push notifications.

      - **RequestId** *(string) --*

        A unique identifier that's generated each time the endpoint is updated.

      - **User** *(dict) --*

        One or more custom user attributes that your app reports to Amazon Pinpoint for the user
        who's associated with the endpoint.

        - **UserAttributes** *(dict) --*

          One or more custom attributes that describe the user by associating a name with an array
          of values. For example, the value of an attribute named Interests might be: ["science",
          "music", "travel"]. You can use these attributes as filter criteria when you create
          segments.

          When you define the name of a custom attribute, avoid using the following characters:
          number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon
          Pinpoint console can't display attribute names that contain these characters. This
          limitation doesn't apply to attribute values.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **UserId** *(string) --*

          The unique identifier for the user.

    - **Events** *(dict) --* **[REQUIRED]**

      A set of properties that are associated with the event.

      - *(string) --*

        - *(dict) --*

          Specifies information about an event that reports data to Amazon Pinpoint.

          - **AppPackageName** *(string) --*

            The package name of the app that's recording the event.

          - **AppTitle** *(string) --*

            The title of the app that's recording the event.

          - **AppVersionCode** *(string) --*

            The version number of the app that's recording the event.

          - **Attributes** *(dict) --*

            One or more custom attributes that are associated with the event.

            - *(string) --*

              - *(string) --*

          - **ClientSdkVersion** *(string) --*

            The version of the SDK that's running on the client device.

          - **EventType** *(string) --* **[REQUIRED]**

            The name of the event.

          - **Metrics** *(dict) --*

            One or more custom metrics that are associated with the event.

            - *(string) --*

              - *(float) --*

          - **SdkName** *(string) --*

            The name of the SDK that's being used to record the event.

          - **Session** *(dict) --*

            Information about the session in which the event occurred.

            - **Duration** *(integer) --*

              The duration of the session, in milliseconds.

            - **Id** *(string) --* **[REQUIRED]**

              The unique identifier for the session.

            - **StartTimestamp** *(string) --* **[REQUIRED]**

              The date and time when the session began.

            - **StopTimestamp** *(string) --*

              The date and time when the session ended.

          - **Timestamp** *(string) --* **[REQUIRED]**

            The date and time, in ISO 8601 format, when the event occurred.
    """


_ClientPutEventsEventsRequestTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestTypeDef",
    {"BatchItem": Dict[str, ClientPutEventsEventsRequestBatchItemTypeDef]},
)


class ClientPutEventsEventsRequestTypeDef(_ClientPutEventsEventsRequestTypeDef):
    """
    Type definition for `ClientPutEvents` `EventsRequest`

    Specifies a batch of events to process.

    - **BatchItem** *(dict) --* **[REQUIRED]**

      The batch of events to process. For each item in a batch, the endpoint ID acts as a key that
      has an EventsBatch object as its value.

      - *(string) --*

        - *(dict) --*

          Specifies a batch of endpoints and events to process.

          - **Endpoint** *(dict) --* **[REQUIRED]**

            A set of properties and attributes that are associated with the endpoint.

            - **Address** *(string) --*

              The unique identifier for the recipient, such as a device token, email address, or
              mobile phone number.

            - **Attributes** *(dict) --*

              One or more custom attributes that describe the endpoint by associating a name with an
              array of values. You can use these attributes as filter criteria when you create
              segments.

              - *(string) --*

                - *(list) --*

                  - *(string) --*

            - **ChannelType** *(string) --*

              The channel that's used when sending messages or push notifications to the endpoint.

            - **Demographic** *(dict) --*

              The demographic information for the endpoint, such as the time zone and platform.

              - **AppVersion** *(string) --*

                The version of the app that's associated with the endpoint.

              - **Locale** *(string) --*

                The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code,
                followed by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

              - **Make** *(string) --*

                The manufacturer of the endpoint device, such as Apple or Samsung.

              - **Model** *(string) --*

                The model name or number of the endpoint device, such as iPhone.

              - **ModelVersion** *(string) --*

                The model version of the endpoint device.

              - **Platform** *(string) --*

                The platform of the endpoint device, such as iOS or Android.

              - **PlatformVersion** *(string) --*

                The platform version of the endpoint device.

              - **Timezone** *(string) --*

                The time zone of the endpoint, specified as a tz database name value, such as
                America/Los_Angeles.

            - **EffectiveDate** *(string) --*

              The date and time, in ISO 8601 format, when the endpoint was last updated.

            - **EndpointStatus** *(string) --*

              Specifies whether to send messages or push notifications to the endpoint. Valid values
              are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to
              the endpoint.

              Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
              update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE
              if you update another endpoint that has the same address specified by the Address
              property.

            - **Location** *(dict) --*

              The geographic information for the endpoint.

              - **City** *(string) --*

                The name of the city where the endpoint is located.

              - **Country** *(string) --*

                The two-character code, in ISO 3166-1 alpha-2 format, for the country or region
                where the endpoint is located. For example, US for the United States.

              - **Latitude** *(float) --*

                The latitude coordinate of the endpoint location, rounded to one decimal place.

              - **Longitude** *(float) --*

                The longitude coordinate of the endpoint location, rounded to one decimal place.

              - **PostalCode** *(string) --*

                The postal or ZIP code for the area where the endpoint is located.

              - **Region** *(string) --*

                The name of the region where the endpoint is located. For locations in the United
                States, this value is the name of a state.

            - **Metrics** *(dict) --*

              One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

              - *(string) --*

                - *(float) --*

            - **OptOut** *(string) --*

              Specifies whether the user who's associated with the endpoint has opted out of
              receiving messages and push notifications from you. Possible values are: ALL, the user
              has opted out and doesn't want to receive any messages or push notifications; and,
              NONE, the user hasn't opted out and wants to receive all messages and push
              notifications.

            - **RequestId** *(string) --*

              A unique identifier that's generated each time the endpoint is updated.

            - **User** *(dict) --*

              One or more custom user attributes that your app reports to Amazon Pinpoint for the
              user who's associated with the endpoint.

              - **UserAttributes** *(dict) --*

                One or more custom attributes that describe the user by associating a name with an
                array of values. For example, the value of an attribute named Interests might be:
                ["science", "music", "travel"]. You can use these attributes as filter criteria when
                you create segments.

                When you define the name of a custom attribute, avoid using the following
                characters: number sign (#), colon (:), question mark (?), backslash (\\), and slash
                (/). The Amazon Pinpoint console can't display attribute names that contain these
                characters. This limitation doesn't apply to attribute values.

                - *(string) --*

                  - *(list) --*

                    - *(string) --*

              - **UserId** *(string) --*

                The unique identifier for the user.

          - **Events** *(dict) --* **[REQUIRED]**

            A set of properties that are associated with the event.

            - *(string) --*

              - *(dict) --*

                Specifies information about an event that reports data to Amazon Pinpoint.

                - **AppPackageName** *(string) --*

                  The package name of the app that's recording the event.

                - **AppTitle** *(string) --*

                  The title of the app that's recording the event.

                - **AppVersionCode** *(string) --*

                  The version number of the app that's recording the event.

                - **Attributes** *(dict) --*

                  One or more custom attributes that are associated with the event.

                  - *(string) --*

                    - *(string) --*

                - **ClientSdkVersion** *(string) --*

                  The version of the SDK that's running on the client device.

                - **EventType** *(string) --* **[REQUIRED]**

                  The name of the event.

                - **Metrics** *(dict) --*

                  One or more custom metrics that are associated with the event.

                  - *(string) --*

                    - *(float) --*

                - **SdkName** *(string) --*

                  The name of the SDK that's being used to record the event.

                - **Session** *(dict) --*

                  Information about the session in which the event occurred.

                  - **Duration** *(integer) --*

                    The duration of the session, in milliseconds.

                  - **Id** *(string) --* **[REQUIRED]**

                    The unique identifier for the session.

                  - **StartTimestamp** *(string) --* **[REQUIRED]**

                    The date and time when the session began.

                  - **StopTimestamp** *(string) --*

                    The date and time when the session ended.

                - **Timestamp** *(string) --* **[REQUIRED]**

                  The date and time, in ISO 8601 format, when the event occurred.
    """


_ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef",
    {"Message": str, "StatusCode": int},
    total=False,
)


class ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef(
    _ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef
):
    """
    Type definition for `ClientPutEventsResponseEventsResponseResults` `EndpointItemResponse`

    The response that was received after the endpoint data was accepted.

    - **Message** *(string) --*

      The custom message that's returned in the response as a result of processing the endpoint
      data.

    - **StatusCode** *(integer) --*

      The status code that's returned in the response as a result of processing the endpoint data.
    """


_ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef",
    {"Message": str, "StatusCode": int},
    total=False,
)


class ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef(
    _ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef
):
    """
    Type definition for `ClientPutEventsResponseEventsResponseResults` `EventsItemResponse`

    Provides the status code and message that result from processing an event.

    - **Message** *(string) --*

      A custom message that's returned in the response as a result of processing the event.

    - **StatusCode** *(integer) --*

      The status code that's returned in the response as a result of processing the event. Possible
      values are: 202, for events that were accepted; and, 400, for events that weren't valid.
    """


_ClientPutEventsResponseEventsResponseResultsTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseResultsTypeDef",
    {
        "EndpointItemResponse": ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef,
        "EventsItemResponse": Dict[
            str, ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef
        ],
    },
    total=False,
)


class ClientPutEventsResponseEventsResponseResultsTypeDef(
    _ClientPutEventsResponseEventsResponseResultsTypeDef
):
    """
    Type definition for `ClientPutEventsResponseEventsResponse` `Results`

    Provides information about the results of a request to create or update an endpoint that's
    associated with an event.

    - **EndpointItemResponse** *(dict) --*

      The response that was received after the endpoint data was accepted.

      - **Message** *(string) --*

        The custom message that's returned in the response as a result of processing the endpoint
        data.

      - **StatusCode** *(integer) --*

        The status code that's returned in the response as a result of processing the endpoint data.

    - **EventsItemResponse** *(dict) --*

      A multipart response object that contains a key and a value for each event in the request. In
      each object, the event ID is the key and an EventItemResponse object is the value.

      - *(string) --*

        - *(dict) --*

          Provides the status code and message that result from processing an event.

          - **Message** *(string) --*

            A custom message that's returned in the response as a result of processing the event.

          - **StatusCode** *(integer) --*

            The status code that's returned in the response as a result of processing the event.
            Possible values are: 202, for events that were accepted; and, 400, for events that
            weren't valid.
    """


_ClientPutEventsResponseEventsResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseTypeDef",
    {"Results": Dict[str, ClientPutEventsResponseEventsResponseResultsTypeDef]},
    total=False,
)


class ClientPutEventsResponseEventsResponseTypeDef(_ClientPutEventsResponseEventsResponseTypeDef):
    """
    Type definition for `ClientPutEventsResponse` `EventsResponse`

    Provides information about endpoints and the events that they're associated with.

    - **Results** *(dict) --*

      A map that contains a multipart response for each endpoint. For each item in this object, the
      endpoint ID is the key and the item response is the value. If no item response exists, the
      value can also be one of the following: 202, the request was processed successfully; or 400,
      the payload wasn't valid or required fields were missing.

      - *(string) --*

        - *(dict) --*

          Provides information about the results of a request to create or update an endpoint that's
          associated with an event.

          - **EndpointItemResponse** *(dict) --*

            The response that was received after the endpoint data was accepted.

            - **Message** *(string) --*

              The custom message that's returned in the response as a result of processing the
              endpoint data.

            - **StatusCode** *(integer) --*

              The status code that's returned in the response as a result of processing the endpoint
              data.

          - **EventsItemResponse** *(dict) --*

            A multipart response object that contains a key and a value for each event in the
            request. In each object, the event ID is the key and an EventItemResponse object is the
            value.

            - *(string) --*

              - *(dict) --*

                Provides the status code and message that result from processing an event.

                - **Message** *(string) --*

                  A custom message that's returned in the response as a result of processing the
                  event.

                - **StatusCode** *(integer) --*

                  The status code that's returned in the response as a result of processing the
                  event. Possible values are: 202, for events that were accepted; and, 400, for
                  events that weren't valid.
    """


_ClientPutEventsResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseTypeDef",
    {"EventsResponse": ClientPutEventsResponseEventsResponseTypeDef},
    total=False,
)


class ClientPutEventsResponseTypeDef(_ClientPutEventsResponseTypeDef):
    """
    Type definition for `ClientPutEvents` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **EventsResponse** *(dict) --*

      Provides information about endpoints and the events that they're associated with.

      - **Results** *(dict) --*

        A map that contains a multipart response for each endpoint. For each item in this object,
        the endpoint ID is the key and the item response is the value. If no item response exists,
        the value can also be one of the following: 202, the request was processed successfully; or
        400, the payload wasn't valid or required fields were missing.

        - *(string) --*

          - *(dict) --*

            Provides information about the results of a request to create or update an endpoint
            that's associated with an event.

            - **EndpointItemResponse** *(dict) --*

              The response that was received after the endpoint data was accepted.

              - **Message** *(string) --*

                The custom message that's returned in the response as a result of processing the
                endpoint data.

              - **StatusCode** *(integer) --*

                The status code that's returned in the response as a result of processing the
                endpoint data.

            - **EventsItemResponse** *(dict) --*

              A multipart response object that contains a key and a value for each event in the
              request. In each object, the event ID is the key and an EventItemResponse object is
              the value.

              - *(string) --*

                - *(dict) --*

                  Provides the status code and message that result from processing an event.

                  - **Message** *(string) --*

                    A custom message that's returned in the response as a result of processing the
                    event.

                  - **StatusCode** *(integer) --*

                    The status code that's returned in the response as a result of processing the
                    event. Possible values are: 202, for events that were accepted; and, 400, for
                    events that weren't valid.
    """


_ClientRemoveAttributesResponseAttributesResourceTypeDef = TypedDict(
    "_ClientRemoveAttributesResponseAttributesResourceTypeDef",
    {"ApplicationId": str, "AttributeType": str, "Attributes": List[str]},
    total=False,
)


class ClientRemoveAttributesResponseAttributesResourceTypeDef(
    _ClientRemoveAttributesResponseAttributesResourceTypeDef
):
    """
    Type definition for `ClientRemoveAttributesResponse` `AttributesResource`

    Provides information about the type and the names of attributes that were removed from all the
    endpoints that are associated with an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application.

    - **AttributeType** *(string) --*

      The type of attribute or attributes that were removed from the endpoints. Valid values are:

      * endpoint-custom-attributes - Custom attributes that describe endpoints.

      * endpoint-metric-attributes - Custom metrics that your app reports to Amazon Pinpoint for
      endpoints.

      * endpoint-user-attributes - Custom attributes that describe users.

    - **Attributes** *(list) --*

      An array that specifies the names of the attributes that were removed from the endpoints.

      - *(string) --*
    """


_ClientRemoveAttributesResponseTypeDef = TypedDict(
    "_ClientRemoveAttributesResponseTypeDef",
    {"AttributesResource": ClientRemoveAttributesResponseAttributesResourceTypeDef},
    total=False,
)


class ClientRemoveAttributesResponseTypeDef(_ClientRemoveAttributesResponseTypeDef):
    """
    Type definition for `ClientRemoveAttributes` `Response`

    The request succeeded.

    - **AttributesResource** *(dict) --*

      Provides information about the type and the names of attributes that were removed from all the
      endpoints that are associated with an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application.

      - **AttributeType** *(string) --*

        The type of attribute or attributes that were removed from the endpoints. Valid values are:

        * endpoint-custom-attributes - Custom attributes that describe endpoints.

        * endpoint-metric-attributes - Custom metrics that your app reports to Amazon Pinpoint for
        endpoints.

        * endpoint-user-attributes - Custom attributes that describe users.

      - **Attributes** *(list) --*

        An array that specifies the names of the attributes that were removed from the endpoints.

        - *(string) --*
    """


_ClientRemoveAttributesUpdateAttributesRequestTypeDef = TypedDict(
    "_ClientRemoveAttributesUpdateAttributesRequestTypeDef", {"Blacklist": List[str]}, total=False
)


class ClientRemoveAttributesUpdateAttributesRequestTypeDef(
    _ClientRemoveAttributesUpdateAttributesRequestTypeDef
):
    """
    Type definition for `ClientRemoveAttributes` `UpdateAttributesRequest`

    Specifies one or more attributes to remove from all the endpoints that are associated with an
    application.

    - **Blacklist** *(list) --*

      An array of the attributes to remove from all the endpoints that are associated with the
      application. The array can specify the complete, exact name of each attribute to remove or it
      can specify a glob pattern that an attribute name must match in order for the attribute to be
      removed.

      - *(string) --*
    """


_ClientSendMessagesMessageRequestAddressesTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestAddressesTypeDef",
    {
        "BodyOverride": str,
        "ChannelType": str,
        "Context": Dict[str, str],
        "RawContent": str,
        "Substitutions": Dict[str, List[str]],
        "TitleOverride": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestAddressesTypeDef(
    _ClientSendMessagesMessageRequestAddressesTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequest` `Addresses`

    Specifies address-based configuration settings for a message that's sent directly to an
    endpoint.

    - **BodyOverride** *(string) --*

      The message body to use instead of the default message body. This value overrides the default
      message body.

    - **ChannelType** *(string) --*

      The channel to use when sending the message.

    - **Context** *(dict) --*

      An object that maps custom attributes to attributes for the address and is attached to the
      message. For a push notification, this payload is added to the data.pinpoint object. For an
      email or text message, this payload is added to email/SMS delivery receipt event attributes.

      - *(string) --*

        - *(string) --*

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the message. If specified, this value
      overrides all other values for the message.

    - **Substitutions** *(dict) --*

      A map of the message variables to merge with the variables specified by properties of the
      DefaultMessage object. The variables specified in this map take precedence over all other
      variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **TitleOverride** *(string) --*

      The message title to use instead of the default message title. This value overrides the
      default message title.
    """


_ClientSendMessagesMessageRequestEndpointsTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestEndpointsTypeDef",
    {
        "BodyOverride": str,
        "Context": Dict[str, str],
        "RawContent": str,
        "Substitutions": Dict[str, List[str]],
        "TitleOverride": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestEndpointsTypeDef(
    _ClientSendMessagesMessageRequestEndpointsTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequest` `Endpoints`

    Specifies the content, including message variables and attributes, to use in a message that's
    sent directly to an endpoint.

    - **BodyOverride** *(string) --*

      The body of the message. If specified, this value overrides the default message body.

    - **Context** *(dict) --*

      A map of custom attributes to attach to the message for the address. For a push notification,
      this payload is added to the data.pinpoint object. For an email or text message, this payload
      is added to email/SMS delivery receipt event attributes.

      - *(string) --*

        - *(string) --*

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the message. If specified, this value
      overrides all other values for the message.

    - **Substitutions** *(dict) --*

      A map of the message variables to merge with the variables specified for the default message
      (DefaultMessage.Substitutions). The variables specified in this map take precedence over all
      other variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **TitleOverride** *(string) --*

      The title or subject line of the message. If specified, this value overrides the default
      message title or subject line.
    """


_ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ConsolidationKey": str,
        "Data": Dict[str, str],
        "ExpiresAfter": str,
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "MD5": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `ADMMessage`

    The default push notification message for the ADM (Amazon Device Messaging) channel. This
    message overrides the default push notification message (DefaultPushNotificationMessage).

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message.

    - **ConsolidationKey** *(string) --*

      An arbitrary string that indicates that multiple messages are logically the same and that
      Amazon Device Messaging (ADM) can drop previously enqueued messages in favor of this message.

    - **Data** *(dict) --*

      The JSON data payload to use for the push notification, if the notification is a silent push
      notification. This payload is added to the data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **ExpiresAfter** *(string) --*

      The amount of time, in seconds, that ADM should store the message if the recipient's device is
      offline. Amazon Pinpoint specifies this value in the expiresAfter parameter when it sends the
      notification message to ADM.

    - **IconReference** *(string) --*

      The icon image name of the asset saved in your app.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of the push notification.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **MD5** *(string) --*

      The base64-encoded, MD5 checksum of the value specified by the Data property. ADM uses the MD5
      value to verify the integrity of the data.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration or supporting phone home functionality.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of the push
      notification.

    - **Sound** *(string) --*

      The sound to play when the recipient receives the push notification. You can use the default
      stream or specify the file name of a sound resource that's bundled in your app. On an Android
      platform, the sound file must reside in /res/raw/.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "APNSPushType": str,
        "Action": str,
        "Badge": int,
        "Body": str,
        "Category": str,
        "CollapseId": str,
        "Data": Dict[str, str],
        "MediaUrl": str,
        "PreferredAuthenticationMethod": str,
        "Priority": str,
        "RawContent": str,
        "SilentPush": bool,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "ThreadId": str,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `APNSMessage`

    The default push notification message for the APNs (Apple Push Notification service) channel.
    This message overrides the default push notification message (DefaultPushNotificationMessage).

    - **APNSPushType** *(string) --*

      The type of push notification to send. Valid values are:

      * alert - For a standard notification that's displayed on recipients' devices and prompts a
      recipient to interact with the notification.

      * background - For a silent notification that delivers content in the background and isn't
      displayed on recipients' devices.

      * complication - For a notification that contains update information for an app’s complication
      timeline.

      * fileprovider - For a notification that signals changes to a File Provider extension.

      * mdm - For a notification that tells managed devices to contact the MDM server.

      * voip - For a notification that provides information about an incoming VoIP call.

      Amazon Pinpoint specifies this value in the apns-push-type request header when it sends the
      notification message to APNs. If you don't specify a value for this property, Amazon Pinpoint
      sets the value to alert or background automatically, based on the value that you specify for
      the SilentPush or RawContent property of the message.

      For more information about the apns-push-type request header, see `Sending Notification
      Requests to APNs
      <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/sending_notification_requests_to_apns>`__
      on the Apple Developer website.

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Badge** *(integer) --*

      The key that indicates whether and how to modify the badge of your app's icon when the
      recipient receives the push notification. If this key isn't included in the dictionary, the
      badge doesn't change. To remove the badge, set this value to 0.

    - **Body** *(string) --*

      The body of the notification message.

    - **Category** *(string) --*

      The key that indicates the notification type for the push notification. This key is a value
      that's defined by the identifier property of one of your app's registered categories.

    - **CollapseId** *(string) --*

      An arbitrary identifier that, if assigned to multiple messages, APNs uses to coalesce the
      messages into a single push notification instead of delivering each message individually. This
      value can't exceed 64 bytes.

      Amazon Pinpoint specifies this value in the apns-collapse-id request header when it sends the
      notification message to APNs.

    - **Data** *(dict) --*

      The JSON payload to use for a silent push notification. This payload is added to the
      data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **MediaUrl** *(string) --*

      The URL of an image or video to display in the push notification.

    - **PreferredAuthenticationMethod** *(string) --*

      The authentication method that you want Amazon Pinpoint to use when authenticating with APNs,
      CERTIFICATE or TOKEN.

    - **Priority** *(string) --*

      para>5 - Low priority, the notification might be delayed, delivered as part of a group, or
      throttled.

      /listitem>
      * 10 - High priority, the notification is sent immediately. This is the default value. A high
      priority notification should trigger an alert, play a sound, or badge your app's icon on the
      recipient's device.
      /para>

      Amazon Pinpoint specifies this value in the apns-priority request header when it sends the
      notification message to APNs.

      The equivalent values for Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
      (GCM), are normal, for 5, and high, for 10. If you specify an FCM value for this property,
      Amazon Pinpoint accepts and converts the value to the corresponding APNs value.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

      .. note::

        If you specify the raw content of an APNs push notification, the message payload has to
        include the content-available key. The value of the content-available key has to be an
        integer, and can only be 0 or 1. If you're sending a standard notification, set the value of
        content-available to 0. If you're sending a silent (background) notification, set the value
        of content-available to 1. Additionally, silent notification payloads can't include the
        alert, badge, or sound keys. For more information, see `Generating a Remote Notification
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
        and `Pushing Background Updates to Your App
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
        on the Apple Developer website.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification. A silent (or background)
      push notification isn't displayed on recipients' devices. You can use silent push
      notifications to make small updates to your app, or to display messages in an in-app message
      center.

      Amazon Pinpoint uses this property to determine the correct value for the apns-push-type
      request header when it sends the notification message to APNs. If you specify a value of true
      for this property, Amazon Pinpoint sets the value for the apns-push-type header field to
      background.

      .. note::

        If you specify the raw content of an APNs push notification, the message payload has to
        include the content-available key. For silent (background) notifications, set the value of
        content-available to 1. Additionally, the message payload for a silent notification can't
        include the alert, badge, or sound keys. For more information, see `Generating a Remote
        Notification
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
        and `Pushing Background Updates to Your App
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
        on the Apple Developer website.

        Apple has indicated that they will throttle "excessive" background notifications based on
        current traffic volumes. To prevent your notifications being throttled, Apple recommends
        that you send no more than 3 silent push notifications to each recipient per hour.

    - **Sound** *(string) --*

      The key for the sound to play when the recipient receives the push notification. The value for
      this key is the name of a sound file in your app's main bundle or the Library/Sounds folder in
      your app's data container. If the sound file can't be found or you specify default for the
      value, the system plays the default alert sound.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override these
      default variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ThreadId** *(string) --*

      The key that represents your app-specific identifier for grouping notifications. If you
      provide a Notification Content app extension, you can use this value to group your
      notifications together.

    - **TimeToLive** *(integer) --*

      The amount of time, in seconds, that APNs should store and attempt to deliver the push
      notification, if the service is unable to deliver the notification the first time. If this
      value is 0, APNs treats the notification as if it expires immediately and the service doesn't
      store or try to deliver the notification again.

      Amazon Pinpoint specifies this value in the apns-expiration request header when it sends the
      notification message to APNs.

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `BaiduMessage`

    The default push notification message for the Baidu (Baidu Cloud Push) channel. This message
    overrides the default push notification message (DefaultPushNotificationMessage).

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message.

    - **Data** *(dict) --*

      The JSON data payload to use for the push notification, if the notification is a silent push
      notification. This payload is added to the data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **IconReference** *(string) --*

      The icon image name of the asset saved in your app.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of the push notification.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration or supporting phone home functionality.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of the push
      notification.

    - **Sound** *(string) --*

      The sound to play when the recipient receives the push notification. You can use the default
      stream or specify the file name of a sound resource that's bundled in your app. On an Android
      platform, the sound file must reside in /res/raw/.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **TimeToLive** *(integer) --*

      The amount of time, in seconds, that the Baidu Cloud Push service should store the message if
      the recipient's device is offline. The default value and maximum supported time is 604,800
      seconds (7 days).

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef",
    {"Body": str, "Substitutions": Dict[str, List[str]]},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `DefaultMessage`

    The default message for all channels.

    - **Body** *(string) --*

      The default body of the message.

    - **Substitutions** *(dict) --*

      The default message variables to use in the message. You can override these default variables
      with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*
    """


_ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "Data": Dict[str, str],
        "SilentPush": bool,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration`
    `DefaultPushNotificationMessage`

    The default push notification message for all push notification channels.

    - **Action** *(string) --*

      The default action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS and Android platforms.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The default body of the notification message.

    - **Data** *(dict) --*

      The JSON data payload to use for the default push notification, if the notification is a
      silent push notification. This payload is added to the data.pinpoint.jsonBody object of the
      notification.

      - *(string) --*

        - *(string) --*

    - **SilentPush** *(boolean) --*

      Specifies whether the default notification is a silent push notification, which is a push
      notification that doesn't display on a recipient's device. Silent push notifications can be
      used for cases such as updating an app's configuration or delivering messages to an in-app
      notification center.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **Title** *(string) --*

      The default title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The default URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    {"Data": bytes},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfigurationEmailMessage`
    `RawEmail`

    The email message, represented as a raw MIME message.

    - **Data** *(bytes) --*

      The email message, represented as a raw MIME message. The entire message must be base64
      encoded.
    """


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef
):
    """
    Type definition for
    `ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmail` `HtmlPart`

    The body of the email message, in HTML format. We recommend using HTML format for email clients
    that render HTML content. You can include links, formatted text, and more in an HTML message.

    - **Charset** *(string) --*

      The applicable character set for the message content.

    - **Data** *(string) --*

      The textual data of the message content.
    """


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef
):
    """
    Type definition for
    `ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmail` `Subject`

    The subject line, or title, of the email.

    - **Charset** *(string) --*

      The applicable character set for the message content.

    - **Data** *(string) --*

      The textual data of the message content.
    """


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef
):
    """
    Type definition for
    `ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmail` `TextPart`

    The body of the email message, in plain text format. We recommend using plain text format for
    email clients that don't render HTML content and clients that are connected to high-latency
    networks, such as mobile devices.

    - **Charset** *(string) --*

      The applicable character set for the message content.

    - **Data** *(string) --*

      The textual data of the message content.
    """


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    {
        "HtmlPart": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef,
        "Subject": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef,
        "TextPart": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfigurationEmailMessage`
    `SimpleEmail`

    The email message, composed of a subject, a text part, and an HTML part.

    - **HtmlPart** *(dict) --*

      The body of the email message, in HTML format. We recommend using HTML format for email
      clients that render HTML content. You can include links, formatted text, and more in an HTML
      message.

      - **Charset** *(string) --*

        The applicable character set for the message content.

      - **Data** *(string) --*

        The textual data of the message content.

    - **Subject** *(dict) --*

      The subject line, or title, of the email.

      - **Charset** *(string) --*

        The applicable character set for the message content.

      - **Data** *(string) --*

        The textual data of the message content.

    - **TextPart** *(dict) --*

      The body of the email message, in plain text format. We recommend using plain text format for
      email clients that don't render HTML content and clients that are connected to high-latency
      networks, such as mobile devices.

      - **Charset** *(string) --*

        The applicable character set for the message content.

      - **Data** *(string) --*

        The textual data of the message content.
    """


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef",
    {
        "Body": str,
        "FeedbackForwardingAddress": str,
        "FromAddress": str,
        "RawEmail": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef,
        "ReplyToAddresses": List[str],
        "SimpleEmail": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `EmailMessage`

    The default message for the email channel. This message overrides the default message
    (DefaultMessage).

    - **Body** *(string) --*

      The body of the email message.

    - **FeedbackForwardingAddress** *(string) --*

      The email address to forward bounces and complaints to, if feedback forwarding is enabled.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default value is the
      FromAddress specified for the email channel.

    - **RawEmail** *(dict) --*

      The email message, represented as a raw MIME message.

      - **Data** *(bytes) --*

        The email message, represented as a raw MIME message. The entire message must be base64
        encoded.

    - **ReplyToAddresses** *(list) --*

      The reply-to email address(es) for the email message. If a recipient replies to the email,
      each reply-to address receives the reply.

      - *(string) --*

    - **SimpleEmail** *(dict) --*

      The email message, composed of a subject, a text part, and an HTML part.

      - **HtmlPart** *(dict) --*

        The body of the email message, in HTML format. We recommend using HTML format for email
        clients that render HTML content. You can include links, formatted text, and more in an HTML
        message.

        - **Charset** *(string) --*

          The applicable character set for the message content.

        - **Data** *(string) --*

          The textual data of the message content.

      - **Subject** *(dict) --*

        The subject line, or title, of the email.

        - **Charset** *(string) --*

          The applicable character set for the message content.

        - **Data** *(string) --*

          The textual data of the message content.

      - **TextPart** *(dict) --*

        The body of the email message, in plain text format. We recommend using plain text format
        for email clients that don't render HTML content and clients that are connected to
        high-latency networks, such as mobile devices.

        - **Charset** *(string) --*

          The applicable character set for the message content.

        - **Data** *(string) --*

          The textual data of the message content.

    - **Substitutions** *(dict) --*

      The default message variables to use in the email message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*
    """


_ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "CollapseKey": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "Priority": str,
        "RawContent": str,
        "RestrictedPackageName": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `GCMMessage`

    The default push notification message for the GCM channel, which is used to send notifications
    through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service. This
    message overrides the default push notification message (DefaultPushNotificationMessage).

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message.

    - **CollapseKey** *(string) --*

      An arbitrary string that identifies a group of messages that can be collapsed to ensure that
      only the last message is sent when delivery can resume. This helps avoid sending too many
      instances of the same messages when the recipient's device comes online again or becomes
      active.

      Amazon Pinpoint specifies this value in the Firebase Cloud Messaging (FCM) collapse_key
      parameter when it sends the notification message to FCM.

    - **Data** *(dict) --*

      The JSON data payload to use for the push notification, if the notification is a silent push
      notification. This payload is added to the data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **IconReference** *(string) --*

      The icon image name of the asset saved in your app.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of the push notification.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **Priority** *(string) --*

      para>normal - The notification might be delayed. Delivery is optimized for battery usage on
      the recipient's device. Use this value unless immediate delivery is required.

      /listitem>
      * high - The notification is sent immediately and might wake a sleeping device.
      /para>

      Amazon Pinpoint specifies this value in the FCM priority parameter when it sends the
      notification message to FCM.

      The equivalent values for Apple Push Notification service (APNs) are 5, for normal, and 10,
      for high. If you specify an APNs value for this property, Amazon Pinpoint accepts and converts
      the value to the corresponding FCM value.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **RestrictedPackageName** *(string) --*

      The package name of the application where registration tokens must match in order for the
      recipient to receive the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration or supporting phone home functionality.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of the push
      notification.

    - **Sound** *(string) --*

      The sound to play when the recipient receives the push notification. You can use the default
      stream or specify the file name of a sound resource that's bundled in your app. On an Android
      platform, the sound file must reside in /res/raw/.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **TimeToLive** *(integer) --*

      The amount of time, in seconds, that FCM should store and attempt to deliver the push
      notification, if the service is unable to deliver the notification the first time. If you
      don't specify this value, FCM defaults to the maximum value, which is 2,419,200 seconds (28
      days).

      Amazon Pinpoint specifies this value in the FCM time_to_live parameter when it sends the
      notification message to FCM.

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef",
    {
        "Body": str,
        "Keyword": str,
        "MessageType": str,
        "OriginationNumber": str,
        "SenderId": str,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `SMSMessage`

    The default message for the SMS channel. This message overrides the default message
    (DefaultMessage).

    - **Body** *(string) --*

      The body of the SMS message.

    - **Keyword** *(string) --*

      The SMS program name that you provided to AWS Support when you requested your dedicated
      number.

    - **MessageType** *(string) --*

      The SMS message type. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message is not critical or time-sensitive, such as a marketing message.

    - **OriginationNumber** *(string) --*

      The number to send the SMS message from. This value should be one of the dedicated long or
      short codes that's assigned to your AWS account. If you don't specify a long or short code,
      Amazon Pinpoint assigns a random long code to the SMS message and sends the message from that
      code.

    - **SenderId** *(string) --*

      The sender ID to display as the sender of the message on a recipient's device. Support for
      sender IDs varies by country or region.

    - **Substitutions** *(dict) --*

      The message variables to use in the SMS message. You can override the default variables with
      individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*
    """


_ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef",
    {
        "Body": str,
        "LanguageCode": str,
        "OriginationNumber": str,
        "Substitutions": Dict[str, List[str]],
        "VoiceId": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestMessageConfiguration` `VoiceMessage`

    The default message for the voice channel. This message overrides the default message
    (DefaultMessage).

    - **Body** *(string) --*

      The text of the script to use for the voice message.

    - **LanguageCode** *(string) --*

      The code for the language to use when synthesizing the text of the message script. For a list
      of supported languages and the code for each one, see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

    - **OriginationNumber** *(string) --*

      The long code to send the voice message from. This value should be one of the dedicated long
      codes that's assigned to your AWS account. Although it isn't required, we recommend that you
      specify the long code in E.164 format, for example +12065550100, to ensure prompt and accurate
      delivery of the message.

    - **Substitutions** *(dict) --*

      The default message variables to use in the voice message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **VoiceId** *(string) --*

      The name of the voice to use when delivering the message. For a list of supported voices, see
      the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """


_ClientSendMessagesMessageRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef,
        "DefaultPushNotificationMessage": ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef,
        "EmailMessage": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef,
        "VoiceMessage": ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequest` `MessageConfiguration`

    The settings and content for the default message and any default messages that you defined for
    specific channels.

    - **ADMMessage** *(dict) --*

      The default push notification message for the ADM (Amazon Device Messaging) channel. This
      message overrides the default push notification message (DefaultPushNotificationMessage).

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message.

      - **ConsolidationKey** *(string) --*

        An arbitrary string that indicates that multiple messages are logically the same and that
        Amazon Device Messaging (ADM) can drop previously enqueued messages in favor of this
        message.

      - **Data** *(dict) --*

        The JSON data payload to use for the push notification, if the notification is a silent push
        notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **ExpiresAfter** *(string) --*

        The amount of time, in seconds, that ADM should store the message if the recipient's device
        is offline. Amazon Pinpoint specifies this value in the expiresAfter parameter when it sends
        the notification message to ADM.

      - **IconReference** *(string) --*

        The icon image name of the asset saved in your app.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of the push notification.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **MD5** *(string) --*

        The base64-encoded, MD5 checksum of the value specified by the Data property. ADM uses the
        MD5 value to verify the integrity of the data.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or supporting phone home
        functionality.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of the
        push notification.

      - **Sound** *(string) --*

        The sound to play when the recipient receives the push notification. You can use the default
        stream or specify the file name of a sound resource that's bundled in your app. On an
        Android platform, the sound file must reside in /res/raw/.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The default push notification message for the APNs (Apple Push Notification service) channel.
      This message overrides the default push notification message (DefaultPushNotificationMessage).

      - **APNSPushType** *(string) --*

        The type of push notification to send. Valid values are:

        * alert - For a standard notification that's displayed on recipients' devices and prompts a
        recipient to interact with the notification.

        * background - For a silent notification that delivers content in the background and isn't
        displayed on recipients' devices.

        * complication - For a notification that contains update information for an app’s
        complication timeline.

        * fileprovider - For a notification that signals changes to a File Provider extension.

        * mdm - For a notification that tells managed devices to contact the MDM server.

        * voip - For a notification that provides information about an incoming VoIP call.

        Amazon Pinpoint specifies this value in the apns-push-type request header when it sends the
        notification message to APNs. If you don't specify a value for this property, Amazon
        Pinpoint sets the value to alert or background automatically, based on the value that you
        specify for the SilentPush or RawContent property of the message.

        For more information about the apns-push-type request header, see `Sending Notification
        Requests to APNs
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/sending_notification_requests_to_apns>`__
        on the Apple Developer website.

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Badge** *(integer) --*

        The key that indicates whether and how to modify the badge of your app's icon when the
        recipient receives the push notification. If this key isn't included in the dictionary, the
        badge doesn't change. To remove the badge, set this value to 0.

      - **Body** *(string) --*

        The body of the notification message.

      - **Category** *(string) --*

        The key that indicates the notification type for the push notification. This key is a value
        that's defined by the identifier property of one of your app's registered categories.

      - **CollapseId** *(string) --*

        An arbitrary identifier that, if assigned to multiple messages, APNs uses to coalesce the
        messages into a single push notification instead of delivering each message individually.
        This value can't exceed 64 bytes.

        Amazon Pinpoint specifies this value in the apns-collapse-id request header when it sends
        the notification message to APNs.

      - **Data** *(dict) --*

        The JSON payload to use for a silent push notification. This payload is added to the
        data.pinpoint.jsonBody object of the notification.

        - *(string) --*

          - *(string) --*

      - **MediaUrl** *(string) --*

        The URL of an image or video to display in the push notification.

      - **PreferredAuthenticationMethod** *(string) --*

        The authentication method that you want Amazon Pinpoint to use when authenticating with
        APNs, CERTIFICATE or TOKEN.

      - **Priority** *(string) --*

        para>5 - Low priority, the notification might be delayed, delivered as part of a group, or
        throttled.

        /listitem>
        * 10 - High priority, the notification is sent immediately. This is the default value. A
        high priority notification should trigger an alert, play a sound, or badge your app's icon
        on the recipient's device.
        /para>

        Amazon Pinpoint specifies this value in the apns-priority request header when it sends the
        notification message to APNs.

        The equivalent values for Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
        (GCM), are normal, for 5, and high, for 10. If you specify an FCM value for this property,
        Amazon Pinpoint accepts and converts the value to the corresponding APNs value.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

        .. note::

          If you specify the raw content of an APNs push notification, the message payload has to
          include the content-available key. The value of the content-available key has to be an
          integer, and can only be 0 or 1. If you're sending a standard notification, set the value
          of content-available to 0. If you're sending a silent (background) notification, set the
          value of content-available to 1. Additionally, silent notification payloads can't include
          the alert, badge, or sound keys. For more information, see `Generating a Remote
          Notification
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
          and `Pushing Background Updates to Your App
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
          on the Apple Developer website.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification. A silent (or background)
        push notification isn't displayed on recipients' devices. You can use silent push
        notifications to make small updates to your app, or to display messages in an in-app message
        center.

        Amazon Pinpoint uses this property to determine the correct value for the apns-push-type
        request header when it sends the notification message to APNs. If you specify a value of
        true for this property, Amazon Pinpoint sets the value for the apns-push-type header field
        to background.

        .. note::

          If you specify the raw content of an APNs push notification, the message payload has to
          include the content-available key. For silent (background) notifications, set the value of
          content-available to 1. Additionally, the message payload for a silent notification can't
          include the alert, badge, or sound keys. For more information, see `Generating a Remote
          Notification
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
          and `Pushing Background Updates to Your App
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
          on the Apple Developer website.

          Apple has indicated that they will throttle "excessive" background notifications based on
          current traffic volumes. To prevent your notifications being throttled, Apple recommends
          that you send no more than 3 silent push notifications to each recipient per hour.

      - **Sound** *(string) --*

        The key for the sound to play when the recipient receives the push notification. The value
        for this key is the name of a sound file in your app's main bundle or the Library/Sounds
        folder in your app's data container. If the sound file can't be found or you specify default
        for the value, the system plays the default alert sound.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override these
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **ThreadId** *(string) --*

        The key that represents your app-specific identifier for grouping notifications. If you
        provide a Notification Content app extension, you can use this value to group your
        notifications together.

      - **TimeToLive** *(integer) --*

        The amount of time, in seconds, that APNs should store and attempt to deliver the push
        notification, if the service is unable to deliver the notification the first time. If this
        value is 0, APNs treats the notification as if it expires immediately and the service
        doesn't store or try to deliver the notification again.

        Amazon Pinpoint specifies this value in the apns-expiration request header when it sends the
        notification message to APNs.

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The default push notification message for the Baidu (Baidu Cloud Push) channel. This message
      overrides the default push notification message (DefaultPushNotificationMessage).

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message.

      - **Data** *(dict) --*

        The JSON data payload to use for the push notification, if the notification is a silent push
        notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **IconReference** *(string) --*

        The icon image name of the asset saved in your app.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of the push notification.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or supporting phone home
        functionality.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of the
        push notification.

      - **Sound** *(string) --*

        The sound to play when the recipient receives the push notification. You can use the default
        stream or specify the file name of a sound resource that's bundled in your app. On an
        Android platform, the sound file must reside in /res/raw/.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **TimeToLive** *(integer) --*

        The amount of time, in seconds, that the Baidu Cloud Push service should store the message
        if the recipient's device is offline. The default value and maximum supported time is
        604,800 seconds (7 days).

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message for all channels.

      - **Body** *(string) --*

        The default body of the message.

      - **Substitutions** *(dict) --*

        The default message variables to use in the message. You can override these default
        variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

    - **DefaultPushNotificationMessage** *(dict) --*

      The default push notification message for all push notification channels.

      - **Action** *(string) --*

        The default action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS and Android platforms.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The default body of the notification message.

      - **Data** *(dict) --*

        The JSON data payload to use for the default push notification, if the notification is a
        silent push notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **SilentPush** *(boolean) --*

        Specifies whether the default notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or delivering messages to an in-app
        notification center.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **Title** *(string) --*

        The default title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The default URL to open in a recipient's default mobile browser, if a recipient taps the
        push notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The default message for the email channel. This message overrides the default message
      (DefaultMessage).

      - **Body** *(string) --*

        The body of the email message.

      - **FeedbackForwardingAddress** *(string) --*

        The email address to forward bounces and complaints to, if feedback forwarding is enabled.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default value is the
        FromAddress specified for the email channel.

      - **RawEmail** *(dict) --*

        The email message, represented as a raw MIME message.

        - **Data** *(bytes) --*

          The email message, represented as a raw MIME message. The entire message must be base64
          encoded.

      - **ReplyToAddresses** *(list) --*

        The reply-to email address(es) for the email message. If a recipient replies to the email,
        each reply-to address receives the reply.

        - *(string) --*

      - **SimpleEmail** *(dict) --*

        The email message, composed of a subject, a text part, and an HTML part.

        - **HtmlPart** *(dict) --*

          The body of the email message, in HTML format. We recommend using HTML format for email
          clients that render HTML content. You can include links, formatted text, and more in an
          HTML message.

          - **Charset** *(string) --*

            The applicable character set for the message content.

          - **Data** *(string) --*

            The textual data of the message content.

        - **Subject** *(dict) --*

          The subject line, or title, of the email.

          - **Charset** *(string) --*

            The applicable character set for the message content.

          - **Data** *(string) --*

            The textual data of the message content.

        - **TextPart** *(dict) --*

          The body of the email message, in plain text format. We recommend using plain text format
          for email clients that don't render HTML content and clients that are connected to
          high-latency networks, such as mobile devices.

          - **Charset** *(string) --*

            The applicable character set for the message content.

          - **Data** *(string) --*

            The textual data of the message content.

      - **Substitutions** *(dict) --*

        The default message variables to use in the email message. You can override the default
        variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

    - **GCMMessage** *(dict) --*

      The default push notification message for the GCM channel, which is used to send notifications
      through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
      This message overrides the default push notification message (DefaultPushNotificationMessage).

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message.

      - **CollapseKey** *(string) --*

        An arbitrary string that identifies a group of messages that can be collapsed to ensure that
        only the last message is sent when delivery can resume. This helps avoid sending too many
        instances of the same messages when the recipient's device comes online again or becomes
        active.

        Amazon Pinpoint specifies this value in the Firebase Cloud Messaging (FCM) collapse_key
        parameter when it sends the notification message to FCM.

      - **Data** *(dict) --*

        The JSON data payload to use for the push notification, if the notification is a silent push
        notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **IconReference** *(string) --*

        The icon image name of the asset saved in your app.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of the push notification.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **Priority** *(string) --*

        para>normal - The notification might be delayed. Delivery is optimized for battery usage on
        the recipient's device. Use this value unless immediate delivery is required.

        /listitem>
        * high - The notification is sent immediately and might wake a sleeping device.
        /para>

        Amazon Pinpoint specifies this value in the FCM priority parameter when it sends the
        notification message to FCM.

        The equivalent values for Apple Push Notification service (APNs) are 5, for normal, and 10,
        for high. If you specify an APNs value for this property, Amazon Pinpoint accepts and
        converts the value to the corresponding FCM value.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **RestrictedPackageName** *(string) --*

        The package name of the application where registration tokens must match in order for the
        recipient to receive the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or supporting phone home
        functionality.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of the
        push notification.

      - **Sound** *(string) --*

        The sound to play when the recipient receives the push notification. You can use the default
        stream or specify the file name of a sound resource that's bundled in your app. On an
        Android platform, the sound file must reside in /res/raw/.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **TimeToLive** *(integer) --*

        The amount of time, in seconds, that FCM should store and attempt to deliver the push
        notification, if the service is unable to deliver the notification the first time. If you
        don't specify this value, FCM defaults to the maximum value, which is 2,419,200 seconds (28
        days).

        Amazon Pinpoint specifies this value in the FCM time_to_live parameter when it sends the
        notification message to FCM.

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The default message for the SMS channel. This message overrides the default message
      (DefaultMessage).

      - **Body** *(string) --*

        The body of the SMS message.

      - **Keyword** *(string) --*

        The SMS program name that you provided to AWS Support when you requested your dedicated
        number.

      - **MessageType** *(string) --*

        The SMS message type. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message is not critical or time-sensitive, such as a marketing message.

      - **OriginationNumber** *(string) --*

        The number to send the SMS message from. This value should be one of the dedicated long or
        short codes that's assigned to your AWS account. If you don't specify a long or short code,
        Amazon Pinpoint assigns a random long code to the SMS message and sends the message from
        that code.

      - **SenderId** *(string) --*

        The sender ID to display as the sender of the message on a recipient's device. Support for
        sender IDs varies by country or region.

      - **Substitutions** *(dict) --*

        The message variables to use in the SMS message. You can override the default variables with
        individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

    - **VoiceMessage** *(dict) --*

      The default message for the voice channel. This message overrides the default message
      (DefaultMessage).

      - **Body** *(string) --*

        The text of the script to use for the voice message.

      - **LanguageCode** *(string) --*

        The code for the language to use when synthesizing the text of the message script. For a
        list of supported languages and the code for each one, see the `Amazon Polly Developer Guide
        <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

      - **OriginationNumber** *(string) --*

        The long code to send the voice message from. This value should be one of the dedicated long
        codes that's assigned to your AWS account. Although it isn't required, we recommend that you
        specify the long code in E.164 format, for example +12065550100, to ensure prompt and
        accurate delivery of the message.

      - **Substitutions** *(dict) --*

        The default message variables to use in the voice message. You can override the default
        variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **VoiceId** *(string) --*

        The name of the voice to use when delivering the message. For a list of supported voices,
        see the `Amazon Polly Developer Guide
        <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """


_ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestTemplateConfiguration` `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestTemplateConfiguration` `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestTemplateConfiguration` `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequestTemplateConfiguration` `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendMessagesMessageRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientSendMessagesMessageRequest` `TemplateConfiguration`

    The message template to use for the message.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_RequiredClientSendMessagesMessageRequestTypeDef = TypedDict(
    "_RequiredClientSendMessagesMessageRequestTypeDef",
    {"MessageConfiguration": ClientSendMessagesMessageRequestMessageConfigurationTypeDef},
)
_OptionalClientSendMessagesMessageRequestTypeDef = TypedDict(
    "_OptionalClientSendMessagesMessageRequestTypeDef",
    {
        "Addresses": Dict[str, ClientSendMessagesMessageRequestAddressesTypeDef],
        "Context": Dict[str, str],
        "Endpoints": Dict[str, ClientSendMessagesMessageRequestEndpointsTypeDef],
        "TemplateConfiguration": ClientSendMessagesMessageRequestTemplateConfigurationTypeDef,
        "TraceId": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestTypeDef(
    _RequiredClientSendMessagesMessageRequestTypeDef,
    _OptionalClientSendMessagesMessageRequestTypeDef,
):
    """
    Type definition for `ClientSendMessages` `MessageRequest`

    Specifies the configuration and other settings for a message.

    - **Addresses** *(dict) --*

      A map of key-value pairs, where each key is an address and each value is an
      AddressConfiguration object. An address can be a push notification token, a phone number, or
      an email address. You can use an AddressConfiguration object to tailor the message for an
      address by specifying settings such as content overrides and message variables.

      - *(string) --*

        - *(dict) --*

          Specifies address-based configuration settings for a message that's sent directly to an
          endpoint.

          - **BodyOverride** *(string) --*

            The message body to use instead of the default message body. This value overrides the
            default message body.

          - **ChannelType** *(string) --*

            The channel to use when sending the message.

          - **Context** *(dict) --*

            An object that maps custom attributes to attributes for the address and is attached to
            the message. For a push notification, this payload is added to the data.pinpoint object.
            For an email or text message, this payload is added to email/SMS delivery receipt event
            attributes.

            - *(string) --*

              - *(string) --*

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the message. If specified, this
            value overrides all other values for the message.

          - **Substitutions** *(dict) --*

            A map of the message variables to merge with the variables specified by properties of
            the DefaultMessage object. The variables specified in this map take precedence over all
            other variables.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **TitleOverride** *(string) --*

            The message title to use instead of the default message title. This value overrides the
            default message title.

    - **Context** *(dict) --*

      A map of custom attributes to attach to the message. For a push notification, this payload is
      added to the data.pinpoint object. For an email or text message, this payload is added to
      email/SMS delivery receipt event attributes.

      - *(string) --*

        - *(string) --*

    - **Endpoints** *(dict) --*

      A map of key-value pairs, where each key is an endpoint ID and each value is an
      EndpointSendConfiguration object. You can use an EndpointSendConfiguration object to tailor
      the message for an endpoint by specifying settings such as content overrides and message
      variables.

      - *(string) --*

        - *(dict) --*

          Specifies the content, including message variables and attributes, to use in a message
          that's sent directly to an endpoint.

          - **BodyOverride** *(string) --*

            The body of the message. If specified, this value overrides the default message body.

          - **Context** *(dict) --*

            A map of custom attributes to attach to the message for the address. For a push
            notification, this payload is added to the data.pinpoint object. For an email or text
            message, this payload is added to email/SMS delivery receipt event attributes.

            - *(string) --*

              - *(string) --*

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the message. If specified, this
            value overrides all other values for the message.

          - **Substitutions** *(dict) --*

            A map of the message variables to merge with the variables specified for the default
            message (DefaultMessage.Substitutions). The variables specified in this map take
            precedence over all other variables.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **TitleOverride** *(string) --*

            The title or subject line of the message. If specified, this value overrides the default
            message title or subject line.

    - **MessageConfiguration** *(dict) --* **[REQUIRED]**

      The settings and content for the default message and any default messages that you defined for
      specific channels.

      - **ADMMessage** *(dict) --*

        The default push notification message for the ADM (Amazon Device Messaging) channel. This
        message overrides the default push notification message (DefaultPushNotificationMessage).

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message.

        - **ConsolidationKey** *(string) --*

          An arbitrary string that indicates that multiple messages are logically the same and that
          Amazon Device Messaging (ADM) can drop previously enqueued messages in favor of this
          message.

        - **Data** *(dict) --*

          The JSON data payload to use for the push notification, if the notification is a silent
          push notification. This payload is added to the data.pinpoint.jsonBody object of the
          notification.

          - *(string) --*

            - *(string) --*

        - **ExpiresAfter** *(string) --*

          The amount of time, in seconds, that ADM should store the message if the recipient's
          device is offline. Amazon Pinpoint specifies this value in the expiresAfter parameter when
          it sends the notification message to ADM.

        - **IconReference** *(string) --*

          The icon image name of the asset saved in your app.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of the push notification.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **MD5** *(string) --*

          The base64-encoded, MD5 checksum of the value specified by the Data property. ADM uses the
          MD5 value to verify the integrity of the data.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or supporting phone home
          functionality.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of the
          push notification.

        - **Sound** *(string) --*

          The sound to play when the recipient receives the push notification. You can use the
          default stream or specify the file name of a sound resource that's bundled in your app. On
          an Android platform, the sound file must reside in /res/raw/.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The default push notification message for the APNs (Apple Push Notification service)
        channel. This message overrides the default push notification message
        (DefaultPushNotificationMessage).

        - **APNSPushType** *(string) --*

          The type of push notification to send. Valid values are:

          * alert - For a standard notification that's displayed on recipients' devices and prompts
          a recipient to interact with the notification.

          * background - For a silent notification that delivers content in the background and isn't
          displayed on recipients' devices.

          * complication - For a notification that contains update information for an app’s
          complication timeline.

          * fileprovider - For a notification that signals changes to a File Provider extension.

          * mdm - For a notification that tells managed devices to contact the MDM server.

          * voip - For a notification that provides information about an incoming VoIP call.

          Amazon Pinpoint specifies this value in the apns-push-type request header when it sends
          the notification message to APNs. If you don't specify a value for this property, Amazon
          Pinpoint sets the value to alert or background automatically, based on the value that you
          specify for the SilentPush or RawContent property of the message.

          For more information about the apns-push-type request header, see `Sending Notification
          Requests to APNs
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/sending_notification_requests_to_apns>`__
          on the Apple Developer website.

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of the iOS platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Badge** *(integer) --*

          The key that indicates whether and how to modify the badge of your app's icon when the
          recipient receives the push notification. If this key isn't included in the dictionary,
          the badge doesn't change. To remove the badge, set this value to 0.

        - **Body** *(string) --*

          The body of the notification message.

        - **Category** *(string) --*

          The key that indicates the notification type for the push notification. This key is a
          value that's defined by the identifier property of one of your app's registered
          categories.

        - **CollapseId** *(string) --*

          An arbitrary identifier that, if assigned to multiple messages, APNs uses to coalesce the
          messages into a single push notification instead of delivering each message individually.
          This value can't exceed 64 bytes.

          Amazon Pinpoint specifies this value in the apns-collapse-id request header when it sends
          the notification message to APNs.

        - **Data** *(dict) --*

          The JSON payload to use for a silent push notification. This payload is added to the
          data.pinpoint.jsonBody object of the notification.

          - *(string) --*

            - *(string) --*

        - **MediaUrl** *(string) --*

          The URL of an image or video to display in the push notification.

        - **PreferredAuthenticationMethod** *(string) --*

          The authentication method that you want Amazon Pinpoint to use when authenticating with
          APNs, CERTIFICATE or TOKEN.

        - **Priority** *(string) --*

          para>5 - Low priority, the notification might be delayed, delivered as part of a group, or
          throttled.

          /listitem>
          * 10 - High priority, the notification is sent immediately. This is the default value. A
          high priority notification should trigger an alert, play a sound, or badge your app's icon
          on the recipient's device.
          /para>

          Amazon Pinpoint specifies this value in the apns-priority request header when it sends the
          notification message to APNs.

          The equivalent values for Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
          (GCM), are normal, for 5, and high, for 10. If you specify an FCM value for this property,
          Amazon Pinpoint accepts and converts the value to the corresponding APNs value.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

          .. note::

            If you specify the raw content of an APNs push notification, the message payload has to
            include the content-available key. The value of the content-available key has to be an
            integer, and can only be 0 or 1. If you're sending a standard notification, set the
            value of content-available to 0. If you're sending a silent (background) notification,
            set the value of content-available to 1. Additionally, silent notification payloads
            can't include the alert, badge, or sound keys. For more information, see `Generating a
            Remote Notification
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
            and `Pushing Background Updates to Your App
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
            on the Apple Developer website.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification. A silent (or background)
          push notification isn't displayed on recipients' devices. You can use silent push
          notifications to make small updates to your app, or to display messages in an in-app
          message center.

          Amazon Pinpoint uses this property to determine the correct value for the apns-push-type
          request header when it sends the notification message to APNs. If you specify a value of
          true for this property, Amazon Pinpoint sets the value for the apns-push-type header field
          to background.

          .. note::

            If you specify the raw content of an APNs push notification, the message payload has to
            include the content-available key. For silent (background) notifications, set the value
            of content-available to 1. Additionally, the message payload for a silent notification
            can't include the alert, badge, or sound keys. For more information, see `Generating a
            Remote Notification
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
            and `Pushing Background Updates to Your App
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
            on the Apple Developer website.

            Apple has indicated that they will throttle "excessive" background notifications based
            on current traffic volumes. To prevent your notifications being throttled, Apple
            recommends that you send no more than 3 silent push notifications to each recipient per
            hour.

        - **Sound** *(string) --*

          The key for the sound to play when the recipient receives the push notification. The value
          for this key is the name of a sound file in your app's main bundle or the Library/Sounds
          folder in your app's data container. If the sound file can't be found or you specify
          default for the value, the system plays the default alert sound.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override these
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **ThreadId** *(string) --*

          The key that represents your app-specific identifier for grouping notifications. If you
          provide a Notification Content app extension, you can use this value to group your
          notifications together.

        - **TimeToLive** *(integer) --*

          The amount of time, in seconds, that APNs should store and attempt to deliver the push
          notification, if the service is unable to deliver the notification the first time. If this
          value is 0, APNs treats the notification as if it expires immediately and the service
          doesn't store or try to deliver the notification again.

          Amazon Pinpoint specifies this value in the apns-expiration request header when it sends
          the notification message to APNs.

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The default push notification message for the Baidu (Baidu Cloud Push) channel. This message
        overrides the default push notification message (DefaultPushNotificationMessage).

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message.

        - **Data** *(dict) --*

          The JSON data payload to use for the push notification, if the notification is a silent
          push notification. This payload is added to the data.pinpoint.jsonBody object of the
          notification.

          - *(string) --*

            - *(string) --*

        - **IconReference** *(string) --*

          The icon image name of the asset saved in your app.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of the push notification.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or supporting phone home
          functionality.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of the
          push notification.

        - **Sound** *(string) --*

          The sound to play when the recipient receives the push notification. You can use the
          default stream or specify the file name of a sound resource that's bundled in your app. On
          an Android platform, the sound file must reside in /res/raw/.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **TimeToLive** *(integer) --*

          The amount of time, in seconds, that the Baidu Cloud Push service should store the message
          if the recipient's device is offline. The default value and maximum supported time is
          604,800 seconds (7 days).

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message for all channels.

        - **Body** *(string) --*

          The default body of the message.

        - **Substitutions** *(dict) --*

          The default message variables to use in the message. You can override these default
          variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

      - **DefaultPushNotificationMessage** *(dict) --*

        The default push notification message for all push notification channels.

        - **Action** *(string) --*

          The default action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of the iOS and Android platforms.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The default body of the notification message.

        - **Data** *(dict) --*

          The JSON data payload to use for the default push notification, if the notification is a
          silent push notification. This payload is added to the data.pinpoint.jsonBody object of
          the notification.

          - *(string) --*

            - *(string) --*

        - **SilentPush** *(boolean) --*

          Specifies whether the default notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or delivering messages to an
          in-app notification center.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **Title** *(string) --*

          The default title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The default URL to open in a recipient's default mobile browser, if a recipient taps the
          push notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The default message for the email channel. This message overrides the default message
        (DefaultMessage).

        - **Body** *(string) --*

          The body of the email message.

        - **FeedbackForwardingAddress** *(string) --*

          The email address to forward bounces and complaints to, if feedback forwarding is enabled.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default value is the
          FromAddress specified for the email channel.

        - **RawEmail** *(dict) --*

          The email message, represented as a raw MIME message.

          - **Data** *(bytes) --*

            The email message, represented as a raw MIME message. The entire message must be base64
            encoded.

        - **ReplyToAddresses** *(list) --*

          The reply-to email address(es) for the email message. If a recipient replies to the email,
          each reply-to address receives the reply.

          - *(string) --*

        - **SimpleEmail** *(dict) --*

          The email message, composed of a subject, a text part, and an HTML part.

          - **HtmlPart** *(dict) --*

            The body of the email message, in HTML format. We recommend using HTML format for email
            clients that render HTML content. You can include links, formatted text, and more in an
            HTML message.

            - **Charset** *(string) --*

              The applicable character set for the message content.

            - **Data** *(string) --*

              The textual data of the message content.

          - **Subject** *(dict) --*

            The subject line, or title, of the email.

            - **Charset** *(string) --*

              The applicable character set for the message content.

            - **Data** *(string) --*

              The textual data of the message content.

          - **TextPart** *(dict) --*

            The body of the email message, in plain text format. We recommend using plain text
            format for email clients that don't render HTML content and clients that are connected
            to high-latency networks, such as mobile devices.

            - **Charset** *(string) --*

              The applicable character set for the message content.

            - **Data** *(string) --*

              The textual data of the message content.

        - **Substitutions** *(dict) --*

          The default message variables to use in the email message. You can override the default
          variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

      - **GCMMessage** *(dict) --*

        The default push notification message for the GCM channel, which is used to send
        notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
        (GCM), service. This message overrides the default push notification message
        (DefaultPushNotificationMessage).

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message.

        - **CollapseKey** *(string) --*

          An arbitrary string that identifies a group of messages that can be collapsed to ensure
          that only the last message is sent when delivery can resume. This helps avoid sending too
          many instances of the same messages when the recipient's device comes online again or
          becomes active.

          Amazon Pinpoint specifies this value in the Firebase Cloud Messaging (FCM) collapse_key
          parameter when it sends the notification message to FCM.

        - **Data** *(dict) --*

          The JSON data payload to use for the push notification, if the notification is a silent
          push notification. This payload is added to the data.pinpoint.jsonBody object of the
          notification.

          - *(string) --*

            - *(string) --*

        - **IconReference** *(string) --*

          The icon image name of the asset saved in your app.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of the push notification.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **Priority** *(string) --*

          para>normal - The notification might be delayed. Delivery is optimized for battery usage
          on the recipient's device. Use this value unless immediate delivery is required.

          /listitem>
          * high - The notification is sent immediately and might wake a sleeping device.
          /para>

          Amazon Pinpoint specifies this value in the FCM priority parameter when it sends the
          notification message to FCM.

          The equivalent values for Apple Push Notification service (APNs) are 5, for normal, and
          10, for high. If you specify an APNs value for this property, Amazon Pinpoint accepts and
          converts the value to the corresponding FCM value.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **RestrictedPackageName** *(string) --*

          The package name of the application where registration tokens must match in order for the
          recipient to receive the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or supporting phone home
          functionality.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of the
          push notification.

        - **Sound** *(string) --*

          The sound to play when the recipient receives the push notification. You can use the
          default stream or specify the file name of a sound resource that's bundled in your app. On
          an Android platform, the sound file must reside in /res/raw/.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **TimeToLive** *(integer) --*

          The amount of time, in seconds, that FCM should store and attempt to deliver the push
          notification, if the service is unable to deliver the notification the first time. If you
          don't specify this value, FCM defaults to the maximum value, which is 2,419,200 seconds
          (28 days).

          Amazon Pinpoint specifies this value in the FCM time_to_live parameter when it sends the
          notification message to FCM.

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The default message for the SMS channel. This message overrides the default message
        (DefaultMessage).

        - **Body** *(string) --*

          The body of the SMS message.

        - **Keyword** *(string) --*

          The SMS program name that you provided to AWS Support when you requested your dedicated
          number.

        - **MessageType** *(string) --*

          The SMS message type. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message is not critical or time-sensitive, such as a marketing message.

        - **OriginationNumber** *(string) --*

          The number to send the SMS message from. This value should be one of the dedicated long or
          short codes that's assigned to your AWS account. If you don't specify a long or short
          code, Amazon Pinpoint assigns a random long code to the SMS message and sends the message
          from that code.

        - **SenderId** *(string) --*

          The sender ID to display as the sender of the message on a recipient's device. Support for
          sender IDs varies by country or region.

        - **Substitutions** *(dict) --*

          The message variables to use in the SMS message. You can override the default variables
          with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

      - **VoiceMessage** *(dict) --*

        The default message for the voice channel. This message overrides the default message
        (DefaultMessage).

        - **Body** *(string) --*

          The text of the script to use for the voice message.

        - **LanguageCode** *(string) --*

          The code for the language to use when synthesizing the text of the message script. For a
          list of supported languages and the code for each one, see the `Amazon Polly Developer
          Guide <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

        - **OriginationNumber** *(string) --*

          The long code to send the voice message from. This value should be one of the dedicated
          long codes that's assigned to your AWS account. Although it isn't required, we recommend
          that you specify the long code in E.164 format, for example +12065550100, to ensure prompt
          and accurate delivery of the message.

        - **Substitutions** *(dict) --*

          The default message variables to use in the voice message. You can override the default
          variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **VoiceId** *(string) --*

          The name of the voice to use when delivering the message. For a list of supported voices,
          see the `Amazon Polly Developer Guide
          <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the message.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TraceId** *(string) --*

      The unique identifier for tracing the message. This identifier is visible to message
      recipients.
    """


_ClientSendMessagesResponseMessageResponseEndpointResultTypeDef = TypedDict(
    "_ClientSendMessagesResponseMessageResponseEndpointResultTypeDef",
    {
        "Address": str,
        "DeliveryStatus": str,
        "MessageId": str,
        "StatusCode": int,
        "StatusMessage": str,
        "UpdatedToken": str,
    },
    total=False,
)


class ClientSendMessagesResponseMessageResponseEndpointResultTypeDef(
    _ClientSendMessagesResponseMessageResponseEndpointResultTypeDef
):
    """
    Type definition for `ClientSendMessagesResponseMessageResponse` `EndpointResult`

    Provides information about the delivery status and results of sending a message directly to an
    endpoint.

    - **Address** *(string) --*

      The endpoint address that the message was delivered to.

    - **DeliveryStatus** *(string) --*

      The delivery status of the message. Possible values are:

      * DUPLICATE - The endpoint address is a duplicate of another endpoint address. Amazon Pinpoint
      won't attempt to send the message again.

      * OPT_OUT - The user who's associated with the endpoint has opted out of receiving messages
      from you. Amazon Pinpoint won't attempt to send the message again.

      * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint. Amazon
      Pinpoint won't attempt to send the message again.

      * SUCCESSFUL - The message was successfully delivered to the endpoint.

      * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to deliver the
      message again later.

      * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the endpoint.

      * TIMEOUT - The message couldn't be sent within the timeout period.

      * UNKNOWN_FAILURE - An unknown error occurred.

    - **MessageId** *(string) --*

      The unique identifier for the message that was sent.

    - **StatusCode** *(integer) --*

      The downstream service status code for delivering the message.

    - **StatusMessage** *(string) --*

      The status message for delivering the message.

    - **UpdatedToken** *(string) --*

      For push notifications that are sent through the GCM channel, specifies whether the endpoint's
      device registration token was updated as part of delivering the message.
    """


_ClientSendMessagesResponseMessageResponseResultTypeDef = TypedDict(
    "_ClientSendMessagesResponseMessageResponseResultTypeDef",
    {
        "DeliveryStatus": str,
        "MessageId": str,
        "StatusCode": int,
        "StatusMessage": str,
        "UpdatedToken": str,
    },
    total=False,
)


class ClientSendMessagesResponseMessageResponseResultTypeDef(
    _ClientSendMessagesResponseMessageResponseResultTypeDef
):
    """
    Type definition for `ClientSendMessagesResponseMessageResponse` `Result`

    Provides information about the results of sending a message directly to an endpoint address.

    - **DeliveryStatus** *(string) --*

      The delivery status of the message. Possible values are:

      * DUPLICATE - The endpoint address is a duplicate of another endpoint address. Amazon Pinpoint
      won't attempt to send the message again.

      * OPT_OUT - The user who's associated with the endpoint address has opted out of receiving
      messages from you. Amazon Pinpoint won't attempt to send the message again.

      * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint address.
      Amazon Pinpoint won't attempt to send the message again.

      * SUCCESSFUL - The message was successfully delivered to the endpoint address.

      * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to deliver the
      message again later.

      * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the endpoint
      address.

      * TIMEOUT - The message couldn't be sent within the timeout period.

      * UNKNOWN_FAILURE - An unknown error occurred.

    - **MessageId** *(string) --*

      The unique identifier for the message that was sent.

    - **StatusCode** *(integer) --*

      The downstream service status code for delivering the message.

    - **StatusMessage** *(string) --*

      The status message for delivering the message.

    - **UpdatedToken** *(string) --*

      For push notifications that are sent through the GCM channel, specifies whether the endpoint's
      device registration token was updated as part of delivering the message.
    """


_ClientSendMessagesResponseMessageResponseTypeDef = TypedDict(
    "_ClientSendMessagesResponseMessageResponseTypeDef",
    {
        "ApplicationId": str,
        "EndpointResult": Dict[str, ClientSendMessagesResponseMessageResponseEndpointResultTypeDef],
        "RequestId": str,
        "Result": Dict[str, ClientSendMessagesResponseMessageResponseResultTypeDef],
    },
    total=False,
)


class ClientSendMessagesResponseMessageResponseTypeDef(
    _ClientSendMessagesResponseMessageResponseTypeDef
):
    """
    Type definition for `ClientSendMessagesResponse` `MessageResponse`

    Provides information about the results of a request to send a message to an endpoint address.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that was used to send the message.

    - **EndpointResult** *(dict) --*

      A map that contains a multipart response for each address that the message was sent to. In the
      map, the endpoint ID is the key and the result is the value.

      - *(string) --*

        - *(dict) --*

          Provides information about the delivery status and results of sending a message directly
          to an endpoint.

          - **Address** *(string) --*

            The endpoint address that the message was delivered to.

          - **DeliveryStatus** *(string) --*

            The delivery status of the message. Possible values are:

            * DUPLICATE - The endpoint address is a duplicate of another endpoint address. Amazon
            Pinpoint won't attempt to send the message again.

            * OPT_OUT - The user who's associated with the endpoint has opted out of receiving
            messages from you. Amazon Pinpoint won't attempt to send the message again.

            * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint.
            Amazon Pinpoint won't attempt to send the message again.

            * SUCCESSFUL - The message was successfully delivered to the endpoint.

            * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to
            deliver the message again later.

            * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the
            endpoint.

            * TIMEOUT - The message couldn't be sent within the timeout period.

            * UNKNOWN_FAILURE - An unknown error occurred.

          - **MessageId** *(string) --*

            The unique identifier for the message that was sent.

          - **StatusCode** *(integer) --*

            The downstream service status code for delivering the message.

          - **StatusMessage** *(string) --*

            The status message for delivering the message.

          - **UpdatedToken** *(string) --*

            For push notifications that are sent through the GCM channel, specifies whether the
            endpoint's device registration token was updated as part of delivering the message.

    - **RequestId** *(string) --*

      The identifier for the original request that the message was delivered for.

    - **Result** *(dict) --*

      A map that contains a multipart response for each address (email address, phone number, or
      push notification token) that the message was sent to. In the map, the address is the key and
      the result is the value.

      - *(string) --*

        - *(dict) --*

          Provides information about the results of sending a message directly to an endpoint
          address.

          - **DeliveryStatus** *(string) --*

            The delivery status of the message. Possible values are:

            * DUPLICATE - The endpoint address is a duplicate of another endpoint address. Amazon
            Pinpoint won't attempt to send the message again.

            * OPT_OUT - The user who's associated with the endpoint address has opted out of
            receiving messages from you. Amazon Pinpoint won't attempt to send the message again.

            * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint
            address. Amazon Pinpoint won't attempt to send the message again.

            * SUCCESSFUL - The message was successfully delivered to the endpoint address.

            * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to
            deliver the message again later.

            * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the
            endpoint address.

            * TIMEOUT - The message couldn't be sent within the timeout period.

            * UNKNOWN_FAILURE - An unknown error occurred.

          - **MessageId** *(string) --*

            The unique identifier for the message that was sent.

          - **StatusCode** *(integer) --*

            The downstream service status code for delivering the message.

          - **StatusMessage** *(string) --*

            The status message for delivering the message.

          - **UpdatedToken** *(string) --*

            For push notifications that are sent through the GCM channel, specifies whether the
            endpoint's device registration token was updated as part of delivering the message.
    """


_ClientSendMessagesResponseTypeDef = TypedDict(
    "_ClientSendMessagesResponseTypeDef",
    {"MessageResponse": ClientSendMessagesResponseMessageResponseTypeDef},
    total=False,
)


class ClientSendMessagesResponseTypeDef(_ClientSendMessagesResponseTypeDef):
    """
    Type definition for `ClientSendMessages` `Response`

    The request succeeded.

    - **MessageResponse** *(dict) --*

      Provides information about the results of a request to send a message to an endpoint address.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that was used to send the message.

      - **EndpointResult** *(dict) --*

        A map that contains a multipart response for each address that the message was sent to. In
        the map, the endpoint ID is the key and the result is the value.

        - *(string) --*

          - *(dict) --*

            Provides information about the delivery status and results of sending a message directly
            to an endpoint.

            - **Address** *(string) --*

              The endpoint address that the message was delivered to.

            - **DeliveryStatus** *(string) --*

              The delivery status of the message. Possible values are:

              * DUPLICATE - The endpoint address is a duplicate of another endpoint address. Amazon
              Pinpoint won't attempt to send the message again.

              * OPT_OUT - The user who's associated with the endpoint has opted out of receiving
              messages from you. Amazon Pinpoint won't attempt to send the message again.

              * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint.
              Amazon Pinpoint won't attempt to send the message again.

              * SUCCESSFUL - The message was successfully delivered to the endpoint.

              * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to
              deliver the message again later.

              * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the
              endpoint.

              * TIMEOUT - The message couldn't be sent within the timeout period.

              * UNKNOWN_FAILURE - An unknown error occurred.

            - **MessageId** *(string) --*

              The unique identifier for the message that was sent.

            - **StatusCode** *(integer) --*

              The downstream service status code for delivering the message.

            - **StatusMessage** *(string) --*

              The status message for delivering the message.

            - **UpdatedToken** *(string) --*

              For push notifications that are sent through the GCM channel, specifies whether the
              endpoint's device registration token was updated as part of delivering the message.

      - **RequestId** *(string) --*

        The identifier for the original request that the message was delivered for.

      - **Result** *(dict) --*

        A map that contains a multipart response for each address (email address, phone number, or
        push notification token) that the message was sent to. In the map, the address is the key
        and the result is the value.

        - *(string) --*

          - *(dict) --*

            Provides information about the results of sending a message directly to an endpoint
            address.

            - **DeliveryStatus** *(string) --*

              The delivery status of the message. Possible values are:

              * DUPLICATE - The endpoint address is a duplicate of another endpoint address. Amazon
              Pinpoint won't attempt to send the message again.

              * OPT_OUT - The user who's associated with the endpoint address has opted out of
              receiving messages from you. Amazon Pinpoint won't attempt to send the message again.

              * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint
              address. Amazon Pinpoint won't attempt to send the message again.

              * SUCCESSFUL - The message was successfully delivered to the endpoint address.

              * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to
              deliver the message again later.

              * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the
              endpoint address.

              * TIMEOUT - The message couldn't be sent within the timeout period.

              * UNKNOWN_FAILURE - An unknown error occurred.

            - **MessageId** *(string) --*

              The unique identifier for the message that was sent.

            - **StatusCode** *(integer) --*

              The downstream service status code for delivering the message.

            - **StatusMessage** *(string) --*

              The status message for delivering the message.

            - **UpdatedToken** *(string) --*

              For push notifications that are sent through the GCM channel, specifies whether the
              endpoint's device registration token was updated as part of delivering the message.
    """


_ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef = TypedDict(
    "_ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef",
    {
        "Address": str,
        "DeliveryStatus": str,
        "MessageId": str,
        "StatusCode": int,
        "StatusMessage": str,
        "UpdatedToken": str,
    },
    total=False,
)


class ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef(
    _ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesResponseSendUsersMessageResponse` `Result`

    Provides information about the delivery status and results of sending a message directly to an
    endpoint.

    - **Address** *(string) --*

      The endpoint address that the message was delivered to.

    - **DeliveryStatus** *(string) --*

      The delivery status of the message. Possible values are:

      * DUPLICATE - The endpoint address is a duplicate of another endpoint address. Amazon Pinpoint
      won't attempt to send the message again.

      * OPT_OUT - The user who's associated with the endpoint has opted out of receiving messages
      from you. Amazon Pinpoint won't attempt to send the message again.

      * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint. Amazon
      Pinpoint won't attempt to send the message again.

      * SUCCESSFUL - The message was successfully delivered to the endpoint.

      * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to deliver the
      message again later.

      * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the endpoint.

      * TIMEOUT - The message couldn't be sent within the timeout period.

      * UNKNOWN_FAILURE - An unknown error occurred.

    - **MessageId** *(string) --*

      The unique identifier for the message that was sent.

    - **StatusCode** *(integer) --*

      The downstream service status code for delivering the message.

    - **StatusMessage** *(string) --*

      The status message for delivering the message.

    - **UpdatedToken** *(string) --*

      For push notifications that are sent through the GCM channel, specifies whether the endpoint's
      device registration token was updated as part of delivering the message.
    """


_ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef = TypedDict(
    "_ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef",
    {
        "ApplicationId": str,
        "RequestId": str,
        "Result": Dict[
            str, Dict[str, ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef]
        ],
    },
    total=False,
)


class ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef(
    _ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesResponse` `SendUsersMessageResponse`

    Provides information about which users and endpoints a message was sent to.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that was used to send the message.

    - **RequestId** *(string) --*

      The unique identifier that was assigned to the message request.

    - **Result** *(dict) --*

      An object that indicates which endpoints the message was sent to, for each user. The object
      lists user IDs and, for each user ID, provides the endpoint IDs that the message was sent to.
      For each endpoint ID, it provides an EndpointMessageResult object.

      - *(string) --*

        - *(dict) --*

          - *(string) --*

            - *(dict) --*

              Provides information about the delivery status and results of sending a message
              directly to an endpoint.

              - **Address** *(string) --*

                The endpoint address that the message was delivered to.

              - **DeliveryStatus** *(string) --*

                The delivery status of the message. Possible values are:

                * DUPLICATE - The endpoint address is a duplicate of another endpoint address.
                Amazon Pinpoint won't attempt to send the message again.

                * OPT_OUT - The user who's associated with the endpoint has opted out of receiving
                messages from you. Amazon Pinpoint won't attempt to send the message again.

                * PERMANENT_FAILURE - An error occurred when delivering the message to the endpoint.
                Amazon Pinpoint won't attempt to send the message again.

                * SUCCESSFUL - The message was successfully delivered to the endpoint.

                * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to
                deliver the message again later.

                * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the
                endpoint.

                * TIMEOUT - The message couldn't be sent within the timeout period.

                * UNKNOWN_FAILURE - An unknown error occurred.

              - **MessageId** *(string) --*

                The unique identifier for the message that was sent.

              - **StatusCode** *(integer) --*

                The downstream service status code for delivering the message.

              - **StatusMessage** *(string) --*

                The status message for delivering the message.

              - **UpdatedToken** *(string) --*

                For push notifications that are sent through the GCM channel, specifies whether the
                endpoint's device registration token was updated as part of delivering the message.
    """


_ClientSendUsersMessagesResponseTypeDef = TypedDict(
    "_ClientSendUsersMessagesResponseTypeDef",
    {"SendUsersMessageResponse": ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef},
    total=False,
)


class ClientSendUsersMessagesResponseTypeDef(_ClientSendUsersMessagesResponseTypeDef):
    """
    Type definition for `ClientSendUsersMessages` `Response`

    The request succeeded.

    - **SendUsersMessageResponse** *(dict) --*

      Provides information about which users and endpoints a message was sent to.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that was used to send the message.

      - **RequestId** *(string) --*

        The unique identifier that was assigned to the message request.

      - **Result** *(dict) --*

        An object that indicates which endpoints the message was sent to, for each user. The object
        lists user IDs and, for each user ID, provides the endpoint IDs that the message was sent
        to. For each endpoint ID, it provides an EndpointMessageResult object.

        - *(string) --*

          - *(dict) --*

            - *(string) --*

              - *(dict) --*

                Provides information about the delivery status and results of sending a message
                directly to an endpoint.

                - **Address** *(string) --*

                  The endpoint address that the message was delivered to.

                - **DeliveryStatus** *(string) --*

                  The delivery status of the message. Possible values are:

                  * DUPLICATE - The endpoint address is a duplicate of another endpoint address.
                  Amazon Pinpoint won't attempt to send the message again.

                  * OPT_OUT - The user who's associated with the endpoint has opted out of receiving
                  messages from you. Amazon Pinpoint won't attempt to send the message again.

                  * PERMANENT_FAILURE - An error occurred when delivering the message to the
                  endpoint. Amazon Pinpoint won't attempt to send the message again.

                  * SUCCESSFUL - The message was successfully delivered to the endpoint.

                  * TEMPORARY_FAILURE - A temporary error occurred. Amazon Pinpoint will attempt to
                  deliver the message again later.

                  * THROTTLED - Amazon Pinpoint throttled the operation to send the message to the
                  endpoint.

                  * TIMEOUT - The message couldn't be sent within the timeout period.

                  * UNKNOWN_FAILURE - An unknown error occurred.

                - **MessageId** *(string) --*

                  The unique identifier for the message that was sent.

                - **StatusCode** *(integer) --*

                  The downstream service status code for delivering the message.

                - **StatusMessage** *(string) --*

                  The status message for delivering the message.

                - **UpdatedToken** *(string) --*

                  For push notifications that are sent through the GCM channel, specifies whether
                  the endpoint's device registration token was updated as part of delivering the
                  message.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ConsolidationKey": str,
        "Data": Dict[str, str],
        "ExpiresAfter": str,
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "MD5": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `ADMMessage`

    The default push notification message for the ADM (Amazon Device Messaging) channel. This
    message overrides the default push notification message (DefaultPushNotificationMessage).

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message.

    - **ConsolidationKey** *(string) --*

      An arbitrary string that indicates that multiple messages are logically the same and that
      Amazon Device Messaging (ADM) can drop previously enqueued messages in favor of this message.

    - **Data** *(dict) --*

      The JSON data payload to use for the push notification, if the notification is a silent push
      notification. This payload is added to the data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **ExpiresAfter** *(string) --*

      The amount of time, in seconds, that ADM should store the message if the recipient's device is
      offline. Amazon Pinpoint specifies this value in the expiresAfter parameter when it sends the
      notification message to ADM.

    - **IconReference** *(string) --*

      The icon image name of the asset saved in your app.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of the push notification.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **MD5** *(string) --*

      The base64-encoded, MD5 checksum of the value specified by the Data property. ADM uses the MD5
      value to verify the integrity of the data.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration or supporting phone home functionality.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of the push
      notification.

    - **Sound** *(string) --*

      The sound to play when the recipient receives the push notification. You can use the default
      stream or specify the file name of a sound resource that's bundled in your app. On an Android
      platform, the sound file must reside in /res/raw/.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "APNSPushType": str,
        "Action": str,
        "Badge": int,
        "Body": str,
        "Category": str,
        "CollapseId": str,
        "Data": Dict[str, str],
        "MediaUrl": str,
        "PreferredAuthenticationMethod": str,
        "Priority": str,
        "RawContent": str,
        "SilentPush": bool,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "ThreadId": str,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `APNSMessage`

    The default push notification message for the APNs (Apple Push Notification service) channel.
    This message overrides the default push notification message (DefaultPushNotificationMessage).

    - **APNSPushType** *(string) --*

      The type of push notification to send. Valid values are:

      * alert - For a standard notification that's displayed on recipients' devices and prompts a
      recipient to interact with the notification.

      * background - For a silent notification that delivers content in the background and isn't
      displayed on recipients' devices.

      * complication - For a notification that contains update information for an app’s complication
      timeline.

      * fileprovider - For a notification that signals changes to a File Provider extension.

      * mdm - For a notification that tells managed devices to contact the MDM server.

      * voip - For a notification that provides information about an incoming VoIP call.

      Amazon Pinpoint specifies this value in the apns-push-type request header when it sends the
      notification message to APNs. If you don't specify a value for this property, Amazon Pinpoint
      sets the value to alert or background automatically, based on the value that you specify for
      the SilentPush or RawContent property of the message.

      For more information about the apns-push-type request header, see `Sending Notification
      Requests to APNs
      <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/sending_notification_requests_to_apns>`__
      on the Apple Developer website.

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Badge** *(integer) --*

      The key that indicates whether and how to modify the badge of your app's icon when the
      recipient receives the push notification. If this key isn't included in the dictionary, the
      badge doesn't change. To remove the badge, set this value to 0.

    - **Body** *(string) --*

      The body of the notification message.

    - **Category** *(string) --*

      The key that indicates the notification type for the push notification. This key is a value
      that's defined by the identifier property of one of your app's registered categories.

    - **CollapseId** *(string) --*

      An arbitrary identifier that, if assigned to multiple messages, APNs uses to coalesce the
      messages into a single push notification instead of delivering each message individually. This
      value can't exceed 64 bytes.

      Amazon Pinpoint specifies this value in the apns-collapse-id request header when it sends the
      notification message to APNs.

    - **Data** *(dict) --*

      The JSON payload to use for a silent push notification. This payload is added to the
      data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **MediaUrl** *(string) --*

      The URL of an image or video to display in the push notification.

    - **PreferredAuthenticationMethod** *(string) --*

      The authentication method that you want Amazon Pinpoint to use when authenticating with APNs,
      CERTIFICATE or TOKEN.

    - **Priority** *(string) --*

      para>5 - Low priority, the notification might be delayed, delivered as part of a group, or
      throttled.

      /listitem>
      * 10 - High priority, the notification is sent immediately. This is the default value. A high
      priority notification should trigger an alert, play a sound, or badge your app's icon on the
      recipient's device.
      /para>

      Amazon Pinpoint specifies this value in the apns-priority request header when it sends the
      notification message to APNs.

      The equivalent values for Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
      (GCM), are normal, for 5, and high, for 10. If you specify an FCM value for this property,
      Amazon Pinpoint accepts and converts the value to the corresponding APNs value.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

      .. note::

        If you specify the raw content of an APNs push notification, the message payload has to
        include the content-available key. The value of the content-available key has to be an
        integer, and can only be 0 or 1. If you're sending a standard notification, set the value of
        content-available to 0. If you're sending a silent (background) notification, set the value
        of content-available to 1. Additionally, silent notification payloads can't include the
        alert, badge, or sound keys. For more information, see `Generating a Remote Notification
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
        and `Pushing Background Updates to Your App
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
        on the Apple Developer website.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification. A silent (or background)
      push notification isn't displayed on recipients' devices. You can use silent push
      notifications to make small updates to your app, or to display messages in an in-app message
      center.

      Amazon Pinpoint uses this property to determine the correct value for the apns-push-type
      request header when it sends the notification message to APNs. If you specify a value of true
      for this property, Amazon Pinpoint sets the value for the apns-push-type header field to
      background.

      .. note::

        If you specify the raw content of an APNs push notification, the message payload has to
        include the content-available key. For silent (background) notifications, set the value of
        content-available to 1. Additionally, the message payload for a silent notification can't
        include the alert, badge, or sound keys. For more information, see `Generating a Remote
        Notification
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
        and `Pushing Background Updates to Your App
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
        on the Apple Developer website.

        Apple has indicated that they will throttle "excessive" background notifications based on
        current traffic volumes. To prevent your notifications being throttled, Apple recommends
        that you send no more than 3 silent push notifications to each recipient per hour.

    - **Sound** *(string) --*

      The key for the sound to play when the recipient receives the push notification. The value for
      this key is the name of a sound file in your app's main bundle or the Library/Sounds folder in
      your app's data container. If the sound file can't be found or you specify default for the
      value, the system plays the default alert sound.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override these
      default variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ThreadId** *(string) --*

      The key that represents your app-specific identifier for grouping notifications. If you
      provide a Notification Content app extension, you can use this value to group your
      notifications together.

    - **TimeToLive** *(integer) --*

      The amount of time, in seconds, that APNs should store and attempt to deliver the push
      notification, if the service is unable to deliver the notification the first time. If this
      value is 0, APNs treats the notification as if it expires immediately and the service doesn't
      store or try to deliver the notification again.

      Amazon Pinpoint specifies this value in the apns-expiration request header when it sends the
      notification message to APNs.

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `BaiduMessage`

    The default push notification message for the Baidu (Baidu Cloud Push) channel. This message
    overrides the default push notification message (DefaultPushNotificationMessage).

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message.

    - **Data** *(dict) --*

      The JSON data payload to use for the push notification, if the notification is a silent push
      notification. This payload is added to the data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **IconReference** *(string) --*

      The icon image name of the asset saved in your app.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of the push notification.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration or supporting phone home functionality.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of the push
      notification.

    - **Sound** *(string) --*

      The sound to play when the recipient receives the push notification. You can use the default
      stream or specify the file name of a sound resource that's bundled in your app. On an Android
      platform, the sound file must reside in /res/raw/.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **TimeToLive** *(integer) --*

      The amount of time, in seconds, that the Baidu Cloud Push service should store the message if
      the recipient's device is offline. The default value and maximum supported time is 604,800
      seconds (7 days).

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef",
    {"Body": str, "Substitutions": Dict[str, List[str]]},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `DefaultMessage`

    The default message for all channels.

    - **Body** *(string) --*

      The default body of the message.

    - **Substitutions** *(dict) --*

      The default message variables to use in the message. You can override these default variables
      with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "Data": Dict[str, str],
        "SilentPush": bool,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `DefaultPushNotificationMessage`

    The default push notification message for all push notification channels.

    - **Action** *(string) --*

      The default action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS and Android platforms.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The default body of the notification message.

    - **Data** *(dict) --*

      The JSON data payload to use for the default push notification, if the notification is a
      silent push notification. This payload is added to the data.pinpoint.jsonBody object of the
      notification.

      - *(string) --*

        - *(string) --*

    - **SilentPush** *(boolean) --*

      Specifies whether the default notification is a silent push notification, which is a push
      notification that doesn't display on a recipient's device. Silent push notifications can be
      used for cases such as updating an app's configuration or delivering messages to an in-app
      notification center.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **Title** *(string) --*

      The default title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The default URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    {"Data": bytes},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef
):
    """
    Type definition for
    `ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessage` `RawEmail`

    The email message, represented as a raw MIME message.

    - **Data** *(bytes) --*

      The email message, represented as a raw MIME message. The entire message must be base64
      encoded.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef
):
    """
    Type definition for
    `ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmail`
    `HtmlPart`

    The body of the email message, in HTML format. We recommend using HTML format for email clients
    that render HTML content. You can include links, formatted text, and more in an HTML message.

    - **Charset** *(string) --*

      The applicable character set for the message content.

    - **Data** *(string) --*

      The textual data of the message content.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef
):
    """
    Type definition for
    `ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmail`
    `Subject`

    The subject line, or title, of the email.

    - **Charset** *(string) --*

      The applicable character set for the message content.

    - **Data** *(string) --*

      The textual data of the message content.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef
):
    """
    Type definition for
    `ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmail`
    `TextPart`

    The body of the email message, in plain text format. We recommend using plain text format for
    email clients that don't render HTML content and clients that are connected to high-latency
    networks, such as mobile devices.

    - **Charset** *(string) --*

      The applicable character set for the message content.

    - **Data** *(string) --*

      The textual data of the message content.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    {
        "HtmlPart": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef,
        "Subject": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef,
        "TextPart": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef
):
    """
    Type definition for
    `ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessage` `SimpleEmail`

    The email message, composed of a subject, a text part, and an HTML part.

    - **HtmlPart** *(dict) --*

      The body of the email message, in HTML format. We recommend using HTML format for email
      clients that render HTML content. You can include links, formatted text, and more in an HTML
      message.

      - **Charset** *(string) --*

        The applicable character set for the message content.

      - **Data** *(string) --*

        The textual data of the message content.

    - **Subject** *(dict) --*

      The subject line, or title, of the email.

      - **Charset** *(string) --*

        The applicable character set for the message content.

      - **Data** *(string) --*

        The textual data of the message content.

    - **TextPart** *(dict) --*

      The body of the email message, in plain text format. We recommend using plain text format for
      email clients that don't render HTML content and clients that are connected to high-latency
      networks, such as mobile devices.

      - **Charset** *(string) --*

        The applicable character set for the message content.

      - **Data** *(string) --*

        The textual data of the message content.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef",
    {
        "Body": str,
        "FeedbackForwardingAddress": str,
        "FromAddress": str,
        "RawEmail": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef,
        "ReplyToAddresses": List[str],
        "SimpleEmail": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `EmailMessage`

    The default message for the email channel. This message overrides the default message
    (DefaultMessage).

    - **Body** *(string) --*

      The body of the email message.

    - **FeedbackForwardingAddress** *(string) --*

      The email address to forward bounces and complaints to, if feedback forwarding is enabled.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default value is the
      FromAddress specified for the email channel.

    - **RawEmail** *(dict) --*

      The email message, represented as a raw MIME message.

      - **Data** *(bytes) --*

        The email message, represented as a raw MIME message. The entire message must be base64
        encoded.

    - **ReplyToAddresses** *(list) --*

      The reply-to email address(es) for the email message. If a recipient replies to the email,
      each reply-to address receives the reply.

      - *(string) --*

    - **SimpleEmail** *(dict) --*

      The email message, composed of a subject, a text part, and an HTML part.

      - **HtmlPart** *(dict) --*

        The body of the email message, in HTML format. We recommend using HTML format for email
        clients that render HTML content. You can include links, formatted text, and more in an HTML
        message.

        - **Charset** *(string) --*

          The applicable character set for the message content.

        - **Data** *(string) --*

          The textual data of the message content.

      - **Subject** *(dict) --*

        The subject line, or title, of the email.

        - **Charset** *(string) --*

          The applicable character set for the message content.

        - **Data** *(string) --*

          The textual data of the message content.

      - **TextPart** *(dict) --*

        The body of the email message, in plain text format. We recommend using plain text format
        for email clients that don't render HTML content and clients that are connected to
        high-latency networks, such as mobile devices.

        - **Charset** *(string) --*

          The applicable character set for the message content.

        - **Data** *(string) --*

          The textual data of the message content.

    - **Substitutions** *(dict) --*

      The default message variables to use in the email message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "CollapseKey": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "Priority": str,
        "RawContent": str,
        "RestrictedPackageName": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `GCMMessage`

    The default push notification message for the GCM channel, which is used to send notifications
    through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service. This
    message overrides the default push notification message (DefaultPushNotificationMessage).

    - **Action** *(string) --*

      The action to occur if the recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message.

    - **CollapseKey** *(string) --*

      An arbitrary string that identifies a group of messages that can be collapsed to ensure that
      only the last message is sent when delivery can resume. This helps avoid sending too many
      instances of the same messages when the recipient's device comes online again or becomes
      active.

      Amazon Pinpoint specifies this value in the Firebase Cloud Messaging (FCM) collapse_key
      parameter when it sends the notification message to FCM.

    - **Data** *(dict) --*

      The JSON data payload to use for the push notification, if the notification is a silent push
      notification. This payload is added to the data.pinpoint.jsonBody object of the notification.

      - *(string) --*

        - *(string) --*

    - **IconReference** *(string) --*

      The icon image name of the asset saved in your app.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of the push notification.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **Priority** *(string) --*

      para>normal - The notification might be delayed. Delivery is optimized for battery usage on
      the recipient's device. Use this value unless immediate delivery is required.

      /listitem>
      * high - The notification is sent immediately and might wake a sleeping device.
      /para>

      Amazon Pinpoint specifies this value in the FCM priority parameter when it sends the
      notification message to FCM.

      The equivalent values for Apple Push Notification service (APNs) are 5, for normal, and 10,
      for high. If you specify an APNs value for this property, Amazon Pinpoint accepts and converts
      the value to the corresponding FCM value.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **RestrictedPackageName** *(string) --*

      The package name of the application where registration tokens must match in order for the
      recipient to receive the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration or supporting phone home functionality.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of the push
      notification.

    - **Sound** *(string) --*

      The sound to play when the recipient receives the push notification. You can use the default
      stream or specify the file name of a sound resource that's bundled in your app. On an Android
      platform, the sound file must reside in /res/raw/.

    - **Substitutions** *(dict) --*

      The default message variables to use in the notification message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **TimeToLive** *(integer) --*

      The amount of time, in seconds, that FCM should store and attempt to deliver the push
      notification, if the service is unable to deliver the notification the first time. If you
      don't specify this value, FCM defaults to the maximum value, which is 2,419,200 seconds (28
      days).

      Amazon Pinpoint specifies this value in the FCM time_to_live parameter when it sends the
      notification message to FCM.

    - **Title** *(string) --*

      The title to display above the notification message on the recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef",
    {
        "Body": str,
        "Keyword": str,
        "MessageType": str,
        "OriginationNumber": str,
        "SenderId": str,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `SMSMessage`

    The default message for the SMS channel. This message overrides the default message
    (DefaultMessage).

    - **Body** *(string) --*

      The body of the SMS message.

    - **Keyword** *(string) --*

      The SMS program name that you provided to AWS Support when you requested your dedicated
      number.

    - **MessageType** *(string) --*

      The SMS message type. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message is not critical or time-sensitive, such as a marketing message.

    - **OriginationNumber** *(string) --*

      The number to send the SMS message from. This value should be one of the dedicated long or
      short codes that's assigned to your AWS account. If you don't specify a long or short code,
      Amazon Pinpoint assigns a random long code to the SMS message and sends the message from that
      code.

    - **SenderId** *(string) --*

      The sender ID to display as the sender of the message on a recipient's device. Support for
      sender IDs varies by country or region.

    - **Substitutions** *(dict) --*

      The message variables to use in the SMS message. You can override the default variables with
      individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef",
    {
        "Body": str,
        "LanguageCode": str,
        "OriginationNumber": str,
        "Substitutions": Dict[str, List[str]],
        "VoiceId": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestMessageConfiguration`
    `VoiceMessage`

    The default message for the voice channel. This message overrides the default message
    (DefaultMessage).

    - **Body** *(string) --*

      The text of the script to use for the voice message.

    - **LanguageCode** *(string) --*

      The code for the language to use when synthesizing the text of the message script. For a list
      of supported languages and the code for each one, see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

    - **OriginationNumber** *(string) --*

      The long code to send the voice message from. This value should be one of the dedicated long
      codes that's assigned to your AWS account. Although it isn't required, we recommend that you
      specify the long code in E.164 format, for example +12065550100, to ensure prompt and accurate
      delivery of the message.

    - **Substitutions** *(dict) --*

      The default message variables to use in the voice message. You can override the default
      variables with individual address variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **VoiceId** *(string) --*

      The name of the voice to use when delivering the message. For a list of supported voices, see
      the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef,
        "DefaultPushNotificationMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef,
        "EmailMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef,
        "VoiceMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequest` `MessageConfiguration`

    The settings and content for the default message and any default messages that you defined for
    specific channels.

    - **ADMMessage** *(dict) --*

      The default push notification message for the ADM (Amazon Device Messaging) channel. This
      message overrides the default push notification message (DefaultPushNotificationMessage).

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message.

      - **ConsolidationKey** *(string) --*

        An arbitrary string that indicates that multiple messages are logically the same and that
        Amazon Device Messaging (ADM) can drop previously enqueued messages in favor of this
        message.

      - **Data** *(dict) --*

        The JSON data payload to use for the push notification, if the notification is a silent push
        notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **ExpiresAfter** *(string) --*

        The amount of time, in seconds, that ADM should store the message if the recipient's device
        is offline. Amazon Pinpoint specifies this value in the expiresAfter parameter when it sends
        the notification message to ADM.

      - **IconReference** *(string) --*

        The icon image name of the asset saved in your app.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of the push notification.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **MD5** *(string) --*

        The base64-encoded, MD5 checksum of the value specified by the Data property. ADM uses the
        MD5 value to verify the integrity of the data.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or supporting phone home
        functionality.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of the
        push notification.

      - **Sound** *(string) --*

        The sound to play when the recipient receives the push notification. You can use the default
        stream or specify the file name of a sound resource that's bundled in your app. On an
        Android platform, the sound file must reside in /res/raw/.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The default push notification message for the APNs (Apple Push Notification service) channel.
      This message overrides the default push notification message (DefaultPushNotificationMessage).

      - **APNSPushType** *(string) --*

        The type of push notification to send. Valid values are:

        * alert - For a standard notification that's displayed on recipients' devices and prompts a
        recipient to interact with the notification.

        * background - For a silent notification that delivers content in the background and isn't
        displayed on recipients' devices.

        * complication - For a notification that contains update information for an app’s
        complication timeline.

        * fileprovider - For a notification that signals changes to a File Provider extension.

        * mdm - For a notification that tells managed devices to contact the MDM server.

        * voip - For a notification that provides information about an incoming VoIP call.

        Amazon Pinpoint specifies this value in the apns-push-type request header when it sends the
        notification message to APNs. If you don't specify a value for this property, Amazon
        Pinpoint sets the value to alert or background automatically, based on the value that you
        specify for the SilentPush or RawContent property of the message.

        For more information about the apns-push-type request header, see `Sending Notification
        Requests to APNs
        <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/sending_notification_requests_to_apns>`__
        on the Apple Developer website.

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Badge** *(integer) --*

        The key that indicates whether and how to modify the badge of your app's icon when the
        recipient receives the push notification. If this key isn't included in the dictionary, the
        badge doesn't change. To remove the badge, set this value to 0.

      - **Body** *(string) --*

        The body of the notification message.

      - **Category** *(string) --*

        The key that indicates the notification type for the push notification. This key is a value
        that's defined by the identifier property of one of your app's registered categories.

      - **CollapseId** *(string) --*

        An arbitrary identifier that, if assigned to multiple messages, APNs uses to coalesce the
        messages into a single push notification instead of delivering each message individually.
        This value can't exceed 64 bytes.

        Amazon Pinpoint specifies this value in the apns-collapse-id request header when it sends
        the notification message to APNs.

      - **Data** *(dict) --*

        The JSON payload to use for a silent push notification. This payload is added to the
        data.pinpoint.jsonBody object of the notification.

        - *(string) --*

          - *(string) --*

      - **MediaUrl** *(string) --*

        The URL of an image or video to display in the push notification.

      - **PreferredAuthenticationMethod** *(string) --*

        The authentication method that you want Amazon Pinpoint to use when authenticating with
        APNs, CERTIFICATE or TOKEN.

      - **Priority** *(string) --*

        para>5 - Low priority, the notification might be delayed, delivered as part of a group, or
        throttled.

        /listitem>
        * 10 - High priority, the notification is sent immediately. This is the default value. A
        high priority notification should trigger an alert, play a sound, or badge your app's icon
        on the recipient's device.
        /para>

        Amazon Pinpoint specifies this value in the apns-priority request header when it sends the
        notification message to APNs.

        The equivalent values for Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
        (GCM), are normal, for 5, and high, for 10. If you specify an FCM value for this property,
        Amazon Pinpoint accepts and converts the value to the corresponding APNs value.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

        .. note::

          If you specify the raw content of an APNs push notification, the message payload has to
          include the content-available key. The value of the content-available key has to be an
          integer, and can only be 0 or 1. If you're sending a standard notification, set the value
          of content-available to 0. If you're sending a silent (background) notification, set the
          value of content-available to 1. Additionally, silent notification payloads can't include
          the alert, badge, or sound keys. For more information, see `Generating a Remote
          Notification
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
          and `Pushing Background Updates to Your App
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
          on the Apple Developer website.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification. A silent (or background)
        push notification isn't displayed on recipients' devices. You can use silent push
        notifications to make small updates to your app, or to display messages in an in-app message
        center.

        Amazon Pinpoint uses this property to determine the correct value for the apns-push-type
        request header when it sends the notification message to APNs. If you specify a value of
        true for this property, Amazon Pinpoint sets the value for the apns-push-type header field
        to background.

        .. note::

          If you specify the raw content of an APNs push notification, the message payload has to
          include the content-available key. For silent (background) notifications, set the value of
          content-available to 1. Additionally, the message payload for a silent notification can't
          include the alert, badge, or sound keys. For more information, see `Generating a Remote
          Notification
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
          and `Pushing Background Updates to Your App
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
          on the Apple Developer website.

          Apple has indicated that they will throttle "excessive" background notifications based on
          current traffic volumes. To prevent your notifications being throttled, Apple recommends
          that you send no more than 3 silent push notifications to each recipient per hour.

      - **Sound** *(string) --*

        The key for the sound to play when the recipient receives the push notification. The value
        for this key is the name of a sound file in your app's main bundle or the Library/Sounds
        folder in your app's data container. If the sound file can't be found or you specify default
        for the value, the system plays the default alert sound.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override these
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **ThreadId** *(string) --*

        The key that represents your app-specific identifier for grouping notifications. If you
        provide a Notification Content app extension, you can use this value to group your
        notifications together.

      - **TimeToLive** *(integer) --*

        The amount of time, in seconds, that APNs should store and attempt to deliver the push
        notification, if the service is unable to deliver the notification the first time. If this
        value is 0, APNs treats the notification as if it expires immediately and the service
        doesn't store or try to deliver the notification again.

        Amazon Pinpoint specifies this value in the apns-expiration request header when it sends the
        notification message to APNs.

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The default push notification message for the Baidu (Baidu Cloud Push) channel. This message
      overrides the default push notification message (DefaultPushNotificationMessage).

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message.

      - **Data** *(dict) --*

        The JSON data payload to use for the push notification, if the notification is a silent push
        notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **IconReference** *(string) --*

        The icon image name of the asset saved in your app.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of the push notification.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or supporting phone home
        functionality.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of the
        push notification.

      - **Sound** *(string) --*

        The sound to play when the recipient receives the push notification. You can use the default
        stream or specify the file name of a sound resource that's bundled in your app. On an
        Android platform, the sound file must reside in /res/raw/.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **TimeToLive** *(integer) --*

        The amount of time, in seconds, that the Baidu Cloud Push service should store the message
        if the recipient's device is offline. The default value and maximum supported time is
        604,800 seconds (7 days).

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message for all channels.

      - **Body** *(string) --*

        The default body of the message.

      - **Substitutions** *(dict) --*

        The default message variables to use in the message. You can override these default
        variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

    - **DefaultPushNotificationMessage** *(dict) --*

      The default push notification message for all push notification channels.

      - **Action** *(string) --*

        The default action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS and Android platforms.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The default body of the notification message.

      - **Data** *(dict) --*

        The JSON data payload to use for the default push notification, if the notification is a
        silent push notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **SilentPush** *(boolean) --*

        Specifies whether the default notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or delivering messages to an in-app
        notification center.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **Title** *(string) --*

        The default title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The default URL to open in a recipient's default mobile browser, if a recipient taps the
        push notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The default message for the email channel. This message overrides the default message
      (DefaultMessage).

      - **Body** *(string) --*

        The body of the email message.

      - **FeedbackForwardingAddress** *(string) --*

        The email address to forward bounces and complaints to, if feedback forwarding is enabled.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default value is the
        FromAddress specified for the email channel.

      - **RawEmail** *(dict) --*

        The email message, represented as a raw MIME message.

        - **Data** *(bytes) --*

          The email message, represented as a raw MIME message. The entire message must be base64
          encoded.

      - **ReplyToAddresses** *(list) --*

        The reply-to email address(es) for the email message. If a recipient replies to the email,
        each reply-to address receives the reply.

        - *(string) --*

      - **SimpleEmail** *(dict) --*

        The email message, composed of a subject, a text part, and an HTML part.

        - **HtmlPart** *(dict) --*

          The body of the email message, in HTML format. We recommend using HTML format for email
          clients that render HTML content. You can include links, formatted text, and more in an
          HTML message.

          - **Charset** *(string) --*

            The applicable character set for the message content.

          - **Data** *(string) --*

            The textual data of the message content.

        - **Subject** *(dict) --*

          The subject line, or title, of the email.

          - **Charset** *(string) --*

            The applicable character set for the message content.

          - **Data** *(string) --*

            The textual data of the message content.

        - **TextPart** *(dict) --*

          The body of the email message, in plain text format. We recommend using plain text format
          for email clients that don't render HTML content and clients that are connected to
          high-latency networks, such as mobile devices.

          - **Charset** *(string) --*

            The applicable character set for the message content.

          - **Data** *(string) --*

            The textual data of the message content.

      - **Substitutions** *(dict) --*

        The default message variables to use in the email message. You can override the default
        variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

    - **GCMMessage** *(dict) --*

      The default push notification message for the GCM channel, which is used to send notifications
      through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
      This message overrides the default push notification message (DefaultPushNotificationMessage).

      - **Action** *(string) --*

        The action to occur if the recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message.

      - **CollapseKey** *(string) --*

        An arbitrary string that identifies a group of messages that can be collapsed to ensure that
        only the last message is sent when delivery can resume. This helps avoid sending too many
        instances of the same messages when the recipient's device comes online again or becomes
        active.

        Amazon Pinpoint specifies this value in the Firebase Cloud Messaging (FCM) collapse_key
        parameter when it sends the notification message to FCM.

      - **Data** *(dict) --*

        The JSON data payload to use for the push notification, if the notification is a silent push
        notification. This payload is added to the data.pinpoint.jsonBody object of the
        notification.

        - *(string) --*

          - *(string) --*

      - **IconReference** *(string) --*

        The icon image name of the asset saved in your app.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of the push notification.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **Priority** *(string) --*

        para>normal - The notification might be delayed. Delivery is optimized for battery usage on
        the recipient's device. Use this value unless immediate delivery is required.

        /listitem>
        * high - The notification is sent immediately and might wake a sleeping device.
        /para>

        Amazon Pinpoint specifies this value in the FCM priority parameter when it sends the
        notification message to FCM.

        The equivalent values for Apple Push Notification service (APNs) are 5, for normal, and 10,
        for high. If you specify an APNs value for this property, Amazon Pinpoint accepts and
        converts the value to the corresponding FCM value.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **RestrictedPackageName** *(string) --*

        The package name of the application where registration tokens must match in order for the
        recipient to receive the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration or supporting phone home
        functionality.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of the
        push notification.

      - **Sound** *(string) --*

        The sound to play when the recipient receives the push notification. You can use the default
        stream or specify the file name of a sound resource that's bundled in your app. On an
        Android platform, the sound file must reside in /res/raw/.

      - **Substitutions** *(dict) --*

        The default message variables to use in the notification message. You can override the
        default variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **TimeToLive** *(integer) --*

        The amount of time, in seconds, that FCM should store and attempt to deliver the push
        notification, if the service is unable to deliver the notification the first time. If you
        don't specify this value, FCM defaults to the maximum value, which is 2,419,200 seconds (28
        days).

        Amazon Pinpoint specifies this value in the FCM time_to_live parameter when it sends the
        notification message to FCM.

      - **Title** *(string) --*

        The title to display above the notification message on the recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The default message for the SMS channel. This message overrides the default message
      (DefaultMessage).

      - **Body** *(string) --*

        The body of the SMS message.

      - **Keyword** *(string) --*

        The SMS program name that you provided to AWS Support when you requested your dedicated
        number.

      - **MessageType** *(string) --*

        The SMS message type. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message is not critical or time-sensitive, such as a marketing message.

      - **OriginationNumber** *(string) --*

        The number to send the SMS message from. This value should be one of the dedicated long or
        short codes that's assigned to your AWS account. If you don't specify a long or short code,
        Amazon Pinpoint assigns a random long code to the SMS message and sends the message from
        that code.

      - **SenderId** *(string) --*

        The sender ID to display as the sender of the message on a recipient's device. Support for
        sender IDs varies by country or region.

      - **Substitutions** *(dict) --*

        The message variables to use in the SMS message. You can override the default variables with
        individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

    - **VoiceMessage** *(dict) --*

      The default message for the voice channel. This message overrides the default message
      (DefaultMessage).

      - **Body** *(string) --*

        The text of the script to use for the voice message.

      - **LanguageCode** *(string) --*

        The code for the language to use when synthesizing the text of the message script. For a
        list of supported languages and the code for each one, see the `Amazon Polly Developer Guide
        <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

      - **OriginationNumber** *(string) --*

        The long code to send the voice message from. This value should be one of the dedicated long
        codes that's assigned to your AWS account. Although it isn't required, we recommend that you
        specify the long code in E.164 format, for example +12065550100, to ensure prompt and
        accurate delivery of the message.

      - **Substitutions** *(dict) --*

        The default message variables to use in the voice message. You can override the default
        variables with individual address variables.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **VoiceId** *(string) --*

        The name of the voice to use when delivering the message. For a list of supported voices,
        see the `Amazon Polly Developer Guide
        <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequestTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequest` `TemplateConfiguration`

    The message template to use for the message.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef",
    {
        "BodyOverride": str,
        "Context": Dict[str, str],
        "RawContent": str,
        "Substitutions": Dict[str, List[str]],
        "TitleOverride": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef
):
    """
    Type definition for `ClientSendUsersMessagesSendUsersMessageRequest` `Users`

    Specifies the content, including message variables and attributes, to use in a message that's
    sent directly to an endpoint.

    - **BodyOverride** *(string) --*

      The body of the message. If specified, this value overrides the default message body.

    - **Context** *(dict) --*

      A map of custom attributes to attach to the message for the address. For a push notification,
      this payload is added to the data.pinpoint object. For an email or text message, this payload
      is added to email/SMS delivery receipt event attributes.

      - *(string) --*

        - *(string) --*

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the message. If specified, this value
      overrides all other values for the message.

    - **Substitutions** *(dict) --*

      A map of the message variables to merge with the variables specified for the default message
      (DefaultMessage.Substitutions). The variables specified in this map take precedence over all
      other variables.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **TitleOverride** *(string) --*

      The title or subject line of the message. If specified, this value overrides the default
      message title or subject line.
    """


_RequiredClientSendUsersMessagesSendUsersMessageRequestTypeDef = TypedDict(
    "_RequiredClientSendUsersMessagesSendUsersMessageRequestTypeDef",
    {
        "MessageConfiguration": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef,
        "Users": Dict[str, ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef],
    },
)
_OptionalClientSendUsersMessagesSendUsersMessageRequestTypeDef = TypedDict(
    "_OptionalClientSendUsersMessagesSendUsersMessageRequestTypeDef",
    {
        "Context": Dict[str, str],
        "TemplateConfiguration": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef,
        "TraceId": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTypeDef(
    _RequiredClientSendUsersMessagesSendUsersMessageRequestTypeDef,
    _OptionalClientSendUsersMessagesSendUsersMessageRequestTypeDef,
):
    """
    Type definition for `ClientSendUsersMessages` `SendUsersMessageRequest`

    Specifies the configuration and other settings for a message to send to all the endpoints that
    are associated with a list of users.

    - **Context** *(dict) --*

      A map of custom attribute-value pairs. For a push notification, Amazon Pinpoint adds these
      attributes to the data.pinpoint object in the body of the notification payload. Amazon
      Pinpoint also provides these attributes in the events that it generates for users-messages
      deliveries.

      - *(string) --*

        - *(string) --*

    - **MessageConfiguration** *(dict) --* **[REQUIRED]**

      The settings and content for the default message and any default messages that you defined for
      specific channels.

      - **ADMMessage** *(dict) --*

        The default push notification message for the ADM (Amazon Device Messaging) channel. This
        message overrides the default push notification message (DefaultPushNotificationMessage).

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message.

        - **ConsolidationKey** *(string) --*

          An arbitrary string that indicates that multiple messages are logically the same and that
          Amazon Device Messaging (ADM) can drop previously enqueued messages in favor of this
          message.

        - **Data** *(dict) --*

          The JSON data payload to use for the push notification, if the notification is a silent
          push notification. This payload is added to the data.pinpoint.jsonBody object of the
          notification.

          - *(string) --*

            - *(string) --*

        - **ExpiresAfter** *(string) --*

          The amount of time, in seconds, that ADM should store the message if the recipient's
          device is offline. Amazon Pinpoint specifies this value in the expiresAfter parameter when
          it sends the notification message to ADM.

        - **IconReference** *(string) --*

          The icon image name of the asset saved in your app.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of the push notification.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **MD5** *(string) --*

          The base64-encoded, MD5 checksum of the value specified by the Data property. ADM uses the
          MD5 value to verify the integrity of the data.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or supporting phone home
          functionality.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of the
          push notification.

        - **Sound** *(string) --*

          The sound to play when the recipient receives the push notification. You can use the
          default stream or specify the file name of a sound resource that's bundled in your app. On
          an Android platform, the sound file must reside in /res/raw/.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The default push notification message for the APNs (Apple Push Notification service)
        channel. This message overrides the default push notification message
        (DefaultPushNotificationMessage).

        - **APNSPushType** *(string) --*

          The type of push notification to send. Valid values are:

          * alert - For a standard notification that's displayed on recipients' devices and prompts
          a recipient to interact with the notification.

          * background - For a silent notification that delivers content in the background and isn't
          displayed on recipients' devices.

          * complication - For a notification that contains update information for an app’s
          complication timeline.

          * fileprovider - For a notification that signals changes to a File Provider extension.

          * mdm - For a notification that tells managed devices to contact the MDM server.

          * voip - For a notification that provides information about an incoming VoIP call.

          Amazon Pinpoint specifies this value in the apns-push-type request header when it sends
          the notification message to APNs. If you don't specify a value for this property, Amazon
          Pinpoint sets the value to alert or background automatically, based on the value that you
          specify for the SilentPush or RawContent property of the message.

          For more information about the apns-push-type request header, see `Sending Notification
          Requests to APNs
          <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/sending_notification_requests_to_apns>`__
          on the Apple Developer website.

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of the iOS platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Badge** *(integer) --*

          The key that indicates whether and how to modify the badge of your app's icon when the
          recipient receives the push notification. If this key isn't included in the dictionary,
          the badge doesn't change. To remove the badge, set this value to 0.

        - **Body** *(string) --*

          The body of the notification message.

        - **Category** *(string) --*

          The key that indicates the notification type for the push notification. This key is a
          value that's defined by the identifier property of one of your app's registered
          categories.

        - **CollapseId** *(string) --*

          An arbitrary identifier that, if assigned to multiple messages, APNs uses to coalesce the
          messages into a single push notification instead of delivering each message individually.
          This value can't exceed 64 bytes.

          Amazon Pinpoint specifies this value in the apns-collapse-id request header when it sends
          the notification message to APNs.

        - **Data** *(dict) --*

          The JSON payload to use for a silent push notification. This payload is added to the
          data.pinpoint.jsonBody object of the notification.

          - *(string) --*

            - *(string) --*

        - **MediaUrl** *(string) --*

          The URL of an image or video to display in the push notification.

        - **PreferredAuthenticationMethod** *(string) --*

          The authentication method that you want Amazon Pinpoint to use when authenticating with
          APNs, CERTIFICATE or TOKEN.

        - **Priority** *(string) --*

          para>5 - Low priority, the notification might be delayed, delivered as part of a group, or
          throttled.

          /listitem>
          * 10 - High priority, the notification is sent immediately. This is the default value. A
          high priority notification should trigger an alert, play a sound, or badge your app's icon
          on the recipient's device.
          /para>

          Amazon Pinpoint specifies this value in the apns-priority request header when it sends the
          notification message to APNs.

          The equivalent values for Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
          (GCM), are normal, for 5, and high, for 10. If you specify an FCM value for this property,
          Amazon Pinpoint accepts and converts the value to the corresponding APNs value.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

          .. note::

            If you specify the raw content of an APNs push notification, the message payload has to
            include the content-available key. The value of the content-available key has to be an
            integer, and can only be 0 or 1. If you're sending a standard notification, set the
            value of content-available to 0. If you're sending a silent (background) notification,
            set the value of content-available to 1. Additionally, silent notification payloads
            can't include the alert, badge, or sound keys. For more information, see `Generating a
            Remote Notification
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
            and `Pushing Background Updates to Your App
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
            on the Apple Developer website.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification. A silent (or background)
          push notification isn't displayed on recipients' devices. You can use silent push
          notifications to make small updates to your app, or to display messages in an in-app
          message center.

          Amazon Pinpoint uses this property to determine the correct value for the apns-push-type
          request header when it sends the notification message to APNs. If you specify a value of
          true for this property, Amazon Pinpoint sets the value for the apns-push-type header field
          to background.

          .. note::

            If you specify the raw content of an APNs push notification, the message payload has to
            include the content-available key. For silent (background) notifications, set the value
            of content-available to 1. Additionally, the message payload for a silent notification
            can't include the alert, badge, or sound keys. For more information, see `Generating a
            Remote Notification
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/generating_a_remote_notification>`__
            and `Pushing Background Updates to Your App
            <https://developer.apple.com/documentation/usernotifications/setting_up_a_remote_notification_server/pushing_background_updates_to_your_app>`__
            on the Apple Developer website.

            Apple has indicated that they will throttle "excessive" background notifications based
            on current traffic volumes. To prevent your notifications being throttled, Apple
            recommends that you send no more than 3 silent push notifications to each recipient per
            hour.

        - **Sound** *(string) --*

          The key for the sound to play when the recipient receives the push notification. The value
          for this key is the name of a sound file in your app's main bundle or the Library/Sounds
          folder in your app's data container. If the sound file can't be found or you specify
          default for the value, the system plays the default alert sound.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override these
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **ThreadId** *(string) --*

          The key that represents your app-specific identifier for grouping notifications. If you
          provide a Notification Content app extension, you can use this value to group your
          notifications together.

        - **TimeToLive** *(integer) --*

          The amount of time, in seconds, that APNs should store and attempt to deliver the push
          notification, if the service is unable to deliver the notification the first time. If this
          value is 0, APNs treats the notification as if it expires immediately and the service
          doesn't store or try to deliver the notification again.

          Amazon Pinpoint specifies this value in the apns-expiration request header when it sends
          the notification message to APNs.

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The default push notification message for the Baidu (Baidu Cloud Push) channel. This message
        overrides the default push notification message (DefaultPushNotificationMessage).

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message.

        - **Data** *(dict) --*

          The JSON data payload to use for the push notification, if the notification is a silent
          push notification. This payload is added to the data.pinpoint.jsonBody object of the
          notification.

          - *(string) --*

            - *(string) --*

        - **IconReference** *(string) --*

          The icon image name of the asset saved in your app.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of the push notification.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or supporting phone home
          functionality.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of the
          push notification.

        - **Sound** *(string) --*

          The sound to play when the recipient receives the push notification. You can use the
          default stream or specify the file name of a sound resource that's bundled in your app. On
          an Android platform, the sound file must reside in /res/raw/.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **TimeToLive** *(integer) --*

          The amount of time, in seconds, that the Baidu Cloud Push service should store the message
          if the recipient's device is offline. The default value and maximum supported time is
          604,800 seconds (7 days).

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message for all channels.

        - **Body** *(string) --*

          The default body of the message.

        - **Substitutions** *(dict) --*

          The default message variables to use in the message. You can override these default
          variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

      - **DefaultPushNotificationMessage** *(dict) --*

        The default push notification message for all push notification channels.

        - **Action** *(string) --*

          The default action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of the iOS and Android platforms.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The default body of the notification message.

        - **Data** *(dict) --*

          The JSON data payload to use for the default push notification, if the notification is a
          silent push notification. This payload is added to the data.pinpoint.jsonBody object of
          the notification.

          - *(string) --*

            - *(string) --*

        - **SilentPush** *(boolean) --*

          Specifies whether the default notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or delivering messages to an
          in-app notification center.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **Title** *(string) --*

          The default title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The default URL to open in a recipient's default mobile browser, if a recipient taps the
          push notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The default message for the email channel. This message overrides the default message
        (DefaultMessage).

        - **Body** *(string) --*

          The body of the email message.

        - **FeedbackForwardingAddress** *(string) --*

          The email address to forward bounces and complaints to, if feedback forwarding is enabled.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default value is the
          FromAddress specified for the email channel.

        - **RawEmail** *(dict) --*

          The email message, represented as a raw MIME message.

          - **Data** *(bytes) --*

            The email message, represented as a raw MIME message. The entire message must be base64
            encoded.

        - **ReplyToAddresses** *(list) --*

          The reply-to email address(es) for the email message. If a recipient replies to the email,
          each reply-to address receives the reply.

          - *(string) --*

        - **SimpleEmail** *(dict) --*

          The email message, composed of a subject, a text part, and an HTML part.

          - **HtmlPart** *(dict) --*

            The body of the email message, in HTML format. We recommend using HTML format for email
            clients that render HTML content. You can include links, formatted text, and more in an
            HTML message.

            - **Charset** *(string) --*

              The applicable character set for the message content.

            - **Data** *(string) --*

              The textual data of the message content.

          - **Subject** *(dict) --*

            The subject line, or title, of the email.

            - **Charset** *(string) --*

              The applicable character set for the message content.

            - **Data** *(string) --*

              The textual data of the message content.

          - **TextPart** *(dict) --*

            The body of the email message, in plain text format. We recommend using plain text
            format for email clients that don't render HTML content and clients that are connected
            to high-latency networks, such as mobile devices.

            - **Charset** *(string) --*

              The applicable character set for the message content.

            - **Data** *(string) --*

              The textual data of the message content.

        - **Substitutions** *(dict) --*

          The default message variables to use in the email message. You can override the default
          variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

      - **GCMMessage** *(dict) --*

        The default push notification message for the GCM channel, which is used to send
        notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging
        (GCM), service. This message overrides the default push notification message
        (DefaultPushNotificationMessage).

        - **Action** *(string) --*

          The action to occur if the recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message.

        - **CollapseKey** *(string) --*

          An arbitrary string that identifies a group of messages that can be collapsed to ensure
          that only the last message is sent when delivery can resume. This helps avoid sending too
          many instances of the same messages when the recipient's device comes online again or
          becomes active.

          Amazon Pinpoint specifies this value in the Firebase Cloud Messaging (FCM) collapse_key
          parameter when it sends the notification message to FCM.

        - **Data** *(dict) --*

          The JSON data payload to use for the push notification, if the notification is a silent
          push notification. This payload is added to the data.pinpoint.jsonBody object of the
          notification.

          - *(string) --*

            - *(string) --*

        - **IconReference** *(string) --*

          The icon image name of the asset saved in your app.

        - **ImageIconUrl** *(string) --*

          The URL of the large icon image to display in the content view of the push notification.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **Priority** *(string) --*

          para>normal - The notification might be delayed. Delivery is optimized for battery usage
          on the recipient's device. Use this value unless immediate delivery is required.

          /listitem>
          * high - The notification is sent immediately and might wake a sleeping device.
          /para>

          Amazon Pinpoint specifies this value in the FCM priority parameter when it sends the
          notification message to FCM.

          The equivalent values for Apple Push Notification service (APNs) are 5, for normal, and
          10, for high. If you specify an APNs value for this property, Amazon Pinpoint accepts and
          converts the value to the corresponding FCM value.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **RestrictedPackageName** *(string) --*

          The package name of the application where registration tokens must match in order for the
          recipient to receive the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration or supporting phone home
          functionality.

        - **SmallImageIconUrl** *(string) --*

          The URL of the small icon image to display in the status bar and the content view of the
          push notification.

        - **Sound** *(string) --*

          The sound to play when the recipient receives the push notification. You can use the
          default stream or specify the file name of a sound resource that's bundled in your app. On
          an Android platform, the sound file must reside in /res/raw/.

        - **Substitutions** *(dict) --*

          The default message variables to use in the notification message. You can override the
          default variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **TimeToLive** *(integer) --*

          The amount of time, in seconds, that FCM should store and attempt to deliver the push
          notification, if the service is unable to deliver the notification the first time. If you
          don't specify this value, FCM defaults to the maximum value, which is 2,419,200 seconds
          (28 days).

          Amazon Pinpoint specifies this value in the FCM time_to_live parameter when it sends the
          notification message to FCM.

        - **Title** *(string) --*

          The title to display above the notification message on the recipient's device.

        - **Url** *(string) --*

          The URL to open in the recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The default message for the SMS channel. This message overrides the default message
        (DefaultMessage).

        - **Body** *(string) --*

          The body of the SMS message.

        - **Keyword** *(string) --*

          The SMS program name that you provided to AWS Support when you requested your dedicated
          number.

        - **MessageType** *(string) --*

          The SMS message type. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message is not critical or time-sensitive, such as a marketing message.

        - **OriginationNumber** *(string) --*

          The number to send the SMS message from. This value should be one of the dedicated long or
          short codes that's assigned to your AWS account. If you don't specify a long or short
          code, Amazon Pinpoint assigns a random long code to the SMS message and sends the message
          from that code.

        - **SenderId** *(string) --*

          The sender ID to display as the sender of the message on a recipient's device. Support for
          sender IDs varies by country or region.

        - **Substitutions** *(dict) --*

          The message variables to use in the SMS message. You can override the default variables
          with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

      - **VoiceMessage** *(dict) --*

        The default message for the voice channel. This message overrides the default message
        (DefaultMessage).

        - **Body** *(string) --*

          The text of the script to use for the voice message.

        - **LanguageCode** *(string) --*

          The code for the language to use when synthesizing the text of the message script. For a
          list of supported languages and the code for each one, see the `Amazon Polly Developer
          Guide <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

        - **OriginationNumber** *(string) --*

          The long code to send the voice message from. This value should be one of the dedicated
          long codes that's assigned to your AWS account. Although it isn't required, we recommend
          that you specify the long code in E.164 format, for example +12065550100, to ensure prompt
          and accurate delivery of the message.

        - **Substitutions** *(dict) --*

          The default message variables to use in the voice message. You can override the default
          variables with individual address variables.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **VoiceId** *(string) --*

          The name of the voice to use when delivering the message. For a list of supported voices,
          see the `Amazon Polly Developer Guide
          <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the message.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TraceId** *(string) --*

      The unique identifier for tracing the message. This identifier is visible to message
      recipients.

    - **Users** *(dict) --* **[REQUIRED]**

      A map that associates user IDs with EndpointSendConfiguration objects. You can use an
      EndpointSendConfiguration object to tailor the message for a user by specifying settings such
      as content overrides and message variables.

      - *(string) --*

        - *(dict) --*

          Specifies the content, including message variables and attributes, to use in a message
          that's sent directly to an endpoint.

          - **BodyOverride** *(string) --*

            The body of the message. If specified, this value overrides the default message body.

          - **Context** *(dict) --*

            A map of custom attributes to attach to the message for the address. For a push
            notification, this payload is added to the data.pinpoint object. For an email or text
            message, this payload is added to email/SMS delivery receipt event attributes.

            - *(string) --*

              - *(string) --*

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the message. If specified, this
            value overrides all other values for the message.

          - **Substitutions** *(dict) --*

            A map of the message variables to merge with the variables specified for the default
            message (DefaultMessage.Substitutions). The variables specified in this map take
            precedence over all other variables.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **TitleOverride** *(string) --*

            The title or subject line of the message. If specified, this value overrides the default
            message title or subject line.
    """


_ClientTagResourceTagsModelTypeDef = TypedDict(
    "_ClientTagResourceTagsModelTypeDef", {"tags": Dict[str, str]}
)


class ClientTagResourceTagsModelTypeDef(_ClientTagResourceTagsModelTypeDef):
    """
    Type definition for `ClientTagResource` `TagsModel`

    Specifies the tags (keys and values) for an application, campaign, journey, message template, or
    segment.

    - **tags** *(dict) --* **[REQUIRED]**

      A string-to-string map of key-value pairs that defines the tags for an application, campaign,
      journey, message template, or segment. Each of these resources can have a maximum of 50 tags.

      Each tag consists of a required tag key and an associated tag value. The maximum length of a
      tag key is 128 characters. The maximum length of a tag value is 256 characters.

      - *(string) --*

        - *(string) --*
    """


_RequiredClientUpdateAdmChannelADMChannelRequestTypeDef = TypedDict(
    "_RequiredClientUpdateAdmChannelADMChannelRequestTypeDef",
    {"ClientId": str, "ClientSecret": str},
)
_OptionalClientUpdateAdmChannelADMChannelRequestTypeDef = TypedDict(
    "_OptionalClientUpdateAdmChannelADMChannelRequestTypeDef", {"Enabled": bool}, total=False
)


class ClientUpdateAdmChannelADMChannelRequestTypeDef(
    _RequiredClientUpdateAdmChannelADMChannelRequestTypeDef,
    _OptionalClientUpdateAdmChannelADMChannelRequestTypeDef,
):
    """
    Type definition for `ClientUpdateAdmChannel` `ADMChannelRequest`

    Specifies the status and settings of the ADM (Amazon Device Messaging) channel for an
    application.

    - **ClientId** *(string) --* **[REQUIRED]**

      The Client ID that you received from Amazon to send messages by using ADM.

    - **ClientSecret** *(string) --* **[REQUIRED]**

      The Client Secret that you received from Amazon to send messages by using ADM.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the ADM channel for the application.
    """


_ClientUpdateAdmChannelResponseADMChannelResponseTypeDef = TypedDict(
    "_ClientUpdateAdmChannelResponseADMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateAdmChannelResponseADMChannelResponseTypeDef(
    _ClientUpdateAdmChannelResponseADMChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateAdmChannelResponse` `ADMChannelResponse`

    Provides information about the status and settings of the ADM (Amazon Device Messaging) channel
    for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the ADM channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the ADM channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the ADM channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the ADM channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the ADM channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the ADM channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the ADM channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the ADM channel, this
      value is ADM.

    - **Version** *(integer) --*

      The current version of the ADM channel.
    """


_ClientUpdateAdmChannelResponseTypeDef = TypedDict(
    "_ClientUpdateAdmChannelResponseTypeDef",
    {"ADMChannelResponse": ClientUpdateAdmChannelResponseADMChannelResponseTypeDef},
    total=False,
)


class ClientUpdateAdmChannelResponseTypeDef(_ClientUpdateAdmChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateAdmChannel` `Response`

    The request succeeded.

    - **ADMChannelResponse** *(dict) --*

      Provides information about the status and settings of the ADM (Amazon Device Messaging)
      channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the ADM channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the ADM channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the ADM channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the ADM channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the ADM channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the ADM channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the ADM channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the ADM channel, this
        value is ADM.

      - **Version** *(integer) --*

        The current version of the ADM channel.
    """


_ClientUpdateApnsChannelAPNSChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsChannelAPNSChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsChannelAPNSChannelRequestTypeDef(
    _ClientUpdateApnsChannelAPNSChannelRequestTypeDef
):
    """
    Type definition for `ClientUpdateApnsChannel` `APNSChannelRequest`

    Specifies the status and settings of the APNs (Apple Push Notification service) channel for an
    application.

    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.

    - **Certificate** *(string) --*

      The APNs client certificate that you received from Apple, if you want Amazon Pinpoint to
      communicate with APNs by using an APNs certificate.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that you want Amazon Pinpoint to use when authenticating
      with APNs, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the APNs channel for the application.

    - **PrivateKey** *(string) --*

      The private key for the APNs client certificate that you want Amazon Pinpoint to use to
      communicate with APNs.

    - **TeamId** *(string) --*

      The identifier that's assigned to your Apple developer account team. This identifier is used
      for APNs tokens.

    - **TokenKey** *(string) --*

      The authentication key to use for APNs tokens.

    - **TokenKeyId** *(string) --*

      The key identifier that's assigned to your APNs signing key, if you want Amazon Pinpoint to
      communicate with APNs by using APNs tokens.
    """


_ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef(
    _ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateApnsChannelResponse` `APNSChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with APNs for this
      channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs channel is configured to communicate with APNs by using APNs
      tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
      channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs channel, this
      value is APNS.

    - **Version** *(integer) --*

      The current version of the APNs channel.
    """


_ClientUpdateApnsChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsChannelResponseTypeDef",
    {"APNSChannelResponse": ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef},
    total=False,
)


class ClientUpdateApnsChannelResponseTypeDef(_ClientUpdateApnsChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateApnsChannel` `Response`

    The request succeeded.

    - **APNSChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with APNs for
        this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs channel is configured to communicate with APNs by using APNs
        tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
        channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs channel, this
        value is APNS.

      - **Version** *(integer) --*

        The current version of the APNs channel.
    """


_ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef(
    _ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef
):
    """
    Type definition for `ClientUpdateApnsSandboxChannel` `APNSSandboxChannelRequest`

    Specifies the status and settings of the APNs (Apple Push Notification service) sandbox channel
    for an application.

    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.

    - **Certificate** *(string) --*

      The APNs client certificate that you received from Apple, if you want Amazon Pinpoint to
      communicate with the APNs sandbox environment by using an APNs certificate.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that you want Amazon Pinpoint to use when authenticating
      with the APNs sandbox environment, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the APNs sandbox channel for the application.

    - **PrivateKey** *(string) --*

      The private key for the APNs client certificate that you want Amazon Pinpoint to use to
      communicate with the APNs sandbox environment.

    - **TeamId** *(string) --*

      The identifier that's assigned to your Apple developer account team. This identifier is used
      for APNs tokens.

    - **TokenKey** *(string) --*

      The authentication key to use for APNs tokens.

    - **TokenKeyId** *(string) --*

      The key identifier that's assigned to your APNs signing key, if you want Amazon Pinpoint to
      communicate with the APNs sandbox environment by using APNs tokens.
    """


_ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef(
    _ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateApnsSandboxChannelResponse` `APNSSandboxChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    sandbox channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs sandbox channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs sandbox channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
      sandbox environment for this channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs sandbox channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs sandbox channel is configured to communicate with APNs by using
      APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property of
      the channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs sandbox channel. This property is retained only for
      backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs sandbox channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs sandbox channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs sandbox channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs sandbox channel,
      this value is APNS_SANDBOX.

    - **Version** *(integer) --*

      The current version of the APNs sandbox channel.
    """


_ClientUpdateApnsSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsSandboxChannelResponseTypeDef",
    {
        "APNSSandboxChannelResponse": ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientUpdateApnsSandboxChannelResponseTypeDef(_ClientUpdateApnsSandboxChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateApnsSandboxChannel` `Response`

    The request succeeded.

    - **APNSSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) sandbox channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs sandbox channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs sandbox channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
        sandbox environment for this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs sandbox channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs sandbox channel is configured to communicate with APNs by using
        APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property of
        the channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs sandbox channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs sandbox channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs sandbox channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs sandbox channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs sandbox
        channel, this value is APNS_SANDBOX.

      - **Version** *(integer) --*

        The current version of the APNs sandbox channel.
    """


_ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef(
    _ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef
):
    """
    Type definition for `ClientUpdateApnsVoipChannel` `APNSVoipChannelRequest`

    Specifies the status and settings of the APNs (Apple Push Notification service) VoIP channel for
    an application.

    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.

    - **Certificate** *(string) --*

      The APNs client certificate that you received from Apple, if you want Amazon Pinpoint to
      communicate with APNs by using an APNs certificate.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that you want Amazon Pinpoint to use when authenticating
      with APNs, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the APNs VoIP channel for the application.

    - **PrivateKey** *(string) --*

      The private key for the APNs client certificate that you want Amazon Pinpoint to use to
      communicate with APNs.

    - **TeamId** *(string) --*

      The identifier that's assigned to your Apple developer account team. This identifier is used
      for APNs tokens.

    - **TokenKey** *(string) --*

      The authentication key to use for APNs tokens.

    - **TokenKeyId** *(string) --*

      The key identifier that's assigned to your APNs signing key, if you want Amazon Pinpoint to
      communicate with APNs by using APNs tokens.
    """


_ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef(
    _ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateApnsVoipChannelResponse` `APNSVoipChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    VoIP channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs VoIP channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs VoIP channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with APNs for this
      channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs VoIP channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs VoIP channel is configured to communicate with APNs by using APNs
      tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
      channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs VoIP channel. This property is retained only for
      backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs VoIP channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs VoIP channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs VoIP channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs VoIP channel,
      this value is APNS_VOIP.

    - **Version** *(integer) --*

      The current version of the APNs VoIP channel.
    """


_ClientUpdateApnsVoipChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipChannelResponseTypeDef",
    {"APNSVoipChannelResponse": ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef},
    total=False,
)


class ClientUpdateApnsVoipChannelResponseTypeDef(_ClientUpdateApnsVoipChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateApnsVoipChannel` `Response`

    The request succeeded.

    - **APNSVoipChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs VoIP channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with APNs for
        this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs VoIP channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs VoIP channel is configured to communicate with APNs by using APNs
        tokens. To provide an authentication key for APNs tokens, set the TokenKey property of the
        channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs VoIP channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs VoIP channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs VoIP channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs VoIP channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs VoIP channel,
        this value is APNS_VOIP.

      - **Version** *(integer) --*

        The current version of the APNs VoIP channel.
    """


_ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef(
    _ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef
):
    """
    Type definition for `ClientUpdateApnsVoipSandboxChannel` `APNSVoipSandboxChannelRequest`

    Specifies the status and settings of the APNs (Apple Push Notification service) VoIP sandbox
    channel for an application.

    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.

    - **Certificate** *(string) --*

      The APNs client certificate that you received from Apple, if you want Amazon Pinpoint to
      communicate with the APNs sandbox environment by using an APNs certificate.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that you want Amazon Pinpoint to use when authenticating
      with the APNs sandbox environment for this channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is enabled for the application.

    - **PrivateKey** *(string) --*

      The private key for the APNs client certificate that you want Amazon Pinpoint to use to
      communicate with the APNs sandbox environment.

    - **TeamId** *(string) --*

      The identifier that's assigned to your Apple developer account team. This identifier is used
      for APNs tokens.

    - **TokenKey** *(string) --*

      The authentication key to use for APNs tokens.

    - **TokenKeyId** *(string) --*

      The key identifier that's assigned to your APNs signing key, if you want Amazon Pinpoint to
      communicate with the APNs sandbox environment by using APNs tokens.
    """


_ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef(
    _ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateApnsVoipSandboxChannelResponse`
    `APNSVoipSandboxChannelResponse`

    Provides information about the status and settings of the APNs (Apple Push Notification service)
    VoIP sandbox channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the APNs VoIP sandbox channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the APNs VoIP sandbox channel was enabled.

    - **DefaultAuthenticationMethod** *(string) --*

      The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
      sandbox environment for this channel, key or certificate.

    - **Enabled** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **HasTokenKey** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is configured to communicate with APNs by
      using APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey property
      of the channel.

    - **Id** *(string) --*

      (Deprecated) An identifier for the APNs VoIP sandbox channel. This property is retained only
      for backward compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the APNs VoIP sandbox channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the APNs VoIP sandbox channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the APNs VoIP sandbox channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the APNs VoIP sandbox
      channel, this value is APNS_VOIP_SANDBOX.

    - **Version** *(integer) --*

      The current version of the APNs VoIP sandbox channel.
    """


_ClientUpdateApnsVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipSandboxChannelResponseTypeDef",
    {
        "APNSVoipSandboxChannelResponse": ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientUpdateApnsVoipSandboxChannelResponseTypeDef(
    _ClientUpdateApnsVoipSandboxChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateApnsVoipSandboxChannel` `Response`

    The request succeeded.

    - **APNSVoipSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP sandbox channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP sandbox channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the APNs VoIP sandbox channel was enabled.

      - **DefaultAuthenticationMethod** *(string) --*

        The default authentication method that Amazon Pinpoint uses to authenticate with the APNs
        sandbox environment for this channel, key or certificate.

      - **Enabled** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **HasTokenKey** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is configured to communicate with APNs by
        using APNs tokens. To provide an authentication key for APNs tokens, set the TokenKey
        property of the channel.

      - **Id** *(string) --*

        (Deprecated) An identifier for the APNs VoIP sandbox channel. This property is retained only
        for backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the APNs VoIP sandbox channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the APNs VoIP sandbox channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the APNs VoIP sandbox channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the APNs VoIP sandbox
        channel, this value is APNS_VOIP_SANDBOX.

      - **Version** *(integer) --*

        The current version of the APNs VoIP sandbox channel.
    """


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettingsResponseApplicationSettingsResource`
    `CampaignHook`

    The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
    application.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettingsResponseApplicationSettingsResource`
    `Limits`

    The default sending limits for campaigns in the application.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettingsResponseApplicationSettingsResource`
    `QuietTime`

    The default quiet time for campaigns and journeys in the application. Quiet time is a specific
    time range when messages aren't sent to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the application (or a campaign or journey that has custom quiet
    time settings).

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the application (or a campaign or journey that has custom quiet
    time settings).

    If any of the preceding conditions isn't met, the endpoint will receive messages from a campaign
    or journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    {
        "ApplicationId": str,
        "CampaignHook": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef,
        "LastModifiedDate": str,
        "Limits": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef,
        "QuietTime": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef,
    },
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettingsResponse` `ApplicationSettingsResource`

    Provides information about an application, including the default settings for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application. This identifier is displayed as the **Project ID**
      on the Amazon Pinpoint console.

    - **CampaignHook** *(dict) --*

      The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
      application.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the application's settings were last modified.

    - **Limits** *(dict) --*

      The default sending limits for campaigns in the application.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **QuietTime** *(dict) --*

      The default quiet time for campaigns and journeys in the application. Quiet time is a specific
      time range when messages aren't sent to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the application (or a campaign or journey that has custom
      quiet time settings).

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the application (or a campaign or journey that has custom
      quiet time settings).

      If any of the preceding conditions isn't met, the endpoint will receive messages from a
      campaign or journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateApplicationSettingsResponseTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseTypeDef",
    {
        "ApplicationSettingsResource": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef
    },
    total=False,
)


class ClientUpdateApplicationSettingsResponseTypeDef(
    _ClientUpdateApplicationSettingsResponseTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettings` `Response`

    The request succeeded.

    - **ApplicationSettingsResource** *(dict) --*

      Provides information about an application, including the default settings for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application. This identifier is displayed as the **Project
        ID** on the Amazon Pinpoint console.

      - **CampaignHook** *(dict) --*

        The settings for the AWS Lambda function to use by default as a code hook for campaigns in
        the application.

        - **LambdaFunctionName** *(string) --*

          The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
          invokes to send messages for a campaign.

        - **Mode** *(string) --*

          Specifies which Lambda mode to use when invoking the AWS Lambda function.

        - **WebUrl** *(string) --*

          The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the application's settings were last modified.

      - **Limits** *(dict) --*

        The default sending limits for campaigns in the application.

        - **Daily** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during a
          24-hour period. The maximum value is 100.

        - **MaximumDuration** *(integer) --*

          The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
          after the scheduled start time for the campaign. The minimum value is 60 seconds.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that a campaign can send each second. The minimum value is
          50. The maximum value is 20,000.

        - **Total** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during the
          course of the campaign. The maximum value is 100.

      - **QuietTime** *(dict) --*

        The default quiet time for campaigns and journeys in the application. Quiet time is a
        specific time range when messages aren't sent to endpoints, if all the following conditions
        are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the application (or a campaign or journey that has
        custom quiet time settings).

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the application (or a campaign or journey that
        has custom quiet time settings).

        If any of the preceding conditions isn't met, the endpoint will receive messages from a
        campaign or journey, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettingsWriteApplicationSettingsRequest`
    `CampaignHook`

    The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
    application. To override these settings for a specific campaign, use the Campaignresource to
    define custom Lambda function settings for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettingsWriteApplicationSettingsRequest` `Limits`

    The default sending limits for campaigns in the application. To override these limits for a
    specific campaign, use the Campaignresource to define custom limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettingsWriteApplicationSettingsRequest` `QuietTime`

    The default quiet time for campaigns and journeys in the application. Quiet time is a specific
    time range when messages aren't sent to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the application (or a campaign or journey that has custom quiet
    time settings).

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the application (or a campaign or journey that has custom quiet
    time settings).

    If any of the preceding conditions isn't met, the endpoint will receive messages from a campaign
    or journey, even if quiet time is enabled.

    To override the default quiet time settings for a specific campaign or journey, use the
    Campaignresource or the Journeyresource to define a custom quiet time for the campaign or
    journey.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef",
    {
        "CampaignHook": ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef,
        "CloudWatchMetricsEnabled": bool,
        "Limits": ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef,
        "QuietTime": ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef,
    },
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef
):
    """
    Type definition for `ClientUpdateApplicationSettings` `WriteApplicationSettingsRequest`

    Specifies the default settings for an application.

    - **CampaignHook** *(dict) --*

      The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
      application. To override these settings for a specific campaign, use the Campaignresource to
      define custom Lambda function settings for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **CloudWatchMetricsEnabled** *(boolean) --*

      Specifies whether to enable application-related alarms in Amazon CloudWatch.

    - **Limits** *(dict) --*

      The default sending limits for campaigns in the application. To override these limits for a
      specific campaign, use the Campaignresource to define custom limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **QuietTime** *(dict) --*

      The default quiet time for campaigns and journeys in the application. Quiet time is a specific
      time range when messages aren't sent to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the application (or a campaign or journey that has custom
      quiet time settings).

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the application (or a campaign or journey that has custom
      quiet time settings).

      If any of the preceding conditions isn't met, the endpoint will receive messages from a
      campaign or journey, even if quiet time is enabled.

      To override the default quiet time settings for a specific campaign or journey, use the
      Campaignresource or the Journeyresource to define a custom quiet time for the campaign or
      journey.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_RequiredClientUpdateBaiduChannelBaiduChannelRequestTypeDef = TypedDict(
    "_RequiredClientUpdateBaiduChannelBaiduChannelRequestTypeDef", {"ApiKey": str, "SecretKey": str}
)
_OptionalClientUpdateBaiduChannelBaiduChannelRequestTypeDef = TypedDict(
    "_OptionalClientUpdateBaiduChannelBaiduChannelRequestTypeDef", {"Enabled": bool}, total=False
)


class ClientUpdateBaiduChannelBaiduChannelRequestTypeDef(
    _RequiredClientUpdateBaiduChannelBaiduChannelRequestTypeDef,
    _OptionalClientUpdateBaiduChannelBaiduChannelRequestTypeDef,
):
    """
    Type definition for `ClientUpdateBaiduChannel` `BaiduChannelRequest`

    Specifies the status and settings of the Baidu (Baidu Cloud Push) channel for an application.

    - **ApiKey** *(string) --* **[REQUIRED]**

      The API key that you received from the Baidu Cloud Push service to communicate with the
      service.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the Baidu channel for the application.

    - **SecretKey** *(string) --* **[REQUIRED]**

      The secret key that you received from the Baidu Cloud Push service to communicate with the
      service.
    """


_ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef = TypedDict(
    "_ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef(
    _ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateBaiduChannelResponse` `BaiduChannelResponse`

    Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
    an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the Baidu channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the Baidu channel was enabled.

    - **Credential** *(string) --*

      The API key that you received from the Baidu Cloud Push service to communicate with the
      service.

    - **Enabled** *(boolean) --*

      Specifies whether the Baidu channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the Baidu channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the Baidu channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the Baidu channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the Baidu channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the Baidu channel, this
      value is BAIDU.

    - **Version** *(integer) --*

      The current version of the Baidu channel.
    """


_ClientUpdateBaiduChannelResponseTypeDef = TypedDict(
    "_ClientUpdateBaiduChannelResponseTypeDef",
    {"BaiduChannelResponse": ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef},
    total=False,
)


class ClientUpdateBaiduChannelResponseTypeDef(_ClientUpdateBaiduChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateBaiduChannel` `Response`

    The request succeeded.

    - **BaiduChannelResponse** *(dict) --*

      Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
      an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the Baidu channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the Baidu channel was enabled.

      - **Credential** *(string) --*

        The API key that you received from the Baidu Cloud Push service to communicate with the
        service.

      - **Enabled** *(boolean) --*

        Specifies whether the Baidu channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the Baidu channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the Baidu channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the Baidu channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the Baidu channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the Baidu channel, this
        value is BAIDU.

      - **Version** *(integer) --*

        The current version of the Baidu channel.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsSchedule`
    `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatments`
    `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatments` `State`

    The current status of the treatment.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **Id** *(string) --*

      The unique identifier for the treatment.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --*

      The allocated percentage of users (segment members) that the treatment is sent to.

    - **State** *(dict) --*

      The current status of the treatment.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `DefaultState`

    The current status of the campaign's default treatment. This value exists only for campaigns
    that have more than one treatment, to support A/B testing.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientUpdateCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseHookTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseHookTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseMessageConfiguration`
    `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseMessageConfiguration`
    `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --*

      The subject line, or title, of the email.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseMessageConfiguration`
    `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseMessageConfiguration`
    `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --*

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseScheduleEventFilter`
    `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --*

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **FilterType** *(string) --*

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --*

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **FilterType** *(string) --*

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientUpdateCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseStateTypeDef",
    {"CampaignStatus": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseStateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseStateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `State`

    The current status of the campaign.

    - **CampaignStatus** *(string) --*

      The current status of the campaign, or the current status of a treatment that belongs to an
      A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED only
      if all campaign treatments have a status of COMPLETED.
    """


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponseTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponseCampaignResponse` `TemplateConfiguration`

    The message template that’s used for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientUpdateCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientUpdateCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientUpdateCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTypeDef
):
    """
    Type definition for `ClientUpdateCampaignResponse` `CampaignResponse`

    Provides information about the status, configuration, and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of responses, one for each treatment that you defined for the campaign, in addition
      to the default treatment.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **Id** *(string) --*

          The unique identifier for the treatment.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --*

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --*

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **FilterType** *(string) --*

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --*

          The allocated percentage of users (segment members) that the treatment is sent to.

        - **State** *(dict) --*

          The current status of the treatment.

          - **CampaignStatus** *(string) --*

            The current status of the campaign, or the current status of a treatment that belongs to
            an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
            COMPLETED only if all campaign treatments have a status of COMPLETED.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          The custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the campaign applies to.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the campaign.

    - **CreationDate** *(string) --*

      The date, ISO 8601 format, when the campaign was created.

    - **DefaultState** *(dict) --*

      The current status of the campaign's default treatment. This value exists only for campaigns
      that have more than one treatment, to support A/B testing.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **Description** *(string) --*

      The custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **Id** *(string) --*

      The unique identifier for the campaign.

    - **IsPaused** *(boolean) --*

      Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
      by changing this value to false.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the campaign was last modified.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --*

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --*

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **FilterType** *(string) --*

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment that's associated with the campaign.

    - **SegmentVersion** *(integer) --*

      The version number of the segment that's associated with the campaign.

    - **State** *(dict) --*

      The current status of the campaign.

      - **CampaignStatus** *(string) --*

        The current status of the campaign, or the current status of a treatment that belongs to an
        A/B test campaign. If a campaign uses A/B testing, the campaign has a status of COMPLETED
        only if all campaign treatments have a status of COMPLETED.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template that’s used for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      The custom description of a variation of the campaign that's used for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign that's used for A/B testing.

    - **Version** *(integer) --*

      The version number of the campaign.
    """


_ClientUpdateCampaignResponseTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseTypeDef",
    {"CampaignResponse": ClientUpdateCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientUpdateCampaignResponseTypeDef(_ClientUpdateCampaignResponseTypeDef):
    """
    Type definition for `ClientUpdateCampaign` `Response`

    The request succeeded.

    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.

      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.

        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.

          - **Id** *(string) --*

            The unique identifier for the treatment.

          - **MessageConfiguration** *(dict) --*

            The message configuration settings for the treatment.

            - **ADMMessage** *(dict) --*

              The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
              This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **APNSMessage** *(dict) --*

              The message that the campaign sends through the APNs (Apple Push Notification service)
              channel. This message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **BaiduMessage** *(dict) --*

              The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
              message overrides the default message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **DefaultMessage** *(dict) --*

              The default message that the campaign sends through all the channels that are
              configured for the campaign.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **EmailMessage** *(dict) --*

              The message that the campaign sends through the email channel.

              - **Body** *(string) --*

                The body of the email for recipients whose email clients don't render HTML content.

              - **FromAddress** *(string) --*

                The verified email address to send the email from. The default address is the
                FromAddress specified for the email channel for the application.

              - **HtmlBody** *(string) --*

                The body of the email, in HTML format, for recipients whose email clients render
                HTML content.

              - **Title** *(string) --*

                The subject line, or title, of the email.

            - **GCMMessage** *(dict) --*

              The message that the campaign sends through the GCM channel, which enables Amazon
              Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM),
              formerly Google Cloud Messaging (GCM), service. This message overrides the default
              message.

              - **Action** *(string) --*

                The action to occur if a recipient taps the push notification. Valid values are:

                * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
                background. This is the default action.

                * DEEP_LINK - Your app opens and displays a designated user interface in the app.
                This setting uses the deep-linking features of iOS and Android.

                * URL - The default mobile browser on the recipient's device opens and loads the web
                page at a URL that you specify.

              - **Body** *(string) --*

                The body of the notification message. The maximum number of characters is 200.

              - **ImageIconUrl** *(string) --*

                The URL of the image to display as the push-notification icon, such as the icon for
                the app.

              - **ImageSmallIconUrl** *(string) --*

                The URL of the image to display as the small, push-notification icon, such as a
                small version of the icon for the app.

              - **ImageUrl** *(string) --*

                The URL of an image to display in the push notification.

              - **JsonBody** *(string) --*

                The JSON payload to use for a silent push notification.

              - **MediaUrl** *(string) --*

                The URL of the image or video to display in the push notification.

              - **RawContent** *(string) --*

                The raw, JSON-formatted string to use as the payload for the notification message.
                If specified, this value overrides all other content for the message.

              - **SilentPush** *(boolean) --*

                Specifies whether the notification is a silent push notification, which is a push
                notification that doesn't display on a recipient's device. Silent push notifications
                can be used for cases such as updating an app's configuration, displaying messages
                in an in-app message center, or supporting phone home functionality.

              - **TimeToLive** *(integer) --*

                The number of seconds that the push-notification service should keep the message, if
                the service is unable to deliver the notification the first time. This value is
                converted to an expiration value when it's sent to a push-notification service. If
                this value is 0, the service treats the notification as if it expires immediately
                and the service doesn't store or try to deliver the notification again.

                This value doesn't apply to messages that are sent through the Amazon Device
                Messaging (ADM) service.

              - **Title** *(string) --*

                The title to display above the notification message on a recipient's device.

              - **Url** *(string) --*

                The URL to open in a recipient's default mobile browser, if a recipient taps the
                push notification and the value of the Action property is URL.

            - **SMSMessage** *(dict) --*

              The message that the campaign sends through the SMS channel.

              - **Body** *(string) --*

                The body of the SMS message.

              - **MessageType** *(string) --*

                The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
                time-sensitive, such as a one-time password that supports a customer transaction;
                and, PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
                message.

              - **SenderId** *(string) --*

                The sender ID to display on recipients' devices when they receive the SMS message.

          - **Schedule** *(dict) --*

            The schedule settings for the treatment.

            - **EndTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign ended or will end.

            - **EventFilter** *(dict) --*

              The type of event that causes the campaign to be sent, if the value of the Frequency
              property is EVENT.

              - **Dimensions** *(dict) --*

                The dimension settings of the event filter for the campaign.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **FilterType** *(string) --*

                The type of event that causes the campaign to be sent. Valid values are: SYSTEM,
                sends the campaign when a system event occurs; and, ENDPOINT, sends the campaign
                when an endpoint event (Events resource) occurs.

            - **Frequency** *(string) --*

              Specifies how often the campaign is sent or whether the campaign is sent in response
              to a specific event.

            - **IsLocalTime** *(boolean) --*

              Specifies whether the start and end times for the campaign schedule use each
              recipient's local time. To base the schedule on each recipient's local time, set this
              value to true.

            - **QuietTime** *(dict) --*

              The default quiet time for the campaign. Quiet time is a specific time range when a
              campaign doesn't send messages to endpoints, if all the following conditions are met:

              * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

              * The current time in the endpoint's time zone is later than or equal to the time
              specified by the QuietTime.Start property for the campaign.

              * The current time in the endpoint's time zone is earlier than or equal to the time
              specified by the QuietTime.End property for the campaign.

              If any of the preceding conditions isn't met, the endpoint will receive messages from
              the campaign, even if quiet time is enabled.

              - **End** *(string) --*

                The specific time when quiet time ends. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

              - **Start** *(string) --*

                The specific time when quiet time begins. This value has to use 24-hour notation and
                be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
                is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
                2:30 PM.

            - **StartTime** *(string) --*

              The scheduled time, in ISO 8601 format, when the campaign began or will begin.

            - **Timezone** *(string) --*

              The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
              property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
              UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
              UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
              UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

          - **SizePercent** *(integer) --*

            The allocated percentage of users (segment members) that the treatment is sent to.

          - **State** *(dict) --*

            The current status of the treatment.

            - **CampaignStatus** *(string) --*

              The current status of the campaign, or the current status of a treatment that belongs
              to an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
              COMPLETED only if all campaign treatments have a status of COMPLETED.

          - **TemplateConfiguration** *(dict) --*

            The message template to use for the treatment.

            - **EmailTemplate** *(dict) --*

              The email template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **PushTemplate** *(dict) --*

              The push notification template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **SMSTemplate** *(dict) --*

              The SMS template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

            - **VoiceTemplate** *(dict) --*

              The voice template to use for the message.

              - **Name** *(string) --*

                The name of the message template to use for the message. If specified, this value
                must match the name of an existing message template.

          - **TreatmentDescription** *(string) --*

            The custom description of the treatment.

          - **TreatmentName** *(string) --*

            The custom name of the treatment. A treatment is a variation of a campaign that's used
            for A/B testing of a campaign.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the campaign applies to.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the campaign.

      - **CreationDate** *(string) --*

        The date, ISO 8601 format, when the campaign was created.

      - **DefaultState** *(dict) --*

        The current status of the campaign's default treatment. This value exists only for campaigns
        that have more than one treatment, to support A/B testing.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **Description** *(string) --*

        The custom description of the campaign.

      - **HoldoutPercent** *(integer) --*

        The allocated percentage of users (segment members) who shouldn't receive messages from the
        campaign.

      - **Hook** *(dict) --*

        The settings for the AWS Lambda function to use as a code hook for the campaign.

        - **LambdaFunctionName** *(string) --*

          The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
          invokes to send messages for a campaign.

        - **Mode** *(string) --*

          Specifies which Lambda mode to use when invoking the AWS Lambda function.

        - **WebUrl** *(string) --*

          The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

      - **Id** *(string) --*

        The unique identifier for the campaign.

      - **IsPaused** *(boolean) --*

        Specifies whether the campaign is paused. A paused campaign doesn't run unless you resume it
        by changing this value to false.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the campaign was last modified.

      - **Limits** *(dict) --*

        The messaging limits for the campaign.

        - **Daily** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during a
          24-hour period. The maximum value is 100.

        - **MaximumDuration** *(integer) --*

          The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
          after the scheduled start time for the campaign. The minimum value is 60 seconds.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that a campaign can send each second. The minimum value is
          50. The maximum value is 20,000.

        - **Total** *(integer) --*

          The maximum number of messages that a campaign can send to a single endpoint during the
          course of the campaign. The maximum value is 100.

      - **MessageConfiguration** *(dict) --*

        The message configuration settings for the campaign.

        - **ADMMessage** *(dict) --*

          The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
          This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **APNSMessage** *(dict) --*

          The message that the campaign sends through the APNs (Apple Push Notification service)
          channel. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **BaiduMessage** *(dict) --*

          The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
          message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **DefaultMessage** *(dict) --*

          The default message that the campaign sends through all the channels that are configured
          for the campaign.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **EmailMessage** *(dict) --*

          The message that the campaign sends through the email channel.

          - **Body** *(string) --*

            The body of the email for recipients whose email clients don't render HTML content.

          - **FromAddress** *(string) --*

            The verified email address to send the email from. The default address is the
            FromAddress specified for the email channel for the application.

          - **HtmlBody** *(string) --*

            The body of the email, in HTML format, for recipients whose email clients render HTML
            content.

          - **Title** *(string) --*

            The subject line, or title, of the email.

        - **GCMMessage** *(dict) --*

          The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
          to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google
          Cloud Messaging (GCM), service. This message overrides the default message.

          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:

            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.

            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.

            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.

          - **Body** *(string) --*

            The body of the notification message. The maximum number of characters is 200.

          - **ImageIconUrl** *(string) --*

            The URL of the image to display as the push-notification icon, such as the icon for the
            app.

          - **ImageSmallIconUrl** *(string) --*

            The URL of the image to display as the small, push-notification icon, such as a small
            version of the icon for the app.

          - **ImageUrl** *(string) --*

            The URL of an image to display in the push notification.

          - **JsonBody** *(string) --*

            The JSON payload to use for a silent push notification.

          - **MediaUrl** *(string) --*

            The URL of the image or video to display in the push notification.

          - **RawContent** *(string) --*

            The raw, JSON-formatted string to use as the payload for the notification message. If
            specified, this value overrides all other content for the message.

          - **SilentPush** *(boolean) --*

            Specifies whether the notification is a silent push notification, which is a push
            notification that doesn't display on a recipient's device. Silent push notifications can
            be used for cases such as updating an app's configuration, displaying messages in an
            in-app message center, or supporting phone home functionality.

          - **TimeToLive** *(integer) --*

            The number of seconds that the push-notification service should keep the message, if the
            service is unable to deliver the notification the first time. This value is converted to
            an expiration value when it's sent to a push-notification service. If this value is 0,
            the service treats the notification as if it expires immediately and the service doesn't
            store or try to deliver the notification again.

            This value doesn't apply to messages that are sent through the Amazon Device Messaging
            (ADM) service.

          - **Title** *(string) --*

            The title to display above the notification message on a recipient's device.

          - **Url** *(string) --*

            The URL to open in a recipient's default mobile browser, if a recipient taps the push
            notification and the value of the Action property is URL.

        - **SMSMessage** *(dict) --*

          The message that the campaign sends through the SMS channel.

          - **Body** *(string) --*

            The body of the SMS message.

          - **MessageType** *(string) --*

            The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
            time-sensitive, such as a one-time password that supports a customer transaction; and,
            PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

          - **SenderId** *(string) --*

            The sender ID to display on recipients' devices when they receive the SMS message.

      - **Name** *(string) --*

        The name of the campaign.

      - **Schedule** *(dict) --*

        The schedule settings for the campaign.

        - **EndTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign ended or will end.

        - **EventFilter** *(dict) --*

          The type of event that causes the campaign to be sent, if the value of the Frequency
          property is EVENT.

          - **Dimensions** *(dict) --*

            The dimension settings of the event filter for the campaign.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **FilterType** *(string) --*

            The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
            the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
            endpoint event (Events resource) occurs.

        - **Frequency** *(string) --*

          Specifies how often the campaign is sent or whether the campaign is sent in response to a
          specific event.

        - **IsLocalTime** *(boolean) --*

          Specifies whether the start and end times for the campaign schedule use each recipient's
          local time. To base the schedule on each recipient's local time, set this value to true.

        - **QuietTime** *(dict) --*

          The default quiet time for the campaign. Quiet time is a specific time range when a
          campaign doesn't send messages to endpoints, if all the following conditions are met:

          * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

          * The current time in the endpoint's time zone is later than or equal to the time
          specified by the QuietTime.Start property for the campaign.

          * The current time in the endpoint's time zone is earlier than or equal to the time
          specified by the QuietTime.End property for the campaign.

          If any of the preceding conditions isn't met, the endpoint will receive messages from the
          campaign, even if quiet time is enabled.

          - **End** *(string) --*

            The specific time when quiet time ends. This value has to use 24-hour notation and be in
            HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

          - **Start** *(string) --*

            The specific time when quiet time begins. This value has to use 24-hour notation and be
            in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
            minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **StartTime** *(string) --*

          The scheduled time, in ISO 8601 format, when the campaign began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
          UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
          UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

      - **SegmentId** *(string) --*

        The unique identifier for the segment that's associated with the campaign.

      - **SegmentVersion** *(integer) --*

        The version number of the segment that's associated with the campaign.

      - **State** *(dict) --*

        The current status of the campaign.

        - **CampaignStatus** *(string) --*

          The current status of the campaign, or the current status of a treatment that belongs to
          an A/B test campaign. If a campaign uses A/B testing, the campaign has a status of
          COMPLETED only if all campaign treatments have a status of COMPLETED.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the campaign. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **TemplateConfiguration** *(dict) --*

        The message template that’s used for the campaign.

        - **EmailTemplate** *(dict) --*

          The email template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **PushTemplate** *(dict) --*

          The push notification template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **SMSTemplate** *(dict) --*

          The SMS template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

        - **VoiceTemplate** *(dict) --*

          The voice template to use for the message.

          - **Name** *(string) --*

            The name of the message template to use for the message. If specified, this value must
            match the name of an existing message template.

      - **TreatmentDescription** *(string) --*

        The custom description of a variation of the campaign that's used for A/B testing.

      - **TreatmentName** *(string) --*

        The custom name of a variation of the campaign that's used for A/B testing.

      - **Version** *(integer) --*

        The version number of the campaign.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Title": str},
)
_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --* **[REQUIRED]**

      The subject line, or title, of the email.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfiguration` `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatments`
    `MessageConfiguration`

    The message configuration settings for the treatment.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --* **[REQUIRED]**

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilter` `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsSchedule`
    `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **FilterType** *(string) --* **[REQUIRED]**

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsSchedule`
    `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    {"StartTime": str},
)
_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatments` `Schedule`

    The schedule settings for the treatment.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **FilterType** *(string) --* **[REQUIRED]**

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --* **[REQUIRED]**

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for
    `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestAdditionalTreatments`
    `TemplateConfiguration`

    The message template to use for the treatment.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    {"SizePercent": int},
)
_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    {
        "MessageConfiguration": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
        "TemplateConfiguration": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef,
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequest` `AdditionalTreatments`

    Specifies the settings for a campaign treatment. A treatment is a variation of a campaign that's
    used for A/B testing of a campaign.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --* **[REQUIRED]**

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Schedule** *(dict) --*

      The schedule settings for the treatment.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --* **[REQUIRED]**

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

        - **FilterType** *(string) --* **[REQUIRED]**

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --* **[REQUIRED]**

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SizePercent** *(integer) --* **[REQUIRED]**

      The allocated percentage of users (segment members) to send the treatment to.

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the treatment.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      A custom description of the treatment.

    - **TreatmentName** *(string) --*

      The custom name of the treatment. A treatment is a variation of a campaign that's used for A/B
      testing of a campaign.
    """


_ClientUpdateCampaignWriteCampaignRequestHookTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestHookTypeDef",
    {"LambdaFunctionName": str, "Mode": str, "WebUrl": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestHookTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestHookTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequest` `Hook`

    The settings for the AWS Lambda function to use as a code hook for the campaign.

    - **LambdaFunctionName** *(string) --*

      The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint invokes
      to send messages for a campaign.

    - **Mode** *(string) --*

      Specifies which Lambda mode to use when invoking the AWS Lambda function.

    - **WebUrl** *(string) --*

      The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.
    """


_ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequest` `Limits`

    The messaging limits for the campaign.

    - **Daily** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during a 24-hour
      period. The maximum value is 100.

    - **MaximumDuration** *(integer) --*

      The maximum amount of time, in seconds, that a campaign can attempt to deliver a message after
      the scheduled start time for the campaign. The minimum value is 60 seconds.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that a campaign can send each second. The minimum value is 50.
      The maximum value is 20,000.

    - **Total** *(integer) --*

      The maximum number of messages that a campaign can send to a single endpoint during the course
      of the campaign. The maximum value is 100.
    """


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestMessageConfiguration` `ADMMessage`

    The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
    message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestMessageConfiguration` `APNSMessage`

    The message that the campaign sends through the APNs (Apple Push Notification service) channel.
    This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestMessageConfiguration`
    `BaiduMessage`

    The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
    overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestMessageConfiguration`
    `DefaultMessage`

    The default message that the campaign sends through all the channels that are configured for the
    campaign.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_RequiredClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    {"Title": str},
)
_OptionalClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestMessageConfiguration`
    `EmailMessage`

    The message that the campaign sends through the email channel.

    - **Body** *(string) --*

      The body of the email for recipients whose email clients don't render HTML content.

    - **FromAddress** *(string) --*

      The verified email address to send the email from. The default address is the FromAddress
      specified for the email channel for the application.

    - **HtmlBody** *(string) --*

      The body of the email, in HTML format, for recipients whose email clients render HTML content.

    - **Title** *(string) --* **[REQUIRED]**

      The subject line, or title, of the email.
    """


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestMessageConfiguration` `GCMMessage`

    The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
    send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
    Messaging (GCM), service. This message overrides the default message.

    - **Action** *(string) --*

      The action to occur if a recipient taps the push notification. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of iOS and Android.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The body of the notification message. The maximum number of characters is 200.

    - **ImageIconUrl** *(string) --*

      The URL of the image to display as the push-notification icon, such as the icon for the app.

    - **ImageSmallIconUrl** *(string) --*

      The URL of the image to display as the small, push-notification icon, such as a small version
      of the icon for the app.

    - **ImageUrl** *(string) --*

      The URL of an image to display in the push notification.

    - **JsonBody** *(string) --*

      The JSON payload to use for a silent push notification.

    - **MediaUrl** *(string) --*

      The URL of the image or video to display in the push notification.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for the notification message. If
      specified, this value overrides all other content for the message.

    - **SilentPush** *(boolean) --*

      Specifies whether the notification is a silent push notification, which is a push notification
      that doesn't display on a recipient's device. Silent push notifications can be used for cases
      such as updating an app's configuration, displaying messages in an in-app message center, or
      supporting phone home functionality.

    - **TimeToLive** *(integer) --*

      The number of seconds that the push-notification service should keep the message, if the
      service is unable to deliver the notification the first time. This value is converted to an
      expiration value when it's sent to a push-notification service. If this value is 0, the
      service treats the notification as if it expires immediately and the service doesn't store or
      try to deliver the notification again.

      This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
      service.

    - **Title** *(string) --*

      The title to display above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps the push
      notification and the value of the Action property is URL.
    """


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": str, "SenderId": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestMessageConfiguration` `SMSMessage`

    The message that the campaign sends through the SMS channel.

    - **Body** *(string) --*

      The body of the SMS message.

    - **MessageType** *(string) --*

      The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
      time-sensitive, such as a one-time password that supports a customer transaction; and,
      PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

    - **SenderId** *(string) --*

      The sender ID to display on recipients' devices when they receive the SMS message.
    """


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequest` `MessageConfiguration`

    The message configuration settings for the campaign.

    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **APNSMessage** *(dict) --*

      The message that the campaign sends through the APNs (Apple Push Notification service)
      channel. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **BaiduMessage** *(dict) --*

      The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This message
      overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **DefaultMessage** *(dict) --*

      The default message that the campaign sends through all the channels that are configured for
      the campaign.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **EmailMessage** *(dict) --*

      The message that the campaign sends through the email channel.

      - **Body** *(string) --*

        The body of the email for recipients whose email clients don't render HTML content.

      - **FromAddress** *(string) --*

        The verified email address to send the email from. The default address is the FromAddress
        specified for the email channel for the application.

      - **HtmlBody** *(string) --*

        The body of the email, in HTML format, for recipients whose email clients render HTML
        content.

      - **Title** *(string) --* **[REQUIRED]**

        The subject line, or title, of the email.

    - **GCMMessage** *(dict) --*

      The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint to
      send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
      Messaging (GCM), service. This message overrides the default message.

      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The body of the notification message. The maximum number of characters is 200.

      - **ImageIconUrl** *(string) --*

        The URL of the image to display as the push-notification icon, such as the icon for the app.

      - **ImageSmallIconUrl** *(string) --*

        The URL of the image to display as the small, push-notification icon, such as a small
        version of the icon for the app.

      - **ImageUrl** *(string) --*

        The URL of an image to display in the push notification.

      - **JsonBody** *(string) --*

        The JSON payload to use for a silent push notification.

      - **MediaUrl** *(string) --*

        The URL of the image or video to display in the push notification.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for the notification message. If
        specified, this value overrides all other content for the message.

      - **SilentPush** *(boolean) --*

        Specifies whether the notification is a silent push notification, which is a push
        notification that doesn't display on a recipient's device. Silent push notifications can be
        used for cases such as updating an app's configuration, displaying messages in an in-app
        message center, or supporting phone home functionality.

      - **TimeToLive** *(integer) --*

        The number of seconds that the push-notification service should keep the message, if the
        service is unable to deliver the notification the first time. This value is converted to an
        expiration value when it's sent to a push-notification service. If this value is 0, the
        service treats the notification as if it expires immediately and the service doesn't store
        or try to deliver the notification again.

        This value doesn't apply to messages that are sent through the Amazon Device Messaging (ADM)
        service.

      - **Title** *(string) --*

        The title to display above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps the push
        notification and the value of the Action property is URL.

    - **SMSMessage** *(dict) --*

      The message that the campaign sends through the SMS channel.

      - **Body** *(string) --*

        The body of the SMS message.

      - **MessageType** *(string) --*

        The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
        time-sensitive, such as a one-time password that supports a customer transaction; and,
        PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

      - **SenderId** *(string) --*

        The sender ID to display on recipients' devices when they receive the SMS message.
    """


_RequiredClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str, ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestScheduleEventFilter` `Dimensions`

    The dimension settings of the event filter for the campaign.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef,
        "FilterType": str,
    },
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestSchedule` `EventFilter`

    The type of event that causes the campaign to be sent, if the value of the Frequency property is
    EVENT.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimension settings of the event filter for the campaign.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **FilterType** *(string) --* **[REQUIRED]**

      The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
      campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint event
      (Events resource) occurs.
    """


_ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestSchedule` `QuietTime`

    The default quiet time for the campaign. Quiet time is a specific time range when a campaign
    doesn't send messages to endpoints, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

    * The current time in the endpoint's time zone is later than or equal to the time specified by
    the QuietTime.Start property for the campaign.

    * The current time in the endpoint's time zone is earlier than or equal to the time specified by
    the QuietTime.End property for the campaign.

    If any of the preceding conditions isn't met, the endpoint will receive messages from the
    campaign, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_RequiredClientUpdateCampaignWriteCampaignRequestScheduleTypeDef = TypedDict(
    "_RequiredClientUpdateCampaignWriteCampaignRequestScheduleTypeDef", {"StartTime": str}
)
_OptionalClientUpdateCampaignWriteCampaignRequestScheduleTypeDef = TypedDict(
    "_OptionalClientUpdateCampaignWriteCampaignRequestScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef,
        "Frequency": str,
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef(
    _RequiredClientUpdateCampaignWriteCampaignRequestScheduleTypeDef,
    _OptionalClientUpdateCampaignWriteCampaignRequestScheduleTypeDef,
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequest` `Schedule`

    The schedule settings for the campaign.

    - **EndTime** *(string) --*

      The scheduled time, in ISO 8601 format, when the campaign ended or will end.

    - **EventFilter** *(dict) --*

      The type of event that causes the campaign to be sent, if the value of the Frequency property
      is EVENT.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimension settings of the event filter for the campaign.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **FilterType** *(string) --* **[REQUIRED]**

        The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
        campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
        event (Events resource) occurs.

    - **Frequency** *(string) --*

      Specifies how often the campaign is sent or whether the campaign is sent in response to a
      specific event.

    - **IsLocalTime** *(boolean) --*

      Specifies whether the start and end times for the campaign schedule use each recipient's local
      time. To base the schedule on each recipient's local time, set this value to true.

    - **QuietTime** *(dict) --*

      The default quiet time for the campaign. Quiet time is a specific time range when a campaign
      doesn't send messages to endpoints, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

      * The current time in the endpoint's time zone is later than or equal to the time specified by
      the QuietTime.Start property for the campaign.

      * The current time in the endpoint's time zone is earlier than or equal to the time specified
      by the QuietTime.End property for the campaign.

      If any of the preceding conditions isn't met, the endpoint will receive messages from the
      campaign, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **StartTime** *(string) --* **[REQUIRED]**

      The scheduled time, in ISO 8601 format, when the campaign began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property is
      true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30, UTC+05,
      UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10, UTC+10:30,
      UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
      UTC-10, and UTC-11.
    """


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestTemplateConfiguration`
    `EmailTemplate`

    The email template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestTemplateConfiguration`
    `PushTemplate`

    The push notification template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestTemplateConfiguration`
    `SMSTemplate`

    The SMS template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequestTemplateConfiguration`
    `VoiceTemplate`

    The voice template to use for the message.

    - **Name** *(string) --*

      The name of the message template to use for the message. If specified, this value must match
      the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef
):
    """
    Type definition for `ClientUpdateCampaignWriteCampaignRequest` `TemplateConfiguration`

    The message template to use for the campaign.

    - **EmailTemplate** *(dict) --*

      The email template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **PushTemplate** *(dict) --*

      The push notification template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **SMSTemplate** *(dict) --*

      The SMS template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.

    - **VoiceTemplate** *(dict) --*

      The voice template to use for the message.

      - **Name** *(string) --*

        The name of the message template to use for the message. If specified, this value must match
        the name of an existing message template.
    """


_ClientUpdateCampaignWriteCampaignRequestTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTypeDef",
    {
        "AdditionalTreatments": List[
            ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef
        ],
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientUpdateCampaignWriteCampaignRequestHookTypeDef,
        "IsPaused": bool,
        "Limits": ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef,
        "MessageConfiguration": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTypeDef
):
    """
    Type definition for `ClientUpdateCampaign` `WriteCampaignRequest`

    Specifies the configuration and other settings for a campaign.

    - **AdditionalTreatments** *(list) --*

      An array of requests that defines additional treatments for the campaign, in addition to the
      default treatment for the campaign.

      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.

        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.

          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **APNSMessage** *(dict) --*

            The message that the campaign sends through the APNs (Apple Push Notification service)
            channel. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **BaiduMessage** *(dict) --*

            The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
            message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **DefaultMessage** *(dict) --*

            The default message that the campaign sends through all the channels that are configured
            for the campaign.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **EmailMessage** *(dict) --*

            The message that the campaign sends through the email channel.

            - **Body** *(string) --*

              The body of the email for recipients whose email clients don't render HTML content.

            - **FromAddress** *(string) --*

              The verified email address to send the email from. The default address is the
              FromAddress specified for the email channel for the application.

            - **HtmlBody** *(string) --*

              The body of the email, in HTML format, for recipients whose email clients render HTML
              content.

            - **Title** *(string) --* **[REQUIRED]**

              The subject line, or title, of the email.

          - **GCMMessage** *(dict) --*

            The message that the campaign sends through the GCM channel, which enables Amazon
            Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
            Google Cloud Messaging (GCM), service. This message overrides the default message.

            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:

              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.

              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.

              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.

            - **Body** *(string) --*

              The body of the notification message. The maximum number of characters is 200.

            - **ImageIconUrl** *(string) --*

              The URL of the image to display as the push-notification icon, such as the icon for
              the app.

            - **ImageSmallIconUrl** *(string) --*

              The URL of the image to display as the small, push-notification icon, such as a small
              version of the icon for the app.

            - **ImageUrl** *(string) --*

              The URL of an image to display in the push notification.

            - **JsonBody** *(string) --*

              The JSON payload to use for a silent push notification.

            - **MediaUrl** *(string) --*

              The URL of the image or video to display in the push notification.

            - **RawContent** *(string) --*

              The raw, JSON-formatted string to use as the payload for the notification message. If
              specified, this value overrides all other content for the message.

            - **SilentPush** *(boolean) --*

              Specifies whether the notification is a silent push notification, which is a push
              notification that doesn't display on a recipient's device. Silent push notifications
              can be used for cases such as updating an app's configuration, displaying messages in
              an in-app message center, or supporting phone home functionality.

            - **TimeToLive** *(integer) --*

              The number of seconds that the push-notification service should keep the message, if
              the service is unable to deliver the notification the first time. This value is
              converted to an expiration value when it's sent to a push-notification service. If
              this value is 0, the service treats the notification as if it expires immediately and
              the service doesn't store or try to deliver the notification again.

              This value doesn't apply to messages that are sent through the Amazon Device Messaging
              (ADM) service.

            - **Title** *(string) --*

              The title to display above the notification message on a recipient's device.

            - **Url** *(string) --*

              The URL to open in a recipient's default mobile browser, if a recipient taps the push
              notification and the value of the Action property is URL.

          - **SMSMessage** *(dict) --*

            The message that the campaign sends through the SMS channel.

            - **Body** *(string) --*

              The body of the SMS message.

            - **MessageType** *(string) --*

              The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
              time-sensitive, such as a one-time password that supports a customer transaction; and,
              PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing
              message.

            - **SenderId** *(string) --*

              The sender ID to display on recipients' devices when they receive the SMS message.

        - **Schedule** *(dict) --*

          The schedule settings for the treatment.

          - **EndTime** *(string) --*

            The scheduled time, in ISO 8601 format, when the campaign ended or will end.

          - **EventFilter** *(dict) --*

            The type of event that causes the campaign to be sent, if the value of the Frequency
            property is EVENT.

            - **Dimensions** *(dict) --* **[REQUIRED]**

              The dimension settings of the event filter for the campaign.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

            - **FilterType** *(string) --* **[REQUIRED]**

              The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends
              the campaign when a system event occurs; and, ENDPOINT, sends the campaign when an
              endpoint event (Events resource) occurs.

          - **Frequency** *(string) --*

            Specifies how often the campaign is sent or whether the campaign is sent in response to
            a specific event.

          - **IsLocalTime** *(boolean) --*

            Specifies whether the start and end times for the campaign schedule use each recipient's
            local time. To base the schedule on each recipient's local time, set this value to true.

          - **QuietTime** *(dict) --*

            The default quiet time for the campaign. Quiet time is a specific time range when a
            campaign doesn't send messages to endpoints, if all the following conditions are met:

            * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

            * The current time in the endpoint's time zone is later than or equal to the time
            specified by the QuietTime.Start property for the campaign.

            * The current time in the endpoint's time zone is earlier than or equal to the time
            specified by the QuietTime.End property for the campaign.

            If any of the preceding conditions isn't met, the endpoint will receive messages from
            the campaign, even if quiet time is enabled.

            - **End** *(string) --*

              The specific time when quiet time ends. This value has to use 24-hour notation and be
              in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is
              the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30
              PM.

            - **Start** *(string) --*

              The specific time when quiet time begins. This value has to use 24-hour notation and
              be in HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM
              is the minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent
              2:30 PM.

          - **StartTime** *(string) --* **[REQUIRED]**

            The scheduled time, in ISO 8601 format, when the campaign began or will begin.

          - **Timezone** *(string) --*

            The starting UTC offset for the campaign schedule, if the value of the IsLocalTime
            property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
            UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09,
            UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05,
            UTC-06, UTC-07, UTC-08, UTC-09, UTC-10, and UTC-11.

        - **SizePercent** *(integer) --* **[REQUIRED]**

          The allocated percentage of users (segment members) to send the treatment to.

        - **TemplateConfiguration** *(dict) --*

          The message template to use for the treatment.

          - **EmailTemplate** *(dict) --*

            The email template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **PushTemplate** *(dict) --*

            The push notification template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **SMSTemplate** *(dict) --*

            The SMS template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

          - **VoiceTemplate** *(dict) --*

            The voice template to use for the message.

            - **Name** *(string) --*

              The name of the message template to use for the message. If specified, this value must
              match the name of an existing message template.

        - **TreatmentDescription** *(string) --*

          A custom description of the treatment.

        - **TreatmentName** *(string) --*

          The custom name of the treatment. A treatment is a variation of a campaign that's used for
          A/B testing of a campaign.

    - **Description** *(string) --*

      A custom description of the campaign.

    - **HoldoutPercent** *(integer) --*

      The allocated percentage of users (segment members) who shouldn't receive messages from the
      campaign.

    - **Hook** *(dict) --*

      The settings for the AWS Lambda function to use as a code hook for the campaign.

      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.

      - **Mode** *(string) --*

        Specifies which Lambda mode to use when invoking the AWS Lambda function.

      - **WebUrl** *(string) --*

        The web URL that Amazon Pinpoint calls to invoke the AWS Lambda function over HTTPS.

    - **IsPaused** *(boolean) --*

      Specifies whether to pause the campaign. A paused campaign doesn't run unless you resume it by
      setting this value to false.

    - **Limits** *(dict) --*

      The messaging limits for the campaign.

      - **Daily** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during a
        24-hour period. The maximum value is 100.

      - **MaximumDuration** *(integer) --*

        The maximum amount of time, in seconds, that a campaign can attempt to deliver a message
        after the scheduled start time for the campaign. The minimum value is 60 seconds.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that a campaign can send each second. The minimum value is
        50. The maximum value is 20,000.

      - **Total** *(integer) --*

        The maximum number of messages that a campaign can send to a single endpoint during the
        course of the campaign. The maximum value is 100.

    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the campaign.

      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **APNSMessage** *(dict) --*

        The message that the campaign sends through the APNs (Apple Push Notification service)
        channel. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **BaiduMessage** *(dict) --*

        The message that the campaign sends through the Baidu (Baidu Cloud Push) channel. This
        message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **DefaultMessage** *(dict) --*

        The default message that the campaign sends through all the channels that are configured for
        the campaign.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **EmailMessage** *(dict) --*

        The message that the campaign sends through the email channel.

        - **Body** *(string) --*

          The body of the email for recipients whose email clients don't render HTML content.

        - **FromAddress** *(string) --*

          The verified email address to send the email from. The default address is the FromAddress
          specified for the email channel for the application.

        - **HtmlBody** *(string) --*

          The body of the email, in HTML format, for recipients whose email clients render HTML
          content.

        - **Title** *(string) --* **[REQUIRED]**

          The subject line, or title, of the email.

      - **GCMMessage** *(dict) --*

        The message that the campaign sends through the GCM channel, which enables Amazon Pinpoint
        to send push notifications through the Firebase Cloud Messaging (FCM), formerly Google Cloud
        Messaging (GCM), service. This message overrides the default message.

        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:

          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.

          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.

          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.

        - **Body** *(string) --*

          The body of the notification message. The maximum number of characters is 200.

        - **ImageIconUrl** *(string) --*

          The URL of the image to display as the push-notification icon, such as the icon for the
          app.

        - **ImageSmallIconUrl** *(string) --*

          The URL of the image to display as the small, push-notification icon, such as a small
          version of the icon for the app.

        - **ImageUrl** *(string) --*

          The URL of an image to display in the push notification.

        - **JsonBody** *(string) --*

          The JSON payload to use for a silent push notification.

        - **MediaUrl** *(string) --*

          The URL of the image or video to display in the push notification.

        - **RawContent** *(string) --*

          The raw, JSON-formatted string to use as the payload for the notification message. If
          specified, this value overrides all other content for the message.

        - **SilentPush** *(boolean) --*

          Specifies whether the notification is a silent push notification, which is a push
          notification that doesn't display on a recipient's device. Silent push notifications can
          be used for cases such as updating an app's configuration, displaying messages in an
          in-app message center, or supporting phone home functionality.

        - **TimeToLive** *(integer) --*

          The number of seconds that the push-notification service should keep the message, if the
          service is unable to deliver the notification the first time. This value is converted to
          an expiration value when it's sent to a push-notification service. If this value is 0, the
          service treats the notification as if it expires immediately and the service doesn't store
          or try to deliver the notification again.

          This value doesn't apply to messages that are sent through the Amazon Device Messaging
          (ADM) service.

        - **Title** *(string) --*

          The title to display above the notification message on a recipient's device.

        - **Url** *(string) --*

          The URL to open in a recipient's default mobile browser, if a recipient taps the push
          notification and the value of the Action property is URL.

      - **SMSMessage** *(dict) --*

        The message that the campaign sends through the SMS channel.

        - **Body** *(string) --*

          The body of the SMS message.

        - **MessageType** *(string) --*

          The type of SMS message. Valid values are: TRANSACTIONAL, the message is critical or
          time-sensitive, such as a one-time password that supports a customer transaction; and,
          PROMOTIONAL, the message isn't critical or time-sensitive, such as a marketing message.

        - **SenderId** *(string) --*

          The sender ID to display on recipients' devices when they receive the SMS message.

    - **Name** *(string) --*

      The custom name of the campaign.

    - **Schedule** *(dict) --*

      The schedule settings for the campaign.

      - **EndTime** *(string) --*

        The scheduled time, in ISO 8601 format, when the campaign ended or will end.

      - **EventFilter** *(dict) --*

        The type of event that causes the campaign to be sent, if the value of the Frequency
        property is EVENT.

        - **Dimensions** *(dict) --* **[REQUIRED]**

          The dimension settings of the event filter for the campaign.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

        - **FilterType** *(string) --* **[REQUIRED]**

          The type of event that causes the campaign to be sent. Valid values are: SYSTEM, sends the
          campaign when a system event occurs; and, ENDPOINT, sends the campaign when an endpoint
          event (Events resource) occurs.

      - **Frequency** *(string) --*

        Specifies how often the campaign is sent or whether the campaign is sent in response to a
        specific event.

      - **IsLocalTime** *(boolean) --*

        Specifies whether the start and end times for the campaign schedule use each recipient's
        local time. To base the schedule on each recipient's local time, set this value to true.

      - **QuietTime** *(dict) --*

        The default quiet time for the campaign. Quiet time is a specific time range when a campaign
        doesn't send messages to endpoints, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint is set to a valid value.

        * The current time in the endpoint's time zone is later than or equal to the time specified
        by the QuietTime.Start property for the campaign.

        * The current time in the endpoint's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the campaign.

        If any of the preceding conditions isn't met, the endpoint will receive messages from the
        campaign, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **StartTime** *(string) --* **[REQUIRED]**

        The scheduled time, in ISO 8601 format, when the campaign began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the campaign schedule, if the value of the IsLocalTime property
        is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
        UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+09, UTC+09:30, UTC+10,
        UTC+10:30, UTC+11, UTC+12, UTC+13, UTC-02, UTC-03, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08,
        UTC-09, UTC-10, and UTC-11.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the campaign.

    - **SegmentVersion** *(integer) --*

      The version of the segment to associate with the campaign.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the
      campaign. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateConfiguration** *(dict) --*

      The message template to use for the campaign.

      - **EmailTemplate** *(dict) --*

        The email template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **PushTemplate** *(dict) --*

        The push notification template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **SMSTemplate** *(dict) --*

        The SMS template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

      - **VoiceTemplate** *(dict) --*

        The voice template to use for the message.

        - **Name** *(string) --*

          The name of the message template to use for the message. If specified, this value must
          match the name of an existing message template.

    - **TreatmentDescription** *(string) --*

      A custom description of a variation of the campaign to use for A/B testing.

    - **TreatmentName** *(string) --*

      The custom name of a variation of the campaign to use for A/B testing.
    """


_RequiredClientUpdateEmailChannelEmailChannelRequestTypeDef = TypedDict(
    "_RequiredClientUpdateEmailChannelEmailChannelRequestTypeDef",
    {"FromAddress": str, "Identity": str},
)
_OptionalClientUpdateEmailChannelEmailChannelRequestTypeDef = TypedDict(
    "_OptionalClientUpdateEmailChannelEmailChannelRequestTypeDef",
    {"ConfigurationSet": str, "Enabled": bool, "RoleArn": str},
    total=False,
)


class ClientUpdateEmailChannelEmailChannelRequestTypeDef(
    _RequiredClientUpdateEmailChannelEmailChannelRequestTypeDef,
    _OptionalClientUpdateEmailChannelEmailChannelRequestTypeDef,
):
    """
    Type definition for `ClientUpdateEmailChannel` `EmailChannelRequest`

    Specifies the status and settings of the email channel for an application.

    - **ConfigurationSet** *(string) --*

      The configuration set that you want to apply to email that you send through the channel by
      using the `Amazon Pinpoint Email API <emailAPIreference.html>`__ .

    - **Enabled** *(boolean) --*

      Specifies whether to enable the email channel for the application.

    - **FromAddress** *(string) --* **[REQUIRED]**

      The verified email address that you want to send email from when you send email through the
      channel.

    - **Identity** *(string) --* **[REQUIRED]**

      The Amazon Resource Name (ARN) of the identity, verified with Amazon Simple Email Service
      (Amazon SES), that you want to use when you send email through the channel.

    - **RoleArn** *(string) --*

      The ARN of the AWS Identity and Access Management (IAM) role that you want Amazon Pinpoint to
      use when it submits email-related event data for the channel.
    """


_ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef = TypedDict(
    "_ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "ConfigurationSet": str,
        "CreationDate": str,
        "Enabled": bool,
        "FromAddress": str,
        "HasCredential": bool,
        "Id": str,
        "Identity": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "MessagesPerSecond": int,
        "Platform": str,
        "RoleArn": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef(
    _ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateEmailChannelResponse` `EmailChannelResponse`

    Provides information about the status and settings of the email channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the email channel applies to.

    - **ConfigurationSet** *(string) --*

      The configuration set that's applied to email that's sent through the channel by using the
      `Amazon Pinpoint Email API <emailAPIreference.html>`__ .

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the email channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the email channel is enabled for the application.

    - **FromAddress** *(string) --*

      The verified email address that you send email from when you send email through the channel.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the email channel. This property is retained only for backward
      compatibility.

    - **Identity** *(string) --*

      The Amazon Resource Name (ARN) of the identity, verified with Amazon Simple Email Service
      (Amazon SES), that you use when you send email through the channel.

    - **IsArchived** *(boolean) --*

      Specifies whether the email channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the email channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the email channel was last modified.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of emails that you can send through the channel each second.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the email channel, this
      value is EMAIL.

    - **RoleArn** *(string) --*

      The ARN of the AWS Identity and Access Management (IAM) role that Amazon Pinpoint uses to
      submit email-related event data for the channel.

    - **Version** *(integer) --*

      The current version of the email channel.
    """


_ClientUpdateEmailChannelResponseTypeDef = TypedDict(
    "_ClientUpdateEmailChannelResponseTypeDef",
    {"EmailChannelResponse": ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef},
    total=False,
)


class ClientUpdateEmailChannelResponseTypeDef(_ClientUpdateEmailChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateEmailChannel` `Response`

    The request succeeded.

    - **EmailChannelResponse** *(dict) --*

      Provides information about the status and settings of the email channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the email channel applies to.

      - **ConfigurationSet** *(string) --*

        The configuration set that's applied to email that's sent through the channel by using the
        `Amazon Pinpoint Email API <emailAPIreference.html>`__ .

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the email channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the email channel is enabled for the application.

      - **FromAddress** *(string) --*

        The verified email address that you send email from when you send email through the channel.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the email channel. This property is retained only for
        backward compatibility.

      - **Identity** *(string) --*

        The Amazon Resource Name (ARN) of the identity, verified with Amazon Simple Email Service
        (Amazon SES), that you use when you send email through the channel.

      - **IsArchived** *(boolean) --*

        Specifies whether the email channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the email channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the email channel was last modified.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of emails that you can send through the channel each second.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the email channel, this
        value is EMAIL.

      - **RoleArn** *(string) --*

        The ARN of the AWS Identity and Access Management (IAM) role that Amazon Pinpoint uses to
        submit email-related event data for the channel.

      - **Version** *(integer) --*

        The current version of the email channel.
    """


_ClientUpdateEmailTemplateEmailTemplateRequestTypeDef = TypedDict(
    "_ClientUpdateEmailTemplateEmailTemplateRequestTypeDef",
    {
        "DefaultSubstitutions": str,
        "HtmlPart": str,
        "Subject": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TextPart": str,
    },
    total=False,
)


class ClientUpdateEmailTemplateEmailTemplateRequestTypeDef(
    _ClientUpdateEmailTemplateEmailTemplateRequestTypeDef
):
    """
    Type definition for `ClientUpdateEmailTemplate` `EmailTemplateRequest`

    Specifies the content and settings for a message template that can be used in messages that are
    sent through the email channel.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **HtmlPart** *(string) --*

      The message body, in HTML format, to use in email messages that are based on the message
      template. We recommend using HTML format for email clients that render HTML content. You can
      include links, formatted text, and more in an HTML message.

    - **Subject** *(string) --*

      The subject line, or title, to use in email messages that are based on the message template.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.

    - **TextPart** *(string) --*

      The message body, in plain text format, to use in email messages that are based on the message
      template. We recommend using plain text format for email clients that don't render HTML
      content and clients that are connected to high-latency networks, such as mobile devices.
    """


_ClientUpdateEmailTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateEmailTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateEmailTemplateResponseMessageBodyTypeDef(
    _ClientUpdateEmailTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientUpdateEmailTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientUpdateEmailTemplateResponseTypeDef = TypedDict(
    "_ClientUpdateEmailTemplateResponseTypeDef",
    {"MessageBody": ClientUpdateEmailTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateEmailTemplateResponseTypeDef(_ClientUpdateEmailTemplateResponseTypeDef):
    """
    Type definition for `ClientUpdateEmailTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientUpdateEndpointEndpointRequestDemographicTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateEndpointEndpointRequestDemographicTypeDef(
    _ClientUpdateEndpointEndpointRequestDemographicTypeDef
):
    """
    Type definition for `ClientUpdateEndpointEndpointRequest` `Demographic`

    The demographic information for the endpoint, such as the time zone and platform.

    - **AppVersion** *(string) --*

      The version of the app that's associated with the endpoint.

    - **Locale** *(string) --*

      The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
      an underscore (_), followed by an ISO 3166-1 alpha-2 value.

    - **Make** *(string) --*

      The manufacturer of the endpoint device, such as Apple or Samsung.

    - **Model** *(string) --*

      The model name or number of the endpoint device, such as iPhone.

    - **ModelVersion** *(string) --*

      The model version of the endpoint device.

    - **Platform** *(string) --*

      The platform of the endpoint device, such as iOS or Android.

    - **PlatformVersion** *(string) --*

      The platform version of the endpoint device.

    - **Timezone** *(string) --*

      The time zone of the endpoint, specified as a tz database name value, such as
      America/Los_Angeles.
    """


_ClientUpdateEndpointEndpointRequestLocationTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientUpdateEndpointEndpointRequestLocationTypeDef(
    _ClientUpdateEndpointEndpointRequestLocationTypeDef
):
    """
    Type definition for `ClientUpdateEndpointEndpointRequest` `Location`

    The geographic information for the endpoint.

    - **City** *(string) --*

      The name of the city where the endpoint is located.

    - **Country** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      endpoint is located. For example, US for the United States.

    - **Latitude** *(float) --*

      The latitude coordinate of the endpoint location, rounded to one decimal place.

    - **Longitude** *(float) --*

      The longitude coordinate of the endpoint location, rounded to one decimal place.

    - **PostalCode** *(string) --*

      The postal or ZIP code for the area where the endpoint is located.

    - **Region** *(string) --*

      The name of the region where the endpoint is located. For locations in the United States, this
      value is the name of a state.
    """


_ClientUpdateEndpointEndpointRequestUserTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientUpdateEndpointEndpointRequestUserTypeDef(
    _ClientUpdateEndpointEndpointRequestUserTypeDef
):
    """
    Type definition for `ClientUpdateEndpointEndpointRequest` `User`

    One or more custom user attributes that describe the user who's associated with the endpoint.

    - **UserAttributes** *(dict) --*

      One or more custom attributes that describe the user by associating a name with an array of
      values. For example, the value of an attribute named Interests might be: ["science", "music",
      "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **UserId** *(string) --*

      The unique identifier for the user.
    """


_ClientUpdateEndpointEndpointRequestTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestTypeDef",
    {
        "Address": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": str,
        "Demographic": ClientUpdateEndpointEndpointRequestDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Location": ClientUpdateEndpointEndpointRequestLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientUpdateEndpointEndpointRequestUserTypeDef,
    },
    total=False,
)


class ClientUpdateEndpointEndpointRequestTypeDef(_ClientUpdateEndpointEndpointRequestTypeDef):
    """
    Type definition for `ClientUpdateEndpoint` `EndpointRequest`

    Specifies the channel type and other settings for an endpoint.

    - **Address** *(string) --*

      The destination address for messages or push notifications that you send to the endpoint. The
      address varies by channel. For a push-notification channel, use the token provided by the push
      notification service, such as an Apple Push Notification service (APNs) device token or a
      Firebase Cloud Messaging (FCM) registration token. For the SMS channel, use a phone number in
      E.164 format, such as +12065550100. For the email channel, use an email address.

    - **Attributes** *(dict) --*

      One or more custom attributes that describe the endpoint by associating a name with an array
      of values. For example, the value of a custom attribute named Interests might be: ["science",
      "music", "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ChannelType** *(string) --*

      The channel to use when sending messages or push notifications to the endpoint.

    - **Demographic** *(dict) --*

      The demographic information for the endpoint, such as the time zone and platform.

      - **AppVersion** *(string) --*

        The version of the app that's associated with the endpoint.

      - **Locale** *(string) --*

        The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
        an underscore (_), followed by an ISO 3166-1 alpha-2 value.

      - **Make** *(string) --*

        The manufacturer of the endpoint device, such as Apple or Samsung.

      - **Model** *(string) --*

        The model name or number of the endpoint device, such as iPhone.

      - **ModelVersion** *(string) --*

        The model version of the endpoint device.

      - **Platform** *(string) --*

        The platform of the endpoint device, such as iOS or Android.

      - **PlatformVersion** *(string) --*

        The platform version of the endpoint device.

      - **Timezone** *(string) --*

        The time zone of the endpoint, specified as a tz database name value, such as
        America/Los_Angeles.

    - **EffectiveDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint is updated.

    - **EndpointStatus** *(string) --*

      Specifies whether to send messages or push notifications to the endpoint. Valid values are:
      ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
      endpoint.

      Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or update
      an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if you update
      another endpoint that has the same address specified by the Address property.

    - **Location** *(dict) --*

      The geographic information for the endpoint.

      - **City** *(string) --*

        The name of the city where the endpoint is located.

      - **Country** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        endpoint is located. For example, US for the United States.

      - **Latitude** *(float) --*

        The latitude coordinate of the endpoint location, rounded to one decimal place.

      - **Longitude** *(float) --*

        The longitude coordinate of the endpoint location, rounded to one decimal place.

      - **PostalCode** *(string) --*

        The postal or ZIP code for the area where the endpoint is located.

      - **Region** *(string) --*

        The name of the region where the endpoint is located. For locations in the United States,
        this value is the name of a state.

    - **Metrics** *(dict) --*

      One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

      - *(string) --*

        - *(float) --*

    - **OptOut** *(string) --*

      Specifies whether the user who's associated with the endpoint has opted out of receiving
      messages and push notifications from you. Possible values are: ALL, the user has opted out and
      doesn't want to receive any messages or push notifications; and, NONE, the user hasn't opted
      out and wants to receive all messages and push notifications.

    - **RequestId** *(string) --*

      The unique identifier for the most recent request to update the endpoint.

    - **User** *(dict) --*

      One or more custom user attributes that describe the user who's associated with the endpoint.

      - **UserAttributes** *(dict) --*

        One or more custom attributes that describe the user by associating a name with an array of
        values. For example, the value of an attribute named Interests might be: ["science",
        "music", "travel"]. You can use these attributes as filter criteria when you create
        segments.

        When you define the name of a custom attribute, avoid using the following characters: number
        sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
        console can't display attribute names that contain these characters. This limitation doesn't
        apply to attribute values.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **UserId** *(string) --*

        The unique identifier for the user.
    """


_ClientUpdateEndpointResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateEndpointResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateEndpointResponseMessageBodyTypeDef(
    _ClientUpdateEndpointResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientUpdateEndpointResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientUpdateEndpointResponseTypeDef = TypedDict(
    "_ClientUpdateEndpointResponseTypeDef",
    {"MessageBody": ClientUpdateEndpointResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateEndpointResponseTypeDef(_ClientUpdateEndpointResponseTypeDef):
    """
    Type definition for `ClientUpdateEndpoint` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef
):
    """
    Type definition for `ClientUpdateEndpointsBatchEndpointBatchRequestItem` `Demographic`

    The demographic information for the endpoint, such as the time zone and platform.

    - **AppVersion** *(string) --*

      The version of the app that's associated with the endpoint.

    - **Locale** *(string) --*

      The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
      an underscore (_), followed by an ISO 3166-1 alpha-2 value.

    - **Make** *(string) --*

      The manufacturer of the endpoint device, such as Apple or Samsung.

    - **Model** *(string) --*

      The model name or number of the endpoint device, such as iPhone.

    - **ModelVersion** *(string) --*

      The model version of the endpoint device.

    - **Platform** *(string) --*

      The platform of the endpoint device, such as iOS or Android.

    - **PlatformVersion** *(string) --*

      The platform version of the endpoint device.

    - **Timezone** *(string) --*

      The time zone of the endpoint, specified as a tz database name value, such as
      America/Los_Angeles.
    """


_ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef
):
    """
    Type definition for `ClientUpdateEndpointsBatchEndpointBatchRequestItem` `Location`

    The geographic information for the endpoint.

    - **City** *(string) --*

      The name of the city where the endpoint is located.

    - **Country** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      endpoint is located. For example, US for the United States.

    - **Latitude** *(float) --*

      The latitude coordinate of the endpoint location, rounded to one decimal place.

    - **Longitude** *(float) --*

      The longitude coordinate of the endpoint location, rounded to one decimal place.

    - **PostalCode** *(string) --*

      The postal or ZIP code for the area where the endpoint is located.

    - **Region** *(string) --*

      The name of the region where the endpoint is located. For locations in the United States, this
      value is the name of a state.
    """


_ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef
):
    """
    Type definition for `ClientUpdateEndpointsBatchEndpointBatchRequestItem` `User`

    One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
    associated with the endpoint.

    - **UserAttributes** *(dict) --*

      One or more custom attributes that describe the user by associating a name with an array of
      values. For example, the value of an attribute named Interests might be: ["science", "music",
      "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **UserId** *(string) --*

      The unique identifier for the user.
    """


_ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef",
    {
        "Address": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": str,
        "Demographic": ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef,
    },
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef
):
    """
    Type definition for `ClientUpdateEndpointsBatchEndpointBatchRequest` `Item`

    Specifies an endpoint to create or update and the settings and attributes to set or change for
    the endpoint.

    - **Address** *(string) --*

      The destination address for messages or push notifications that you send to the endpoint. The
      address varies by channel. For a push-notification channel, use the token provided by the push
      notification service, such as an Apple Push Notification service (APNs) device token or a
      Firebase Cloud Messaging (FCM) registration token. For the SMS channel, use a phone number in
      E.164 format, such as +12065550100. For the email channel, use an email address.

    - **Attributes** *(dict) --*

      One or more custom attributes that describe the endpoint by associating a name with an array
      of values. For example, the value of a custom attribute named Interests might be: ["science",
      "music", "travel"]. You can use these attributes as filter criteria when you create segments.

      When you define the name of a custom attribute, avoid using the following characters: number
      sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
      console can't display attribute names that contain these characters. This limitation doesn't
      apply to attribute values.

      - *(string) --*

        - *(list) --*

          - *(string) --*

    - **ChannelType** *(string) --*

      The channel to use when sending messages or push notifications to the endpoint.

    - **Demographic** *(dict) --*

      The demographic information for the endpoint, such as the time zone and platform.

      - **AppVersion** *(string) --*

        The version of the app that's associated with the endpoint.

      - **Locale** *(string) --*

        The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code, followed by
        an underscore (_), followed by an ISO 3166-1 alpha-2 value.

      - **Make** *(string) --*

        The manufacturer of the endpoint device, such as Apple or Samsung.

      - **Model** *(string) --*

        The model name or number of the endpoint device, such as iPhone.

      - **ModelVersion** *(string) --*

        The model version of the endpoint device.

      - **Platform** *(string) --*

        The platform of the endpoint device, such as iOS or Android.

      - **PlatformVersion** *(string) --*

        The platform version of the endpoint device.

      - **Timezone** *(string) --*

        The time zone of the endpoint, specified as a tz database name value, such as
        America/Los_Angeles.

    - **EffectiveDate** *(string) --*

      The date and time, in ISO 8601 format, when the endpoint was created or updated.

    - **EndpointStatus** *(string) --*

      Specifies whether to send messages or push notifications to the endpoint. Valid values are:
      ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
      endpoint.

      Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or update
      an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if you update
      another endpoint that has the same address specified by the Address property.

    - **Id** *(string) --*

      The unique identifier for the endpoint in the context of the batch.

    - **Location** *(dict) --*

      The geographic information for the endpoint.

      - **City** *(string) --*

        The name of the city where the endpoint is located.

      - **Country** *(string) --*

        The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
        endpoint is located. For example, US for the United States.

      - **Latitude** *(float) --*

        The latitude coordinate of the endpoint location, rounded to one decimal place.

      - **Longitude** *(float) --*

        The longitude coordinate of the endpoint location, rounded to one decimal place.

      - **PostalCode** *(string) --*

        The postal or ZIP code for the area where the endpoint is located.

      - **Region** *(string) --*

        The name of the region where the endpoint is located. For locations in the United States,
        this value is the name of a state.

    - **Metrics** *(dict) --*

      One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

      - *(string) --*

        - *(float) --*

    - **OptOut** *(string) --*

      Specifies whether the user who's associated with the endpoint has opted out of receiving
      messages and push notifications from you. Possible values are: ALL, the user has opted out and
      doesn't want to receive any messages or push notifications; and, NONE, the user hasn't opted
      out and wants to receive all messages and push notifications.

    - **RequestId** *(string) --*

      The unique identifier for the request to create or update the endpoint.

    - **User** *(dict) --*

      One or more custom user attributes that your app reports to Amazon Pinpoint for the user who's
      associated with the endpoint.

      - **UserAttributes** *(dict) --*

        One or more custom attributes that describe the user by associating a name with an array of
        values. For example, the value of an attribute named Interests might be: ["science",
        "music", "travel"]. You can use these attributes as filter criteria when you create
        segments.

        When you define the name of a custom attribute, avoid using the following characters: number
        sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon Pinpoint
        console can't display attribute names that contain these characters. This limitation doesn't
        apply to attribute values.

        - *(string) --*

          - *(list) --*

            - *(string) --*

      - **UserId** *(string) --*

        The unique identifier for the user.
    """


_ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef",
    {"Item": List[ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef]},
)


class ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef
):
    """
    Type definition for `ClientUpdateEndpointsBatch` `EndpointBatchRequest`

    Specifies a batch of endpoints to create or update and the settings and attributes to set or
    change for each endpoint.

    - **Item** *(list) --* **[REQUIRED]**

      An array that defines the endpoints to create or update and, for each endpoint, the property
      values to set or change. An array can contain a maximum of 100 items.

      - *(dict) --*

        Specifies an endpoint to create or update and the settings and attributes to set or change
        for the endpoint.

        - **Address** *(string) --*

          The destination address for messages or push notifications that you send to the endpoint.
          The address varies by channel. For a push-notification channel, use the token provided by
          the push notification service, such as an Apple Push Notification service (APNs) device
          token or a Firebase Cloud Messaging (FCM) registration token. For the SMS channel, use a
          phone number in E.164 format, such as +12065550100. For the email channel, use an email
          address.

        - **Attributes** *(dict) --*

          One or more custom attributes that describe the endpoint by associating a name with an
          array of values. For example, the value of a custom attribute named Interests might be:
          ["science", "music", "travel"]. You can use these attributes as filter criteria when you
          create segments.

          When you define the name of a custom attribute, avoid using the following characters:
          number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon
          Pinpoint console can't display attribute names that contain these characters. This
          limitation doesn't apply to attribute values.

          - *(string) --*

            - *(list) --*

              - *(string) --*

        - **ChannelType** *(string) --*

          The channel to use when sending messages or push notifications to the endpoint.

        - **Demographic** *(dict) --*

          The demographic information for the endpoint, such as the time zone and platform.

          - **AppVersion** *(string) --*

            The version of the app that's associated with the endpoint.

          - **Locale** *(string) --*

            The locale of the endpoint, in the following format: the ISO 639-1 alpha-2 code,
            followed by an underscore (_), followed by an ISO 3166-1 alpha-2 value.

          - **Make** *(string) --*

            The manufacturer of the endpoint device, such as Apple or Samsung.

          - **Model** *(string) --*

            The model name or number of the endpoint device, such as iPhone.

          - **ModelVersion** *(string) --*

            The model version of the endpoint device.

          - **Platform** *(string) --*

            The platform of the endpoint device, such as iOS or Android.

          - **PlatformVersion** *(string) --*

            The platform version of the endpoint device.

          - **Timezone** *(string) --*

            The time zone of the endpoint, specified as a tz database name value, such as
            America/Los_Angeles.

        - **EffectiveDate** *(string) --*

          The date and time, in ISO 8601 format, when the endpoint was created or updated.

        - **EndpointStatus** *(string) --*

          Specifies whether to send messages or push notifications to the endpoint. Valid values
          are: ACTIVE, messages are sent to the endpoint; and, INACTIVE, messages aren’t sent to the
          endpoint.

          Amazon Pinpoint automatically sets this value to ACTIVE when you create an endpoint or
          update an existing endpoint. Amazon Pinpoint automatically sets this value to INACTIVE if
          you update another endpoint that has the same address specified by the Address property.

        - **Id** *(string) --*

          The unique identifier for the endpoint in the context of the batch.

        - **Location** *(dict) --*

          The geographic information for the endpoint.

          - **City** *(string) --*

            The name of the city where the endpoint is located.

          - **Country** *(string) --*

            The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where
            the endpoint is located. For example, US for the United States.

          - **Latitude** *(float) --*

            The latitude coordinate of the endpoint location, rounded to one decimal place.

          - **Longitude** *(float) --*

            The longitude coordinate of the endpoint location, rounded to one decimal place.

          - **PostalCode** *(string) --*

            The postal or ZIP code for the area where the endpoint is located.

          - **Region** *(string) --*

            The name of the region where the endpoint is located. For locations in the United
            States, this value is the name of a state.

        - **Metrics** *(dict) --*

          One or more custom metrics that your app reports to Amazon Pinpoint for the endpoint.

          - *(string) --*

            - *(float) --*

        - **OptOut** *(string) --*

          Specifies whether the user who's associated with the endpoint has opted out of receiving
          messages and push notifications from you. Possible values are: ALL, the user has opted out
          and doesn't want to receive any messages or push notifications; and, NONE, the user hasn't
          opted out and wants to receive all messages and push notifications.

        - **RequestId** *(string) --*

          The unique identifier for the request to create or update the endpoint.

        - **User** *(dict) --*

          One or more custom user attributes that your app reports to Amazon Pinpoint for the user
          who's associated with the endpoint.

          - **UserAttributes** *(dict) --*

            One or more custom attributes that describe the user by associating a name with an array
            of values. For example, the value of an attribute named Interests might be: ["science",
            "music", "travel"]. You can use these attributes as filter criteria when you create
            segments.

            When you define the name of a custom attribute, avoid using the following characters:
            number sign (#), colon (:), question mark (?), backslash (\\), and slash (/). The Amazon
            Pinpoint console can't display attribute names that contain these characters. This
            limitation doesn't apply to attribute values.

            - *(string) --*

              - *(list) --*

                - *(string) --*

          - **UserId** *(string) --*

            The unique identifier for the user.
    """


_ClientUpdateEndpointsBatchResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateEndpointsBatchResponseMessageBodyTypeDef(
    _ClientUpdateEndpointsBatchResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientUpdateEndpointsBatchResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientUpdateEndpointsBatchResponseTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchResponseTypeDef",
    {"MessageBody": ClientUpdateEndpointsBatchResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateEndpointsBatchResponseTypeDef(_ClientUpdateEndpointsBatchResponseTypeDef):
    """
    Type definition for `ClientUpdateEndpointsBatch` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_RequiredClientUpdateGcmChannelGCMChannelRequestTypeDef = TypedDict(
    "_RequiredClientUpdateGcmChannelGCMChannelRequestTypeDef", {"ApiKey": str}
)
_OptionalClientUpdateGcmChannelGCMChannelRequestTypeDef = TypedDict(
    "_OptionalClientUpdateGcmChannelGCMChannelRequestTypeDef", {"Enabled": bool}, total=False
)


class ClientUpdateGcmChannelGCMChannelRequestTypeDef(
    _RequiredClientUpdateGcmChannelGCMChannelRequestTypeDef,
    _OptionalClientUpdateGcmChannelGCMChannelRequestTypeDef,
):
    """
    Type definition for `ClientUpdateGcmChannel` `GCMChannelRequest`

    Specifies the status and settings of the GCM channel for an application. This channel enables
    Amazon Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
    Google Cloud Messaging (GCM), service.

    - **ApiKey** *(string) --* **[REQUIRED]**

      The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
      Google to communicate with Google services.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the GCM channel for the application.
    """


_ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef = TypedDict(
    "_ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef(
    _ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateGcmChannelResponse` `GCMChannelResponse`

    Provides information about the status and settings of the GCM channel for an application. The
    GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
    Messaging (FCM), formerly Google Cloud Messaging (GCM), service.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the GCM channel applies to.

    - **CreationDate** *(string) --*

      The date and time when the GCM channel was enabled.

    - **Credential** *(string) --*

      The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
      Google to communicate with Google services.

    - **Enabled** *(boolean) --*

      Specifies whether the GCM channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the GCM channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the GCM channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the GCM channel.

    - **LastModifiedDate** *(string) --*

      The date and time when the GCM channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the GCM channel, this
      value is GCM.

    - **Version** *(integer) --*

      The current version of the GCM channel.
    """


_ClientUpdateGcmChannelResponseTypeDef = TypedDict(
    "_ClientUpdateGcmChannelResponseTypeDef",
    {"GCMChannelResponse": ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef},
    total=False,
)


class ClientUpdateGcmChannelResponseTypeDef(_ClientUpdateGcmChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateGcmChannel` `Response`

    The request succeeded.

    - **GCMChannelResponse** *(dict) --*

      Provides information about the status and settings of the GCM channel for an application. The
      GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
      Messaging (FCM), formerly Google Cloud Messaging (GCM), service.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the GCM channel applies to.

      - **CreationDate** *(string) --*

        The date and time when the GCM channel was enabled.

      - **Credential** *(string) --*

        The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
        Google to communicate with Google services.

      - **Enabled** *(boolean) --*

        Specifies whether the GCM channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the GCM channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the GCM channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the GCM channel.

      - **LastModifiedDate** *(string) --*

        The date and time when the GCM channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the GCM channel, this
        value is GCM.

      - **Version** *(integer) --*

        The current version of the GCM channel.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitCondition` `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --*

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivities` `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesEMAIL` `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --*

      The percentage of participants who shouldn't continue the journey.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranches`
    `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiCondition`
    `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --*

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplit` `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponse` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --*

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponse` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponse` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponse` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponseStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponseJourneyResponse` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": str,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseTypeDef
):
    """
    Type definition for `ClientUpdateJourneyResponse` `JourneyResponse`

    Provides information about the status, configuration, and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --*

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the journey applies to.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **Id** *(string) --*

      The unique identifier for the journey.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. If this value is true, the schedule uses each participant's local time.

    - **Name** *(string) --*

      The name of the journey.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The current status of the journey. Possible values are:

      * DRAFT - The journey is being developed and hasn't been published yet.

      * ACTIVE - The journey has been developed and published. Depending on the journey's schedule,
      the journey may currently be running or scheduled to start running at a later time. If a
      journey's status is ACTIVE, you can't add, change, or remove activities from it.

      * COMPLETED - The journey has been published and has finished running. All participants have
      entered the journey and no participants are waiting to complete the journey or any activities
      in the journey.

      * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't add,
      change, or remove activities or segment settings from the journey.

      * CLOSED - The journey has been published and has started running. It may have also passed its
      scheduled end time, or passed its scheduled start time and a refresh frequency hasn't been
      specified for it. If a journey's status is CLOSED, you can't add participants to it, and no
      existing participants can enter the journey for the first time. However, any existing
      participants who are currently waiting to start an activity may resume the journey.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the journey. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientUpdateJourneyResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseTypeDef",
    {"JourneyResponse": ClientUpdateJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientUpdateJourneyResponseTypeDef(_ClientUpdateJourneyResponseTypeDef):
    """
    Type definition for `ClientUpdateJourney` `Response`

    The request succeeded.

    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.

      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.

        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.

            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.

              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.

                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.

                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                - **Operator** *(string) --*

                  Specifies how to handle multiple conditions for the activity. For example, if you
                  specify two conditions for an activity, whether both or only one of the conditions
                  must be met for the activity to be performed.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait before determining whether the conditions are met, or the
                date and time when Amazon Pinpoint determines whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

              - **FalseActivity** *(string) --*

                The unique identifier for the activity to perform if the condition isn't met.

              - **TrueActivity** *(string) --*

                The unique identifier for the activity to perform if the condition is met.

            - **Description** *(string) --*

              The custom description of the activity.

            - **EMAIL** *(dict) --*

              The settings for an email activity. This type of activity sends an email message to
              participants.

              - **MessageConfig** *(dict) --*

                The "From" address to use for the message.

                - **FromAddress** *(string) --*

                  The verified email address to send the email message from. The default address is
                  the FromAddress specified for the email channel for the application.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after the message is sent.

              - **TemplateName** *(string) --*

                The name of the email template to use for the message.

            - **Holdout** *(dict) --*

              The settings for a holdout activity. This type of activity stops a journey for a
              specified percentage of participants.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the holdout
                activity.

              - **Percentage** *(integer) --*

                The percentage of participants who shouldn't continue the journey.

            - **MultiCondition** *(dict) --*

              The settings for a multivariate split activity. This type of activity sends
              participants down one of as many as five paths in a journey, based on conditions that
              you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the conditions for entering each path and the
                activity to perform for each path.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity path in a journey.

                  - **Condition** *(dict) --*

                    The condition to evaluate for the activity path.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

              - **DefaultActivity** *(string) --*

                The activity to perform by default for any path in the activity.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait or the date and time when Amazon Pinpoint determines
                whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

            - **RandomSplit** *(dict) --*

              The settings for a random split activity. This type of activity randomly sends
              specified percentages of participants down one of as many as five paths in a journey,
              based on conditions that you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the percentage of participants to enter each
                path and the activity to perform for each path.

                - *(dict) --*

                  Specifies the settings for a path in a random split activity in a journey.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

                  - **Percentage** *(integer) --*

                    The percentage of participants to send down the activity path.

            - **Wait** *(dict) --*

              The settings for a wait activity. This type of activity waits for a certain amount of
              time or until a specific date and time before moving participants to the next activity
              in a journey.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the wait
                activity.

              - **WaitTime** *(dict) --*

                The amount of time to wait or the date and time when the activity moves participants
                to the next activity in the journey.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the journey applies to.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the journey was created.

      - **Id** *(string) --*

        The unique identifier for the journey.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the journey was last modified.

      - **Limits** *(dict) --*

        The messaging and entry limits for the journey.

        - **DailyCap** *(integer) --*

          The maximum number of messages that the journey can send to a single participant during a
          24-hour period. The maximum value is 100.

        - **EndpointReentryCap** *(integer) --*

          The maximum number of times that a participant can enter the journey. The maximum value is
          100. To allow participants to enter the journey an unlimited number of times, set this
          value to 0.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that the journey can send each second.

      - **LocalTime** *(boolean) --*

        Specifies whether the journey's scheduled start and end times use each participant's local
        time. If this value is true, the schedule uses each participant's local time.

      - **Name** *(string) --*

        The name of the journey.

      - **QuietTime** *(dict) --*

        The quiet time settings for the journey. Quiet time is a specific time range when a journey
        doesn't send messages to participants, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
        valid value.

        * The current time in the participant's time zone is later than or equal to the time
        specified by the QuietTime.Start property for the journey.

        * The current time in the participant's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the journey.

        If any of the preceding conditions isn't met, the participant will receive messages from the
        journey, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **RefreshFrequency** *(string) --*

        The frequency with which Amazon Pinpoint evaluates segment and event data for the journey,
        as a duration in ISO 8601 format.

      - **Schedule** *(dict) --*

        The schedule settings for the journey.

        - **EndTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey ended or will end.

        - **StartTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
          UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45,
          UTC-02, UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
          UTC-09:30, UTC-10, and UTC-11.

      - **StartActivity** *(string) --*

        The unique identifier for the first activity in the journey.

      - **StartCondition** *(dict) --*

        The segment that defines which users are participants in the journey.

        - **Description** *(string) --*

          The custom description of the condition.

        - **SegmentStartCondition** *(dict) --*

          The segment that's associated with the first activity in the journey. This segment
          determines which users are participants in the journey.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

      - **State** *(string) --*

        The current status of the journey. Possible values are:

        * DRAFT - The journey is being developed and hasn't been published yet.

        * ACTIVE - The journey has been developed and published. Depending on the journey's
        schedule, the journey may currently be running or scheduled to start running at a later
        time. If a journey's status is ACTIVE, you can't add, change, or remove activities from it.

        * COMPLETED - The journey has been published and has finished running. All participants have
        entered the journey and no participants are waiting to complete the journey or any
        activities in the journey.

        * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't
        add, change, or remove activities or segment settings from the journey.

        * CLOSED - The journey has been published and has started running. It may have also passed
        its scheduled end time, or passed its scheduled start time and a refresh frequency hasn't
        been specified for it. If a journey's status is CLOSED, you can't add participants to it,
        and no existing participants can enter the journey for the first time. However, any existing
        participants who are currently waiting to start an activity may resume the journey.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the journey. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_ClientUpdateJourneyStateJourneyStateRequestTypeDef = TypedDict(
    "_ClientUpdateJourneyStateJourneyStateRequestTypeDef", {"State": str}, total=False
)


class ClientUpdateJourneyStateJourneyStateRequestTypeDef(
    _ClientUpdateJourneyStateJourneyStateRequestTypeDef
):
    """
    Type definition for `ClientUpdateJourneyState` `JourneyStateRequest`

    Changes the status of a journey.

    - **State** *(string) --*

      The status of the journey. Currently, the only supported value is CANCELLED.

      If you cancel a journey, Amazon Pinpoint continues to perform activities that are currently in
      progress, until those activities are complete. Amazon Pinpoint also continues to collect and
      aggregate analytics data for those activities, until they are complete, and any activities
      that were complete when you cancelled the journey.

      After you cancel a journey, you can't add, change, or remove any activities from the journey.
      In addition, Amazon Pinpoint stops evaluating the journey and doesn't perform any activities
      that haven't started.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitCondition`
    `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --*

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --*

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --*

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --*

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --*

                  The latitude coordinate of the location.

                - **Longitude** *(float) --*

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivities`
    `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAIL`
    `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --*

      The percentage of participants who shouldn't continue the journey.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --*

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranches` `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --*

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiCondition`
    `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --*

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --*

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --*

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --*

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --*

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplit`
    `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponse` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --*

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --*

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --*

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponse` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponse` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponse` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponseStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --*

      The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponseJourneyResponse` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --*

        The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyStateResponseJourneyResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef,
        "State": str,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseTypeDef
):
    """
    Type definition for `ClientUpdateJourneyStateResponse` `JourneyResponse`

    Provides information about the status, configuration, and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --*

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --*

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --*

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --*

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --*

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --*

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --*

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --*

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --*

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --*

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --*

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the journey applies to.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **Id** *(string) --*

      The unique identifier for the journey.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. If this value is true, the schedule uses each participant's local time.

    - **Name** *(string) --*

      The name of the journey.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --*

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The current status of the journey. Possible values are:

      * DRAFT - The journey is being developed and hasn't been published yet.

      * ACTIVE - The journey has been developed and published. Depending on the journey's schedule,
      the journey may currently be running or scheduled to start running at a later time. If a
      journey's status is ACTIVE, you can't add, change, or remove activities from it.

      * COMPLETED - The journey has been published and has finished running. All participants have
      entered the journey and no participants are waiting to complete the journey or any activities
      in the journey.

      * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't add,
      change, or remove activities or segment settings from the journey.

      * CLOSED - The journey has been published and has started running. It may have also passed its
      scheduled end time, or passed its scheduled start time and a refresh frequency hasn't been
      specified for it. If a journey's status is CLOSED, you can't add participants to it, and no
      existing participants can enter the journey for the first time. However, any existing
      participants who are currently waiting to start an activity may resume the journey.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the journey. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientUpdateJourneyStateResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseTypeDef",
    {"JourneyResponse": ClientUpdateJourneyStateResponseJourneyResponseTypeDef},
    total=False,
)


class ClientUpdateJourneyStateResponseTypeDef(_ClientUpdateJourneyStateResponseTypeDef):
    """
    Type definition for `ClientUpdateJourneyState` `Response`

    The request succeeded.

    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.

      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.

        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.

            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.

              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.

                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.

                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                - **Operator** *(string) --*

                  Specifies how to handle multiple conditions for the activity. For example, if you
                  specify two conditions for an activity, whether both or only one of the conditions
                  must be met for the activity to be performed.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait before determining whether the conditions are met, or the
                date and time when Amazon Pinpoint determines whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

              - **FalseActivity** *(string) --*

                The unique identifier for the activity to perform if the condition isn't met.

              - **TrueActivity** *(string) --*

                The unique identifier for the activity to perform if the condition is met.

            - **Description** *(string) --*

              The custom description of the activity.

            - **EMAIL** *(dict) --*

              The settings for an email activity. This type of activity sends an email message to
              participants.

              - **MessageConfig** *(dict) --*

                The "From" address to use for the message.

                - **FromAddress** *(string) --*

                  The verified email address to send the email message from. The default address is
                  the FromAddress specified for the email channel for the application.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after the message is sent.

              - **TemplateName** *(string) --*

                The name of the email template to use for the message.

            - **Holdout** *(dict) --*

              The settings for a holdout activity. This type of activity stops a journey for a
              specified percentage of participants.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the holdout
                activity.

              - **Percentage** *(integer) --*

                The percentage of participants who shouldn't continue the journey.

            - **MultiCondition** *(dict) --*

              The settings for a multivariate split activity. This type of activity sends
              participants down one of as many as five paths in a journey, based on conditions that
              you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the conditions for entering each path and the
                activity to perform for each path.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity path in a journey.

                  - **Condition** *(dict) --*

                    The condition to evaluate for the activity path.

                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.

                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.

                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.

                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.

                              - **Values** *(list) --*

                                The criteria values to use for the segment dimension. Depending on
                                the value of the AttributeType property, endpoints are included or
                                excluded from the segment if their attribute values match the
                                criteria values.

                                - *(string) --*

                        - **EventType** *(dict) --*

                          The name of the event that causes the campaign to be sent or the journey
                          activity to be performed. This can be a standard type of event that Amazon
                          Pinpoint generates, such as _email.delivered, or a custom event that's
                          specific to your application.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Metrics** *(dict) --*

                          One or more custom metrics that your application reports to Amazon
                          Pinpoint. You can use these metrics as selection criteria when you create
                          an event filter.

                          - *(string) --*

                            - *(dict) --*

                              Specifies metric-based criteria for including or excluding endpoints
                              from a segment. These criteria derive from custom metrics that you
                              define for endpoints.

                              - **ComparisonOperator** *(string) --*

                                The operator to use when comparing metric values. Valid values are:
                                GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                                and EQUAL.

                              - **Value** *(float) --*

                                The value to compare.

                      - **MessageActivity** *(string) --*

                        The message identifier (message_id) for the message to use when determining
                        whether message events meet the condition.

                    - **SegmentCondition** *(dict) --*

                      The segment that's associated with the activity.

                      - **SegmentId** *(string) --*

                        The unique identifier for the segment to associate with the activity.

                    - **SegmentDimensions** *(dict) --*

                      The dimension settings for the segment that's associated with the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **Behavior** *(dict) --*

                        The behavior-based criteria, such as how recently users have used your app,
                        for the segment.

                        - **Recency** *(dict) --*

                          The dimension settings that are based on how recently an endpoint was
                          active.

                          - **Duration** *(string) --*

                            The duration to use when determining whether an endpoint is active or
                            inactive.

                          - **RecencyType** *(string) --*

                            The type of recency dimension to use for the segment. Valid values are:
                            ACTIVE, endpoints that were active within the specified duration are
                            included in the segment; and, INACTIVE, endpoints that weren't active
                            within the specified duration are included in the segment.

                      - **Demographic** *(dict) --*

                        The demographic-based criteria, such as device platform, for the segment.

                        - **AppVersion** *(dict) --*

                          The app version criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Channel** *(dict) --*

                          The channel criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **DeviceType** *(dict) --*

                          The device type criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Make** *(dict) --*

                          The device make criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Model** *(dict) --*

                          The device model criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **Platform** *(dict) --*

                          The device platform criteria for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                      - **Location** *(dict) --*

                        The location-based criteria, such as region or GPS coordinates, for the
                        segment.

                        - **Country** *(dict) --*

                          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                          - **DimensionType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --*

                            The criteria values to use for the segment dimension. Depending on the
                            value of the DimensionType property, endpoints are included or excluded
                            from the segment if their values match the criteria values.

                            - *(string) --*

                        - **GPSPoint** *(dict) --*

                          The GPS location and range for the segment.

                          - **Coordinates** *(dict) --*

                            The GPS coordinates to measure distance from.

                            - **Latitude** *(float) --*

                              The latitude coordinate of the location.

                            - **Longitude** *(float) --*

                              The longitude coordinate of the location.

                          - **RangeInKilometers** *(float) --*

                            The range, in kilometers, from the GPS coordinates.

                      - **Metrics** *(dict) --*

                        One or more custom metrics to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --*

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --*

                              The value to compare.

                      - **UserAttributes** *(dict) --*

                        One or more custom user attributes to use as criteria for the segment.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --*

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

              - **DefaultActivity** *(string) --*

                The activity to perform by default for any path in the activity.

              - **EvaluationWaitTime** *(dict) --*

                The amount of time to wait or the date and time when Amazon Pinpoint determines
                whether the conditions are met.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

            - **RandomSplit** *(dict) --*

              The settings for a random split activity. This type of activity randomly sends
              specified percentages of participants down one of as many as five paths in a journey,
              based on conditions that you specify.

              - **Branches** *(list) --*

                The paths for the activity, including the percentage of participants to enter each
                path and the activity to perform for each path.

                - *(dict) --*

                  Specifies the settings for a path in a random split activity in a journey.

                  - **NextActivity** *(string) --*

                    The unique identifier for the next activity to perform, after completing the
                    activity for the path.

                  - **Percentage** *(integer) --*

                    The percentage of participants to send down the activity path.

            - **Wait** *(dict) --*

              The settings for a wait activity. This type of activity waits for a certain amount of
              time or until a specific date and time before moving participants to the next activity
              in a journey.

              - **NextActivity** *(string) --*

                The unique identifier for the next activity to perform, after performing the wait
                activity.

              - **WaitTime** *(dict) --*

                The amount of time to wait or the date and time when the activity moves participants
                to the next activity in the journey.

                - **WaitFor** *(string) --*

                  The amount of time to wait, as a duration in ISO 8601 format, before determining
                  whether the activity's conditions have been met or moving participants to the next
                  activity in the journey.

                - **WaitUntil** *(string) --*

                  The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                  activity's conditions have been met or the activity moves participants to the next
                  activity in the journey.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the journey applies to.

      - **CreationDate** *(string) --*

        The date, in ISO 8601 format, when the journey was created.

      - **Id** *(string) --*

        The unique identifier for the journey.

      - **LastModifiedDate** *(string) --*

        The date, in ISO 8601 format, when the journey was last modified.

      - **Limits** *(dict) --*

        The messaging and entry limits for the journey.

        - **DailyCap** *(integer) --*

          The maximum number of messages that the journey can send to a single participant during a
          24-hour period. The maximum value is 100.

        - **EndpointReentryCap** *(integer) --*

          The maximum number of times that a participant can enter the journey. The maximum value is
          100. To allow participants to enter the journey an unlimited number of times, set this
          value to 0.

        - **MessagesPerSecond** *(integer) --*

          The maximum number of messages that the journey can send each second.

      - **LocalTime** *(boolean) --*

        Specifies whether the journey's scheduled start and end times use each participant's local
        time. If this value is true, the schedule uses each participant's local time.

      - **Name** *(string) --*

        The name of the journey.

      - **QuietTime** *(dict) --*

        The quiet time settings for the journey. Quiet time is a specific time range when a journey
        doesn't send messages to participants, if all the following conditions are met:

        * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
        valid value.

        * The current time in the participant's time zone is later than or equal to the time
        specified by the QuietTime.Start property for the journey.

        * The current time in the participant's time zone is earlier than or equal to the time
        specified by the QuietTime.End property for the journey.

        If any of the preceding conditions isn't met, the participant will receive messages from the
        journey, even if quiet time is enabled.

        - **End** *(string) --*

          The specific time when quiet time ends. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

        - **Start** *(string) --*

          The specific time when quiet time begins. This value has to use 24-hour notation and be in
          HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
          minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **RefreshFrequency** *(string) --*

        The frequency with which Amazon Pinpoint evaluates segment and event data for the journey,
        as a duration in ISO 8601 format.

      - **Schedule** *(dict) --*

        The schedule settings for the journey.

        - **EndTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey ended or will end.

        - **StartTime** *(datetime) --*

          The scheduled time, in ISO 8601 format, when the journey began or will begin.

        - **Timezone** *(string) --*

          The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
          property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
          UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
          UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45,
          UTC-02, UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09,
          UTC-09:30, UTC-10, and UTC-11.

      - **StartActivity** *(string) --*

        The unique identifier for the first activity in the journey.

      - **StartCondition** *(dict) --*

        The segment that defines which users are participants in the journey.

        - **Description** *(string) --*

          The custom description of the condition.

        - **SegmentStartCondition** *(dict) --*

          The segment that's associated with the first activity in the journey. This segment
          determines which users are participants in the journey.

          - **SegmentId** *(string) --*

            The unique identifier for the segment to associate with the activity.

      - **State** *(string) --*

        The current status of the journey. Possible values are:

        * DRAFT - The journey is being developed and hasn't been published yet.

        * ACTIVE - The journey has been developed and published. Depending on the journey's
        schedule, the journey may currently be running or scheduled to start running at a later
        time. If a journey's status is ACTIVE, you can't add, change, or remove activities from it.

        * COMPLETED - The journey has been published and has finished running. All participants have
        entered the journey and no participants are waiting to complete the journey or any
        activities in the journey.

        * CANCELLED - The journey has been stopped. If a journey's status is CANCELLED, you can't
        add, change, or remove activities or segment settings from the journey.

        * CLOSED - The journey has been published and has started running. It may have also passed
        its scheduled end time, or passed its scheduled start time and a refresh frequency hasn't
        been specified for it. If a journey's status is CLOSED, you can't add participants to it,
        and no existing participants can enter the journey for the first time. However, any existing
        participants who are currently waiting to start an activity may resume the journey.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the journey. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
    },
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {"MessageActivity": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditions`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditions`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --* **[REQUIRED]**

      The unique identifier for the segment to associate with the activity.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditions`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitCondition`
    `Conditions`

    Specifies a condition to evaluate for an activity in a journey.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --* **[REQUIRED]**

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --* **[REQUIRED]**

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --* **[REQUIRED]**

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --* **[REQUIRED]**

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --* **[REQUIRED]**

              The latitude coordinate of the location.

            - **Longitude** *(float) --* **[REQUIRED]**

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplit`
    `Condition`

    The conditions that define the paths for the activity, and the relationship between the
    conditions.

    - **Conditions** *(list) --*

      The conditions to evaluate for the activity.

      - *(dict) --*

        Specifies a condition to evaluate for an activity in a journey.

        - **EventCondition** *(dict) --*

          The dimension settings for the event that's associated with the activity.

          - **Dimensions** *(dict) --* **[REQUIRED]**

            The dimensions for the event filter to use for the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes that your application reports to Amazon Pinpoint. You
              can use these attributes as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **EventType** *(dict) --*

              The name of the event that causes the campaign to be sent or the journey activity to
              be performed. This can be a standard type of event that Amazon Pinpoint generates,
              such as _email.delivered, or a custom event that's specific to your application.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Metrics** *(dict) --*

              One or more custom metrics that your application reports to Amazon Pinpoint. You can
              use these metrics as selection criteria when you create an event filter.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

          - **MessageActivity** *(string) --*

            The message identifier (message_id) for the message to use when determining whether
            message events meet the condition.

        - **SegmentCondition** *(dict) --*

          The segment that's associated with the activity.

          - **SegmentId** *(string) --* **[REQUIRED]**

            The unique identifier for the segment to associate with the activity.

        - **SegmentDimensions** *(dict) --*

          The dimension settings for the segment that's associated with the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **Behavior** *(dict) --*

            The behavior-based criteria, such as how recently users have used your app, for the
            segment.

            - **Recency** *(dict) --*

              The dimension settings that are based on how recently an endpoint was active.

              - **Duration** *(string) --* **[REQUIRED]**

                The duration to use when determining whether an endpoint is active or inactive.

              - **RecencyType** *(string) --* **[REQUIRED]**

                The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                endpoints that were active within the specified duration are included in the
                segment; and, INACTIVE, endpoints that weren't active within the specified duration
                are included in the segment.

          - **Demographic** *(dict) --*

            The demographic-based criteria, such as device platform, for the segment.

            - **AppVersion** *(dict) --*

              The app version criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Channel** *(dict) --*

              The channel criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **DeviceType** *(dict) --*

              The device type criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Make** *(dict) --*

              The device make criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Model** *(dict) --*

              The device model criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **Platform** *(dict) --*

              The device platform criteria for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

          - **Location** *(dict) --*

            The location-based criteria, such as region or GPS coordinates, for the segment.

            - **Country** *(dict) --*

              The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

              - **DimensionType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                DimensionType property, endpoints are included or excluded from the segment if their
                values match the criteria values.

                - *(string) --*

            - **GPSPoint** *(dict) --*

              The GPS location and range for the segment.

              - **Coordinates** *(dict) --* **[REQUIRED]**

                The GPS coordinates to measure distance from.

                - **Latitude** *(float) --* **[REQUIRED]**

                  The latitude coordinate of the location.

                - **Longitude** *(float) --* **[REQUIRED]**

                  The longitude coordinate of the location.

              - **RangeInKilometers** *(float) --*

                The range, in kilometers, from the GPS coordinates.

          - **Metrics** *(dict) --*

            One or more custom metrics to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

          - **UserAttributes** *(dict) --*

            One or more custom user attributes to use as criteria for the segment.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

    - **Operator** *(string) --*

      Specifies how to handle multiple conditions for the activity. For example, if you specify two
      conditions for an activity, whether both or only one of the conditions must be met for the
      activity to be performed.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplit`
    `EvaluationWaitTime`

    The amount of time to wait before determining whether the conditions are met, or the date and
    time when Amazon Pinpoint determines whether the conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivities` `ConditionalSplit`

    The settings for a yes/no split activity. This type of activity sends participants down one of
    two paths in a journey, based on conditions that you specify.

    - **Condition** *(dict) --*

      The conditions that define the paths for the activity, and the relationship between the
      conditions.

      - **Conditions** *(list) --*

        The conditions to evaluate for the activity.

        - *(dict) --*

          Specifies a condition to evaluate for an activity in a journey.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --* **[REQUIRED]**

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --* **[REQUIRED]**

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --* **[REQUIRED]**

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --* **[REQUIRED]**

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --* **[REQUIRED]**

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --* **[REQUIRED]**

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --* **[REQUIRED]**

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

      - **Operator** *(string) --*

        Specifies how to handle multiple conditions for the activity. For example, if you specify
        two conditions for an activity, whether both or only one of the conditions must be met for
        the activity to be performed.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait before determining whether the conditions are met, or the date and
      time when Amazon Pinpoint determines whether the conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.

    - **FalseActivity** *(string) --*

      The unique identifier for the activity to perform if the condition isn't met.

    - **TrueActivity** *(string) --*

      The unique identifier for the activity to perform if the condition is met.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesEMAIL` `MessageConfig`

    The "From" address to use for the message.

    - **FromAddress** *(string) --*

      The verified email address to send the email message from. The default address is the
      FromAddress specified for the email channel for the application.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivities` `EMAIL`

    The settings for an email activity. This type of activity sends an email message to
    participants.

    - **MessageConfig** *(dict) --*

      The "From" address to use for the message.

      - **FromAddress** *(string) --*

        The verified email address to send the email message from. The default address is the
        FromAddress specified for the email channel for the application.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after the message is sent.

    - **TemplateName** *(string) --*

      The name of the email template to use for the message.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef", {"Percentage": int}
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    {"NextActivity": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivities` `Holdout`

    The settings for a holdout activity. This type of activity stops a journey for a specified
    percentage of participants.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the holdout activity.

    - **Percentage** *(integer) --* **[REQUIRED]**

      The percentage of participants who shouldn't continue the journey.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `EventType`

    The name of the event that causes the campaign to be sent or the journey activity to be
    performed. This can be a standard type of event that Amazon Pinpoint generates, such as
    _email.delivered, or a custom event that's specific to your application.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventCondition`
    `Dimensions`

    The dimensions for the event filter to use for the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes that your application reports to Amazon Pinpoint. You can use
      these attributes as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **EventType** *(dict) --*

      The name of the event that causes the campaign to be sent or the journey activity to be
      performed. This can be a standard type of event that Amazon Pinpoint generates, such as
      _email.delivered, or a custom event that's specific to your application.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Metrics** *(dict) --*

      One or more custom metrics that your application reports to Amazon Pinpoint. You can use these
      metrics as selection criteria when you create an event filter.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
    },
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {"MessageActivity": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesCondition`
    `EventCondition`

    The dimension settings for the event that's associated with the activity.

    - **Dimensions** *(dict) --* **[REQUIRED]**

      The dimensions for the event filter to use for the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes that your application reports to Amazon Pinpoint. You can use
        these attributes as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **EventType** *(dict) --*

        The name of the event that causes the campaign to be sent or the journey activity to be
        performed. This can be a standard type of event that Amazon Pinpoint generates, such as
        _email.delivered, or a custom event that's specific to your application.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Metrics** *(dict) --*

        One or more custom metrics that your application reports to Amazon Pinpoint. You can use
        these metrics as selection criteria when you create an event filter.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

    - **MessageActivity** *(string) --*

      The message identifier (message_id) for the message to use when determining whether message
      events meet the condition.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesCondition`
    `SegmentCondition`

    The segment that's associated with the activity.

    - **SegmentId** *(string) --* **[REQUIRED]**

      The unique identifier for the segment to associate with the activity.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehavior`
    `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographic`
    `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocation`
    `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    """
    Type definition for
    `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesCondition`
    `SegmentDimensions`

    The dimension settings for the segment that's associated with the activity.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranches`
    `Condition`

    The condition to evaluate for the activity path.

    - **EventCondition** *(dict) --*

      The dimension settings for the event that's associated with the activity.

      - **Dimensions** *(dict) --* **[REQUIRED]**

        The dimensions for the event filter to use for the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes that your application reports to Amazon Pinpoint. You can
          use these attributes as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **EventType** *(dict) --*

          The name of the event that causes the campaign to be sent or the journey activity to be
          performed. This can be a standard type of event that Amazon Pinpoint generates, such as
          _email.delivered, or a custom event that's specific to your application.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Metrics** *(dict) --*

          One or more custom metrics that your application reports to Amazon Pinpoint. You can use
          these metrics as selection criteria when you create an event filter.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

      - **MessageActivity** *(string) --*

        The message identifier (message_id) for the message to use when determining whether message
        events meet the condition.

    - **SegmentCondition** *(dict) --*

      The segment that's associated with the activity.

      - **SegmentId** *(string) --* **[REQUIRED]**

        The unique identifier for the segment to associate with the activity.

    - **SegmentDimensions** *(dict) --*

      The dimension settings for the segment that's associated with the activity.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --* **[REQUIRED]**

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --* **[REQUIRED]**

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --* **[REQUIRED]**

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --* **[REQUIRED]**

              The latitude coordinate of the location.

            - **Longitude** *(float) --* **[REQUIRED]**

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiCondition` `Branches`

    Specifies a condition to evaluate for an activity path in a journey.

    - **Condition** *(dict) --*

      The condition to evaluate for the activity path.

      - **EventCondition** *(dict) --*

        The dimension settings for the event that's associated with the activity.

        - **Dimensions** *(dict) --* **[REQUIRED]**

          The dimensions for the event filter to use for the activity.

          - **Attributes** *(dict) --*

            One or more custom attributes that your application reports to Amazon Pinpoint. You can
            use these attributes as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies attribute-based criteria for including or excluding endpoints from a
                segment.

                - **AttributeType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the AttributeType property, endpoints are included or excluded from the segment if
                  their attribute values match the criteria values.

                  - *(string) --*

          - **EventType** *(dict) --*

            The name of the event that causes the campaign to be sent or the journey activity to be
            performed. This can be a standard type of event that Amazon Pinpoint generates, such as
            _email.delivered, or a custom event that's specific to your application.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Metrics** *(dict) --*

            One or more custom metrics that your application reports to Amazon Pinpoint. You can use
            these metrics as selection criteria when you create an event filter.

            - *(string) --*

              - *(dict) --*

                Specifies metric-based criteria for including or excluding endpoints from a segment.
                These criteria derive from custom metrics that you define for endpoints.

                - **ComparisonOperator** *(string) --* **[REQUIRED]**

                  The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                  LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                - **Value** *(float) --* **[REQUIRED]**

                  The value to compare.

        - **MessageActivity** *(string) --*

          The message identifier (message_id) for the message to use when determining whether
          message events meet the condition.

      - **SegmentCondition** *(dict) --*

        The segment that's associated with the activity.

        - **SegmentId** *(string) --* **[REQUIRED]**

          The unique identifier for the segment to associate with the activity.

      - **SegmentDimensions** *(dict) --*

        The dimension settings for the segment that's associated with the activity.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --* **[REQUIRED]**

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --* **[REQUIRED]**

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --* **[REQUIRED]**

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --* **[REQUIRED]**

                The latitude coordinate of the location.

              - **Longitude** *(float) --* **[REQUIRED]**

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesMultiCondition`
    `EvaluationWaitTime`

    The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
    conditions are met.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivities` `MultiCondition`

    The settings for a multivariate split activity. This type of activity sends participants down
    one of as many as five paths in a journey, based on conditions that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the conditions for entering each path and the activity
      to perform for each path.

      - *(dict) --*

        Specifies a condition to evaluate for an activity path in a journey.

        - **Condition** *(dict) --*

          The condition to evaluate for the activity path.

          - **EventCondition** *(dict) --*

            The dimension settings for the event that's associated with the activity.

            - **Dimensions** *(dict) --* **[REQUIRED]**

              The dimensions for the event filter to use for the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes that your application reports to Amazon Pinpoint. You
                can use these attributes as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **EventType** *(dict) --*

                The name of the event that causes the campaign to be sent or the journey activity to
                be performed. This can be a standard type of event that Amazon Pinpoint generates,
                such as _email.delivered, or a custom event that's specific to your application.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Metrics** *(dict) --*

                One or more custom metrics that your application reports to Amazon Pinpoint. You can
                use these metrics as selection criteria when you create an event filter.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

            - **MessageActivity** *(string) --*

              The message identifier (message_id) for the message to use when determining whether
              message events meet the condition.

          - **SegmentCondition** *(dict) --*

            The segment that's associated with the activity.

            - **SegmentId** *(string) --* **[REQUIRED]**

              The unique identifier for the segment to associate with the activity.

          - **SegmentDimensions** *(dict) --*

            The dimension settings for the segment that's associated with the activity.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --* **[REQUIRED]**

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --* **[REQUIRED]**

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --* **[REQUIRED]**

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --* **[REQUIRED]**

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --* **[REQUIRED]**

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

    - **DefaultActivity** *(string) --*

      The activity to perform by default for any path in the activity.

    - **EvaluationWaitTime** *(dict) --*

      The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
      conditions are met.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplit` `Branches`

    Specifies the settings for a path in a random split activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after completing the activity for the
      path.

    - **Percentage** *(integer) --*

      The percentage of participants to send down the activity path.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    {"Branches": List[ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivities` `RandomSplit`

    The settings for a random split activity. This type of activity randomly sends specified
    percentages of participants down one of as many as five paths in a journey, based on conditions
    that you specify.

    - **Branches** *(list) --*

      The paths for the activity, including the percentage of participants to enter each path and
      the activity to perform for each path.

      - *(dict) --*

        Specifies the settings for a path in a random split activity in a journey.

        - **NextActivity** *(string) --*

          The unique identifier for the next activity to perform, after completing the activity for
          the path.

        - **Percentage** *(integer) --*

          The percentage of participants to send down the activity path.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivitiesWait` `WaitTime`

    The amount of time to wait or the date and time when the activity moves participants to the next
    activity in the journey.

    - **WaitFor** *(string) --*

      The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
      activity's conditions have been met or moving participants to the next activity in the
      journey.

    - **WaitUntil** *(string) --*

      The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the activity's
      conditions have been met or the activity moves participants to the next activity in the
      journey.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestActivities` `Wait`

    The settings for a wait activity. This type of activity waits for a certain amount of time or
    until a specific date and time before moving participants to the next activity in a journey.

    - **NextActivity** *(string) --*

      The unique identifier for the next activity to perform, after performing the wait activity.

    - **WaitTime** *(dict) --*

      The amount of time to wait or the date and time when the activity moves participants to the
      next activity in the journey.

      - **WaitFor** *(string) --*

        The amount of time to wait, as a duration in ISO 8601 format, before determining whether the
        activity's conditions have been met or moving participants to the next activity in the
        journey.

      - **WaitUntil** *(string) --*

        The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
        activity's conditions have been met or the activity moves participants to the next activity
        in the journey.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef",
    {
        "ConditionalSplit": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef,
        "Holdout": ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
        "MultiCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef,
        "Wait": ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequest` `Activities`

    Specifies the configuration and other settings for an activity in a journey.

    - **ConditionalSplit** *(dict) --*

      The settings for a yes/no split activity. This type of activity sends participants down one of
      two paths in a journey, based on conditions that you specify.

      - **Condition** *(dict) --*

        The conditions that define the paths for the activity, and the relationship between the
        conditions.

        - **Conditions** *(list) --*

          The conditions to evaluate for the activity.

          - *(dict) --*

            Specifies a condition to evaluate for an activity in a journey.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --* **[REQUIRED]**

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --* **[REQUIRED]**

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --* **[REQUIRED]**

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --* **[REQUIRED]**

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --* **[REQUIRED]**

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --* **[REQUIRED]**

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --* **[REQUIRED]**

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --* **[REQUIRED]**

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --* **[REQUIRED]**

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --* **[REQUIRED]**

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

        - **Operator** *(string) --*

          Specifies how to handle multiple conditions for the activity. For example, if you specify
          two conditions for an activity, whether both or only one of the conditions must be met for
          the activity to be performed.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait before determining whether the conditions are met, or the date
        and time when Amazon Pinpoint determines whether the conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

      - **FalseActivity** *(string) --*

        The unique identifier for the activity to perform if the condition isn't met.

      - **TrueActivity** *(string) --*

        The unique identifier for the activity to perform if the condition is met.

    - **Description** *(string) --*

      The custom description of the activity.

    - **EMAIL** *(dict) --*

      The settings for an email activity. This type of activity sends an email message to
      participants.

      - **MessageConfig** *(dict) --*

        The "From" address to use for the message.

        - **FromAddress** *(string) --*

          The verified email address to send the email message from. The default address is the
          FromAddress specified for the email channel for the application.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after the message is sent.

      - **TemplateName** *(string) --*

        The name of the email template to use for the message.

    - **Holdout** *(dict) --*

      The settings for a holdout activity. This type of activity stops a journey for a specified
      percentage of participants.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the holdout
        activity.

      - **Percentage** *(integer) --* **[REQUIRED]**

        The percentage of participants who shouldn't continue the journey.

    - **MultiCondition** *(dict) --*

      The settings for a multivariate split activity. This type of activity sends participants down
      one of as many as five paths in a journey, based on conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the conditions for entering each path and the activity
        to perform for each path.

        - *(dict) --*

          Specifies a condition to evaluate for an activity path in a journey.

          - **Condition** *(dict) --*

            The condition to evaluate for the activity path.

            - **EventCondition** *(dict) --*

              The dimension settings for the event that's associated with the activity.

              - **Dimensions** *(dict) --* **[REQUIRED]**

                The dimensions for the event filter to use for the activity.

                - **Attributes** *(dict) --*

                  One or more custom attributes that your application reports to Amazon Pinpoint.
                  You can use these attributes as selection criteria when you create an event
                  filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --* **[REQUIRED]**

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **EventType** *(dict) --*

                  The name of the event that causes the campaign to be sent or the journey activity
                  to be performed. This can be a standard type of event that Amazon Pinpoint
                  generates, such as _email.delivered, or a custom event that's specific to your
                  application.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Metrics** *(dict) --*

                  One or more custom metrics that your application reports to Amazon Pinpoint. You
                  can use these metrics as selection criteria when you create an event filter.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --* **[REQUIRED]**

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --* **[REQUIRED]**

                        The value to compare.

              - **MessageActivity** *(string) --*

                The message identifier (message_id) for the message to use when determining whether
                message events meet the condition.

            - **SegmentCondition** *(dict) --*

              The segment that's associated with the activity.

              - **SegmentId** *(string) --* **[REQUIRED]**

                The unique identifier for the segment to associate with the activity.

            - **SegmentDimensions** *(dict) --*

              The dimension settings for the segment that's associated with the activity.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --* **[REQUIRED]**

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --* **[REQUIRED]**

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --* **[REQUIRED]**

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --* **[REQUIRED]**

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --* **[REQUIRED]**

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

      - **DefaultActivity** *(string) --*

        The activity to perform by default for any path in the activity.

      - **EvaluationWaitTime** *(dict) --*

        The amount of time to wait or the date and time when Amazon Pinpoint determines whether the
        conditions are met.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.

    - **RandomSplit** *(dict) --*

      The settings for a random split activity. This type of activity randomly sends specified
      percentages of participants down one of as many as five paths in a journey, based on
      conditions that you specify.

      - **Branches** *(list) --*

        The paths for the activity, including the percentage of participants to enter each path and
        the activity to perform for each path.

        - *(dict) --*

          Specifies the settings for a path in a random split activity in a journey.

          - **NextActivity** *(string) --*

            The unique identifier for the next activity to perform, after completing the activity
            for the path.

          - **Percentage** *(integer) --*

            The percentage of participants to send down the activity path.

    - **Wait** *(dict) --*

      The settings for a wait activity. This type of activity waits for a certain amount of time or
      until a specific date and time before moving participants to the next activity in a journey.

      - **NextActivity** *(string) --*

        The unique identifier for the next activity to perform, after performing the wait activity.

      - **WaitTime** *(dict) --*

        The amount of time to wait or the date and time when the activity moves participants to the
        next activity in the journey.

        - **WaitFor** *(string) --*

          The amount of time to wait, as a duration in ISO 8601 format, before determining whether
          the activity's conditions have been met or moving participants to the next activity in the
          journey.

        - **WaitUntil** *(string) --*

          The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
          activity's conditions have been met or the activity moves participants to the next
          activity in the journey.
    """


_ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequest` `Limits`

    The messaging and entry limits for the journey.

    - **DailyCap** *(integer) --*

      The maximum number of messages that the journey can send to a single participant during a
      24-hour period. The maximum value is 100.

    - **EndpointReentryCap** *(integer) --*

      The maximum number of times that a participant can enter the journey. The maximum value is
      100. To allow participants to enter the journey an unlimited number of times, set this value
      to 0.

    - **MessagesPerSecond** *(integer) --*

      The maximum number of messages that the journey can send each second.
    """


_ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequest` `QuietTime`

    The quiet time settings for the journey. Quiet time is a specific time range when a journey
    doesn't send messages to participants, if all the following conditions are met:

    * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
    valid value.

    * The current time in the participant's time zone is later than or equal to the time specified
    by the QuietTime.Start property for the journey.

    * The current time in the participant's time zone is earlier than or equal to the time specified
    by the QuietTime.End property for the journey.

    If any of the preceding conditions isn't met, the participant will receive messages from the
    journey, even if quiet time is enabled.

    - **End** *(string) --*

      The specific time when quiet time ends. This value has to use 24-hour notation and be in HH:MM
      format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes. For
      example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **Start** *(string) --*

      The specific time when quiet time begins. This value has to use 24-hour notation and be in
      HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the minutes.
      For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.
    """


_ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequest` `Schedule`

    The schedule settings for the journey.

    - **EndTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey ended or will end.

    - **StartTime** *(datetime) --*

      The scheduled time, in ISO 8601 format, when the journey began or will begin.

    - **Timezone** *(string) --*

      The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
      property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04, UTC+04:30,
      UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45, UTC+09, UTC+09:30,
      UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02, UTC-02:30, UTC-03,
      UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30, UTC-10, and UTC-11.
    """


_ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
)


class ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequestStartCondition`
    `SegmentStartCondition`

    The segment that's associated with the first activity in the journey. This segment determines
    which users are participants in the journey.

    - **SegmentId** *(string) --* **[REQUIRED]**

      The unique identifier for the segment to associate with the activity.
    """


_ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef
):
    """
    Type definition for `ClientUpdateJourneyWriteJourneyRequest` `StartCondition`

    The segment that defines which users are participants in the journey.

    - **Description** *(string) --*

      The custom description of the condition.

    - **SegmentStartCondition** *(dict) --*

      The segment that's associated with the first activity in the journey. This segment determines
      which users are participants in the journey.

      - **SegmentId** *(string) --* **[REQUIRED]**

        The unique identifier for the segment to associate with the activity.
    """


_RequiredClientUpdateJourneyWriteJourneyRequestTypeDef = TypedDict(
    "_RequiredClientUpdateJourneyWriteJourneyRequestTypeDef", {"Name": str}
)
_OptionalClientUpdateJourneyWriteJourneyRequestTypeDef = TypedDict(
    "_OptionalClientUpdateJourneyWriteJourneyRequestTypeDef",
    {
        "Activities": Dict[str, ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef],
        "CreationDate": str,
        "LastModifiedDate": str,
        "Limits": ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef,
        "LocalTime": bool,
        "QuietTime": ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef,
        "State": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestTypeDef(
    _RequiredClientUpdateJourneyWriteJourneyRequestTypeDef,
    _OptionalClientUpdateJourneyWriteJourneyRequestTypeDef,
):
    """
    Type definition for `ClientUpdateJourney` `WriteJourneyRequest`

    Specifies the configuration and other settings for a journey.

    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.

      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.

          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.

            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.

              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.

                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --* **[REQUIRED]**

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --* **[REQUIRED]**

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --* **[REQUIRED]**

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --* **[REQUIRED]**

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --* **[REQUIRED]**

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --* **[REQUIRED]**

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --* **[REQUIRED]**

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --* **[REQUIRED]**

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --* **[REQUIRED]**

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --* **[REQUIRED]**

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --* **[REQUIRED]**

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --* **[REQUIRED]**

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

              - **Operator** *(string) --*

                Specifies how to handle multiple conditions for the activity. For example, if you
                specify two conditions for an activity, whether both or only one of the conditions
                must be met for the activity to be performed.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait before determining whether the conditions are met, or the
              date and time when Amazon Pinpoint determines whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

            - **FalseActivity** *(string) --*

              The unique identifier for the activity to perform if the condition isn't met.

            - **TrueActivity** *(string) --*

              The unique identifier for the activity to perform if the condition is met.

          - **Description** *(string) --*

            The custom description of the activity.

          - **EMAIL** *(dict) --*

            The settings for an email activity. This type of activity sends an email message to
            participants.

            - **MessageConfig** *(dict) --*

              The "From" address to use for the message.

              - **FromAddress** *(string) --*

                The verified email address to send the email message from. The default address is
                the FromAddress specified for the email channel for the application.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after the message is sent.

            - **TemplateName** *(string) --*

              The name of the email template to use for the message.

          - **Holdout** *(dict) --*

            The settings for a holdout activity. This type of activity stops a journey for a
            specified percentage of participants.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the holdout
              activity.

            - **Percentage** *(integer) --* **[REQUIRED]**

              The percentage of participants who shouldn't continue the journey.

          - **MultiCondition** *(dict) --*

            The settings for a multivariate split activity. This type of activity sends participants
            down one of as many as five paths in a journey, based on conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the conditions for entering each path and the
              activity to perform for each path.

              - *(dict) --*

                Specifies a condition to evaluate for an activity path in a journey.

                - **Condition** *(dict) --*

                  The condition to evaluate for the activity path.

                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.

                    - **Dimensions** *(dict) --* **[REQUIRED]**

                      The dimensions for the event filter to use for the activity.

                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.

                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.

                            - **Values** *(list) --* **[REQUIRED]**

                              The criteria values to use for the segment dimension. Depending on the
                              value of the AttributeType property, endpoints are included or
                              excluded from the segment if their attribute values match the criteria
                              values.

                              - *(string) --*

                      - **EventType** *(dict) --*

                        The name of the event that causes the campaign to be sent or the journey
                        activity to be performed. This can be a standard type of event that Amazon
                        Pinpoint generates, such as _email.delivered, or a custom event that's
                        specific to your application.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Metrics** *(dict) --*

                        One or more custom metrics that your application reports to Amazon Pinpoint.
                        You can use these metrics as selection criteria when you create an event
                        filter.

                        - *(string) --*

                          - *(dict) --*

                            Specifies metric-based criteria for including or excluding endpoints
                            from a segment. These criteria derive from custom metrics that you
                            define for endpoints.

                            - **ComparisonOperator** *(string) --* **[REQUIRED]**

                              The operator to use when comparing metric values. Valid values are:
                              GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL,
                              and EQUAL.

                            - **Value** *(float) --* **[REQUIRED]**

                              The value to compare.

                    - **MessageActivity** *(string) --*

                      The message identifier (message_id) for the message to use when determining
                      whether message events meet the condition.

                  - **SegmentCondition** *(dict) --*

                    The segment that's associated with the activity.

                    - **SegmentId** *(string) --* **[REQUIRED]**

                      The unique identifier for the segment to associate with the activity.

                  - **SegmentDimensions** *(dict) --*

                    The dimension settings for the segment that's associated with the activity.

                    - **Attributes** *(dict) --*

                      One or more custom attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                    - **Behavior** *(dict) --*

                      The behavior-based criteria, such as how recently users have used your app,
                      for the segment.

                      - **Recency** *(dict) --*

                        The dimension settings that are based on how recently an endpoint was
                        active.

                        - **Duration** *(string) --* **[REQUIRED]**

                          The duration to use when determining whether an endpoint is active or
                          inactive.

                        - **RecencyType** *(string) --* **[REQUIRED]**

                          The type of recency dimension to use for the segment. Valid values are:
                          ACTIVE, endpoints that were active within the specified duration are
                          included in the segment; and, INACTIVE, endpoints that weren't active
                          within the specified duration are included in the segment.

                    - **Demographic** *(dict) --*

                      The demographic-based criteria, such as device platform, for the segment.

                      - **AppVersion** *(dict) --*

                        The app version criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Channel** *(dict) --*

                        The channel criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **DeviceType** *(dict) --*

                        The device type criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Make** *(dict) --*

                        The device make criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Model** *(dict) --*

                        The device model criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **Platform** *(dict) --*

                        The device platform criteria for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                    - **Location** *(dict) --*

                      The location-based criteria, such as region or GPS coordinates, for the
                      segment.

                      - **Country** *(dict) --*

                        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                        - **DimensionType** *(string) --*

                          The type of segment dimension to use. Valid values are: INCLUSIVE,
                          endpoints that match the criteria are included in the segment; and,
                          EXCLUSIVE, endpoints that match the criteria are excluded from the
                          segment.

                        - **Values** *(list) --* **[REQUIRED]**

                          The criteria values to use for the segment dimension. Depending on the
                          value of the DimensionType property, endpoints are included or excluded
                          from the segment if their values match the criteria values.

                          - *(string) --*

                      - **GPSPoint** *(dict) --*

                        The GPS location and range for the segment.

                        - **Coordinates** *(dict) --* **[REQUIRED]**

                          The GPS coordinates to measure distance from.

                          - **Latitude** *(float) --* **[REQUIRED]**

                            The latitude coordinate of the location.

                          - **Longitude** *(float) --* **[REQUIRED]**

                            The longitude coordinate of the location.

                        - **RangeInKilometers** *(float) --*

                          The range, in kilometers, from the GPS coordinates.

                    - **Metrics** *(dict) --*

                      One or more custom metrics to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies metric-based criteria for including or excluding endpoints from
                          a segment. These criteria derive from custom metrics that you define for
                          endpoints.

                          - **ComparisonOperator** *(string) --* **[REQUIRED]**

                            The operator to use when comparing metric values. Valid values are:
                            GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                            EQUAL.

                          - **Value** *(float) --* **[REQUIRED]**

                            The value to compare.

                    - **UserAttributes** *(dict) --*

                      One or more custom user attributes to use as criteria for the segment.

                      - *(string) --*

                        - *(dict) --*

                          Specifies attribute-based criteria for including or excluding endpoints
                          from a segment.

                          - **AttributeType** *(string) --*

                            The type of segment dimension to use. Valid values are: INCLUSIVE,
                            endpoints that match the criteria are included in the segment; and,
                            EXCLUSIVE, endpoints that match the criteria are excluded from the
                            segment.

                          - **Values** *(list) --* **[REQUIRED]**

                            The criteria values to use for the segment dimension. Depending on the
                            value of the AttributeType property, endpoints are included or excluded
                            from the segment if their attribute values match the criteria values.

                            - *(string) --*

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

            - **DefaultActivity** *(string) --*

              The activity to perform by default for any path in the activity.

            - **EvaluationWaitTime** *(dict) --*

              The amount of time to wait or the date and time when Amazon Pinpoint determines
              whether the conditions are met.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

          - **RandomSplit** *(dict) --*

            The settings for a random split activity. This type of activity randomly sends specified
            percentages of participants down one of as many as five paths in a journey, based on
            conditions that you specify.

            - **Branches** *(list) --*

              The paths for the activity, including the percentage of participants to enter each
              path and the activity to perform for each path.

              - *(dict) --*

                Specifies the settings for a path in a random split activity in a journey.

                - **NextActivity** *(string) --*

                  The unique identifier for the next activity to perform, after completing the
                  activity for the path.

                - **Percentage** *(integer) --*

                  The percentage of participants to send down the activity path.

          - **Wait** *(dict) --*

            The settings for a wait activity. This type of activity waits for a certain amount of
            time or until a specific date and time before moving participants to the next activity
            in a journey.

            - **NextActivity** *(string) --*

              The unique identifier for the next activity to perform, after performing the wait
              activity.

            - **WaitTime** *(dict) --*

              The amount of time to wait or the date and time when the activity moves participants
              to the next activity in the journey.

              - **WaitFor** *(string) --*

                The amount of time to wait, as a duration in ISO 8601 format, before determining
                whether the activity's conditions have been met or moving participants to the next
                activity in the journey.

              - **WaitUntil** *(string) --*

                The date and time, in ISO 8601 format, when Amazon Pinpoint determines whether the
                activity's conditions have been met or the activity moves participants to the next
                activity in the journey.

    - **CreationDate** *(string) --*

      The date, in ISO 8601 format, when the journey was created.

    - **LastModifiedDate** *(string) --*

      The date, in ISO 8601 format, when the journey was last modified.

    - **Limits** *(dict) --*

      The messaging and entry limits for the journey.

      - **DailyCap** *(integer) --*

        The maximum number of messages that the journey can send to a single participant during a
        24-hour period. The maximum value is 100.

      - **EndpointReentryCap** *(integer) --*

        The maximum number of times that a participant can enter the journey. The maximum value is
        100. To allow participants to enter the journey an unlimited number of times, set this value
        to 0.

      - **MessagesPerSecond** *(integer) --*

        The maximum number of messages that the journey can send each second.

    - **LocalTime** *(boolean) --*

      Specifies whether the journey's scheduled start and end times use each participant's local
      time. To base the schedule on each participant's local time, set this value to true.

    - **Name** *(string) --* **[REQUIRED]**

      The name of the journey. A journey name can contain a maximum of 150 characters. The
      characters can be alphanumeric characters or symbols, such as underscores (_) or hyphens (-).
      A journey name can't contain any spaces.

    - **QuietTime** *(dict) --*

      The quiet time settings for the journey. Quiet time is a specific time range when a journey
      doesn't send messages to participants, if all the following conditions are met:

      * The EndpointDemographic.Timezone property of the endpoint for the participant is set to a
      valid value.

      * The current time in the participant's time zone is later than or equal to the time specified
      by the QuietTime.Start property for the journey.

      * The current time in the participant's time zone is earlier than or equal to the time
      specified by the QuietTime.End property for the journey.

      If any of the preceding conditions isn't met, the participant will receive messages from the
      journey, even if quiet time is enabled.

      - **End** *(string) --*

        The specific time when quiet time ends. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

      - **Start** *(string) --*

        The specific time when quiet time begins. This value has to use 24-hour notation and be in
        HH:MM format, where HH is the hour (with a leading zero, if applicable) and MM is the
        minutes. For example, use 02:30 to represent 2:30 AM, or 14:30 to represent 2:30 PM.

    - **RefreshFrequency** *(string) --*

      The frequency with which Amazon Pinpoint evaluates segment and event data for the journey, as
      a duration in ISO 8601 format.

    - **Schedule** *(dict) --*

      The schedule settings for the journey.

      - **EndTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey ended or will end.

      - **StartTime** *(datetime) --*

        The scheduled time, in ISO 8601 format, when the journey began or will begin.

      - **Timezone** *(string) --*

        The starting UTC offset for the journey schedule, if the value of the journey's LocalTime
        property is true. Valid values are: UTC, UTC+01, UTC+02, UTC+03, UTC+03:30, UTC+04,
        UTC+04:30, UTC+05, UTC+05:30, UTC+05:45, UTC+06, UTC+06:30, UTC+07, UTC+08, UTC+08:45,
        UTC+09, UTC+09:30, UTC+10, UTC+10:30, UTC+11, UTC+12, UTC+12:45, UTC+13, UTC+13:45, UTC-02,
        UTC-02:30, UTC-03, UTC-03:30, UTC-04, UTC-05, UTC-06, UTC-07, UTC-08, UTC-09, UTC-09:30,
        UTC-10, and UTC-11.

    - **StartActivity** *(string) --*

      The unique identifier for the first activity in the journey.

    - **StartCondition** *(dict) --*

      The segment that defines which users are participants in the journey.

      - **Description** *(string) --*

        The custom description of the condition.

      - **SegmentStartCondition** *(dict) --*

        The segment that's associated with the first activity in the journey. This segment
        determines which users are participants in the journey.

        - **SegmentId** *(string) --* **[REQUIRED]**

          The unique identifier for the segment to associate with the activity.

    - **State** *(string) --*

      The status of the journey. Valid values are:

      * DRAFT - Saves the journey and doesn't publish it.

      * ACTIVE - Saves and publishes the journey. Depending on the journey's schedule, the journey
      starts running immediately or at the scheduled start time. If a journey's status is ACTIVE,
      you can't add, change, or remove activities from it.

      The CANCELLED, COMPLETED, and CLOSED values are not supported in requests to create or update
      a journey. To cancel a journey, use the Journey Stateresource.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef
):
    """
    Type definition for `ClientUpdatePushTemplatePushNotificationTemplateRequest` `ADM`

    The message template to use for the ADM (Amazon Device Messaging) channel. This message template
    overrides the default template for push notification channels (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    {
        "Action": str,
        "Body": str,
        "MediaUrl": str,
        "RawContent": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef
):
    """
    Type definition for `ClientUpdatePushTemplatePushNotificationTemplateRequest` `APNS`

    The message template to use for the APNs (Apple Push Notification service) channel. This message
    template overrides the default template for push notification channels
    (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in push notifications that are based on the message template.

    - **MediaUrl** *(string) --*

      The URL of an image or video to display in push notifications that are based on the message
      template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for push notifications that are based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **Sound** *(string) --*

      The key for the sound to play when the recipient receives a push notification that's based on
      the message template. The value for this key is the name of a sound file in your app's main
      bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
      found or you specify default for the value, the system plays the default alert sound.

    - **Title** *(string) --*

      The title to use in push notifications that are based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in the recipient's default mobile browser, if a recipient taps a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef
):
    """
    Type definition for `ClientUpdatePushTemplatePushNotificationTemplateRequest` `Baidu`

    The message template to use for the Baidu (Baidu Cloud Push) channel. This message template
    overrides the default template for push notification channels (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    {"Action": str, "Body": str, "Sound": str, "Title": str, "Url": str},
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef
):
    """
    Type definition for `ClientUpdatePushTemplatePushNotificationTemplateRequest` `Default`

    The default message template to use for push notification channels.

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This setting
      uses the deep-linking features of the iOS and Android platforms.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in push notifications that are based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      For an iOS platform, this value is the key for the name of a sound file in your app's main
      bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
      found or you specify default for the value, the system plays the default alert sound.

    - **Title** *(string) --*

      The title to use in push notifications that are based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    {
        "Action": str,
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef
):
    """
    Type definition for `ClientUpdatePushTemplatePushNotificationTemplateRequest` `GCM`

    The message template to use for the GCM channel, which is used to send notifications through the
    Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service. This message
    template overrides the default template for push notification channels
    (DefaultPushNotificationTemplate).

    - **Action** *(string) --*

      The action to occur if a recipient taps a push notification that's based on the message
      template. Valid values are:

      * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the background.
      This is the default action.

      * DEEP_LINK - Your app opens and displays a designated user interface in the app. This action
      uses the deep-linking features of the Android platform.

      * URL - The default mobile browser on the recipient's device opens and loads the web page at a
      URL that you specify.

    - **Body** *(string) --*

      The message body to use in a push notification that's based on the message template.

    - **ImageIconUrl** *(string) --*

      The URL of the large icon image to display in the content view of a push notification that's
      based on the message template.

    - **ImageUrl** *(string) --*

      The URL of an image to display in a push notification that's based on the message template.

    - **RawContent** *(string) --*

      The raw, JSON-formatted string to use as the payload for a push notification that's based on
      the message template. If specified, this value overrides all other content for the message
      template.

    - **SmallImageIconUrl** *(string) --*

      The URL of the small icon image to display in the status bar and the content view of a push
      notification that's based on the message template.

    - **Sound** *(string) --*

      The sound to play when a recipient receives a push notification that's based on the message
      template. You can use the default stream or specify the file name of a sound resource that's
      bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

    - **Title** *(string) --*

      The title to use in a push notification that's based on the message template. This title
      appears above the notification message on a recipient's device.

    - **Url** *(string) --*

      The URL to open in a recipient's default mobile browser, if a recipient taps a a push
      notification that's based on the message template and the value of the Action property is URL.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef",
    {
        "ADM": ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef,
        "APNS": ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef,
        "Baidu": ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef,
        "Default": ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef,
        "DefaultSubstitutions": str,
        "GCM": ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef,
        "tags": Dict[str, str],
        "TemplateDescription": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef
):
    """
    Type definition for `ClientUpdatePushTemplate` `PushNotificationTemplateRequest`

    Updates an existing message template that you can use in messages that are sent through a push
    notification channel.

    - **ADM** *(dict) --*

      The message template to use for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **APNS** *(dict) --*

      The message template to use for the APNs (Apple Push Notification service) channel. This
      message template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in push notifications that are based on the message template.

      - **MediaUrl** *(string) --*

        The URL of an image or video to display in push notifications that are based on the message
        template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for push notifications that are based
        on the message template. If specified, this value overrides all other content for the
        message template.

      - **Sound** *(string) --*

        The key for the sound to play when the recipient receives a push notification that's based
        on the message template. The value for this key is the name of a sound file in your app's
        main bundle or the Library/Sounds folder in your app's data container. If the sound file
        can't be found or you specify default for the value, the system plays the default alert
        sound.

      - **Title** *(string) --*

        The title to use in push notifications that are based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in the recipient's default mobile browser, if a recipient taps a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **Baidu** *(dict) --*

      The message template to use for the Baidu (Baidu Cloud Push) channel. This message template
      overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **Default** *(dict) --*

      The default message template to use for push notification channels.

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of the iOS and Android platforms.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in push notifications that are based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

        For an iOS platform, this value is the key for the name of a sound file in your app's main
        bundle or the Library/Sounds folder in your app's data container. If the sound file can't be
        found or you specify default for the value, the system plays the default alert sound.

      - **Title** *(string) --*

        The title to use in push notifications that are based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **GCM** *(dict) --*

      The message template to use for the GCM channel, which is used to send notifications through
      the Firebase Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service. This
      message template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).

      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:

        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.

        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.

        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.

      - **Body** *(string) --*

        The message body to use in a push notification that's based on the message template.

      - **ImageIconUrl** *(string) --*

        The URL of the large icon image to display in the content view of a push notification that's
        based on the message template.

      - **ImageUrl** *(string) --*

        The URL of an image to display in a push notification that's based on the message template.

      - **RawContent** *(string) --*

        The raw, JSON-formatted string to use as the payload for a push notification that's based on
        the message template. If specified, this value overrides all other content for the message
        template.

      - **SmallImageIconUrl** *(string) --*

        The URL of the small icon image to display in the status bar and the content view of a push
        notification that's based on the message template.

      - **Sound** *(string) --*

        The sound to play when a recipient receives a push notification that's based on the message
        template. You can use the default stream or specify the file name of a sound resource that's
        bundled in your app. On an Android platform, the sound file must reside in /res/raw/.

      - **Title** *(string) --*

        The title to use in a push notification that's based on the message template. This title
        appears above the notification message on a recipient's device.

      - **Url** *(string) --*

        The URL to open in a recipient's default mobile browser, if a recipient taps a a push
        notification that's based on the message template and the value of the Action property is
        URL.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.
    """


_ClientUpdatePushTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdatePushTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdatePushTemplateResponseMessageBodyTypeDef(
    _ClientUpdatePushTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientUpdatePushTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientUpdatePushTemplateResponseTypeDef = TypedDict(
    "_ClientUpdatePushTemplateResponseTypeDef",
    {"MessageBody": ClientUpdatePushTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdatePushTemplateResponseTypeDef(_ClientUpdatePushTemplateResponseTypeDef):
    """
    Type definition for `ClientUpdatePushTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponse` `Dimensions`

    The dimension settings for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": str,
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponse` `ImportDefinition`

    The settings for the import job that's associated with the segment.

    - **ChannelCounts** *(dict) --*

      The number of channel types in the endpoint definitions that were imported to create the
      segment.

      - *(string) --*

        - *(integer) --*

    - **ExternalId** *(string) --*

      (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
      policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
      endpoint definitions, but we removed this requirement. We don't recommend use of external IDs
      for IAM roles that are assumed by Amazon Pinpoint.

    - **Format** *(string) --*

      The format of the files that were imported to create the segment. Valid values are: CSV, for
      comma-separated values format; and, JSON, for newline-delimited JSON format.

    - **RoleArn** *(string) --*

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
      from.

    - **S3Url** *(string) --*

      The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint definitions
      were imported from to create the segment.

    - **Size** *(integer) --*

      The number of endpoint definitions that were imported successfully to create the segment.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --*

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --*

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --*

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --*

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic`
    `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --*

      The latitude coordinate of the location.

    - **Longitude** *(float) --*

      The longitude coordinate of the location.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --*

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --*

        The latitude coordinate of the location.

      - **Longitude** *(float) --*

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --*

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --*

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --*

          The latitude coordinate of the location.

        - **Longitude** *(float) --*

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --*

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --*

      The value to compare.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str, "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --*

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroups` `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --*

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --*

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --*

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --*

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --*

            The latitude coordinate of the location.

          - **Longitude** *(float) --*

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --*

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --*

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroups`
    `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponseSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --*

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponseSegmentResponse` `SegmentGroups`

    A list of one or more segment groups that apply to the segment. Each segment group consists of
    zero or more base segments and the dimensions that are applied to those base segments.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --*

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --*

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --*

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --*

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --*

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --*

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --*

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --*

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --*

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientUpdateSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": str,
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseTypeDef
):
    """
    Type definition for `ClientUpdateSegmentResponse` `SegmentResponse`

    Provides information about the configuration, dimension, and other settings for a segment.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the segment is associated with.

    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the segment.

    - **CreationDate** *(string) --*

      The date and time when the segment was created.

    - **Dimensions** *(dict) --*

      The dimension settings for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --*

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --*

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --*

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --*

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --*

              The latitude coordinate of the location.

            - **Longitude** *(float) --*

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --*

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --*

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Id** *(string) --*

      The unique identifier for the segment.

    - **ImportDefinition** *(dict) --*

      The settings for the import job that's associated with the segment.

      - **ChannelCounts** *(dict) --*

        The number of channel types in the endpoint definitions that were imported to create the
        segment.

        - *(string) --*

          - *(integer) --*

      - **ExternalId** *(string) --*

        (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
        policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
        endpoint definitions, but we removed this requirement. We don't recommend use of external
        IDs for IAM roles that are assumed by Amazon Pinpoint.

      - **Format** *(string) --*

        The format of the files that were imported to create the segment. Valid values are: CSV, for
        comma-separated values format; and, JSON, for newline-delimited JSON format.

      - **RoleArn** *(string) --*

        The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
        authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
        from.

      - **S3Url** *(string) --*

        The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
        definitions were imported from to create the segment.

      - **Size** *(integer) --*

        The number of endpoint definitions that were imported successfully to create the segment.

    - **LastModifiedDate** *(string) --*

      The date and time when the segment was last modified.

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      A list of one or more segment groups that apply to the segment. Each segment group consists of
      zero or more base segments and the dimensions that are applied to those base segments.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --*

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --*

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --*

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --*

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --*

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --*

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --*

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --*

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --*

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **SegmentType** *(string) --*

      The segment type. Valid values are:

      * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
      specify and is based on endpoint data that's reported by your app. Dynamic segments can change
      over time.

      * IMPORT - A static segment, which is a segment that uses selection criteria that you specify
      and is based on endpoint definitions that you import from a file. Imported segments are
      static; they don't change over time.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that identifies the tags that are associated with
      the segment. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientUpdateSegmentResponseTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseTypeDef",
    {"SegmentResponse": ClientUpdateSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientUpdateSegmentResponseTypeDef(_ClientUpdateSegmentResponseTypeDef):
    """
    Type definition for `ClientUpdateSegment` `Response`

    The request succeeded.

    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.

      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the segment.

      - **CreationDate** *(string) --*

        The date and time when the segment was created.

      - **Dimensions** *(dict) --*

        The dimension settings for the segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --*

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --*

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --*

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --*

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --*

                The latitude coordinate of the location.

              - **Longitude** *(float) --*

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --*

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --*

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --*

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

      - **Id** *(string) --*

        The unique identifier for the segment.

      - **ImportDefinition** *(dict) --*

        The settings for the import job that's associated with the segment.

        - **ChannelCounts** *(dict) --*

          The number of channel types in the endpoint definitions that were imported to create the
          segment.

          - *(string) --*

            - *(integer) --*

        - **ExternalId** *(string) --*

          (Deprecated) Your AWS account ID, which you assigned to an external ID key in an IAM trust
          policy. Amazon Pinpoint previously used this value to assume an IAM role when importing
          endpoint definitions, but we removed this requirement. We don't recommend use of external
          IDs for IAM roles that are assumed by Amazon Pinpoint.

        - **Format** *(string) --*

          The format of the files that were imported to create the segment. Valid values are: CSV,
          for comma-separated values format; and, JSON, for newline-delimited JSON format.

        - **RoleArn** *(string) --*

          The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
          authorized Amazon Pinpoint to access the Amazon S3 location to import endpoint definitions
          from.

        - **S3Url** *(string) --*

          The URL of the Amazon Simple Storage Service (Amazon S3) bucket that the endpoint
          definitions were imported from to create the segment.

        - **Size** *(integer) --*

          The number of endpoint definitions that were imported successfully to create the segment.

      - **LastModifiedDate** *(string) --*

        The date and time when the segment was last modified.

      - **Name** *(string) --*

        The name of the segment.

      - **SegmentGroups** *(dict) --*

        A list of one or more segment groups that apply to the segment. Each segment group consists
        of zero or more base segments and the dimensions that are applied to those base segments.

        - **Groups** *(list) --*

          An array that defines the set of segment criteria to evaluate when handling segment groups
          for the segment.

          - *(dict) --*

            Specifies the base segments and dimensions for a segment, and the relationships between
            these base segments and dimensions.

            - **Dimensions** *(list) --*

              An array that defines the dimensions for the segment.

              - *(dict) --*

                Specifies the dimension settings for a segment.

                - **Attributes** *(dict) --*

                  One or more custom attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

                - **Behavior** *(dict) --*

                  The behavior-based criteria, such as how recently users have used your app, for
                  the segment.

                  - **Recency** *(dict) --*

                    The dimension settings that are based on how recently an endpoint was active.

                    - **Duration** *(string) --*

                      The duration to use when determining whether an endpoint is active or
                      inactive.

                    - **RecencyType** *(string) --*

                      The type of recency dimension to use for the segment. Valid values are:
                      ACTIVE, endpoints that were active within the specified duration are included
                      in the segment; and, INACTIVE, endpoints that weren't active within the
                      specified duration are included in the segment.

                - **Demographic** *(dict) --*

                  The demographic-based criteria, such as device platform, for the segment.

                  - **AppVersion** *(dict) --*

                    The app version criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Channel** *(dict) --*

                    The channel criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **DeviceType** *(dict) --*

                    The device type criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Make** *(dict) --*

                    The device make criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Model** *(dict) --*

                    The device model criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **Platform** *(dict) --*

                    The device platform criteria for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                - **Location** *(dict) --*

                  The location-based criteria, such as region or GPS coordinates, for the segment.

                  - **Country** *(dict) --*

                    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                    - **DimensionType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --*

                      The criteria values to use for the segment dimension. Depending on the value
                      of the DimensionType property, endpoints are included or excluded from the
                      segment if their values match the criteria values.

                      - *(string) --*

                  - **GPSPoint** *(dict) --*

                    The GPS location and range for the segment.

                    - **Coordinates** *(dict) --*

                      The GPS coordinates to measure distance from.

                      - **Latitude** *(float) --*

                        The latitude coordinate of the location.

                      - **Longitude** *(float) --*

                        The longitude coordinate of the location.

                    - **RangeInKilometers** *(float) --*

                      The range, in kilometers, from the GPS coordinates.

                - **Metrics** *(dict) --*

                  One or more custom metrics to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies metric-based criteria for including or excluding endpoints from a
                      segment. These criteria derive from custom metrics that you define for
                      endpoints.

                      - **ComparisonOperator** *(string) --*

                        The operator to use when comparing metric values. Valid values are:
                        GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and
                        EQUAL.

                      - **Value** *(float) --*

                        The value to compare.

                - **UserAttributes** *(dict) --*

                  One or more custom user attributes to use as criteria for the segment.

                  - *(string) --*

                    - *(dict) --*

                      Specifies attribute-based criteria for including or excluding endpoints from a
                      segment.

                      - **AttributeType** *(string) --*

                        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                        that match the criteria are included in the segment; and, EXCLUSIVE,
                        endpoints that match the criteria are excluded from the segment.

                      - **Values** *(list) --*

                        The criteria values to use for the segment dimension. Depending on the value
                        of the AttributeType property, endpoints are included or excluded from the
                        segment if their attribute values match the criteria values.

                        - *(string) --*

            - **SourceSegments** *(list) --*

              The base segment to build the segment on. A base segment, also referred to as a
              *source segment* , defines the initial population of endpoints for a segment. When you
              add dimensions to a segment, Amazon Pinpoint filters the base segment by using the
              dimensions that you specify.

              You can specify more than one dimensional segment or only one imported segment. If you
              specify an imported segment, the Amazon Pinpoint console displays a segment size
              estimate that indicates the size of the imported segment without any filters applied
              to it.

              - *(dict) --*

                Specifies the segment identifier and version of a segment.

                - **Id** *(string) --*

                  The unique identifier for the segment.

                - **Version** *(integer) --*

                  The version number of the segment.

            - **SourceType** *(string) --*

              Specifies how to handle multiple base segments for the segment. For example, if you
              specify three base segments for the segment, whether the resulting segment is based on
              all, any, or none of the base segments.

            - **Type** *(string) --*

              Specifies how to handle multiple dimensions for the segment. For example, if you
              specify three dimensions for the segment, whether the resulting segment includes
              endpoints that match all, any, or none of the dimensions.

        - **Include** *(string) --*

          Specifies how to handle multiple segment groups for the segment. For example, if the
          segment includes three segment groups, whether the resulting segment includes endpoints
          that match all, any, or none of the segment groups.

      - **SegmentType** *(string) --*

        The segment type. Valid values are:

        * DIMENSIONAL - A dynamic segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint data that's reported by your app. Dynamic segments can
        change over time.

        * IMPORT - A static segment, which is a segment that uses selection criteria that you
        specify and is based on endpoint definitions that you import from a file. Imported segments
        are static; they don't change over time.

      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that identifies the tags that are associated with
        the segment. Each tag consists of a required tag key and an associated tag value.

        - *(string) --*

          - *(string) --*

      - **Version** *(integer) --*

        The version number of the segment.
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensions` `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    {"Recency": ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensions` `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsDemographic` `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsDemographic` `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensions` `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensions` `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensions` `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestDimensions` `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef",
    {
        "Attributes": Dict[str, ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef],
        "Behavior": ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequest` `Dimensions`

    The criteria that define the dimensions for the segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Attributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {"Duration": str, "RecencyType": str},
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehavior` `Recency`

    The dimension settings that are based on how recently an endpoint was active.

    - **Duration** *(string) --* **[REQUIRED]**

      The duration to use when determining whether an endpoint is active or inactive.

    - **RecencyType** *(string) --* **[REQUIRED]**

      The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints that
      were active within the specified duration are included in the segment; and, INACTIVE,
      endpoints that weren't active within the specified duration are included in the segment.
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Behavior`

    The behavior-based criteria, such as how recently users have used your app, for the segment.

    - **Recency** *(dict) --*

      The dimension settings that are based on how recently an endpoint was active.

      - **Duration** *(string) --* **[REQUIRED]**

        The duration to use when determining whether an endpoint is active or inactive.

      - **RecencyType** *(string) --* **[REQUIRED]**

        The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
        that were active within the specified duration are included in the segment; and, INACTIVE,
        endpoints that weren't active within the specified duration are included in the segment.
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `AppVersion`

    The app version criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Channel`

    The channel criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `DeviceType`

    The device type criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Make`

    The device make criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Model`

    The device model criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographic` `Platform`

    The device platform criteria for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Demographic`

    The demographic-based criteria, such as device platform, for the segment.

    - **AppVersion** *(dict) --*

      The app version criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Channel** *(dict) --*

      The channel criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **DeviceType** *(dict) --*

      The device type criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Make** *(dict) --*

      The device make criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Model** *(dict) --*

      The device model criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **Platform** *(dict) --*

      The device platform criteria for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocation` `Country`

    The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

    - **DimensionType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      DimensionType property, endpoints are included or excluded from the segment if their values
      match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPoint`
    `Coordinates`

    The GPS coordinates to measure distance from.

    - **Latitude** *(float) --* **[REQUIRED]**

      The latitude coordinate of the location.

    - **Longitude** *(float) --* **[REQUIRED]**

      The longitude coordinate of the location.
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
    },
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {"RangeInKilometers": float},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
):
    """
    Type definition for
    `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocation` `GPSPoint`

    The GPS location and range for the segment.

    - **Coordinates** *(dict) --* **[REQUIRED]**

      The GPS coordinates to measure distance from.

      - **Latitude** *(float) --* **[REQUIRED]**

        The latitude coordinate of the location.

      - **Longitude** *(float) --* **[REQUIRED]**

        The longitude coordinate of the location.

    - **RangeInKilometers** *(float) --*

      The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Location`

    The location-based criteria, such as region or GPS coordinates, for the segment.

    - **Country** *(dict) --*

      The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

      - **DimensionType** *(string) --*

        The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
        criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
        excluded from the segment.

      - **Values** *(list) --* **[REQUIRED]**

        The criteria values to use for the segment dimension. Depending on the value of the
        DimensionType property, endpoints are included or excluded from the segment if their values
        match the criteria values.

        - *(string) --*

    - **GPSPoint** *(dict) --*

      The GPS location and range for the segment.

      - **Coordinates** *(dict) --* **[REQUIRED]**

        The GPS coordinates to measure distance from.

        - **Latitude** *(float) --* **[REQUIRED]**

          The latitude coordinate of the location.

        - **Longitude** *(float) --* **[REQUIRED]**

          The longitude coordinate of the location.

      - **RangeInKilometers** *(float) --*

        The range, in kilometers, from the GPS coordinates.
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `Metrics`

    Specifies metric-based criteria for including or excluding endpoints from a segment. These
    criteria derive from custom metrics that you define for endpoints.

    - **ComparisonOperator** *(string) --* **[REQUIRED]**

      The operator to use when comparing metric values. Valid values are: GREATER_THAN, LESS_THAN,
      GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

    - **Value** *(float) --* **[REQUIRED]**

      The value to compare.
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"Values": List[str]},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": str},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensions`
    `UserAttributes`

    Specifies attribute-based criteria for including or excluding endpoints from a segment.

    - **AttributeType** *(string) --*

      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match the
      criteria are included in the segment; and, EXCLUSIVE, endpoints that match the criteria are
      excluded from the segment.

    - **Values** *(list) --* **[REQUIRED]**

      The criteria values to use for the segment dimension. Depending on the value of the
      AttributeType property, endpoints are included or excluded from the segment if their attribute
      values match the criteria values.

      - *(string) --*
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroups` `Dimensions`

    Specifies the dimension settings for a segment.

    - **Attributes** *(dict) --*

      One or more custom attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*

    - **Behavior** *(dict) --*

      The behavior-based criteria, such as how recently users have used your app, for the segment.

      - **Recency** *(dict) --*

        The dimension settings that are based on how recently an endpoint was active.

        - **Duration** *(string) --* **[REQUIRED]**

          The duration to use when determining whether an endpoint is active or inactive.

        - **RecencyType** *(string) --* **[REQUIRED]**

          The type of recency dimension to use for the segment. Valid values are: ACTIVE, endpoints
          that were active within the specified duration are included in the segment; and, INACTIVE,
          endpoints that weren't active within the specified duration are included in the segment.

    - **Demographic** *(dict) --*

      The demographic-based criteria, such as device platform, for the segment.

      - **AppVersion** *(dict) --*

        The app version criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Channel** *(dict) --*

        The channel criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **DeviceType** *(dict) --*

        The device type criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Make** *(dict) --*

        The device make criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Model** *(dict) --*

        The device model criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **Platform** *(dict) --*

        The device platform criteria for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

    - **Location** *(dict) --*

      The location-based criteria, such as region or GPS coordinates, for the segment.

      - **Country** *(dict) --*

        The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

        - **DimensionType** *(string) --*

          The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
          the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
          criteria are excluded from the segment.

        - **Values** *(list) --* **[REQUIRED]**

          The criteria values to use for the segment dimension. Depending on the value of the
          DimensionType property, endpoints are included or excluded from the segment if their
          values match the criteria values.

          - *(string) --*

      - **GPSPoint** *(dict) --*

        The GPS location and range for the segment.

        - **Coordinates** *(dict) --* **[REQUIRED]**

          The GPS coordinates to measure distance from.

          - **Latitude** *(float) --* **[REQUIRED]**

            The latitude coordinate of the location.

          - **Longitude** *(float) --* **[REQUIRED]**

            The longitude coordinate of the location.

        - **RangeInKilometers** *(float) --*

          The range, in kilometers, from the GPS coordinates.

    - **Metrics** *(dict) --*

      One or more custom metrics to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies metric-based criteria for including or excluding endpoints from a segment. These
          criteria derive from custom metrics that you define for endpoints.

          - **ComparisonOperator** *(string) --* **[REQUIRED]**

            The operator to use when comparing metric values. Valid values are: GREATER_THAN,
            LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

          - **Value** *(float) --* **[REQUIRED]**

            The value to compare.

    - **UserAttributes** *(dict) --*

      One or more custom user attributes to use as criteria for the segment.

      - *(string) --*

        - *(dict) --*

          Specifies attribute-based criteria for including or excluding endpoints from a segment.

          - **AttributeType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            AttributeType property, endpoints are included or excluded from the segment if their
            attribute values match the criteria values.

            - *(string) --*
    """


_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str},
)
_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Version": int},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef(
    _RequiredClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef,
    _OptionalClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef,
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroups` `SourceSegments`

    Specifies the segment identifier and version of a segment.

    - **Id** *(string) --* **[REQUIRED]**

      The unique identifier for the segment.

    - **Version** *(integer) --*

      The version number of the segment.
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": str,
        "Type": str,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequestSegmentGroups` `Groups`

    Specifies the base segments and dimensions for a segment, and the relationships between these
    base segments and dimensions.

    - **Dimensions** *(list) --*

      An array that defines the dimensions for the segment.

      - *(dict) --*

        Specifies the dimension settings for a segment.

        - **Attributes** *(dict) --*

          One or more custom attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

        - **Behavior** *(dict) --*

          The behavior-based criteria, such as how recently users have used your app, for the
          segment.

          - **Recency** *(dict) --*

            The dimension settings that are based on how recently an endpoint was active.

            - **Duration** *(string) --* **[REQUIRED]**

              The duration to use when determining whether an endpoint is active or inactive.

            - **RecencyType** *(string) --* **[REQUIRED]**

              The type of recency dimension to use for the segment. Valid values are: ACTIVE,
              endpoints that were active within the specified duration are included in the segment;
              and, INACTIVE, endpoints that weren't active within the specified duration are
              included in the segment.

        - **Demographic** *(dict) --*

          The demographic-based criteria, such as device platform, for the segment.

          - **AppVersion** *(dict) --*

            The app version criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Channel** *(dict) --*

            The channel criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **DeviceType** *(dict) --*

            The device type criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Make** *(dict) --*

            The device make criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Model** *(dict) --*

            The device model criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **Platform** *(dict) --*

            The device platform criteria for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

        - **Location** *(dict) --*

          The location-based criteria, such as region or GPS coordinates, for the segment.

          - **Country** *(dict) --*

            The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

            - **DimensionType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              DimensionType property, endpoints are included or excluded from the segment if their
              values match the criteria values.

              - *(string) --*

          - **GPSPoint** *(dict) --*

            The GPS location and range for the segment.

            - **Coordinates** *(dict) --* **[REQUIRED]**

              The GPS coordinates to measure distance from.

              - **Latitude** *(float) --* **[REQUIRED]**

                The latitude coordinate of the location.

              - **Longitude** *(float) --* **[REQUIRED]**

                The longitude coordinate of the location.

            - **RangeInKilometers** *(float) --*

              The range, in kilometers, from the GPS coordinates.

        - **Metrics** *(dict) --*

          One or more custom metrics to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies metric-based criteria for including or excluding endpoints from a segment.
              These criteria derive from custom metrics that you define for endpoints.

              - **ComparisonOperator** *(string) --* **[REQUIRED]**

                The operator to use when comparing metric values. Valid values are: GREATER_THAN,
                LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

              - **Value** *(float) --* **[REQUIRED]**

                The value to compare.

        - **UserAttributes** *(dict) --*

          One or more custom user attributes to use as criteria for the segment.

          - *(string) --*

            - *(dict) --*

              Specifies attribute-based criteria for including or excluding endpoints from a
              segment.

              - **AttributeType** *(string) --*

                The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
                the criteria are excluded from the segment.

              - **Values** *(list) --* **[REQUIRED]**

                The criteria values to use for the segment dimension. Depending on the value of the
                AttributeType property, endpoints are included or excluded from the segment if their
                attribute values match the criteria values.

                - *(string) --*

    - **SourceSegments** *(list) --*

      The base segment to build the segment on. A base segment, also referred to as a *source
      segment* , defines the initial population of endpoints for a segment. When you add dimensions
      to a segment, Amazon Pinpoint filters the base segment by using the dimensions that you
      specify.

      You can specify more than one dimensional segment or only one imported segment. If you specify
      an imported segment, the Amazon Pinpoint console displays a segment size estimate that
      indicates the size of the imported segment without any filters applied to it.

      - *(dict) --*

        Specifies the segment identifier and version of a segment.

        - **Id** *(string) --* **[REQUIRED]**

          The unique identifier for the segment.

        - **Version** *(integer) --*

          The version number of the segment.

    - **SourceType** *(string) --*

      Specifies how to handle multiple base segments for the segment. For example, if you specify
      three base segments for the segment, whether the resulting segment is based on all, any, or
      none of the base segments.

    - **Type** *(string) --*

      Specifies how to handle multiple dimensions for the segment. For example, if you specify three
      dimensions for the segment, whether the resulting segment includes endpoints that match all,
      any, or none of the dimensions.
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    {
        "Groups": List[ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef],
        "Include": str,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef
):
    """
    Type definition for `ClientUpdateSegmentWriteSegmentRequest` `SegmentGroups`

    The segment group to use and the dimensions to apply to the group's base segments in order to
    build the segment. A segment group can consist of zero or more base segments. Your request can
    include only one segment group.

    - **Groups** *(list) --*

      An array that defines the set of segment criteria to evaluate when handling segment groups for
      the segment.

      - *(dict) --*

        Specifies the base segments and dimensions for a segment, and the relationships between
        these base segments and dimensions.

        - **Dimensions** *(list) --*

          An array that defines the dimensions for the segment.

          - *(dict) --*

            Specifies the dimension settings for a segment.

            - **Attributes** *(dict) --*

              One or more custom attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

            - **Behavior** *(dict) --*

              The behavior-based criteria, such as how recently users have used your app, for the
              segment.

              - **Recency** *(dict) --*

                The dimension settings that are based on how recently an endpoint was active.

                - **Duration** *(string) --* **[REQUIRED]**

                  The duration to use when determining whether an endpoint is active or inactive.

                - **RecencyType** *(string) --* **[REQUIRED]**

                  The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                  endpoints that were active within the specified duration are included in the
                  segment; and, INACTIVE, endpoints that weren't active within the specified
                  duration are included in the segment.

            - **Demographic** *(dict) --*

              The demographic-based criteria, such as device platform, for the segment.

              - **AppVersion** *(dict) --*

                The app version criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Channel** *(dict) --*

                The channel criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **DeviceType** *(dict) --*

                The device type criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Make** *(dict) --*

                The device make criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Model** *(dict) --*

                The device model criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **Platform** *(dict) --*

                The device platform criteria for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

            - **Location** *(dict) --*

              The location-based criteria, such as region or GPS coordinates, for the segment.

              - **Country** *(dict) --*

                The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                - **DimensionType** *(string) --*

                  The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
                  match the criteria are included in the segment; and, EXCLUSIVE, endpoints that
                  match the criteria are excluded from the segment.

                - **Values** *(list) --* **[REQUIRED]**

                  The criteria values to use for the segment dimension. Depending on the value of
                  the DimensionType property, endpoints are included or excluded from the segment if
                  their values match the criteria values.

                  - *(string) --*

              - **GPSPoint** *(dict) --*

                The GPS location and range for the segment.

                - **Coordinates** *(dict) --* **[REQUIRED]**

                  The GPS coordinates to measure distance from.

                  - **Latitude** *(float) --* **[REQUIRED]**

                    The latitude coordinate of the location.

                  - **Longitude** *(float) --* **[REQUIRED]**

                    The longitude coordinate of the location.

                - **RangeInKilometers** *(float) --*

                  The range, in kilometers, from the GPS coordinates.

            - **Metrics** *(dict) --*

              One or more custom metrics to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies metric-based criteria for including or excluding endpoints from a
                  segment. These criteria derive from custom metrics that you define for endpoints.

                  - **ComparisonOperator** *(string) --* **[REQUIRED]**

                    The operator to use when comparing metric values. Valid values are:
                    GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                  - **Value** *(float) --* **[REQUIRED]**

                    The value to compare.

            - **UserAttributes** *(dict) --*

              One or more custom user attributes to use as criteria for the segment.

              - *(string) --*

                - *(dict) --*

                  Specifies attribute-based criteria for including or excluding endpoints from a
                  segment.

                  - **AttributeType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the AttributeType property, endpoints are included or excluded from the segment
                    if their attribute values match the criteria values.

                    - *(string) --*

        - **SourceSegments** *(list) --*

          The base segment to build the segment on. A base segment, also referred to as a *source
          segment* , defines the initial population of endpoints for a segment. When you add
          dimensions to a segment, Amazon Pinpoint filters the base segment by using the dimensions
          that you specify.

          You can specify more than one dimensional segment or only one imported segment. If you
          specify an imported segment, the Amazon Pinpoint console displays a segment size estimate
          that indicates the size of the imported segment without any filters applied to it.

          - *(dict) --*

            Specifies the segment identifier and version of a segment.

            - **Id** *(string) --* **[REQUIRED]**

              The unique identifier for the segment.

            - **Version** *(integer) --*

              The version number of the segment.

        - **SourceType** *(string) --*

          Specifies how to handle multiple base segments for the segment. For example, if you
          specify three base segments for the segment, whether the resulting segment is based on
          all, any, or none of the base segments.

        - **Type** *(string) --*

          Specifies how to handle multiple dimensions for the segment. For example, if you specify
          three dimensions for the segment, whether the resulting segment includes endpoints that
          match all, any, or none of the dimensions.

    - **Include** *(string) --*

      Specifies how to handle multiple segment groups for the segment. For example, if the segment
      includes three segment groups, whether the resulting segment includes endpoints that match
      all, any, or none of the segment groups.
    """


_ClientUpdateSegmentWriteSegmentRequestTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestTypeDef",
    {
        "Dimensions": ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef,
        "Name": str,
        "SegmentGroups": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestTypeDef(_ClientUpdateSegmentWriteSegmentRequestTypeDef):
    """
    Type definition for `ClientUpdateSegment` `WriteSegmentRequest`

    Specifies the configuration, dimension, and other settings for a segment. A WriteSegmentRequest
    object can include a Dimensions object or a SegmentGroups object, but not both.

    - **Dimensions** *(dict) --*

      The criteria that define the dimensions for the segment.

      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

      - **Behavior** *(dict) --*

        The behavior-based criteria, such as how recently users have used your app, for the segment.

        - **Recency** *(dict) --*

          The dimension settings that are based on how recently an endpoint was active.

          - **Duration** *(string) --* **[REQUIRED]**

            The duration to use when determining whether an endpoint is active or inactive.

          - **RecencyType** *(string) --* **[REQUIRED]**

            The type of recency dimension to use for the segment. Valid values are: ACTIVE,
            endpoints that were active within the specified duration are included in the segment;
            and, INACTIVE, endpoints that weren't active within the specified duration are included
            in the segment.

      - **Demographic** *(dict) --*

        The demographic-based criteria, such as device platform, for the segment.

        - **AppVersion** *(dict) --*

          The app version criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Channel** *(dict) --*

          The channel criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **DeviceType** *(dict) --*

          The device type criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Make** *(dict) --*

          The device make criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Model** *(dict) --*

          The device model criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **Platform** *(dict) --*

          The device platform criteria for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

      - **Location** *(dict) --*

        The location-based criteria, such as region or GPS coordinates, for the segment.

        - **Country** *(dict) --*

          The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

          - **DimensionType** *(string) --*

            The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that match
            the criteria are included in the segment; and, EXCLUSIVE, endpoints that match the
            criteria are excluded from the segment.

          - **Values** *(list) --* **[REQUIRED]**

            The criteria values to use for the segment dimension. Depending on the value of the
            DimensionType property, endpoints are included or excluded from the segment if their
            values match the criteria values.

            - *(string) --*

        - **GPSPoint** *(dict) --*

          The GPS location and range for the segment.

          - **Coordinates** *(dict) --* **[REQUIRED]**

            The GPS coordinates to measure distance from.

            - **Latitude** *(float) --* **[REQUIRED]**

              The latitude coordinate of the location.

            - **Longitude** *(float) --* **[REQUIRED]**

              The longitude coordinate of the location.

          - **RangeInKilometers** *(float) --*

            The range, in kilometers, from the GPS coordinates.

      - **Metrics** *(dict) --*

        One or more custom metrics to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies metric-based criteria for including or excluding endpoints from a segment.
            These criteria derive from custom metrics that you define for endpoints.

            - **ComparisonOperator** *(string) --* **[REQUIRED]**

              The operator to use when comparing metric values. Valid values are: GREATER_THAN,
              LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

            - **Value** *(float) --* **[REQUIRED]**

              The value to compare.

      - **UserAttributes** *(dict) --*

        One or more custom user attributes to use as criteria for the segment.

        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.

            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.

            - **Values** *(list) --* **[REQUIRED]**

              The criteria values to use for the segment dimension. Depending on the value of the
              AttributeType property, endpoints are included or excluded from the segment if their
              attribute values match the criteria values.

              - *(string) --*

    - **Name** *(string) --*

      The name of the segment.

    - **SegmentGroups** *(dict) --*

      The segment group to use and the dimensions to apply to the group's base segments in order to
      build the segment. A segment group can consist of zero or more base segments. Your request can
      include only one segment group.

      - **Groups** *(list) --*

        An array that defines the set of segment criteria to evaluate when handling segment groups
        for the segment.

        - *(dict) --*

          Specifies the base segments and dimensions for a segment, and the relationships between
          these base segments and dimensions.

          - **Dimensions** *(list) --*

            An array that defines the dimensions for the segment.

            - *(dict) --*

              Specifies the dimension settings for a segment.

              - **Attributes** *(dict) --*

                One or more custom attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

              - **Behavior** *(dict) --*

                The behavior-based criteria, such as how recently users have used your app, for the
                segment.

                - **Recency** *(dict) --*

                  The dimension settings that are based on how recently an endpoint was active.

                  - **Duration** *(string) --* **[REQUIRED]**

                    The duration to use when determining whether an endpoint is active or inactive.

                  - **RecencyType** *(string) --* **[REQUIRED]**

                    The type of recency dimension to use for the segment. Valid values are: ACTIVE,
                    endpoints that were active within the specified duration are included in the
                    segment; and, INACTIVE, endpoints that weren't active within the specified
                    duration are included in the segment.

              - **Demographic** *(dict) --*

                The demographic-based criteria, such as device platform, for the segment.

                - **AppVersion** *(dict) --*

                  The app version criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Channel** *(dict) --*

                  The channel criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **DeviceType** *(dict) --*

                  The device type criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Make** *(dict) --*

                  The device make criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Model** *(dict) --*

                  The device model criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **Platform** *(dict) --*

                  The device platform criteria for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

              - **Location** *(dict) --*

                The location-based criteria, such as region or GPS coordinates, for the segment.

                - **Country** *(dict) --*

                  The country or region code, in ISO 3166-1 alpha-2 format, for the segment.

                  - **DimensionType** *(string) --*

                    The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                    that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                    that match the criteria are excluded from the segment.

                  - **Values** *(list) --* **[REQUIRED]**

                    The criteria values to use for the segment dimension. Depending on the value of
                    the DimensionType property, endpoints are included or excluded from the segment
                    if their values match the criteria values.

                    - *(string) --*

                - **GPSPoint** *(dict) --*

                  The GPS location and range for the segment.

                  - **Coordinates** *(dict) --* **[REQUIRED]**

                    The GPS coordinates to measure distance from.

                    - **Latitude** *(float) --* **[REQUIRED]**

                      The latitude coordinate of the location.

                    - **Longitude** *(float) --* **[REQUIRED]**

                      The longitude coordinate of the location.

                  - **RangeInKilometers** *(float) --*

                    The range, in kilometers, from the GPS coordinates.

              - **Metrics** *(dict) --*

                One or more custom metrics to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies metric-based criteria for including or excluding endpoints from a
                    segment. These criteria derive from custom metrics that you define for
                    endpoints.

                    - **ComparisonOperator** *(string) --* **[REQUIRED]**

                      The operator to use when comparing metric values. Valid values are:
                      GREATER_THAN, LESS_THAN, GREATER_THAN_OR_EQUAL, LESS_THAN_OR_EQUAL, and EQUAL.

                    - **Value** *(float) --* **[REQUIRED]**

                      The value to compare.

              - **UserAttributes** *(dict) --*

                One or more custom user attributes to use as criteria for the segment.

                - *(string) --*

                  - *(dict) --*

                    Specifies attribute-based criteria for including or excluding endpoints from a
                    segment.

                    - **AttributeType** *(string) --*

                      The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints
                      that match the criteria are included in the segment; and, EXCLUSIVE, endpoints
                      that match the criteria are excluded from the segment.

                    - **Values** *(list) --* **[REQUIRED]**

                      The criteria values to use for the segment dimension. Depending on the value
                      of the AttributeType property, endpoints are included or excluded from the
                      segment if their attribute values match the criteria values.

                      - *(string) --*

          - **SourceSegments** *(list) --*

            The base segment to build the segment on. A base segment, also referred to as a *source
            segment* , defines the initial population of endpoints for a segment. When you add
            dimensions to a segment, Amazon Pinpoint filters the base segment by using the
            dimensions that you specify.

            You can specify more than one dimensional segment or only one imported segment. If you
            specify an imported segment, the Amazon Pinpoint console displays a segment size
            estimate that indicates the size of the imported segment without any filters applied to
            it.

            - *(dict) --*

              Specifies the segment identifier and version of a segment.

              - **Id** *(string) --* **[REQUIRED]**

                The unique identifier for the segment.

              - **Version** *(integer) --*

                The version number of the segment.

          - **SourceType** *(string) --*

            Specifies how to handle multiple base segments for the segment. For example, if you
            specify three base segments for the segment, whether the resulting segment is based on
            all, any, or none of the base segments.

          - **Type** *(string) --*

            Specifies how to handle multiple dimensions for the segment. For example, if you specify
            three dimensions for the segment, whether the resulting segment includes endpoints that
            match all, any, or none of the dimensions.

      - **Include** *(string) --*

        Specifies how to handle multiple segment groups for the segment. For example, if the segment
        includes three segment groups, whether the resulting segment includes endpoints that match
        all, any, or none of the segment groups.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the segment.
      Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*
    """


_ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef = TypedDict(
    "_ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "PromotionalMessagesPerSecond": int,
        "SenderId": str,
        "ShortCode": str,
        "TransactionalMessagesPerSecond": int,
        "Version": int,
    },
    total=False,
)


class ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef(
    _ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateSmsChannelResponse` `SMSChannelResponse`

    Provides information about the status and settings of the SMS channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the SMS channel applies to.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the SMS channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the SMS channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the SMS channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the SMS channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the SMS channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the SMS channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the SMS channel, this
      value is SMS.

    - **PromotionalMessagesPerSecond** *(integer) --*

      The maximum number of promotional messages that you can send through the SMS channel each
      second.

    - **SenderId** *(string) --*

      The identity that displays on recipients' devices when they receive messages from the SMS
      channel.

    - **ShortCode** *(string) --*

      The registered short code to use when you send messages through the SMS channel.

    - **TransactionalMessagesPerSecond** *(integer) --*

      The maximum number of transactional messages that you can send through the SMS channel each
      second.

    - **Version** *(integer) --*

      The current version of the SMS channel.
    """


_ClientUpdateSmsChannelResponseTypeDef = TypedDict(
    "_ClientUpdateSmsChannelResponseTypeDef",
    {"SMSChannelResponse": ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef},
    total=False,
)


class ClientUpdateSmsChannelResponseTypeDef(_ClientUpdateSmsChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateSmsChannel` `Response`

    The request succeeded.

    - **SMSChannelResponse** *(dict) --*

      Provides information about the status and settings of the SMS channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the SMS channel applies to.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the SMS channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the SMS channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the SMS channel. This property is retained only for backward
        compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the SMS channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the SMS channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the SMS channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the SMS channel, this
        value is SMS.

      - **PromotionalMessagesPerSecond** *(integer) --*

        The maximum number of promotional messages that you can send through the SMS channel each
        second.

      - **SenderId** *(string) --*

        The identity that displays on recipients' devices when they receive messages from the SMS
        channel.

      - **ShortCode** *(string) --*

        The registered short code to use when you send messages through the SMS channel.

      - **TransactionalMessagesPerSecond** *(integer) --*

        The maximum number of transactional messages that you can send through the SMS channel each
        second.

      - **Version** *(integer) --*

        The current version of the SMS channel.
    """


_ClientUpdateSmsChannelSMSChannelRequestTypeDef = TypedDict(
    "_ClientUpdateSmsChannelSMSChannelRequestTypeDef",
    {"Enabled": bool, "SenderId": str, "ShortCode": str},
    total=False,
)


class ClientUpdateSmsChannelSMSChannelRequestTypeDef(
    _ClientUpdateSmsChannelSMSChannelRequestTypeDef
):
    """
    Type definition for `ClientUpdateSmsChannel` `SMSChannelRequest`

    Specifies the status and settings of the SMS channel for an application.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the SMS channel for the application.

    - **SenderId** *(string) --*

      The identity that you want to display on recipients' devices when they receive messages from
      the SMS channel.

    - **ShortCode** *(string) --*

      The registered short code that you want to use when you send messages through the SMS channel.
    """


_ClientUpdateSmsTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateSmsTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateSmsTemplateResponseMessageBodyTypeDef(
    _ClientUpdateSmsTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientUpdateSmsTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientUpdateSmsTemplateResponseTypeDef = TypedDict(
    "_ClientUpdateSmsTemplateResponseTypeDef",
    {"MessageBody": ClientUpdateSmsTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateSmsTemplateResponseTypeDef(_ClientUpdateSmsTemplateResponseTypeDef):
    """
    Type definition for `ClientUpdateSmsTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientUpdateSmsTemplateSMSTemplateRequestTypeDef = TypedDict(
    "_ClientUpdateSmsTemplateSMSTemplateRequestTypeDef",
    {"Body": str, "DefaultSubstitutions": str, "tags": Dict[str, str], "TemplateDescription": str},
    total=False,
)


class ClientUpdateSmsTemplateSMSTemplateRequestTypeDef(
    _ClientUpdateSmsTemplateSMSTemplateRequestTypeDef
):
    """
    Type definition for `ClientUpdateSmsTemplate` `SMSTemplateRequest`

    Specifies the content and settings for a message template that can be used in text messages that
    are sent through the SMS channel.

    - **Body** *(string) --*

      The message body to use in text messages that are based on the message template.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.
    """


_ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef = TypedDict(
    "_ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef(
    _ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef
):
    """
    Type definition for `ClientUpdateVoiceChannelResponse` `VoiceChannelResponse`

    Provides information about the status and settings of the voice channel for an application.

    - **ApplicationId** *(string) --*

      The unique identifier for the application that the voice channel applies to.

    - **CreationDate** *(string) --*

      The date and time, in ISO 8601 format, when the voice channel was enabled.

    - **Enabled** *(boolean) --*

      Specifies whether the voice channel is enabled for the application.

    - **HasCredential** *(boolean) --*

      (Not used) This property is retained only for backward compatibility.

    - **Id** *(string) --*

      (Deprecated) An identifier for the voice channel. This property is retained only for backward
      compatibility.

    - **IsArchived** *(boolean) --*

      Specifies whether the voice channel is archived.

    - **LastModifiedBy** *(string) --*

      The user who last modified the voice channel.

    - **LastModifiedDate** *(string) --*

      The date and time, in ISO 8601 format, when the voice channel was last modified.

    - **Platform** *(string) --*

      The type of messaging or notification platform for the channel. For the voice channel, this
      value is VOICE.

    - **Version** *(integer) --*

      The current version of the voice channel.
    """


_ClientUpdateVoiceChannelResponseTypeDef = TypedDict(
    "_ClientUpdateVoiceChannelResponseTypeDef",
    {"VoiceChannelResponse": ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef},
    total=False,
)


class ClientUpdateVoiceChannelResponseTypeDef(_ClientUpdateVoiceChannelResponseTypeDef):
    """
    Type definition for `ClientUpdateVoiceChannel` `Response`

    The request succeeded.

    - **VoiceChannelResponse** *(dict) --*

      Provides information about the status and settings of the voice channel for an application.

      - **ApplicationId** *(string) --*

        The unique identifier for the application that the voice channel applies to.

      - **CreationDate** *(string) --*

        The date and time, in ISO 8601 format, when the voice channel was enabled.

      - **Enabled** *(boolean) --*

        Specifies whether the voice channel is enabled for the application.

      - **HasCredential** *(boolean) --*

        (Not used) This property is retained only for backward compatibility.

      - **Id** *(string) --*

        (Deprecated) An identifier for the voice channel. This property is retained only for
        backward compatibility.

      - **IsArchived** *(boolean) --*

        Specifies whether the voice channel is archived.

      - **LastModifiedBy** *(string) --*

        The user who last modified the voice channel.

      - **LastModifiedDate** *(string) --*

        The date and time, in ISO 8601 format, when the voice channel was last modified.

      - **Platform** *(string) --*

        The type of messaging or notification platform for the channel. For the voice channel, this
        value is VOICE.

      - **Version** *(integer) --*

        The current version of the voice channel.
    """


_ClientUpdateVoiceChannelVoiceChannelRequestTypeDef = TypedDict(
    "_ClientUpdateVoiceChannelVoiceChannelRequestTypeDef", {"Enabled": bool}, total=False
)


class ClientUpdateVoiceChannelVoiceChannelRequestTypeDef(
    _ClientUpdateVoiceChannelVoiceChannelRequestTypeDef
):
    """
    Type definition for `ClientUpdateVoiceChannel` `VoiceChannelRequest`

    Specifies the status and settings of the voice channel for an application.

    - **Enabled** *(boolean) --*

      Specifies whether to enable the voice channel for the application.
    """


_ClientUpdateVoiceTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateVoiceTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateVoiceTemplateResponseMessageBodyTypeDef(
    _ClientUpdateVoiceTemplateResponseMessageBodyTypeDef
):
    """
    Type definition for `ClientUpdateVoiceTemplateResponse` `MessageBody`

    Provides information about an API request or response.

    - **Message** *(string) --*

      The message that's returned from the API.

    - **RequestID** *(string) --*

      The unique identifier for the request or response.
    """


_ClientUpdateVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientUpdateVoiceTemplateResponseTypeDef",
    {"MessageBody": ClientUpdateVoiceTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateVoiceTemplateResponseTypeDef(_ClientUpdateVoiceTemplateResponseTypeDef):
    """
    Type definition for `ClientUpdateVoiceTemplate` `Response`

    The request was accepted for processing. Processing may not be complete.

    - **MessageBody** *(dict) --*

      Provides information about an API request or response.

      - **Message** *(string) --*

        The message that's returned from the API.

      - **RequestID** *(string) --*

        The unique identifier for the request or response.
    """


_ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef = TypedDict(
    "_ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef",
    {
        "Body": str,
        "DefaultSubstitutions": str,
        "LanguageCode": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "VoiceId": str,
    },
    total=False,
)


class ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef(
    _ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef
):
    """
    Type definition for `ClientUpdateVoiceTemplate` `VoiceTemplateRequest`

    Specifies the content and settings for a message template that can be used in messages that are
    sent through the voice channel.

    - **Body** *(string) --*

      The text of the script to use in messages that are based on the message template, in plain
      text format.

    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.

    - **LanguageCode** *(string) --*

      The code for the language to use when synthesizing the text of the script in messages that are
      based on the message template. For a list of supported languages and the code for each one,
      see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .

    - **tags** *(dict) --*

      A string-to-string map of key-value pairs that defines the tags to associate with the message
      template. Each tag consists of a required tag key and an associated tag value.

      - *(string) --*

        - *(string) --*

    - **TemplateDescription** *(string) --*

      A custom description of the message template.

    - **VoiceId** *(string) --*

      The name of the voice to use when delivering messages that are based on the message template.
      For a list of supported voices, see the `Amazon Polly Developer Guide
      <https://docs.aws.amazon.com/polly/latest/dg/what-is.html>`__ .
    """
